/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './gdbmhash.pmc'
 * by ../../tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#define PARROT_IN_EXTENSION
#define CONST_STRING(i, s) Parrot_str_new_constant((i), s)
#define CONST_STRING_GEN(i, s) Parrot_str_new_constant((i), s)
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_gdbmhash.h"
#include "pmc_default.h"
#include "pmc_continuation.h"
#line 1 "./gdbmhash.pmc"
/* gdbmhash.pmc
 *  Copyright (C) 2005-2009, Parrot Foundation.
 *  SVN Info
 *     $Id: gdbmhash.pmc 37268 2009-03-10 11:17:56Z cotto $
 *  Overview:
 *     These are the vtable functions for the GDBMHash PMC
 *  Data Structure and Algorithms:
 *  History:
 *  Notes:
 *     Please remove unneeded entries.
 *  References:

=head1 NAME

src/dynpmc/gdbmhash.pmc - GDBM PMC

=head1 DESCRIPTION

This is an interface to the GNU dbm library.

=head1 keys

On inserted and fetch, keys are converted to STRINGs.

=head2 store

PMC insert values are converted to STRINGs.

=head2 fetch

get_integer_keyed() and get_number_keyed() probably don't make any sense,
as integers usually can't be converted.

When a PMC is requested, a String PMC is returned.


=head2 Functions

=over 4

=cut

 */

#include <gdbm.h>
#include "parrot/extend.h"

typedef struct GDBM_FH {
    GDBM_FILE f;
} GDBM_FH;

#define PMC_dbfh(x) ((Parrot_GDBMHash_attributes *)PMC_data(x))->db_handle->f


/*

=item C<static STRING* make_hash_key(PARROT_INTERP, PMC *key)>

Returns a Parrot string for C<*key>.

=cut

*/

static STRING* make_hash_key(PARROT_INTERP, NOTNULL(PMC * key))
{
    if (key)
        return VTABLE_get_string(interp, key);

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
        "Hash: Cannot use NULL key");

}
#line 97 "./gdbmhash.c"
PARROT_DYNEXT_EXPORT  void 
Parrot_GDBMHash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 355 "./gdbmhash.pmc"

    STRING* keystr;
    GDBM_FILE dbf = PMC_dbfh(pmc);
    datum key_gdbm;

    if (!key) return;
    if (!dbf) return;
    keystr = make_hash_key(interp, key);

    key_gdbm.dsize = keystr->strlen;
    key_gdbm.dptr  = keystr->strstart;

    if (gdbm_exists(dbf, key_gdbm)) {
       gdbm_delete(dbf, key_gdbm);
    }

    return;
#line 119 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_GDBMHash_destroy(PARROT_INTERP, PMC *pmc)
{
#line 98 "./gdbmhash.pmc"

    mem_sys_free(
            ((Parrot_GDBMHash_attributes *)PMC_data(pmc))->db_handle);
    mem_sys_free(PMC_data(pmc));
#line 129 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_GDBMHash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 330 "./gdbmhash.pmc"

    STRING* keystr;
    GDBM_FILE dbf = PMC_dbfh(pmc);
    datum key_gdbm;

    if (!key) return 0;
    if (!dbf) return 0;
    keystr = make_hash_key(interp, key);

    key_gdbm.dsize = keystr->strlen;
    key_gdbm.dptr  = keystr->strstart;

    return gdbm_exists(dbf, key_gdbm);
#line 148 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_GDBMHash_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 170 "./gdbmhash.pmc"

    GDBM_FILE dbf = PMC_dbfh(pmc);
    if (! dbf) {
        return 0;
    }
    else {
        datum key = gdbm_firstkey(dbf);
        if (key.dptr) {
            return 1;
        }
        else {
            return 0;
        }
    }
#line 168 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_GDBMHash_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 142 "./gdbmhash.pmc"

    GDBM_FILE dbf = PMC_dbfh(pmc);
    if (! dbf) {
        return 0;
    }
    else {
        INTVAL cnt = 0;
        datum key, nextkey;
        for (key = gdbm_firstkey(dbf); key.dptr; key = nextkey) {
            cnt++;
            nextkey = gdbm_nextkey(dbf, key);
            free(key.dptr);
        }

        return cnt;
    }
#line 190 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  PMC* 
Parrot_GDBMHash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 274 "./gdbmhash.pmc"

    STRING * ret_string = VTABLE_get_string_keyed(interp, pmc, key);
    PMC *ret_pmc = pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, ret_pmc, ret_string);

    return ret_pmc;
#line 203 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  void* 
Parrot_GDBMHash_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 104 "./gdbmhash.pmc"

    return PMC_dbfh(pmc);
#line 211 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  STRING* 
Parrot_GDBMHash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 223 "./gdbmhash.pmc"

    STRING *keystr, *val;
    GDBM_FILE dbf = PMC_dbfh(pmc);
    datum key_gdbm, val_gdbm;

    if (!key)
        return string_from_literal(interp, "");

    if (!dbf)
        return string_from_literal(interp, "");

    keystr         = make_hash_key(interp, key);

    key_gdbm.dsize = keystr->strlen;
    key_gdbm.dptr  = keystr->strstart;
    val_gdbm       = gdbm_fetch(dbf, key_gdbm);

    val = Parrot_str_new(interp, val_gdbm.dptr, val_gdbm.dsize);
    free(val_gdbm.dptr);

    return val;
#line 238 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_GDBMHash_init(PARROT_INTERP, PMC *pmc)
{
#line 89 "./gdbmhash.pmc"

    Parrot_GDBMHash_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_GDBMHash_attributes);

    attrs->db_handle = mem_allocate_zeroed_typed(GDBM_FH);
    PMC_data(pmc)   = attrs;
    PObj_active_destroy_SET(pmc);
#line 251 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_GDBMHash_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 293 "./gdbmhash.pmc"

    PMC *temp;

    temp = pmc_new(interp, enum_class_String);
    VTABLE_set_integer_native(interp, temp, value);
    VTABLE_set_pmc_keyed(interp, pmc, key, temp);
#line 263 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_GDBMHash_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 312 "./gdbmhash.pmc"

    PMC *temp;

    temp = pmc_new(interp, enum_class_String);
    VTABLE_set_number_native(interp, temp, value);
    VTABLE_set_pmc_keyed(interp, pmc, key, temp);
#line 275 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_GDBMHash_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 257 "./gdbmhash.pmc"

    STRING *temp;

    temp = VTABLE_get_string(interp, value);
    VTABLE_set_string_keyed(interp, pmc, key, temp);
#line 286 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_GDBMHash_set_pointer(PARROT_INTERP, PMC *pmc, void *p)
{
#line 108 "./gdbmhash.pmc"

    PMC_dbfh(pmc) = (GDBM_FILE)p;
#line 294 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_GDBMHash_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 194 "./gdbmhash.pmc"

    STRING* keystr;
    GDBM_FILE dbf = PMC_dbfh(pmc);
    datum key_gdbm, val_gdbm;

    if (!key) return;
    if (!dbf) return;
    keystr = make_hash_key(interp, key);

    key_gdbm.dsize = keystr->strlen;
    key_gdbm.dptr  = keystr->strstart;
    val_gdbm.dsize = value->strlen;
    val_gdbm.dptr  = value->strstart;

    gdbm_store(dbf, key_gdbm, val_gdbm, GDBM_REPLACE);

    return;
#line 317 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_GDBMHash_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 122 "./gdbmhash.pmc"

    char * const c_db_name = Parrot_str_to_cstring(interp, value);
    GDBM_FILE dbf          = gdbm_open(c_db_name, 0, GDBM_NEWDB, 0666, 0);

    Parrot_str_free_cstring(c_db_name);

    PMC_dbfh(pmc) = dbf;
#line 330 "./gdbmhash.c"
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  PMC *
Parrot_GDBMHash_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  FLOATVAL
Parrot_GDBMHash_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  INTVAL
Parrot_GDBMHash_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  PMC *
Parrot_GDBMHash_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  STRING *
Parrot_GDBMHash_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  FLOATVAL
Parrot_GDBMHash_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  INTVAL
Parrot_GDBMHash_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  PMC *
Parrot_GDBMHash_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  STRING *
Parrot_GDBMHash_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of GDBMHash");
}
PARROT_DYNEXT_EXPORT  void
Parrot_GDBMHash_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of GDBMHash");
}
#include "pmc_default.h"
void
Parrot_GDBMHash_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":db_handle ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        -1, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_GDBMHash_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_GDBMHash_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_GDBMHash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_GDBMHash_get_bool,
        Parrot_default_get_class,
        Parrot_GDBMHash_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_GDBMHash_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_GDBMHash_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_GDBMHash_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_GDBMHash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_GDBMHash_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_GDBMHash_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_GDBMHash_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_GDBMHash_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_GDBMHash_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_GDBMHash_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        -1, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_GDBMHash_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_GDBMHash_ro_add_method,
        Parrot_GDBMHash_ro_add_parent,
        Parrot_GDBMHash_ro_add_role,
        Parrot_GDBMHash_ro_add_vtable_override,
        Parrot_GDBMHash_ro_assign_pmc,
        Parrot_GDBMHash_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_GDBMHash_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_GDBMHash_ro_delete_keyed,
        Parrot_GDBMHash_ro_delete_keyed_int,
        Parrot_GDBMHash_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_GDBMHash_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_GDBMHash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_GDBMHash_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_GDBMHash_get_bool,
        Parrot_default_get_class,
        Parrot_GDBMHash_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_GDBMHash_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_GDBMHash_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_GDBMHash_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_GDBMHash_ro_i_absolute,
        Parrot_GDBMHash_ro_i_add,
        Parrot_GDBMHash_ro_i_add_float,
        Parrot_GDBMHash_ro_i_add_int,
        Parrot_GDBMHash_ro_i_bitwise_and,
        Parrot_GDBMHash_ro_i_bitwise_and_int,
        Parrot_GDBMHash_ro_i_bitwise_ands,
        Parrot_GDBMHash_ro_i_bitwise_ands_str,
        Parrot_GDBMHash_ro_i_bitwise_lsr,
        Parrot_GDBMHash_ro_i_bitwise_lsr_int,
        Parrot_GDBMHash_ro_i_bitwise_not,
        Parrot_GDBMHash_ro_i_bitwise_nots,
        Parrot_GDBMHash_ro_i_bitwise_or,
        Parrot_GDBMHash_ro_i_bitwise_or_int,
        Parrot_GDBMHash_ro_i_bitwise_ors,
        Parrot_GDBMHash_ro_i_bitwise_ors_str,
        Parrot_GDBMHash_ro_i_bitwise_shl,
        Parrot_GDBMHash_ro_i_bitwise_shl_int,
        Parrot_GDBMHash_ro_i_bitwise_shr,
        Parrot_GDBMHash_ro_i_bitwise_shr_int,
        Parrot_GDBMHash_ro_i_bitwise_xor,
        Parrot_GDBMHash_ro_i_bitwise_xor_int,
        Parrot_GDBMHash_ro_i_bitwise_xors,
        Parrot_GDBMHash_ro_i_bitwise_xors_str,
        Parrot_GDBMHash_ro_i_concatenate,
        Parrot_GDBMHash_ro_i_concatenate_str,
        Parrot_GDBMHash_ro_i_divide,
        Parrot_GDBMHash_ro_i_divide_float,
        Parrot_GDBMHash_ro_i_divide_int,
        Parrot_GDBMHash_ro_i_floor_divide,
        Parrot_GDBMHash_ro_i_floor_divide_float,
        Parrot_GDBMHash_ro_i_floor_divide_int,
        Parrot_GDBMHash_ro_i_logical_not,
        Parrot_GDBMHash_ro_i_modulus,
        Parrot_GDBMHash_ro_i_modulus_float,
        Parrot_GDBMHash_ro_i_modulus_int,
        Parrot_GDBMHash_ro_i_multiply,
        Parrot_GDBMHash_ro_i_multiply_float,
        Parrot_GDBMHash_ro_i_multiply_int,
        Parrot_GDBMHash_ro_i_neg,
        Parrot_GDBMHash_ro_i_pow,
        Parrot_GDBMHash_ro_i_pow_float,
        Parrot_GDBMHash_ro_i_pow_int,
        Parrot_GDBMHash_ro_i_repeat,
        Parrot_GDBMHash_ro_i_repeat_int,
        Parrot_GDBMHash_ro_i_subtract,
        Parrot_GDBMHash_ro_i_subtract_float,
        Parrot_GDBMHash_ro_i_subtract_int,
        Parrot_GDBMHash_ro_increment,
        Parrot_GDBMHash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_GDBMHash_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_GDBMHash_ro_pop_float,
        Parrot_GDBMHash_ro_pop_integer,
        Parrot_GDBMHash_ro_pop_pmc,
        Parrot_GDBMHash_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_GDBMHash_ro_push_float,
        Parrot_GDBMHash_ro_push_integer,
        Parrot_GDBMHash_ro_push_pmc,
        Parrot_GDBMHash_ro_push_string,
        Parrot_GDBMHash_ro_remove_attribute,
        Parrot_GDBMHash_ro_remove_method,
        Parrot_GDBMHash_ro_remove_parent,
        Parrot_GDBMHash_ro_remove_role,
        Parrot_GDBMHash_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_GDBMHash_ro_set_attr_keyed,
        Parrot_GDBMHash_ro_set_attr_str,
        Parrot_GDBMHash_ro_set_bignum_int,
        Parrot_GDBMHash_ro_set_bignum_num,
        Parrot_GDBMHash_ro_set_bignum_str,
        Parrot_GDBMHash_ro_set_bool,
        Parrot_GDBMHash_ro_set_integer_keyed,
        Parrot_GDBMHash_ro_set_integer_keyed_int,
        Parrot_GDBMHash_ro_set_integer_keyed_str,
        Parrot_GDBMHash_ro_set_integer_native,
        Parrot_GDBMHash_ro_set_integer_same,
        Parrot_GDBMHash_ro_set_number_keyed,
        Parrot_GDBMHash_ro_set_number_keyed_int,
        Parrot_GDBMHash_ro_set_number_keyed_str,
        Parrot_GDBMHash_ro_set_number_native,
        Parrot_GDBMHash_ro_set_number_same,
        Parrot_GDBMHash_ro_set_pmc,
        Parrot_GDBMHash_ro_set_pmc_keyed,
        Parrot_GDBMHash_ro_set_pmc_keyed_int,
        Parrot_GDBMHash_ro_set_pmc_keyed_str,
        Parrot_GDBMHash_ro_set_pointer,
        Parrot_GDBMHash_ro_set_pointer_keyed,
        Parrot_GDBMHash_ro_set_pointer_keyed_int,
        Parrot_GDBMHash_ro_set_pointer_keyed_str,
        Parrot_GDBMHash_ro_set_string_keyed,
        Parrot_GDBMHash_ro_set_string_keyed_int,
        Parrot_GDBMHash_ro_set_string_keyed_str,
        Parrot_GDBMHash_ro_set_string_native,
        Parrot_GDBMHash_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_GDBMHash_ro_shift_float,
        Parrot_GDBMHash_ro_shift_integer,
        Parrot_GDBMHash_ro_shift_pmc,
        Parrot_GDBMHash_ro_shift_string,
        Parrot_default_slice,
        Parrot_GDBMHash_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_GDBMHash_ro_thaw,
        Parrot_GDBMHash_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_GDBMHash_ro_unshift_float,
        Parrot_GDBMHash_ro_unshift_integer,
        Parrot_GDBMHash_ro_unshift_pmc,
        Parrot_GDBMHash_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->base_type    = entry;
        vt_clone->whoami       = string_make(interp, "GDBMHash", 8, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG);
        vt_clone->provides_str = Parrot_str_append(interp, vt_clone->provides_str,
            string_make(interp, " hash", 5, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG));

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "GDBMHash")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "GDBMHash"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
        {
        
            if (pass) {
        #ifdef WIN32
                /* RT #46393: What if libgdbm.so cannot be loaded */
                /* Parrot_load_lib(interp, slib, NULL); */
                STRING *slib = CONST_STRING(interp, "gdbm3");
        #endif
            }

        }
        {
        }
    } /* pass */
} /* Parrot_GDBMHash_class_init */
/*
 * This load function will be called to do global (once) setup
 * whatever is needed to get this extension running
 */


PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_gdbmhash_load(PARROT_INTERP); /* don't warn */
PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_gdbmhash_load(PARROT_INTERP)
{
    Parrot_String whoami;
    Parrot_PMC    pmc;
    Parrot_Int typeGDBMHash;
    int pass;

    /* create a library PMC */
    pmc = constant_pmc_new(interp, enum_class_ParrotLibrary);

    /* TODO: stuff some info into this PMC's props */

    /* for all PMCs we want to register: */
    whoami = CONST_STRING_GEN(interp, "GDBMHash");
    typeGDBMHash = pmc_register(interp, whoami);

    /* do class_init code */
    for (pass = 0; pass <= 1; ++pass) {
        Parrot_GDBMHash_class_init(interp, typeGDBMHash, pass);
    }
    return pmc;
}

#line 372 "./gdbmhash.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>, L<http://gdbm.gnu.org>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
