/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './rational.pmc'
 * by ../../tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#define PARROT_IN_EXTENSION
#define CONST_STRING(i, s) Parrot_str_new_constant((i), s)
#define CONST_STRING_GEN(i, s) Parrot_str_new_constant((i), s)
#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_rational.h"
#include "pmc_default.h"
#include "pmc_continuation.h"
#line 1 "./rational.pmc"
/*
Copyright (C) 2008-2009, Parrot Foundation.
$Id: rational.pmc 37238 2009-03-09 11:38:54Z cotto $

=pod

=head1 NAME

src/dynpmc/rational.pmc - Rational numbers PMC

=head1 DESCRIPTION

Rational is currently going to get implemented. It uses the GNU Multiple Precision (GMP) library,
like BigInt, because implementation with integers would be too unstable and inaccurate.

'LispRational' will subclass this.

You may use Rational with any of parrot's basic data types as well as with String-, Integer- and
Float-PMCs.

=head1 Functions

Currently C<rational.pmc> only has some C<static> functions for code sharing.

=over 4

=cut

*/

#include "parrot/has_header.h"

#ifdef PARROT_HAS_GMP
#  include <gmp.h>
   typedef struct RATIONAL {
      mpq_t q;
   } RATIONAL;
#  define PMC_rational(x) ((Parrot_Rational_attributes *)PMC_data(x))->rational
#  define RT(x)           ((Parrot_Rational_attributes *)PMC_data(x))->rational->q
#else
#  define RT(x)
#endif

#define RAISE_EXCEPTION   Parrot_ex_throw_from_c_args(interp, NULL, \
    EXCEPTION_LIBRARY_NOT_LOADED, "GNU Multiple Precision library not found.");

/*

=item * static STRING *rat_get_string_to_base(PARROT_INTERP, PMC *self, int base)

Returns a string representation of a Rational-PMC to a certain base.

=cut

*/
static STRING *rat_get_string_to_base(PARROT_INTERP, PMC *self, int base) {
  #ifdef PARROT_HAS_GMP
    char * const cstr   = mpq_get_str(NULL, (int) base, RT(self));
    STRING * const pstr = Parrot_str_new(interp, cstr, 0);
    Parrot_str_free_cstring(cstr);
    return pstr;
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_add_integer(PARROT_INTERP, PMC *self, int value, PMC *dest)

Adds an integer "value" to a Rational-PMC and stores the result in (another) Rational-PMC.

=cut

*/
static void rat_add_integer(PARROT_INTERP, PMC *self, int value, PMC *dest) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    if (dest) {
        if (self != dest)
            pmc_reuse(interp, dest, self->vtable->base_type, 0);
    }
    else {
        dest = pmc_new(interp, self->vtable->base_type);
    }

    mpq_init(t);
    mpq_set_si(t, (int) value, 1);
    mpq_add(RT(dest), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_add_float(PARROT_INTERP, PMC *self, double value, PMC *dest)

Adds a float "value" to a Rational-PMC and stores the result in (another) Rational-PMC. "value" is
first conveted to a rational using GMPs mpq_set_d-function. This is meant to be exact.

=cut

*/
static void rat_add_float(PARROT_INTERP, PMC *self, double value, PMC *dest) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    if (dest)
        pmc_reuse(interp, dest, self->vtable->base_type, 0);
    else
        dest = pmc_new(interp, self->vtable->base_type);

    mpq_init(t);
    mpq_set_d(t, (double) value);
    mpq_add(RT(dest), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_multiply_integer(PARROT_INTERP, PMC *self, int value, PMC *dest)

Multiplys a Rational-PMC with an integer "value" and stores the result in (another) Rational-PMC.

=cut

*/
static void rat_multiply_integer(PARROT_INTERP, PMC *self, int value, PMC *dest) {
  #ifdef PARROT_HAS_GMP
    if (dest)
        pmc_reuse(interp, dest, self->vtable->base_type, 0);
    else
        dest = pmc_new(interp, self->vtable->base_type);

    mpz_mul_ui(mpq_numref(RT(dest)), mpq_numref(RT(self)), (unsigned int) value);
    mpq_set_den(RT(dest), mpq_denref(RT(self)));
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_multiply_float(PARROT_INTERP, PMC *self, double value, PMC *dest)

Multiplies a Rational-PMC with a float "value" and stores the result in (another) Rational-PMC.

=cut

*/
static void rat_multiply_float(PARROT_INTERP, PMC *self, double value, PMC *dest) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    if (dest)
        pmc_reuse(interp, dest, self->vtable->base_type, 0);
    else
        dest = pmc_new(interp, self->vtable->base_type);

    mpq_init(t);
    mpq_set_d(t, (double) value);
    mpq_mul(RT(dest), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_divide_integer(PARROT_INTERP, PMC *self, int value, PMC *dest)

Divides a Rational-PMC through an integer "value" and stores the result in (another) Rational-PMC.

=cut

*/
static void rat_divide_integer(PARROT_INTERP, PMC *self, int value, PMC *dest) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    if (dest)
        pmc_reuse(interp, dest, self->vtable->base_type, 0);
    else
        dest = pmc_new(interp, self->vtable->base_type);

    mpq_init(t);
    mpq_set_si(t, (int) value, 1);
    mpq_div(RT(dest), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_divide_float(PARROT_INTERP, PMC *self, double value, PMC *dest)

Divides a Rational-PMC through a float "value" and stores the result in (another) Rational-PMC.

=cut

*/
static void rat_divide_float(PARROT_INTERP, PMC *self, double value, PMC *dest) {
  #ifdef PARROT_HAS_GMP
    mpq_t t;

    if (dest)
        pmc_reuse(interp, dest, self->vtable->base_type, 0);
    else
        dest = pmc_new(interp, self->vtable->base_type);

    mpq_init(t);
    mpq_set_d(t, (double) value);
    mpq_div(RT(dest), RT(self), t);
    mpq_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=item * static void rat_power_int(PARROT_INTERP, PMC *self, int value, PMC *dest)

Calculates the power of a Rational-PMC to an exponent value and stores the result in (another)
Rational-PMC.

=cut

*/
static void rat_power_int(PARROT_INTERP, PMC *self, int value, PMC *dest) {
  #ifdef PARROT_HAS_GMP
    mpz_t t;

    if (dest)
        pmc_reuse(interp, dest, self->vtable->base_type, 0);
    else
        dest = pmc_new(interp, self->vtable->base_type);

    mpq_get_num(t, RT(self));
    mpz_pow_ui(t, t, (unsigned int) value);
    mpq_set_num(RT(dest), t);
    mpz_clear(t);

    mpq_get_den(t, RT(self));
    mpz_pow_ui(t, t, (unsigned int) value);
    mpq_set_den(RT(dest), t);
    mpz_clear(t);
  #else
    RAISE_EXCEPTION
  #endif
}

/*

=back

=cut

*/
#line 293 "./rational.c"
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1016 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    mpq_abs(RT(dest), RT(pmc));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 310 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 627 "./rational.pmc"

    rat_add_float(interp, pmc, (double) value, dest);
    return dest;
#line 319 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 604 "./rational.pmc"

    rat_add_integer(interp, pmc, (int) value, dest);
    return dest;
#line 328 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_clone(PARROT_INTERP, PMC *pmc)
{
#line 307 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpz_t num, den;
    PMC * const ret = pmc_new(interp, pmc->vtable->base_type);
    mpq_get_num(num, RT(pmc));
    mpq_get_den(den, RT(pmc));
    mpq_set_num(RT(ret), num);
    mpq_set_den(RT(ret), den);
    mpz_clear(num);
    mpz_clear(den);
    return ret;
  #else
    RAISE_EXCEPTION
  #endif
#line 348 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_decrement(PARROT_INTERP, PMC *pmc)
{
#line 522 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpz_sub(mpq_numref(RT(pmc)), mpq_numref(RT(pmc)), mpq_denref(RT(pmc)));
    mpq_canonicalize(RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 361 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_destroy(PARROT_INTERP, PMC *pmc)
{
#line 330 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_clear(RT(pmc));
    mem_sys_free(RT(pmc));
    mem_sys_free(PMC_data(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 375 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 957 "./rational.pmc"

    rat_divide_float(interp, pmc, (double) value, dest);
    return dest;
#line 384 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 934 "./rational.pmc"

    rat_divide_integer(interp, pmc, (int) value, dest);
    return dest;
#line 393 "./rational.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_Rational_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 459 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    if (mpq_cmp_si(RT(pmc), 0, 0))
        return 0;
    else
        return 1;
  #else
    RAISE_EXCEPTION
  #endif
#line 408 "./rational.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_Rational_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 416 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpz_t q;
    mpz_init(q);
    mpz_tdiv_q(q, mpq_numref(RT(pmc)), mpq_denref(RT(pmc)));
    if (mpz_fits_slong_p(q)) {
        const INTVAL ret = (INTVAL) mpz_get_si(q);
        mpz_clear(q);
        return ret;
    }
    else {
        mpz_clear(q);
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "Rational, get_integer(): Number is too big.");
    }
  #else
    RAISE_EXCEPTION
  #endif
#line 432 "./rational.c"
}
PARROT_DYNEXT_EXPORT  FLOATVAL 
Parrot_Rational_get_number(PARROT_INTERP, PMC *pmc)
{
#line 443 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    const double d = mpq_get_d(RT(pmc));
    return (FLOATVAL) d;
  #else
    RAISE_EXCEPTION
  #endif
#line 445 "./rational.c"
}
PARROT_DYNEXT_EXPORT  STRING  *
Parrot_Rational_get_string(PARROT_INTERP, PMC *pmc)
{
#line 476 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    return rat_get_string_to_base(interp, pmc, 10);
  #else
    RAISE_EXCEPTION
  #endif
#line 457 "./rational.c"
}
PARROT_DYNEXT_EXPORT  STRING  *
Parrot_Rational_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base)
{
#line 491 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    return rat_get_string_to_base(interp, pmc, (int) base);
  #else
    RAISE_EXCEPTION
  #endif
#line 469 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 1037 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_abs(RT(pmc), RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 481 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 639 "./rational.pmc"

    rat_add_float(interp, pmc, (double) value, pmc);
#line 489 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 616 "./rational.pmc"

    rat_add_integer(interp, pmc, (int) value, pmc);
#line 497 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 969 "./rational.pmc"

    rat_divide_float(interp, pmc, (double) value, pmc);
#line 505 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 946 "./rational.pmc"

    rat_divide_integer(interp, pmc, (int) value, pmc);
#line 513 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 859 "./rational.pmc"

    rat_multiply_float(interp, pmc, (double) value, pmc);
#line 521 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 836 "./rational.pmc"

    rat_multiply_integer(interp, pmc, (int) value, pmc);
#line 529 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_i_neg(PARROT_INTERP, PMC *pmc)
{
#line 1001 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_neg(RT(pmc), RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 541 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 749 "./rational.pmc"

    rat_add_float(interp, pmc, -((double) value), pmc);
#line 549 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 726 "./rational.pmc"

    rat_add_integer(interp, pmc, -((int) value), pmc);
#line 557 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_increment(PARROT_INTERP, PMC *pmc)
{
#line 506 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpz_add(mpq_numref(RT(pmc)), mpq_numref(RT(pmc)), mpq_denref(RT(pmc)));
    mpq_canonicalize(RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 570 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_init(PARROT_INTERP, PMC *pmc)
{
#line 289 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    Parrot_Rational_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_Rational_attributes);
    PMC_data(pmc)     = attrs;
    PMC_rational(pmc) = (RATIONAL *)malloc(sizeof (RATIONAL));
    mpq_init(RT(pmc));
    PObj_active_destroy_SET(pmc);
  #endif
#line 585 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 847 "./rational.pmc"

    rat_multiply_float(interp, pmc, (double) value, dest);
    return dest;
#line 594 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 824 "./rational.pmc"

    rat_multiply_integer(interp, pmc, (int) value, dest);
    return dest;
#line 603 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 980 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    mpq_neg(RT(dest), RT(pmc));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 621 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 347 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_set_si(RT(pmc), (signed int) value, 1);
    mpq_canonicalize(RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 634 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 363 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_set_d(RT(pmc), (double) value);
    mpq_canonicalize(RT(pmc));
  #else
    RAISE_EXCEPTION
  #endif
#line 647 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base, STRING *value)
{
#line 397 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    char * const cstr = Parrot_str_to_cstring(interp, value);
    mpq_set_str(RT(pmc), cstr, (int) base);
    mpq_canonicalize(RT(pmc));
    Parrot_str_free_cstring(cstr);
  #else
    RAISE_EXCEPTION
  #endif
#line 662 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 379 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    char * const cstr = Parrot_str_to_cstring(interp, value);
    mpq_set_str(RT(pmc), cstr, 0);
    mpq_canonicalize(RT(pmc));
    Parrot_str_free_cstring(cstr);
  #else
    RAISE_EXCEPTION
  #endif
#line 677 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 737 "./rational.pmc"

    rat_add_float(interp, pmc, -((double) value), dest);
    return dest;
#line 686 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 714 "./rational.pmc"

    rat_add_integer(interp, pmc, -((int) value), dest);
    return dest;
#line 695 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_nci_version(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 733 "./rational.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 750 "./rational.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 272 "./rational.pmc"

    STRING *version;
  #ifdef PARROT_HAS_GMP
    version = Parrot_str_new(interp, gmp_version, 0);
  #else
    version = Parrot_str_new(interp, "0.0.0", 0);
  #endif
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *version */
    /*BEGIN GENERATED ACCESSORS */
#line 769 "./rational.pmc"
    CTX_REG_STR(_ctx, 0) = version;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto version_returns;
    /*END RETURN STRING *version */
    }
#line 279 "./rational.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
version_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 814 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 540 "./rational.pmc"

    rat_add_integer(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 823 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_add_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 545 "./rational.pmc"

    rat_add_float(interp, pmc, VTABLE_get_number(interp, value), dest);
    return dest;
#line 832 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_add_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 550 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    mpq_add(RT(dest), RT(pmc), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 850 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 564 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, add: Not implemented (yet).");
#line 859 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 576 "./rational.pmc"

    rat_add_integer(interp, pmc, (int) VTABLE_get_integer(interp, value), pmc);
#line 867 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_add_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 580 "./rational.pmc"

    rat_add_float(interp, pmc, (double) VTABLE_get_number(interp, value), pmc);
#line 875 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_add_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 584 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_add(RT(pmc), RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 887 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 592 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_add: Not implemented (yet).");
#line 896 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 650 "./rational.pmc"

    rat_add_integer(interp, pmc, -((int) VTABLE_get_integer(interp, value)), dest);
    return dest;
#line 905 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_subtract_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 655 "./rational.pmc"

    rat_add_float(interp, pmc, - ((double) VTABLE_get_number(interp, value)), dest);
    return dest;
#line 914 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_subtract_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 660 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    mpq_sub(RT(dest), RT(pmc), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 932 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 674 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, subtract: Not implemented (yet).");
#line 941 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 686 "./rational.pmc"

    rat_add_integer(interp, pmc, -((int) VTABLE_get_integer(interp, value)), pmc);
#line 949 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_subtract_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 690 "./rational.pmc"

    rat_add_float(interp, pmc, - ((double) VTABLE_get_number(interp, value)), pmc);
#line 957 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_subtract_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 694 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_sub(RT(pmc), RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 969 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 702 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_subtract: Not implemented (yet).");
#line 978 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 760 "./rational.pmc"

    rat_multiply_integer(interp, pmc, (int) VTABLE_get_integer(interp, value), dest);
    return dest;
#line 987 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_multiply_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 765 "./rational.pmc"

    rat_multiply_float(interp, pmc, (double) VTABLE_get_number(interp, value), dest);
    return dest;
#line 996 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_multiply_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 770 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    mpq_mul(RT(dest), RT(pmc), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 1014 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 784 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, multiply: Not implemented (yet).");
#line 1023 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 796 "./rational.pmc"

    rat_multiply_integer(interp, pmc, (int) VTABLE_get_integer(interp, value), pmc);
#line 1031 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_multiply_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 800 "./rational.pmc"

    rat_multiply_float(interp, pmc, (double) VTABLE_get_number(interp, value), pmc);
#line 1039 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_multiply_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 804 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_mul(RT(pmc), RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 1051 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 812 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_multiply: Not implemented (yet).");
#line 1060 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 870 "./rational.pmc"

    rat_divide_integer(interp, pmc, (int) VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1069 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_divide_Float_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 875 "./rational.pmc"

    rat_divide_float(interp, pmc, (double) VTABLE_get_number(interp, value), dest);
    return dest;
#line 1078 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_divide_Rational_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 880 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    mpq_div(RT(dest), RT(pmc), RT(value));
    return dest;
  #else
    RAISE_EXCEPTION
  #endif
#line 1096 "./rational.c"
}
PARROT_DYNEXT_EXPORT  PMC  *
Parrot_Rational_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 894 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, divide: Not implemented (yet).");
#line 1105 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 906 "./rational.pmc"

    rat_divide_integer(interp, pmc, (int) VTABLE_get_integer(interp, value), pmc);
#line 1113 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_divide_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 910 "./rational.pmc"

    rat_divide_float(interp, pmc, (double) VTABLE_get_number(interp, value), pmc);
#line 1121 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_divide_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 914 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    mpq_div(RT(pmc), RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 1133 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void 
Parrot_Rational_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 922 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Rational, i_divide: Not implemented (yet).");
#line 1142 "./rational.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_Rational_multi_cmp_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1052 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    return (INTVAL) mpq_cmp_si(RT(pmc), VTABLE_get_integer(interp, value), 1);
  #else
    RAISE_EXCEPTION
  #endif
#line 1154 "./rational.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_Rational_multi_cmp_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1060 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "This is going to get implemented soon.");
  #else
    RAISE_EXCEPTION
  #endif
#line 1167 "./rational.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_Rational_multi_cmp_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1069 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    return (INTVAL) mpq_cmp(RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 1179 "./rational.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_Rational_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1077 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "cmp not implemented (yet).");
#line 1188 "./rational.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_Rational_multi_is_equal_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1089 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    INTVAL eq = 0;
    mpq_t t;
    mpq_init(t);
    mpq_set_ui(t, VTABLE_get_integer(interp, value), 1);

    eq = (INTVAL) mpq_equal(RT(pmc), RT(value));
    mpq_clear(t);

    return eq;
  #else
    RAISE_EXCEPTION
  #endif
#line 1208 "./rational.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_Rational_multi_is_equal_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1105 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "Equality to floats can not be checked because of limited machine "
        "accuracy.\nApproximate the rational and check whether the "
        "difference to a value is lower\nthan an epsilon.");
#line 1219 "./rational.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_Rational_multi_is_equal_Rational(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1112 "./rational.pmc"

  #ifdef PARROT_HAS_GMP
    return (INTVAL) mpq_equal(RT(pmc), RT(value));
  #else
    RAISE_EXCEPTION
  #endif
#line 1231 "./rational.c"
}
PARROT_DYNEXT_EXPORT  INTVAL 
Parrot_Rational_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1120 "./rational.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
        "is_equal not implemented (yet).");
#line 1240 "./rational.c"
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  PMC *
Parrot_Rational_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  FLOATVAL
Parrot_Rational_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  INTVAL
Parrot_Rational_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  PMC *
Parrot_Rational_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  STRING *
Parrot_Rational_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  FLOATVAL
Parrot_Rational_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  INTVAL
Parrot_Rational_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  PMC *
Parrot_Rational_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  STRING *
Parrot_Rational_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Rational");
}
PARROT_DYNEXT_EXPORT  void
Parrot_Rational_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Rational");
}
#include "pmc_default.h"
void
Parrot_Rational_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":rational ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        -1, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_Rational_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_Rational_add_float,
        Parrot_Rational_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Rational_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Rational_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Rational_destroy,
        Parrot_default_divide,
        Parrot_Rational_divide_float,
        Parrot_Rational_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Rational_get_bool,
        Parrot_default_get_class,
        Parrot_Rational_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_Rational_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Rational_get_string,
        Parrot_default_get_string_keyed,
        Parrot_Rational_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Rational_i_absolute,
        Parrot_default_i_add,
        Parrot_Rational_i_add_float,
        Parrot_Rational_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_Rational_i_divide_float,
        Parrot_Rational_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_Rational_i_multiply_float,
        Parrot_Rational_i_multiply_int,
        Parrot_Rational_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_Rational_i_subtract_float,
        Parrot_Rational_i_subtract_int,
        Parrot_Rational_increment,
        Parrot_Rational_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_Rational_multiply_float,
        Parrot_Rational_multiply_int,
        Parrot_default_name,
        Parrot_Rational_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Rational_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_Rational_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_Rational_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Rational_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_Rational_subtract_float,
        Parrot_Rational_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        -1, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_Rational_absolute,
        Parrot_default_add,
        Parrot_Rational_ro_add_attribute,
        Parrot_Rational_add_float,
        Parrot_Rational_add_int,
        Parrot_Rational_ro_add_method,
        Parrot_Rational_ro_add_parent,
        Parrot_Rational_ro_add_role,
        Parrot_Rational_ro_add_vtable_override,
        Parrot_Rational_ro_assign_pmc,
        Parrot_Rational_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Rational_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Rational_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Rational_ro_delete_keyed,
        Parrot_Rational_ro_delete_keyed_int,
        Parrot_Rational_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Rational_destroy,
        Parrot_default_divide,
        Parrot_Rational_divide_float,
        Parrot_Rational_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Rational_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Rational_get_bool,
        Parrot_default_get_class,
        Parrot_Rational_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_Rational_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Rational_get_string,
        Parrot_default_get_string_keyed,
        Parrot_Rational_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Rational_ro_i_absolute,
        Parrot_Rational_ro_i_add,
        Parrot_Rational_ro_i_add_float,
        Parrot_Rational_ro_i_add_int,
        Parrot_Rational_ro_i_bitwise_and,
        Parrot_Rational_ro_i_bitwise_and_int,
        Parrot_Rational_ro_i_bitwise_ands,
        Parrot_Rational_ro_i_bitwise_ands_str,
        Parrot_Rational_ro_i_bitwise_lsr,
        Parrot_Rational_ro_i_bitwise_lsr_int,
        Parrot_Rational_ro_i_bitwise_not,
        Parrot_Rational_ro_i_bitwise_nots,
        Parrot_Rational_ro_i_bitwise_or,
        Parrot_Rational_ro_i_bitwise_or_int,
        Parrot_Rational_ro_i_bitwise_ors,
        Parrot_Rational_ro_i_bitwise_ors_str,
        Parrot_Rational_ro_i_bitwise_shl,
        Parrot_Rational_ro_i_bitwise_shl_int,
        Parrot_Rational_ro_i_bitwise_shr,
        Parrot_Rational_ro_i_bitwise_shr_int,
        Parrot_Rational_ro_i_bitwise_xor,
        Parrot_Rational_ro_i_bitwise_xor_int,
        Parrot_Rational_ro_i_bitwise_xors,
        Parrot_Rational_ro_i_bitwise_xors_str,
        Parrot_Rational_ro_i_concatenate,
        Parrot_Rational_ro_i_concatenate_str,
        Parrot_Rational_ro_i_divide,
        Parrot_Rational_ro_i_divide_float,
        Parrot_Rational_ro_i_divide_int,
        Parrot_Rational_ro_i_floor_divide,
        Parrot_Rational_ro_i_floor_divide_float,
        Parrot_Rational_ro_i_floor_divide_int,
        Parrot_Rational_ro_i_logical_not,
        Parrot_Rational_ro_i_modulus,
        Parrot_Rational_ro_i_modulus_float,
        Parrot_Rational_ro_i_modulus_int,
        Parrot_Rational_ro_i_multiply,
        Parrot_Rational_ro_i_multiply_float,
        Parrot_Rational_ro_i_multiply_int,
        Parrot_Rational_ro_i_neg,
        Parrot_Rational_ro_i_pow,
        Parrot_Rational_ro_i_pow_float,
        Parrot_Rational_ro_i_pow_int,
        Parrot_Rational_ro_i_repeat,
        Parrot_Rational_ro_i_repeat_int,
        Parrot_Rational_ro_i_subtract,
        Parrot_Rational_ro_i_subtract_float,
        Parrot_Rational_ro_i_subtract_int,
        Parrot_Rational_ro_increment,
        Parrot_Rational_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_Rational_ro_morph,
        Parrot_default_multiply,
        Parrot_Rational_multiply_float,
        Parrot_Rational_multiply_int,
        Parrot_default_name,
        Parrot_Rational_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Rational_ro_pop_float,
        Parrot_Rational_ro_pop_integer,
        Parrot_Rational_ro_pop_pmc,
        Parrot_Rational_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Rational_ro_push_float,
        Parrot_Rational_ro_push_integer,
        Parrot_Rational_ro_push_pmc,
        Parrot_Rational_ro_push_string,
        Parrot_Rational_ro_remove_attribute,
        Parrot_Rational_ro_remove_method,
        Parrot_Rational_ro_remove_parent,
        Parrot_Rational_ro_remove_role,
        Parrot_Rational_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_Rational_ro_set_attr_keyed,
        Parrot_Rational_ro_set_attr_str,
        Parrot_Rational_ro_set_bignum_int,
        Parrot_Rational_ro_set_bignum_num,
        Parrot_Rational_ro_set_bignum_str,
        Parrot_Rational_ro_set_bool,
        Parrot_Rational_ro_set_integer_keyed,
        Parrot_Rational_ro_set_integer_keyed_int,
        Parrot_Rational_ro_set_integer_keyed_str,
        Parrot_Rational_ro_set_integer_native,
        Parrot_Rational_ro_set_integer_same,
        Parrot_Rational_ro_set_number_keyed,
        Parrot_Rational_ro_set_number_keyed_int,
        Parrot_Rational_ro_set_number_keyed_str,
        Parrot_Rational_ro_set_number_native,
        Parrot_Rational_ro_set_number_same,
        Parrot_Rational_ro_set_pmc,
        Parrot_Rational_ro_set_pmc_keyed,
        Parrot_Rational_ro_set_pmc_keyed_int,
        Parrot_Rational_ro_set_pmc_keyed_str,
        Parrot_Rational_ro_set_pointer,
        Parrot_Rational_ro_set_pointer_keyed,
        Parrot_Rational_ro_set_pointer_keyed_int,
        Parrot_Rational_ro_set_pointer_keyed_str,
        Parrot_Rational_ro_set_string_keyed,
        Parrot_Rational_ro_set_string_keyed_int,
        Parrot_Rational_ro_set_string_keyed_str,
        Parrot_Rational_ro_set_string_native,
        Parrot_Rational_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Rational_ro_shift_float,
        Parrot_Rational_ro_shift_integer,
        Parrot_Rational_ro_shift_pmc,
        Parrot_Rational_ro_shift_string,
        Parrot_default_slice,
        Parrot_Rational_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_Rational_subtract_float,
        Parrot_Rational_subtract_int,
        Parrot_Rational_ro_thaw,
        Parrot_Rational_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Rational_ro_unshift_float,
        Parrot_Rational_ro_unshift_integer,
        Parrot_Rational_ro_unshift_pmc,
        Parrot_Rational_ro_unshift_string,
        Parrot_default_visit
    };

     multi_func_list _temp_multi_func_list[] = {
        { "add", 
          "PJPPP", 
          "Rational,Integer,PMC", 
          (funcptr_t) Parrot_Rational_multi_add_Integer_PMC },
        { "add", 
          "PJPPP", 
          "Rational,Float,PMC", 
          (funcptr_t) Parrot_Rational_multi_add_Float_PMC },
        { "add", 
          "PJPPP", 
          "Rational,Rational,PMC", 
          (funcptr_t) Parrot_Rational_multi_add_Rational_PMC },
        { "add", 
          "PJPPP", 
          "Rational,DEFAULT,PMC", 
          (funcptr_t) Parrot_Rational_multi_add_DEFAULT_PMC },
        { "i_add", 
          "vJPP", 
          "Rational,Integer", 
          (funcptr_t) Parrot_Rational_multi_i_add_Integer },
        { "i_add", 
          "vJPP", 
          "Rational,Float", 
          (funcptr_t) Parrot_Rational_multi_i_add_Float },
        { "i_add", 
          "vJPP", 
          "Rational,Rational", 
          (funcptr_t) Parrot_Rational_multi_i_add_Rational },
        { "i_add", 
          "vJPP", 
          "Rational,DEFAULT", 
          (funcptr_t) Parrot_Rational_multi_i_add_DEFAULT },
        { "subtract", 
          "PJPPP", 
          "Rational,Integer,PMC", 
          (funcptr_t) Parrot_Rational_multi_subtract_Integer_PMC },
        { "subtract", 
          "PJPPP", 
          "Rational,Float,PMC", 
          (funcptr_t) Parrot_Rational_multi_subtract_Float_PMC },
        { "subtract", 
          "PJPPP", 
          "Rational,Rational,PMC", 
          (funcptr_t) Parrot_Rational_multi_subtract_Rational_PMC },
        { "subtract", 
          "PJPPP", 
          "Rational,DEFAULT,PMC", 
          (funcptr_t) Parrot_Rational_multi_subtract_DEFAULT_PMC },
        { "i_subtract", 
          "vJPP", 
          "Rational,Integer", 
          (funcptr_t) Parrot_Rational_multi_i_subtract_Integer },
        { "i_subtract", 
          "vJPP", 
          "Rational,Float", 
          (funcptr_t) Parrot_Rational_multi_i_subtract_Float },
        { "i_subtract", 
          "vJPP", 
          "Rational,Rational", 
          (funcptr_t) Parrot_Rational_multi_i_subtract_Rational },
        { "i_subtract", 
          "vJPP", 
          "Rational,DEFAULT", 
          (funcptr_t) Parrot_Rational_multi_i_subtract_DEFAULT },
        { "multiply", 
          "PJPPP", 
          "Rational,Integer,PMC", 
          (funcptr_t) Parrot_Rational_multi_multiply_Integer_PMC },
        { "multiply", 
          "PJPPP", 
          "Rational,Float,PMC", 
          (funcptr_t) Parrot_Rational_multi_multiply_Float_PMC },
        { "multiply", 
          "PJPPP", 
          "Rational,Rational,PMC", 
          (funcptr_t) Parrot_Rational_multi_multiply_Rational_PMC },
        { "multiply", 
          "PJPPP", 
          "Rational,DEFAULT,PMC", 
          (funcptr_t) Parrot_Rational_multi_multiply_DEFAULT_PMC },
        { "i_multiply", 
          "vJPP", 
          "Rational,Integer", 
          (funcptr_t) Parrot_Rational_multi_i_multiply_Integer },
        { "i_multiply", 
          "vJPP", 
          "Rational,Float", 
          (funcptr_t) Parrot_Rational_multi_i_multiply_Float },
        { "i_multiply", 
          "vJPP", 
          "Rational,Rational", 
          (funcptr_t) Parrot_Rational_multi_i_multiply_Rational },
        { "i_multiply", 
          "vJPP", 
          "Rational,DEFAULT", 
          (funcptr_t) Parrot_Rational_multi_i_multiply_DEFAULT },
        { "divide", 
          "PJPPP", 
          "Rational,Integer,PMC", 
          (funcptr_t) Parrot_Rational_multi_divide_Integer_PMC },
        { "divide", 
          "PJPPP", 
          "Rational,Float,PMC", 
          (funcptr_t) Parrot_Rational_multi_divide_Float_PMC },
        { "divide", 
          "PJPPP", 
          "Rational,Rational,PMC", 
          (funcptr_t) Parrot_Rational_multi_divide_Rational_PMC },
        { "divide", 
          "PJPPP", 
          "Rational,DEFAULT,PMC", 
          (funcptr_t) Parrot_Rational_multi_divide_DEFAULT_PMC },
        { "i_divide", 
          "vJPP", 
          "Rational,Integer", 
          (funcptr_t) Parrot_Rational_multi_i_divide_Integer },
        { "i_divide", 
          "vJPP", 
          "Rational,Float", 
          (funcptr_t) Parrot_Rational_multi_i_divide_Float },
        { "i_divide", 
          "vJPP", 
          "Rational,Rational", 
          (funcptr_t) Parrot_Rational_multi_i_divide_Rational },
        { "i_divide", 
          "vJPP", 
          "Rational,DEFAULT", 
          (funcptr_t) Parrot_Rational_multi_i_divide_DEFAULT },
        { "cmp", 
          "IJPP", 
          "Rational,Integer", 
          (funcptr_t) Parrot_Rational_multi_cmp_Integer },
        { "cmp", 
          "IJPP", 
          "Rational,Float", 
          (funcptr_t) Parrot_Rational_multi_cmp_Float },
        { "cmp", 
          "IJPP", 
          "Rational,Rational", 
          (funcptr_t) Parrot_Rational_multi_cmp_Rational },
        { "cmp", 
          "IJPP", 
          "Rational,DEFAULT", 
          (funcptr_t) Parrot_Rational_multi_cmp_DEFAULT },
        { "is_equal", 
          "IJPP", 
          "Rational,Integer", 
          (funcptr_t) Parrot_Rational_multi_is_equal_Integer },
        { "is_equal", 
          "IJPP", 
          "Rational,Float", 
          (funcptr_t) Parrot_Rational_multi_is_equal_Float },
        { "is_equal", 
          "IJPP", 
          "Rational,Rational", 
          (funcptr_t) Parrot_Rational_multi_is_equal_Rational },
        { "is_equal", 
          "IJPP", 
          "Rational,DEFAULT", 
          (funcptr_t) Parrot_Rational_multi_is_equal_DEFAULT }
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->base_type    = entry;
        vt_clone->whoami       = string_make(interp, "Rational", 8, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG);
        vt_clone->provides_str = Parrot_str_append(interp, vt_clone->provides_str,
            string_make(interp, " scalar", 7, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG));

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Rational")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Rational"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Rational_nci_version), "version");
        {
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_Rational_class_init */
/*
 * This load function will be called to do global (once) setup
 * whatever is needed to get this extension running
 */


PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_rational_load(PARROT_INTERP); /* don't warn */
PARROT_DYNEXT_EXPORT Parrot_PMC Parrot_lib_rational_load(PARROT_INTERP)
{
    Parrot_String whoami;
    Parrot_PMC    pmc;
    Parrot_Int typeRational;
    int pass;

    /* create a library PMC */
    pmc = constant_pmc_new(interp, enum_class_ParrotLibrary);

    /* TODO: stuff some info into this PMC's props */

    /* for all PMCs we want to register: */
    whoami = CONST_STRING_GEN(interp, "Rational");
    typeRational = pmc_register(interp, whoami);

    /* do class_init code */
    for (pass = 0; pass <= 1; ++pass) {
        Parrot_Rational_class_init(interp, typeRational, pass);
    }
    return pmc;
}

#line 1123 "./rational.pmc"


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
