/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/array.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_array.h"
#include "pmc_default.h"
#include "array.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/array.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: array.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/array.pmc - Array PMC

=head1 DESCRIPTION

These are the vtable functions for the Array base class.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

/*

=item C<static PMC *undef(PARROT_INTERP)>

Returns a C<Undef> PMC.

=cut

*/

static PMC *undef(PARROT_INTERP) {
    return pmc_new(interp, enum_class_Undef);
}

/*

=item C<static PMC *retval(PARROT_INTERP, void *ret)>

Processes C<*ret>, returning the appropriate PMC, or raising an
exception if necessary.

=cut

*/

static PMC *retval(PARROT_INTERP, void *ret) {
    PMC *value;

    if (ret == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "Array index out of bounds!");

    /* XXX getting non existent value, exception or undef?
     * current is for perlarray */
    if (ret == (void *)-1)
        value = undef(interp);
    else {
        value = *(PMC **)ret;

        /* XXX same here */
        if (!value)
            value = undef(interp);
    }

    return value;
}

/*

=item C<static PMC
*Parrot_Array_set_pmc_ptr(PARROT_INTERP, List *list, INTVAL key)>

Returns a pointer to the element at index C<key> of C<*list>. If
this element was previously empty, then this function also creates
and assigns an "undef" PMC to that element.

=cut

*/

static PMC *Parrot_Array_set_pmc_ptr(PARROT_INTERP, List *list, INTVAL key) {
    void * const ret = list_get(interp, list, key, enum_type_PMC);
    PMC  *value;

    if (ret == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "Array index out of bounds!");

    /* assign into a sparse or not yet set value */
    if (ret == (void *)-1 || *(PMC **)ret == 0) {
        value = undef(interp);
        list_assign(interp, list, key, value, enum_type_PMC);
    }
    else
        value = *(PMC **)ret;

    return value;
}
#line 123 "./src/pmc/array.c"
PARROT_EXPORT  void 
Parrot_Array_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 174 "./src/pmc/array.pmc"

    const INTVAL size = VTABLE_elements(interp, other);
    INTVAL       i;

    VTABLE_set_integer_native(interp, pmc, size);
    for (i = 0; i < size; i++) {
        PMC * const elem = VTABLE_get_pmc_keyed_int(interp, other, i);
        VTABLE_set_pmc_keyed_int(interp, pmc, i, elem);
    }
#line 137 "./src/pmc/array.c"
}
PARROT_EXPORT  PMC  *
Parrot_Array_clone(PARROT_INTERP, PMC *pmc)
{
#line 224 "./src/pmc/array.pmc"

    List       *l    = list_clone(interp, (List *)PMC_data(pmc));
    PMC * const dest = pmc_new_noinit(interp, pmc->vtable->base_type);

    PObj_custom_mark_SET(dest);

    PMC_data(dest) = l;
    l->container   = dest;

    return dest;
#line 153 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1040 "./src/pmc/array.pmc"

    PMC *box;

    const INTVAL ix      = key_integer(interp, key);
    PMC * const  nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_defined_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        return 0;

    return VTABLE_defined_keyed(interp, box, nextkey);
#line 174 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 1014 "./src/pmc/array.pmc"

    PMC  *value;
    void * const ret =
        list_get(interp, (List *)PMC_data(pmc), key, enum_type_PMC);

    if (ret == 0 || ret == (void *) -1)
        return 0;

    value = *(PMC **)ret;

    if (!value)
        return 0;

    return VTABLE_defined(interp, value);
#line 194 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1128 "./src/pmc/array.pmc"

    const INTVAL ix = key_integer(interp, key);
    list_splice(interp, (List *)PMC_data(pmc), NULL, ix, 1);
#line 203 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 1114 "./src/pmc/array.pmc"

    list_splice(interp, (List *)PMC_data(pmc), NULL, key, 1);
#line 211 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_elements(PARROT_INTERP, PMC *pmc)
{
#line 275 "./src/pmc/array.pmc"

    return ((List *) PMC_data(pmc))->length;
#line 219 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 1087 "./src/pmc/array.pmc"

    PMC *box;

    const INTVAL ix      = key_integer(interp, key);
    PMC * const  nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_exists_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        return 0;

    return VTABLE_exists_keyed(interp, box, nextkey);
#line 240 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 1067 "./src/pmc/array.pmc"

    void * ret = list_get(interp,
        (List *)PMC_data(pmc), key, enum_type_PMC);

    if (ret == 0 || ret == (void *)-1)
        return 0;

    return !PMC_IS_NULL(*(PMC **)ret);
#line 254 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1241 "./src/pmc/array.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_freeze(interp, pmc, info);
    VTABLE_push_integer(interp, io, VTABLE_elements(interp, pmc));
#line 264 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 260 "./src/pmc/array.pmc"

    const INTVAL size = VTABLE_elements(interp, pmc);
    return (INTVAL)(size != 0);
#line 273 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 246 "./src/pmc/array.pmc"

    return VTABLE_elements(interp, pmc);
#line 281 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 334 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return 0;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_get_integer_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_integer_keyed(interp, box, nextkey);
#line 306 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 318 "./src/pmc/array.pmc"

    PMC * const value = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    return VTABLE_get_integer(interp, value);
#line 316 "./src/pmc/array.c"
}
PARROT_EXPORT  PMC  *
Parrot_Array_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 1198 "./src/pmc/array.pmc"

    STRING     *name = CONST_STRING(interp, "set_key");
    PMC * const iter = pmc_new_init(interp, enum_class_Iterator, pmc);
    PMC * const key  = pmc_new(interp, enum_class_Key);
    Parrot_PCCINVOKE(interp, iter, name, "P->", key);

    PObj_get_FLAGS(key) |= KEY_integer_FLAG;

    if (!((List *)PMC_data(pmc))->length)
        VTABLE_set_integer_native(interp, key, -1);
    else
        VTABLE_set_integer_native(interp, key, 0);

    return iter;
#line 336 "./src/pmc/array.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Array_get_number(PARROT_INTERP, PMC *pmc)
{
#line 289 "./src/pmc/array.pmc"

    INTVAL e = VTABLE_elements(interp, pmc);
    return (FLOATVAL)e;
#line 345 "./src/pmc/array.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Array_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 382 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC *nextkey, *box;

    if (!key)
        return (FLOATVAL)0;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_get_number_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_number_keyed(interp, box, nextkey);
#line 370 "./src/pmc/array.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Array_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 365 "./src/pmc/array.pmc"

    PMC * const value = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    return VTABLE_get_number(interp, value);

#line 381 "./src/pmc/array.c"
}
PARROT_EXPORT  PMC  *
Parrot_Array_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 476 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return 0;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_pmc_keyed(interp, box, nextkey);
#line 406 "./src/pmc/array.c"
}
PARROT_EXPORT  PMC  *
Parrot_Array_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 460 "./src/pmc/array.pmc"


    return retval(interp,
        list_get(interp, (List *)PMC_data(pmc), key, enum_type_PMC));
#line 416 "./src/pmc/array.c"
}
PARROT_EXPORT  STRING  *
Parrot_Array_get_string(PARROT_INTERP, PMC *pmc)
{
#line 304 "./src/pmc/array.pmc"

    return Parrot_sprintf_c(interp, "array[%p]", pmc);
#line 424 "./src/pmc/array.c"
}
PARROT_EXPORT  STRING  *
Parrot_Array_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 429 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return 0;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey)
        return VTABLE_get_string_keyed_int(interp, pmc, ix);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    if (!box)
        box = undef(interp);

    return VTABLE_get_string_keyed(interp, box, nextkey);
#line 449 "./src/pmc/array.c"
}
PARROT_EXPORT  STRING  *
Parrot_Array_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 413 "./src/pmc/array.pmc"

    PMC * const value = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    return VTABLE_get_string(interp, value);
#line 459 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_init(PARROT_INTERP, PMC *pmc)
{
#line 143 "./src/pmc/array.pmc"

    list_pmc_new(interp, pmc);
    PObj_custom_mark_SET(pmc);
#line 468 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 159 "./src/pmc/array.pmc"

    list_pmc_new_init(interp, pmc, init);
    PObj_custom_mark_SET(pmc);
#line 477 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1143 "./src/pmc/array.pmc"

    INTVAL j, n;

    if (value->vtable->base_type != enum_class_Array)
        return 0;

    n = VTABLE_elements(interp, pmc);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        PMC * const item1 = VTABLE_get_pmc_keyed_int(interp, pmc, j);
        PMC * const item2 = VTABLE_get_pmc_keyed_int(interp, value, j);

        if (item1 != item2) {
            INTVAL result;
            Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal",
                "PP->I", item1, item2, &result);
            if (!result)
                return 0;
        }
    }

    return 1;
#line 508 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_mark(PARROT_INTERP, PMC *pmc)
{
#line 210 "./src/pmc/array.pmc"

    list_mark(interp, (List *)PMC_data(pmc));
#line 516 "./src/pmc/array.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Array_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 886 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_number(interp, ptr);
#line 525 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 871 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_integer(interp, ptr);
#line 534 "./src/pmc/array.c"
}
PARROT_EXPORT  PMC  *
Parrot_Array_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 916 "./src/pmc/array.pmc"

    return retval(interp,
        list_pop(interp, (List *)PMC_data(pmc), enum_type_PMC));
#line 543 "./src/pmc/array.c"
}
PARROT_EXPORT  STRING  *
Parrot_Array_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 901 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_string(interp, ptr);
#line 552 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 756 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_number_keyed_int(interp, pmc, nextix, value);
#line 561 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 740 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_integer_keyed_int(interp, pmc, nextix, value);
#line 570 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 788 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_pmc_keyed_int(interp, pmc, nextix, value);
#line 579 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 772 "./src/pmc/array.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_string_keyed_int(interp, pmc, nextix, value);
#line 588 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 552 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_integer_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_keyed(interp, box, nextkey, value);
#line 616 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 535 "./src/pmc/array.pmc"

    PMC * const ptr =
        Parrot_Array_set_pmc_ptr(interp, (List *)PMC_data(pmc), key);

    VTABLE_set_integer_native(interp, ptr, value);
#line 627 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 507 "./src/pmc/array.pmc"

    list_set_length(interp, (List *)PMC_data(pmc), size);
#line 635 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 520 "./src/pmc/array.pmc"

    const INTVAL size = VTABLE_elements(interp, value);
    list_set_length(interp, (List *)PMC_data(pmc), size);
#line 644 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 603 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_number_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_keyed(interp, box, nextkey, value);
#line 672 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 586 "./src/pmc/array.pmc"

    PMC * const ptr =
        Parrot_Array_set_pmc_ptr(interp, (List *)PMC_data(pmc), key);

    VTABLE_set_number_native(interp, ptr, value);
#line 683 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_set_pmc(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 196 "./src/pmc/array.pmc"

    VTABLE_assign_pmc(interp, pmc, other);
#line 691 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 709 "./src/pmc/array.pmc"

    PMC *box;

    const INTVAL ix      = key_integer(interp, key);
    PMC * const  nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_pmc_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_pmc_keyed(interp, box, nextkey, value);
#line 715 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *src)
{
#line 688 "./src/pmc/array.pmc"

    const INTVAL length = ((List *)PMC_data(pmc))->length;

    if (idx >= length || -idx > length)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "Array index out of bounds!");

    list_assign(interp, (List *)PMC_data(pmc), idx,
        (void *)src, enum_type_PMC);
#line 730 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 654 "./src/pmc/array.pmc"

    INTVAL ix;
    PMC   *nextkey, *box;

    if (!key)
        return;

    ix      = key_integer(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_string_keyed_int(interp, pmc, ix, value);
        return;
    }

    box = VTABLE_get_pmc_keyed_int(interp, pmc, ix);

    /* autovivify an Array */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_keyed(interp, box, nextkey, value);
#line 758 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 637 "./src/pmc/array.pmc"

    PMC * const ptr =
        Parrot_Array_set_pmc_ptr(interp, (List *)PMC_data(pmc), key);

    VTABLE_set_string_native(interp, ptr, value);
#line 769 "./src/pmc/array.c"
}
PARROT_EXPORT  PMC  *
Parrot_Array_share_ro(PARROT_INTERP, PMC *pmc)
{
#line 1275 "./src/pmc/array.pmc"

    PMC *_true, *ret;

    /* prevent infinite recursion */
    if (PObj_is_PMC_shared_TEST(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "share_ro on something that already is shared");

    _true = pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, _true, 1);

    ret   = pt_shared_fixup(interp, pmc);

    /* first set readonly */
    VTABLE_setprop(interp, ret, CONST_STRING(interp, "_ro"), _true);

    /* XXX do something that deals better with sparse lists */
    {
        INTVAL i;
        const INTVAL max = VTABLE_elements(interp, ret);

        for (i = 0; i < max; ++i) {
            PMC * const value =
                (PMC *)list_get(interp, PMC_data_typed(ret, List *),
                             i, enum_type_PMC);

            if (!PMC_IS_NULL(value)) {
                /* XXX do we need to clone first? */
                PMC * const new_value = VTABLE_share_ro(interp, value);

                if (new_value != value)
                    list_assign(interp, PMC_data_typed(ret, List *),
                        i, new_value, enum_type_PMC);
            }
        }
    }

    /* XXX FIXME workaround lack of metadata sharing */
    PMC_metadata(pmc) = NULL;

    return ret;
#line 816 "./src/pmc/array.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Array_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 946 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_number(interp, ptr);
#line 825 "./src/pmc/array.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Array_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 931 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_integer(interp, ptr);
#line 834 "./src/pmc/array.c"
}
PARROT_EXPORT  PMC  *
Parrot_Array_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 976 "./src/pmc/array.pmc"

    return retval(interp,
        list_shift(interp, (List *)PMC_data(pmc), enum_type_PMC));
#line 843 "./src/pmc/array.c"
}
PARROT_EXPORT  STRING  *
Parrot_Array_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 961 "./src/pmc/array.pmc"

    PMC * const ptr = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_string(interp, ptr);
#line 852 "./src/pmc/array.c"
}
PARROT_EXPORT  PMC  *
Parrot_Array_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL f)
{
#line 1186 "./src/pmc/array.pmc"

    if (f == 0) {
        STRING     *name = CONST_STRING(interp, "set_key");
        PMC * const iter = pmc_new_init(interp, enum_class_Iterator, pmc);
        Parrot_PCCINVOKE(interp, iter, name, "P->", key);
        return iter;
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Array: Unknown slice type");
#line 868 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
#line 995 "./src/pmc/array.pmc"

    if (pmc->vtable->base_type != value->vtable->base_type)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Type mismatch in splice");

    list_splice(interp, (List *)PMC_data(pmc),
        (List *)PMC_data(value), offset, count);
#line 881 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1257 "./src/pmc/array.pmc"

    IMAGE_IO * const io = info->image_io;

    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL) {
        VTABLE_set_integer_native(interp, pmc, VTABLE_shift_integer(interp, io));
}
#line 894 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 822 "./src/pmc/array.pmc"

    PMC * const val = undef(interp);

    list_unshift(interp, (List *)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_number_native(interp, val, value);
#line 905 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 804 "./src/pmc/array.pmc"

    PMC * const val = undef(interp);

    list_unshift(interp, (List *)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_integer_native(interp, val, value);
#line 916 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 857 "./src/pmc/array.pmc"

    list_unshift(interp, (List *)PMC_data(pmc), value, enum_type_PMC);
#line 924 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 840 "./src/pmc/array.pmc"

    PMC * const val = undef(interp);
    list_unshift(interp, (List *)PMC_data(pmc), val, enum_type_PMC);
    VTABLE_set_string_native(interp, val, value);
#line 934 "./src/pmc/array.c"
}
PARROT_EXPORT  void 
Parrot_Array_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1226 "./src/pmc/array.pmc"

    list_visit(interp, (List *)PMC_data(pmc), info);
    Parrot_default_visit(interp, pmc, info);
#line 943 "./src/pmc/array.c"
}
PARROT_EXPORT  void
Parrot_Array_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Array");
}
PARROT_EXPORT  PMC *
Parrot_Array_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Array_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Array");
}
PARROT_EXPORT  FLOATVAL
Parrot_Array_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Array");
}
PARROT_EXPORT  INTVAL
Parrot_Array_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Array");
}
PARROT_EXPORT  PMC *
Parrot_Array_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Array");
}
PARROT_EXPORT  STRING *
Parrot_Array_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Array");
}
PARROT_EXPORT  FLOATVAL
Parrot_Array_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Array");
}
PARROT_EXPORT  INTVAL
Parrot_Array_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Array");
}
PARROT_EXPORT  PMC *
Parrot_Array_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Array");
}
PARROT_EXPORT  STRING *
Parrot_Array_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Array");
}
PARROT_EXPORT  void
Parrot_Array_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Array");
}
#include "pmc_default.h"
void
Parrot_Array_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Array, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_Array_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Array_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_Array_defined_keyed,
        Parrot_Array_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Array_delete_keyed,
        Parrot_Array_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_Array_elements,
        Parrot_Array_exists_keyed,
        Parrot_Array_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Array_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Array_get_bool,
        Parrot_default_get_class,
        Parrot_Array_get_integer,
        Parrot_Array_get_integer_keyed,
        Parrot_Array_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Array_get_iter,
        Parrot_default_get_namespace,
        Parrot_Array_get_number,
        Parrot_Array_get_number_keyed,
        Parrot_Array_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Array_get_pmc_keyed,
        Parrot_Array_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Array_get_string,
        Parrot_Array_get_string_keyed,
        Parrot_Array_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_Array_init,
        Parrot_Array_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_Array_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Array_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Array_pop_float,
        Parrot_Array_pop_integer,
        Parrot_Array_pop_pmc,
        Parrot_Array_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Array_push_float,
        Parrot_Array_push_integer,
        Parrot_Array_push_pmc,
        Parrot_Array_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_Array_set_integer_keyed,
        Parrot_Array_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Array_set_integer_native,
        Parrot_Array_set_integer_same,
        Parrot_Array_set_number_keyed,
        Parrot_Array_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Array_set_pmc,
        Parrot_Array_set_pmc_keyed,
        Parrot_Array_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Array_set_string_keyed,
        Parrot_Array_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_Array_share_ro,
        Parrot_Array_shift_float,
        Parrot_Array_shift_integer,
        Parrot_Array_shift_pmc,
        Parrot_Array_shift_string,
        Parrot_Array_slice,
        Parrot_Array_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Array_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Array_unshift_float,
        Parrot_Array_unshift_integer,
        Parrot_Array_unshift_pmc,
        Parrot_Array_unshift_string,
        Parrot_Array_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Array, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Array_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Array_ro_add_method,
        Parrot_Array_ro_add_parent,
        Parrot_Array_ro_add_role,
        Parrot_Array_ro_add_vtable_override,
        Parrot_Array_ro_assign_pmc,
        Parrot_Array_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Array_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Array_ro_decrement,
        Parrot_default_defined,
        Parrot_Array_defined_keyed,
        Parrot_Array_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Array_ro_delete_keyed,
        Parrot_Array_ro_delete_keyed_int,
        Parrot_Array_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_Array_elements,
        Parrot_Array_exists_keyed,
        Parrot_Array_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Array_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Array_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Array_get_bool,
        Parrot_default_get_class,
        Parrot_Array_get_integer,
        Parrot_Array_get_integer_keyed,
        Parrot_Array_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Array_get_iter,
        Parrot_default_get_namespace,
        Parrot_Array_get_number,
        Parrot_Array_get_number_keyed,
        Parrot_Array_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Array_get_pmc_keyed,
        Parrot_Array_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Array_get_string,
        Parrot_Array_get_string_keyed,
        Parrot_Array_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Array_ro_i_absolute,
        Parrot_Array_ro_i_add,
        Parrot_Array_ro_i_add_float,
        Parrot_Array_ro_i_add_int,
        Parrot_Array_ro_i_bitwise_and,
        Parrot_Array_ro_i_bitwise_and_int,
        Parrot_Array_ro_i_bitwise_ands,
        Parrot_Array_ro_i_bitwise_ands_str,
        Parrot_Array_ro_i_bitwise_lsr,
        Parrot_Array_ro_i_bitwise_lsr_int,
        Parrot_Array_ro_i_bitwise_not,
        Parrot_Array_ro_i_bitwise_nots,
        Parrot_Array_ro_i_bitwise_or,
        Parrot_Array_ro_i_bitwise_or_int,
        Parrot_Array_ro_i_bitwise_ors,
        Parrot_Array_ro_i_bitwise_ors_str,
        Parrot_Array_ro_i_bitwise_shl,
        Parrot_Array_ro_i_bitwise_shl_int,
        Parrot_Array_ro_i_bitwise_shr,
        Parrot_Array_ro_i_bitwise_shr_int,
        Parrot_Array_ro_i_bitwise_xor,
        Parrot_Array_ro_i_bitwise_xor_int,
        Parrot_Array_ro_i_bitwise_xors,
        Parrot_Array_ro_i_bitwise_xors_str,
        Parrot_Array_ro_i_concatenate,
        Parrot_Array_ro_i_concatenate_str,
        Parrot_Array_ro_i_divide,
        Parrot_Array_ro_i_divide_float,
        Parrot_Array_ro_i_divide_int,
        Parrot_Array_ro_i_floor_divide,
        Parrot_Array_ro_i_floor_divide_float,
        Parrot_Array_ro_i_floor_divide_int,
        Parrot_Array_ro_i_logical_not,
        Parrot_Array_ro_i_modulus,
        Parrot_Array_ro_i_modulus_float,
        Parrot_Array_ro_i_modulus_int,
        Parrot_Array_ro_i_multiply,
        Parrot_Array_ro_i_multiply_float,
        Parrot_Array_ro_i_multiply_int,
        Parrot_Array_ro_i_neg,
        Parrot_Array_ro_i_pow,
        Parrot_Array_ro_i_pow_float,
        Parrot_Array_ro_i_pow_int,
        Parrot_Array_ro_i_repeat,
        Parrot_Array_ro_i_repeat_int,
        Parrot_Array_ro_i_subtract,
        Parrot_Array_ro_i_subtract_float,
        Parrot_Array_ro_i_subtract_int,
        Parrot_Array_ro_increment,
        Parrot_Array_init,
        Parrot_Array_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_Array_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Array_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_Array_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Array_ro_pop_float,
        Parrot_Array_ro_pop_integer,
        Parrot_Array_ro_pop_pmc,
        Parrot_Array_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Array_ro_push_float,
        Parrot_Array_ro_push_integer,
        Parrot_Array_ro_push_pmc,
        Parrot_Array_ro_push_string,
        Parrot_Array_ro_remove_attribute,
        Parrot_Array_ro_remove_method,
        Parrot_Array_ro_remove_parent,
        Parrot_Array_ro_remove_role,
        Parrot_Array_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_Array_ro_set_attr_keyed,
        Parrot_Array_ro_set_attr_str,
        Parrot_Array_ro_set_bignum_int,
        Parrot_Array_ro_set_bignum_num,
        Parrot_Array_ro_set_bignum_str,
        Parrot_Array_ro_set_bool,
        Parrot_Array_ro_set_integer_keyed,
        Parrot_Array_ro_set_integer_keyed_int,
        Parrot_Array_ro_set_integer_keyed_str,
        Parrot_Array_ro_set_integer_native,
        Parrot_Array_ro_set_integer_same,
        Parrot_Array_ro_set_number_keyed,
        Parrot_Array_ro_set_number_keyed_int,
        Parrot_Array_ro_set_number_keyed_str,
        Parrot_Array_ro_set_number_native,
        Parrot_Array_ro_set_number_same,
        Parrot_Array_ro_set_pmc,
        Parrot_Array_ro_set_pmc_keyed,
        Parrot_Array_ro_set_pmc_keyed_int,
        Parrot_Array_ro_set_pmc_keyed_str,
        Parrot_Array_ro_set_pointer,
        Parrot_Array_ro_set_pointer_keyed,
        Parrot_Array_ro_set_pointer_keyed_int,
        Parrot_Array_ro_set_pointer_keyed_str,
        Parrot_Array_ro_set_string_keyed,
        Parrot_Array_ro_set_string_keyed_int,
        Parrot_Array_ro_set_string_keyed_str,
        Parrot_Array_ro_set_string_native,
        Parrot_Array_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_Array_share_ro,
        Parrot_Array_ro_shift_float,
        Parrot_Array_ro_shift_integer,
        Parrot_Array_ro_shift_pmc,
        Parrot_Array_ro_shift_string,
        Parrot_Array_slice,
        Parrot_Array_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Array_ro_thaw,
        Parrot_Array_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Array_ro_unshift_float,
        Parrot_Array_ro_unshift_integer,
        Parrot_Array_ro_unshift_pmc,
        Parrot_Array_ro_unshift_string,
        Parrot_Array_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Array");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "array");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Array")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Array"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
        {
        
            /* class_init_code; called for side effects */
            Small_Object_Pool *List_chunks =
                get_bufferlike_pool(interp, sizeof (List_chunk));
            Small_Object_Pool *Lists       =
                get_bufferlike_pool(interp, sizeof (List));
        
            /* XXX until there's a function to allocate a pool in an arena */
            UNUSED(List_chunks);
            UNUSED(Lists);

        }
        {
        }
    } /* pass */
} /* Parrot_Array_class_init */
#line 1316 "./src/pmc/array.pmc"


/*

=back

=head1 SEE ALSO

F<src/list.c>, F<include/parrot/list.h>

=head1 TODO

Create global immutable undef object.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
