/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/bigint.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_bigint.h"
#include "pmc_default.h"
#include "bigint.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/bigint.pmc"
/*
Copyright (C) 2004-2009, Parrot Foundation.
$Id: bigint.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/bigint.pmc - BigInt PMC class

=head1 DESCRIPTION

C<BigInt> provides arbitrary precision integer mathematic functions.

=head2 Functions

=over 4

=item C<static void bigint_set_long(Interp*, PMC *, long value)>

=item C<static void bigint_set_double(Interp*, PMC *, double value)>

=cut

*/

#include "parrot/parrot.h"

/* TODO split that out into a separate file */

#ifdef S_SPLINT_S
#  undef PARROT_HAS_GMP /* splint barfs on the gmp.h header */
#endif /* S_SPLINT_S */

#ifdef PARROT_HAS_GMP
#  include <gmp.h>
typedef struct BIGINT {
    mpz_t b;
} BIGINT;


static void
bigint_init(PARROT_INTERP, PMC *self) {
    Parrot_BigInt_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_BigInt_attributes);
    attrs->bi = mem_allocate_zeroed_typed(BIGINT);
    mpz_init(attrs->bi->b);
    PMC_data(self) = attrs;
}

static void
bigint_clear(PARROT_INTERP, PMC *self) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_clear(bi->b);
}

static void
bigint_set(PARROT_INTERP, PMC *dest, PMC *src) {
    BIGINT *bi_dest, *bi_src;
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    GETATTR_BigInt_bi(interp, src,  bi_src);
    mpz_clear(bi_dest->b);
    mpz_init(bi_dest->b);
    mpz_set(bi_dest->b, bi_src->b);
}

static void
bigint_set_long(PARROT_INTERP, PMC *self, long value) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set_si(bi->b, value);
}

static void
bigint_set_double(PARROT_INTERP, PMC *self, double value) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set_d(bi->b, value);
}

static void
bigint_set_str(PARROT_INTERP, PMC *self, char *value, int base) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set_str(bi->b, value, base);
}

static BIGINT*
bigint_get_self(PARROT_INTERP, PMC *self) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    return bi;
}

static void
bigint_set_self(PARROT_INTERP, PMC *self, BIGINT *value) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    mpz_set(bi->b, (mpz_srcptr)((BIGINT*)value)->b);
}

static long
bigint_get_long(PARROT_INTERP, PMC *self) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    if (mpz_fits_slong_p(bi->b))
        return mpz_get_si(bi->b);

    Parrot_ex_throw_from_c_args(interp, NULL, 1, "bigint_get_long: number too big");
}

static int
bigint_get_bool(PARROT_INTERP, PMC *self) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    if (mpz_sgn(bi->b) != 0)
        return 1;
    else
        return 0;
}

static char *
bigint_get_string(PARROT_INTERP, PMC *self, int base) {
    BIGINT *bi;
    size_t  n;
    char   *s;

    GETATTR_BigInt_bi(interp, self, bi);
    n = mpz_sizeinbase(bi->b, base) + 2;
    s = (char *)mem_sys_allocate(n);
    return mpz_get_str(s, base, bi->b);
}

static double
bigint_get_double(PARROT_INTERP, PMC *self) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    return mpz_get_d(bi->b);
}

static void
bigint_add_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_add(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_add_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    if (value < 0)
        mpz_sub_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
    else
        mpz_add_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static void
bigint_sub_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_sub(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_sub_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    if (value < 0)
        mpz_add_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
    else
        mpz_sub_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static void
bigint_mul_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_mul(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_mul_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_mul_si(bi_dest->b, bi_self->b, value);
}

static void
bigint_pow_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_pow_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static void
int_check_divide_zero(PARROT_INTERP, INTVAL value) {
    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bigint_check_divide_zero(PARROT_INTERP, PMC *value) {
    /* Throw an exception if we are dividing by zero. */
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, value, bi);
    if (mpz_cmp_si(bi->b, 0) == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bigint_div_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    bigint_check_divide_zero(interp, value);
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    /* this is mpz_fdiv_q */
    mpz_div(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_div_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    int_check_divide_zero(interp, value);

    /* this is mpz_fdiv_q */
    if (value < 0) {
        mpz_div_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
        mpz_neg(bi_dest->b, bi_dest->b);
    }
    else
        mpz_div_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static void
bigint_fdiv_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    bigint_check_divide_zero(interp, value);
    mpz_fdiv_q(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_fdiv_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpz_fdiv_q_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
        mpz_neg(bi_dest->b, bi_dest->b);
    }
    else
        mpz_fdiv_q_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static void
bigint_mod_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGINT *bi_self, *bi_value, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    bigint_check_divide_zero(interp, value);
    mpz_mod(bi_dest->b, bi_self->b, bi_value->b);
}

static void
bigint_mod_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpz_mod_ui(bi_dest->b, bi_self->b, (unsigned long int)-value);
    }
    else
        mpz_mod_ui(bi_dest->b, bi_self->b, (unsigned long int)value);
}

static INTVAL
bigint_cmp(PARROT_INTERP, PMC *self, PMC *value) {
    BIGINT *bi_self, *bi_value;
    GETATTR_BigInt_bi(interp, self,  bi_self);
    GETATTR_BigInt_bi(interp, value, bi_value);
    return mpz_cmp(bi_self->b, bi_value->b);
}

static INTVAL
bigint_cmp_int(PARROT_INTERP, PMC *self, INTVAL value) {
    BIGINT *bi;
    GETATTR_BigInt_bi(interp, self, bi);
    return mpz_cmp_si(bi->b, value);
}

static void
bigint_abs(PARROT_INTERP, PMC *self, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    pmc_reuse(interp, dest, enum_class_BigInt, 0);
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_abs(bi_dest->b, bi_self->b);
}

static void
bigint_neg(PARROT_INTERP, PMC *self, PMC *dest) {
    BIGINT *bi_self, *bi_dest;
    pmc_reuse(interp, dest, enum_class_BigInt, 0);
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    mpz_neg(bi_dest->b, bi_self->b);
}

static void
bigint_bitwise_shl_bigint_int(PARROT_INTERP, PMC *self,
                              INTVAL value, PMC *dest)
{
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    /* The third args to mpz_mul_2exp and mpz_tdiv_q_2exp are unsigned, so we
       need to do something sensible with negative values. */
    if (value >= 0)
        mpz_mul_2exp(bi_dest->b, bi_self->b, (unsigned long int)value);
    else
        mpz_tdiv_q_2exp(bi_dest->b, bi_self->b, (unsigned long int)-value);
}

static void
bigint_bitwise_shr_bigint_int(PARROT_INTERP, PMC *self,
                              INTVAL value, PMC *dest)
{
    BIGINT *bi_self, *bi_dest;
    GETATTR_BigInt_bi(interp, self, bi_self);
    GETATTR_BigInt_bi(interp, dest, bi_dest);
    /* The third args to mpz_mul_2exp and mpz_tdiv_q_2exp are unsigned, so we
       need to do something sensible with negative values. */
    if (value >= 0)
        mpz_tdiv_q_2exp(bi_dest->b, bi_self->b, (unsigned long int)value);
    else
        mpz_mul_2exp(bi_dest->b, bi_self->b, (unsigned long int)-value);
}

#else /* ifdef PARROT_HAS_GMP */

typedef struct BIGINT {
    INTVAL b; /* bogus definition for users without libgmp*/
} BIGINT;

static void
bigint_init(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_clear(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_set_long(PARROT_INTERP, PMC *self, long value) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_set(PARROT_INTERP, PMC *dest, PMC *src) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_set_double(PARROT_INTERP, PMC *self, double value) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_set_str(PARROT_INTERP, PMC *self, char *value, int base) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_set_self(PARROT_INTERP, PMC *self, BIGINT *value) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static BIGINT*
bigint_get_self(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static char *
bigint_get_string(PARROT_INTERP, PMC *self, int base) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static long
bigint_get_long(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static long
bigint_get_bool(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static double
bigint_get_double(PARROT_INTERP, PMC *self) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_add_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_add_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_sub_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_sub_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_mul_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_mul_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_pow_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_div_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_div_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_fdiv_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_fdiv_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_mod_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_mod_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static INTVAL
bigint_cmp(PARROT_INTERP, PMC *self, PMC *value) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static INTVAL
bigint_cmp_int(PARROT_INTERP, PMC *self, INTVAL value) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_abs(PARROT_INTERP, PMC *self, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_neg(PARROT_INTERP, PMC *self, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shl_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shl_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest)
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shr_bigint(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

static void
bigint_bitwise_shr_bigint_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest)
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_LIBRARY_ERROR,
        "no bigint lib loaded");
}

#endif /* ifdef PARROT_HAS_GMP */
#line 590 "./src/pmc/bigint.c"
PARROT_EXPORT  PMC  *
Parrot_BigInt_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1223 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_abs(interp, pmc, dest);
    return dest;
#line 600 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 861 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_add_bigint_int(interp, pmc, value, dest);
    return dest;
#line 611 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1305 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_bitwise_shl_bigint_int(interp, pmc, value, dest);
    return dest;
#line 625 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1386 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_bitwise_shr_bigint_int(interp, pmc, value, dest);
    return dest;
#line 639 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_clone(PARROT_INTERP, PMC *pmc)
{
#line 636 "./src/pmc/bigint.pmc"

    PMC *res = pmc_new(interp, pmc->vtable->base_type);
    bigint_set(interp, res, pmc);
    return res;
#line 649 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_decrement(PARROT_INTERP, PMC *pmc)
{
#line 836 "./src/pmc/bigint.pmc"

    bigint_sub_bigint_int(interp, pmc, 1, pmc);
#line 657 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_destroy(PARROT_INTERP, PMC *pmc)
{
#line 642 "./src/pmc/bigint.pmc"

    BIGINT                   *bi;
    Parrot_BigInt_attributes *attrs;

    bigint_clear(interp, pmc);

    attrs = (Parrot_BigInt_attributes*)PMC_data(pmc);
    mem_sys_free(attrs->bi);
    mem_sys_free(attrs);
#line 672 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1064 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_div_bigint_int(interp, pmc, value, dest);
    return dest;
#line 686 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1112 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_fdiv_bigint_int(interp, pmc, value, dest);
    return dest;
#line 700 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_get_bignum(PARROT_INTERP, PMC *pmc)
{
#line 757 "./src/pmc/bigint.pmc"

    return pmc;
#line 708 "./src/pmc/bigint.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigInt_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 771 "./src/pmc/bigint.pmc"

    return bigint_get_bool(interp, pmc);
#line 716 "./src/pmc/bigint.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigInt_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 743 "./src/pmc/bigint.pmc"

    return bigint_get_long(interp, pmc);
#line 724 "./src/pmc/bigint.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_BigInt_get_number(PARROT_INTERP, PMC *pmc)
{
#line 729 "./src/pmc/bigint.pmc"

    return bigint_get_double(interp, pmc);
#line 732 "./src/pmc/bigint.c"
}
PARROT_EXPORT  STRING  *
Parrot_BigInt_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 808 "./src/pmc/bigint.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    return Parrot_str_append(interp, s, CONST_STRING(interp, "L"));
#line 741 "./src/pmc/bigint.c"
}
PARROT_EXPORT  STRING  *
Parrot_BigInt_get_string(PARROT_INTERP, PMC *pmc)
{
#line 794 "./src/pmc/bigint.pmc"

    char   * const s  = bigint_get_string(interp, pmc, 10);
    STRING * const ps = Parrot_str_new(interp, s, 0);
    mem_sys_free(s);
    return ps;
#line 752 "./src/pmc/bigint.c"
}
PARROT_EXPORT  STRING  *
Parrot_BigInt_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base)
{
#line 801 "./src/pmc/bigint.pmc"

    char   * const s  = bigint_get_string(interp, pmc, base);
    STRING * const ps = Parrot_str_new(interp, s, 0);
    mem_sys_free(s);
    return ps;
#line 763 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 1230 "./src/pmc/bigint.pmc"

    bigint_abs(interp, pmc, pmc);
#line 771 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 887 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_add_float' for FLOATVAL");
#line 781 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 883 "./src/pmc/bigint.pmc"

    bigint_add_bigint_int(interp, pmc, value, pmc);
#line 789 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1334 "./src/pmc/bigint.pmc"

    bigint_bitwise_shl_bigint_int(interp, pmc, value, pmc);
#line 797 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1415 "./src/pmc/bigint.pmc"

    bigint_bitwise_shr_bigint_int(interp, pmc, value, pmc);
#line 805 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1087 "./src/pmc/bigint.pmc"

    bigint_div_bigint_int(interp, pmc, value, pmc);
#line 813 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1137 "./src/pmc/bigint.pmc"

    bigint_fdiv_bigint_int(interp, pmc, value, pmc);
#line 821 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1002 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_multiply_float' for FLOATVAL");
#line 831 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 998 "./src/pmc/bigint.pmc"

    bigint_mul_bigint_int(interp, pmc, value, pmc);
#line 839 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_neg(PARROT_INTERP, PMC *pmc)
{
#line 1254 "./src/pmc/bigint.pmc"

    bigint_neg(interp, pmc, pmc);
#line 847 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 950 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_subtract_float' for FLOATVAL");
#line 857 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 946 "./src/pmc/bigint.pmc"

    bigint_sub_bigint_int(interp, pmc, value, pmc);
#line 865 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_increment(PARROT_INTERP, PMC *pmc)
{
#line 822 "./src/pmc/bigint.pmc"

    bigint_add_bigint_int(interp, pmc, 1, pmc);
#line 873 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_init(PARROT_INTERP, PMC *pmc)
{
#line 631 "./src/pmc/bigint.pmc"

    bigint_init(interp, pmc);
    PObj_active_destroy_SET(pmc);
#line 882 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_instantiate(PARROT_INTERP, PMC *pmc, PMC *sig)
{
#line 608 "./src/pmc/bigint.pmc"

    return PMCNULL;

    /* TODO -- actually build this thing */
#if 0
    int argcP = REG_INT(interp, 3);
    int base;
    PMC *res;
    STRING *num;

    res = pmc_new(interp, enum_class_BigInt);
    if (!argcP) {
        return res;
    }
    base = 10;
    if (argcP == 2)
        base = VTABLE_get_integer(interp, REG_PMC(interp, 6));
    num = VTABLE_get_string(interp, REG_PMC(interp, 5));
    VTABLE_set_string_keyed_int(interp, res, base, num);
    return res;
#endif
#line 909 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 978 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_mul_bigint_int(interp, pmc, value, dest);
    return dest;
#line 920 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1247 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_neg(interp, pmc, dest);
    return dest;
#line 931 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1008 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_pow_bigint_int(interp, pmc, value, dest);
    return dest;
#line 945 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 661 "./src/pmc/bigint.pmc"

    bigint_set_long(interp, pmc, (long)value);
#line 953 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 675 "./src/pmc/bigint.pmc"

    bigint_set_double(interp, pmc, (double)value);
#line 961 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 715 "./src/pmc/bigint.pmc"

    bigint_set_self(interp, pmc, bigint_get_self(interp, value));
#line 969 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base, STRING *value)
{
#line 700 "./src/pmc/bigint.pmc"

    char * const s = Parrot_str_to_cstring(interp, value);
    bigint_set_str(interp, pmc, s, base);
    Parrot_str_free_cstring(s);
#line 979 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 694 "./src/pmc/bigint.pmc"

    char * const s = Parrot_str_to_cstring(interp, value);
    bigint_set_str(interp, pmc, s, 10);
    Parrot_str_free_cstring(s);
#line 989 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 921 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_sub_bigint_int(interp, pmc, value, dest);
    return dest;
#line 1003 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void
Parrot_BigInt_nci_version(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1041 "./src/pmc/bigint.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1058 "./src/pmc/bigint.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 588 "./src/pmc/bigint.pmc"

    STRING *version;
#ifdef PARROT_HAS_GMP
    version = Parrot_str_new(interp, gmp_version, 0);
#else
    version = CONST_STRING(interp, "0.0.0");
#endif
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *version */
    /*BEGIN GENERATED ACCESSORS */
#line 1077 "./src/pmc/bigint.pmc"
    CTX_REG_STR(_ctx, 0) = version;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto version_returns;
    /*END RETURN STRING *version */
    }
#line 595 "./src/pmc/bigint.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
version_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1122 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_add_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 840 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_add_bigint(interp, pmc, value, dest);
    return dest;
#line 1133 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 847 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_add_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1144 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 854 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'add' for %Ss",
        VTABLE_name(interp, value));
#line 1155 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_add_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 868 "./src/pmc/bigint.pmc"

    bigint_add_bigint(interp, pmc, value, pmc);
#line 1163 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 872 "./src/pmc/bigint.pmc"

    bigint_add_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1171 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 876 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_add' for %Ss",
        VTABLE_name(interp, value));
#line 1182 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_subtract_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 894 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_sub_bigint(interp, pmc, value, dest);
    return dest;
#line 1196 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 904 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_sub_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1210 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 914 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'subtract' for %Ss",
        VTABLE_name(interp, value));
#line 1221 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_subtract_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 931 "./src/pmc/bigint.pmc"

    bigint_sub_bigint(interp, pmc, value, pmc);
#line 1229 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 935 "./src/pmc/bigint.pmc"

    bigint_sub_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1237 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 939 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_subtract' for %Ss",
        VTABLE_name(interp, value));
#line 1248 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_multiply_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 957 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_mul_bigint(interp, pmc, value, dest);
    return dest;
#line 1259 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 964 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_mul_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1270 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 971 "./src/pmc/bigint.pmc"

     Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'multiply' for %Ss",
        VTABLE_name(interp, value));
#line 1281 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 985 "./src/pmc/bigint.pmc"

    bigint_mul_bigint(interp, pmc, value, pmc);
#line 1289 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 988 "./src/pmc/bigint.pmc"

    bigint_mul_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1297 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 991 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_multiply' for %Ss",
        VTABLE_name(interp, value));
#line 1308 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_pow_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1018 "./src/pmc/bigint.pmc"

    /* XXX only Integer RHS currently */
    const INTVAL r = VTABLE_get_integer(interp, value);
    dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_pow_bigint_int(interp, pmc, r, dest);
    return dest;
#line 1321 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1027 "./src/pmc/bigint.pmc"

    BIGINT *bi;
    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_div_bigint(interp, pmc, value, dest);
#if 0
    /* to downgrade or not that's the question */
    GETATTR_BigInt_bi(interp, dest, bi);
    if (mpz_fits_slong_p(bi->b)) {
        long iresult = mpz_get_si(bi->b);
        VTABLE_morph(interp, dest, enum_class_Integer);
        VTABLE_set_integer_native(interp, dest, iresult);
    }
#endif
    return dest;
#line 1345 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1047 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_div_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1359 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1057 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'divide' for %Ss",
        VTABLE_name(interp, value));
#line 1370 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1074 "./src/pmc/bigint.pmc"

    bigint_div_bigint(interp, pmc, value, pmc);
#line 1378 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1077 "./src/pmc/bigint.pmc"

    bigint_div_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1386 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1080 "./src/pmc/bigint.pmc"

     Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_divide' for %Ss",
        VTABLE_name(interp, value));
#line 1397 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_floor_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1091 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_fdiv_bigint(interp, pmc, value, dest);
    return dest;
#line 1408 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_floor_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1098 "./src/pmc/bigint.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_fdiv_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1419 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1105 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'floor_divide' for %Ss",
        VTABLE_name(interp, value));
#line 1430 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1122 "./src/pmc/bigint.pmc"

    bigint_fdiv_bigint(interp, pmc, value, pmc);
#line 1438 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_floor_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1126 "./src/pmc/bigint.pmc"

    bigint_fdiv_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1446 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1130 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_floor_divide' for %Ss",
        VTABLE_name(interp, value));
#line 1457 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_modulus_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1141 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_mod_bigint(interp, pmc, value, dest);
    return dest;
#line 1471 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_modulus_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1151 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_mod_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1485 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_modulus_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1161 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'modulus' for %Ss",
        VTABLE_name(interp, value));
#line 1496 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1168 "./src/pmc/bigint.pmc"

    bigint_mod_bigint(interp, pmc, value, pmc);
#line 1504 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_modulus_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1171 "./src/pmc/bigint.pmc"

    bigint_mod_bigint_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1512 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_modulus_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1174 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_modulus' for %Ss",
        VTABLE_name(interp, value));
#line 1523 "./src/pmc/bigint.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigInt_multi_cmp_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1181 "./src/pmc/bigint.pmc"

    return bigint_cmp(interp, pmc, value);
#line 1531 "./src/pmc/bigint.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigInt_multi_cmp_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1185 "./src/pmc/bigint.pmc"

    return bigint_cmp_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 1539 "./src/pmc/bigint.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigInt_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1189 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'cmp' for %Ss",
        VTABLE_name(interp, value));
#line 1550 "./src/pmc/bigint.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigInt_multi_is_equal_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1196 "./src/pmc/bigint.pmc"

    return bigint_cmp(interp, pmc, value) == 0;
#line 1558 "./src/pmc/bigint.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigInt_multi_is_equal_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1200 "./src/pmc/bigint.pmc"

    return bigint_cmp_int(interp, pmc, VTABLE_get_integer(interp, value)) == 0;
#line 1566 "./src/pmc/bigint.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigInt_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1204 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'is_equal' for %Ss",
        VTABLE_name(interp, value));
#line 1577 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_bitwise_shl_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1276 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_bitwise_shl_bigint_int(interp, pmc,
                                  VTABLE_get_integer(interp, value),
                                  dest);
    return dest;
#line 1593 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_bitwise_shl_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1288 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_bitwise_shl_bigint_int(interp, pmc,
            VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1608 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_bitwise_shl_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1298 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'bitwise_shl' for %Ss",
        VTABLE_name(interp, value));
#line 1619 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_bitwise_shl_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1316 "./src/pmc/bigint.pmc"

    bigint_bitwise_shl_bigint_int(interp, pmc,
                                  VTABLE_get_integer(interp, value),
                                  pmc);
#line 1629 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_bitwise_shl_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1322 "./src/pmc/bigint.pmc"

    bigint_bitwise_shl_bigint_int(interp, pmc,
            VTABLE_get_integer(interp, value), pmc);
#line 1638 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_bitwise_shl_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1327 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_bitwise_shl' for %Ss",
        VTABLE_name(interp, value));
#line 1649 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_bitwise_shr_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1356 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_bitwise_shr_bigint_int(interp, pmc,
                                  VTABLE_get_integer(interp, value),
                                  dest);
    return dest;
#line 1665 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_bitwise_shr_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1368 "./src/pmc/bigint.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bigint_bitwise_shr_bigint_int(interp, pmc,
            VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1680 "./src/pmc/bigint.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigInt_multi_bitwise_shr_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1379 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'bitwise_shr' for %Ss",
        VTABLE_name(interp, value));
#line 1691 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_bitwise_shr_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1397 "./src/pmc/bigint.pmc"

    bigint_bitwise_shr_bigint_int(interp, pmc,
                                  VTABLE_get_integer(interp, value),
                                  pmc);
#line 1701 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_bitwise_shr_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1403 "./src/pmc/bigint.pmc"

    bigint_bitwise_shr_bigint_int(interp, pmc,
            VTABLE_get_integer(interp, value), pmc);
#line 1710 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void 
Parrot_BigInt_multi_i_bitwise_shr_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1408 "./src/pmc/bigint.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigInt: no multiple dispatch variant 'i_bitwise_shr' for %Ss",
        VTABLE_name(interp, value));
#line 1721 "./src/pmc/bigint.c"
}
PARROT_EXPORT  void
Parrot_BigInt_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of BigInt");
}
PARROT_EXPORT  PMC *
Parrot_BigInt_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of BigInt");
}
PARROT_EXPORT  FLOATVAL
Parrot_BigInt_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of BigInt");
}
PARROT_EXPORT  INTVAL
Parrot_BigInt_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of BigInt");
}
PARROT_EXPORT  PMC *
Parrot_BigInt_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of BigInt");
}
PARROT_EXPORT  STRING *
Parrot_BigInt_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of BigInt");
}
PARROT_EXPORT  FLOATVAL
Parrot_BigInt_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of BigInt");
}
PARROT_EXPORT  INTVAL
Parrot_BigInt_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of BigInt");
}
PARROT_EXPORT  PMC *
Parrot_BigInt_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of BigInt");
}
PARROT_EXPORT  STRING *
Parrot_BigInt_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of BigInt");
}
PARROT_EXPORT  void
Parrot_BigInt_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of BigInt");
}
#include "pmc_default.h"
void
Parrot_BigInt_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":bi ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_BigInt, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_BigInt_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_BigInt_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_BigInt_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_BigInt_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_BigInt_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_BigInt_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_BigInt_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_BigInt_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_BigInt_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_BigInt_get_bignum,
        Parrot_BigInt_get_bool,
        Parrot_default_get_class,
        Parrot_BigInt_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_BigInt_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_BigInt_get_repr,
        Parrot_BigInt_get_string,
        Parrot_default_get_string_keyed,
        Parrot_BigInt_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_BigInt_i_absolute,
        Parrot_default_i_add,
        Parrot_BigInt_i_add_float,
        Parrot_BigInt_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_BigInt_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_BigInt_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_BigInt_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_BigInt_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_BigInt_i_multiply_float,
        Parrot_BigInt_i_multiply_int,
        Parrot_BigInt_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_BigInt_i_subtract_float,
        Parrot_BigInt_i_subtract_int,
        Parrot_BigInt_increment,
        Parrot_BigInt_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_BigInt_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_BigInt_multiply_int,
        Parrot_default_name,
        Parrot_BigInt_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_BigInt_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_BigInt_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_BigInt_set_number_native,
        Parrot_default_set_number_same,
        Parrot_BigInt_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_BigInt_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_BigInt_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_BigInt_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_BigInt, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_BigInt_absolute,
        Parrot_default_add,
        Parrot_BigInt_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_BigInt_add_int,
        Parrot_BigInt_ro_add_method,
        Parrot_BigInt_ro_add_parent,
        Parrot_BigInt_ro_add_role,
        Parrot_BigInt_ro_add_vtable_override,
        Parrot_BigInt_ro_assign_pmc,
        Parrot_BigInt_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_BigInt_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_BigInt_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_BigInt_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_BigInt_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_BigInt_ro_delete_keyed,
        Parrot_BigInt_ro_delete_keyed_int,
        Parrot_BigInt_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_BigInt_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_BigInt_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_BigInt_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_BigInt_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_BigInt_get_bignum,
        Parrot_BigInt_get_bool,
        Parrot_default_get_class,
        Parrot_BigInt_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_BigInt_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_BigInt_get_repr,
        Parrot_BigInt_get_string,
        Parrot_default_get_string_keyed,
        Parrot_BigInt_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_BigInt_ro_i_absolute,
        Parrot_BigInt_ro_i_add,
        Parrot_BigInt_ro_i_add_float,
        Parrot_BigInt_ro_i_add_int,
        Parrot_BigInt_ro_i_bitwise_and,
        Parrot_BigInt_ro_i_bitwise_and_int,
        Parrot_BigInt_ro_i_bitwise_ands,
        Parrot_BigInt_ro_i_bitwise_ands_str,
        Parrot_BigInt_ro_i_bitwise_lsr,
        Parrot_BigInt_ro_i_bitwise_lsr_int,
        Parrot_BigInt_ro_i_bitwise_not,
        Parrot_BigInt_ro_i_bitwise_nots,
        Parrot_BigInt_ro_i_bitwise_or,
        Parrot_BigInt_ro_i_bitwise_or_int,
        Parrot_BigInt_ro_i_bitwise_ors,
        Parrot_BigInt_ro_i_bitwise_ors_str,
        Parrot_BigInt_ro_i_bitwise_shl,
        Parrot_BigInt_ro_i_bitwise_shl_int,
        Parrot_BigInt_ro_i_bitwise_shr,
        Parrot_BigInt_ro_i_bitwise_shr_int,
        Parrot_BigInt_ro_i_bitwise_xor,
        Parrot_BigInt_ro_i_bitwise_xor_int,
        Parrot_BigInt_ro_i_bitwise_xors,
        Parrot_BigInt_ro_i_bitwise_xors_str,
        Parrot_BigInt_ro_i_concatenate,
        Parrot_BigInt_ro_i_concatenate_str,
        Parrot_BigInt_ro_i_divide,
        Parrot_BigInt_ro_i_divide_float,
        Parrot_BigInt_ro_i_divide_int,
        Parrot_BigInt_ro_i_floor_divide,
        Parrot_BigInt_ro_i_floor_divide_float,
        Parrot_BigInt_ro_i_floor_divide_int,
        Parrot_BigInt_ro_i_logical_not,
        Parrot_BigInt_ro_i_modulus,
        Parrot_BigInt_ro_i_modulus_float,
        Parrot_BigInt_ro_i_modulus_int,
        Parrot_BigInt_ro_i_multiply,
        Parrot_BigInt_ro_i_multiply_float,
        Parrot_BigInt_ro_i_multiply_int,
        Parrot_BigInt_ro_i_neg,
        Parrot_BigInt_ro_i_pow,
        Parrot_BigInt_ro_i_pow_float,
        Parrot_BigInt_ro_i_pow_int,
        Parrot_BigInt_ro_i_repeat,
        Parrot_BigInt_ro_i_repeat_int,
        Parrot_BigInt_ro_i_subtract,
        Parrot_BigInt_ro_i_subtract_float,
        Parrot_BigInt_ro_i_subtract_int,
        Parrot_BigInt_ro_increment,
        Parrot_BigInt_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_BigInt_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_BigInt_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_BigInt_multiply_int,
        Parrot_default_name,
        Parrot_BigInt_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_BigInt_ro_pop_float,
        Parrot_BigInt_ro_pop_integer,
        Parrot_BigInt_ro_pop_pmc,
        Parrot_BigInt_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_BigInt_pow_int,
        Parrot_BigInt_ro_push_float,
        Parrot_BigInt_ro_push_integer,
        Parrot_BigInt_ro_push_pmc,
        Parrot_BigInt_ro_push_string,
        Parrot_BigInt_ro_remove_attribute,
        Parrot_BigInt_ro_remove_method,
        Parrot_BigInt_ro_remove_parent,
        Parrot_BigInt_ro_remove_role,
        Parrot_BigInt_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_BigInt_ro_set_attr_keyed,
        Parrot_BigInt_ro_set_attr_str,
        Parrot_BigInt_ro_set_bignum_int,
        Parrot_BigInt_ro_set_bignum_num,
        Parrot_BigInt_ro_set_bignum_str,
        Parrot_BigInt_ro_set_bool,
        Parrot_BigInt_ro_set_integer_keyed,
        Parrot_BigInt_ro_set_integer_keyed_int,
        Parrot_BigInt_ro_set_integer_keyed_str,
        Parrot_BigInt_ro_set_integer_native,
        Parrot_BigInt_ro_set_integer_same,
        Parrot_BigInt_ro_set_number_keyed,
        Parrot_BigInt_ro_set_number_keyed_int,
        Parrot_BigInt_ro_set_number_keyed_str,
        Parrot_BigInt_ro_set_number_native,
        Parrot_BigInt_ro_set_number_same,
        Parrot_BigInt_ro_set_pmc,
        Parrot_BigInt_ro_set_pmc_keyed,
        Parrot_BigInt_ro_set_pmc_keyed_int,
        Parrot_BigInt_ro_set_pmc_keyed_str,
        Parrot_BigInt_ro_set_pointer,
        Parrot_BigInt_ro_set_pointer_keyed,
        Parrot_BigInt_ro_set_pointer_keyed_int,
        Parrot_BigInt_ro_set_pointer_keyed_str,
        Parrot_BigInt_ro_set_string_keyed,
        Parrot_BigInt_ro_set_string_keyed_int,
        Parrot_BigInt_ro_set_string_keyed_str,
        Parrot_BigInt_ro_set_string_native,
        Parrot_BigInt_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_BigInt_ro_shift_float,
        Parrot_BigInt_ro_shift_integer,
        Parrot_BigInt_ro_shift_pmc,
        Parrot_BigInt_ro_shift_string,
        Parrot_default_slice,
        Parrot_BigInt_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_BigInt_subtract_int,
        Parrot_BigInt_ro_thaw,
        Parrot_BigInt_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_BigInt_ro_unshift_float,
        Parrot_BigInt_ro_unshift_integer,
        Parrot_BigInt_ro_unshift_pmc,
        Parrot_BigInt_ro_unshift_string,
        Parrot_default_visit
    };

    const  multi_func_list _temp_multi_func_list[] = {
        { "add", 
          "PJPPP", 
          "BigInt,BigInt,PMC", 
          (funcptr_t) Parrot_BigInt_multi_add_BigInt_PMC },
        { "add", 
          "PJPPP", 
          "BigInt,Integer,PMC", 
          (funcptr_t) Parrot_BigInt_multi_add_Integer_PMC },
        { "add", 
          "PJPPP", 
          "BigInt,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigInt_multi_add_DEFAULT_PMC },
        { "i_add", 
          "vJPP", 
          "BigInt,BigInt", 
          (funcptr_t) Parrot_BigInt_multi_i_add_BigInt },
        { "i_add", 
          "vJPP", 
          "BigInt,Integer", 
          (funcptr_t) Parrot_BigInt_multi_i_add_Integer },
        { "i_add", 
          "vJPP", 
          "BigInt,DEFAULT", 
          (funcptr_t) Parrot_BigInt_multi_i_add_DEFAULT },
        { "subtract", 
          "PJPPP", 
          "BigInt,BigInt,PMC", 
          (funcptr_t) Parrot_BigInt_multi_subtract_BigInt_PMC },
        { "subtract", 
          "PJPPP", 
          "BigInt,Integer,PMC", 
          (funcptr_t) Parrot_BigInt_multi_subtract_Integer_PMC },
        { "subtract", 
          "PJPPP", 
          "BigInt,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigInt_multi_subtract_DEFAULT_PMC },
        { "i_subtract", 
          "vJPP", 
          "BigInt,BigInt", 
          (funcptr_t) Parrot_BigInt_multi_i_subtract_BigInt },
        { "i_subtract", 
          "vJPP", 
          "BigInt,Integer", 
          (funcptr_t) Parrot_BigInt_multi_i_subtract_Integer },
        { "i_subtract", 
          "vJPP", 
          "BigInt,DEFAULT", 
          (funcptr_t) Parrot_BigInt_multi_i_subtract_DEFAULT },
        { "multiply", 
          "PJPPP", 
          "BigInt,BigInt,PMC", 
          (funcptr_t) Parrot_BigInt_multi_multiply_BigInt_PMC },
        { "multiply", 
          "PJPPP", 
          "BigInt,Integer,PMC", 
          (funcptr_t) Parrot_BigInt_multi_multiply_Integer_PMC },
        { "multiply", 
          "PJPPP", 
          "BigInt,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigInt_multi_multiply_DEFAULT_PMC },
        { "i_multiply", 
          "vJPP", 
          "BigInt,BigInt", 
          (funcptr_t) Parrot_BigInt_multi_i_multiply_BigInt },
        { "i_multiply", 
          "vJPP", 
          "BigInt,Integer", 
          (funcptr_t) Parrot_BigInt_multi_i_multiply_Integer },
        { "i_multiply", 
          "vJPP", 
          "BigInt,DEFAULT", 
          (funcptr_t) Parrot_BigInt_multi_i_multiply_DEFAULT },
        { "pow", 
          "PJPPP", 
          "BigInt,PMC,PMC", 
          (funcptr_t) Parrot_BigInt_multi_pow_PMC_PMC },
        { "divide", 
          "PJPPP", 
          "BigInt,BigInt,PMC", 
          (funcptr_t) Parrot_BigInt_multi_divide_BigInt_PMC },
        { "divide", 
          "PJPPP", 
          "BigInt,Integer,PMC", 
          (funcptr_t) Parrot_BigInt_multi_divide_Integer_PMC },
        { "divide", 
          "PJPPP", 
          "BigInt,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigInt_multi_divide_DEFAULT_PMC },
        { "i_divide", 
          "vJPP", 
          "BigInt,BigInt", 
          (funcptr_t) Parrot_BigInt_multi_i_divide_BigInt },
        { "i_divide", 
          "vJPP", 
          "BigInt,Integer", 
          (funcptr_t) Parrot_BigInt_multi_i_divide_Integer },
        { "i_divide", 
          "vJPP", 
          "BigInt,DEFAULT", 
          (funcptr_t) Parrot_BigInt_multi_i_divide_DEFAULT },
        { "floor_divide", 
          "PJPPP", 
          "BigInt,BigInt,PMC", 
          (funcptr_t) Parrot_BigInt_multi_floor_divide_BigInt_PMC },
        { "floor_divide", 
          "PJPPP", 
          "BigInt,Integer,PMC", 
          (funcptr_t) Parrot_BigInt_multi_floor_divide_Integer_PMC },
        { "floor_divide", 
          "PJPPP", 
          "BigInt,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigInt_multi_floor_divide_DEFAULT_PMC },
        { "i_floor_divide", 
          "vJPP", 
          "BigInt,BigInt", 
          (funcptr_t) Parrot_BigInt_multi_i_floor_divide_BigInt },
        { "i_floor_divide", 
          "vJPP", 
          "BigInt,Integer", 
          (funcptr_t) Parrot_BigInt_multi_i_floor_divide_Integer },
        { "i_floor_divide", 
          "vJPP", 
          "BigInt,DEFAULT", 
          (funcptr_t) Parrot_BigInt_multi_i_floor_divide_DEFAULT },
        { "modulus", 
          "PJPPP", 
          "BigInt,BigInt,PMC", 
          (funcptr_t) Parrot_BigInt_multi_modulus_BigInt_PMC },
        { "modulus", 
          "PJPPP", 
          "BigInt,Integer,PMC", 
          (funcptr_t) Parrot_BigInt_multi_modulus_Integer_PMC },
        { "modulus", 
          "PJPPP", 
          "BigInt,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigInt_multi_modulus_DEFAULT_PMC },
        { "i_modulus", 
          "vJPP", 
          "BigInt,BigInt", 
          (funcptr_t) Parrot_BigInt_multi_i_modulus_BigInt },
        { "i_modulus", 
          "vJPP", 
          "BigInt,Integer", 
          (funcptr_t) Parrot_BigInt_multi_i_modulus_Integer },
        { "i_modulus", 
          "vJPP", 
          "BigInt,DEFAULT", 
          (funcptr_t) Parrot_BigInt_multi_i_modulus_DEFAULT },
        { "cmp", 
          "IJPP", 
          "BigInt,BigInt", 
          (funcptr_t) Parrot_BigInt_multi_cmp_BigInt },
        { "cmp", 
          "IJPP", 
          "BigInt,Integer", 
          (funcptr_t) Parrot_BigInt_multi_cmp_Integer },
        { "cmp", 
          "IJPP", 
          "BigInt,DEFAULT", 
          (funcptr_t) Parrot_BigInt_multi_cmp_DEFAULT },
        { "is_equal", 
          "IJPP", 
          "BigInt,BigInt", 
          (funcptr_t) Parrot_BigInt_multi_is_equal_BigInt },
        { "is_equal", 
          "IJPP", 
          "BigInt,Integer", 
          (funcptr_t) Parrot_BigInt_multi_is_equal_Integer },
        { "is_equal", 
          "IJPP", 
          "BigInt,DEFAULT", 
          (funcptr_t) Parrot_BigInt_multi_is_equal_DEFAULT },
        { "bitwise_shl", 
          "PJPPP", 
          "BigInt,BigInt,PMC", 
          (funcptr_t) Parrot_BigInt_multi_bitwise_shl_BigInt_PMC },
        { "bitwise_shl", 
          "PJPPP", 
          "BigInt,Integer,PMC", 
          (funcptr_t) Parrot_BigInt_multi_bitwise_shl_Integer_PMC },
        { "bitwise_shl", 
          "PJPPP", 
          "BigInt,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigInt_multi_bitwise_shl_DEFAULT_PMC },
        { "i_bitwise_shl", 
          "vJPP", 
          "BigInt,BigInt", 
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shl_BigInt },
        { "i_bitwise_shl", 
          "vJPP", 
          "BigInt,Integer", 
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shl_Integer },
        { "i_bitwise_shl", 
          "vJPP", 
          "BigInt,DEFAULT", 
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shl_DEFAULT },
        { "bitwise_shr", 
          "PJPPP", 
          "BigInt,BigInt,PMC", 
          (funcptr_t) Parrot_BigInt_multi_bitwise_shr_BigInt_PMC },
        { "bitwise_shr", 
          "PJPPP", 
          "BigInt,Integer,PMC", 
          (funcptr_t) Parrot_BigInt_multi_bitwise_shr_Integer_PMC },
        { "bitwise_shr", 
          "PJPPP", 
          "BigInt,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigInt_multi_bitwise_shr_DEFAULT_PMC },
        { "i_bitwise_shr", 
          "vJPP", 
          "BigInt,BigInt", 
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shr_BigInt },
        { "i_bitwise_shr", 
          "vJPP", 
          "BigInt,Integer", 
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shr_Integer },
        { "i_bitwise_shr", 
          "vJPP", 
          "BigInt,DEFAULT", 
          (funcptr_t) Parrot_BigInt_multi_i_bitwise_shr_DEFAULT }
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "BigInt");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "BigInt")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "BigInt"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_BigInt_nci_version), "version");
        {
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_BigInt_class_init */
#line 1417 "./src/pmc/bigint.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
