/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/bignum.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_bignum.h"
#include "pmc_default.h"
#include "bignum.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/bignum.pmc"
/*
Copyright (C) 2004-2009, Parrot Foundation.
$Id: bignum.pmc 37453 2009-03-15 20:19:46Z rurban $

=head1 NAME

src/pmc/bignum.pmc - BigNum PMC class

=head1 DESCRIPTION

C<BigNum> provides arbitrary precision floating point mathematic
functions, based on the GMP mpf library.

=head1 SYNOPSIS

Make mixing of classes work, like in:

        new $P0 ['BigInt']
        new $P1 ['BigNum']
        set $P0, 10
        set $P1, 2
        div P2, P0, P1  # $P2 = $P0 / $P1; (BigNum) 5.0

Make auto-upgrading/downgrading work.

        set $N1, $P0
        set $N1, $P1
        set $I1, $P0
        set $I1, $P1
        set $P0, $I1
        set $P0, $N1
        set $P1, $I1
        set $P1, $N1

  BigNum
    => BigInt => Integer
    => Number: float (can be long double) and double
    => Integer (unsigned long)

=head2 Functions

=over 4

=item C<static void bignum_init(Interp*, PMC *self)>

=item C<static void bignum_clear(Interp*, PMC *self)>

=item C<static void bignum_set(Interp*, PMC *dest, PMC *src)>

=item C<static void bignum_set_si(Interp*, PMC *self, long value)>

=item C<static void bignum_set_ui(Interp*, PMC *self, unsigned long value)>

=item C<static void bignum_set_float(Interp*, PMC *self, FLOATVAL value)>

=item C<static void bignum_set_double(Interp*, PMC *self, double value)>

=item C<static void bignum_set_str(Interp*, PMC *self, char *value, int base)>

=item C<static void bignum_set_bigint(Interp*, PMC *self, struct BIGINT *value)>

=item C<static BIGNUM* bignum_get_self(Interp*, PMC *self)>

=item C<static void bignum_set_self(Interp*, PMC *self, BIGNUM *value)>

=item C<static long bignum_get_si(Interp*, PMC *self)>

=item C<static unsigned long bignum_get_ui(Interp*, PMC *self)>

=item C<static int bignum_get_bool(Interp*, PMC *self)>

=item C<static char* bignum_get_string(Interp*, PMC *self, int base)>

=item C<static char* bignum_get_string_size(Interp*, PMC *self, int base, int digits)>

=item C<static double bignum_get_double(Interp*, PMC *self)>

=item C<static FLOATVAL bignum_get_float(Interp*, PMC *self)>

=item C<static BIGINT bignum_get_bigint(Interp*, PMC *self)>

=item C<static void bignum_add_bignum(Interp*, PMC *self, PMC *value, PMC *dest)>

=item C<static void bignum_add_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static void bignum_add_bignum_float(Interp*, PMC *self, FLOATVAL value, PMC *dest)>

=item C<static void bignum_sub_bignum(Interp*, PMC *self, PMC *value, PMC *dest)>

=item C<static void bignum_sub_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static void bignum_sub_bignum_float(Interp*, PMC *self, FLOATVAL value, PMC *dest)>

=item C<static void bignum_mul_bignum(Interp*, PMC *self, PMC *value, PMC *dest)>

=item C<static void bignum_mul_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static void bignum_mul_bignum_float(Interp*, PMC *self, FLOATVAL value, PMC *dest)>

=item C<static void bignum_pow_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static void bignum_check_divide_zero(Interp*, PMC *value)>

=item C<static void bignum_div_bignum(Interp*, PMC *self, PMC *value, PMC *dest)>

=item C<static void bignum_div_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static void bignum_div_bignum_float(Interp*, PMC *self, FLOATVAL value, PMC *dest)>

=item C<static void bignum_fdiv_bignum(Interp*, PMC *self, PMC *value, PMC *dest)>

=item C<static void bignum_fdiv_bignum_int(Interp*, PMC *self, INTVAL value, PMC *dest)>

=item C<static INTVAL bignum_cmp(Interp*, PMC *self, PMC *value)>

=item C<static INTVAL bignum_cmp_double(Interp*, PMC *self, double value)>

=item C<static INTVAL bignum_cmp_int(Interp*, PMC *self, INTVAL value)>

=item C<static INTVAL bignum_cmp_ulong(Interp*, PMC *self, unsigned long value)>

=item C<static void bignum_abs(Interp*, PMC *self, PMC *dest)>

=item C<static void bignum_neg(Interp*, PMC *self, PMC *dest)>

=item C<static INTVAL bignum_get_default_prec(Interp*, PMC *self)>

=item C<static void bignum_set_default_prec(Interp*, PMC *self, INTVAL prec)>

=cut

*/

#include "parrot/parrot.h"

#ifdef S_SPLINT_S
#  undef PARROT_HAS_GMP /* splint barfs on the gmp.h header */
#endif /* S_SPLINT_S */

/* Uncomment to easily disable it */
/*
#ifdef PARROT_HAS_GMP
#  undef PARROT_HAS_GMP
#endif
*/
#undef PARROT_BIGNUM_CAN_BIGINT

#ifdef PARROT_HAS_GMP
#  include "pmc_bigint.h"
#  include <gmp.h>
typedef struct BIGNUM {
    mpf_t b;
} BIGNUM;
#endif

static void
bignum_init(PARROT_INTERP, PMC *self) {
    Parrot_BigNum_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_BigNum_attributes);
#ifdef PARROT_HAS_GMP
    attrs->bn = mem_allocate_zeroed_typed(BIGNUM);
    mpf_clear(attrs->bn->b);
    mpf_init(attrs->bn->b);
#else
    attrs->bn = NULL;
#endif
    PMC_data(self) = attrs;
}


static void
bignum_clear(PARROT_INTERP, PMC *self) {
#ifdef PARROT_HAS_GMP
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_clear(bn->b);
#endif
}


#ifdef PARROT_HAS_GMP

static void
bignum_set(PARROT_INTERP, PMC *dest, PMC *src) {
    BIGNUM *bn_dest, *bn_src;
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    GETATTR_BigNum_bn(interp, src,  bn_src);
    mpf_set(bn_dest->b, bn_src->b);
}

static void
bignum_set_si(PARROT_INTERP, PMC *self, long value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_si(bn->b, value);
}

static void
bignum_set_ui(PARROT_INTERP, PMC *self, unsigned long value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_ui(bn->b, value);
}

static void
bignum_set_float(PARROT_INTERP, PMC *self, FLOATVAL value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_d(bn->b, (double)value);
}

static void
bignum_set_double(PARROT_INTERP, PMC *self, double value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_d(bn->b, value);
}

static void
bignum_set_str(PARROT_INTERP, PMC *self, char *value, int base) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set_str(bn->b, value, base);
}

#  ifdef PARROT_BIGNUM_CAN_BIGINT
static void
bignum_set_bigint(PARROT_INTERP, PMC *self, struct BIGINT *value) {
    BIGNUM *bn;
    struct BIGINT *bi;
    GETATTR_BigNum_bn(interp, self, bn);
    bi->b = PARROT_BIGINT(value);
    mpf_set(bn->b, (mpf_srcptr)bi->b);
}
#  endif

static BIGNUM*
bignum_get_self(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return bn;
}

static void
bignum_set_self(PARROT_INTERP, PMC *self, BIGNUM *value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    mpf_set(bn->b, (mpf_srcptr)((BIGNUM*)value)->b);
}

static long
bignum_get_si(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_fits_slong_p(bn->b))
        return mpf_get_si(bn->b);

    Parrot_ex_throw_from_c_args(interp, NULL, 1, "bignum_get_si: number too big");
}

static unsigned long
bignum_get_ui(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_fits_slong_p(bn->b))
        return mpf_get_ui(bn->b);

    Parrot_ex_throw_from_c_args(interp, NULL, 1, "bignum_get_ui: number too big");
}

static int
bignum_get_bool(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    if (mpf_sgn(bn->b) != 0)
        return 1;
    else
        return 0;
}

static char *
bignum_get_string(PARROT_INTERP, PMC *self, int base) {
    BIGNUM *bn;
    size_t  n;
    char   *s;
    mp_exp_t exponent;

    GETATTR_BigNum_bn(interp, self, bn);
    n = (mpf_get_prec(bn->b)) / log(base) * log(2);
    s = (char *)mem_sys_allocate(n + 5);
    return mpf_get_str(s, &exponent, base, 0, bn->b);
}

static char *
bignum_get_string_size(PARROT_INTERP, PMC *self, int base, int digits) {
    BIGNUM *bn;
    size_t  n;
    char   *s;
    mp_exp_t exponent;

    GETATTR_BigNum_bn(interp, self, bn);
    s = (char *)mem_sys_allocate(digits + 5);
    return mpf_get_str(s, &exponent, base, digits, bn->b);
}

static double
bignum_get_double(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_get_d(bn->b);
}

static FLOATVAL
bignum_get_float(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_get_d(bn->b);
}

#  ifdef PARROT_BIGNUM_CAN_BIGINT
static struct BIGINT
bignum_get_bigint(PARROT_INTERP, PMC *self) {
    BIGNUM *bn;
    struct BIGINT *bi_dest;
    GETATTR_BigNum_bn(interp, self, bn);
    mpz_clear(bi_dest->b);
    mpz_init(bi_dest->b);
    if (mpf_fits_slong_p(bn->b)) {
        bi_dest->b = mpf_get_ui(bn->b);
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "bignum_get_bigint: Precision loss");
    }
    return bi_dest;
}
#  endif

static void
bignum_add_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_add(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_add_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    if (value < 0)
        mpf_sub_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
    else
        mpf_add_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_add_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    BIGNUM *bn_value, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_value);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_value->b, value);
    mpf_add(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_sub_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_sub(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_sub_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    if (value < 0)
        mpf_add_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
    else
        mpf_sub_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_sub_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    BIGNUM *bn_tmp, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_tmp);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_tmp->b, value);
    mpf_sub(bn_dest->b, bn_self->b, bn_tmp->b);
}

static void
bignum_mul_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_mul(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_mul_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_mul_ui(bn_dest->b, bn_self->b, (unsigned long)value);
}

static void
bignum_mul_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    BIGNUM *bn_tmp, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_tmp);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_set_d(bn_tmp->b, value);
    mpf_mul(bn_dest->b, bn_self->b, bn_tmp->b);
}

static void
bignum_pow_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_pow_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
int_check_divide_zero(PARROT_INTERP, INTVAL value) {
    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bignum_check_divide_zero(PARROT_INTERP, PMC *value) {
    /* Throw an exception if we are dividing by zero. */
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, value, bn);
    if (mpf_cmp_si(bn->b, 0) == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

static void
bignum_div_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGNUM *bn_self, *bn_value, *bn_dest;
    bignum_check_divide_zero(interp, value);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_div(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_div_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);

    /* this is mpz_fdiv_q */
    if (value < 0) {
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static void
bignum_div_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    BIGNUM *bn, *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpf_set_d(bn->b, -value);
        mpf_div(bn_dest->b, bn_self->b, bn->b);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else
        mpf_div(bn_dest->b, bn_self->b, bn->b);
}

/* There's no such mpf_fdiv, only mpz_fdiv and mpf_div */
static void
bignum_fdiv_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    BIGNUM *bn_self, *bn_value, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    bignum_check_divide_zero(interp, value);
    mpf_div(bn_dest->b, bn_self->b, bn_value->b);
}

static void
bignum_fdiv_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    int_check_divide_zero(interp, value);

    if (value < 0) {
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)-value);
        mpf_neg(bn_dest->b, bn_dest->b);
    }
    else
        mpf_div_ui(bn_dest->b, bn_self->b, (unsigned long int)value);
}

static INTVAL
bignum_cmp(PARROT_INTERP, PMC *self, PMC *value) {
    BIGNUM *bn_self, *bn_value;
    GETATTR_BigNum_bn(interp, self,  bn_self);
    GETATTR_BigNum_bn(interp, value, bn_value);
    return mpf_cmp(bn_self->b, bn_value->b);
}

static INTVAL
bignum_cmp_double(PARROT_INTERP, PMC *self, double value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_d(bn->b, value);
}

static INTVAL
bignum_cmp_int(PARROT_INTERP, PMC *self, INTVAL value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_si(bn->b, value);
}

static INTVAL
bignum_cmp_ulong(PARROT_INTERP, PMC *self, unsigned long value) {
    BIGNUM *bn;
    GETATTR_BigNum_bn(interp, self, bn);
    return mpf_cmp_ui(bn->b, value);
}

static void
bignum_abs(PARROT_INTERP, PMC *self, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    pmc_reuse(interp, dest, enum_class_BigNum, 0);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_abs(bn_dest->b, bn_self->b);
}

static void
bignum_neg(PARROT_INTERP, PMC *self, PMC *dest) {
    BIGNUM *bn_self, *bn_dest;
    pmc_reuse(interp, dest, enum_class_BigNum, 0);
    GETATTR_BigNum_bn(interp, self, bn_self);
    GETATTR_BigNum_bn(interp, dest, bn_dest);
    mpf_neg(bn_dest->b, bn_self->b);
}

static INTVAL
bignum_get_default_prec(PARROT_INTERP, PMC *self) {
    return mpf_get_default_prec();
}

static void
bignum_set_default_prec(PARROT_INTERP, PMC *self, INTVAL prec) {
    mpf_set_default_prec(prec);
}

#else /* ifdef PARROT_HAS_GMP */

typedef struct BIGNUM {
    FLOATVAL b; /* bogus definition for users without libgmp*/
} BIGNUM;

#  define THROW_NYI Parrot_ex_throw_from_c_args(interp, NULL, \
                        EXCEPTION_LIBRARY_ERROR, "no bignum lib loaded")

#  if 0
static void
bignum_init(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static void
bignum_clear(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}
#  endif

static void
bignum_set(PARROT_INTERP, PMC *dest, PMC *src) {
    THROW_NYI;
}

static void
bignum_set_si(PARROT_INTERP, PMC *self, long value) {
    THROW_NYI;
}

static void
bignum_set_double(PARROT_INTERP, PMC *self, double value) {
    THROW_NYI;
}

static void
bignum_set_str(PARROT_INTERP, PMC *self, char *value, int base) {
    THROW_NYI;
}

static void
bignum_set_self(PARROT_INTERP, PMC *self, BIGNUM *value) {
    THROW_NYI;
}

static BIGNUM*
bignum_get_self(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static char *
bignum_get_string(PARROT_INTERP, PMC *self, int base) {
    THROW_NYI;
}

static char *
bignum_get_string_size(PARROT_INTERP, PMC *self, int base, int digits) {
    THROW_NYI;
}

static unsigned long
bignum_get_ui(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static long
bignum_get_si(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static long
bignum_get_bool(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static double
bignum_get_double(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static void
bignum_add_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_add_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_add_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_sub_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_sub_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_sub_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_mul_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_mul_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_mul_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_pow_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_pow_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_div_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_div_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_div_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_fdiv_bignum(PARROT_INTERP, PMC *self, PMC *value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_fdiv_bignum_int(PARROT_INTERP, PMC *self, INTVAL value, PMC *dest) {
    THROW_NYI;
}

static void
bignum_fdiv_bignum_float(PARROT_INTERP, PMC *self, FLOATVAL value, PMC *dest) {
    THROW_NYI;
}

static INTVAL
bignum_cmp(PARROT_INTERP, PMC *self, PMC *value) {
    THROW_NYI;
}

static INTVAL
bignum_cmp_int(PARROT_INTERP, PMC *self, INTVAL value) {
    THROW_NYI;
}

static INTVAL
bignum_cmp_float(PARROT_INTERP, PMC *self, FLOATVAL value) {
    THROW_NYI;
}

static void
bignum_abs(PARROT_INTERP, PMC *self, PMC *dest) {
    THROW_NYI;
}

static void
bignum_neg(PARROT_INTERP, PMC *self, PMC *dest) {
    THROW_NYI;
}

static INTVAL
bignum_get_default_prec(PARROT_INTERP, PMC *self) {
    THROW_NYI;
}

static void
bignum_set_default_prec(PARROT_INTERP, PMC *self, INTVAL prec) {
    THROW_NYI;
}

#  undef THROW_NYI

#endif /* ifdef PARROT_HAS_GMP */
#line 802 "./src/pmc/bignum.c"
PARROT_EXPORT  PMC  *
Parrot_BigNum_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1509 "./src/pmc/bignum.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_abs(interp, pmc, dest);
    return dest;
#line 812 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1127 "./src/pmc/bignum.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_add_bignum_int(interp, pmc, value, dest);
    return dest;
#line 823 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_clone(PARROT_INTERP, PMC *pmc)
{
#line 847 "./src/pmc/bignum.pmc"

    PMC *res = pmc_new(interp, pmc->vtable->base_type);
    bignum_set(interp, res, pmc);
    return res;
#line 833 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_decrement(PARROT_INTERP, PMC *pmc)
{
#line 1094 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_int(interp, pmc, 1, pmc);
#line 841 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_destroy(PARROT_INTERP, PMC *pmc)
{
#line 853 "./src/pmc/bignum.pmc"

    BIGNUM                   *bn;
    Parrot_BigNum_attributes *attrs;

    bignum_clear(interp, pmc);

    attrs = (Parrot_BigNum_attributes*)PMC_data(pmc);
#ifdef PARROT_HAS_GMP
    mem_sys_free(attrs->bn);
#endif
    mem_sys_free(attrs);
#line 858 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1366 "./src/pmc/bignum.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_div_bignum_int(interp, pmc, value, dest);
    return dest;
#line 872 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1422 "./src/pmc/bignum.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_fdiv_bignum_int(interp, pmc, value, dest);
    return dest;
#line 886 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_get_bignum(PARROT_INTERP, PMC *pmc)
{
#line 984 "./src/pmc/bignum.pmc"

    return pmc;
#line 894 "./src/pmc/bignum.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigNum_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 1017 "./src/pmc/bignum.pmc"

    return bignum_get_bool(interp, pmc);
#line 902 "./src/pmc/bignum.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigNum_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 956 "./src/pmc/bignum.pmc"

    return bignum_get_si(interp, pmc);
#line 910 "./src/pmc/bignum.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_BigNum_get_number(PARROT_INTERP, PMC *pmc)
{
#line 942 "./src/pmc/bignum.pmc"

    return bignum_get_double(interp, pmc);
#line 918 "./src/pmc/bignum.c"
}
PARROT_EXPORT  STRING  *
Parrot_BigNum_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 1066 "./src/pmc/bignum.pmc"

    STRING *s = VTABLE_get_string(interp, pmc);
    return Parrot_str_append(interp, s, Parrot_str_new(interp, "N", 1));
#line 927 "./src/pmc/bignum.c"
}
PARROT_EXPORT  STRING  *
Parrot_BigNum_get_string(PARROT_INTERP, PMC *pmc)
{
#line 1045 "./src/pmc/bignum.pmc"

    char   *s  = bignum_get_string(interp, pmc, 10);
    STRING *ps = Parrot_str_new(interp, s, 0);
    mem_sys_free(s);
    return ps;
#line 938 "./src/pmc/bignum.c"
}
PARROT_EXPORT  STRING  *
Parrot_BigNum_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base)
{
#line 1052 "./src/pmc/bignum.pmc"

    char   *s  = bignum_get_string(interp, pmc, base);
    STRING *ps = Parrot_str_new(interp, s, 0);
    mem_sys_free(s);
    return ps;
#line 949 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 1516 "./src/pmc/bignum.pmc"

    bignum_abs(interp, pmc, pmc);
#line 957 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1153 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_add_float' for FLOATVAL");
#line 967 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1149 "./src/pmc/bignum.pmc"

    bignum_add_bignum_int(interp, pmc, value, pmc);
#line 975 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1389 "./src/pmc/bignum.pmc"

    bignum_div_bignum_int(interp, pmc, value, pmc);
#line 983 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1447 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum_int(interp, pmc, value, pmc);
#line 991 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1288 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_multiply_float' for FLOATVAL");
#line 1001 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1284 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_int(interp, pmc, value, pmc);
#line 1009 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_i_neg(PARROT_INTERP, PMC *pmc)
{
#line 1540 "./src/pmc/bignum.pmc"

    bignum_neg(interp, pmc, pmc);
#line 1017 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1223 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_subtract_float' for FLOATVAL");
#line 1027 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1219 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_int(interp, pmc, value, pmc);
#line 1035 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_increment(PARROT_INTERP, PMC *pmc)
{
#line 1080 "./src/pmc/bignum.pmc"

    bignum_add_bignum_int(interp, pmc, 1, pmc);
#line 1043 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_init(PARROT_INTERP, PMC *pmc)
{
#line 842 "./src/pmc/bignum.pmc"

    bignum_init(interp, pmc);
    PObj_active_destroy_SET(pmc);
#line 1052 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_instantiate(PARROT_INTERP, PMC *pmc, PMC *sig)
{
#line 820 "./src/pmc/bignum.pmc"

#ifdef PARROT_HAS_GMP
    int argcP = REG_INT(interp, 3);
    int base;
    PMC *res;
    STRING *num;

    res = pmc_new(interp, enum_class_BigNum);
    if (!argcP) {
        return res;
    }
    base = 10;
    if (argcP == 2)
        base = VTABLE_get_integer(interp, REG_PMC(interp, 6));
    num = VTABLE_get_string(interp, REG_PMC(interp, 5));
    VTABLE_set_string_keyed_int(interp, res, base, num);
    return res;
#else
    return PMCNULL;
#endif
#line 1078 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1258 "./src/pmc/bignum.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_mul_bignum_int(interp, pmc, value, dest);
    return dest;
#line 1089 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1533 "./src/pmc/bignum.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_neg(interp, pmc, dest);
    return dest;
#line 1100 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1302 "./src/pmc/bignum.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_pow_bignum_int(interp, pmc, value, dest);
    return dest;
#line 1114 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 874 "./src/pmc/bignum.pmc"

    bignum_set_si(interp, pmc, (long)value);
#line 1122 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 888 "./src/pmc/bignum.pmc"

    bignum_set_double(interp, pmc, (double)value);
#line 1130 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 928 "./src/pmc/bignum.pmc"

    bignum_set_self(interp, pmc, bignum_get_self(interp, value));
#line 1138 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL base, STRING *value)
{
#line 913 "./src/pmc/bignum.pmc"

    char * const s = Parrot_str_to_cstring(interp, value);
    bignum_set_str(interp, pmc, s, base);
    Parrot_str_free_cstring(s);
#line 1148 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 907 "./src/pmc/bignum.pmc"

    char * const s = Parrot_str_to_cstring(interp, value);
    bignum_set_str(interp, pmc, s, 10);
    Parrot_str_free_cstring(s);
#line 1158 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1194 "./src/pmc/bignum.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_sub_bignum_int(interp, pmc, value, dest);
    return dest;
#line 1172 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void
Parrot_BigNum_nci_version(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1210 "./src/pmc/bignum.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1227 "./src/pmc/bignum.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 800 "./src/pmc/bignum.pmc"

    STRING *version;
#ifdef PARROT_HAS_GMP
    version = Parrot_str_new(interp, gmp_version, 0);
#else
    version = Parrot_str_new(interp, "0.0.0", 5);
#endif
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *version */
    /*BEGIN GENERATED ACCESSORS */
#line 1246 "./src/pmc/bignum.pmc"
    CTX_REG_STR(_ctx, 0) = version;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto version_returns;
    /*END RETURN STRING *version */
    }
#line 807 "./src/pmc/bignum.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
version_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1291 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_add_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1106 "./src/pmc/bignum.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_add_bignum(interp, pmc, value, dest);
    return dest;
#line 1302 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1113 "./src/pmc/bignum.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_add_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1313 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1120 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'add' for %Ss",
        VTABLE_name(interp, value));
#line 1324 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_add_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1134 "./src/pmc/bignum.pmc"

    bignum_add_bignum(interp, pmc, value, pmc);
#line 1332 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_add_FLOATVAL(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1138 "./src/pmc/bignum.pmc"

    bignum_add_bignum_float(interp, pmc, value, pmc);
#line 1340 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1142 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_add' for %Ss",
        VTABLE_name(interp, value));
#line 1351 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_subtract_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1167 "./src/pmc/bignum.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_sub_bignum(interp, pmc, value, dest);
    return dest;
#line 1365 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1177 "./src/pmc/bignum.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_sub_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1379 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1187 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'subtract' for %Ss",
        VTABLE_name(interp, value));
#line 1390 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_subtract_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1204 "./src/pmc/bignum.pmc"

    bignum_sub_bignum(interp, pmc, value, pmc);
#line 1398 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_subtract_FLOATVAL(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1208 "./src/pmc/bignum.pmc"

    bignum_sub_bignum_float(interp, pmc, value, pmc);
#line 1406 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1212 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_subtract' for %Ss",
        VTABLE_name(interp, value));
#line 1417 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_multiply_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1237 "./src/pmc/bignum.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_mul_bignum(interp, pmc, value, dest);
    return dest;
#line 1428 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1244 "./src/pmc/bignum.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_mul_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1439 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1251 "./src/pmc/bignum.pmc"

     Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'multiply' for %Ss",
        VTABLE_name(interp, value));
#line 1450 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_multiply_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1265 "./src/pmc/bignum.pmc"

    bignum_mul_bignum(interp, pmc, value, pmc);
#line 1458 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_multiply_FLOATVAL(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1269 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_float(interp, pmc, value, pmc);
#line 1466 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1273 "./src/pmc/bignum.pmc"

    bignum_mul_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1474 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1277 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_multiply' for %Ss",
        VTABLE_name(interp, value));
#line 1485 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_pow_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1312 "./src/pmc/bignum.pmc"

    /* only Integer RHS currently. TODO: check number and bignum types */
    INTVAL r = VTABLE_get_integer(interp, value);
    dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_pow_bignum_int(interp, pmc, r, dest);
    return dest;
#line 1498 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_divide_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1329 "./src/pmc/bignum.pmc"

    BIGNUM *bn;
    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_div_bignum(interp, pmc, value, dest);
#if 0
    /* to downgrade or not that's the question */
    GETATTR_BigNum_bn(interp, dest, bn);
    if (mpf_fits_slong_p(bn->b)) {
        long iresult = mpf_get_si(bn->b);
        VTABLE_morph(interp, dest, enum_class_Integer);
        VTABLE_set_integer_native(interp, dest, iresult);
    }
#endif
    return dest;
#line 1522 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1349 "./src/pmc/bignum.pmc"

    if (dest)
        pmc_reuse(interp, dest, pmc->vtable->base_type, 0);
    else
        dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_div_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1536 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1359 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'divide' for %Ss",
        VTABLE_name(interp, value));
#line 1547 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_divide_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1376 "./src/pmc/bignum.pmc"

    bignum_div_bignum(interp, pmc, value, pmc);
#line 1555 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1379 "./src/pmc/bignum.pmc"

    bignum_div_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1563 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1382 "./src/pmc/bignum.pmc"

     Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_divide' for %Ss",
        VTABLE_name(interp, value));
#line 1574 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_floor_divide_BigNum_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1401 "./src/pmc/bignum.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_fdiv_bignum(interp, pmc, value, dest);
    return dest;
#line 1585 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_floor_divide_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1408 "./src/pmc/bignum.pmc"

    dest = pmc_new(interp, pmc->vtable->base_type);

    bignum_fdiv_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), dest);
    return dest;
#line 1596 "./src/pmc/bignum.c"
}
PARROT_EXPORT  PMC  *
Parrot_BigNum_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1415 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'floor_divide' for %Ss",
        VTABLE_name(interp, value));
#line 1607 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_floor_divide_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1432 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum(interp, pmc, value, pmc);
#line 1615 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_floor_divide_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1436 "./src/pmc/bignum.pmc"

    bignum_fdiv_bignum_int(interp, pmc, VTABLE_get_integer(interp, value), pmc);
#line 1623 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void 
Parrot_BigNum_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1440 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'i_floor_divide' for %Ss",
        VTABLE_name(interp, value));
#line 1634 "./src/pmc/bignum.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigNum_multi_cmp_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1459 "./src/pmc/bignum.pmc"

    return bignum_cmp(interp, pmc, value);
#line 1642 "./src/pmc/bignum.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigNum_multi_cmp_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1463 "./src/pmc/bignum.pmc"

    return bignum_cmp_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 1650 "./src/pmc/bignum.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigNum_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1467 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'cmp' for %Ss",
        VTABLE_name(interp, value));
#line 1661 "./src/pmc/bignum.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigNum_multi_is_equal_BigNum(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1482 "./src/pmc/bignum.pmc"

    return bignum_cmp(interp, pmc, value) == 0;
#line 1669 "./src/pmc/bignum.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigNum_multi_is_equal_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1486 "./src/pmc/bignum.pmc"

    return bignum_cmp_int(interp, pmc, VTABLE_get_integer(interp, value)) == 0;
#line 1677 "./src/pmc/bignum.c"
}
PARROT_EXPORT  INTVAL 
Parrot_BigNum_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1490 "./src/pmc/bignum.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "BigNum: no multiple dispatch variant 'is_equal' for %Ss",
        VTABLE_name(interp, value));
#line 1688 "./src/pmc/bignum.c"
}
PARROT_EXPORT  void
Parrot_BigNum_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of BigNum");
}
PARROT_EXPORT  PMC *
Parrot_BigNum_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of BigNum");
}
PARROT_EXPORT  FLOATVAL
Parrot_BigNum_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of BigNum");
}
PARROT_EXPORT  INTVAL
Parrot_BigNum_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of BigNum");
}
PARROT_EXPORT  PMC *
Parrot_BigNum_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of BigNum");
}
PARROT_EXPORT  STRING *
Parrot_BigNum_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of BigNum");
}
PARROT_EXPORT  FLOATVAL
Parrot_BigNum_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of BigNum");
}
PARROT_EXPORT  INTVAL
Parrot_BigNum_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of BigNum");
}
PARROT_EXPORT  PMC *
Parrot_BigNum_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of BigNum");
}
PARROT_EXPORT  STRING *
Parrot_BigNum_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of BigNum");
}
PARROT_EXPORT  void
Parrot_BigNum_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of BigNum");
}
#include "pmc_default.h"
void
Parrot_BigNum_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":bn ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_BigNum, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_BigNum_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_BigNum_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_BigNum_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_BigNum_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_BigNum_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_BigNum_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_BigNum_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_BigNum_get_bignum,
        Parrot_BigNum_get_bool,
        Parrot_default_get_class,
        Parrot_BigNum_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_BigNum_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_BigNum_get_repr,
        Parrot_BigNum_get_string,
        Parrot_default_get_string_keyed,
        Parrot_BigNum_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_BigNum_i_absolute,
        Parrot_default_i_add,
        Parrot_BigNum_i_add_float,
        Parrot_BigNum_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_BigNum_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_BigNum_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_BigNum_i_multiply_float,
        Parrot_BigNum_i_multiply_int,
        Parrot_BigNum_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_BigNum_i_subtract_float,
        Parrot_BigNum_i_subtract_int,
        Parrot_BigNum_increment,
        Parrot_BigNum_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_BigNum_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_BigNum_multiply_int,
        Parrot_default_name,
        Parrot_BigNum_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_BigNum_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_BigNum_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_BigNum_set_number_native,
        Parrot_default_set_number_same,
        Parrot_BigNum_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_BigNum_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_BigNum_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_BigNum_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_BigNum, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_BigNum_absolute,
        Parrot_default_add,
        Parrot_BigNum_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_BigNum_add_int,
        Parrot_BigNum_ro_add_method,
        Parrot_BigNum_ro_add_parent,
        Parrot_BigNum_ro_add_role,
        Parrot_BigNum_ro_add_vtable_override,
        Parrot_BigNum_ro_assign_pmc,
        Parrot_BigNum_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_BigNum_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_BigNum_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_BigNum_ro_delete_keyed,
        Parrot_BigNum_ro_delete_keyed_int,
        Parrot_BigNum_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_BigNum_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_BigNum_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_BigNum_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_BigNum_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_BigNum_get_bignum,
        Parrot_BigNum_get_bool,
        Parrot_default_get_class,
        Parrot_BigNum_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_BigNum_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_BigNum_get_repr,
        Parrot_BigNum_get_string,
        Parrot_default_get_string_keyed,
        Parrot_BigNum_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_BigNum_ro_i_absolute,
        Parrot_BigNum_ro_i_add,
        Parrot_BigNum_ro_i_add_float,
        Parrot_BigNum_ro_i_add_int,
        Parrot_BigNum_ro_i_bitwise_and,
        Parrot_BigNum_ro_i_bitwise_and_int,
        Parrot_BigNum_ro_i_bitwise_ands,
        Parrot_BigNum_ro_i_bitwise_ands_str,
        Parrot_BigNum_ro_i_bitwise_lsr,
        Parrot_BigNum_ro_i_bitwise_lsr_int,
        Parrot_BigNum_ro_i_bitwise_not,
        Parrot_BigNum_ro_i_bitwise_nots,
        Parrot_BigNum_ro_i_bitwise_or,
        Parrot_BigNum_ro_i_bitwise_or_int,
        Parrot_BigNum_ro_i_bitwise_ors,
        Parrot_BigNum_ro_i_bitwise_ors_str,
        Parrot_BigNum_ro_i_bitwise_shl,
        Parrot_BigNum_ro_i_bitwise_shl_int,
        Parrot_BigNum_ro_i_bitwise_shr,
        Parrot_BigNum_ro_i_bitwise_shr_int,
        Parrot_BigNum_ro_i_bitwise_xor,
        Parrot_BigNum_ro_i_bitwise_xor_int,
        Parrot_BigNum_ro_i_bitwise_xors,
        Parrot_BigNum_ro_i_bitwise_xors_str,
        Parrot_BigNum_ro_i_concatenate,
        Parrot_BigNum_ro_i_concatenate_str,
        Parrot_BigNum_ro_i_divide,
        Parrot_BigNum_ro_i_divide_float,
        Parrot_BigNum_ro_i_divide_int,
        Parrot_BigNum_ro_i_floor_divide,
        Parrot_BigNum_ro_i_floor_divide_float,
        Parrot_BigNum_ro_i_floor_divide_int,
        Parrot_BigNum_ro_i_logical_not,
        Parrot_BigNum_ro_i_modulus,
        Parrot_BigNum_ro_i_modulus_float,
        Parrot_BigNum_ro_i_modulus_int,
        Parrot_BigNum_ro_i_multiply,
        Parrot_BigNum_ro_i_multiply_float,
        Parrot_BigNum_ro_i_multiply_int,
        Parrot_BigNum_ro_i_neg,
        Parrot_BigNum_ro_i_pow,
        Parrot_BigNum_ro_i_pow_float,
        Parrot_BigNum_ro_i_pow_int,
        Parrot_BigNum_ro_i_repeat,
        Parrot_BigNum_ro_i_repeat_int,
        Parrot_BigNum_ro_i_subtract,
        Parrot_BigNum_ro_i_subtract_float,
        Parrot_BigNum_ro_i_subtract_int,
        Parrot_BigNum_ro_increment,
        Parrot_BigNum_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_BigNum_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_BigNum_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_BigNum_multiply_int,
        Parrot_default_name,
        Parrot_BigNum_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_BigNum_ro_pop_float,
        Parrot_BigNum_ro_pop_integer,
        Parrot_BigNum_ro_pop_pmc,
        Parrot_BigNum_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_BigNum_pow_int,
        Parrot_BigNum_ro_push_float,
        Parrot_BigNum_ro_push_integer,
        Parrot_BigNum_ro_push_pmc,
        Parrot_BigNum_ro_push_string,
        Parrot_BigNum_ro_remove_attribute,
        Parrot_BigNum_ro_remove_method,
        Parrot_BigNum_ro_remove_parent,
        Parrot_BigNum_ro_remove_role,
        Parrot_BigNum_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_BigNum_ro_set_attr_keyed,
        Parrot_BigNum_ro_set_attr_str,
        Parrot_BigNum_ro_set_bignum_int,
        Parrot_BigNum_ro_set_bignum_num,
        Parrot_BigNum_ro_set_bignum_str,
        Parrot_BigNum_ro_set_bool,
        Parrot_BigNum_ro_set_integer_keyed,
        Parrot_BigNum_ro_set_integer_keyed_int,
        Parrot_BigNum_ro_set_integer_keyed_str,
        Parrot_BigNum_ro_set_integer_native,
        Parrot_BigNum_ro_set_integer_same,
        Parrot_BigNum_ro_set_number_keyed,
        Parrot_BigNum_ro_set_number_keyed_int,
        Parrot_BigNum_ro_set_number_keyed_str,
        Parrot_BigNum_ro_set_number_native,
        Parrot_BigNum_ro_set_number_same,
        Parrot_BigNum_ro_set_pmc,
        Parrot_BigNum_ro_set_pmc_keyed,
        Parrot_BigNum_ro_set_pmc_keyed_int,
        Parrot_BigNum_ro_set_pmc_keyed_str,
        Parrot_BigNum_ro_set_pointer,
        Parrot_BigNum_ro_set_pointer_keyed,
        Parrot_BigNum_ro_set_pointer_keyed_int,
        Parrot_BigNum_ro_set_pointer_keyed_str,
        Parrot_BigNum_ro_set_string_keyed,
        Parrot_BigNum_ro_set_string_keyed_int,
        Parrot_BigNum_ro_set_string_keyed_str,
        Parrot_BigNum_ro_set_string_native,
        Parrot_BigNum_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_BigNum_ro_shift_float,
        Parrot_BigNum_ro_shift_integer,
        Parrot_BigNum_ro_shift_pmc,
        Parrot_BigNum_ro_shift_string,
        Parrot_default_slice,
        Parrot_BigNum_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_BigNum_subtract_int,
        Parrot_BigNum_ro_thaw,
        Parrot_BigNum_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_BigNum_ro_unshift_float,
        Parrot_BigNum_ro_unshift_integer,
        Parrot_BigNum_ro_unshift_pmc,
        Parrot_BigNum_ro_unshift_string,
        Parrot_default_visit
    };

    const  multi_func_list _temp_multi_func_list[] = {
        { "add", 
          "PJPPP", 
          "BigNum,BigNum,PMC", 
          (funcptr_t) Parrot_BigNum_multi_add_BigNum_PMC },
        { "add", 
          "PJPPP", 
          "BigNum,Integer,PMC", 
          (funcptr_t) Parrot_BigNum_multi_add_Integer_PMC },
        { "add", 
          "PJPPP", 
          "BigNum,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigNum_multi_add_DEFAULT_PMC },
        { "i_add", 
          "vJPP", 
          "BigNum,BigNum", 
          (funcptr_t) Parrot_BigNum_multi_i_add_BigNum },
        { "i_add", 
          "vJPN", 
          "BigNum,FLOATVAL", 
          (funcptr_t) Parrot_BigNum_multi_i_add_FLOATVAL },
        { "i_add", 
          "vJPP", 
          "BigNum,DEFAULT", 
          (funcptr_t) Parrot_BigNum_multi_i_add_DEFAULT },
        { "subtract", 
          "PJPPP", 
          "BigNum,BigNum,PMC", 
          (funcptr_t) Parrot_BigNum_multi_subtract_BigNum_PMC },
        { "subtract", 
          "PJPPP", 
          "BigNum,Integer,PMC", 
          (funcptr_t) Parrot_BigNum_multi_subtract_Integer_PMC },
        { "subtract", 
          "PJPPP", 
          "BigNum,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigNum_multi_subtract_DEFAULT_PMC },
        { "i_subtract", 
          "vJPP", 
          "BigNum,BigNum", 
          (funcptr_t) Parrot_BigNum_multi_i_subtract_BigNum },
        { "i_subtract", 
          "vJPN", 
          "BigNum,FLOATVAL", 
          (funcptr_t) Parrot_BigNum_multi_i_subtract_FLOATVAL },
        { "i_subtract", 
          "vJPP", 
          "BigNum,DEFAULT", 
          (funcptr_t) Parrot_BigNum_multi_i_subtract_DEFAULT },
        { "multiply", 
          "PJPPP", 
          "BigNum,BigNum,PMC", 
          (funcptr_t) Parrot_BigNum_multi_multiply_BigNum_PMC },
        { "multiply", 
          "PJPPP", 
          "BigNum,Integer,PMC", 
          (funcptr_t) Parrot_BigNum_multi_multiply_Integer_PMC },
        { "multiply", 
          "PJPPP", 
          "BigNum,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigNum_multi_multiply_DEFAULT_PMC },
        { "i_multiply", 
          "vJPP", 
          "BigNum,BigNum", 
          (funcptr_t) Parrot_BigNum_multi_i_multiply_BigNum },
        { "i_multiply", 
          "vJPN", 
          "BigNum,FLOATVAL", 
          (funcptr_t) Parrot_BigNum_multi_i_multiply_FLOATVAL },
        { "i_multiply", 
          "vJPP", 
          "BigNum,Integer", 
          (funcptr_t) Parrot_BigNum_multi_i_multiply_Integer },
        { "i_multiply", 
          "vJPP", 
          "BigNum,DEFAULT", 
          (funcptr_t) Parrot_BigNum_multi_i_multiply_DEFAULT },
        { "pow", 
          "PJPPP", 
          "BigNum,PMC,PMC", 
          (funcptr_t) Parrot_BigNum_multi_pow_PMC_PMC },
        { "divide", 
          "PJPPP", 
          "BigNum,BigNum,PMC", 
          (funcptr_t) Parrot_BigNum_multi_divide_BigNum_PMC },
        { "divide", 
          "PJPPP", 
          "BigNum,Integer,PMC", 
          (funcptr_t) Parrot_BigNum_multi_divide_Integer_PMC },
        { "divide", 
          "PJPPP", 
          "BigNum,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigNum_multi_divide_DEFAULT_PMC },
        { "i_divide", 
          "vJPP", 
          "BigNum,BigNum", 
          (funcptr_t) Parrot_BigNum_multi_i_divide_BigNum },
        { "i_divide", 
          "vJPP", 
          "BigNum,Integer", 
          (funcptr_t) Parrot_BigNum_multi_i_divide_Integer },
        { "i_divide", 
          "vJPP", 
          "BigNum,DEFAULT", 
          (funcptr_t) Parrot_BigNum_multi_i_divide_DEFAULT },
        { "floor_divide", 
          "PJPPP", 
          "BigNum,BigNum,PMC", 
          (funcptr_t) Parrot_BigNum_multi_floor_divide_BigNum_PMC },
        { "floor_divide", 
          "PJPPP", 
          "BigNum,Integer,PMC", 
          (funcptr_t) Parrot_BigNum_multi_floor_divide_Integer_PMC },
        { "floor_divide", 
          "PJPPP", 
          "BigNum,DEFAULT,PMC", 
          (funcptr_t) Parrot_BigNum_multi_floor_divide_DEFAULT_PMC },
        { "i_floor_divide", 
          "vJPP", 
          "BigNum,BigNum", 
          (funcptr_t) Parrot_BigNum_multi_i_floor_divide_BigNum },
        { "i_floor_divide", 
          "vJPP", 
          "BigNum,Integer", 
          (funcptr_t) Parrot_BigNum_multi_i_floor_divide_Integer },
        { "i_floor_divide", 
          "vJPP", 
          "BigNum,DEFAULT", 
          (funcptr_t) Parrot_BigNum_multi_i_floor_divide_DEFAULT },
        { "cmp", 
          "IJPP", 
          "BigNum,BigNum", 
          (funcptr_t) Parrot_BigNum_multi_cmp_BigNum },
        { "cmp", 
          "IJPP", 
          "BigNum,Integer", 
          (funcptr_t) Parrot_BigNum_multi_cmp_Integer },
        { "cmp", 
          "IJPP", 
          "BigNum,DEFAULT", 
          (funcptr_t) Parrot_BigNum_multi_cmp_DEFAULT },
        { "is_equal", 
          "IJPP", 
          "BigNum,BigNum", 
          (funcptr_t) Parrot_BigNum_multi_is_equal_BigNum },
        { "is_equal", 
          "IJPP", 
          "BigNum,Integer", 
          (funcptr_t) Parrot_BigNum_multi_is_equal_Integer },
        { "is_equal", 
          "IJPP", 
          "BigNum,DEFAULT", 
          (funcptr_t) Parrot_BigNum_multi_is_equal_DEFAULT }
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "BigNum");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "BigNum")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "BigNum"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_BigNum_nci_version), "version");
        {
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_BigNum_class_init */
#line 1542 "./src/pmc/bignum.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
