/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/coroutine.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_coroutine.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "coroutine.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/coroutine.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: coroutine.pmc 37393 2009-03-13 19:56:52Z Util $

=head1 NAME

src/pmc/coroutine.pmc - Co-Routine PMC

=head1 DESCRIPTION

C<Coroutine> extends C<Continuation> to provide a subroutine that can
stop in the middle, and start back up later at the point at which it
stopped. See the L<Glossary|docs/glossary.pod> for more information.

=head2 Flags

=over 4

=item private0 call flip flop

=item private3 restore current sub after "flop".  Used by generators.

=back

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/oplib/ops.h"

static void
print_sub_name(PARROT_INTERP, PMC *sub_pmc)
{
    /* It's actually a Parrot_coro, but this avoids casting warnings. */
    Parrot_sub          *co;
    Interp      * const tracer = (interp->pdb && interp->pdb->debugger) ?
        interp->pdb->debugger :
        interp;

    GETATTR_Coroutine_sub(interp, sub_pmc, co);

    Parrot_io_eprintf(tracer, "# %s coro '%Ss'",
        !(PObj_get_FLAGS(sub_pmc) & SUB_FLAG_CORO_FF) ?
        "Calling" : "yielding from",
        Parrot_full_sub_name(interp, sub_pmc));

    if (co->ctx && (PObj_get_FLAGS(sub_pmc) & SUB_FLAG_CORO_FF)) {
        Parrot_io_eprintf(tracer, " to '%Ss'",
                Parrot_full_sub_name(interp,
                    co->ctx->caller_ctx->current_sub));
    }

    Parrot_io_eprintf(tracer, "\n# ");
    print_pbc_location(interp);
}
#line 83 "./src/pmc/coroutine.c"
PARROT_EXPORT  PMC  *
Parrot_Coroutine_clone(PARROT_INTERP, PMC *pmc)
{
#line 106 "./src/pmc/coroutine.pmc"

    Parrot_coro * const coro_sub = mem_allocate_typed(Parrot_coro);
    PMC         * const ret      = pmc_new(interp, pmc->vtable->base_type);
    Parrot_sub         *sub;

    PObj_custom_mark_destroy_SETALL(ret);

    SETATTR_Coroutine_sub(interp, ret, (Parrot_sub *)coro_sub);

    PMC_get_sub(interp, pmc, sub);
    memcpy(coro_sub, sub, sizeof (Parrot_coro));

    coro_sub->name      = Parrot_str_copy(interp, coro_sub->name);

    return ret;
#line 103 "./src/pmc/coroutine.c"
}
PARROT_EXPORT  void 
Parrot_Coroutine_destroy(PARROT_INTERP, PMC *pmc)
{
#line 96 "./src/pmc/coroutine.pmc"

    Parrot_Coroutine_attributes *attrs = PARROT_COROUTINE(pmc);
    Parrot_sub                  *sub   = attrs->sub;

    if (sub->ctx)
        Parrot_free_context(interp, sub->ctx, 1);

    Parrot_Sub_destroy(interp, pmc);
#line 117 "./src/pmc/coroutine.c"
}
PARROT_EXPORT  void 
Parrot_Coroutine_init(PARROT_INTERP, PMC *pmc)
{
#line 78 "./src/pmc/coroutine.pmc"

    Parrot_Coroutine_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_Coroutine_attributes);
    attrs->sub = (Parrot_sub*)new_coroutine(interp);
    PMC_data(pmc) = attrs;
    PObj_custom_mark_destroy_SETALL(pmc);
#line 129 "./src/pmc/coroutine.c"
}
PARROT_EXPORT  opcode_t  *
Parrot_Coroutine_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 133 "./src/pmc/coroutine.pmc"

    PackFile_ByteCode  *wanted_seg;
    Parrot_Coroutine_attributes *attrs = PARROT_COROUTINE(pmc);
    Parrot_coro * const co = (Parrot_coro*)attrs->sub;
    opcode_t    * dest     = co->address;

    if (Interp_trace_TEST(interp, PARROT_TRACE_SUB_CALL_FLAG))
        print_sub_name(interp, pmc);

    if (!co->ctx) {
        Parrot_Context *caller_ctx;
        Parrot_Context *ctx;
        PMC *ccont;

        /* RT#46699 factor out common code with Sub.invoke and inherit it */
        ccont = interp->current_cont;

        if (ccont == NEED_CONTINUATION)
            ccont = (PMC *)new_ret_continuation_pmc(interp,
                                                   (opcode_t *)next);

        if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL)
            Parrot_ex_throw_from_c_args(interp, NULL, CONTROL_ERROR,
                    "tail call to coro not allowed");

        /* first time set current sub, cont, object */
        caller_ctx = CONTEXT(interp);
        ctx        = Parrot_set_new_context(interp, co->n_regs_used);

        co->ctx                   = ctx;
        co->dynamic_state         = interp->dynamic_env;

        ctx->caller_ctx           = caller_ctx;
        PMC_cont(ccont)->from_ctx = ctx;
        ctx->current_sub          = pmc;
        ctx->current_HLL          = co->HLL_id;
        ctx->current_namespace    = co->namespace_stash;
        ctx->current_cont         = ccont;
        ctx->current_object       = NULL;
        interp->current_object    = NULL;
        interp->current_cont      = NULL;

        /* create pad if needed */
        if (!PMC_IS_NULL(co->lex_info)) {
            ctx->lex_pad = pmc_new_init(interp,
                    Parrot_get_ctx_HLL_type(interp, enum_class_LexPad),
                    co->lex_info);
            VTABLE_set_pointer(interp, ctx->lex_pad, ctx);
        }

        PObj_get_FLAGS(pmc) |= SUB_FLAG_CORO_FF;
        wanted_seg            = co->seg;
        co->caller_seg        = interp->code;
        co->address           = co->seg->base.data + co->start_offs;
    }

    /* if calling the Coro we need the segment of the Coro */
    else if (!(PObj_get_FLAGS(pmc) & SUB_FLAG_CORO_FF)) {
        PMC *ccont;
        Stack_Chunk_t    *state;
        Parrot_Context   *ctx;

        PObj_get_FLAGS(pmc) |= SUB_FLAG_CORO_FF;
        wanted_seg            = co->seg;

        /* remember segment of caller */
        co->caller_seg        = interp->code;
        ctx                   = co->ctx;

        /* and the recent call context */
        ccont                 = ctx->current_cont;
        ctx->caller_ctx       = PMC_cont(ccont)->to_ctx
                              = CONTEXT(interp);

        /* set context to coro context */
        state                 = interp->dynamic_env;
        interp->dynamic_env   = co->dynamic_state;
        co->dynamic_state     = state;
        CONTEXT(interp)       = ctx;
        interp->ctx.bp        = ctx->bp;
        interp->ctx.bp_ps     = ctx->bp_ps;
    }
    else {
        PMC *ccont;
        Stack_Chunk_t    *state;
        Parrot_Context   *ctx;

        PObj_get_FLAGS(pmc) &= ~SUB_FLAG_CORO_FF;
        /* switch back to last remembered code seg and context */

        wanted_seg            = co->caller_seg;
        ccont                 = co->ctx->current_cont;
        ctx                   = PMC_cont(ccont)->to_ctx;

        if (! ctx) {
            /* This still isn't quite right, but it beats segfaulting.  See
               the "Call an exited coroutine" case in t/pmc/coroutine.t; the
               problem is that the defunct coroutine yields up one more
               result before we get here.  -- rgr, 7-Oct-06.
            */
            Parrot_ex_throw_from_c_args(interp, NULL, CONTROL_ERROR,
                           "Cannot resume dead coroutine.");
        }

        state                = interp->dynamic_env;
        interp->dynamic_env  = co->dynamic_state;
        co->dynamic_state    = state;
        CONTEXT(interp)      = ctx;
        interp->ctx.bp       = ctx->bp;
        interp->ctx.bp_ps    = ctx->bp_ps;
    }

    /* toggle address */
    dest        = co->address;
    co->address = (opcode_t *)next;

    if (interp->code != wanted_seg)
        Parrot_switch_to_cs(interp, wanted_seg, 1);

    return dest;
#line 255 "./src/pmc/coroutine.c"
}
PARROT_EXPORT  void 
Parrot_Coroutine_mark(PARROT_INTERP, PMC *pmc)
{
#line 265 "./src/pmc/coroutine.pmc"

    Parrot_Coroutine_attributes *attrs = PARROT_COROUTINE(pmc);
    Parrot_coro * const co = (Parrot_coro *)attrs->sub;

    if (co) {
        if (co->ctx)
            mark_context(interp, co->ctx);
        if (co->dynamic_state)
            mark_stack(interp, co->dynamic_state);

    }

    Parrot_Sub_mark(interp, pmc);
#line 274 "./src/pmc/coroutine.c"
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  PMC *
Parrot_Coroutine_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Coroutine");
}
PARROT_EXPORT  FLOATVAL
Parrot_Coroutine_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Coroutine");
}
PARROT_EXPORT  INTVAL
Parrot_Coroutine_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Coroutine");
}
PARROT_EXPORT  PMC *
Parrot_Coroutine_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Coroutine");
}
PARROT_EXPORT  STRING *
Parrot_Coroutine_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Coroutine");
}
PARROT_EXPORT  FLOATVAL
Parrot_Coroutine_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Coroutine");
}
PARROT_EXPORT  INTVAL
Parrot_Coroutine_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Coroutine");
}
PARROT_EXPORT  PMC *
Parrot_Coroutine_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Coroutine");
}
PARROT_EXPORT  STRING *
Parrot_Coroutine_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Coroutine");
}
PARROT_EXPORT  void
Parrot_Coroutine_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Coroutine");
}
#include "pmc_default.h"
void
Parrot_Coroutine_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":sub ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Coroutine, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_Sub_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Coroutine_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Coroutine_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Sub_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Sub_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_Coroutine_init,
        Parrot_default_init_pmc,
        Parrot_Sub_inspect,
        Parrot_Sub_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_Coroutine_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Coroutine_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Sub_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Sub_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Sub_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Sub_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Sub_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Coroutine, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Coroutine_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Coroutine_ro_add_method,
        Parrot_Coroutine_ro_add_parent,
        Parrot_Coroutine_ro_add_role,
        Parrot_Coroutine_ro_add_vtable_override,
        Parrot_Coroutine_ro_assign_pmc,
        Parrot_Coroutine_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Coroutine_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Coroutine_ro_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Coroutine_ro_delete_keyed,
        Parrot_Coroutine_ro_delete_keyed_int,
        Parrot_Coroutine_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Coroutine_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Coroutine_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Sub_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Sub_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Coroutine_ro_i_absolute,
        Parrot_Coroutine_ro_i_add,
        Parrot_Coroutine_ro_i_add_float,
        Parrot_Coroutine_ro_i_add_int,
        Parrot_Coroutine_ro_i_bitwise_and,
        Parrot_Coroutine_ro_i_bitwise_and_int,
        Parrot_Coroutine_ro_i_bitwise_ands,
        Parrot_Coroutine_ro_i_bitwise_ands_str,
        Parrot_Coroutine_ro_i_bitwise_lsr,
        Parrot_Coroutine_ro_i_bitwise_lsr_int,
        Parrot_Coroutine_ro_i_bitwise_not,
        Parrot_Coroutine_ro_i_bitwise_nots,
        Parrot_Coroutine_ro_i_bitwise_or,
        Parrot_Coroutine_ro_i_bitwise_or_int,
        Parrot_Coroutine_ro_i_bitwise_ors,
        Parrot_Coroutine_ro_i_bitwise_ors_str,
        Parrot_Coroutine_ro_i_bitwise_shl,
        Parrot_Coroutine_ro_i_bitwise_shl_int,
        Parrot_Coroutine_ro_i_bitwise_shr,
        Parrot_Coroutine_ro_i_bitwise_shr_int,
        Parrot_Coroutine_ro_i_bitwise_xor,
        Parrot_Coroutine_ro_i_bitwise_xor_int,
        Parrot_Coroutine_ro_i_bitwise_xors,
        Parrot_Coroutine_ro_i_bitwise_xors_str,
        Parrot_Coroutine_ro_i_concatenate,
        Parrot_Coroutine_ro_i_concatenate_str,
        Parrot_Coroutine_ro_i_divide,
        Parrot_Coroutine_ro_i_divide_float,
        Parrot_Coroutine_ro_i_divide_int,
        Parrot_Coroutine_ro_i_floor_divide,
        Parrot_Coroutine_ro_i_floor_divide_float,
        Parrot_Coroutine_ro_i_floor_divide_int,
        Parrot_Coroutine_ro_i_logical_not,
        Parrot_Coroutine_ro_i_modulus,
        Parrot_Coroutine_ro_i_modulus_float,
        Parrot_Coroutine_ro_i_modulus_int,
        Parrot_Coroutine_ro_i_multiply,
        Parrot_Coroutine_ro_i_multiply_float,
        Parrot_Coroutine_ro_i_multiply_int,
        Parrot_Coroutine_ro_i_neg,
        Parrot_Coroutine_ro_i_pow,
        Parrot_Coroutine_ro_i_pow_float,
        Parrot_Coroutine_ro_i_pow_int,
        Parrot_Coroutine_ro_i_repeat,
        Parrot_Coroutine_ro_i_repeat_int,
        Parrot_Coroutine_ro_i_subtract,
        Parrot_Coroutine_ro_i_subtract_float,
        Parrot_Coroutine_ro_i_subtract_int,
        Parrot_Coroutine_ro_increment,
        Parrot_Coroutine_init,
        Parrot_default_init_pmc,
        Parrot_Sub_inspect,
        Parrot_Sub_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_Coroutine_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Coroutine_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_Coroutine_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Coroutine_ro_pop_float,
        Parrot_Coroutine_ro_pop_integer,
        Parrot_Coroutine_ro_pop_pmc,
        Parrot_Coroutine_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Coroutine_ro_push_float,
        Parrot_Coroutine_ro_push_integer,
        Parrot_Coroutine_ro_push_pmc,
        Parrot_Coroutine_ro_push_string,
        Parrot_Coroutine_ro_remove_attribute,
        Parrot_Coroutine_ro_remove_method,
        Parrot_Coroutine_ro_remove_parent,
        Parrot_Coroutine_ro_remove_role,
        Parrot_Coroutine_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_Coroutine_ro_set_attr_keyed,
        Parrot_Coroutine_ro_set_attr_str,
        Parrot_Coroutine_ro_set_bignum_int,
        Parrot_Coroutine_ro_set_bignum_num,
        Parrot_Coroutine_ro_set_bignum_str,
        Parrot_Coroutine_ro_set_bool,
        Parrot_Coroutine_ro_set_integer_keyed,
        Parrot_Coroutine_ro_set_integer_keyed_int,
        Parrot_Coroutine_ro_set_integer_keyed_str,
        Parrot_Coroutine_ro_set_integer_native,
        Parrot_Coroutine_ro_set_integer_same,
        Parrot_Coroutine_ro_set_number_keyed,
        Parrot_Coroutine_ro_set_number_keyed_int,
        Parrot_Coroutine_ro_set_number_keyed_str,
        Parrot_Coroutine_ro_set_number_native,
        Parrot_Coroutine_ro_set_number_same,
        Parrot_Coroutine_ro_set_pmc,
        Parrot_Coroutine_ro_set_pmc_keyed,
        Parrot_Coroutine_ro_set_pmc_keyed_int,
        Parrot_Coroutine_ro_set_pmc_keyed_str,
        Parrot_Coroutine_ro_set_pointer,
        Parrot_Coroutine_ro_set_pointer_keyed,
        Parrot_Coroutine_ro_set_pointer_keyed_int,
        Parrot_Coroutine_ro_set_pointer_keyed_str,
        Parrot_Coroutine_ro_set_string_keyed,
        Parrot_Coroutine_ro_set_string_keyed_int,
        Parrot_Coroutine_ro_set_string_keyed_str,
        Parrot_Coroutine_ro_set_string_native,
        Parrot_Coroutine_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Coroutine_ro_shift_float,
        Parrot_Coroutine_ro_shift_integer,
        Parrot_Coroutine_ro_shift_pmc,
        Parrot_Coroutine_ro_shift_string,
        Parrot_default_slice,
        Parrot_Coroutine_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Coroutine_ro_thaw,
        Parrot_Coroutine_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Coroutine_ro_unshift_float,
        Parrot_Coroutine_ro_unshift_integer,
        Parrot_Coroutine_ro_unshift_pmc,
        Parrot_Coroutine_ro_unshift_string,
        Parrot_Sub_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Coroutine");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Coroutine")), PMCNULL);
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Sub")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Coroutine"));
            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Sub"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_Coroutine_class_init */
#line 278 "./src/pmc/coroutine.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
