/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/default.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_default.h"
#include "pmc_default.h"
#include "default.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/default.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: default.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/default.pmc - Abstract root class

=head1 DESCRIPTION

These are the vtable functions for the default PMC class.

All methods which are not defined here get a default implementation
generated from F<src/vtable.tbl> by F<tools/build/pmc2c.pl>.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#define INT2KEY(i, k) key_new_integer((i), (k))

/* undef 'interface' to keep MSVC happy */
#undef interface

/*

=item C<static STRING *caller(PARROT_INTERP, PMC *pmc)>

Returns a C string for the name of C<*pmc>.

=cut

*/

static STRING *
caller(PARROT_INTERP, PMC *pmc /*NULLOK*/)
{
    STRING * const null_str = CONST_STRING(interp, "(null)");

    return pmc && pmc->vtable && pmc->vtable->whoami
                ? VTABLE_name(interp, pmc) : null_str;
}

/*

=item C<static void cant_do_method(PARROT_INTERP, PMC *pmc,
                                   const char *methname)>

Throws an exception "$methname() not implemented in class '$class'", used by
all unimplemented messages.

=cut

*/

static void
cant_do_method(PARROT_INTERP, PMC *pmc /*NULLOK*/, const char *methname)
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ILL_INHERIT,
            "%s() not implemented in class '%Ss'", methname,
            caller(interp, pmc));
}

/*

=item C<static INTVAL
check_set_std_props(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)>

Called from C<setprop()>.

Returns a true value if C<setprop()> can avoid actually setting a property
in the prophash. If it returns true, the property setting will be reflected
in a future call to C<propagate_std_props()>

=cut

*/

static INTVAL
check_set_std_props(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    /* the quick hack below cannot be used because the string could
       be constructed in an interpreter that is later destroyed */
#if  0
    /* RT #46659
     * a quick hack, to prevent freeing that string during GC
     * triggered in t/pmc/pmc_62.t when configured with --gc=libc
     */
    static STRING *ro;
    if (!ro)
        ro = string_make(interp, "_ro", 3, "ascii",
            PObj_constant_FLAG|PObj_external_FLAG);
    if (!Parrot_str_compare(interp, key, ro)) {
#else

    /*
     * s2 in Parrot_str_compare is freed here
     */
    if (!Parrot_str_compare(interp, key, CONST_STRING(interp, "_ro"))) {
#endif
        /* pmc should set/clear readonly */
        const INTVAL on = VTABLE_get_bool(interp, value);

        /* morph to Const/normal class or readonly class */
        /* RT #46661 warn when this fails? */
        if (on && (pmc->vtable->flags & VTABLE_HAS_CONST_TOO))
            pmc->vtable = interp->vtables[pmc->vtable->base_type + 1];
        else if (!on && (pmc->vtable->flags & (VTABLE_IS_CONST_FLAG)))
            VTABLE_morph(interp, pmc, interp->vtables[pmc->vtable->base_type - 1]->pmc_class);
        else if (on && (pmc->vtable->flags & VTABLE_HAS_READONLY_FLAG))
            pmc->vtable = pmc->vtable->ro_variant_vtable;
        else if (!on && (pmc->vtable->flags & VTABLE_IS_READONLY_FLAG)
                && pmc->vtable->ro_variant_vtable)
            pmc->vtable = pmc->vtable->ro_variant_vtable;
        else
            return 0;

        return 1;
    }

    return 0;
}

/*

=item C<static void
propagate_std_props(PARROT_INTERP, PMC *self, PMC *prop_hash)>

Set pending standard properties in C<prop_hash>.

=cut

*/

static void
propagate_std_props(PARROT_INTERP, PMC *self, PMC *prop_hash) {
    if (self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG)){
        PMC * const pmc_true  = pmc_new(interp, enum_class_Integer);
        PMC_int_val(pmc_true) = 1;
        VTABLE_set_pmc_keyed_str(interp, prop_hash, CONST_STRING(interp, "_ro"), pmc_true);
    }
}

/*

=item C<static INTVAL
has_pending_std_props(PMC *self)>

Returns true if propagate_std_props() would create a non-empty prophash.

=cut

*/

static INTVAL
has_pending_std_props(PMC *self) {
    if (self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG))
        return 1;
    else
        return 0;
}


/*

=item C<static PMC*
check_get_std_props(PARROT_INTERPeter, PMC *self, STRING *key)>

Checks if we can infer the value of C<key> property from C<self> without
looking at its prophash. Returns C<PMCNULL> if not, returns the value otherwise.

=cut
*/

static PMC*
check_get_std_props(PARROT_INTERP, PMC *self, STRING *key) {
    if ((self->vtable->flags & (VTABLE_IS_CONST_FLAG | VTABLE_IS_READONLY_FLAG))
        &&!Parrot_str_compare(interp, key, CONST_STRING(interp, "_ro"))) {
        PMC * const ret_val  = pmc_new(interp, enum_class_Integer);
        PMC_int_val(ret_val) = 1;
        return ret_val;
    }
    else
        return PMCNULL;
}

/*

=item C<static PMC *
make_prop_hash(PARROT_INTERP, PMC *self)>

Create a property hash for C<self>. Returns the created hash. Inferred
properties will be added to the hash and it will be set as
C<PMC_metadata(self)>.

=cut

*/

static PMC*
make_prop_hash(PARROT_INTERP, PMC *self) {
    PMC *prop;

    if (!self->pmc_ext)
        add_pmc_ext(interp, self);

    PMC_metadata(self) = prop = pmc_new_noinit(interp, enum_class_Hash);
    GC_WRITE_BARRIER(interp, self, NULL, prop);
    VTABLE_init(interp, prop);
    propagate_std_props(interp, self, prop);
    return prop;
}

/*

=item C<static INTVAL
does_isa(PARROT_INTERP, STRING *method, STRING *what)>

Compares C<*method> and C<*what>.
Returns true (1) if B<method> is found in B<what>, false (0) otherwise.

=cut

*/

static INTVAL
does_isa(PARROT_INTERP, const STRING *method, const STRING *what)
{
    INTVAL  pos    = 0;
    INTVAL  length = Parrot_str_byte_length(interp, what);

    do {
        INTVAL len;
        INTVAL idx = Parrot_str_find_index(interp, what, method, (INTVAL)pos);

        if (idx < 0)
            return 0;

        pos = idx;

        if (pos >= length)
            return 0;

        len = Parrot_str_byte_length(interp, method);

        if (pos && Parrot_str_indexed(interp, what, pos - 1) != 32) {
            pos += len;
            continue;
        }

        if (pos + len < length && Parrot_str_indexed(interp, what, pos + len) != 32) {
            pos += len;
            continue;
        }

        return 1;
    } while (1);
}
#line 286 "./src/pmc/default.c"
PARROT_EXPORT  PMC *
Parrot_default_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    cant_do_method(interp, pmc, "absolute");
    return PMCNULL;
}
PARROT_EXPORT  PMC  *
Parrot_default_add(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1182 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "add", "PPP->P", pmc, value, dest, &result);
    return result;
#line 302 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
    cant_do_method(interp, pmc, "add_attribute");
    
}
PARROT_EXPORT  PMC  *
Parrot_default_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1216 "./src/pmc/default.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) + value);
    return dest;
#line 320 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1199 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "add_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 331 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_add_method(PARROT_INTERP, PMC *pmc, STRING *method_name, PMC *sub_pmc)
{
#line 485 "./src/pmc/default.pmc"

    VTABLE_set_pmc_keyed_str(interp, pmc->vtable->_namespace,
                             method_name, sub_pmc);
#line 340 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
#line 1071 "./src/pmc/default.pmc"

    if (!PObj_is_class_TEST(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "Only classes can be subclassed");

    Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "All classes should override add_parent");
#line 353 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    cant_do_method(interp, pmc, "add_role");
    
}
PARROT_EXPORT  void
Parrot_default_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name, PMC *sub_pmc)
{
    cant_do_method(interp, pmc, "add_vtable_override");
    
}
PARROT_EXPORT  void 
Parrot_default_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 612 "./src/pmc/default.pmc"

    STRING * const undef = CONST_STRING(interp, "Undef");

    if (VTABLE_isa(interp, value, undef))
        pmc_reuse(interp, pmc, value->vtable->base_type, 0);
    else
        VTABLE_set_pmc(interp, pmc, value);
#line 378 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_assign_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 621 "./src/pmc/default.pmc"

    VTABLE_set_string_native(interp, pmc, value);
#line 386 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1919 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_and", "PPP->P", pmc, value, dest, &result);
    return result;
#line 397 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1936 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_and_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 408 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2111 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_ands", "PPP->P", pmc, value, dest, &result);
    return result;
#line 419 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
#line 2128 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_ands_str", "PSP->P", pmc, value, dest, &result);
    return result;
#line 430 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2367 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_lsr", "PPP->P", pmc, value, dest, &result);
    return result;
#line 441 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 2384 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_lsr_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 452 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC *
Parrot_default_bitwise_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_not");
    return PMCNULL;
}
PARROT_EXPORT  PMC *
Parrot_default_bitwise_nots(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    cant_do_method(interp, pmc, "bitwise_nots");
    return PMCNULL;
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1855 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_or", "PPP->P", pmc, value, dest, &result);
    return result;
#line 475 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1872 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_or_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 486 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2047 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_ors", "PPP->P", pmc, value, dest, &result);
    return result;
#line 497 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
#line 2064 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_ors_str", "PSP->P", pmc, value, dest, &result);
    return result;
#line 508 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2239 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_shl", "PPP->P", pmc, value, dest, &result);
    return result;
#line 519 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 2256 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_shl_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 530 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2303 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_shr", "PPP->P", pmc, value, dest, &result);
    return result;
#line 541 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 2320 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_shr_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 552 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1983 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_xor", "PPP->P", pmc, value, dest, &result);
    return result;
#line 563 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 2000 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_xor_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 574 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2175 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_xors", "PPP->P", pmc, value, dest, &result);
    return result;
#line 585 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
#line 2192 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "bitwise_xors_str", "PSP->P", pmc, value, dest, &result);
    return result;
#line 596 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL 
Parrot_default_can(PARROT_INTERP, PMC *pmc, STRING *method)
{
#line 862 "./src/pmc/default.pmc"

    return !PMC_IS_NULL(VTABLE_find_method(interp, pmc, method));
#line 604 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC* 
Parrot_default_clone(PARROT_INTERP, PMC *pmc)
{
#line 1115 "./src/pmc/default.pmc"

    return Parrot_thaw(interp, Parrot_freeze(interp, pmc));
#line 612 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC *
Parrot_default_clone_pmc(PARROT_INTERP, PMC *pmc, PMC *args)
{
    cant_do_method(interp, pmc, "clone_pmc");
    return PMCNULL;
}
PARROT_EXPORT  INTVAL 
Parrot_default_cmp(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2431 "./src/pmc/default.pmc"

    INTVAL retval;

    /* Don't multidispatch if you've got two pointers to the same PMC. They
     * are equal. */
    if (pmc == value)
        return 0;

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp", "PP->I", pmc, value, &retval);

    return retval;
#line 636 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL 
Parrot_default_cmp_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2455 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp_num", "PP->I", pmc, value, &retval);

    return retval;
#line 648 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_cmp_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2491 "./src/pmc/default.pmc"

    PMC *retval;

    /* Don't multidispatch if you've got two pointers to the same PMC. They
     * are equal. */
    if (pmc == value)
        return 0;

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp_pmc", "PP->P", pmc, value, &retval);

    return retval;
#line 666 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL 
Parrot_default_cmp_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2473 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "cmp_string", "PP->I", pmc, value, &retval);

    return retval;
#line 678 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_concatenate(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2565 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "concatenate", "PPP->P", pmc, value, dest, &result);
    return result;
#line 689 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
#line 2582 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "concatenate_str", "PSP->P", pmc, value, dest, &result);
    return result;
#line 700 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_decrement(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "decrement");
    
}
PARROT_EXPORT  INTVAL 
Parrot_default_defined(PARROT_INTERP, PMC *pmc)
{
#line 799 "./src/pmc/default.pmc"

    return 1;
#line 714 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL
Parrot_default_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "defined_keyed");
    return (INTVAL)0;
}
PARROT_EXPORT  INTVAL 
Parrot_default_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 814 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_defined_keyed(interp, pmc, r_key);
#line 729 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL
Parrot_default_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "defined_keyed_str");
    return (INTVAL)0;
}
PARROT_EXPORT  void
Parrot_default_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "delete_keyed");
    
}
PARROT_EXPORT  void 
Parrot_default_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 829 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_delete_keyed(interp, pmc, r_key);
#line 750 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "delete_keyed_str");
    
}
PARROT_EXPORT  void 
Parrot_default_delprop(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 399 "./src/pmc/default.pmc"

    if (pmc->pmc_ext && PMC_metadata(pmc))
        VTABLE_delete_keyed_str(interp, PMC_metadata(pmc), key);
#line 765 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_destroy(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "destroy");
    
}
PARROT_EXPORT  PMC  *
Parrot_default_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1471 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "divide", "PPP->P", pmc, value, dest, &result);
    return result;
#line 782 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1505 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "divide_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 793 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1488 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "divide_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 804 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL 
Parrot_default_does(PARROT_INTERP, PMC *pmc, STRING *_interface)
{
#line 878 "./src/pmc/default.pmc"

    return does_isa(interp, _interface, pmc->vtable->provides_str);
#line 812 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL 
Parrot_default_does_pmc(PARROT_INTERP, PMC *pmc, PMC *role)
{
#line 892 "./src/pmc/default.pmc"

    /* No C-level roles yet. */
    return 0;
#line 821 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL
Parrot_default_elements(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "elements");
    return (INTVAL)0;
}
PARROT_EXPORT  INTVAL
Parrot_default_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "exists_keyed");
    return (INTVAL)0;
}
PARROT_EXPORT  INTVAL 
Parrot_default_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 784 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_exists_keyed(interp, pmc, r_key);
#line 842 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL
Parrot_default_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "exists_keyed_str");
    return (INTVAL)0;
}
PARROT_EXPORT  PMC  *
Parrot_default_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
#line 481 "./src/pmc/default.pmc"

    return Parrot_find_method_with_cache(interp, pmc, method_name);
#line 856 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1567 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "floor_divide", "PPP->P", pmc, value, dest, &result);
    return result;
#line 867 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1601 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "floor_divide_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 878 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1584 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "floor_divide_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 889 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1129 "./src/pmc/default.pmc"

    /* default - no action */
#line 897 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_get_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name)
{
#line 1053 "./src/pmc/default.pmc"

    return VTABLE_get_attr_str(interp, pmc, name);
#line 905 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 1012 "./src/pmc/default.pmc"

    PMC *p = VTABLE_find_method(interp, pmc, name);

    if (PMC_IS_NULL(p))
        return PMCNULL;

    if (VTABLE_isa(interp, p, CONST_STRING(interp, "NCI"))) {
        PMC * const bound_meth = VTABLE_clone(interp, p);
        bound_meth->vtable     = interp->vtables[enum_class_Bound_NCI];
        VTABLE_set_pmc(interp, bound_meth, pmc);

        return bound_meth;
    }
    else if (p->vtable->base_type == enum_class_MultiSub) {
        PMC * const bound_meth      = pmc_new(interp, enum_class_Bound_NCI);
        VTABLE_set_pmc(interp, bound_meth, pmc);
        PMC_struct_val(bound_meth)  = p;
        PObj_get_FLAGS(bound_meth) |= PObj_private0_FLAG;

        return bound_meth;
    }

    /* RT #46671 bound user functions */
    return p;
#line 935 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC *
Parrot_default_get_bignum(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_bignum");
    return PMCNULL;
}
PARROT_EXPORT  INTVAL
Parrot_default_get_bool(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_bool");
    return (INTVAL)0;
}
PARROT_EXPORT  PMC  *
Parrot_default_get_class(PARROT_INTERP, PMC *pmc)
{
#line 994 "./src/pmc/default.pmc"

    PMC *ns     = VTABLE_get_namespace(interp, pmc);
    PMC *_class = PMCNULL;

    if (!PMC_IS_NULL(ns))
        _class = VTABLE_get_class(interp, ns);

    if (PMC_IS_NULL(_class)) {
        INTVAL type      = VTABLE_type(interp, pmc);
        PMC   *type_num  = pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, type_num, type);
        return pmc_new_init(interp, enum_class_PMCProxy, type_num);
    }

    return _class;

#line 969 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL
Parrot_default_get_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_integer");
    return (INTVAL)0;
}
PARROT_EXPORT  INTVAL
Parrot_default_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "get_integer_keyed");
    return (INTVAL)0;
}
PARROT_EXPORT  INTVAL 
Parrot_default_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 500 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_integer_keyed(interp, pmc, r_key);
#line 990 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL
Parrot_default_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "get_integer_keyed_str");
    return (INTVAL)0;
}
PARROT_EXPORT  PMC *
Parrot_default_get_iter(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_iter");
    return PMCNULL;
}
PARROT_EXPORT  PMC  *
Parrot_default_get_namespace(PARROT_INTERP, PMC *pmc)
{
#line 476 "./src/pmc/default.pmc"

    return pmc->vtable->_namespace;
#line 1010 "./src/pmc/default.c"
}
PARROT_EXPORT  FLOATVAL
Parrot_default_get_number(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_number");
    return (FLOATVAL)0;
}
PARROT_EXPORT  FLOATVAL
Parrot_default_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "get_number_keyed");
    return (FLOATVAL)0;
}
PARROT_EXPORT  FLOATVAL 
Parrot_default_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 516 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_number_keyed(interp, pmc, r_key);
#line 1031 "./src/pmc/default.c"
}
PARROT_EXPORT  FLOATVAL
Parrot_default_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "get_number_keyed_str");
    return (FLOATVAL)0;
}
PARROT_EXPORT  PMC *
Parrot_default_get_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_pmc");
    return PMCNULL;
}
PARROT_EXPORT  PMC *
Parrot_default_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "get_pmc_keyed");
    return PMCNULL;
}
PARROT_EXPORT  PMC  *
Parrot_default_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 566 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_pmc_keyed(interp, pmc, r_key);
#line 1058 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC *
Parrot_default_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "get_pmc_keyed_str");
    return PMCNULL;
}
PARROT_EXPORT  void  *
Parrot_default_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 581 "./src/pmc/default.pmc"

    return pmc;
#line 1072 "./src/pmc/default.c"
}
PARROT_EXPORT  void *
Parrot_default_get_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "get_pointer_keyed");
    return (void*)0;
}
PARROT_EXPORT  void *
Parrot_default_get_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
    cant_do_method(interp, pmc, "get_pointer_keyed_int");
    return (void*)0;
}
PARROT_EXPORT  void *
Parrot_default_get_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "get_pointer_keyed_str");
    return (void*)0;
}
PARROT_EXPORT  STRING *
Parrot_default_get_repr(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_repr");
    return (STRING*)0;
}
PARROT_EXPORT  STRING *
Parrot_default_get_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "get_string");
    return (STRING*)0;
}
PARROT_EXPORT  STRING *
Parrot_default_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "get_string_keyed");
    return (STRING*)0;
}
PARROT_EXPORT  STRING  *
Parrot_default_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 533 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_get_string_keyed(interp, pmc, r_key);
#line 1117 "./src/pmc/default.c"
}
PARROT_EXPORT  STRING *
Parrot_default_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
    cant_do_method(interp, pmc, "get_string_keyed_str");
    return (STRING*)0;
}
PARROT_EXPORT  PMC  *
Parrot_default_getprop(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 357 "./src/pmc/default.pmc"

    if (pmc->pmc_ext && PMC_metadata(pmc))
        return VTABLE_get_pmc_keyed_str(interp, PMC_metadata(pmc), key);
    else
        return check_get_std_props(interp, pmc, key);
#line 1134 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_getprops(PARROT_INTERP, PMC *pmc)
{
#line 414 "./src/pmc/default.pmc"

    if (!pmc->pmc_ext)
        add_pmc_ext(interp, pmc);

    if (!PMC_metadata(pmc)) {
        if (has_pending_std_props(pmc))
            return make_prop_hash(interp, pmc);
        else
            return PMCNULL;
    }

    return PMC_metadata(pmc);
#line 1152 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_i_absolute(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_absolute");
    
}
PARROT_EXPORT  void 
Parrot_default_i_add(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1234 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_add", "PP", pmc, value);
#line 1167 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1264 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_add_float", "PN", pmc, value);
#line 1176 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1249 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_add_int", "PI", pmc, value);
#line 1185 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1953 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_and", "PP", pmc, value);
#line 1194 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1968 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_and_int", "PI", pmc, value);
#line 1203 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_ands(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2145 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_ands", "PP", pmc, value);
#line 1212 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_ands_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 2160 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_ands_str", "PS", pmc, value);
#line 1221 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2401 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_lsr", "PP", pmc, value);
#line 1230 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 2416 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_lsr_int", "PI", pmc, value);
#line 1239 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_bitwise_not");
    
}
PARROT_EXPORT  void
Parrot_default_i_bitwise_nots(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_bitwise_nots");
    
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1889 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_or", "PP", pmc, value);
#line 1260 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1904 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_or_int", "PI", pmc, value);
#line 1269 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_ors(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2081 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_ors", "PP", pmc, value);
#line 1278 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_ors_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 2096 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_ors_str", "PS", pmc, value);
#line 1287 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2273 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_shl", "PP", pmc, value);
#line 1296 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 2288 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_shl_int", "PI", pmc, value);
#line 1305 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2337 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_shr", "PP", pmc, value);
#line 1314 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 2352 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_shr_int", "PI", pmc, value);
#line 1323 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2017 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_xor", "PP", pmc, value);
#line 1332 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 2032 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_xor_int", "PI", pmc, value);
#line 1341 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_xors(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2209 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_xors", "PP", pmc, value);
#line 1350 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_bitwise_xors_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 2224 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_bitwise_xors_str", "PS", pmc, value);
#line 1359 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2599 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_concatenate", "PP", pmc, value);
#line 1368 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 2614 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_concatenate_str", "PS", pmc, value);
#line 1377 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1522 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_divide", "PP", pmc, value);
#line 1386 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1552 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_divide_float", "PN", pmc, value);
#line 1395 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1537 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_divide_int", "PI", pmc, value);
#line 1404 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1618 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_floor_divide", "PP", pmc, value);
#line 1413 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1648 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_floor_divide_float", "PN", pmc, value);
#line 1422 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1633 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_floor_divide_int", "PI", pmc, value);
#line 1431 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_i_logical_not(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_logical_not");
    
}
PARROT_EXPORT  void 
Parrot_default_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1714 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_modulus", "PP", pmc, value);
#line 1446 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1744 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_modulus_float", "PN", pmc, value);
#line 1455 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1729 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_modulus_int", "PI", pmc, value);
#line 1464 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_multiply(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1426 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_multiply", "PP", pmc, value);
#line 1473 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1456 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_multiply_float", "PN", pmc, value);
#line 1482 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1441 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_multiply_int", "PI", pmc, value);
#line 1491 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_i_neg(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "i_neg");
    
}
PARROT_EXPORT  void 
Parrot_default_i_pow(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1810 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_pow", "PP", pmc, value);
#line 1506 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1840 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_pow_float", "PN", pmc, value);
#line 1515 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1825 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_pow_int", "PI", pmc, value);
#line 1524 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 2663 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_repeat", "PP", pmc, value);
#line 1533 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 2678 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_repeat_int", "PI", pmc, value);
#line 1542 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_subtract(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1330 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_subtract", "PP", pmc, value);
#line 1551 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1360 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_subtract_float", "PN", pmc, value);
#line 1560 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1345 "./src/pmc/default.pmc"

    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "i_subtract_int", "PI", pmc, value);
#line 1569 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_increment(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "increment");
    
}
PARROT_EXPORT  void 
Parrot_default_init(PARROT_INTERP, PMC *pmc)
{
#line 284 "./src/pmc/default.pmc"

#line 1582 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_init_pmc(PARROT_INTERP, PMC *pmc, PMC *initializer)
{
#line 297 "./src/pmc/default.pmc"

    if (PMC_IS_NULL(initializer))
        VTABLE_init(interp, pmc);
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ILL_INHERIT,
            "init_pmc() not implemented in class '%Ss'",
            caller(interp, pmc));
#line 1595 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_inspect(PARROT_INTERP, PMC *pmc)
{
#line 971 "./src/pmc/default.pmc"

    PMC    *metadata           = pmc_new(interp, enum_class_Hash);
    STRING * const flags_str   = CONST_STRING(interp, "flags");

    VTABLE_set_pmc_keyed_str(interp, metadata, flags_str,
        VTABLE_inspect_str(interp, pmc, flags_str));

    return metadata;
#line 1609 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_inspect_str(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 946 "./src/pmc/default.pmc"

    if (Parrot_str_equal(interp, name, CONST_STRING(interp, "flags"))) {
        PMC *found = pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, found,
                (INTVAL)PObj_get_FLAGS(pmc));
        return found;
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "mro"))) {
        return VTABLE_clone(interp, pmc->vtable->mro);
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unknown introspection value '%S'", name);
#line 1628 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_instantiate(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 317 "./src/pmc/default.pmc"

    const INTVAL type = VTABLE_type(interp, pmc);

    /* Ensure no looping, as pmc_new calls the instantiate vtable entry for
     * classes. */
    if (PObj_is_class_TEST(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
                "All high-level classes should override instantiate");

    if (!PMC_IS_NULL(init))
        return pmc_new_init(interp, type, init);

    return pmc_new(interp, type);
#line 1647 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC *
Parrot_default_instantiate_str(PARROT_INTERP, PMC *pmc, STRING *rep, INTVAL flags)
{
    cant_do_method(interp, pmc, "instantiate_str");
    return PMCNULL;
}
PARROT_EXPORT  opcode_t *
Parrot_default_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
    cant_do_method(interp, pmc, "invoke");
    return (opcode_t*)0;
}
PARROT_EXPORT  INTVAL 
Parrot_default_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 729 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "is_equal", "PP->I", pmc, value, &retval);

    return retval;
#line 1671 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL 
Parrot_default_is_equal_num(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 747 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "is_equal_num", "PP->I", pmc, value, &retval);

    return retval;
#line 1683 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL 
Parrot_default_is_equal_string(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 765 "./src/pmc/default.pmc"

    INTVAL retval;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "is_equal_string", "PP->I", pmc, value, &retval);

    return retval;
#line 1695 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL 
Parrot_default_is_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 596 "./src/pmc/default.pmc"

    return pmc == value;
#line 1703 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL 
Parrot_default_isa(PARROT_INTERP, PMC *pmc, STRING *_class)
{
#line 930 "./src/pmc/default.pmc"

    /* RT #46665 - walk mro */
    return parrot_hash_exists(interp, pmc->vtable->isa_hash,
                (void *)_class);
#line 1713 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL 
Parrot_default_isa_pmc(PARROT_INTERP, PMC *pmc, PMC *lookup)
{
#line 909 "./src/pmc/default.pmc"

    if (PMC_IS_NULL(lookup))
        return 0;

    /* RT #46665 - walk mro */
    return parrot_hash_exists(interp, pmc->vtable->isa_hash,
            (void *)VTABLE_get_string(interp, lookup));
#line 1726 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_logical_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2531 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "logical_and", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1737 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC *
Parrot_default_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    cant_do_method(interp, pmc, "logical_not");
    return PMCNULL;
}
PARROT_EXPORT  PMC  *
Parrot_default_logical_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2514 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "logical_or", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1754 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2548 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "logical_xor", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1765 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_mark(PARROT_INTERP, PMC *pmc)
{
#line 342 "./src/pmc/default.pmc"

    PANIC(interp, "custom_mark flag set but no custom mark routine defined");
#line 1773 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_modulus(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1663 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "modulus", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1784 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1697 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "modulus_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 1795 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1680 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "modulus_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 1806 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_morph(PARROT_INTERP, PMC *pmc, PMC *type)
{
#line 635 "./src/pmc/default.pmc"

    pmc_reuse(interp, pmc, VTABLE_get_integer(interp, type), 0);
#line 1814 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_multiply(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1375 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "multiply", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1825 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1409 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "multiply_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 1836 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1392 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "multiply_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 1847 "./src/pmc/default.c"
}
PARROT_EXPORT  STRING  *
Parrot_default_name(PARROT_INTERP, PMC *pmc)
{
#line 452 "./src/pmc/default.pmc"

    return pmc->vtable->whoami;
#line 1855 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC *
Parrot_default_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
    cant_do_method(interp, pmc, "neg");
    return PMCNULL;
}
PARROT_EXPORT  PMC *
Parrot_default_nextkey_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL what)
{
    cant_do_method(interp, pmc, "nextkey_keyed");
    return PMCNULL;
}
PARROT_EXPORT  PMC  *
Parrot_default_nextkey_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL w)
{
#line 845 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    return VTABLE_nextkey_keyed(interp, pmc, r_key, w);
#line 1876 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC *
Parrot_default_nextkey_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL what)
{
    cant_do_method(interp, pmc, "nextkey_keyed_str");
    return PMCNULL;
}
PARROT_EXPORT  FLOATVAL
Parrot_default_pop_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_float");
    return (FLOATVAL)0;
}
PARROT_EXPORT  INTVAL
Parrot_default_pop_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_integer");
    return (INTVAL)0;
}
PARROT_EXPORT  PMC *
Parrot_default_pop_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_pmc");
    return PMCNULL;
}
PARROT_EXPORT  STRING *
Parrot_default_pop_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "pop_string");
    return (STRING*)0;
}
PARROT_EXPORT  PMC  *
Parrot_default_pow(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1759 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "pow", "PPP->P", pmc, value, dest, &result);
    return result;
#line 1917 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1793 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "pow_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 1928 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1776 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "pow_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 1939 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "push_float");
    
}
PARROT_EXPORT  void
Parrot_default_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "push_integer");
    
}
PARROT_EXPORT  void
Parrot_default_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "push_pmc");
    
}
PARROT_EXPORT  void
Parrot_default_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "push_string");
    
}
PARROT_EXPORT  void
Parrot_default_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
    cant_do_method(interp, pmc, "remove_attribute");
    
}
PARROT_EXPORT  void
Parrot_default_remove_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    cant_do_method(interp, pmc, "remove_method");
    
}
PARROT_EXPORT  void
Parrot_default_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
    cant_do_method(interp, pmc, "remove_parent");
    
}
PARROT_EXPORT  void
Parrot_default_remove_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
    cant_do_method(interp, pmc, "remove_role");
    
}
PARROT_EXPORT  void
Parrot_default_remove_vtable_override(PARROT_INTERP, PMC *pmc, STRING *vtable_name)
{
    cant_do_method(interp, pmc, "remove_vtable_override");
    
}
PARROT_EXPORT  PMC  *
Parrot_default_repeat(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 2629 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "repeat", "PPP->P", pmc, value, dest, &result);
    return result;
#line 2004 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 2646 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "repeat_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 2015 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_set_attr_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *name, PMC *value)
{
#line 1057 "./src/pmc/default.pmc"

    VTABLE_set_attr_str(interp, pmc, name, value);
#line 2023 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *idx, PMC *value)
{
    cant_do_method(interp, pmc, "set_attr_str");
    
}
PARROT_EXPORT  void
Parrot_default_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "set_bignum_int");
    
}
PARROT_EXPORT  void
Parrot_default_set_bignum_num(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_bignum_num");
    
}
PARROT_EXPORT  void
Parrot_default_set_bignum_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "set_bignum_str");
    
}
PARROT_EXPORT  void
Parrot_default_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "set_bool");
    
}
PARROT_EXPORT  void
Parrot_default_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
    cant_do_method(interp, pmc, "set_integer_keyed");
    
}
PARROT_EXPORT  void 
Parrot_default_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 650 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_integer_keyed(interp, pmc, r_key, value);
#line 2068 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
    cant_do_method(interp, pmc, "set_integer_keyed_str");
    
}
PARROT_EXPORT  void
Parrot_default_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "set_integer_native");
    
}
PARROT_EXPORT  void
Parrot_default_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "set_integer_same");
    
}
PARROT_EXPORT  void
Parrot_default_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_number_keyed");
    
}
PARROT_EXPORT  void 
Parrot_default_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 666 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_number_keyed(interp, pmc, r_key, value);
#line 2101 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_number_keyed_str");
    
}
PARROT_EXPORT  void
Parrot_default_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "set_number_native");
    
}
PARROT_EXPORT  void
Parrot_default_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "set_number_same");
    
}
PARROT_EXPORT  void
Parrot_default_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "set_pmc");
    
}
PARROT_EXPORT  void
Parrot_default_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
    cant_do_method(interp, pmc, "set_pmc_keyed");
    
}
PARROT_EXPORT  void 
Parrot_default_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
#line 714 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_pmc_keyed(interp, pmc, r_key, value);
#line 2140 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
    cant_do_method(interp, pmc, "set_pmc_keyed_str");
    
}
PARROT_EXPORT  void
Parrot_default_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
    cant_do_method(interp, pmc, "set_pointer");
    
}
PARROT_EXPORT  void
Parrot_default_set_pointer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, void *value)
{
    cant_do_method(interp, pmc, "set_pointer_keyed");
    
}
PARROT_EXPORT  void
Parrot_default_set_pointer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, void *value)
{
    cant_do_method(interp, pmc, "set_pointer_keyed_int");
    
}
PARROT_EXPORT  void
Parrot_default_set_pointer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, void *value)
{
    cant_do_method(interp, pmc, "set_pointer_keyed_str");
    
}
PARROT_EXPORT  void
Parrot_default_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
    cant_do_method(interp, pmc, "set_string_keyed");
    
}
PARROT_EXPORT  void 
Parrot_default_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *string)
{
#line 682 "./src/pmc/default.pmc"

    PMC *const r_key = INT2KEY(interp, key);
    VTABLE_set_string_keyed(interp, pmc, r_key, string);
#line 2185 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
    cant_do_method(interp, pmc, "set_string_keyed_str");
    
}
PARROT_EXPORT  void
Parrot_default_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "set_string_native");
    
}
PARROT_EXPORT  void
Parrot_default_set_string_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "set_string_same");
    
}
PARROT_EXPORT  void 
Parrot_default_setprop(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 374 "./src/pmc/default.pmc"

    if (check_set_std_props(interp, pmc, key, value))
        return;

    if (pmc->pmc_ext && PMC_metadata(pmc)) {
        VTABLE_set_pmc_keyed_str(interp,
            PMC_metadata(pmc), key, value);
    }
    else {
        PMC * const prop = make_prop_hash(interp, pmc);

        VTABLE_set_pmc_keyed_str(interp, prop, key, value);
    }
#line 2222 "./src/pmc/default.c"
}
PARROT_EXPORT  void
Parrot_default_share(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "share");
    
}
PARROT_EXPORT  PMC *
Parrot_default_share_ro(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "share_ro");
    return PMCNULL;
}
PARROT_EXPORT  FLOATVAL
Parrot_default_shift_float(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_float");
    return (FLOATVAL)0;
}
PARROT_EXPORT  INTVAL
Parrot_default_shift_integer(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_integer");
    return (INTVAL)0;
}
PARROT_EXPORT  PMC *
Parrot_default_shift_pmc(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_pmc");
    return PMCNULL;
}
PARROT_EXPORT  STRING *
Parrot_default_shift_string(PARROT_INTERP, PMC *pmc)
{
    cant_do_method(interp, pmc, "shift_string");
    return (STRING*)0;
}
PARROT_EXPORT  PMC *
Parrot_default_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL flag)
{
    cant_do_method(interp, pmc, "slice");
    return PMCNULL;
}
PARROT_EXPORT  void
Parrot_default_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
    cant_do_method(interp, pmc, "splice");
    
}
PARROT_EXPORT  void
Parrot_default_substr(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length, PMC *dest)
{
    cant_do_method(interp, pmc, "substr");
    
}
PARROT_EXPORT  STRING *
Parrot_default_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length)
{
    cant_do_method(interp, pmc, "substr_str");
    return (STRING*)0;
}
PARROT_EXPORT  PMC  *
Parrot_default_subtract(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1279 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "subtract", "PPP->P", pmc, value, dest, &result);
    return result;
#line 2293 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1313 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "subtract_float", "PNP->P", pmc, value, dest, &result);
    return result;
#line 2304 "./src/pmc/default.c"
}
PARROT_EXPORT  PMC  *
Parrot_default_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1296 "./src/pmc/default.pmc"

    PMC *result = PMCNULL;
    Parrot_mmd_multi_dispatch_from_c_args(interp,
            "subtract_int", "PIP->P", pmc, value, dest, &result);
    return result;
#line 2315 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1143 "./src/pmc/default.pmc"

    /* default - initialize the PMC */
    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        if (!pmc->pmc_ext)
            add_pmc_ext(interp, pmc);

        info->thaw_ptr  = &PMC_metadata(pmc);
        info->container = pmc;

        (info->visit_pmc_now)(interp, PMC_metadata(pmc), info);
    }
    else
        VTABLE_init(interp, pmc);
#line 2334 "./src/pmc/default.c"
}
PARROT_EXPORT  void 
Parrot_default_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1168 "./src/pmc/default.pmc"

    /* default - no action */
#line 2342 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL 
Parrot_default_type(PARROT_INTERP, PMC *pmc)
{
#line 438 "./src/pmc/default.pmc"

    return pmc->vtable->base_type;
#line 2350 "./src/pmc/default.c"
}
PARROT_EXPORT  INTVAL
Parrot_default_type_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
    cant_do_method(interp, pmc, "type_keyed");
    return (INTVAL)0;
}
PARROT_EXPORT  void
Parrot_default_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
    cant_do_method(interp, pmc, "unshift_float");
    
}
PARROT_EXPORT  void
Parrot_default_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
    cant_do_method(interp, pmc, "unshift_integer");
    
}
PARROT_EXPORT  void
Parrot_default_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
    cant_do_method(interp, pmc, "unshift_pmc");
    
}
PARROT_EXPORT  void
Parrot_default_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
    cant_do_method(interp, pmc, "unshift_string");
    
}
PARROT_EXPORT  void 
Parrot_default_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1090 "./src/pmc/default.pmc"

    /* default - mark prop hash */
    if (pmc->pmc_ext && PMC_metadata(pmc) &&
        info->extra_flags != EXTRA_IS_PROP_HASH) {
        info->extra_flags = EXTRA_IS_PROP_HASH;
        info->extra       = PMC_metadata(pmc);

        /* place escape mark */
        (info->visit_pmc_now)(interp, pmc, info);

        /* place and the prop hash */
        (info->visit_pmc_now)(interp, PMC_metadata(pmc), info);
    }
#line 2399 "./src/pmc/default.c"
}
#include "pmc_default.h"
#line 2681 "./src/pmc/default.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
