/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/env.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_env.h"
#include "pmc_default.h"
#include "env.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/env.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: env.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/env.pmc - System Environment

=head1 DESCRIPTION

C<Env> is a singleton class which provides access to the system environment.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"

/* array of environment variables,
   speced in POSIX.1, but not in ISO-C
   MS C compilers know about environ, as it is declared in stdlib.h.
   OS X doesn't allow access to "environ" from within shared libraries.
*/
#ifndef WIN32
#  ifdef __APPLE_CC__
#    include <crt_externs.h>
#    define environ (*_NSGetEnviron())
#  else /* !__APPLE_CC__ */
extern char **environ;
#  endif /* __APPLE_CC__ */
#endif /* !WIN32 */

static PMC *Env_PMC;
#line 60 "./src/pmc/env.c"
PARROT_EXPORT  void 
Parrot_Env_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 314 "./src/pmc/env.pmc"

    char * const keyname = Parrot_str_to_cstring(interp,
        VTABLE_get_string(interp, key));

    if (keyname) {
        int          free_it;
        char * const val = Parrot_getenv(keyname, &free_it);

        if (val) {
            if (free_it)
                mem_sys_free(val);

            Parrot_unsetenv(keyname);
        }

        Parrot_str_free_cstring(keyname);
    }
#line 82 "./src/pmc/env.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Env_elements(PARROT_INTERP, PMC *pmc)
{
#line 102 "./src/pmc/env.pmc"

    INTVAL rv = 0;

    while (environ[rv] != NULL)
        rv++;

    return rv;
#line 95 "./src/pmc/env.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Env_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 285 "./src/pmc/env.pmc"

    char * const keyname = Parrot_str_to_cstring(interp,
        VTABLE_get_string(interp, key));

    if (keyname) {
        int free_it;
        char * const val = Parrot_getenv(keyname, &free_it);
        Parrot_str_free_cstring(keyname);

        if (val) {
            if (free_it)
                mem_sys_free(val);
            return 1;
        }
    }

    return 0;
#line 118 "./src/pmc/env.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Env_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 121 "./src/pmc/env.pmc"

    return VTABLE_elements(interp, pmc);
#line 126 "./src/pmc/env.c"
}
PARROT_EXPORT  PMC  *
Parrot_Env_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 75 "./src/pmc/env.pmc"

    STRING *name         = CONST_STRING(interp, "set_key");
    PMC    *iter         = pmc_new_init(interp, enum_class_Iterator, pmc);
    PMC    *key          = pmc_new(interp, enum_class_Key);

    Parrot_PCCINVOKE(interp, iter, name, "P->", key);
    PObj_get_FLAGS(key) |= KEY_integer_FLAG;

    if (!environ[0])
        VTABLE_set_integer_native(interp, key, -1);
    else
        VTABLE_set_integer_native(interp, key, 0);

    return iter;
#line 146 "./src/pmc/env.c"
}
PARROT_EXPORT  PMC *
Parrot_Env_get_namespace(PARROT_INTERP, PMC *pmc)
{
  return interp->vtables[pmc->vtable->base_type]->_namespace;
}
PARROT_EXPORT  FLOATVAL 
Parrot_Env_get_number(PARROT_INTERP, PMC *pmc)
{
#line 134 "./src/pmc/env.pmc"

    return VTABLE_elements(interp, pmc);
#line 159 "./src/pmc/env.c"
}
PARROT_EXPORT  PMC  *
Parrot_Env_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 194 "./src/pmc/env.pmc"

    char * const keyname = Parrot_str_to_cstring(interp,
        VTABLE_get_string(interp, key));

    char   *val     = NULL;
    STRING *retval  = NULL;
    PMC    *return_pmc;

    if (keyname) {
        int free_it = 0;
        val         = Parrot_getenv(keyname, &free_it);
        Parrot_str_free_cstring(keyname);

        if (val) {
            retval = Parrot_str_new(interp, val, 0);
            if (free_it)
                mem_sys_free(val);
        }
    }

    if (!retval)
        retval = string_from_literal(interp, "");

    return_pmc = pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, return_pmc, retval);
    return return_pmc;
#line 192 "./src/pmc/env.c"
}
PARROT_EXPORT  void  *
Parrot_Env_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 56 "./src/pmc/env.pmc"

    return Env_PMC;
#line 200 "./src/pmc/env.c"
}
PARROT_EXPORT  STRING  *
Parrot_Env_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 148 "./src/pmc/env.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        INTVAL const keynum = VTABLE_get_integer(interp, key);
        if (keynum < 0 || keynum >= VTABLE_elements(interp, pmc)) {
            return string_from_literal(interp, "");
        }
        else {
            const char * const envp = environ[keynum];
            const char * const p    = strchr(envp, '=');
            return Parrot_str_new(interp, envp, (UINTVAL)(p - envp));
        }
    }
    else {
        char * const keyname = Parrot_str_to_cstring(interp,
            VTABLE_get_string(interp, key));

        if (keyname) {
            int free_it = 0;
            char * const val = Parrot_getenv(keyname, &free_it);
            Parrot_str_free_cstring(keyname);

            if (val) {
                STRING * const retval = Parrot_str_new(interp, val, 0);

                if (free_it)
                    mem_sys_free(val);

                return retval;

            }
        }

        return string_from_literal(interp, "");
    }
#line 240 "./src/pmc/env.c"
}
PARROT_EXPORT  void 
Parrot_Env_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 258 "./src/pmc/env.pmc"

    char * const keyname = Parrot_str_to_cstring(interp,
        VTABLE_get_string(interp, key));

    const STRING * const str_value = VTABLE_get_string(interp, value);
    char         * const env_val   = Parrot_str_to_cstring(interp, str_value);

    if (keyname && env_val)
        Parrot_setenv(keyname, env_val);

    if (keyname)
        Parrot_str_free_cstring(keyname);

    if (env_val)
        Parrot_str_free_cstring(env_val);
#line 261 "./src/pmc/env.c"
}
PARROT_EXPORT  void 
Parrot_Env_set_pointer(PARROT_INTERP, PMC *pmc, void *ptr)
{
#line 60 "./src/pmc/env.pmc"

    Env_PMC = (PMC *)ptr;
#line 269 "./src/pmc/env.c"
}
PARROT_EXPORT  void 
Parrot_Env_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 233 "./src/pmc/env.pmc"

    char * const keyname = Parrot_str_to_cstring(interp,
        VTABLE_get_string(interp, key));
    char * const env_val = Parrot_str_to_cstring(interp, value);

    if (keyname && env_val)
        Parrot_setenv(keyname, env_val);

    if (keyname)
        Parrot_str_free_cstring(keyname);

    if (env_val)
        Parrot_str_free_cstring(env_val);
#line 288 "./src/pmc/env.c"
}
#include "pmc_default.h"
void
Parrot_Env_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Env, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_IS_SINGLETON, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Env_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_Env_elements,
        Parrot_Env_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Env_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Env_get_iter,
        Parrot_Env_get_namespace,
        Parrot_Env_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Env_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Env_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_Env_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_default_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_Env_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Env_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Env_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Env");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "hash");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Env")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Env"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        /* class_init */
        {
        
            Env_PMC = NULL;

        }
        {
        }
    } /* pass */
} /* Parrot_Env_class_init */
#line 331 "./src/pmc/env.pmc"


/*

=back

=head1 SEE ALS0

PDD -
L<http://www.parrotcode.org/docs/pdd/pdd17_pdd.html#Hash_types>

Environment in Perl 6 - L<http://dev.perl.org/perl6/rfc/318.html>

Module for Perl 5 - L<http://search.cpan.org/~stas/Env-C-0.06/>

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
