/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/exception.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_exception.h"
#include "pmc_default.h"
#include "exception.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/exception.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: exception.pmc 37461 2009-03-15 21:35:58Z chromatic $

=head1 NAME

src/pmc/exception.pmc - Exception PMC

=head1 DESCRIPTION

This is the exception base class. An exception object has the following
attributes:

=over 4

=item C<message>

Textual representation of the exception.

=item C<severity>

The severity of the exception, (see F<include/parrot/exceptions.h>,
F<except_severity.pasm>).

=item C<type>

The type of the exception.

=item C<exit_code>

The exit code of the exception. (Added temporarily, to be removed.)

=item C<handled>

Whether the exception has been handled. Defaults to 0, 1 for handled, -1 for a
rethrown exception.

=item C<payload>

Additional data for the exception.

=back

When an exception handler is called, the exception object is passed as
as the first argument, the message as the second argument of the call.
These arguments can be retrieved with the C<get_results> opcode.

=cut

*/

#include "parrot/parrot.h"
#include "parrot/exceptions.h"
#include "pmc_sub.h"
#line 77 "./src/pmc/exception.c"
PARROT_EXPORT  void 
Parrot_Exception_destroy(PARROT_INTERP, PMC *pmc)
{
#line 175 "./src/pmc/exception.pmc"

    Parrot_Exception_attributes * const core_struct = PARROT_EXCEPTION(pmc);

    if (core_struct)
        mem_sys_free(core_struct);
#line 87 "./src/pmc/exception.c"
}
PARROT_EXPORT  PMC  *
Parrot_Exception_get_attr_str(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 561 "./src/pmc/exception.pmc"

    PMC *value = PMCNULL;

    if (Parrot_str_equal(interp, name, CONST_STRING(interp, "type"))) {
            INTVAL type;
            GETATTR_Exception_type(interp, pmc, type);
            value = pmc_new(interp, enum_class_Integer);
            VTABLE_set_integer_native(interp, value, type);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "severity"))) {
            INTVAL severity;
            GETATTR_Exception_severity(interp, pmc, severity);
            value = pmc_new(interp, enum_class_Integer);
            VTABLE_set_integer_native(interp, value, severity);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "exit_code"))) {
            INTVAL exit_code;
            GETATTR_Exception_exit_code(interp, pmc, exit_code);
            value = pmc_new(interp, enum_class_Integer);
            VTABLE_set_integer_native(interp, value, exit_code);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "handled"))) {
            INTVAL handled;
            GETATTR_Exception_handled(interp, pmc, handled);
            value = pmc_new(interp, enum_class_Integer);
            VTABLE_set_integer_native(interp, value, handled);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "message"))) {
            STRING *message;
            GETATTR_Exception_message(interp, pmc, message);
            value = pmc_new(interp, enum_class_String);
            VTABLE_set_string_native(interp, value, message);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "payload"))) {
            GETATTR_Exception_payload(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "resume"))) {
            GETATTR_Exception_resume(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "backtrace"))) {
            GETATTR_Exception_backtrace(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "handler_iter"))) {
            GETATTR_Exception_handler_iter(interp, pmc, value);
    }
    else {
        /* If unknown attribute name, throw an exception. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such attribute '%S'", name);
    }

    return value;
#line 145 "./src/pmc/exception.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Exception_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 192 "./src/pmc/exception.pmc"

    return 1;
#line 153 "./src/pmc/exception.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Exception_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 222 "./src/pmc/exception.pmc"

    Parrot_Exception_attributes * const exception = PARROT_EXCEPTION(pmc);
    return exception->id;
#line 162 "./src/pmc/exception.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Exception_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 264 "./src/pmc/exception.pmc"

    STRING *name   = VTABLE_get_string(interp, key);
    INTVAL  result = 0;

    if (Parrot_str_equal(interp, name, CONST_STRING(interp, "type"))) {
        GETATTR_Exception_type(interp, pmc, result);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "severity"))) {
        GETATTR_Exception_severity(interp, pmc, result);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "exit_code"))) {
        GETATTR_Exception_exit_code(interp, pmc, result);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "handled"))) {
        GETATTR_Exception_handled(interp, pmc, result);
    }
    else {
        /* If unknown attribute name, throw an exception. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such integer attribute '%S'", name);
    }

    return result;
#line 191 "./src/pmc/exception.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Exception_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 299 "./src/pmc/exception.pmc"

    INTVAL result = 0;

    if (Parrot_str_equal(interp, key, CONST_STRING(interp, "type"))) {
        GETATTR_Exception_type(interp, pmc, result);
    }
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "severity"))) {
        GETATTR_Exception_severity(interp, pmc, result);
    }
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "exit_code"))) {
        GETATTR_Exception_exit_code(interp, pmc, result);
    }
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "handled"))) {
        GETATTR_Exception_handled(interp, pmc, result);
    }
    else {
        /* If unknown attribute name, throw an exception. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such integer attribute '%S'", key);
    }

    return result;
#line 219 "./src/pmc/exception.c"
}
PARROT_EXPORT  PMC  *
Parrot_Exception_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 333 "./src/pmc/exception.pmc"

    STRING *s = VTABLE_get_string(interp, key);
    return VTABLE_get_attr_str(interp, pmc, s);
#line 228 "./src/pmc/exception.c"
}
PARROT_EXPORT  void  *
Parrot_Exception_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 513 "./src/pmc/exception.pmc"

    Parrot_Exception_attributes * const core_struct = PARROT_EXCEPTION(pmc);
    return core_struct->handler_ctx;
#line 237 "./src/pmc/exception.c"
}
PARROT_EXPORT  STRING  *
Parrot_Exception_get_string(PARROT_INTERP, PMC *pmc)
{
#line 206 "./src/pmc/exception.pmc"

    STRING *message;
    GETATTR_Exception_message(interp, pmc, message);
    return message;
#line 247 "./src/pmc/exception.c"
}
PARROT_EXPORT  STRING  *
Parrot_Exception_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 238 "./src/pmc/exception.pmc"

    STRING *name = VTABLE_get_string(interp, key);
    STRING *message;

    if (Parrot_str_equal(interp, name, CONST_STRING(interp, "message"))) {
        GETATTR_Exception_message(interp, pmc, message);
    }
    else {
        /* If unknown attribute name, throw an exception. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such string attribute '%S'", name);
    }

    return message;
#line 267 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_init(PARROT_INTERP, PMC *pmc)
{
#line 84 "./src/pmc/exception.pmc"

    Parrot_Exception_attributes * const core_struct =
        mem_allocate_zeroed_typed(Parrot_Exception_attributes);

    /* Set flags for custom GC mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);

    /* Set up the core struct and default values for the exception object. */
    PMC_data(pmc)            = core_struct;
    core_struct->severity     = EXCEPT_error;
    core_struct->handled      = 0;
    core_struct->message      = CONST_STRING(interp, "");
    core_struct->payload      = PMCNULL;
    core_struct->resume       = PMCNULL;
    core_struct->backtrace    = PMCNULL;
    core_struct->handler_iter = PMCNULL;
#line 290 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_init_pmc(PARROT_INTERP, PMC *pmc, PMC *values)
{
#line 113 "./src/pmc/exception.pmc"

    STRING * const severity = CONST_STRING(interp, "severity");
    STRING * const message  = CONST_STRING(interp, "message");

    Parrot_Exception_attributes * const core_struct =
        mem_allocate_zeroed_typed(Parrot_Exception_attributes);

    INTVAL ishash = VTABLE_isa(interp, values, CONST_STRING(interp, 'Hash'));

    /* Set flags for custom GC mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);

    /* Set up the core struct and default values for the exception object. */
    PMC_data(pmc)            = core_struct;
    core_struct->severity     = ishash
        ? VTABLE_get_integer_keyed_str(interp, values, severity)
        : (INTVAL) EXCEPT_error;
    core_struct->handled      = 0;
    core_struct->message      = ishash
        ? VTABLE_get_string_keyed_str(interp, values, message)
        : VTABLE_get_string(interp, values);
    core_struct->payload      = PMCNULL;
    core_struct->resume       = PMCNULL;
    core_struct->backtrace    = PMCNULL;
    core_struct->handler_iter = PMCNULL;
#line 322 "./src/pmc/exception.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Exception_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 529 "./src/pmc/exception.pmc"

    STRING * const exception_str = CONST_STRING(interp, "Exception");

    if (value->vtable->base_type == pmc->vtable->base_type
    &&  VTABLE_isa(interp, value, exception_str)) {
        INTVAL self_compare, value_compare;
        GETATTR_Exception_type(interp, pmc, self_compare);
        GETATTR_Exception_type(interp, value, value_compare);
        if (self_compare == value_compare) {
            GETATTR_Exception_severity(interp, pmc, self_compare);
            GETATTR_Exception_severity(interp, value, value_compare);
            if (self_compare == value_compare) {
                GETATTR_Exception_exit_code(interp, pmc, self_compare);
                GETATTR_Exception_exit_code(interp, value, value_compare);
                if (self_compare == value_compare)
                    return 1;
            }
        }
    }

    return 0;
#line 349 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_mark(PARROT_INTERP, PMC *pmc)
{
#line 151 "./src/pmc/exception.pmc"

    Parrot_Exception_attributes * const core_struct = PARROT_EXCEPTION(pmc);
    if (core_struct->message)
        pobject_lives(interp, (PObj *)core_struct->message);
    if (core_struct->payload)
        pobject_lives(interp, (PObj *)core_struct->payload);
    if (core_struct->resume)
        pobject_lives(interp, (PObj *)core_struct->resume);
    if (core_struct->backtrace)
        pobject_lives(interp, (PObj *)core_struct->backtrace);
    if (core_struct->handler_iter)
        pobject_lives(interp, (PObj *)core_struct->handler_iter);
#line 367 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_set_attr_str(PARROT_INTERP, PMC *pmc, STRING *name, PMC *value)
{
#line 624 "./src/pmc/exception.pmc"


    if (Parrot_str_equal(interp, name, CONST_STRING(interp, "type"))) {
        INTVAL type = VTABLE_get_integer(interp, value);
        SETATTR_Exception_type(interp, pmc, type);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "severity"))) {
        INTVAL severity = VTABLE_get_integer(interp, value);
        SETATTR_Exception_severity(interp, pmc, severity);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "exit_code"))) {
        INTVAL exit_code = VTABLE_get_integer(interp, value);
        SETATTR_Exception_exit_code(interp, pmc, exit_code);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "handled"))) {
        INTVAL handled = VTABLE_get_integer(interp, value);
        SETATTR_Exception_handled(interp, pmc, handled);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "message"))) {
        STRING *message = VTABLE_get_string(interp, value);
        SETATTR_Exception_message(interp, pmc, message);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "payload"))) {
        SETATTR_Exception_payload(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "resume"))) {
        SETATTR_Exception_resume(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "backtrace"))) {
        SETATTR_Exception_backtrace(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "handler_iter"))) {
        SETATTR_Exception_handler_iter(interp, pmc, value);
    }
    else {
        /* If unknown attribute name, throw an exception. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such attribute '%S'", name);
    }

#line 413 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 416 "./src/pmc/exception.pmc"

    STRING *name = VTABLE_get_string(interp, key);

    if (Parrot_str_equal(interp, name, CONST_STRING(interp, "type"))) {
        SETATTR_Exception_type(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "severity"))) {
        SETATTR_Exception_severity(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "exit_code"))) {
        SETATTR_Exception_exit_code(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, name, CONST_STRING(interp, "handled"))) {
        SETATTR_Exception_handled(interp, pmc, value);
    }
    else {
        /* If unknown attribute name, throw an exception. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such integer attribute '%S'", name);
    }
#line 439 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
#line 448 "./src/pmc/exception.pmc"

    if (Parrot_str_equal(interp, key, CONST_STRING(interp, "type"))) {
        SETATTR_Exception_type(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "severity"))) {
        SETATTR_Exception_severity(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "exit_code"))) {
        SETATTR_Exception_exit_code(interp, pmc, value);
    }
    else if (Parrot_str_equal(interp, key, CONST_STRING(interp, "handled"))) {
        SETATTR_Exception_handled(interp, pmc, value);
    }
    else {
        /* If unknown attribute name, throw an exception. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such integer attribute '%S'", key);
    }
#line 463 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 364 "./src/pmc/exception.pmc"

    SETATTR_Exception_id(interp, pmc, value);
#line 471 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 378 "./src/pmc/exception.pmc"

    SETATTR_Exception_birthtime(interp, pmc, value);
#line 479 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 478 "./src/pmc/exception.pmc"

    STRING *s = VTABLE_get_string(interp, key);
    VTABLE_set_attr_str(interp, pmc, s, value);
#line 488 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_set_pointer(PARROT_INTERP, PMC *pmc, void *context)
{
#line 493 "./src/pmc/exception.pmc"

    Parrot_Exception_attributes * const core_struct = PARROT_EXCEPTION(pmc);

    /* contexts are refcounted; increment and decrement appropriately */
    if (core_struct->handler_ctx)
        Parrot_free_context(interp, core_struct->handler_ctx, 1);
    core_struct->handler_ctx = Parrot_context_ref(interp,
                                   (Parrot_Context *)context);
#line 502 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 393 "./src/pmc/exception.pmc"

    STRING *name = VTABLE_get_string(interp, key);

    if (Parrot_str_equal(interp, name, CONST_STRING(interp, "message"))) {
        SETATTR_Exception_message(interp, pmc, value);
    }
    else {
        /* If unknown attribute name, throw an exception. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such string attribute '%S'", name);
    }
#line 519 "./src/pmc/exception.c"
}
PARROT_EXPORT  void 
Parrot_Exception_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 349 "./src/pmc/exception.pmc"

    SETATTR_Exception_message(interp, pmc, value);
#line 527 "./src/pmc/exception.c"
}
PARROT_EXPORT  PMC  *
Parrot_Exception_share_ro(PARROT_INTERP, PMC *pmc)
{
#line 676 "./src/pmc/exception.pmc"

    PMC *shared_self;
    Parrot_Exception_attributes *shared_struct;

    if (PObj_is_PMC_shared_TEST(pmc))
        return pmc;

    shared_self = pt_shared_fixup(interp, pmc);
    shared_struct = PARROT_EXCEPTION(shared_self);

    if (!PMC_IS_NULL(shared_struct->payload))
        shared_struct->payload = pt_shared_fixup(interp, shared_struct->payload);

    if (!PMC_IS_NULL(shared_struct->backtrace))
        shared_struct->backtrace = pt_shared_fixup(interp, shared_struct->backtrace);

    if (!PMC_IS_NULL(shared_struct->handler_iter))
        shared_struct->handler_iter = pt_shared_fixup(interp, shared_struct->handler_iter);

    return shared_self;
#line 553 "./src/pmc/exception.c"
}
PARROT_EXPORT  void
Parrot_Exception_nci_annotations(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 593 "./src/pmc/exception.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 610 "./src/pmc/exception.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    INTVAL have_name = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 711 "./src/pmc/exception.pmc"

    PMC *resume;
    PMC *result = PMCNULL;

    /* Get resume continuation, to find location we failed at. */
    GETATTR_Exception_resume(interp, pmc, resume);
    if (!PMC_IS_NULL(resume)) {
        Parrot_cont *cont = PMC_cont(resume);
        if (cont->seg != NULL && cont->seg->annotations != NULL)
            result = PackFile_Annotations_lookup(interp, cont->seg->annotations,
                    cont->address - cont->seg->base.data, name);
    }

    /* If we didn't have a key specified and we found no annotations to
     * return, should return an empty hash. */
    if (!have_name && PMC_IS_NULL(result))
        result = pmc_new(interp, enum_class_Hash);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *result */
    /*BEGIN GENERATED ACCESSORS */
#line 642 "./src/pmc/exception.pmc"
    CTX_REG_PMC(_ctx, 0) = result;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto annotations_returns;
    /*END RETURN PMC *result */
    }
#line 729 "./src/pmc/exception.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
annotations_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 687 "./src/pmc/exception.c"
}
PARROT_EXPORT  void
Parrot_Exception_nci_backtrace(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 725 "./src/pmc/exception.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 742 "./src/pmc/exception.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 748 "./src/pmc/exception.pmc"

    PMC *result = pmc_new(interp, enum_class_ResizablePMCArray);
    PMC *resume;

    /* Get starting context, then loop over them. */
    GETATTR_Exception_resume(interp, pmc, resume);
    if (!PMC_IS_NULL(resume)) {
        Parrot_cont    *cont    = PMC_cont(resume);
        Parrot_Context *cur_ctx = cont->to_ctx;

        while (cur_ctx) {
            PMC        *frame       = pmc_new(interp, enum_class_Hash);
            PMC        *annotations = NULL;
            Parrot_sub *sub;

            /* Get sub and put it in the hash. */
            PMC *sub_pmc = cur_ctx->current_sub;

            if (!sub_pmc)
                sub_pmc = PMCNULL;

            VTABLE_set_pmc_keyed_str(interp, frame, CONST_STRING(interp, "sub"), sub_pmc);

            /* Look up any annotations and put them in the hash. */
            if (!PMC_IS_NULL(sub_pmc)
            &&  sub_pmc->vtable->base_type == enum_class_Sub) {

                PMC_get_sub(interp, sub_pmc, sub);

                if (sub->seg->annotations) {
                    PackFile_ByteCode *seg = sub->seg;
                    opcode_t          *pc  = cur_ctx == cont->to_ctx
                                           ? cont->address
                                           : cur_ctx->current_pc;

                    annotations = PackFile_Annotations_lookup(interp,
                                    seg->annotations, pc - seg->base.data,
                                    NULL);
                }
            }

            if (!annotations)
                annotations = pmc_new(interp, enum_class_Hash);

            VTABLE_set_pmc_keyed_str(interp, frame, CONST_STRING(interp, "annotations"), annotations);

            /* Push frame and go to next caller. */
            VTABLE_push_pmc(interp, result, frame);
            cur_ctx = cur_ctx->caller_ctx;
        }
    }

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *result */
    /*BEGIN GENERATED ACCESSORS */
#line 806 "./src/pmc/exception.pmc"
    CTX_REG_PMC(_ctx, 0) = result;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto backtrace_returns;
    /*END RETURN PMC *result */
    }
#line 800 "./src/pmc/exception.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
backtrace_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 851 "./src/pmc/exception.c"
}
PARROT_EXPORT  void
Parrot_Exception_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Exception");
}
PARROT_EXPORT  PMC *
Parrot_Exception_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Exception");
}
PARROT_EXPORT  FLOATVAL
Parrot_Exception_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Exception");
}
PARROT_EXPORT  INTVAL
Parrot_Exception_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Exception");
}
PARROT_EXPORT  PMC *
Parrot_Exception_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Exception");
}
PARROT_EXPORT  STRING *
Parrot_Exception_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Exception");
}
PARROT_EXPORT  FLOATVAL
Parrot_Exception_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Exception");
}
PARROT_EXPORT  INTVAL
Parrot_Exception_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Exception");
}
PARROT_EXPORT  PMC *
Parrot_Exception_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Exception");
}
PARROT_EXPORT  STRING *
Parrot_Exception_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Exception");
}
PARROT_EXPORT  void
Parrot_Exception_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Exception");
}
#include "pmc_default.h"
void
Parrot_Exception_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iid Fbirthtime Smessage Fpayload Fresume Iseverity Itype Iexit_code Fbacktrace Ihandled Fhandler_iter :handler_ctx ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Exception, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Exception_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_Exception_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Exception_get_bool,
        Parrot_default_get_class,
        Parrot_Exception_get_integer,
        Parrot_Exception_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_Exception_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Exception_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Exception_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Exception_get_string,
        Parrot_Exception_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_Exception_init,
        Parrot_Exception_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_Exception_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Exception_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_Exception_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_Exception_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_Exception_set_integer_keyed_str,
        Parrot_Exception_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_Exception_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_Exception_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Exception_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Exception_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Exception_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_Exception_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Exception, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Exception_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Exception_ro_add_method,
        Parrot_Exception_ro_add_parent,
        Parrot_Exception_ro_add_role,
        Parrot_Exception_ro_add_vtable_override,
        Parrot_Exception_ro_assign_pmc,
        Parrot_Exception_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Exception_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Exception_ro_delete_keyed,
        Parrot_Exception_ro_delete_keyed_int,
        Parrot_Exception_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Exception_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Exception_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_Exception_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Exception_get_bool,
        Parrot_default_get_class,
        Parrot_Exception_get_integer,
        Parrot_Exception_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_Exception_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Exception_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Exception_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Exception_get_string,
        Parrot_Exception_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Exception_ro_i_absolute,
        Parrot_Exception_ro_i_add,
        Parrot_Exception_ro_i_add_float,
        Parrot_Exception_ro_i_add_int,
        Parrot_Exception_ro_i_bitwise_and,
        Parrot_Exception_ro_i_bitwise_and_int,
        Parrot_Exception_ro_i_bitwise_ands,
        Parrot_Exception_ro_i_bitwise_ands_str,
        Parrot_Exception_ro_i_bitwise_lsr,
        Parrot_Exception_ro_i_bitwise_lsr_int,
        Parrot_Exception_ro_i_bitwise_not,
        Parrot_Exception_ro_i_bitwise_nots,
        Parrot_Exception_ro_i_bitwise_or,
        Parrot_Exception_ro_i_bitwise_or_int,
        Parrot_Exception_ro_i_bitwise_ors,
        Parrot_Exception_ro_i_bitwise_ors_str,
        Parrot_Exception_ro_i_bitwise_shl,
        Parrot_Exception_ro_i_bitwise_shl_int,
        Parrot_Exception_ro_i_bitwise_shr,
        Parrot_Exception_ro_i_bitwise_shr_int,
        Parrot_Exception_ro_i_bitwise_xor,
        Parrot_Exception_ro_i_bitwise_xor_int,
        Parrot_Exception_ro_i_bitwise_xors,
        Parrot_Exception_ro_i_bitwise_xors_str,
        Parrot_Exception_ro_i_concatenate,
        Parrot_Exception_ro_i_concatenate_str,
        Parrot_Exception_ro_i_divide,
        Parrot_Exception_ro_i_divide_float,
        Parrot_Exception_ro_i_divide_int,
        Parrot_Exception_ro_i_floor_divide,
        Parrot_Exception_ro_i_floor_divide_float,
        Parrot_Exception_ro_i_floor_divide_int,
        Parrot_Exception_ro_i_logical_not,
        Parrot_Exception_ro_i_modulus,
        Parrot_Exception_ro_i_modulus_float,
        Parrot_Exception_ro_i_modulus_int,
        Parrot_Exception_ro_i_multiply,
        Parrot_Exception_ro_i_multiply_float,
        Parrot_Exception_ro_i_multiply_int,
        Parrot_Exception_ro_i_neg,
        Parrot_Exception_ro_i_pow,
        Parrot_Exception_ro_i_pow_float,
        Parrot_Exception_ro_i_pow_int,
        Parrot_Exception_ro_i_repeat,
        Parrot_Exception_ro_i_repeat_int,
        Parrot_Exception_ro_i_subtract,
        Parrot_Exception_ro_i_subtract_float,
        Parrot_Exception_ro_i_subtract_int,
        Parrot_Exception_ro_increment,
        Parrot_Exception_init,
        Parrot_Exception_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_Exception_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Exception_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_Exception_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Exception_ro_pop_float,
        Parrot_Exception_ro_pop_integer,
        Parrot_Exception_ro_pop_pmc,
        Parrot_Exception_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Exception_ro_push_float,
        Parrot_Exception_ro_push_integer,
        Parrot_Exception_ro_push_pmc,
        Parrot_Exception_ro_push_string,
        Parrot_Exception_ro_remove_attribute,
        Parrot_Exception_ro_remove_method,
        Parrot_Exception_ro_remove_parent,
        Parrot_Exception_ro_remove_role,
        Parrot_Exception_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_Exception_ro_set_attr_keyed,
        Parrot_Exception_ro_set_attr_str,
        Parrot_Exception_ro_set_bignum_int,
        Parrot_Exception_ro_set_bignum_num,
        Parrot_Exception_ro_set_bignum_str,
        Parrot_Exception_ro_set_bool,
        Parrot_Exception_ro_set_integer_keyed,
        Parrot_Exception_ro_set_integer_keyed_int,
        Parrot_Exception_ro_set_integer_keyed_str,
        Parrot_Exception_ro_set_integer_native,
        Parrot_Exception_ro_set_integer_same,
        Parrot_Exception_ro_set_number_keyed,
        Parrot_Exception_ro_set_number_keyed_int,
        Parrot_Exception_ro_set_number_keyed_str,
        Parrot_Exception_ro_set_number_native,
        Parrot_Exception_ro_set_number_same,
        Parrot_Exception_ro_set_pmc,
        Parrot_Exception_ro_set_pmc_keyed,
        Parrot_Exception_ro_set_pmc_keyed_int,
        Parrot_Exception_ro_set_pmc_keyed_str,
        Parrot_Exception_ro_set_pointer,
        Parrot_Exception_ro_set_pointer_keyed,
        Parrot_Exception_ro_set_pointer_keyed_int,
        Parrot_Exception_ro_set_pointer_keyed_str,
        Parrot_Exception_ro_set_string_keyed,
        Parrot_Exception_ro_set_string_keyed_int,
        Parrot_Exception_ro_set_string_keyed_str,
        Parrot_Exception_ro_set_string_native,
        Parrot_Exception_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_Exception_share_ro,
        Parrot_Exception_ro_shift_float,
        Parrot_Exception_ro_shift_integer,
        Parrot_Exception_ro_shift_pmc,
        Parrot_Exception_ro_shift_string,
        Parrot_default_slice,
        Parrot_Exception_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Exception_ro_thaw,
        Parrot_Exception_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Exception_ro_unshift_float,
        Parrot_Exception_ro_unshift_integer,
        Parrot_Exception_ro_unshift_pmc,
        Parrot_Exception_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Exception");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Exception")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Exception"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Exception_nci_annotations), "annotations");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Exception_nci_backtrace), "backtrace");
        {
        }
    } /* pass */
} /* Parrot_Exception_class_init */
#line 801 "./src/pmc/exception.pmc"


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
