/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/filehandle.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_filehandle.h"
#include "pmc_default.h"
#include "filehandle.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/filehandle.pmc"
/*
Copyright (C) 2008, Parrot Foundation.
$Id: filehandle.pmc 37312 2009-03-11 18:06:16Z allison $

=head1 NAME

src/pmc/filehandle.pmc - FileHandle PMC

=head1 DESCRIPTION

The FileHandle PMC performs I/O operations on a source or destination file.

=head2 Vtable Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "../src/io/io_private.h"

#ifdef PARROT_HAS_READLINE
#ifdef __cplusplus
extern "C" {
#endif
    char *readline(const char *);
    void add_history(const char*);
#ifdef __cplusplus
}
#endif
#endif
#line 56 "./src/pmc/filehandle.c"
PARROT_EXPORT  PMC  *
Parrot_FileHandle_clone(PARROT_INTERP, PMC *pmc)
{
#line 104 "./src/pmc/filehandle.pmc"

    Parrot_FileHandle_attributes * const old_struct  = PARROT_FILEHANDLE(pmc);
    PMC * const copy = Parrot_io_new_pmc(interp, old_struct->flags);
    Parrot_FileHandle_attributes * const data_struct = PARROT_FILEHANDLE(copy);

    data_struct->os_handle    = Parrot_dup(old_struct->os_handle);

    return copy;
#line 69 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void 
Parrot_FileHandle_destroy(PARROT_INTERP, PMC *pmc)
{
#line 143 "./src/pmc/filehandle.pmc"

    if (PARROT_FILEHANDLE(pmc)) {
        Parrot_FileHandle_attributes *data_struct = PARROT_FILEHANDLE(pmc);

        if (!Parrot_io_is_closed_filehandle(interp, pmc)) {
            if (data_struct->flags & PIO_F_SHARED)
                Parrot_io_flush_filehandle(interp, pmc);
            else
                Parrot_io_close_filehandle(interp, pmc);
        }

        if (data_struct->buffer_start)
            mem_sys_free(data_struct->buffer_start);

        mem_sys_free(PARROT_FILEHANDLE(pmc));
        PMC_data(pmc) = NULL;
    }
#line 92 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FileHandle_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 172 "./src/pmc/filehandle.pmc"

    return !Parrot_io_eof(interp, pmc);
#line 100 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void 
Parrot_FileHandle_init(PARROT_INTERP, PMC *pmc)
{
#line 61 "./src/pmc/filehandle.pmc"

    Parrot_FileHandle_attributes *data_struct =
            mem_allocate_typed(Parrot_FileHandle_attributes);

    PMC_data(pmc)            = data_struct;
    data_struct->flags        = 0;
    data_struct->mode         = NULL;
    data_struct->encoding     = NULL;
    data_struct->filename     = NULL;
    data_struct->file_size    = 0;
    data_struct->file_pos     = piooffsetzero;
    data_struct->last_pos     = piooffsetzero;
    data_struct->buffer_flags = 0;
    data_struct->buffer_size  = 0;
    data_struct->buffer_start = NULL;
    data_struct->buffer_end   = NULL;
    data_struct->buffer_next  = NULL;

    /* Initialize the os_handle to the platform-specific value for closed. */
#ifdef PIO_OS_WIN32
data_struct->os_handle    = (PIOHANDLE)INVALID_HANDLE_VALUE;
#endif
#ifdef PIO_OS_UNIX
data_struct->os_handle    = (PIOHANDLE)-1;
#endif
#ifdef PIO_OS_STDIO
data_struct->os_handle    = (PIOHANDLE)NULL;
#endif

    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);
#line 137 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void 
Parrot_FileHandle_mark(PARROT_INTERP, PMC *pmc)
{
#line 124 "./src/pmc/filehandle.pmc"

    Parrot_FileHandle_attributes * const data_struct = PARROT_FILEHANDLE(pmc);
    if (data_struct->mode)
        pobject_lives(interp, (PObj *)data_struct->mode);
    if (data_struct->filename)
        pobject_lives(interp, (PObj *)data_struct->filename);
    if (data_struct->encoding)
        pobject_lives(interp, (PObj *)data_struct->encoding);
#line 151 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_open(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 2, 0, 2, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0, 1, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 5);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 3, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 4, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 193 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 210 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* filename = CTX_REG_STR(_ctx, 0);
    INTVAL got_filename = CTX_REG_INT(_ctx, 0);
    STRING* mode = CTX_REG_STR(_ctx, 1);
    INTVAL got_mode = CTX_REG_INT(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 197 "./src/pmc/filehandle.pmc"

    PMC *filehandle;
    STRING *open_filename, *open_mode;
    INTVAL flags;

    if (!Parrot_io_is_closed_filehandle(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
                            "Cannot reopen already open filehandle");

    if (got_mode && !STRING_IS_NULL(mode))
        SETATTR_FileHandle_mode(interp, pmc, Parrot_str_copy(interp, mode));

    if (got_filename && !STRING_IS_NULL(filename))
        SETATTR_FileHandle_filename(interp, pmc, Parrot_str_copy(interp, filename));

    /* Open the file. When no options are passed, reopen the same file as
     * before */
    GETATTR_FileHandle_filename(interp, pmc, open_filename);
    GETATTR_FileHandle_mode(interp, pmc, open_mode);


    if (STRING_IS_NULL(open_filename))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
                        "Cannot open filehandle, no filename");

    if (STRING_IS_NULL(open_mode)) {
        open_mode = CONST_STRING(interp, "r");
        SETATTR_FileHandle_mode(interp, pmc, open_mode);
    }

    flags = Parrot_io_parse_open_flags(interp, open_mode);
    filehandle = PIO_OPEN(interp, pmc, open_filename, flags);

    if (PMC_IS_NULL(filehandle))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
            "Unable to open filehandle from path '%S'",
            open_filename);

    Parrot_io_setbuf(interp, filehandle, PIO_UNBOUND);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *filehandle */
    /*BEGIN GENERATED ACCESSORS */
#line 266 "./src/pmc/filehandle.pmc"
    CTX_REG_PMC(_ctx, 0) = filehandle;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto open_returns;
    /*END RETURN PMC *filehandle */
    }
#line 237 "./src/pmc/filehandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
open_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 311 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_isatty(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 349 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 366 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 247 "./src/pmc/filehandle.pmc"

    INTVAL isatty = (PARROT_FILEHANDLE(pmc)->flags & PIO_F_CONSOLE) == PIO_F_CONSOLE;
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL isatty */
    /*BEGIN GENERATED ACCESSORS */
#line 380 "./src/pmc/filehandle.pmc"
    CTX_REG_INT(_ctx, 0) = isatty;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto isatty_returns;
    /*END RETURN INTVAL isatty */
    }
#line 249 "./src/pmc/filehandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
isatty_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 425 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_close(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 463 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 480 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 262 "./src/pmc/filehandle.pmc"

    INTVAL status;
    status = Parrot_io_close_filehandle(interp, pmc);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL status */
    /*BEGIN GENERATED ACCESSORS */
#line 495 "./src/pmc/filehandle.pmc"
    CTX_REG_INT(_ctx, 0) = status;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto close_returns;
    /*END RETURN INTVAL status */
    }
#line 265 "./src/pmc/filehandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
close_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 540 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_is_closed(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 578 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 595 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 278 "./src/pmc/filehandle.pmc"

    INTVAL status;
    status = Parrot_io_is_closed_filehandle(interp, pmc);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL status */
    /*BEGIN GENERATED ACCESSORS */
#line 610 "./src/pmc/filehandle.pmc"
    CTX_REG_INT(_ctx, 0) = status;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto is_closed_returns;
    /*END RETURN INTVAL status */
    }
#line 281 "./src/pmc/filehandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
is_closed_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 655 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_read(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 0);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 694 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 711 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    INTVAL length = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 294 "./src/pmc/filehandle.pmc"

    STRING *string_result = NULL;
    INTVAL  ignored;

    if (Parrot_io_is_closed_filehandle(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
            "Cannot read from a closed filehandle");

    string_result = Parrot_io_make_string(interp, &string_result, length);
    string_result->bufused = length;

    if (Parrot_io_is_encoding(interp, pmc, CONST_STRING(interp, "utf8")))
        ignored = Parrot_io_read_utf8(interp, pmc, &string_result);
    else
        ignored = Parrot_io_read_buffer(interp, pmc, &string_result);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
    /*BEGIN GENERATED ACCESSORS */
#line 740 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = string_result;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto read_returns;
    /*END RETURN STRING *string_result */
    }
#line 310 "./src/pmc/filehandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
read_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 785 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_readline(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 823 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 840 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 323 "./src/pmc/filehandle.pmc"

    STRING *string_result;
    if (!(PARROT_FILEHANDLE(pmc)->flags & PIO_F_LINEBUF))
        Parrot_io_setlinebuf(interp, pmc);

    string_result = Parrot_io_reads(interp, pmc, 0);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
    /*BEGIN GENERATED ACCESSORS */
#line 859 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = string_result;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto readline_returns;
    /*END RETURN STRING *string_result */
    }
#line 330 "./src/pmc/filehandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
readline_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 904 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_readline_interactive(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 944 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 961 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* prompt = CTX_REG_STR(_ctx, 0);
    INTVAL got_prompt = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 343 "./src/pmc/filehandle.pmc"

    STRING *string_result;
#ifdef PARROT_HAS_READLINE
    char * const r = readline(got_prompt ? prompt->strstart : NULL);

    if (r) {
        if (*r)
            add_history(r);

        string_result = Parrot_str_new(interp, r, 0);
        mem_sys_free(r);
        #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
    /*BEGIN GENERATED ACCESSORS */
#line 986 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = string_result;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto readline_interactive_returns;
    /*END RETURN STRING *string_result */
    }
#line 354 "./src/pmc/filehandle.pmc"

    }

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 1011 "./src/pmc/filehandle.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto readline_interactive_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 357 "./src/pmc/filehandle.pmc"

#else
    UINTVAL len;

    if (got_prompt)
        fprintf(stderr, "%s", prompt->strstart);

    if (!(PARROT_FILEHANDLE(pmc)->flags & PIO_F_LINEBUF))
        Parrot_io_setlinebuf(interp, pmc);

    string_result = Parrot_io_reads(interp, pmc, 0);
    if (!string_result)
        #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 1045 "./src/pmc/filehandle.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto readline_interactive_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 369 "./src/pmc/filehandle.pmc"

    len = Parrot_str_byte_length(interp, string_result);
    if (len < 1)
        #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 1070 "./src/pmc/filehandle.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto readline_interactive_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 372 "./src/pmc/filehandle.pmc"

    while (len > 0 &&
            (((char*)string_result->strstart)[len - 1] == '\n' ||
             ((char*)string_result->strstart)[len - 1] == '\r')) {
        --len;
        --string_result->strlen;
        --string_result->bufused;
    }

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *string_result */
    /*BEGIN GENERATED ACCESSORS */
#line 1101 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = string_result;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto readline_interactive_returns;
    /*END RETURN STRING *string_result */
    }
#line 381 "./src/pmc/filehandle.pmc"

#endif
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
readline_interactive_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1147 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_readall(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1187 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1204 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    INTVAL got_name = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 409 "./src/pmc/filehandle.pmc"

    STRING *result;

    if (got_name) {
        /* called as class method - open, slurp, close file */
        PMC *filehandle;
        STRING *encoding;
        size_t size;
        GETATTR_FileHandle_encoding(interp, pmc, encoding);
        if (!Parrot_io_is_closed_filehandle(interp, pmc)) {
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
                            "Cannot readall on a new file from an already open filehandle");
        }
        filehandle  = Parrot_io_open(interp, PMCNULL, name, NULL);
        SETATTR_FileHandle_encoding(interp, filehandle, encoding);
        size = (size_t)(Parrot_stat_info_intval(interp, name, STAT_FILESIZE));

        result = Parrot_io_reads(interp, filehandle, size);
        Parrot_io_close(interp, filehandle);
        #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
    /*BEGIN GENERATED ACCESSORS */
#line 1237 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = result;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto readall_returns;
    /*END RETURN STRING *result */
    }
#line 428 "./src/pmc/filehandle.pmc"

    }
    else {
        /* slurp open file */
        if (Parrot_io_is_closed_filehandle(interp, pmc)) {
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
                            "Cannot readall without a file name or open filehandle");
        }
        result = Parrot_str_new_noinit(interp, enum_stringrep_one, 0);

        /* Do line buffering on the filehandle */
        if (!(PARROT_FILEHANDLE(pmc)->flags & PIO_F_LINEBUF))
            Parrot_io_setlinebuf(interp, pmc);

        do {
            STRING * const part = Parrot_io_reads(interp, pmc, 0);

            result = Parrot_str_append(interp, result, part);
            if (Parrot_io_eof(interp, pmc))
                break;
        } while (1);
    }

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
    /*BEGIN GENERATED ACCESSORS */
#line 1282 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = result;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto readall_returns;
    /*END RETURN STRING *result */
    }
#line 451 "./src/pmc/filehandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
readall_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1327 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_flush(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1365 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1382 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 464 "./src/pmc/filehandle.pmc"

    Parrot_io_flush_filehandle(interp, pmc);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1406 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_print(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1445 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1462 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* to_print = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 479 "./src/pmc/filehandle.pmc"

    STRING * const string_to_print = VTABLE_get_string(interp, to_print);

    Parrot_io_putps(interp, pmc, string_to_print);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1489 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_puts(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1528 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1545 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* to_print = CTX_REG_STR(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 495 "./src/pmc/filehandle.pmc"

    INTVAL flags, status;
    if (Parrot_io_is_closed_filehandle(interp, pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
            "Cannot write to a closed filehandle");

    GETATTR_FileHandle_flags(interp, pmc, flags);
    if (!(flags & PIO_F_WRITE))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_PIO_ERROR,
            "Cannot write to a filehandle not opened for write");

    if (STRING_IS_NULL(to_print))
        #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
    /*BEGIN GENERATED ACCESSORS */
#line 1570 "./src/pmc/filehandle.pmc"
    CTX_REG_INT(_ctx, 0) = 0;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto puts_returns;
    /*END RETURN INTVAL 0 */
    }
#line 507 "./src/pmc/filehandle.pmc"


#if ! DISABLE_GC_DEBUG
    /* trigger GC for debug - but not during tests */
    if (0 && GC_DEBUG(interp))
        Parrot_do_gc_run(interp, GC_trace_stack_FLAG);
#endif

    if (Parrot_io_is_encoding(interp, pmc, CONST_STRING(interp, "utf8")))
        status = Parrot_io_write_utf8(interp, pmc, to_print);
    else
        status = Parrot_io_write_buffer(interp, pmc, to_print);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL status */
    /*BEGIN GENERATED ACCESSORS */
#line 1605 "./src/pmc/filehandle.pmc"
    CTX_REG_INT(_ctx, 0) = status;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto puts_returns;
    /*END RETURN INTVAL status */
    }
#line 520 "./src/pmc/filehandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
puts_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1650 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_buffer_type(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1690 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1707 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* new_type = CTX_REG_STR(_ctx, 0);
    INTVAL got_type = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 548 "./src/pmc/filehandle.pmc"

    INTVAL flags;
    STRING * const nobuffer_string   = CONST_STRING(interp, "unbuffered");
    STRING * const linebuffer_string = CONST_STRING(interp, "line-buffered");
    STRING * const fullbuffer_string = CONST_STRING(interp, "full-buffered");

    if (got_type) {
        if (Parrot_str_equal(interp, new_type, nobuffer_string))
            Parrot_io_setbuf(interp, pmc, PIOCTL_NONBUF);
        else if (Parrot_str_equal(interp, new_type, linebuffer_string))
            Parrot_io_setlinebuf(interp, pmc);
        else if (Parrot_str_equal(interp, new_type, fullbuffer_string))
            Parrot_io_setbuf(interp, pmc, PIO_UNBOUND);
    }

    GETATTR_FileHandle_flags(interp, pmc, flags);

    if (flags & PIO_F_LINEBUF)
        #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *linebuffer_string */
    /*BEGIN GENERATED ACCESSORS */
#line 1739 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = linebuffer_string;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto buffer_type_returns;
    /*END RETURN STRING *linebuffer_string */
    }
#line 566 "./src/pmc/filehandle.pmc"

    else if (flags & PIO_F_BLKBUF)
        #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *fullbuffer_string */
    /*BEGIN GENERATED ACCESSORS */
#line 1763 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = fullbuffer_string;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto buffer_type_returns;
    /*END RETURN STRING *fullbuffer_string */
    }
#line 568 "./src/pmc/filehandle.pmc"


    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *nobuffer_string */
    /*BEGIN GENERATED ACCESSORS */
#line 1787 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = nobuffer_string;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto buffer_type_returns;
    /*END RETURN STRING *nobuffer_string */
    }
#line 570 "./src/pmc/filehandle.pmc"


#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
buffer_type_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1833 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_buffer_size(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 2, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 128);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1873 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1890 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    INTVAL new_size = CTX_REG_INT(_ctx, 0);
    INTVAL got_size = CTX_REG_INT(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 584 "./src/pmc/filehandle.pmc"

    INTVAL buffer_size;

    if (got_size) {
        Parrot_io_setbuf(interp, pmc, (size_t) new_size);
    }

    buffer_size = (INTVAL) Parrot_io_get_buffer_size(interp, pmc);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL buffer_size */
    /*BEGIN GENERATED ACCESSORS */
#line 1913 "./src/pmc/filehandle.pmc"
    CTX_REG_INT(_ctx, 0) = buffer_size;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto buffer_size_returns;
    /*END RETURN INTVAL buffer_size */
    }
#line 593 "./src/pmc/filehandle.pmc"


#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
buffer_size_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1959 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_mode(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1997 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2014 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 607 "./src/pmc/filehandle.pmc"

    STRING *mode, *mode_copy;

    GETATTR_FileHandle_mode(interp, pmc, mode);
    mode_copy = Parrot_str_copy(interp, mode);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *mode_copy */
    /*BEGIN GENERATED ACCESSORS */
#line 2032 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = mode_copy;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto mode_returns;
    /*END RETURN STRING *mode_copy */
    }
#line 613 "./src/pmc/filehandle.pmc"


#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
mode_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2078 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_encoding(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2118 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2135 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* new_encoding = CTX_REG_STR(_ctx, 0);
    INTVAL got_encoding = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 628 "./src/pmc/filehandle.pmc"

    STRING *encoding;
    STRING *encoding_copy = NULL;

    if (got_encoding) {
        if (!STRING_IS_NULL(new_encoding))
            encoding_copy = Parrot_str_copy(interp, new_encoding);
        SETATTR_FileHandle_encoding(interp, pmc, encoding_copy);
        #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *new_encoding */
    /*BEGIN GENERATED ACCESSORS */
#line 2157 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = new_encoding;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto encoding_returns;
    /*END RETURN STRING *new_encoding */
    }
#line 636 "./src/pmc/filehandle.pmc"

    }

    GETATTR_FileHandle_encoding(interp, pmc, encoding);
    if (!STRING_IS_NULL(encoding))
        encoding_copy = Parrot_str_copy(interp, encoding);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *encoding_copy */
    /*BEGIN GENERATED ACCESSORS */
#line 2186 "./src/pmc/filehandle.pmc"
    CTX_REG_STR(_ctx, 0) = encoding_copy;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto encoding_returns;
    /*END RETURN STRING *encoding_copy */
    }
#line 643 "./src/pmc/filehandle.pmc"


#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
encoding_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2232 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_eof(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2270 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2287 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 657 "./src/pmc/filehandle.pmc"

    INTVAL flags;
    if (Parrot_io_is_closed_filehandle(interp, pmc))
        #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 1 */
    /*BEGIN GENERATED ACCESSORS */
#line 2302 "./src/pmc/filehandle.pmc"
    CTX_REG_INT(_ctx, 0) = 1;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto eof_returns;
    /*END RETURN INTVAL 1 */
    }
#line 660 "./src/pmc/filehandle.pmc"


    GETATTR_FileHandle_flags(interp, pmc, flags);
    if (flags & PIO_F_EOF)
        #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 1 */
    /*BEGIN GENERATED ACCESSORS */
#line 2328 "./src/pmc/filehandle.pmc"
    CTX_REG_INT(_ctx, 0) = 1;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto eof_returns;
    /*END RETURN INTVAL 1 */
    }
#line 664 "./src/pmc/filehandle.pmc"


    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL 0 */
    /*BEGIN GENERATED ACCESSORS */
#line 2352 "./src/pmc/filehandle.pmc"
    CTX_REG_INT(_ctx, 0) = 0;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto eof_returns;
    /*END RETURN INTVAL 0 */
    }
#line 666 "./src/pmc/filehandle.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
eof_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2397 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_nci_get_fd(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2435 "./src/pmc/filehandle.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2452 "./src/pmc/filehandle.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 681 "./src/pmc/filehandle.pmc"

#ifndef PIO_OS_STDIO
    INTVAL os_handle;
    GETATTR_FileHandle_os_handle(interp, pmc, os_handle);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL os_handle */
    /*BEGIN GENERATED ACCESSORS */
#line 2468 "./src/pmc/filehandle.pmc"
    CTX_REG_INT(_ctx, 0) = os_handle;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto get_fd_returns;
    /*END RETURN INTVAL os_handle */
    }
#line 685 "./src/pmc/filehandle.pmc"

#endif /*PIO_OS_STDIO*/

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL -1 */
    /*BEGIN GENERATED ACCESSORS */
#line 2493 "./src/pmc/filehandle.pmc"
    CTX_REG_INT(_ctx, 0) = -1;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto get_fd_returns;
    /*END RETURN INTVAL -1 */
    }
#line 688 "./src/pmc/filehandle.pmc"


#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_fd_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2539 "./src/pmc/filehandle.c"
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  PMC *
Parrot_FileHandle_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of FileHandle");
}
PARROT_EXPORT  FLOATVAL
Parrot_FileHandle_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of FileHandle");
}
PARROT_EXPORT  INTVAL
Parrot_FileHandle_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of FileHandle");
}
PARROT_EXPORT  PMC *
Parrot_FileHandle_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of FileHandle");
}
PARROT_EXPORT  STRING *
Parrot_FileHandle_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of FileHandle");
}
PARROT_EXPORT  FLOATVAL
Parrot_FileHandle_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of FileHandle");
}
PARROT_EXPORT  INTVAL
Parrot_FileHandle_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of FileHandle");
}
PARROT_EXPORT  PMC *
Parrot_FileHandle_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of FileHandle");
}
PARROT_EXPORT  STRING *
Parrot_FileHandle_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of FileHandle");
}
PARROT_EXPORT  void
Parrot_FileHandle_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of FileHandle");
}
#include "pmc_default.h"
void
Parrot_FileHandle_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iflags Sfilename Smode Sencoding :os_handle :file_size :file_pos :last_pos :buffer_size Ibuffer_flags :buffer_start :buffer_end :buffer_next ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_FileHandle, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_FileHandle_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FileHandle_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FileHandle_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_FileHandle_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_FileHandle_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_FileHandle, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_FileHandle_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_FileHandle_ro_add_method,
        Parrot_FileHandle_ro_add_parent,
        Parrot_FileHandle_ro_add_role,
        Parrot_FileHandle_ro_add_vtable_override,
        Parrot_FileHandle_ro_assign_pmc,
        Parrot_FileHandle_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_FileHandle_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_FileHandle_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_FileHandle_ro_delete_keyed,
        Parrot_FileHandle_ro_delete_keyed_int,
        Parrot_FileHandle_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FileHandle_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_FileHandle_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FileHandle_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_FileHandle_ro_i_absolute,
        Parrot_FileHandle_ro_i_add,
        Parrot_FileHandle_ro_i_add_float,
        Parrot_FileHandle_ro_i_add_int,
        Parrot_FileHandle_ro_i_bitwise_and,
        Parrot_FileHandle_ro_i_bitwise_and_int,
        Parrot_FileHandle_ro_i_bitwise_ands,
        Parrot_FileHandle_ro_i_bitwise_ands_str,
        Parrot_FileHandle_ro_i_bitwise_lsr,
        Parrot_FileHandle_ro_i_bitwise_lsr_int,
        Parrot_FileHandle_ro_i_bitwise_not,
        Parrot_FileHandle_ro_i_bitwise_nots,
        Parrot_FileHandle_ro_i_bitwise_or,
        Parrot_FileHandle_ro_i_bitwise_or_int,
        Parrot_FileHandle_ro_i_bitwise_ors,
        Parrot_FileHandle_ro_i_bitwise_ors_str,
        Parrot_FileHandle_ro_i_bitwise_shl,
        Parrot_FileHandle_ro_i_bitwise_shl_int,
        Parrot_FileHandle_ro_i_bitwise_shr,
        Parrot_FileHandle_ro_i_bitwise_shr_int,
        Parrot_FileHandle_ro_i_bitwise_xor,
        Parrot_FileHandle_ro_i_bitwise_xor_int,
        Parrot_FileHandle_ro_i_bitwise_xors,
        Parrot_FileHandle_ro_i_bitwise_xors_str,
        Parrot_FileHandle_ro_i_concatenate,
        Parrot_FileHandle_ro_i_concatenate_str,
        Parrot_FileHandle_ro_i_divide,
        Parrot_FileHandle_ro_i_divide_float,
        Parrot_FileHandle_ro_i_divide_int,
        Parrot_FileHandle_ro_i_floor_divide,
        Parrot_FileHandle_ro_i_floor_divide_float,
        Parrot_FileHandle_ro_i_floor_divide_int,
        Parrot_FileHandle_ro_i_logical_not,
        Parrot_FileHandle_ro_i_modulus,
        Parrot_FileHandle_ro_i_modulus_float,
        Parrot_FileHandle_ro_i_modulus_int,
        Parrot_FileHandle_ro_i_multiply,
        Parrot_FileHandle_ro_i_multiply_float,
        Parrot_FileHandle_ro_i_multiply_int,
        Parrot_FileHandle_ro_i_neg,
        Parrot_FileHandle_ro_i_pow,
        Parrot_FileHandle_ro_i_pow_float,
        Parrot_FileHandle_ro_i_pow_int,
        Parrot_FileHandle_ro_i_repeat,
        Parrot_FileHandle_ro_i_repeat_int,
        Parrot_FileHandle_ro_i_subtract,
        Parrot_FileHandle_ro_i_subtract_float,
        Parrot_FileHandle_ro_i_subtract_int,
        Parrot_FileHandle_ro_increment,
        Parrot_FileHandle_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_FileHandle_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_FileHandle_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_FileHandle_ro_pop_float,
        Parrot_FileHandle_ro_pop_integer,
        Parrot_FileHandle_ro_pop_pmc,
        Parrot_FileHandle_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_FileHandle_ro_push_float,
        Parrot_FileHandle_ro_push_integer,
        Parrot_FileHandle_ro_push_pmc,
        Parrot_FileHandle_ro_push_string,
        Parrot_FileHandle_ro_remove_attribute,
        Parrot_FileHandle_ro_remove_method,
        Parrot_FileHandle_ro_remove_parent,
        Parrot_FileHandle_ro_remove_role,
        Parrot_FileHandle_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_FileHandle_ro_set_attr_keyed,
        Parrot_FileHandle_ro_set_attr_str,
        Parrot_FileHandle_ro_set_bignum_int,
        Parrot_FileHandle_ro_set_bignum_num,
        Parrot_FileHandle_ro_set_bignum_str,
        Parrot_FileHandle_ro_set_bool,
        Parrot_FileHandle_ro_set_integer_keyed,
        Parrot_FileHandle_ro_set_integer_keyed_int,
        Parrot_FileHandle_ro_set_integer_keyed_str,
        Parrot_FileHandle_ro_set_integer_native,
        Parrot_FileHandle_ro_set_integer_same,
        Parrot_FileHandle_ro_set_number_keyed,
        Parrot_FileHandle_ro_set_number_keyed_int,
        Parrot_FileHandle_ro_set_number_keyed_str,
        Parrot_FileHandle_ro_set_number_native,
        Parrot_FileHandle_ro_set_number_same,
        Parrot_FileHandle_ro_set_pmc,
        Parrot_FileHandle_ro_set_pmc_keyed,
        Parrot_FileHandle_ro_set_pmc_keyed_int,
        Parrot_FileHandle_ro_set_pmc_keyed_str,
        Parrot_FileHandle_ro_set_pointer,
        Parrot_FileHandle_ro_set_pointer_keyed,
        Parrot_FileHandle_ro_set_pointer_keyed_int,
        Parrot_FileHandle_ro_set_pointer_keyed_str,
        Parrot_FileHandle_ro_set_string_keyed,
        Parrot_FileHandle_ro_set_string_keyed_int,
        Parrot_FileHandle_ro_set_string_keyed_str,
        Parrot_FileHandle_ro_set_string_native,
        Parrot_FileHandle_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_FileHandle_ro_shift_float,
        Parrot_FileHandle_ro_shift_integer,
        Parrot_FileHandle_ro_shift_pmc,
        Parrot_FileHandle_ro_shift_string,
        Parrot_default_slice,
        Parrot_FileHandle_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_FileHandle_ro_thaw,
        Parrot_FileHandle_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_FileHandle_ro_unshift_float,
        Parrot_FileHandle_ro_unshift_integer,
        Parrot_FileHandle_ro_unshift_pmc,
        Parrot_FileHandle_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "FileHandle");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "FileHandle")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "FileHandle"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_open), "open");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_isatty), "isatty");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_close), "close");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_is_closed), "is_closed");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_read), "read");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_readline), "readline");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_readline_interactive), "readline_interactive");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_readall), "readall");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_flush), "flush");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_print), "print");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_puts), "puts");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_buffer_type), "buffer_type");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_buffer_size), "buffer_size");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_mode), "mode");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_encoding), "encoding");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_eof), "eof");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FileHandle_nci_get_fd), "get_fd");
        {
        }
    } /* pass */
} /* Parrot_FileHandle_class_init */
#line 690 "./src/pmc/filehandle.pmc"
 /* end pmclass */

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
