/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/fixedbooleanarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_fixedbooleanarray.h"
#include "pmc_default.h"
#include "fixedbooleanarray.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/fixedbooleanarray.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: fixedbooleanarray.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/fixedbooleanarray.pmc - fixed size array for booleans only

=head1 DESCRIPTION

The C<FixedBooleanArray> PMC implements an array of fixed size, which
stores booleans.  It uses the C<Boolean> PMC for all conversions.  The
C<FixedBooleanArray> PMC is extended by the C<ResizableBooleanArray>
PMC.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#define BITS_PER_CHAR 8
#line 49 "./src/pmc/fixedbooleanarray.c"
PARROT_EXPORT  PMC  *
Parrot_FixedBooleanArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 85 "./src/pmc/fixedbooleanarray.pmc"

    unsigned char * my_bit_array, * clone_bit_array;
    UINTVAL         resize_threshold, size;
    PMC *   const   dest   = pmc_new(interp, pmc->vtable->base_type);

    GETATTR_FixedBooleanArray_bit_array(interp, pmc, my_bit_array);
    GETATTR_FixedBooleanArray_size(interp, pmc, size);
    GETATTR_FixedBooleanArray_resize_threshold(interp, pmc, resize_threshold);

    if (my_bit_array) {
        size_t size_in_bytes;

        SETATTR_FixedBooleanArray_size(interp, dest, size);
        SETATTR_FixedBooleanArray_resize_threshold(interp, dest, resize_threshold);

        size_in_bytes   = resize_threshold / BITS_PER_CHAR;
        clone_bit_array = (unsigned char*)mem_sys_allocate(size_in_bytes);
        mem_sys_memcopy(clone_bit_array, my_bit_array, size_in_bytes);

        SETATTR_FixedBooleanArray_bit_array(interp, dest, clone_bit_array);
    }

    PObj_active_destroy_SET(dest);
    return dest;
#line 78 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_destroy(PARROT_INTERP, PMC *pmc)
{
#line 67 "./src/pmc/fixedbooleanarray.pmc"

    unsigned char *bit_array;
    GETATTR_FixedBooleanArray_bit_array(interp, pmc, bit_array);
    if (bit_array)
        mem_sys_free(bit_array);
    mem_sys_free(PMC_data(pmc));
#line 90 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedBooleanArray_elements(PARROT_INTERP, PMC *pmc)
{
#line 133 "./src/pmc/fixedbooleanarray.pmc"

    UINTVAL size;
    GETATTR_FixedBooleanArray_size(interp, pmc, size);
    return size;
#line 100 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 513 "./src/pmc/fixedbooleanarray.pmc"

    UINTVAL          size, resize_threshold;
    unsigned char  * bit_array;
    IMAGE_IO * const io = info->image_io;
    STRING   *       s;
    GETATTR_FixedBooleanArray_size(interp, pmc, size);
    GETATTR_FixedBooleanArray_resize_threshold(interp, pmc, resize_threshold);
    GETATTR_FixedBooleanArray_bit_array(interp, pmc, bit_array);

    s = Parrot_str_new(interp, (char*)bit_array,
            (resize_threshold / BITS_PER_CHAR));

    VTABLE_push_integer(interp, io, size);
    VTABLE_push_string(interp, io, s);
#line 120 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedBooleanArray_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 121 "./src/pmc/fixedbooleanarray.pmc"

    return VTABLE_elements(interp, pmc) ? 1 : 0;
#line 128 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedBooleanArray_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 149 "./src/pmc/fixedbooleanarray.pmc"

    return VTABLE_elements(interp, pmc);
#line 136 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedBooleanArray_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 186 "./src/pmc/fixedbooleanarray.pmc"

    /* simple int keys only */
    const INTVAL k = key_integer(interp, key);
    return VTABLE_get_integer_keyed_int(interp, pmc, k);
#line 146 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedBooleanArray_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 163 "./src/pmc/fixedbooleanarray.pmc"

    UINTVAL               size;
    const unsigned char * bit_array;
    GETATTR_FixedBooleanArray_bit_array(interp, pmc, bit_array);
    GETATTR_FixedBooleanArray_size(interp, pmc, size);

    if (key < 0 || (UINTVAL)key >= size)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "FixedBooleanArray: index out of bounds!");

    return (bit_array[key / BITS_PER_CHAR] & (1 << (key % BITS_PER_CHAR))) ? 1 : 0;
#line 163 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_FixedBooleanArray_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 218 "./src/pmc/fixedbooleanarray.pmc"

    const INTVAL k = key_integer(interp, key);
    return VTABLE_get_number_keyed_int(interp, pmc, k);
#line 172 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_FixedBooleanArray_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 203 "./src/pmc/fixedbooleanarray.pmc"

    const INTVAL i = VTABLE_get_integer_keyed_int(interp, pmc, key);
    return (FLOATVAL)i;
#line 181 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  PMC  *
Parrot_FixedBooleanArray_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 311 "./src/pmc/fixedbooleanarray.pmc"

    const INTVAL k = key_integer(interp, key);
    return VTABLE_get_pmc_keyed_int(interp, pmc, k);
#line 190 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  PMC  *
Parrot_FixedBooleanArray_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 294 "./src/pmc/fixedbooleanarray.pmc"

    PMC  * const ret = pmc_new(interp, enum_class_Boolean);
    const INTVAL val = VTABLE_get_integer_keyed_int(interp, pmc, key);
    VTABLE_set_integer_native(interp, ret, val);
    return ret;
#line 201 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_FixedBooleanArray_get_string(PARROT_INTERP, PMC *pmc)
{
#line 233 "./src/pmc/fixedbooleanarray.pmc"

    STRING *zero, *one;
    STRING *str   = NULL;
    UINTVAL i;
    UINTVAL elems = VTABLE_elements(interp, pmc);

    zero = CONST_STRING(interp, "0");
    one  = CONST_STRING(interp, "1");

    for (i = 0; i < elems; i++) {
        if (VTABLE_get_integer_keyed_int(interp, pmc, (INTVAL)i))
            str = Parrot_str_concat(interp, str, one, 0);
        else
            str = Parrot_str_concat(interp, str, zero, 0);
    }

    return str;

#line 225 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_FixedBooleanArray_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 278 "./src/pmc/fixedbooleanarray.pmc"

    const INTVAL k = key_integer(interp, key);
    return VTABLE_get_string_keyed_int(interp, pmc, k);
#line 234 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_FixedBooleanArray_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 263 "./src/pmc/fixedbooleanarray.pmc"

    PMC * const val = VTABLE_get_pmc_keyed_int(interp, pmc, key);
    return VTABLE_get_string(interp, val);
#line 243 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_init(PARROT_INTERP, PMC *pmc)
{
#line 49 "./src/pmc/fixedbooleanarray.pmc"

    Parrot_FixedBooleanArray_attributes* attrs =
        mem_allocate_zeroed_typed(Parrot_FixedBooleanArray_attributes);

    PMC_data(pmc) = attrs;
    PObj_active_destroy_SET(pmc);
#line 255 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 493 "./src/pmc/fixedbooleanarray.pmc"

    const INTVAL nextix = VTABLE_elements(interp, pmc);
    VTABLE_set_integer_keyed_int(interp, pmc, nextix, value);
#line 264 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 379 "./src/pmc/fixedbooleanarray.pmc"

    const INTVAL k = key_integer(interp, key);
    VTABLE_set_integer_keyed_int(interp, pmc, k, value);
#line 273 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 353 "./src/pmc/fixedbooleanarray.pmc"

    UINTVAL size;
    unsigned char * bit_array;
    GETATTR_FixedBooleanArray_bit_array(interp, pmc, bit_array);
    GETATTR_FixedBooleanArray_size(interp, pmc, size);

    if (key < 0 || (UINTVAL)key >= size)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "FixedBooleanArray: index out of bounds!");

    if (value)
        bit_array[key/BITS_PER_CHAR] |=  (1 << (key % BITS_PER_CHAR));
    else
        bit_array[key/BITS_PER_CHAR] &= ~(1 << (key % BITS_PER_CHAR));
#line 293 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 326 "./src/pmc/fixedbooleanarray.pmc"

    size_t size_in_bytes;
    UINTVAL old_size;

    GETATTR_FixedBooleanArray_size(interp, pmc, old_size);

    if (old_size || size < 1)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "FixedBooleanArray: Can't resize!");

    size_in_bytes = size / BITS_PER_CHAR + 1;
    SETATTR_FixedBooleanArray_size(interp, pmc, size);
    SETATTR_FixedBooleanArray_resize_threshold(interp, pmc, size_in_bytes * BITS_PER_CHAR);
    SETATTR_FixedBooleanArray_bit_array(interp, pmc,
            (unsigned char*)mem_sys_allocate_zeroed(size_in_bytes));
#line 314 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 410 "./src/pmc/fixedbooleanarray.pmc"

    const INTVAL k = key_integer(interp, key);
    VTABLE_set_number_keyed_int(interp, pmc, k, value);
#line 323 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 395 "./src/pmc/fixedbooleanarray.pmc"

    VTABLE_set_integer_keyed_int(interp, pmc, key, !FLOAT_IS_ZERO(value));
#line 331 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 477 "./src/pmc/fixedbooleanarray.pmc"

    const INTVAL k = key_integer(interp, key);
    VTABLE_set_pmc_keyed_int(interp, pmc, k, value);
#line 340 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *src)
{
#line 461 "./src/pmc/fixedbooleanarray.pmc"

    const INTVAL tempInt = VTABLE_get_integer(interp, src);
    VTABLE_set_integer_keyed_int(interp, pmc, key, tempInt);
#line 349 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 446 "./src/pmc/fixedbooleanarray.pmc"

    const INTVAL k = key_integer(interp, key);
    VTABLE_set_string_keyed_int(interp, pmc, k, value);
#line 358 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 425 "./src/pmc/fixedbooleanarray.pmc"

    INTVAL tempInt;
    PMC * const tempPMC = pmc_new(interp, enum_class_Boolean);

    VTABLE_set_string_native(interp, tempPMC, value);
    tempInt = VTABLE_get_integer(interp, tempPMC);

    VTABLE_set_integer_keyed_int(interp, pmc, key, tempInt);
#line 372 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedBooleanArray_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 538 "./src/pmc/fixedbooleanarray.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_thaw(interp, pmc, info);

    if (info->extra_flags == EXTRA_IS_NULL) {
        unsigned char * bit_array;
        const INTVAL    size      = VTABLE_shift_integer(interp, io);
        STRING * const  s         = VTABLE_shift_string(interp, io);

        bit_array = (unsigned char*)mem_sys_allocate_zeroed(s->bufused);
        mem_sys_memcopy(bit_array, s->strstart, s->bufused);

        SETATTR_FixedBooleanArray_size(interp, pmc, size);
        SETATTR_FixedBooleanArray_resize_threshold(interp, pmc,
                s->bufused * BITS_PER_CHAR);
        SETATTR_FixedBooleanArray_bit_array(interp, pmc, bit_array);
    }
#line 395 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_nci_fill(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 0);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 434 "./src/pmc/fixedbooleanarray.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 451 "./src/pmc/fixedbooleanarray.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    INTVAL fill = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 568 "./src/pmc/fixedbooleanarray.pmc"

    UINTVAL         size;
    unsigned char * bit_array;
    size_t          j;

    GETATTR_FixedBooleanArray_bit_array(interp, pmc, bit_array);
    GETATTR_FixedBooleanArray_size(interp, pmc, size);
    j  = size / BITS_PER_CHAR + 1;

    if (fill)
        memset(bit_array, 0xff, j);
    else
        memset(bit_array, 0, j);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 487 "./src/pmc/fixedbooleanarray.c"
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  PMC *
Parrot_FixedBooleanArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  FLOATVAL
Parrot_FixedBooleanArray_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  INTVAL
Parrot_FixedBooleanArray_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  PMC *
Parrot_FixedBooleanArray_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  STRING *
Parrot_FixedBooleanArray_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  FLOATVAL
Parrot_FixedBooleanArray_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  INTVAL
Parrot_FixedBooleanArray_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  PMC *
Parrot_FixedBooleanArray_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  STRING *
Parrot_FixedBooleanArray_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of FixedBooleanArray");
}
PARROT_EXPORT  void
Parrot_FixedBooleanArray_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of FixedBooleanArray");
}
#include "pmc_default.h"
void
Parrot_FixedBooleanArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":size :resize_threshold :bit_array ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_FixedBooleanArray, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_FixedBooleanArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_FixedBooleanArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_FixedBooleanArray_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_FixedBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_FixedBooleanArray_get_string,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_FixedBooleanArray_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedBooleanArray_set_integer_keyed,
        Parrot_FixedBooleanArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_FixedBooleanArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedBooleanArray_set_number_keyed,
        Parrot_FixedBooleanArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedBooleanArray_set_pmc_keyed,
        Parrot_FixedBooleanArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedBooleanArray_set_string_keyed,
        Parrot_FixedBooleanArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_FixedBooleanArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_FixedBooleanArray, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_FixedBooleanArray_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_FixedBooleanArray_ro_add_method,
        Parrot_FixedBooleanArray_ro_add_parent,
        Parrot_FixedBooleanArray_ro_add_role,
        Parrot_FixedBooleanArray_ro_add_vtable_override,
        Parrot_FixedBooleanArray_ro_assign_pmc,
        Parrot_FixedBooleanArray_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_FixedBooleanArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_FixedBooleanArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_FixedBooleanArray_ro_delete_keyed,
        Parrot_FixedBooleanArray_ro_delete_keyed_int,
        Parrot_FixedBooleanArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_FixedBooleanArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_FixedBooleanArray_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_FixedBooleanArray_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_FixedBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_FixedBooleanArray_get_string,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_FixedBooleanArray_ro_i_absolute,
        Parrot_FixedBooleanArray_ro_i_add,
        Parrot_FixedBooleanArray_ro_i_add_float,
        Parrot_FixedBooleanArray_ro_i_add_int,
        Parrot_FixedBooleanArray_ro_i_bitwise_and,
        Parrot_FixedBooleanArray_ro_i_bitwise_and_int,
        Parrot_FixedBooleanArray_ro_i_bitwise_ands,
        Parrot_FixedBooleanArray_ro_i_bitwise_ands_str,
        Parrot_FixedBooleanArray_ro_i_bitwise_lsr,
        Parrot_FixedBooleanArray_ro_i_bitwise_lsr_int,
        Parrot_FixedBooleanArray_ro_i_bitwise_not,
        Parrot_FixedBooleanArray_ro_i_bitwise_nots,
        Parrot_FixedBooleanArray_ro_i_bitwise_or,
        Parrot_FixedBooleanArray_ro_i_bitwise_or_int,
        Parrot_FixedBooleanArray_ro_i_bitwise_ors,
        Parrot_FixedBooleanArray_ro_i_bitwise_ors_str,
        Parrot_FixedBooleanArray_ro_i_bitwise_shl,
        Parrot_FixedBooleanArray_ro_i_bitwise_shl_int,
        Parrot_FixedBooleanArray_ro_i_bitwise_shr,
        Parrot_FixedBooleanArray_ro_i_bitwise_shr_int,
        Parrot_FixedBooleanArray_ro_i_bitwise_xor,
        Parrot_FixedBooleanArray_ro_i_bitwise_xor_int,
        Parrot_FixedBooleanArray_ro_i_bitwise_xors,
        Parrot_FixedBooleanArray_ro_i_bitwise_xors_str,
        Parrot_FixedBooleanArray_ro_i_concatenate,
        Parrot_FixedBooleanArray_ro_i_concatenate_str,
        Parrot_FixedBooleanArray_ro_i_divide,
        Parrot_FixedBooleanArray_ro_i_divide_float,
        Parrot_FixedBooleanArray_ro_i_divide_int,
        Parrot_FixedBooleanArray_ro_i_floor_divide,
        Parrot_FixedBooleanArray_ro_i_floor_divide_float,
        Parrot_FixedBooleanArray_ro_i_floor_divide_int,
        Parrot_FixedBooleanArray_ro_i_logical_not,
        Parrot_FixedBooleanArray_ro_i_modulus,
        Parrot_FixedBooleanArray_ro_i_modulus_float,
        Parrot_FixedBooleanArray_ro_i_modulus_int,
        Parrot_FixedBooleanArray_ro_i_multiply,
        Parrot_FixedBooleanArray_ro_i_multiply_float,
        Parrot_FixedBooleanArray_ro_i_multiply_int,
        Parrot_FixedBooleanArray_ro_i_neg,
        Parrot_FixedBooleanArray_ro_i_pow,
        Parrot_FixedBooleanArray_ro_i_pow_float,
        Parrot_FixedBooleanArray_ro_i_pow_int,
        Parrot_FixedBooleanArray_ro_i_repeat,
        Parrot_FixedBooleanArray_ro_i_repeat_int,
        Parrot_FixedBooleanArray_ro_i_subtract,
        Parrot_FixedBooleanArray_ro_i_subtract_float,
        Parrot_FixedBooleanArray_ro_i_subtract_int,
        Parrot_FixedBooleanArray_ro_increment,
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_FixedBooleanArray_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_FixedBooleanArray_ro_pop_float,
        Parrot_FixedBooleanArray_ro_pop_integer,
        Parrot_FixedBooleanArray_ro_pop_pmc,
        Parrot_FixedBooleanArray_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_FixedBooleanArray_ro_push_float,
        Parrot_FixedBooleanArray_ro_push_integer,
        Parrot_FixedBooleanArray_ro_push_pmc,
        Parrot_FixedBooleanArray_ro_push_string,
        Parrot_FixedBooleanArray_ro_remove_attribute,
        Parrot_FixedBooleanArray_ro_remove_method,
        Parrot_FixedBooleanArray_ro_remove_parent,
        Parrot_FixedBooleanArray_ro_remove_role,
        Parrot_FixedBooleanArray_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_FixedBooleanArray_ro_set_attr_keyed,
        Parrot_FixedBooleanArray_ro_set_attr_str,
        Parrot_FixedBooleanArray_ro_set_bignum_int,
        Parrot_FixedBooleanArray_ro_set_bignum_num,
        Parrot_FixedBooleanArray_ro_set_bignum_str,
        Parrot_FixedBooleanArray_ro_set_bool,
        Parrot_FixedBooleanArray_ro_set_integer_keyed,
        Parrot_FixedBooleanArray_ro_set_integer_keyed_int,
        Parrot_FixedBooleanArray_ro_set_integer_keyed_str,
        Parrot_FixedBooleanArray_ro_set_integer_native,
        Parrot_FixedBooleanArray_ro_set_integer_same,
        Parrot_FixedBooleanArray_ro_set_number_keyed,
        Parrot_FixedBooleanArray_ro_set_number_keyed_int,
        Parrot_FixedBooleanArray_ro_set_number_keyed_str,
        Parrot_FixedBooleanArray_ro_set_number_native,
        Parrot_FixedBooleanArray_ro_set_number_same,
        Parrot_FixedBooleanArray_ro_set_pmc,
        Parrot_FixedBooleanArray_ro_set_pmc_keyed,
        Parrot_FixedBooleanArray_ro_set_pmc_keyed_int,
        Parrot_FixedBooleanArray_ro_set_pmc_keyed_str,
        Parrot_FixedBooleanArray_ro_set_pointer,
        Parrot_FixedBooleanArray_ro_set_pointer_keyed,
        Parrot_FixedBooleanArray_ro_set_pointer_keyed_int,
        Parrot_FixedBooleanArray_ro_set_pointer_keyed_str,
        Parrot_FixedBooleanArray_ro_set_string_keyed,
        Parrot_FixedBooleanArray_ro_set_string_keyed_int,
        Parrot_FixedBooleanArray_ro_set_string_keyed_str,
        Parrot_FixedBooleanArray_ro_set_string_native,
        Parrot_FixedBooleanArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_FixedBooleanArray_ro_shift_float,
        Parrot_FixedBooleanArray_ro_shift_integer,
        Parrot_FixedBooleanArray_ro_shift_pmc,
        Parrot_FixedBooleanArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_FixedBooleanArray_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_FixedBooleanArray_ro_thaw,
        Parrot_FixedBooleanArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_FixedBooleanArray_ro_unshift_float,
        Parrot_FixedBooleanArray_ro_unshift_integer,
        Parrot_FixedBooleanArray_ro_unshift_pmc,
        Parrot_FixedBooleanArray_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "FixedBooleanArray");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "array");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "FixedBooleanArray")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "FixedBooleanArray"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FixedBooleanArray_nci_fill), "fill");
        {
        }
    } /* pass */
} /* Parrot_FixedBooleanArray_class_init */
#line 581 "./src/pmc/fixedbooleanarray.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
