/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/fixedpmcarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_fixedpmcarray.h"
#include "pmc_default.h"
#include "fixedpmcarray.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/fixedpmcarray.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: fixedpmcarray.pmc 37267 2009-03-10 10:01:14Z cotto $

=head1 NAME

src/pmc/fixedpmcarray.pmc - fixed size array for PMCs only

=head1 DESCRIPTION

This class, FixedPMCArray, implements an array of fixed size which stores PMCs.
It puts things into Integer, Float, or String PMCs as appropriate

=head2 Note

The flag C<PObj_private0_FLAG> is used in the C<NameSpace> PMC and should
never be set for user arrays.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#define PMC_size(x)  ((Parrot_FixedPMCArray_attributes *)PMC_data(x))->size
#define PMC_array(x) ((Parrot_FixedPMCArray_attributes *)PMC_data(x))->pmc_array
#line 53 "./src/pmc/fixedpmcarray.c"
PARROT_EXPORT  PMC  *
Parrot_FixedPMCArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 104 "./src/pmc/fixedpmcarray.pmc"

    PMC * const dest  = pmc_new(interp, pmc->vtable->base_type);
    const INTVAL size = PMC_size(pmc);

    if (size) {
        PMC_size(dest) = size;
        PMC_array(dest)    = mem_allocate_n_typed(size, PMC *);
        mem_copy_n_typed(PMC_array(dest), PMC_array(pmc), size, PMC *);
        PObj_custom_mark_destroy_SETALL(dest);
    }

    return dest;
#line 70 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedPMCArray_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 775 "./src/pmc/fixedpmcarray.pmc"

    PMC * const val = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    if (PMC_IS_NULL(val))
        return 0;

    return VTABLE_defined(interp, val);
#line 83 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_destroy(PARROT_INTERP, PMC *pmc)
{
#line 87 "./src/pmc/fixedpmcarray.pmc"

    if (PMC_array(pmc)) {
        mem_sys_free(PMC_array(pmc));
    }
    mem_sys_free(PMC_data(pmc));
#line 94 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedPMCArray_elements(PARROT_INTERP, PMC *pmc)
{
#line 141 "./src/pmc/fixedpmcarray.pmc"

    return PMC_size(pmc);
#line 102 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedPMCArray_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 687 "./src/pmc/fixedpmcarray.pmc"

    const INTVAL ix = key_integer(interp, key);
    return VTABLE_exists_keyed_int(interp, pmc, ix);
#line 111 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedPMCArray_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 677 "./src/pmc/fixedpmcarray.pmc"

    PMC **data;
    if (key < 0 || key >= PMC_size(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            _("FixedPMCArray: index out of bounds!"));

    data = PMC_array(pmc);
    return !PMC_IS_NULL(data[key]);
#line 125 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 752 "./src/pmc/fixedpmcarray.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_freeze(interp, pmc, info);
    VTABLE_push_integer(interp, io, VTABLE_elements(interp, pmc));
#line 135 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedPMCArray_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 128 "./src/pmc/fixedpmcarray.pmc"

    const INTVAL size = VTABLE_elements(interp, pmc);
    return (INTVAL)(size != 0);
#line 144 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedPMCArray_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 155 "./src/pmc/fixedpmcarray.pmc"

    return VTABLE_elements(interp, pmc);
#line 152 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedPMCArray_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 240 "./src/pmc/fixedpmcarray.pmc"

    PMC * const tempPMC = VTABLE_get_pmc_keyed(interp, pmc, key);
    return VTABLE_get_integer(interp, tempPMC);
#line 161 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedPMCArray_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 223 "./src/pmc/fixedpmcarray.pmc"

    PMC * const tempPMC = VTABLE_get_pmc_keyed_int(interp, pmc, key);
    if (PMC_IS_NULL(tempPMC))
        return 0;
    return VTABLE_get_integer(interp, tempPMC);
#line 172 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  PMC  *
Parrot_FixedPMCArray_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 650 "./src/pmc/fixedpmcarray.pmc"

    STRING     *name     = CONST_STRING(interp, "set_key");
    PMC * const iter     = pmc_new_init(interp, enum_class_Iterator, pmc);
    PMC * const key      = pmc_new(interp, enum_class_Key);

    Parrot_PCCINVOKE(interp, iter, name, "P->", key);
    PObj_get_FLAGS(key) |= KEY_integer_FLAG;

    if (PMC_size(pmc) == 0)
        VTABLE_set_integer_native(interp, key, -1);
    else
        VTABLE_set_integer_native(interp, key, 0);

    return iter;
#line 192 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_FixedPMCArray_get_number(PARROT_INTERP, PMC *pmc)
{
#line 169 "./src/pmc/fixedpmcarray.pmc"

    const INTVAL e = VTABLE_elements(interp, pmc);
    return (FLOATVAL)e;
#line 201 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_FixedPMCArray_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 270 "./src/pmc/fixedpmcarray.pmc"

    PMC * const tempPMC = VTABLE_get_pmc_keyed(interp, pmc, key);
    return VTABLE_get_number(interp, tempPMC);
#line 210 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_FixedPMCArray_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 255 "./src/pmc/fixedpmcarray.pmc"

    PMC * const tempPMC = VTABLE_get_pmc_keyed_int(interp, pmc, key);
    return VTABLE_get_number(interp, tempPMC);
#line 219 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  PMC  *
Parrot_FixedPMCArray_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 340 "./src/pmc/fixedpmcarray.pmc"

    const INTVAL k        = key_integer(interp, key);
    PMC   * const nextkey = key_next(interp, key);
    PMC   *box;

    if (!nextkey)
        return VTABLE_get_pmc_keyed_int(interp, pmc, k);

    box = VTABLE_get_pmc_keyed_int(interp, pmc, k);

    if (box == NULL)
        box = pmc_new(interp, enum_class_Undef);

    return VTABLE_get_pmc_keyed(interp, box, nextkey);
#line 239 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  PMC  *
Parrot_FixedPMCArray_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 319 "./src/pmc/fixedpmcarray.pmc"

    PMC **data;

    if (key < 0 || key >= PMC_size(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            _("FixedPMCArray: index out of bounds!"));

    data = PMC_array(pmc);
    return data[key];
#line 254 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_FixedPMCArray_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 193 "./src/pmc/fixedpmcarray.pmc"

    STRING *res    = CONST_STRING(interp, "(");
    const INTVAL n = VTABLE_elements(interp, pmc);
    INTVAL  i;

    for (i = 0; i < n; ++i) {
        PMC * const val = VTABLE_get_pmc_keyed_int(interp, pmc, i);

        res = Parrot_str_append(interp, res, VTABLE_get_repr(interp, val));
        if (n == 1)
            res = Parrot_str_append(interp, res, CONST_STRING(interp, ","));
        else if (i < n - 1)
            res = Parrot_str_append(interp, res, CONST_STRING(interp, ", "));
    }

    res = Parrot_str_append(interp, res, CONST_STRING(interp, ")"));

    return res;
#line 278 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_FixedPMCArray_get_string(PARROT_INTERP, PMC *pmc)
{
#line 189 "./src/pmc/fixedpmcarray.pmc"

    return Parrot_str_from_int(interp, VTABLE_elements(interp, pmc));
#line 286 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_FixedPMCArray_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 304 "./src/pmc/fixedpmcarray.pmc"

    PMC * const tempPMC = VTABLE_get_pmc_keyed(interp, pmc, key);
    return VTABLE_get_string(interp, tempPMC);
#line 295 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_FixedPMCArray_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 285 "./src/pmc/fixedpmcarray.pmc"

    PMC * const retval = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    if (PMC_IS_NULL(retval))
        return string_from_literal(interp, "");

    return VTABLE_get_string(interp, retval);
#line 308 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_init(PARROT_INTERP, PMC *pmc)
{
#line 69 "./src/pmc/fixedpmcarray.pmc"

    Parrot_FixedPMCArray_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_FixedPMCArray_attributes);

    PMC_data(pmc) = attrs;
    PObj_custom_mark_destroy_SETALL(pmc);
#line 320 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_FixedPMCArray_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 593 "./src/pmc/fixedpmcarray.pmc"

    INTVAL j, n;

    if (value->vtable->base_type != enum_class_FixedPMCArray)
        return 0;

    n = VTABLE_elements(interp, pmc);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        PMC * const item1 = VTABLE_get_pmc_keyed_int(interp, pmc, j);
        PMC * const item2 = VTABLE_get_pmc_keyed_int(interp, value, j);

        if (item1 == item2)
            continue;

        if (item1->vtable->base_type == enum_class_Null
        ||  item2->vtable->base_type == enum_class_Null)
            return 0;

        if (!VTABLE_is_equal(interp, item1, item2))
            return 0;
    }

    return 1;
#line 353 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_mark(PARROT_INTERP, PMC *pmc)
{
#line 794 "./src/pmc/fixedpmcarray.pmc"

    PMC ** const data = PMC_array(pmc);
    INTVAL i;

    if (!data)
        return;

    for (i = PMC_size(pmc) - 1; i >= 0; --i)
        if (data[i])
            pobject_lives(interp, (PObj *)data[i]);
#line 369 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 436 "./src/pmc/fixedpmcarray.pmc"

    PMC * const val = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Integer));

    VTABLE_set_integer_native(interp, val, value);

    /* Let set_pmc_keyed worry about multi keys */
    VTABLE_set_pmc_keyed(interp, pmc, key, val);
#line 383 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 418 "./src/pmc/fixedpmcarray.pmc"

    PMC * const val = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Integer));

    VTABLE_set_integer_native(interp, val, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, key, val);
#line 395 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 367 "./src/pmc/fixedpmcarray.pmc"

    int i;
    PMC **data;

    if (PMC_size(pmc) && size)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                _("FixedPMCArray: Can't resize!"));
    if (!size)
        return;

    PMC_size(pmc) = size;
    data           = mem_allocate_n_zeroed_typed(size, PMC *);

    for (i = 0; i < size; i++)
        data[i] = PMCNULL;

    PMC_array(pmc) = data;
#line 418 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 476 "./src/pmc/fixedpmcarray.pmc"

    const INTVAL k        = key_integer(interp, key);
    PMC   * const nextkey = key_next(interp, key);

    if (nextkey == NULL) {
        VTABLE_set_number_keyed_int(interp, pmc, k, value);
    }
    else {
        PMC *box = VTABLE_get_pmc_keyed_int(interp, pmc, k);

        /* RT #46675: autovivify an Array and insert it in pmc */
        if (!box)
            box = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_number_keyed(interp, box, nextkey, value);
    }
#line 440 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 457 "./src/pmc/fixedpmcarray.pmc"

    PMC * const val = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Float));

    VTABLE_set_number_native(interp, val, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, key, val);
#line 452 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 386 "./src/pmc/fixedpmcarray.pmc"

    INTVAL size;
    INTVAL i;

    if (pmc == value)
        return;

    if (!VTABLE_does(interp, value, CONST_STRING(interp, "array")))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                _("Can't set self from this type"));

    if (PMC_array(pmc))
        mem_sys_free(PMC_array(pmc));

    size            = PMC_size(pmc) = VTABLE_elements(interp, value);
    PMC_array(pmc) = mem_allocate_n_zeroed_typed(size, PMC *);

    for (i = 0; i < size; i++)
        (PMC_array(pmc))[i] = VTABLE_get_pmc_keyed_int(interp, value, i);

    PObj_custom_mark_destroy_SETALL(pmc);
#line 479 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 565 "./src/pmc/fixedpmcarray.pmc"

    const INTVAL k = key_integer(interp, key);
    PMC   *nextkey = key_next(interp, key);

    if (!nextkey) {
        VTABLE_set_pmc_keyed_int(interp, pmc, k, value);
    }
    else {
        PMC *box = VTABLE_get_pmc_keyed_int(interp, pmc, k);

        /* RT #46675: autovivify an Array and insert it in pmc */
        if (!box)
            box = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_pmc_keyed(interp, box, nextkey, value);
    }
#line 501 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *src)
{
#line 543 "./src/pmc/fixedpmcarray.pmc"

    PMC **data;

    if (key < 0 || key >= PMC_size(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            _("FixedPMCArray: index out of bounds!"));

    data      = PMC_array(pmc);
    GC_WRITE_BARRIER(interp, pmc, data[key], src);
    data[key] = src;
#line 517 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 523 "./src/pmc/fixedpmcarray.pmc"

    PMC * const val = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_String));

    VTABLE_set_string_native(interp, val, value);

    /* Let set_pmc_keyed worry about multi keys */
    VTABLE_set_pmc_keyed(interp, pmc, key, val);
#line 531 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 504 "./src/pmc/fixedpmcarray.pmc"

    PMC * const val = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_String));

    VTABLE_set_string_native(interp, val, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, key, val);
#line 543 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  PMC  *
Parrot_FixedPMCArray_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL f)
{
#line 638 "./src/pmc/fixedpmcarray.pmc"

    if (f == 0) {
        STRING     *name = CONST_STRING(interp, "set_key");
        PMC * const iter = pmc_new_init(interp, enum_class_Iterator, pmc);
        Parrot_PCCINVOKE(interp, iter, name, "P->", key);
        return iter;
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            _("Array: Unknown slice type"));
#line 559 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
#line 708 "./src/pmc/fixedpmcarray.pmc"

    if (count + offset > PMC_size(pmc))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            _("FixedPMCArray: index out of bounds!"));

    for (count--; count >= 0; --count) {
        VTABLE_set_pmc_keyed_int(interp, pmc, offset + count, value);
    }
#line 573 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 758 "./src/pmc/fixedpmcarray.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
        VTABLE_set_integer_native(interp, pmc, VTABLE_shift_integer(interp, io));
#line 584 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void 
Parrot_FixedPMCArray_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 739 "./src/pmc/fixedpmcarray.pmc"

    INTVAL  i;
    const INTVAL n = VTABLE_elements(interp, pmc);
    PMC   **pos    = PMC_array(pmc);

    for (i = 0; i < n; ++i, ++pos) {
        info->thaw_ptr = pos;
        (info->visit_pmc_now)(interp, *pos, info);
    }

    Parrot_default_visit(interp, pmc, info);
#line 601 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_nci_sort(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 130);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 640 "./src/pmc/fixedpmcarray.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 657 "./src/pmc/fixedpmcarray.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* cmp_func = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 46 "./src/pmc/fixedpmcarray.pmc"

    const UINTVAL n = (UINTVAL) PMC_size(pmc);

    if (n > 1)
       Parrot_quicksort(interp, (void **)PMC_array(pmc), n, cmp_func);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 685 "./src/pmc/fixedpmcarray.c"
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  PMC *
Parrot_FixedPMCArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  FLOATVAL
Parrot_FixedPMCArray_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  INTVAL
Parrot_FixedPMCArray_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  PMC *
Parrot_FixedPMCArray_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  STRING *
Parrot_FixedPMCArray_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  FLOATVAL
Parrot_FixedPMCArray_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  INTVAL
Parrot_FixedPMCArray_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  PMC *
Parrot_FixedPMCArray_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  STRING *
Parrot_FixedPMCArray_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of FixedPMCArray");
}
PARROT_EXPORT  void
Parrot_FixedPMCArray_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of FixedPMCArray");
}
#include "pmc_default.h"
void
Parrot_FixedPMCArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Isize :pmc_array ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_FixedPMCArray, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_FixedPMCArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_FixedPMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_FixedPMCArray_elements,
        Parrot_FixedPMCArray_exists_keyed,
        Parrot_FixedPMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_FixedPMCArray_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedPMCArray_get_integer,
        Parrot_FixedPMCArray_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_get_namespace,
        Parrot_FixedPMCArray_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedPMCArray_get_pmc_keyed,
        Parrot_FixedPMCArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedPMCArray_get_repr,
        Parrot_FixedPMCArray_get_string,
        Parrot_FixedPMCArray_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_FixedPMCArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_FixedPMCArray_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_FixedPMCArray_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedPMCArray_set_integer_keyed,
        Parrot_FixedPMCArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_FixedPMCArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedPMCArray_set_number_keyed,
        Parrot_FixedPMCArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedPMCArray_set_pmc,
        Parrot_FixedPMCArray_set_pmc_keyed,
        Parrot_FixedPMCArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedPMCArray_set_string_keyed,
        Parrot_FixedPMCArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_FixedPMCArray_slice,
        Parrot_FixedPMCArray_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_FixedPMCArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_FixedPMCArray_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_FixedPMCArray, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_FixedPMCArray_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_FixedPMCArray_ro_add_method,
        Parrot_FixedPMCArray_ro_add_parent,
        Parrot_FixedPMCArray_ro_add_role,
        Parrot_FixedPMCArray_ro_add_vtable_override,
        Parrot_FixedPMCArray_ro_assign_pmc,
        Parrot_FixedPMCArray_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_FixedPMCArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_FixedPMCArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_FixedPMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_FixedPMCArray_ro_delete_keyed,
        Parrot_FixedPMCArray_ro_delete_keyed_int,
        Parrot_FixedPMCArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_FixedPMCArray_elements,
        Parrot_FixedPMCArray_exists_keyed,
        Parrot_FixedPMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_FixedPMCArray_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_FixedPMCArray_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedPMCArray_get_integer,
        Parrot_FixedPMCArray_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_get_namespace,
        Parrot_FixedPMCArray_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedPMCArray_get_pmc_keyed,
        Parrot_FixedPMCArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedPMCArray_get_repr,
        Parrot_FixedPMCArray_get_string,
        Parrot_FixedPMCArray_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_FixedPMCArray_ro_i_absolute,
        Parrot_FixedPMCArray_ro_i_add,
        Parrot_FixedPMCArray_ro_i_add_float,
        Parrot_FixedPMCArray_ro_i_add_int,
        Parrot_FixedPMCArray_ro_i_bitwise_and,
        Parrot_FixedPMCArray_ro_i_bitwise_and_int,
        Parrot_FixedPMCArray_ro_i_bitwise_ands,
        Parrot_FixedPMCArray_ro_i_bitwise_ands_str,
        Parrot_FixedPMCArray_ro_i_bitwise_lsr,
        Parrot_FixedPMCArray_ro_i_bitwise_lsr_int,
        Parrot_FixedPMCArray_ro_i_bitwise_not,
        Parrot_FixedPMCArray_ro_i_bitwise_nots,
        Parrot_FixedPMCArray_ro_i_bitwise_or,
        Parrot_FixedPMCArray_ro_i_bitwise_or_int,
        Parrot_FixedPMCArray_ro_i_bitwise_ors,
        Parrot_FixedPMCArray_ro_i_bitwise_ors_str,
        Parrot_FixedPMCArray_ro_i_bitwise_shl,
        Parrot_FixedPMCArray_ro_i_bitwise_shl_int,
        Parrot_FixedPMCArray_ro_i_bitwise_shr,
        Parrot_FixedPMCArray_ro_i_bitwise_shr_int,
        Parrot_FixedPMCArray_ro_i_bitwise_xor,
        Parrot_FixedPMCArray_ro_i_bitwise_xor_int,
        Parrot_FixedPMCArray_ro_i_bitwise_xors,
        Parrot_FixedPMCArray_ro_i_bitwise_xors_str,
        Parrot_FixedPMCArray_ro_i_concatenate,
        Parrot_FixedPMCArray_ro_i_concatenate_str,
        Parrot_FixedPMCArray_ro_i_divide,
        Parrot_FixedPMCArray_ro_i_divide_float,
        Parrot_FixedPMCArray_ro_i_divide_int,
        Parrot_FixedPMCArray_ro_i_floor_divide,
        Parrot_FixedPMCArray_ro_i_floor_divide_float,
        Parrot_FixedPMCArray_ro_i_floor_divide_int,
        Parrot_FixedPMCArray_ro_i_logical_not,
        Parrot_FixedPMCArray_ro_i_modulus,
        Parrot_FixedPMCArray_ro_i_modulus_float,
        Parrot_FixedPMCArray_ro_i_modulus_int,
        Parrot_FixedPMCArray_ro_i_multiply,
        Parrot_FixedPMCArray_ro_i_multiply_float,
        Parrot_FixedPMCArray_ro_i_multiply_int,
        Parrot_FixedPMCArray_ro_i_neg,
        Parrot_FixedPMCArray_ro_i_pow,
        Parrot_FixedPMCArray_ro_i_pow_float,
        Parrot_FixedPMCArray_ro_i_pow_int,
        Parrot_FixedPMCArray_ro_i_repeat,
        Parrot_FixedPMCArray_ro_i_repeat_int,
        Parrot_FixedPMCArray_ro_i_subtract,
        Parrot_FixedPMCArray_ro_i_subtract_float,
        Parrot_FixedPMCArray_ro_i_subtract_int,
        Parrot_FixedPMCArray_ro_increment,
        Parrot_FixedPMCArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_FixedPMCArray_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_FixedPMCArray_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_FixedPMCArray_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_FixedPMCArray_ro_pop_float,
        Parrot_FixedPMCArray_ro_pop_integer,
        Parrot_FixedPMCArray_ro_pop_pmc,
        Parrot_FixedPMCArray_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_FixedPMCArray_ro_push_float,
        Parrot_FixedPMCArray_ro_push_integer,
        Parrot_FixedPMCArray_ro_push_pmc,
        Parrot_FixedPMCArray_ro_push_string,
        Parrot_FixedPMCArray_ro_remove_attribute,
        Parrot_FixedPMCArray_ro_remove_method,
        Parrot_FixedPMCArray_ro_remove_parent,
        Parrot_FixedPMCArray_ro_remove_role,
        Parrot_FixedPMCArray_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_FixedPMCArray_ro_set_attr_keyed,
        Parrot_FixedPMCArray_ro_set_attr_str,
        Parrot_FixedPMCArray_ro_set_bignum_int,
        Parrot_FixedPMCArray_ro_set_bignum_num,
        Parrot_FixedPMCArray_ro_set_bignum_str,
        Parrot_FixedPMCArray_ro_set_bool,
        Parrot_FixedPMCArray_ro_set_integer_keyed,
        Parrot_FixedPMCArray_ro_set_integer_keyed_int,
        Parrot_FixedPMCArray_ro_set_integer_keyed_str,
        Parrot_FixedPMCArray_ro_set_integer_native,
        Parrot_FixedPMCArray_ro_set_integer_same,
        Parrot_FixedPMCArray_ro_set_number_keyed,
        Parrot_FixedPMCArray_ro_set_number_keyed_int,
        Parrot_FixedPMCArray_ro_set_number_keyed_str,
        Parrot_FixedPMCArray_ro_set_number_native,
        Parrot_FixedPMCArray_ro_set_number_same,
        Parrot_FixedPMCArray_ro_set_pmc,
        Parrot_FixedPMCArray_ro_set_pmc_keyed,
        Parrot_FixedPMCArray_ro_set_pmc_keyed_int,
        Parrot_FixedPMCArray_ro_set_pmc_keyed_str,
        Parrot_FixedPMCArray_ro_set_pointer,
        Parrot_FixedPMCArray_ro_set_pointer_keyed,
        Parrot_FixedPMCArray_ro_set_pointer_keyed_int,
        Parrot_FixedPMCArray_ro_set_pointer_keyed_str,
        Parrot_FixedPMCArray_ro_set_string_keyed,
        Parrot_FixedPMCArray_ro_set_string_keyed_int,
        Parrot_FixedPMCArray_ro_set_string_keyed_str,
        Parrot_FixedPMCArray_ro_set_string_native,
        Parrot_FixedPMCArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_FixedPMCArray_ro_shift_float,
        Parrot_FixedPMCArray_ro_shift_integer,
        Parrot_FixedPMCArray_ro_shift_pmc,
        Parrot_FixedPMCArray_ro_shift_string,
        Parrot_FixedPMCArray_slice,
        Parrot_FixedPMCArray_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_FixedPMCArray_ro_thaw,
        Parrot_FixedPMCArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_FixedPMCArray_ro_unshift_float,
        Parrot_FixedPMCArray_ro_unshift_integer,
        Parrot_FixedPMCArray_ro_unshift_pmc,
        Parrot_FixedPMCArray_ro_unshift_string,
        Parrot_FixedPMCArray_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "FixedPMCArray");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "array");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "FixedPMCArray")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "FixedPMCArray"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_FixedPMCArray_nci_sort), "sort");
        {
        }
    } /* pass */
} /* Parrot_FixedPMCArray_class_init */
#line 804 "./src/pmc/fixedpmcarray.pmc"



/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
