/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/float.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_float.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "float.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/float.pmc"
/*
Copyright (C) 2003-2009, Parrot Foundation.
$Id: float.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/float.pmc - Floating-point number

=head1 DESCRIPTION

C<Float> extends C<scalar> to provide floating-point number operations.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#line 45 "./src/pmc/float.c"
PARROT_EXPORT  PMC  *
Parrot_Float_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 373 "./src/pmc/float.pmc"

    const FLOATVAL a = fabs(VTABLE_get_number(interp, pmc));

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, a);
    return dest;
#line 57 "./src/pmc/float.c"
}
PARROT_EXPORT  PMC  *
Parrot_Float_clone(PARROT_INTERP, PMC *pmc)
{
#line 54 "./src/pmc/float.pmc"

    FLOATVAL fv;
    PMC * const dest = pmc_new(interp, pmc->vtable->base_type);
    GETATTR_Float_fv(interp, pmc, fv);
    SETATTR_Float_fv(interp, dest, fv);
    return dest;
#line 69 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_decrement(PARROT_INTERP, PMC *pmc)
{
#line 355 "./src/pmc/float.pmc"

    FLOATVAL fv;
    GETATTR_Float_fv(interp, pmc, fv);
    fv--;
    SETATTR_Float_fv(interp, pmc, fv);
#line 80 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_destroy(PARROT_INTERP, PMC *pmc)
{
#line 41 "./src/pmc/float.pmc"

    mem_sys_free(PMC_data(pmc));
#line 88 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 396 "./src/pmc/float.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_freeze(interp, pmc, info);
    VTABLE_push_float(interp, io, VTABLE_get_number(interp, pmc));
#line 98 "./src/pmc/float.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Float_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 124 "./src/pmc/float.pmc"

    const FLOATVAL f = VTABLE_get_number(interp, pmc);
    return !FLOAT_IS_ZERO(f);
#line 107 "./src/pmc/float.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Float_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 108 "./src/pmc/float.pmc"

    /* two steps avoid casting warnings */
    const FLOATVAL n = VTABLE_get_number(interp, pmc);
    return (INTVAL) n;
#line 117 "./src/pmc/float.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Float_get_number(PARROT_INTERP, PMC *pmc)
{
#line 92 "./src/pmc/float.pmc"

    FLOATVAL fv;
    GETATTR_Float_fv(interp, pmc, fv);
    return fv;
#line 127 "./src/pmc/float.c"
}
PARROT_EXPORT  STRING  *
Parrot_Float_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 145 "./src/pmc/float.pmc"

    const FLOATVAL val      = VTABLE_get_number(interp, pmc);
    const double d          = fabs((double)val);
    const char * const sign = val < 0 ? "-" : "";
    return Parrot_sprintf_c(interp, "%s" FLOATVAL_FMT, sign, d);
#line 138 "./src/pmc/float.c"
}
PARROT_EXPORT  STRING  *
Parrot_Float_get_string(PARROT_INTERP, PMC *pmc)
{
#line 141 "./src/pmc/float.pmc"

    return Parrot_str_from_num(interp, VTABLE_get_number(interp, pmc));
#line 146 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 382 "./src/pmc/float.pmc"

    const FLOATVAL a = fabs(VTABLE_get_number(interp, pmc));
    VTABLE_set_number_native(interp, pmc, a);
#line 155 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_i_neg(PARROT_INTERP, PMC *pmc)
{
#line 255 "./src/pmc/float.pmc"

    const FLOATVAL a = -VTABLE_get_number(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a);
#line 164 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_increment(PARROT_INTERP, PMC *pmc)
{
#line 338 "./src/pmc/float.pmc"

    FLOATVAL fv;
    GETATTR_Float_fv(interp, pmc, fv);
    fv++;
    SETATTR_Float_fv(interp, pmc, fv);
#line 175 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_init(PARROT_INTERP, PMC *pmc)
{
#line 26 "./src/pmc/float.pmc"

    Parrot_Float_attributes * const fattr = mem_allocate_zeroed_typed(Parrot_Float_attributes);
    fattr->fv = 0.0;
    PMC_data(pmc) = fattr;
#line 185 "./src/pmc/float.c"
}
PARROT_EXPORT  PMC  *
Parrot_Float_instantiate_str(PARROT_INTERP, PMC *pmc, STRING *rep, INTVAL flags)
{
#line 71 "./src/pmc/float.pmc"

    const INTVAL type = pmc->vtable->base_type;
    PMC * const res =
        (flags & PObj_constant_FLAG)
            ? constant_pmc_new(interp, type)
            : pmc_new(interp, type);

    SETATTR_Float_fv(interp, res, Parrot_str_to_num(interp, rep));
    return res;
#line 200 "./src/pmc/float.c"
}
PARROT_EXPORT  PMC  *
Parrot_Float_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 246 "./src/pmc/float.pmc"

    const FLOATVAL a = -VTABLE_get_number(interp, pmc);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, a);
    return dest;
#line 213 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 167 "./src/pmc/float.pmc"

    pmc_reuse(interp, pmc, enum_class_Boolean, 0);
    VTABLE_set_bool(interp, pmc, value);
#line 222 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 162 "./src/pmc/float.pmc"

    pmc_reuse(interp, pmc, enum_class_Integer, 0);
    VTABLE_set_integer_native(interp, pmc, value);
#line 231 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 182 "./src/pmc/float.pmc"

    SETATTR_Float_fv(interp, pmc, value);
#line 239 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_set_number_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 196 "./src/pmc/float.pmc"

    FLOATVAL fv;
    GETATTR_Float_fv(interp, value, fv);
    SETATTR_Float_fv(interp, pmc, fv);
#line 249 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 229 "./src/pmc/float.pmc"

    SETATTR_Float_fv(interp, pmc, VTABLE_get_number(interp, value));
#line 257 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 214 "./src/pmc/float.pmc"

    pmc_reuse(interp, pmc, enum_class_String, 0);
    VTABLE_set_string_native(interp, pmc, value);
#line 266 "./src/pmc/float.c"
}
PARROT_EXPORT  void 
Parrot_Float_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 411 "./src/pmc/float.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
        SETATTR_Float_fv(interp, pmc, VTABLE_shift_float(interp, io));
#line 277 "./src/pmc/float.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Float_multi_is_equal_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 270 "./src/pmc/float.pmc"

    return (INTVAL)(pmc->vtable->get_number(interp, pmc) == VTABLE_get_number(interp, value));
#line 285 "./src/pmc/float.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Float_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 274 "./src/pmc/float.pmc"

    return (INTVAL)(pmc->vtable->get_number(interp, pmc) == VTABLE_get_number(interp, value));
#line 293 "./src/pmc/float.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Float_multi_is_equal_num_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 278 "./src/pmc/float.pmc"

    return (INTVAL)(pmc->vtable->get_number(interp, pmc) == VTABLE_get_number(interp, value));
#line 301 "./src/pmc/float.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Float_multi_is_equal_num_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 282 "./src/pmc/float.pmc"

    return (INTVAL)(pmc->vtable->get_number(interp, pmc) == VTABLE_get_number(interp, value));
#line 309 "./src/pmc/float.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Float_multi_cmp_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 296 "./src/pmc/float.pmc"

    const FLOATVAL diff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 318 "./src/pmc/float.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Float_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 301 "./src/pmc/float.pmc"

    const FLOATVAL diff =
            pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 328 "./src/pmc/float.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Float_multi_cmp_num_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 317 "./src/pmc/float.pmc"

    const FLOATVAL diff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 337 "./src/pmc/float.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Float_multi_cmp_num_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 322 "./src/pmc/float.pmc"

    const FLOATVAL diff =
            pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 347 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_acos(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 385 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 402 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 463 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, acos(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 417 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto acos_returns;
    /*END RETURN PMC *d */
    }
#line 466 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
acos_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 462 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_cos(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 500 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 517 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 469 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp,
            Parrot_get_ctx_HLL_type(interp, enum_class_Float));
    SETATTR_Float_fv(interp, d, cos(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 533 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto cos_returns;
    /*END RETURN PMC *d */
    }
#line 473 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
cos_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 578 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_asec(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 616 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 633 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 476 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, acos(1.0 / pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 648 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto asec_returns;
    /*END RETURN PMC *d */
    }
#line 479 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
asec_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 693 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_asin(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 731 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 748 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 482 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, asin(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 763 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto asin_returns;
    /*END RETURN PMC *d */
    }
#line 485 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
asin_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 808 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_atan(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 846 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 863 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 488 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, atan(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 878 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto atan_returns;
    /*END RETURN PMC *d */
    }
#line 491 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
atan_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 923 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_atan2(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 962 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 979 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* val = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 494 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, atan2(pmc->vtable->get_number(interp, pmc), VTABLE_get_number(interp, val)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 995 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto atan2_returns;
    /*END RETURN PMC *d */
    }
#line 497 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
atan2_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1040 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_cosh(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1078 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1095 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 500 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, cosh(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 1110 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto cosh_returns;
    /*END RETURN PMC *d */
    }
#line 503 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
cosh_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1155 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_exp(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1193 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1210 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 506 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, exp(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 1225 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto exp_returns;
    /*END RETURN PMC *d */
    }
#line 509 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
exp_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1270 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_ln(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1308 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1325 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 512 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, log(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 1340 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto ln_returns;
    /*END RETURN PMC *d */
    }
#line 515 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
ln_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1385 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_log10(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1423 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1440 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 518 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, log10(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 1455 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto log10_returns;
    /*END RETURN PMC *d */
    }
#line 521 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
log10_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1500 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_log2(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1538 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1555 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 524 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, log(pmc->vtable->get_number(interp, pmc)) / log(2.0));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 1570 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto log2_returns;
    /*END RETURN PMC *d */
    }
#line 527 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
log2_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1615 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_sec(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1653 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1670 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 530 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, 1.0 / cos(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 1685 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto sec_returns;
    /*END RETURN PMC *d */
    }
#line 533 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
sec_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1730 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_sech(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1768 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1785 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 536 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, 1.0 / cosh(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 1800 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto sech_returns;
    /*END RETURN PMC *d */
    }
#line 539 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
sech_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1845 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_sin(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1883 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1900 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 542 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, sin(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 1915 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto sin_returns;
    /*END RETURN PMC *d */
    }
#line 545 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
sin_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1960 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_sinh(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1998 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2015 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 548 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, sinh(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 2030 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto sinh_returns;
    /*END RETURN PMC *d */
    }
#line 551 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
sinh_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2075 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_tan(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2113 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2130 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 554 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, tan(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 2145 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto tan_returns;
    /*END RETURN PMC *d */
    }
#line 557 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
tan_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2190 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_tanh(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2228 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2245 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 560 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, tanh(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 2260 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto tanh_returns;
    /*END RETURN PMC *d */
    }
#line 563 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
tanh_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2305 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_nci_sqrt(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2343 "./src/pmc/float.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2360 "./src/pmc/float.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 566 "./src/pmc/float.pmc"

    PMC * const d  = pmc_new(interp, VTABLE_type(interp, pmc));
    SETATTR_Float_fv(interp, d, sqrt(pmc->vtable->get_number(interp, pmc)));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *d */
    /*BEGIN GENERATED ACCESSORS */
#line 2375 "./src/pmc/float.pmc"
    CTX_REG_PMC(_ctx, 0) = d;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto sqrt_returns;
    /*END RETURN PMC *d */
    }
#line 569 "./src/pmc/float.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
sqrt_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2420 "./src/pmc/float.c"
}
PARROT_EXPORT  void
Parrot_Float_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Float");
}
PARROT_EXPORT  PMC *
Parrot_Float_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Float_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Float");
}
PARROT_EXPORT  FLOATVAL
Parrot_Float_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Float");
}
PARROT_EXPORT  INTVAL
Parrot_Float_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Float");
}
PARROT_EXPORT  PMC *
Parrot_Float_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Float");
}
PARROT_EXPORT  STRING *
Parrot_Float_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Float");
}
PARROT_EXPORT  FLOATVAL
Parrot_Float_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Float");
}
PARROT_EXPORT  INTVAL
Parrot_Float_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Float");
}
PARROT_EXPORT  PMC *
Parrot_Float_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Float");
}
PARROT_EXPORT  STRING *
Parrot_Float_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Float");
}
PARROT_EXPORT  void
Parrot_Float_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Float");
}
#include "pmc_default.h"
void
Parrot_Float_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Ffv ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Float, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_Float_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_scalar_add_float,
        Parrot_scalar_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_scalar_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_scalar_bitwise_and,
        Parrot_scalar_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_scalar_bitwise_lsr,
        Parrot_scalar_bitwise_lsr_int,
        Parrot_scalar_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_scalar_bitwise_or,
        Parrot_scalar_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_scalar_bitwise_shl,
        Parrot_scalar_bitwise_shl_int,
        Parrot_scalar_bitwise_shr,
        Parrot_scalar_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Float_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_scalar_concatenate,
        Parrot_scalar_concatenate_str,
        Parrot_Float_decrement,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Float_destroy,
        Parrot_default_divide,
        Parrot_scalar_divide_float,
        Parrot_scalar_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_scalar_floor_divide_float,
        Parrot_scalar_floor_divide_int,
        Parrot_Float_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Float_get_bool,
        Parrot_default_get_class,
        Parrot_Float_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_Float_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Float_get_repr,
        Parrot_Float_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Float_i_absolute,
        Parrot_default_i_add,
        Parrot_scalar_i_add_float,
        Parrot_scalar_i_add_int,
        Parrot_scalar_i_bitwise_and,
        Parrot_scalar_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_scalar_i_bitwise_lsr,
        Parrot_scalar_i_bitwise_lsr_int,
        Parrot_scalar_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_scalar_i_bitwise_or,
        Parrot_scalar_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_scalar_i_bitwise_shl,
        Parrot_scalar_i_bitwise_shl_int,
        Parrot_scalar_i_bitwise_shr,
        Parrot_scalar_i_bitwise_shr_int,
        Parrot_scalar_i_bitwise_xor,
        Parrot_scalar_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_scalar_i_concatenate,
        Parrot_scalar_i_concatenate_str,
        Parrot_scalar_i_divide,
        Parrot_scalar_i_divide_float,
        Parrot_scalar_i_divide_int,
        Parrot_scalar_i_floor_divide,
        Parrot_scalar_i_floor_divide_float,
        Parrot_scalar_i_floor_divide_int,
        Parrot_scalar_i_logical_not,
        Parrot_scalar_i_modulus,
        Parrot_scalar_i_modulus_float,
        Parrot_scalar_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_scalar_i_multiply_float,
        Parrot_scalar_i_multiply_int,
        Parrot_Float_i_neg,
        Parrot_scalar_i_pow,
        Parrot_scalar_i_pow_float,
        Parrot_scalar_i_pow_int,
        Parrot_scalar_i_repeat,
        Parrot_scalar_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_scalar_i_subtract_float,
        Parrot_scalar_i_subtract_int,
        Parrot_Float_increment,
        Parrot_Float_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Float_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_scalar_logical_and,
        Parrot_scalar_logical_not,
        Parrot_scalar_logical_or,
        Parrot_scalar_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_scalar_modulus_float,
        Parrot_scalar_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_scalar_multiply_float,
        Parrot_scalar_multiply_int,
        Parrot_default_name,
        Parrot_Float_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_scalar_pow_float,
        Parrot_scalar_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_scalar_repeat,
        Parrot_scalar_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_Float_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Float_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_Float_set_number_native,
        Parrot_Float_set_number_same,
        Parrot_Float_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Float_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_scalar_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_subtract,
        Parrot_scalar_subtract_float,
        Parrot_scalar_subtract_int,
        Parrot_Float_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Float, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_Float_absolute,
        Parrot_default_add,
        Parrot_Float_ro_add_attribute,
        Parrot_scalar_add_float,
        Parrot_scalar_add_int,
        Parrot_Float_ro_add_method,
        Parrot_Float_ro_add_parent,
        Parrot_Float_ro_add_role,
        Parrot_Float_ro_add_vtable_override,
        Parrot_Float_ro_assign_pmc,
        Parrot_Float_ro_assign_string_native,
        Parrot_scalar_bitwise_and,
        Parrot_scalar_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_scalar_bitwise_lsr,
        Parrot_scalar_bitwise_lsr_int,
        Parrot_scalar_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_scalar_bitwise_or,
        Parrot_scalar_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_scalar_bitwise_shl,
        Parrot_scalar_bitwise_shl_int,
        Parrot_scalar_bitwise_shr,
        Parrot_scalar_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Float_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_scalar_concatenate,
        Parrot_scalar_concatenate_str,
        Parrot_Float_ro_decrement,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Float_ro_delete_keyed,
        Parrot_Float_ro_delete_keyed_int,
        Parrot_Float_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Float_destroy,
        Parrot_default_divide,
        Parrot_scalar_divide_float,
        Parrot_scalar_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Float_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_scalar_floor_divide_float,
        Parrot_scalar_floor_divide_int,
        Parrot_Float_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Float_get_bool,
        Parrot_default_get_class,
        Parrot_Float_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_Float_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Float_get_repr,
        Parrot_Float_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Float_ro_i_absolute,
        Parrot_Float_ro_i_add,
        Parrot_Float_ro_i_add_float,
        Parrot_Float_ro_i_add_int,
        Parrot_Float_ro_i_bitwise_and,
        Parrot_Float_ro_i_bitwise_and_int,
        Parrot_Float_ro_i_bitwise_ands,
        Parrot_Float_ro_i_bitwise_ands_str,
        Parrot_Float_ro_i_bitwise_lsr,
        Parrot_Float_ro_i_bitwise_lsr_int,
        Parrot_Float_ro_i_bitwise_not,
        Parrot_Float_ro_i_bitwise_nots,
        Parrot_Float_ro_i_bitwise_or,
        Parrot_Float_ro_i_bitwise_or_int,
        Parrot_Float_ro_i_bitwise_ors,
        Parrot_Float_ro_i_bitwise_ors_str,
        Parrot_Float_ro_i_bitwise_shl,
        Parrot_Float_ro_i_bitwise_shl_int,
        Parrot_Float_ro_i_bitwise_shr,
        Parrot_Float_ro_i_bitwise_shr_int,
        Parrot_Float_ro_i_bitwise_xor,
        Parrot_Float_ro_i_bitwise_xor_int,
        Parrot_Float_ro_i_bitwise_xors,
        Parrot_Float_ro_i_bitwise_xors_str,
        Parrot_Float_ro_i_concatenate,
        Parrot_Float_ro_i_concatenate_str,
        Parrot_Float_ro_i_divide,
        Parrot_Float_ro_i_divide_float,
        Parrot_Float_ro_i_divide_int,
        Parrot_Float_ro_i_floor_divide,
        Parrot_Float_ro_i_floor_divide_float,
        Parrot_Float_ro_i_floor_divide_int,
        Parrot_Float_ro_i_logical_not,
        Parrot_Float_ro_i_modulus,
        Parrot_Float_ro_i_modulus_float,
        Parrot_Float_ro_i_modulus_int,
        Parrot_Float_ro_i_multiply,
        Parrot_Float_ro_i_multiply_float,
        Parrot_Float_ro_i_multiply_int,
        Parrot_Float_ro_i_neg,
        Parrot_Float_ro_i_pow,
        Parrot_Float_ro_i_pow_float,
        Parrot_Float_ro_i_pow_int,
        Parrot_Float_ro_i_repeat,
        Parrot_Float_ro_i_repeat_int,
        Parrot_Float_ro_i_subtract,
        Parrot_Float_ro_i_subtract_float,
        Parrot_Float_ro_i_subtract_int,
        Parrot_Float_ro_increment,
        Parrot_Float_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_Float_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_scalar_logical_and,
        Parrot_scalar_logical_not,
        Parrot_scalar_logical_or,
        Parrot_scalar_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_scalar_modulus_float,
        Parrot_scalar_modulus_int,
        Parrot_Float_ro_morph,
        Parrot_default_multiply,
        Parrot_scalar_multiply_float,
        Parrot_scalar_multiply_int,
        Parrot_default_name,
        Parrot_Float_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Float_ro_pop_float,
        Parrot_Float_ro_pop_integer,
        Parrot_Float_ro_pop_pmc,
        Parrot_Float_ro_pop_string,
        Parrot_default_pow,
        Parrot_scalar_pow_float,
        Parrot_scalar_pow_int,
        Parrot_Float_ro_push_float,
        Parrot_Float_ro_push_integer,
        Parrot_Float_ro_push_pmc,
        Parrot_Float_ro_push_string,
        Parrot_Float_ro_remove_attribute,
        Parrot_Float_ro_remove_method,
        Parrot_Float_ro_remove_parent,
        Parrot_Float_ro_remove_role,
        Parrot_Float_ro_remove_vtable_override,
        Parrot_scalar_repeat,
        Parrot_scalar_repeat_int,
        Parrot_Float_ro_set_attr_keyed,
        Parrot_Float_ro_set_attr_str,
        Parrot_Float_ro_set_bignum_int,
        Parrot_Float_ro_set_bignum_num,
        Parrot_Float_ro_set_bignum_str,
        Parrot_Float_ro_set_bool,
        Parrot_Float_ro_set_integer_keyed,
        Parrot_Float_ro_set_integer_keyed_int,
        Parrot_Float_ro_set_integer_keyed_str,
        Parrot_Float_ro_set_integer_native,
        Parrot_Float_ro_set_integer_same,
        Parrot_Float_ro_set_number_keyed,
        Parrot_Float_ro_set_number_keyed_int,
        Parrot_Float_ro_set_number_keyed_str,
        Parrot_Float_ro_set_number_native,
        Parrot_Float_ro_set_number_same,
        Parrot_Float_ro_set_pmc,
        Parrot_Float_ro_set_pmc_keyed,
        Parrot_Float_ro_set_pmc_keyed_int,
        Parrot_Float_ro_set_pmc_keyed_str,
        Parrot_Float_ro_set_pointer,
        Parrot_Float_ro_set_pointer_keyed,
        Parrot_Float_ro_set_pointer_keyed_int,
        Parrot_Float_ro_set_pointer_keyed_str,
        Parrot_Float_ro_set_string_keyed,
        Parrot_Float_ro_set_string_keyed_int,
        Parrot_Float_ro_set_string_keyed_str,
        Parrot_Float_ro_set_string_native,
        Parrot_Float_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_scalar_share_ro,
        Parrot_Float_ro_shift_float,
        Parrot_Float_ro_shift_integer,
        Parrot_Float_ro_shift_pmc,
        Parrot_Float_ro_shift_string,
        Parrot_default_slice,
        Parrot_Float_ro_splice,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_subtract,
        Parrot_scalar_subtract_float,
        Parrot_scalar_subtract_int,
        Parrot_Float_ro_thaw,
        Parrot_Float_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Float_ro_unshift_float,
        Parrot_Float_ro_unshift_integer,
        Parrot_Float_ro_unshift_pmc,
        Parrot_Float_ro_unshift_string,
        Parrot_default_visit
    };

    const  multi_func_list _temp_multi_func_list[] = {
        { "is_equal", 
          "IJPP", 
          "Float,Float", 
          (funcptr_t) Parrot_Float_multi_is_equal_Float },
        { "is_equal", 
          "IJPP", 
          "Float,DEFAULT", 
          (funcptr_t) Parrot_Float_multi_is_equal_DEFAULT },
        { "is_equal_num", 
          "IJPP", 
          "Float,Float", 
          (funcptr_t) Parrot_Float_multi_is_equal_num_Float },
        { "is_equal_num", 
          "IJPP", 
          "Float,DEFAULT", 
          (funcptr_t) Parrot_Float_multi_is_equal_num_DEFAULT },
        { "cmp", 
          "IJPP", 
          "Float,Float", 
          (funcptr_t) Parrot_Float_multi_cmp_Float },
        { "cmp", 
          "IJPP", 
          "Float,DEFAULT", 
          (funcptr_t) Parrot_Float_multi_cmp_DEFAULT },
        { "cmp_num", 
          "IJPP", 
          "Float,Float", 
          (funcptr_t) Parrot_Float_multi_cmp_num_Float },
        { "cmp_num", 
          "IJPP", 
          "Float,DEFAULT", 
          (funcptr_t) Parrot_Float_multi_cmp_num_DEFAULT }
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Float");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar float");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Float")), PMCNULL);
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "scalar")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Float"));
            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "scalar"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_acos), "acos");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_cos), "cos");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_asec), "asec");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_asin), "asin");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_atan), "atan");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_atan2), "atan2");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_cosh), "cosh");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_exp), "exp");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_ln), "ln");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_log10), "log10");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_log2), "log2");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_sec), "sec");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_sech), "sech");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_sin), "sin");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_sinh), "sinh");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_tan), "tan");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_tanh), "tanh");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Float_nci_sqrt), "sqrt");
        {
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_Float_class_init */
#line 570 "./src/pmc/float.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
