/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/hash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "hash.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/hash.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: hash.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/hash.pmc - Hash PMC

=head1 DESCRIPTION

These are the vtable functions for the Hash PMC.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "pmc_iterator.h"
#include "pmc_key.h"

/*

=item C<static PMC *get_integer_pmc(PARROT_INTERP, INTVAL base_type )>

Lookup the PMC type which is used for storing native integers.

RT #46641: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC *get_integer_pmc(PARROT_INTERP, INTVAL base_type) {
    return pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Integer));
}


/*

=item C<static PMC *get_number_pmc(PARROT_INTERP, INTVAL base_type )>

Lookup the PMC type which is used for floating point numbers.

RT #46641: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC *get_number_pmc(PARROT_INTERP, INTVAL base_type) {
    return pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_Float));
}

/*

=item C<static PMC *get_string_pmc(PARROT_INTERP, INTVAL base_type )>

Lookup the PMC type which is used for storing strings.

RT #46641: PMCs extending Hash should probably register themselves.

=cut

*/

static PMC *get_string_pmc(PARROT_INTERP, INTVAL base_type) {
    return pmc_new(interp, Parrot_get_ctx_HLL_type(interp, enum_class_String));
}


/*

=item C<static STRING *make_hash_key(PARROT_INTERP, PMC *key)>

Returns a Parrot string for C<*key>.

=cut

*/


PARROT_CANNOT_RETURN_NULL
static STRING
*make_hash_key(PARROT_INTERP, NOTNULL(PMC *key))
{
    if (!key)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNEXPECTED_NULL,
            "Hash: Cannot use NULL key");
    else {
        STRING * const keystr = key_string(interp, key);
        if (STRING_IS_NULL(keystr))
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_UNEXPECTED_NULL, "Hash: Cannot use NULL STRING key");
        else
            return keystr;
    }
}

/* Albeit the Hash PMC doesn't use PMC_data, it needs the next_for_GC pointer
 * We would get recursive marking of a deeply nested HoHoH...
 */
#line 127 "./src/pmc/hash.c"
PARROT_EXPORT  PMC  *
Parrot_Hash_clone(PARROT_INTERP, PMC *pmc)
{
#line 159 "./src/pmc/hash.pmc"

    PMC * const dest = pmc_new(interp, pmc->vtable->base_type);

    parrot_hash_clone(interp, (Hash *)PMC_struct_val(pmc),
               (Hash *)PMC_struct_val(dest));

    ((Hash *)PMC_struct_val(dest))->container = dest;
    return dest;
#line 140 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 944 "./src/pmc/hash.pmc"

    Hash   * const h  = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interp, key);
    HashBucket    *b;

    key = key_next(interp, key);
    b   = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return 0;

    if (!key)
        return VTABLE_defined(interp, (PMC*)b->value);
    else
        return VTABLE_defined_keyed(interp, (PMC*)b->value, key);
#line 162 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_defined_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 923 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);

    /* no such key */
    if (!b)
        return 0;

    return VTABLE_defined(interp, (PMC*)b->value);
#line 177 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 984 "./src/pmc/hash.pmc"

    Hash   * const h  = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interp, key);
    HashBucket    *b;

    key = key_next(interp, key);
    b   = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return;

    if (!key)
        parrot_hash_delete(interp, h, sx);
    else
        VTABLE_delete_keyed(interp, (PMC*)b->value, key);
#line 199 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 970 "./src/pmc/hash.pmc"

    parrot_hash_delete(interp, (Hash *)PMC_struct_val(pmc), key);
#line 207 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_destroy(PARROT_INTERP, PMC *pmc)
{
#line 128 "./src/pmc/hash.pmc"

    if (PMC_struct_val(pmc)) {
        parrot_hash_destroy(interp, (Hash *)PMC_struct_val(pmc));
        PMC_struct_val(pmc) = NULL;
    }
#line 218 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_elements(PARROT_INTERP, PMC *pmc)
{
#line 496 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc));
#line 226 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 896 "./src/pmc/hash.pmc"

    Hash   * const h  = (Hash *)PMC_struct_val(pmc);
    STRING * const sx = key_string(interp, key);
    HashBucket    *b;

    key = key_next(interp, key);
    b   = parrot_hash_get_bucket(interp, h, sx);

    /* no such key */
    if (!b)
        return 0;

    /* lookup stops here */
    if (!key)
        return 1;

    return VTABLE_exists_keyed(interp, (PMC *)b->value, key);
#line 249 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 880 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash *)PMC_struct_val(pmc), key);
    return b != NULL;
#line 259 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1050 "./src/pmc/hash.pmc"

    IMAGE_IO * const io   = info->image_io;
    Hash * const     hash = (Hash *)PMC_struct_val(pmc);;

    Parrot_default_freeze(interp, pmc, info);
    VTABLE_push_integer(interp, io, VTABLE_elements(interp, pmc));
    VTABLE_push_integer(interp, io, (INTVAL)hash->key_type);
    VTABLE_push_integer(interp, io, hash->entry_type);
#line 273 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 482 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc)) != 0;
#line 281 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 179 "./src/pmc/hash.pmc"

    return parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc));
#line 289 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 227 "./src/pmc/hash.pmc"

    PMC        *valpmc;
    STRING     *keystr;
    HashBucket *b;
    PMC        *nextkey;
    const Hash * const hash = (Hash *)PMC_struct_val(pmc);

    /* called from iterator with an integer idx in key */
    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_hash_iterator_FLAGS) {

        /* check if we really have Hash_key_type_int */
        if (hash->key_type == Hash_key_type_int) {
            void *idx = parrot_hash_get_idx(interp, hash, key);
            return (INTVAL)idx;
        }
        else {
            const STRING * const s =
                (STRING *)parrot_hash_get_idx(interp, hash, key);
            return Parrot_str_to_int(interp, s);
        }
    }

    keystr  = make_hash_key(interp, key);
    b       = parrot_hash_get_bucket(interp, hash, keystr);

    if (!b)
        return 0;

    nextkey = key_next(interp, key);
    valpmc  = (PMC *)b->value;

    if (!nextkey)
        return VTABLE_get_integer(interp, valpmc);

    return VTABLE_get_integer_keyed(interp, valpmc, nextkey);
#line 330 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 203 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)PMC_struct_val(pmc);
    HashBucket *b;

    if (hash->key_type == Hash_key_type_STRING)
        return VTABLE_get_integer_keyed_str(interp, pmc, Parrot_str_from_int(interp, key));

    b = parrot_hash_get_bucket(interp, hash, (void *)key);

    if (!b)
        return 0;

    return (INTVAL)b->value;
#line 349 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_get_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 193 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash *)PMC_struct_val(pmc), key);

    if (!b)
        return 0;

    return VTABLE_get_integer(interp, (PMC*) b->value);
#line 363 "./src/pmc/hash.c"
}
PARROT_EXPORT  PMC  *
Parrot_Hash_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 539 "./src/pmc/hash.pmc"

    PMC * const iter     = pmc_new_init(interp, enum_class_Iterator, pmc);
    PMC * const key      = pmc_new(interp, enum_class_Key);

    SETATTR_Iterator_key(interp, iter, key);
    PObj_get_FLAGS(key) |= KEY_hash_iterator_FLAGS;
    SETATTR_Key_next_key(interp, key, (PMC *)INITBucketIndex);

    /* -1 for an empty hash, 0 for a non-empty hash.  */
    SETATTR_Key_int_key(interp, key,
        parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc)) ? 0 : -1);

    return iter;
#line 382 "./src/pmc/hash.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Hash_get_number(PARROT_INTERP, PMC *pmc)
{
#line 274 "./src/pmc/hash.pmc"

    /* doing this in two steps avoids dodgy cast warnings with -O */
    const INTVAL size = parrot_hash_size(interp, (Hash *)PMC_struct_val(pmc));
    return (FLOATVAL)size;
#line 392 "./src/pmc/hash.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Hash_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 314 "./src/pmc/hash.pmc"

    PMC               *nextkey;
    PMC               *valpmc;
    STRING     * const keystr = make_hash_key(interp, key);
    HashBucket * const b      = parrot_hash_get_bucket(interp,
                                       (Hash*)PMC_struct_val(pmc), keystr);

    if (!b)
        return 0.0;

    nextkey = key_next(interp, key);
    valpmc  = (PMC *)b->value;

    if (!nextkey)
        return VTABLE_get_number(interp, valpmc);

    return VTABLE_get_number_keyed(interp, valpmc, nextkey);
#line 415 "./src/pmc/hash.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Hash_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 300 "./src/pmc/hash.pmc"

    STRING * const s = Parrot_str_from_int(interp, key);
    return VTABLE_get_number_keyed_str(interp, pmc, s);
#line 424 "./src/pmc/hash.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Hash_get_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 290 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);

    if (!b)
        return 0.0;

    return VTABLE_get_number(interp, (PMC *)b->value);
#line 438 "./src/pmc/hash.c"
}
PARROT_EXPORT  PMC  *
Parrot_Hash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 558 "./src/pmc/hash.pmc"

    const Hash * const hash = (Hash *)PMC_struct_val(pmc);
    STRING        *keystr;
    HashBucket    *b;
    PMC           *nextkey;

    /* called from iterator with an integer idx in key */
    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_hash_iterator_FLAGS) {
        PMC *result;

        /* check if we really have Hash_key_type_int */
        if (hash->key_type == Hash_key_type_int) {
            void *idx           = parrot_hash_get_idx(interp, hash, key);
            const INTVAL i      = (INTVAL)idx;
            result              = pmc_new(interp, enum_class_Integer);
            VTABLE_set_integer_native(interp, result, i);
        }
        else {
            STRING *s = (STRING *)parrot_hash_get_idx(interp, hash, key);
            result    = pmc_new(interp, enum_class_String);
            VTABLE_set_string_native(interp, result, s);
        }

        return result;
    }

    keystr = make_hash_key(interp, key);
    b      = parrot_hash_get_bucket(interp, hash, keystr);

    if (!b)
        return PMCNULL;

    nextkey = key_next(interp, key);

    if (!nextkey)
        return (PMC *)b->value;

    return VTABLE_get_pmc_keyed(interp, (PMC*)b->value, nextkey);
#line 482 "./src/pmc/hash.c"
}
PARROT_EXPORT  PMC  *
Parrot_Hash_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 520 "./src/pmc/hash.pmc"

    STRING * const s = Parrot_str_from_int(interp, key);
    return VTABLE_get_pmc_keyed_str(interp, pmc, s);
#line 491 "./src/pmc/hash.c"
}
PARROT_EXPORT  PMC  *
Parrot_Hash_get_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 510 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash*) PMC_struct_val(pmc), key);

    if (!b)
        return PMCNULL;

    return (PMC *)b->value;
#line 505 "./src/pmc/hash.c"
}
PARROT_EXPORT  STRING  *
Parrot_Hash_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 353 "./src/pmc/hash.pmc"

    /* RT #44643 use freeze */
    PMC * const  iter = VTABLE_get_iter(interp, pmc);
    STRING      *res  = CONST_STRING(interp, "{");
    const INTVAL n    = VTABLE_elements(interp, pmc);
    INTVAL       j;

    for (j = 0; j < n; ++j) {
        STRING * const key       = VTABLE_shift_string(interp, iter);
        int            all_digit = 1;
        int            i;
        PMC           *val;

        for (i = 0; i < (int)key->strlen; ++i) {
            if (!isdigit((unsigned char)((char *)key->strstart)[i])) {
                all_digit = 0;
                break;
            }
        }

        if (all_digit) {
            res = Parrot_str_append(interp, res, key);
        }
        else {
            res = Parrot_str_append(interp, res, CONST_STRING(interp, "'"));
            res = Parrot_str_append(interp, res, key);
            res = Parrot_str_append(interp, res, CONST_STRING(interp, "'"));
        }

        res = Parrot_str_append(interp, res, CONST_STRING(interp, ": "));
        val = VTABLE_get_pmc_keyed_str(interp, pmc, key);
        res = Parrot_str_append(interp, res, VTABLE_get_string(interp, val));

        if (j < n - 1)
            res = Parrot_str_append(interp, res, CONST_STRING(interp, ", "));
    }

    res = Parrot_str_append(interp, res, CONST_STRING(interp, "}"));

    return res;
#line 551 "./src/pmc/hash.c"
}
PARROT_EXPORT  STRING  *
Parrot_Hash_get_string(PARROT_INTERP, PMC *pmc)
{
#line 349 "./src/pmc/hash.pmc"

    return Parrot_sprintf_c(interp, "Hash[0x%x]", pmc);
#line 559 "./src/pmc/hash.c"
}
PARROT_EXPORT  STRING  *
Parrot_Hash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 435 "./src/pmc/hash.pmc"

    PMC         *valpmc;
    STRING      *keystr;
    HashBucket  *b;
    PMC         *nextkey;
    Hash * const hash = (Hash *)PMC_struct_val(pmc);

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_hash_iterator_FLAGS) {
        /* called from iterator with an integer idx in key */
        if (hash->key_type == Hash_key_type_int) {
            void  *idx = parrot_hash_get_idx(interp, hash, key);
            return Parrot_str_from_int(interp, (INTVAL)idx);
        }

        return (STRING *)parrot_hash_get_idx(interp, hash, key);
    }

    keystr = make_hash_key(interp, key);
    b      = parrot_hash_get_bucket(interp, hash, keystr);

    /*
     * RT #46647 current behaviour of $S0 = hsh['no_such_key'] in
     *      PGE and possibly more code needs an empty STRING
     *      (--leo)
     */
    if (!b)
        return Parrot_str_new_noinit(interp, enum_stringrep_one, 0);

    nextkey = key_next(interp, key);
    valpmc  = (PMC *)b->value;

    if (!nextkey)
        return VTABLE_get_string(interp, valpmc);

    return VTABLE_get_string_keyed(interp, valpmc, nextkey);
#line 600 "./src/pmc/hash.c"
}
PARROT_EXPORT  STRING  *
Parrot_Hash_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 420 "./src/pmc/hash.pmc"

    STRING * const s = Parrot_str_from_int(interp, key);
    return VTABLE_get_string_keyed_str(interp, pmc, s);
#line 609 "./src/pmc/hash.c"
}
PARROT_EXPORT  STRING  *
Parrot_Hash_get_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 405 "./src/pmc/hash.pmc"

    HashBucket * const b =
        parrot_hash_get_bucket(interp, (Hash *)PMC_struct_val(pmc), key);

    /*
     * RT #46647 current behaviour of $S0 = hsh['no_such_key'] in
     *      PGE and possibly more code needs an empty STRING
     *      (--leo)
     */
    if (!b)
        return Parrot_str_new_noinit(interp, enum_stringrep_one, 0);

    return VTABLE_get_string(interp, (PMC*) b->value);
#line 628 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_init(PARROT_INTERP, PMC *pmc)
{
#line 122 "./src/pmc/hash.pmc"

    PMC_struct_val(pmc) = NULL;
    PObj_custom_mark_destroy_SETALL(pmc);
    parrot_new_pmc_hash(interp, pmc);
#line 638 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 837 "./src/pmc/hash.pmc"

    PMC * const iter = VTABLE_get_iter(interp, pmc);
    INTVAL      j, n;

    if (value->vtable->base_type != pmc->vtable->base_type)
        return 0;

    n = VTABLE_elements(interp, pmc);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        STRING * const key = VTABLE_shift_string(interp, iter);
        PMC           *item1, *item2;
        INTVAL         result;

        if (!VTABLE_exists_keyed_str(interp, value, key))
            return 0;

        item1 = VTABLE_get_pmc_keyed_str(interp, pmc, key);
        item2 = VTABLE_get_pmc_keyed_str(interp, value, key);

        if (item1 == item2)
            continue;

        Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal",
            "PP->I", item1, item2, &result);
        if (!result)
            return 0;
    }

    return 1;
#line 677 "./src/pmc/hash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Hash_is_same(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 608 "./src/pmc/hash.pmc"

    return (INTVAL)(other->vtable == pmc->vtable &&
        PMC_struct_val(other) == PMC_struct_val(pmc));
#line 686 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_mark(PARROT_INTERP, PMC *pmc)
{
#line 144 "./src/pmc/hash.pmc"

    if (PMC_struct_val(pmc))
        parrot_mark_hash(interp, (Hash *)PMC_struct_val(pmc));
#line 695 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_set_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL value)
{
#line 621 "./src/pmc/hash.pmc"

    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        PMC *val = get_integer_pmc(interp, pmc->vtable->base_type);

        VTABLE_set_integer_native(interp, val, value);
        parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), keystr, val);
        return;
    }

    box = VTABLE_get_pmc_keyed_str(interp, pmc, keystr);

    /* autovivify an Hash */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_keyed(interp, box, nextkey, value);
#line 727 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 649 "./src/pmc/hash.pmc"

    Hash * const hash = (Hash *)PMC_struct_val(pmc);

    /* check if we really have Hash_key_type_int */
    if (hash->key_type == Hash_key_type_int) {
        parrot_hash_put(interp, hash, (void *)key, (void *)value);
    }
    else {
        Parrot_default_set_integer_keyed_int(interp, pmc, key, value);
    }
#line 743 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_set_integer_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, INTVAL value)
{
#line 669 "./src/pmc/hash.pmc"

    PMC * const val  = get_integer_pmc(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, val, value);

    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, val);
#line 754 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_set_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key, FLOATVAL value)
{
#line 684 "./src/pmc/hash.pmc"

    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        PMC *val         = get_number_pmc(interp, pmc->vtable->base_type);
        VTABLE_set_number_native(interp, val, value);
        parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), keystr, val);
        return;
    }

    box = VTABLE_get_pmc_keyed_str(interp, pmc, keystr);

    /* autovivify an Hash */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_keyed(interp, box, nextkey, value);
#line 785 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_set_number_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, FLOATVAL value)
{
#line 721 "./src/pmc/hash.pmc"

    PMC * const val  = get_number_pmc(interp, pmc->vtable->base_type);
    VTABLE_set_number_native(interp, val, value);

    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, val);
#line 796 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *value)
{
#line 786 "./src/pmc/hash.pmc"

    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        parrot_hash_put(interp, (Hash*)PMC_struct_val(pmc), keystr, value);
        return;
    }

    box = VTABLE_get_pmc_keyed_str(interp, pmc, keystr);

    /* autovivify an Hash */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_pmc_keyed(interp, box, nextkey, value);
#line 825 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_set_pmc_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, PMC *value)
{
#line 821 "./src/pmc/hash.pmc"

    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, value);
#line 833 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_set_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key, STRING *value)
{
#line 736 "./src/pmc/hash.pmc"

    STRING *keystr;
    PMC    *nextkey;
    PMC    *box;

    if (!key)
        return;

    keystr  = make_hash_key(interp, key);
    nextkey = key_next(interp, key);

    if (!nextkey) {
        PMC * const val = get_string_pmc(interp, pmc->vtable->base_type);
        VTABLE_set_string_native(interp, val, value);
        parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), keystr, val);
        return;
    }

    box = VTABLE_get_pmc_keyed_str(interp, pmc, keystr);

    /* autovivify an Hash */
    if (!box)
        box = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_keyed(interp, box, nextkey, value);
#line 864 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_set_string_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key, STRING *value)
{
#line 771 "./src/pmc/hash.pmc"

    PMC * const val = get_string_pmc(interp, pmc->vtable->base_type);

    VTABLE_set_string_native(interp, val, value);
    parrot_hash_put(interp, (Hash *)PMC_struct_val(pmc), key, val);
#line 875 "./src/pmc/hash.c"
}
PARROT_EXPORT  PMC  *
Parrot_Hash_slice(PARROT_INTERP, PMC *pmc, PMC *key, INTVAL f)
{
#line 1012 "./src/pmc/hash.pmc"

    if (f == 0) {
        PMC * const iter = pmc_new_init(interp, enum_class_Iterator, pmc);
        PMC_struct_val(iter) = key;
        return iter;
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
        "Hash: Unknown slice type");
#line 890 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1070 "./src/pmc/hash.pmc"

    IMAGE_IO * const io = info->image_io;

    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL) {
        const INTVAL elems  = VTABLE_shift_integer(interp, io);
        const INTVAL k_type = VTABLE_shift_integer(interp, io);
        const INTVAL v_type = VTABLE_shift_integer(interp, io);
        Hash        *hash;

        /* RT #46651 make a better interface for hash creation
         * RT #46653 create hash with needed size in the first place */
        if (k_type == Hash_key_type_int && v_type == enum_hash_int) {
            PMC * const dummy     = Parrot_new_INTVAL_hash(interp, 0);

            /* don't leak the hash if we're going to overwrite it anyway */
            if (PMC_struct_val(pmc))
                parrot_hash_destroy(interp, (Hash *)PMC_struct_val(pmc));

            PMC_struct_val(pmc)  = PMC_struct_val(dummy);
            PMC_struct_val(dummy) = NULL;
        }

        hash            = (Hash *)PMC_struct_val(pmc);

        PARROT_ASSERT((INTVAL)hash->key_type == k_type);
        PARROT_ASSERT(hash->entry_type       == v_type);

        hash->container = pmc;
        hash->entries   = elems;
    }
#line 927 "./src/pmc/hash.c"
}
PARROT_EXPORT  void 
Parrot_Hash_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1034 "./src/pmc/hash.pmc"

    info->container = pmc;
    parrot_hash_visit(interp, (Hash *)PMC_struct_val(pmc), info);
    Parrot_default_visit(interp, pmc, info);
#line 937 "./src/pmc/hash.c"
}
PARROT_EXPORT  void
Parrot_Hash_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Hash");
}
PARROT_EXPORT  PMC *
Parrot_Hash_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Hash");
}
PARROT_EXPORT  FLOATVAL
Parrot_Hash_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Hash");
}
PARROT_EXPORT  INTVAL
Parrot_Hash_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Hash");
}
PARROT_EXPORT  PMC *
Parrot_Hash_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Hash");
}
PARROT_EXPORT  STRING *
Parrot_Hash_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Hash");
}
PARROT_EXPORT  FLOATVAL
Parrot_Hash_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Hash");
}
PARROT_EXPORT  INTVAL
Parrot_Hash_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Hash");
}
PARROT_EXPORT  PMC *
Parrot_Hash_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Hash");
}
PARROT_EXPORT  STRING *
Parrot_Hash_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Hash");
}
PARROT_EXPORT  void
Parrot_Hash_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Hash");
}
#include "pmc_default.h"
void
Parrot_Hash_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Hash, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Hash_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_Hash_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_Hash_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_Hash_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Hash_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_Hash_elements,
        Parrot_Hash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_Hash_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Hash_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_Hash_get_integer_keyed,
        Parrot_Hash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_namespace,
        Parrot_Hash_get_number,
        Parrot_Hash_get_number_keyed,
        Parrot_Hash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Hash_get_pmc_keyed,
        Parrot_Hash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string,
        Parrot_Hash_get_string_keyed,
        Parrot_Hash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_Hash_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Hash_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_Hash_set_integer_keyed,
        Parrot_Hash_set_integer_keyed_int,
        Parrot_Hash_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_Hash_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_Hash_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_Hash_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_Hash_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Hash_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_Hash_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_Hash_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Hash_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Hash_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Hash, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Hash_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Hash_ro_add_method,
        Parrot_Hash_ro_add_parent,
        Parrot_Hash_ro_add_role,
        Parrot_Hash_ro_add_vtable_override,
        Parrot_Hash_ro_assign_pmc,
        Parrot_Hash_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Hash_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Hash_ro_decrement,
        Parrot_default_defined,
        Parrot_Hash_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_Hash_ro_delete_keyed,
        Parrot_Hash_ro_delete_keyed_int,
        Parrot_Hash_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Hash_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_Hash_elements,
        Parrot_Hash_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_Hash_exists_keyed_str,
        Parrot_Hash_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Hash_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_Hash_get_integer_keyed,
        Parrot_Hash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_namespace,
        Parrot_Hash_get_number,
        Parrot_Hash_get_number_keyed,
        Parrot_Hash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_Hash_get_pmc_keyed,
        Parrot_Hash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string,
        Parrot_Hash_get_string_keyed,
        Parrot_Hash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Hash_ro_i_absolute,
        Parrot_Hash_ro_i_add,
        Parrot_Hash_ro_i_add_float,
        Parrot_Hash_ro_i_add_int,
        Parrot_Hash_ro_i_bitwise_and,
        Parrot_Hash_ro_i_bitwise_and_int,
        Parrot_Hash_ro_i_bitwise_ands,
        Parrot_Hash_ro_i_bitwise_ands_str,
        Parrot_Hash_ro_i_bitwise_lsr,
        Parrot_Hash_ro_i_bitwise_lsr_int,
        Parrot_Hash_ro_i_bitwise_not,
        Parrot_Hash_ro_i_bitwise_nots,
        Parrot_Hash_ro_i_bitwise_or,
        Parrot_Hash_ro_i_bitwise_or_int,
        Parrot_Hash_ro_i_bitwise_ors,
        Parrot_Hash_ro_i_bitwise_ors_str,
        Parrot_Hash_ro_i_bitwise_shl,
        Parrot_Hash_ro_i_bitwise_shl_int,
        Parrot_Hash_ro_i_bitwise_shr,
        Parrot_Hash_ro_i_bitwise_shr_int,
        Parrot_Hash_ro_i_bitwise_xor,
        Parrot_Hash_ro_i_bitwise_xor_int,
        Parrot_Hash_ro_i_bitwise_xors,
        Parrot_Hash_ro_i_bitwise_xors_str,
        Parrot_Hash_ro_i_concatenate,
        Parrot_Hash_ro_i_concatenate_str,
        Parrot_Hash_ro_i_divide,
        Parrot_Hash_ro_i_divide_float,
        Parrot_Hash_ro_i_divide_int,
        Parrot_Hash_ro_i_floor_divide,
        Parrot_Hash_ro_i_floor_divide_float,
        Parrot_Hash_ro_i_floor_divide_int,
        Parrot_Hash_ro_i_logical_not,
        Parrot_Hash_ro_i_modulus,
        Parrot_Hash_ro_i_modulus_float,
        Parrot_Hash_ro_i_modulus_int,
        Parrot_Hash_ro_i_multiply,
        Parrot_Hash_ro_i_multiply_float,
        Parrot_Hash_ro_i_multiply_int,
        Parrot_Hash_ro_i_neg,
        Parrot_Hash_ro_i_pow,
        Parrot_Hash_ro_i_pow_float,
        Parrot_Hash_ro_i_pow_int,
        Parrot_Hash_ro_i_repeat,
        Parrot_Hash_ro_i_repeat_int,
        Parrot_Hash_ro_i_subtract,
        Parrot_Hash_ro_i_subtract_float,
        Parrot_Hash_ro_i_subtract_int,
        Parrot_Hash_ro_increment,
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_Hash_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Hash_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_Hash_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Hash_ro_pop_float,
        Parrot_Hash_ro_pop_integer,
        Parrot_Hash_ro_pop_pmc,
        Parrot_Hash_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Hash_ro_push_float,
        Parrot_Hash_ro_push_integer,
        Parrot_Hash_ro_push_pmc,
        Parrot_Hash_ro_push_string,
        Parrot_Hash_ro_remove_attribute,
        Parrot_Hash_ro_remove_method,
        Parrot_Hash_ro_remove_parent,
        Parrot_Hash_ro_remove_role,
        Parrot_Hash_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_Hash_ro_set_attr_keyed,
        Parrot_Hash_ro_set_attr_str,
        Parrot_Hash_ro_set_bignum_int,
        Parrot_Hash_ro_set_bignum_num,
        Parrot_Hash_ro_set_bignum_str,
        Parrot_Hash_ro_set_bool,
        Parrot_Hash_ro_set_integer_keyed,
        Parrot_Hash_ro_set_integer_keyed_int,
        Parrot_Hash_ro_set_integer_keyed_str,
        Parrot_Hash_ro_set_integer_native,
        Parrot_Hash_ro_set_integer_same,
        Parrot_Hash_ro_set_number_keyed,
        Parrot_Hash_ro_set_number_keyed_int,
        Parrot_Hash_ro_set_number_keyed_str,
        Parrot_Hash_ro_set_number_native,
        Parrot_Hash_ro_set_number_same,
        Parrot_Hash_ro_set_pmc,
        Parrot_Hash_ro_set_pmc_keyed,
        Parrot_Hash_ro_set_pmc_keyed_int,
        Parrot_Hash_ro_set_pmc_keyed_str,
        Parrot_Hash_ro_set_pointer,
        Parrot_Hash_ro_set_pointer_keyed,
        Parrot_Hash_ro_set_pointer_keyed_int,
        Parrot_Hash_ro_set_pointer_keyed_str,
        Parrot_Hash_ro_set_string_keyed,
        Parrot_Hash_ro_set_string_keyed_int,
        Parrot_Hash_ro_set_string_keyed_str,
        Parrot_Hash_ro_set_string_native,
        Parrot_Hash_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Hash_ro_shift_float,
        Parrot_Hash_ro_shift_integer,
        Parrot_Hash_ro_shift_pmc,
        Parrot_Hash_ro_shift_string,
        Parrot_Hash_slice,
        Parrot_Hash_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Hash_ro_thaw,
        Parrot_Hash_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Hash_ro_unshift_float,
        Parrot_Hash_ro_unshift_integer,
        Parrot_Hash_ro_unshift_pmc,
        Parrot_Hash_ro_unshift_string,
        Parrot_Hash_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Hash");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "hash");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Hash")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Hash"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_Hash_class_init */
#line 1101 "./src/pmc/hash.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
