/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/integer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_integer.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "integer.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/integer.pmc"
/*
Copyright (C) 2003-2008, Parrot Foundation.
$Id: integer.pmc 37393 2009-03-13 19:56:52Z Util $

=head1 NAME

src/pmc/integer.pmc - Integer PMC class

=head1 DESCRIPTION

C<Integer> provides an integer for languages that want a value-restricted
integer type without going to an I register.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#include "pmc_bigint.h"

static void
maybe_throw_overflow_error(PARROT_INTERP)
{
    /* check to see what the behavior is. If the interpreter is set
       to throw an exception on overflow. If so, throw the exception,
       otherwise, chill out it's no big deal. */
    if (PARROT_ERRORS_test(interp, PARROT_ERRORS_OVERFLOW_FLAG))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ERR_OVERFLOW,
            "Integer overflow");
}

static PMC*
upgrade_self_to_bignum(PARROT_INTERP, PMC *self)
{
    /* Do an in-place upgrade to a Bignum of SELF and return a pointer
       to it (which is probably redundant, but whatever). */
    const INTVAL a = VTABLE_get_integer(interp, self);
    pmc_reuse(interp, self, enum_class_BigInt, 0);
    VTABLE_set_integer_native(interp, self, a);
    return self;
}
#line 70 "./src/pmc/integer.c"
PARROT_EXPORT  PMC  *
Parrot_Integer_absolute(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1312 "./src/pmc/integer.pmc"

    const INTVAL a = abs(VTABLE_get_integer(interp, pmc));

    /* RT #46635 overflow for -maxint */
    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, a);
    return dest;

#line 84 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_add_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 407 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_add_int(interp, temp, b, dest);
    }
#line 106 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_clone(PARROT_INTERP, PMC *pmc)
{
#line 116 "./src/pmc/integer.pmc"

    PMC * const clone = pmc_new(interp, pmc->vtable->base_type);
    VTABLE_set_integer_native(interp, clone, VTABLE_get_integer(interp, pmc));
    return clone;
#line 116 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_decrement(PARROT_INTERP, PMC *pmc)
{
#line 1286 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - 1;

    if ((c^a) >= 0 || (c^~1) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        pmc_reuse(interp, pmc, enum_class_BigInt, 0);
        VTABLE_set_integer_native(interp, pmc, a);
        VTABLE_decrement(interp, pmc);
    }
#line 133 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_destroy(PARROT_INTERP, PMC *pmc)
{
#line 102 "./src/pmc/integer.pmc"

    mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
#line 142 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 893 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);

    return dest;
#line 161 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 878 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);

    return dest;
#line 180 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1366 "./src/pmc/integer.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_freeze(interp, pmc, info);
    VTABLE_push_integer(interp, io, VTABLE_get_integer(interp, pmc));
#line 190 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_get_bignum(PARROT_INTERP, PMC *pmc)
{
#line 238 "./src/pmc/integer.pmc"

    const INTVAL val = VTABLE_get_integer(interp, pmc);
    PMC * const  ret = pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, ret, val);
    return ret;
#line 201 "./src/pmc/integer.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Integer_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 209 "./src/pmc/integer.pmc"

    return VTABLE_get_integer(interp, pmc) ? 1 : 0;
#line 209 "./src/pmc/integer.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Integer_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 193 "./src/pmc/integer.pmc"

    INTVAL iv;
    GETATTR_Integer_iv(interp, pmc, iv);
    return iv;
#line 219 "./src/pmc/integer.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Integer_get_number(PARROT_INTERP, PMC *pmc)
{
#line 223 "./src/pmc/integer.pmc"

    return VTABLE_get_integer(interp, pmc);
#line 227 "./src/pmc/integer.c"
}
PARROT_EXPORT  STRING  *
Parrot_Integer_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 261 "./src/pmc/integer.pmc"

    return Parrot_str_from_int(interp, VTABLE_get_integer(interp, pmc));
#line 235 "./src/pmc/integer.c"
}
PARROT_EXPORT  STRING  *
Parrot_Integer_get_string(PARROT_INTERP, PMC *pmc)
{
#line 257 "./src/pmc/integer.pmc"

    return Parrot_str_from_int(interp, VTABLE_get_integer(interp, pmc));
#line 243 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_absolute(PARROT_INTERP, PMC *pmc)
{
#line 1324 "./src/pmc/integer.pmc"

    const INTVAL a = abs(VTABLE_get_integer(interp, pmc));
    VTABLE_set_integer_native(interp, pmc, a);
#line 252 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 475 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a + value);
#line 261 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 460 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        VTABLE_i_add_int(interp, temp, b);
    }
#line 279 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 939 "./src/pmc/integer.pmc"

    FLOATVAL f;
    INTVAL   self_val;

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 295 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 927 "./src/pmc/integer.pmc"

    FLOATVAL f;

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(VTABLE_get_number(interp, pmc) / value);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 310 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 1054 "./src/pmc/integer.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, pmc,
            intval_mod(VTABLE_get_integer(interp, pmc) , (INTVAL)value));
#line 323 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1044 "./src/pmc/integer.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, pmc,
            intval_mod(VTABLE_get_integer(interp, pmc) , value));
#line 336 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 766 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a * value);
#line 345 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 751 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, pmc);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        maybe_throw_overflow_error(interp);
        upgrade_self_to_bignum(interp, pmc);
        VTABLE_i_multiply_int(interp, pmc, b);
    }
#line 363 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_pow(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1144 "./src/pmc/integer.pmc"

    VTABLE_pow(interp, pmc, value, pmc);
#line 371 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1149 "./src/pmc/integer.pmc"

    Parrot_Integer_pow_int(interp, pmc, value, pmc);
#line 379 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 634 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    VTABLE_set_number_native(interp, pmc, a - value);
#line 388 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b)
{
#line 620 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        maybe_throw_overflow_error(interp);
        pmc = upgrade_self_to_bignum(interp, pmc);
        VTABLE_i_subtract_int(interp, pmc, b);
    }
#line 405 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_increment(PARROT_INTERP, PMC *pmc)
{
#line 1261 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a + 1;

    /* did not overflow */
    if ((c^a) >= 0 || (c^1) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        pmc_reuse(interp, pmc, enum_class_BigInt, 0);
        VTABLE_set_integer_native(interp, pmc, a);
        VTABLE_increment(interp, pmc);
    }
#line 423 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_init(PARROT_INTERP, PMC *pmc)
{
#line 94 "./src/pmc/integer.pmc"

    Parrot_Integer_attributes* const attrs =
        mem_allocate_zeroed_typed(Parrot_Integer_attributes);
    attrs->iv = 0;
    PMC_data(pmc) = attrs;
    PObj_active_destroy_SET(pmc);
#line 435 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_instantiate(PARROT_INTERP, PMC *pmc, PMC *sig)
{
#line 68 "./src/pmc/integer.pmc"

    PMC            * const ret    = pmc_new(interp, VTABLE_type(interp, pmc));
    const opcode_t * const arg_op = interp->current_args;
    INTVAL                 init   = 0;

    if (VTABLE_elements(interp, sig) == 2) {
        switch (VTABLE_get_integer_keyed_int(interp, sig, 1)) {
            case PARROT_ARG_I:
                init = REG_INT(interp, arg_op[3]);
                break;
            case PARROT_ARG_IC:
                init = arg_op[3];
                break;
            default:
                Parrot_ex_throw_from_c_args(interp, NULL,
                        EXCEPTION_SYNTAX_ERROR,
                        "Integer.instantiate: unhandled initializer");
                break;
        }
    }

    VTABLE_set_integer_native(interp, ret, init);
    return ret;
#line 464 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_instantiate_str(PARROT_INTERP, PMC *pmc, STRING *rep, INTVAL flags)
{
#line 132 "./src/pmc/integer.pmc"

    const INTVAL type = pmc->vtable->base_type;
    PMC * const  res  = (flags & PObj_constant_FLAG)
        ? constant_pmc_new(interp, type)
        : pmc_new(interp, type);

    /* RT #46623 bigint overflow */
    VTABLE_set_integer_native(interp, res, Parrot_str_to_int(interp, rep));
    return res;
#line 479 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 1012 "./src/pmc/integer.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(VTABLE_get_integer(interp, pmc), (INTVAL)value));
    return dest;
#line 495 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 999 "./src/pmc/integer.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(VTABLE_get_integer(interp, pmc), value));
    return dest;
#line 511 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 697 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, pmc);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_multiply_int(interp, temp, b, dest);
    }
#line 534 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_pow_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 1098 "./src/pmc/integer.pmc"

    const INTVAL a      = VTABLE_get_integer(interp, pmc);
    const INTVAL orig_b = b;
    INTVAL       r      = 1;

    if (b < 0)
        return Parrot_scalar_pow_int(interp, pmc, b, dest);

    if (a) {
        INTVAL temp = a;
        while (b > 0) {
            INTVAL prev = r;
            if (b & 1) {
                r *= temp;
                if (r / temp != prev) {
                    PMC *temp;
                    maybe_throw_overflow_error(interp);
                    temp = VTABLE_get_bignum(interp, pmc);
                    return VTABLE_pow_int(interp, temp, orig_b, dest);
                }
            }

            b >>= 1;
            if (!b)
                break;

            prev  = temp;
            temp *= temp;

            if (prev != 0 && temp / prev != prev) {
                PMC *temp;
                maybe_throw_overflow_error(interp);
                temp = VTABLE_get_bignum(interp, pmc);
                return VTABLE_pow_int(interp, temp, orig_b, dest);
            }
        }
    }

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, r);
    return dest;

#line 583 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_set_bignum_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 321 "./src/pmc/integer.pmc"

    pmc_reuse(interp, pmc, enum_class_BigInt, 0);
    VTABLE_set_integer_native(interp, pmc, value);
#line 592 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_set_bool(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 315 "./src/pmc/integer.pmc"

    pmc_reuse(interp, pmc, enum_class_Boolean, 0);
    VTABLE_set_bool(interp, pmc, value);
#line 601 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 283 "./src/pmc/integer.pmc"

    SETATTR_Integer_iv(interp, pmc, value);
#line 609 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_set_integer_same(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 278 "./src/pmc/integer.pmc"

    VTABLE_set_integer_native(interp, pmc, VTABLE_get_integer(interp, value));
#line 617 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 309 "./src/pmc/integer.pmc"

    pmc_reuse(interp, pmc, enum_class_Float, 0);
    VTABLE_set_number_native(interp, pmc, value);
#line 626 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 154 "./src/pmc/integer.pmc"

    VTABLE_set_integer_native(interp, pmc, VTABLE_get_integer(interp, value));
#line 634 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 327 "./src/pmc/integer.pmc"

    pmc_reuse(interp, pmc, enum_class_String, 0);
    VTABLE_set_string_native(interp, pmc, value);
#line 643 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_share(PARROT_INTERP, PMC *pmc)
{
#line 169 "./src/pmc/integer.pmc"

    /*
     * assume that the access to a long is atomic.
     * integers are most often (1) equal to C longs,
     * not C ints, and this makes a difference in 64-bit
     * platforms where longs are 64-bit but ints are 32-bit.
     * (1) Not equal when integers have been configured
     *     to be software-emulated long longs.
     */
    if (sizeof (INTVAL) != sizeof (long))
        Parrot_default_share(interp, pmc);
#line 660 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL b, PMC *dest)
{
#line 555 "./src/pmc/integer.pmc"

    const INTVAL a = VTABLE_get_integer(interp, pmc);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_subtract_int(interp, temp, b, dest);
    }
#line 682 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1382 "./src/pmc/integer.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_thaw(interp, pmc, info);
    if (info->extra_flags == EXTRA_IS_NULL)
        VTABLE_set_integer_native(interp, pmc, VTABLE_shift_integer(interp, io));
#line 693 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_add_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 344 "./src/pmc/integer.pmc"

    /*
     * pmc and value can both be PMCs that inherit
     * from Integer:
     *   cl = subclass "Integer", "MyInt"
     * so we can't used PMC_int_val(pmc) in any of these
     * Integer methods
     *
     * RT #46627
     *   check for exact Integer type
     *   e.g. MMD_Integer_EXACT
     */

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a + b;

    if ((c^a) >= 0 || (c^b) >= 0) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        /* need this for e.g. Undef PMC */
        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC * temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_add(interp, temp, value, dest);
    }
#line 729 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_add_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 377 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    dest           = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a + VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            VTABLE_get_number_keyed_int(interp, value, 1));

    return dest;
#line 745 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_add_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 390 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = VTABLE_get_bignum(interp, pmc);
    return VTABLE_add(interp, temp, value, dest);
#line 756 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 398 "./src/pmc/integer.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            pmc->vtable->get_integer(interp, pmc) + VTABLE_get_number(interp, value));
    return dest;
#line 768 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_add_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 440 "./src/pmc/integer.pmc"

    Parrot_Integer_i_add_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 776 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 445 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);

    pmc_reuse(interp, pmc, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) + VTABLE_get_number(interp, value));
#line 788 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 454 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) + VTABLE_get_number(interp, value));
#line 797 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_subtract_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 495 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_subtract(interp, temp, value, dest);
    }
#line 820 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 515 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    dest           = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));

    return dest;
#line 836 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_subtract_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 528 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = VTABLE_get_bignum(interp, pmc);
    return VTABLE_subtract(interp, temp, value, dest);
#line 847 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 536 "./src/pmc/integer.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_number(interp, value));
    return dest;
#line 859 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_subtract_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 588 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);
    const INTVAL b = VTABLE_get_integer(interp, value);
    const INTVAL c = a - b;

    if ((c^a) >= 0 || (c^~b) >= 0)
        VTABLE_set_integer_native(interp, pmc, c);
    else {
        maybe_throw_overflow_error(interp);
        pmc = upgrade_self_to_bignum(interp, pmc);
        VTABLE_i_subtract(interp, pmc, value);
    }
#line 877 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 603 "./src/pmc/integer.pmc"

    const INTVAL a = pmc->vtable->get_integer(interp, pmc);

    pmc_reuse(interp, pmc, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, pmc,
            (FLOATVAL)a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, pmc, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));
#line 891 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 614 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_number(interp, value));
#line 900 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_multiply_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 652 "./src/pmc/integer.pmc"

    const INTVAL a  = VTABLE_get_integer(interp, pmc);
    const INTVAL b  = VTABLE_get_integer(interp, value);
    const INTVAL c  = a * b;
    const double cf = (double)a * (double)b;

    if ((double) c == cf) {
        dest = pmc_new(interp, VTABLE_type(interp, pmc));

        VTABLE_set_integer_native(interp, dest, c);
        return dest;
    }
    else {
        PMC *temp;
        maybe_throw_overflow_error(interp);
        temp = VTABLE_get_bignum(interp, pmc);
        return VTABLE_multiply(interp, temp, value, dest);
    }
#line 924 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 673 "./src/pmc/integer.pmc"

    return VTABLE_multiply(interp, value, pmc, dest);
#line 932 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_multiply_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 678 "./src/pmc/integer.pmc"

    return VTABLE_multiply_int(interp, value, pmc->vtable->get_integer(interp, pmc), dest);
#line 940 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_multiply_String_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 683 "./src/pmc/integer.pmc"

    return Parrot_Integer_multi_multiply_Integer_PMC(interp, pmc, value, dest);
#line 948 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 688 "./src/pmc/integer.pmc"

    const FLOATVAL valf = VTABLE_get_number(interp, value);
    dest                = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, pmc->vtable->get_number(interp, pmc) * valf);
    return dest;
#line 960 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_multiply_Integer(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 730 "./src/pmc/integer.pmc"

    Parrot_Integer_i_multiply_int(interp, pmc, VTABLE_get_integer(interp, value));
#line 968 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_multiply_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 735 "./src/pmc/integer.pmc"

    Parrot_BigInt_multiply_int(interp, value, pmc->vtable->get_integer(interp, pmc), pmc);
#line 976 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 740 "./src/pmc/integer.pmc"

    VTABLE_multiply(interp, value, pmc, pmc);
#line 984 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 745 "./src/pmc/integer.pmc"

    VTABLE_set_number_native(interp, pmc,
            pmc->vtable->get_integer(interp, pmc) * VTABLE_get_number(interp, value));
#line 993 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 794 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = VTABLE_get_bignum(interp, pmc);
    return VTABLE_divide(interp, temp, value, dest);
#line 1004 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 801 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));
    VTABLE_set_number_native(interp, dest, pmc->vtable->get_number(interp, pmc) / d);
    return dest;
#line 1020 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 814 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    pmc = upgrade_self_to_bignum(interp, pmc);
    VTABLE_i_divide(interp, pmc, value);
#line 1030 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 821 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    VTABLE_set_number_native(interp, pmc, pmc->vtable->get_number(interp, pmc) / d);
#line 1044 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_floor_divide_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 854 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = VTABLE_get_bignum(interp, pmc);
    return VTABLE_floor_divide(interp, temp, value, dest);
#line 1055 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_floor_divide_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 862 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);
    FLOATVAL f;

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    f = floor(pmc->vtable->get_number(interp, pmc) / d);
    VTABLE_set_integer_native(interp, dest, (INTVAL)f);
    return dest;
#line 1074 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_floor_divide_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 908 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    pmc = upgrade_self_to_bignum(interp, pmc);
    VTABLE_i_floor_divide(interp, pmc, value);
#line 1084 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_floor_divide_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 914 "./src/pmc/integer.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);
    FLOATVAL f;

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "float division by zero");

    f = floor(pmc->vtable->get_number(interp, pmc) / d);
    VTABLE_set_integer_native(interp, pmc, (INTVAL)f);
#line 1100 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_modulus_BigInt_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 976 "./src/pmc/integer.pmc"

    PMC *temp;
    maybe_throw_overflow_error(interp);
    temp = VTABLE_get_bignum(interp, pmc);
    return VTABLE_modulus(interp, temp, value, dest);
#line 1111 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_modulus_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 984 "./src/pmc/integer.pmc"

    const INTVAL d = VTABLE_get_integer(interp, value);

    if (d == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest,
            intval_mod(pmc->vtable->get_integer(interp, pmc), d));
    return dest;
#line 1129 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_modulus_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1025 "./src/pmc/integer.pmc"

    maybe_throw_overflow_error(interp);
    pmc = upgrade_self_to_bignum(interp, pmc);
    VTABLE_i_modulus(interp, pmc, value);
#line 1139 "./src/pmc/integer.c"
}
PARROT_EXPORT  void 
Parrot_Integer_multi_i_modulus_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1032 "./src/pmc/integer.pmc"

    const INTVAL d = VTABLE_get_integer(interp, value);

    if (d == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
                "int modulus by zero");

    VTABLE_set_integer_native(interp, pmc,
            intval_mod(pmc->vtable->get_integer(interp, pmc), d));
#line 1154 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_pow_Integer_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1084 "./src/pmc/integer.pmc"

    const INTVAL v = VTABLE_get_integer(interp, value);
    return Parrot_Integer_pow_int(interp, pmc, v, dest);
#line 1163 "./src/pmc/integer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Integer_multi_pow_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1090 "./src/pmc/integer.pmc"

    PMC * const auxval = pmc_new(interp, VTABLE_type(interp, value));
    FLOATVAL selfval = pmc->vtable->get_integer(interp, pmc);
    VTABLE_set_number_native(interp, auxval, selfval);
    return VTABLE_pow(interp, auxval, value, dest);
#line 1174 "./src/pmc/integer.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Integer_multi_is_equal_BigInt(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1164 "./src/pmc/integer.pmc"

    PMC * const temp = pmc_new(interp, enum_class_BigInt);
    VTABLE_set_integer_native(interp, temp, pmc->vtable->get_integer(interp, pmc));
    return Parrot_BigInt_multi_is_equal_BigInt(interp, temp, value);
#line 1184 "./src/pmc/integer.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Integer_multi_is_equal_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1171 "./src/pmc/integer.pmc"

    return (VTABLE_get_integer(interp, pmc)
        ==  VTABLE_get_integer(interp, value));
#line 1193 "./src/pmc/integer.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Integer_multi_cmp_String(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1187 "./src/pmc/integer.pmc"

    const FLOATVAL fdiff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(fdiff)) {
        const INTVAL idiff =
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_integer(interp, value);
        return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
    }

    return fdiff > 0 ? 1 : -1;
#line 1209 "./src/pmc/integer.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Integer_multi_cmp_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1200 "./src/pmc/integer.pmc"

    const FLOATVAL diff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1218 "./src/pmc/integer.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Integer_multi_cmp_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1206 "./src/pmc/integer.pmc"

    /* int or undef */
    const INTVAL selfint  = pmc->vtable->get_integer(interp, pmc);
    const INTVAL valueint = VTABLE_get_integer(interp, value);

    return selfint > valueint ? 1 : selfint < valueint ? -1 : 0;
#line 1230 "./src/pmc/integer.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Integer_multi_cmp_num_String(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1225 "./src/pmc/integer.pmc"

    const FLOATVAL fdiff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(fdiff)) {
        const INTVAL idiff =
            pmc->vtable->get_integer(interp, pmc) - VTABLE_get_integer(interp, value);
        return idiff > 0 ? 1 : idiff < 0 ? -1 : 0;
    }

    return fdiff > 0 ? 1 : -1;
#line 1246 "./src/pmc/integer.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Integer_multi_cmp_num_Float(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1238 "./src/pmc/integer.pmc"

    const FLOATVAL diff = pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1255 "./src/pmc/integer.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Integer_multi_cmp_num_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1244 "./src/pmc/integer.pmc"

    /* int or undef */
    const INTVAL diff = pmc->vtable->get_integer(interp, pmc) - VTABLE_get_integer(interp, value);
    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
#line 1265 "./src/pmc/integer.c"
}
PARROT_EXPORT  void
Parrot_Integer_nci_get_as_base(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 0);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1304 "./src/pmc/integer.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1321 "./src/pmc/integer.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    INTVAL base = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1341 "./src/pmc/integer.pmc"

    char buf[128];
    STRING *result;

    if ((base < 2) || (base > 36))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "get_as_base: base out of bounds");

    result = Parrot_str_from_int_base(interp, buf,
            (HUGEINTVAL)VTABLE_get_integer(interp, pmc),
            (unsigned int)base);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *result */
    /*BEGIN GENERATED ACCESSORS */
#line 1346 "./src/pmc/integer.pmc"
    CTX_REG_STR(_ctx, 0) = result;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto get_as_base_returns;
    /*END RETURN STRING *result */
    }
#line 1353 "./src/pmc/integer.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_as_base_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1391 "./src/pmc/integer.c"
}
PARROT_EXPORT  void
Parrot_Integer_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Integer");
}
PARROT_EXPORT  PMC *
Parrot_Integer_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Integer");
}
PARROT_EXPORT  FLOATVAL
Parrot_Integer_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Integer");
}
PARROT_EXPORT  INTVAL
Parrot_Integer_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Integer");
}
PARROT_EXPORT  PMC *
Parrot_Integer_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Integer");
}
PARROT_EXPORT  STRING *
Parrot_Integer_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Integer");
}
PARROT_EXPORT  FLOATVAL
Parrot_Integer_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Integer");
}
PARROT_EXPORT  INTVAL
Parrot_Integer_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Integer");
}
PARROT_EXPORT  PMC *
Parrot_Integer_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Integer");
}
PARROT_EXPORT  STRING *
Parrot_Integer_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Integer");
}
PARROT_EXPORT  void
Parrot_Integer_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Integer");
}
#include "pmc_default.h"
void
Parrot_Integer_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iiv ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Integer, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_Integer_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_scalar_add_float,
        Parrot_Integer_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_scalar_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_scalar_bitwise_and,
        Parrot_scalar_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_scalar_bitwise_lsr,
        Parrot_scalar_bitwise_lsr_int,
        Parrot_scalar_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_scalar_bitwise_or,
        Parrot_scalar_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_scalar_bitwise_shl,
        Parrot_scalar_bitwise_shl_int,
        Parrot_scalar_bitwise_shr,
        Parrot_scalar_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Integer_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_scalar_concatenate,
        Parrot_scalar_concatenate_str,
        Parrot_Integer_decrement,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Integer_destroy,
        Parrot_default_divide,
        Parrot_scalar_divide_float,
        Parrot_scalar_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_Integer_floor_divide_float,
        Parrot_Integer_floor_divide_int,
        Parrot_Integer_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_Integer_get_bignum,
        Parrot_Integer_get_bool,
        Parrot_default_get_class,
        Parrot_Integer_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_Integer_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Integer_get_repr,
        Parrot_Integer_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Integer_i_absolute,
        Parrot_default_i_add,
        Parrot_Integer_i_add_float,
        Parrot_Integer_i_add_int,
        Parrot_scalar_i_bitwise_and,
        Parrot_scalar_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_scalar_i_bitwise_lsr,
        Parrot_scalar_i_bitwise_lsr_int,
        Parrot_scalar_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_scalar_i_bitwise_or,
        Parrot_scalar_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_scalar_i_bitwise_shl,
        Parrot_scalar_i_bitwise_shl_int,
        Parrot_scalar_i_bitwise_shr,
        Parrot_scalar_i_bitwise_shr_int,
        Parrot_scalar_i_bitwise_xor,
        Parrot_scalar_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_scalar_i_concatenate,
        Parrot_scalar_i_concatenate_str,
        Parrot_scalar_i_divide,
        Parrot_scalar_i_divide_float,
        Parrot_scalar_i_divide_int,
        Parrot_scalar_i_floor_divide,
        Parrot_Integer_i_floor_divide_float,
        Parrot_Integer_i_floor_divide_int,
        Parrot_scalar_i_logical_not,
        Parrot_scalar_i_modulus,
        Parrot_Integer_i_modulus_float,
        Parrot_Integer_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_Integer_i_multiply_float,
        Parrot_Integer_i_multiply_int,
        Parrot_scalar_i_neg,
        Parrot_Integer_i_pow,
        Parrot_scalar_i_pow_float,
        Parrot_Integer_i_pow_int,
        Parrot_scalar_i_repeat,
        Parrot_scalar_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_Integer_i_subtract_float,
        Parrot_Integer_i_subtract_int,
        Parrot_Integer_increment,
        Parrot_Integer_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_Integer_instantiate,
        Parrot_Integer_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_scalar_logical_and,
        Parrot_scalar_logical_not,
        Parrot_scalar_logical_or,
        Parrot_scalar_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_Integer_modulus_float,
        Parrot_Integer_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_scalar_multiply_float,
        Parrot_Integer_multiply_int,
        Parrot_default_name,
        Parrot_scalar_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_scalar_pow_float,
        Parrot_Integer_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_scalar_repeat,
        Parrot_scalar_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_Integer_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_Integer_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Integer_set_integer_native,
        Parrot_Integer_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_Integer_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Integer_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Integer_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_Integer_share,
        Parrot_scalar_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_subtract,
        Parrot_scalar_subtract_float,
        Parrot_Integer_subtract_int,
        Parrot_Integer_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Integer, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_Integer_absolute,
        Parrot_default_add,
        Parrot_Integer_ro_add_attribute,
        Parrot_scalar_add_float,
        Parrot_Integer_add_int,
        Parrot_Integer_ro_add_method,
        Parrot_Integer_ro_add_parent,
        Parrot_Integer_ro_add_role,
        Parrot_Integer_ro_add_vtable_override,
        Parrot_Integer_ro_assign_pmc,
        Parrot_Integer_ro_assign_string_native,
        Parrot_scalar_bitwise_and,
        Parrot_scalar_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_scalar_bitwise_lsr,
        Parrot_scalar_bitwise_lsr_int,
        Parrot_scalar_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_scalar_bitwise_or,
        Parrot_scalar_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_scalar_bitwise_shl,
        Parrot_scalar_bitwise_shl_int,
        Parrot_scalar_bitwise_shr,
        Parrot_scalar_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Integer_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_scalar_concatenate,
        Parrot_scalar_concatenate_str,
        Parrot_Integer_ro_decrement,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Integer_ro_delete_keyed,
        Parrot_Integer_ro_delete_keyed_int,
        Parrot_Integer_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Integer_destroy,
        Parrot_default_divide,
        Parrot_scalar_divide_float,
        Parrot_scalar_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Integer_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_Integer_floor_divide_float,
        Parrot_Integer_floor_divide_int,
        Parrot_Integer_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_Integer_get_bignum,
        Parrot_Integer_get_bool,
        Parrot_default_get_class,
        Parrot_Integer_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_Integer_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Integer_get_repr,
        Parrot_Integer_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Integer_ro_i_absolute,
        Parrot_Integer_ro_i_add,
        Parrot_Integer_ro_i_add_float,
        Parrot_Integer_ro_i_add_int,
        Parrot_Integer_ro_i_bitwise_and,
        Parrot_Integer_ro_i_bitwise_and_int,
        Parrot_Integer_ro_i_bitwise_ands,
        Parrot_Integer_ro_i_bitwise_ands_str,
        Parrot_Integer_ro_i_bitwise_lsr,
        Parrot_Integer_ro_i_bitwise_lsr_int,
        Parrot_Integer_ro_i_bitwise_not,
        Parrot_Integer_ro_i_bitwise_nots,
        Parrot_Integer_ro_i_bitwise_or,
        Parrot_Integer_ro_i_bitwise_or_int,
        Parrot_Integer_ro_i_bitwise_ors,
        Parrot_Integer_ro_i_bitwise_ors_str,
        Parrot_Integer_ro_i_bitwise_shl,
        Parrot_Integer_ro_i_bitwise_shl_int,
        Parrot_Integer_ro_i_bitwise_shr,
        Parrot_Integer_ro_i_bitwise_shr_int,
        Parrot_Integer_ro_i_bitwise_xor,
        Parrot_Integer_ro_i_bitwise_xor_int,
        Parrot_Integer_ro_i_bitwise_xors,
        Parrot_Integer_ro_i_bitwise_xors_str,
        Parrot_Integer_ro_i_concatenate,
        Parrot_Integer_ro_i_concatenate_str,
        Parrot_Integer_ro_i_divide,
        Parrot_Integer_ro_i_divide_float,
        Parrot_Integer_ro_i_divide_int,
        Parrot_Integer_ro_i_floor_divide,
        Parrot_Integer_ro_i_floor_divide_float,
        Parrot_Integer_ro_i_floor_divide_int,
        Parrot_Integer_ro_i_logical_not,
        Parrot_Integer_ro_i_modulus,
        Parrot_Integer_ro_i_modulus_float,
        Parrot_Integer_ro_i_modulus_int,
        Parrot_Integer_ro_i_multiply,
        Parrot_Integer_ro_i_multiply_float,
        Parrot_Integer_ro_i_multiply_int,
        Parrot_Integer_ro_i_neg,
        Parrot_Integer_ro_i_pow,
        Parrot_Integer_ro_i_pow_float,
        Parrot_Integer_ro_i_pow_int,
        Parrot_Integer_ro_i_repeat,
        Parrot_Integer_ro_i_repeat_int,
        Parrot_Integer_ro_i_subtract,
        Parrot_Integer_ro_i_subtract_float,
        Parrot_Integer_ro_i_subtract_int,
        Parrot_Integer_ro_increment,
        Parrot_Integer_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_Integer_instantiate,
        Parrot_Integer_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_scalar_logical_and,
        Parrot_scalar_logical_not,
        Parrot_scalar_logical_or,
        Parrot_scalar_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_Integer_modulus_float,
        Parrot_Integer_modulus_int,
        Parrot_Integer_ro_morph,
        Parrot_default_multiply,
        Parrot_scalar_multiply_float,
        Parrot_Integer_multiply_int,
        Parrot_default_name,
        Parrot_scalar_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Integer_ro_pop_float,
        Parrot_Integer_ro_pop_integer,
        Parrot_Integer_ro_pop_pmc,
        Parrot_Integer_ro_pop_string,
        Parrot_default_pow,
        Parrot_scalar_pow_float,
        Parrot_Integer_pow_int,
        Parrot_Integer_ro_push_float,
        Parrot_Integer_ro_push_integer,
        Parrot_Integer_ro_push_pmc,
        Parrot_Integer_ro_push_string,
        Parrot_Integer_ro_remove_attribute,
        Parrot_Integer_ro_remove_method,
        Parrot_Integer_ro_remove_parent,
        Parrot_Integer_ro_remove_role,
        Parrot_Integer_ro_remove_vtable_override,
        Parrot_scalar_repeat,
        Parrot_scalar_repeat_int,
        Parrot_Integer_ro_set_attr_keyed,
        Parrot_Integer_ro_set_attr_str,
        Parrot_Integer_ro_set_bignum_int,
        Parrot_Integer_ro_set_bignum_num,
        Parrot_Integer_ro_set_bignum_str,
        Parrot_Integer_ro_set_bool,
        Parrot_Integer_ro_set_integer_keyed,
        Parrot_Integer_ro_set_integer_keyed_int,
        Parrot_Integer_ro_set_integer_keyed_str,
        Parrot_Integer_ro_set_integer_native,
        Parrot_Integer_ro_set_integer_same,
        Parrot_Integer_ro_set_number_keyed,
        Parrot_Integer_ro_set_number_keyed_int,
        Parrot_Integer_ro_set_number_keyed_str,
        Parrot_Integer_ro_set_number_native,
        Parrot_Integer_ro_set_number_same,
        Parrot_Integer_ro_set_pmc,
        Parrot_Integer_ro_set_pmc_keyed,
        Parrot_Integer_ro_set_pmc_keyed_int,
        Parrot_Integer_ro_set_pmc_keyed_str,
        Parrot_Integer_ro_set_pointer,
        Parrot_Integer_ro_set_pointer_keyed,
        Parrot_Integer_ro_set_pointer_keyed_int,
        Parrot_Integer_ro_set_pointer_keyed_str,
        Parrot_Integer_ro_set_string_keyed,
        Parrot_Integer_ro_set_string_keyed_int,
        Parrot_Integer_ro_set_string_keyed_str,
        Parrot_Integer_ro_set_string_native,
        Parrot_Integer_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_Integer_share,
        Parrot_scalar_share_ro,
        Parrot_Integer_ro_shift_float,
        Parrot_Integer_ro_shift_integer,
        Parrot_Integer_ro_shift_pmc,
        Parrot_Integer_ro_shift_string,
        Parrot_default_slice,
        Parrot_Integer_ro_splice,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_subtract,
        Parrot_scalar_subtract_float,
        Parrot_Integer_subtract_int,
        Parrot_Integer_ro_thaw,
        Parrot_Integer_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Integer_ro_unshift_float,
        Parrot_Integer_ro_unshift_integer,
        Parrot_Integer_ro_unshift_pmc,
        Parrot_Integer_ro_unshift_string,
        Parrot_default_visit
    };

    const  multi_func_list _temp_multi_func_list[] = {
        { "add", 
          "PJPPP", 
          "Integer,Integer,PMC", 
          (funcptr_t) Parrot_Integer_multi_add_Integer_PMC },
        { "add", 
          "PJPPP", 
          "Integer,Complex,PMC", 
          (funcptr_t) Parrot_Integer_multi_add_Complex_PMC },
        { "add", 
          "PJPPP", 
          "Integer,BigInt,PMC", 
          (funcptr_t) Parrot_Integer_multi_add_BigInt_PMC },
        { "add", 
          "PJPPP", 
          "Integer,DEFAULT,PMC", 
          (funcptr_t) Parrot_Integer_multi_add_DEFAULT_PMC },
        { "i_add", 
          "vJPP", 
          "Integer,Integer", 
          (funcptr_t) Parrot_Integer_multi_i_add_Integer },
        { "i_add", 
          "vJPP", 
          "Integer,Complex", 
          (funcptr_t) Parrot_Integer_multi_i_add_Complex },
        { "i_add", 
          "vJPP", 
          "Integer,DEFAULT", 
          (funcptr_t) Parrot_Integer_multi_i_add_DEFAULT },
        { "subtract", 
          "PJPPP", 
          "Integer,Integer,PMC", 
          (funcptr_t) Parrot_Integer_multi_subtract_Integer_PMC },
        { "subtract", 
          "PJPPP", 
          "Integer,Complex,PMC", 
          (funcptr_t) Parrot_Integer_multi_subtract_Complex_PMC },
        { "subtract", 
          "PJPPP", 
          "Integer,BigInt,PMC", 
          (funcptr_t) Parrot_Integer_multi_subtract_BigInt_PMC },
        { "subtract", 
          "PJPPP", 
          "Integer,DEFAULT,PMC", 
          (funcptr_t) Parrot_Integer_multi_subtract_DEFAULT_PMC },
        { "i_subtract", 
          "vJPP", 
          "Integer,Integer", 
          (funcptr_t) Parrot_Integer_multi_i_subtract_Integer },
        { "i_subtract", 
          "vJPP", 
          "Integer,Complex", 
          (funcptr_t) Parrot_Integer_multi_i_subtract_Complex },
        { "i_subtract", 
          "vJPP", 
          "Integer,DEFAULT", 
          (funcptr_t) Parrot_Integer_multi_i_subtract_DEFAULT },
        { "multiply", 
          "PJPPP", 
          "Integer,Integer,PMC", 
          (funcptr_t) Parrot_Integer_multi_multiply_Integer_PMC },
        { "multiply", 
          "PJPPP", 
          "Integer,Complex,PMC", 
          (funcptr_t) Parrot_Integer_multi_multiply_Complex_PMC },
        { "multiply", 
          "PJPPP", 
          "Integer,BigInt,PMC", 
          (funcptr_t) Parrot_Integer_multi_multiply_BigInt_PMC },
        { "multiply", 
          "PJPPP", 
          "Integer,String,PMC", 
          (funcptr_t) Parrot_Integer_multi_multiply_String_PMC },
        { "multiply", 
          "PJPPP", 
          "Integer,DEFAULT,PMC", 
          (funcptr_t) Parrot_Integer_multi_multiply_DEFAULT_PMC },
        { "i_multiply", 
          "vJPP", 
          "Integer,Integer", 
          (funcptr_t) Parrot_Integer_multi_i_multiply_Integer },
        { "i_multiply", 
          "vJPP", 
          "Integer,BigInt", 
          (funcptr_t) Parrot_Integer_multi_i_multiply_BigInt },
        { "i_multiply", 
          "vJPP", 
          "Integer,Complex", 
          (funcptr_t) Parrot_Integer_multi_i_multiply_Complex },
        { "i_multiply", 
          "vJPP", 
          "Integer,DEFAULT", 
          (funcptr_t) Parrot_Integer_multi_i_multiply_DEFAULT },
        { "divide", 
          "PJPPP", 
          "Integer,BigInt,PMC", 
          (funcptr_t) Parrot_Integer_multi_divide_BigInt_PMC },
        { "divide", 
          "PJPPP", 
          "Integer,DEFAULT,PMC", 
          (funcptr_t) Parrot_Integer_multi_divide_DEFAULT_PMC },
        { "i_divide", 
          "vJPP", 
          "Integer,BigInt", 
          (funcptr_t) Parrot_Integer_multi_i_divide_BigInt },
        { "i_divide", 
          "vJPP", 
          "Integer,DEFAULT", 
          (funcptr_t) Parrot_Integer_multi_i_divide_DEFAULT },
        { "floor_divide", 
          "PJPPP", 
          "Integer,BigInt,PMC", 
          (funcptr_t) Parrot_Integer_multi_floor_divide_BigInt_PMC },
        { "floor_divide", 
          "PJPPP", 
          "Integer,DEFAULT,PMC", 
          (funcptr_t) Parrot_Integer_multi_floor_divide_DEFAULT_PMC },
        { "i_floor_divide", 
          "vJPP", 
          "Integer,BigInt", 
          (funcptr_t) Parrot_Integer_multi_i_floor_divide_BigInt },
        { "i_floor_divide", 
          "vJPP", 
          "Integer,DEFAULT", 
          (funcptr_t) Parrot_Integer_multi_i_floor_divide_DEFAULT },
        { "modulus", 
          "PJPPP", 
          "Integer,BigInt,PMC", 
          (funcptr_t) Parrot_Integer_multi_modulus_BigInt_PMC },
        { "modulus", 
          "PJPPP", 
          "Integer,DEFAULT,PMC", 
          (funcptr_t) Parrot_Integer_multi_modulus_DEFAULT_PMC },
        { "i_modulus", 
          "vJPP", 
          "Integer,BigInt", 
          (funcptr_t) Parrot_Integer_multi_i_modulus_BigInt },
        { "i_modulus", 
          "vJPP", 
          "Integer,DEFAULT", 
          (funcptr_t) Parrot_Integer_multi_i_modulus_DEFAULT },
        { "pow", 
          "PJPPP", 
          "Integer,Integer,PMC", 
          (funcptr_t) Parrot_Integer_multi_pow_Integer_PMC },
        { "pow", 
          "PJPPP", 
          "Integer,DEFAULT,PMC", 
          (funcptr_t) Parrot_Integer_multi_pow_DEFAULT_PMC },
        { "is_equal", 
          "IJPP", 
          "Integer,BigInt", 
          (funcptr_t) Parrot_Integer_multi_is_equal_BigInt },
        { "is_equal", 
          "IJPP", 
          "Integer,DEFAULT", 
          (funcptr_t) Parrot_Integer_multi_is_equal_DEFAULT },
        { "cmp", 
          "IJPP", 
          "Integer,String", 
          (funcptr_t) Parrot_Integer_multi_cmp_String },
        { "cmp", 
          "IJPP", 
          "Integer,Float", 
          (funcptr_t) Parrot_Integer_multi_cmp_Float },
        { "cmp", 
          "IJPP", 
          "Integer,DEFAULT", 
          (funcptr_t) Parrot_Integer_multi_cmp_DEFAULT },
        { "cmp_num", 
          "IJPP", 
          "Integer,String", 
          (funcptr_t) Parrot_Integer_multi_cmp_num_String },
        { "cmp_num", 
          "IJPP", 
          "Integer,Float", 
          (funcptr_t) Parrot_Integer_multi_cmp_num_Float },
        { "cmp_num", 
          "IJPP", 
          "Integer,DEFAULT", 
          (funcptr_t) Parrot_Integer_multi_cmp_num_DEFAULT }
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Integer");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar integer");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Integer")), PMCNULL);
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "scalar")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Integer"));
            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "scalar"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Integer_nci_get_as_base), "get_as_base");
        {
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_Integer_class_init */
#line 1387 "./src/pmc/integer.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
