/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/iterator.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_iterator.h"
#include "pmc_default.h"
#include "iterator.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/iterator.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: iterator.pmc 37393 2009-03-13 19:56:52Z Util $

=head1 NAME

src/pmc/iterator.pmc - Iterator PMC

=head1 DESCRIPTION

These are the vtable functions for the Iterator base class. Iterators are
used in combination with other classes(mainly aggregates) to visit all entries
in that aggregate.

=head1 SYNOPSIS

=head2 default usage

    .local pmc iterator, array, entry
    iterator = new 'Iterator', array
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = shift iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

The C<new> can alternatively be written as:

  iterator = iter array

=head2 iterate from the end, for arrays

    .local pmc iterator, array, entry
    iterator = new 'Iterator', array
    iterator = .ITERATE_FROM_END
  iter_loop:
    unless iterator, iter_end  # while (more values)
    entry = pop iterator     # get an entry
    ...
    goto iter_loop
  iter_end:

=head2 iterate over a hash

    .local pmc iterator, hash, key, entry
    iterator = new 'Iterator', hash
  iter_loop:
    unless iterator, iter_end  # while (more values)
    key   = shift iterator     # get the key..
    entry = hash[key]
    ...
    goto iter_loop
  iter_end:

=head1 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#line 87 "./src/pmc/iterator.c"
PARROT_EXPORT  PMC  *
Parrot_Iterator_clone(PARROT_INTERP, PMC *pmc)
{
#line 165 "./src/pmc/iterator.pmc"

    PMC           *key;
    STRING * const name = CONST_STRING(interp, "set_key");
    PMC    * const res  = pmc_new_init(interp, pmc->vtable->base_type,
                                       VTABLE_get_pmc(interp, pmc));

    GETATTR_Iterator_key(interp, pmc, key);

    Parrot_PCCINVOKE(interp, res, name, "P->", VTABLE_clone(interp, key));
    return res;
#line 102 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_defined(PARROT_INTERP, PMC *pmc)
{
#line 698 "./src/pmc/iterator.pmc"

    return (INTVAL)(VTABLE_get_pmc(interp, pmc) != PMCNULL);
#line 110 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 710 "./src/pmc/iterator.pmc"

    return VTABLE_defined_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 118 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 724 "./src/pmc/iterator.pmc"

    PMC * const agg = VTABLE_get_pmc(interp, pmc);
    PMC        *key;

    GETATTR_Iterator_key(interp, pmc, key);
    return VTABLE_defined_keyed_int(interp, agg,
            VTABLE_get_integer(interp, key) + idx);
#line 131 "./src/pmc/iterator.c"
}
PARROT_EXPORT  void 
Parrot_Iterator_destroy(PARROT_INTERP, PMC *pmc)
{
#line 129 "./src/pmc/iterator.pmc"

    mem_sys_free(PMC_data(pmc));
#line 139 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_elements(PARROT_INTERP, PMC *pmc)
{
#line 330 "./src/pmc/iterator.pmc"

    return VTABLE_elements(interp, VTABLE_get_pmc(interp, pmc));
#line 147 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 666 "./src/pmc/iterator.pmc"

    return VTABLE_exists_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 155 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 680 "./src/pmc/iterator.pmc"

    PMC * const agg = VTABLE_get_pmc(interp, pmc);
    PMC        *key;
    GETATTR_Iterator_key(interp, pmc, key);
    return VTABLE_exists_keyed_int(interp, agg,
            VTABLE_get_integer(interp, key) + idx);
#line 167 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 313 "./src/pmc/iterator.pmc"

    PMC *key;
    GETATTR_Iterator_key(interp, pmc, key);
    return !PMC_is_null(interp, key) &&
            VTABLE_get_integer(interp, key) != -1;
#line 178 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 188 "./src/pmc/iterator.pmc"

    return VTABLE_elements(interp, pmc);
#line 186 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 216 "./src/pmc/iterator.pmc"

    return VTABLE_get_integer_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 194 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 230 "./src/pmc/iterator.pmc"

    PMC * const agg = VTABLE_get_pmc(interp, pmc);
    PMC        *key;

    GETATTR_Iterator_key(interp, pmc, key);
    return VTABLE_get_integer_keyed_int(interp, agg,
            VTABLE_get_integer(interp, key) +idx);
#line 207 "./src/pmc/iterator.c"
}
PARROT_EXPORT  PMC  *
Parrot_Iterator_get_iter(PARROT_INTERP, PMC *pmc)
{
#line 733 "./src/pmc/iterator.pmc"

    return pmc;
#line 215 "./src/pmc/iterator.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Iterator_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 247 "./src/pmc/iterator.pmc"

    return VTABLE_get_number_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 223 "./src/pmc/iterator.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Iterator_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 261 "./src/pmc/iterator.pmc"

    PMC * const agg = VTABLE_get_pmc(interp, pmc);
    PMC        *key;

    GETATTR_Iterator_key(interp, pmc, key);
    return VTABLE_get_number_keyed_int(interp, agg,
            VTABLE_get_integer(interp, key) + idx);
#line 236 "./src/pmc/iterator.c"
}
PARROT_EXPORT  PMC  *
Parrot_Iterator_get_pmc(PARROT_INTERP, PMC *pmc)
{
#line 344 "./src/pmc/iterator.pmc"

    PMC *agg;
    GETATTR_Iterator_aggregate(interp, pmc, agg);
    return agg ? agg : PMCNULL;
#line 246 "./src/pmc/iterator.c"
}
PARROT_EXPORT  PMC  *
Parrot_Iterator_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 359 "./src/pmc/iterator.pmc"

    return VTABLE_get_pmc_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 254 "./src/pmc/iterator.c"
}
PARROT_EXPORT  PMC  *
Parrot_Iterator_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 373 "./src/pmc/iterator.pmc"

    PMC * const agg = VTABLE_get_pmc(interp, pmc);
    PMC        *key;

    GETATTR_Iterator_key(interp, pmc, key);
    return VTABLE_get_pmc_keyed_int(interp, agg,
            VTABLE_get_integer(interp, key) + idx);
#line 267 "./src/pmc/iterator.c"
}
PARROT_EXPORT  STRING  *
Parrot_Iterator_get_string(PARROT_INTERP, PMC *pmc)
{
#line 202 "./src/pmc/iterator.pmc"

    PMC *key;
    GETATTR_Iterator_key(interp, pmc, key);
    return Parrot_str_from_int(interp, key_integer(interp, key));
#line 277 "./src/pmc/iterator.c"
}
PARROT_EXPORT  STRING  *
Parrot_Iterator_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 280 "./src/pmc/iterator.pmc"

    return VTABLE_get_string_keyed(interp, VTABLE_get_pmc(interp, pmc), key);
#line 285 "./src/pmc/iterator.c"
}
PARROT_EXPORT  STRING  *
Parrot_Iterator_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 294 "./src/pmc/iterator.pmc"

    PMC * const agg = VTABLE_get_pmc(interp, pmc);
    PMC        *key;

    GETATTR_Iterator_key(interp, pmc, key);
    return VTABLE_get_string_keyed_int(interp, agg,
            VTABLE_get_integer(interp, key) + idx);
#line 298 "./src/pmc/iterator.c"
}
PARROT_EXPORT  void 
Parrot_Iterator_init(PARROT_INTERP, PMC *pmc)
{
#line 89 "./src/pmc/iterator.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Iterator init without aggregate");
#line 307 "./src/pmc/iterator.c"
}
PARROT_EXPORT  void 
Parrot_Iterator_init_pmc(PARROT_INTERP, PMC *pmc, PMC *aggregate)
{
#line 105 "./src/pmc/iterator.pmc"

    Parrot_Iterator_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_Iterator_attributes);

    attrs->aggregate = aggregate;
    attrs->key       = PMCNULL;
    PMC_data(pmc)   = attrs;

    PObj_custom_mark_destroy_SETALL(pmc);

    /* by default, iterate from start */
    VTABLE_set_integer_native(interp, pmc, ITERATE_FROM_START);
#line 325 "./src/pmc/iterator.c"
}
PARROT_EXPORT  opcode_t  *
Parrot_Iterator_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 545 "./src/pmc/iterator.pmc"

    PMC *agg;

    /* iterator constructor */
    if (REG_INT(interp, 3) == 1) {
        PMC * const arg = REG_PMC(interp, 5);
        PMC *iter;

        if (PObj_is_object_TEST(arg)) {
            REG_PMC(interp, 5) = VTABLE_get_iter(interp, arg);
            return (opcode_t *)next;
        }

        REG_PMC(interp, 5) = iter = pmc_new_init(interp,
                enum_class_Iterator, arg);
        VTABLE_set_integer_native(interp, iter, 0);
        return (opcode_t *)next;
    }
    /* TODO function + sentinel */
    else if (REG_INT(interp, 3) == 2)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Iterator: invoke 2 args");

    REG_INT(interp, 1) =
        REG_INT(interp, 2) =
        REG_INT(interp, 3) =
        REG_INT(interp, 4) = 0;

    agg = VTABLE_get_pmc(interp, pmc);

    {
        PMC * const res    = VTABLE_shift_pmc(interp, pmc);
        REG_INT(interp, 3) = 1;
        REG_PMC(interp, 5) = res;
        return (opcode_t *)next;
    }
#line 367 "./src/pmc/iterator.c"
}
PARROT_EXPORT  void 
Parrot_Iterator_mark(PARROT_INTERP, PMC *pmc)
{
#line 143 "./src/pmc/iterator.pmc"

    /* the Key */
    PMC *key;
    GETATTR_Iterator_key(interp, pmc, key);
    if (key)
         pobject_lives(interp, (PObj *)key);

    /* the aggregate */
    if (VTABLE_get_pmc(interp, pmc) != PMCNULL)
         pobject_lives(interp, (PObj *)VTABLE_get_pmc(interp, pmc));
#line 383 "./src/pmc/iterator.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Iterator_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 450 "./src/pmc/iterator.pmc"

    PMC * const    agg = VTABLE_get_pmc(interp, pmc);
    PMC           *key;
    FLOATVAL       ret;

    GETATTR_Iterator_key(interp, pmc, key);
    ret = VTABLE_get_number_keyed(interp, agg, key);
    SETATTR_Iterator_key(interp, pmc,
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_PREV));

    return ret;
#line 400 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 429 "./src/pmc/iterator.pmc"

    PMC * const  agg   = VTABLE_get_pmc(interp, pmc);
    PMC         *key;
    INTVAL       ret;

    GETATTR_Iterator_key(interp, pmc, key);
    ret  = VTABLE_get_integer_keyed(interp, agg, key);
    SETATTR_Iterator_key(interp, pmc,
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_PREV));

    return ret;
#line 417 "./src/pmc/iterator.c"
}
PARROT_EXPORT  PMC  *
Parrot_Iterator_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 495 "./src/pmc/iterator.pmc"

    PMC * const agg = VTABLE_get_pmc(interp, pmc);
    PMC        *key;
    PMC        *ret;

    GETATTR_Iterator_key(interp, pmc, key);
    ret = VTABLE_get_pmc_keyed(interp, agg, key);
    SETATTR_Iterator_key(interp, pmc,
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_PREV));

    return ret;
#line 434 "./src/pmc/iterator.c"
}
PARROT_EXPORT  STRING  *
Parrot_Iterator_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 471 "./src/pmc/iterator.pmc"

    STRING     *ret;
    PMC        *key;
    PMC * const agg = VTABLE_get_pmc(interp, pmc);

    GETATTR_Iterator_key(interp, pmc, key);
    ret = VTABLE_get_string_keyed(interp, agg, key);
    SETATTR_Iterator_key(interp, pmc,
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_PREV));

    return ret;
#line 451 "./src/pmc/iterator.c"
}
PARROT_EXPORT  void 
Parrot_Iterator_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 396 "./src/pmc/iterator.pmc"

    PMC *agg;
    if (value < ITERATE_FROM_START || value > ITERATE_FROM_END)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Illegal set_integer on iterator");

    /* reset iterator on aggregate */
    agg = VTABLE_get_pmc(interp, pmc);

    if (agg->vtable->base_type == enum_class_Slice) {
        /* it's an xrange serving as its own aggregate */
        SETATTR_Iterator_key(interp, pmc,
            VTABLE_nextkey_keyed(interp, agg, NULL, value));
    }
    else {
        PMC *key;
        GETATTR_Iterator_key(interp, pmc, key);
        if (PMC_is_null(interp, key))
            key = key_new(interp);

        SETATTR_Iterator_key(interp, pmc,
            VTABLE_nextkey_keyed(interp, key, agg, value));
    }
#line 480 "./src/pmc/iterator.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Iterator_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 591 "./src/pmc/iterator.pmc"

    PMC        *key;
    PMC * const agg = VTABLE_get_pmc(interp, pmc);
    FLOATVAL    ret;

    GETATTR_Iterator_key(interp, pmc, key);
    ret = VTABLE_get_number_keyed(interp, agg, key);
    SETATTR_Iterator_key(interp, pmc,
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_NEXT));

    return ret;
#line 497 "./src/pmc/iterator.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Iterator_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 519 "./src/pmc/iterator.pmc"

    INTVAL       ret;
    PMC         *key;
    PMC * const  agg = VTABLE_get_pmc(interp, pmc);

    GETATTR_Iterator_key(interp, pmc, key);
    ret = VTABLE_get_integer_keyed(interp, agg, key);
    SETATTR_Iterator_key(interp, pmc,
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_NEXT));

    return ret;
#line 514 "./src/pmc/iterator.c"
}
PARROT_EXPORT  PMC  *
Parrot_Iterator_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 637 "./src/pmc/iterator.pmc"

    PMC * const agg = VTABLE_get_pmc(interp, pmc);
    PMC        *ret;
    PMC        *key;

    GETATTR_Iterator_key(interp, pmc, key);

    if (VTABLE_get_integer(interp, key) == -1)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "StopIteration");

    ret = VTABLE_get_pmc_keyed(interp, agg, key);

    SETATTR_Iterator_key(interp, pmc,
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_NEXT));

    return ret;
#line 537 "./src/pmc/iterator.c"
}
PARROT_EXPORT  STRING  *
Parrot_Iterator_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 613 "./src/pmc/iterator.pmc"

    PMC        *key;
    PMC * const agg = VTABLE_get_pmc(interp, pmc);
    STRING     *ret;

    GETATTR_Iterator_key(interp, pmc, key);
    ret = VTABLE_get_string_keyed(interp, agg, key);
    SETATTR_Iterator_key(interp, pmc,
        VTABLE_nextkey_keyed(interp, key, agg, ITERATE_GET_NEXT));

    return ret;
#line 554 "./src/pmc/iterator.c"
}
PARROT_EXPORT  void
Parrot_Iterator_nci_set_key(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 593 "./src/pmc/iterator.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 610 "./src/pmc/iterator.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* key = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 737 "./src/pmc/iterator.pmc"

    SETATTR_Iterator_key(interp, pmc, key);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 635 "./src/pmc/iterator.c"
}
PARROT_EXPORT  void
Parrot_Iterator_nci_get_key(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 673 "./src/pmc/iterator.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 690 "./src/pmc/iterator.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 741 "./src/pmc/iterator.pmc"

    PMC *key;
    GETATTR_Iterator_key(interp, pmc, key);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *key */
    /*BEGIN GENERATED ACCESSORS */
#line 705 "./src/pmc/iterator.pmc"
    CTX_REG_PMC(_ctx, 0) = key;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_key_returns;
    /*END RETURN PMC *key */
    }
#line 744 "./src/pmc/iterator.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_key_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 750 "./src/pmc/iterator.c"
}
PARROT_EXPORT  void
Parrot_Iterator_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Iterator");
}
PARROT_EXPORT  PMC *
Parrot_Iterator_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Iterator");
}
PARROT_EXPORT  FLOATVAL
Parrot_Iterator_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Iterator");
}
PARROT_EXPORT  INTVAL
Parrot_Iterator_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Iterator");
}
PARROT_EXPORT  PMC *
Parrot_Iterator_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Iterator");
}
PARROT_EXPORT  STRING *
Parrot_Iterator_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Iterator");
}
PARROT_EXPORT  FLOATVAL
Parrot_Iterator_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Iterator");
}
PARROT_EXPORT  INTVAL
Parrot_Iterator_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Iterator");
}
PARROT_EXPORT  PMC *
Parrot_Iterator_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Iterator");
}
PARROT_EXPORT  STRING *
Parrot_Iterator_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Iterator");
}
PARROT_EXPORT  void
Parrot_Iterator_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Iterator");
}
#include "pmc_default.h"
void
Parrot_Iterator_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Faggregate Fkey ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Iterator, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Iterator_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_Iterator_defined,
        Parrot_Iterator_defined_keyed,
        Parrot_Iterator_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Iterator_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_Iterator_elements,
        Parrot_Iterator_exists_keyed,
        Parrot_Iterator_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Iterator_get_bool,
        Parrot_default_get_class,
        Parrot_Iterator_get_integer,
        Parrot_Iterator_get_integer_keyed,
        Parrot_Iterator_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Iterator_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_Iterator_get_number_keyed,
        Parrot_Iterator_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_Iterator_get_pmc,
        Parrot_Iterator_get_pmc_keyed,
        Parrot_Iterator_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Iterator_get_string,
        Parrot_Iterator_get_string_keyed,
        Parrot_Iterator_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_Iterator_init,
        Parrot_Iterator_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_Iterator_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Iterator_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Iterator_pop_float,
        Parrot_Iterator_pop_integer,
        Parrot_Iterator_pop_pmc,
        Parrot_Iterator_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Iterator_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Iterator_shift_float,
        Parrot_Iterator_shift_integer,
        Parrot_Iterator_shift_pmc,
        Parrot_Iterator_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Iterator, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Iterator_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Iterator_ro_add_method,
        Parrot_Iterator_ro_add_parent,
        Parrot_Iterator_ro_add_role,
        Parrot_Iterator_ro_add_vtable_override,
        Parrot_Iterator_ro_assign_pmc,
        Parrot_Iterator_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Iterator_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Iterator_ro_decrement,
        Parrot_Iterator_defined,
        Parrot_Iterator_defined_keyed,
        Parrot_Iterator_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Iterator_ro_delete_keyed,
        Parrot_Iterator_ro_delete_keyed_int,
        Parrot_Iterator_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Iterator_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_Iterator_elements,
        Parrot_Iterator_exists_keyed,
        Parrot_Iterator_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Iterator_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Iterator_get_bool,
        Parrot_default_get_class,
        Parrot_Iterator_get_integer,
        Parrot_Iterator_get_integer_keyed,
        Parrot_Iterator_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_Iterator_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_Iterator_get_number_keyed,
        Parrot_Iterator_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_Iterator_get_pmc,
        Parrot_Iterator_get_pmc_keyed,
        Parrot_Iterator_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Iterator_get_string,
        Parrot_Iterator_get_string_keyed,
        Parrot_Iterator_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Iterator_ro_i_absolute,
        Parrot_Iterator_ro_i_add,
        Parrot_Iterator_ro_i_add_float,
        Parrot_Iterator_ro_i_add_int,
        Parrot_Iterator_ro_i_bitwise_and,
        Parrot_Iterator_ro_i_bitwise_and_int,
        Parrot_Iterator_ro_i_bitwise_ands,
        Parrot_Iterator_ro_i_bitwise_ands_str,
        Parrot_Iterator_ro_i_bitwise_lsr,
        Parrot_Iterator_ro_i_bitwise_lsr_int,
        Parrot_Iterator_ro_i_bitwise_not,
        Parrot_Iterator_ro_i_bitwise_nots,
        Parrot_Iterator_ro_i_bitwise_or,
        Parrot_Iterator_ro_i_bitwise_or_int,
        Parrot_Iterator_ro_i_bitwise_ors,
        Parrot_Iterator_ro_i_bitwise_ors_str,
        Parrot_Iterator_ro_i_bitwise_shl,
        Parrot_Iterator_ro_i_bitwise_shl_int,
        Parrot_Iterator_ro_i_bitwise_shr,
        Parrot_Iterator_ro_i_bitwise_shr_int,
        Parrot_Iterator_ro_i_bitwise_xor,
        Parrot_Iterator_ro_i_bitwise_xor_int,
        Parrot_Iterator_ro_i_bitwise_xors,
        Parrot_Iterator_ro_i_bitwise_xors_str,
        Parrot_Iterator_ro_i_concatenate,
        Parrot_Iterator_ro_i_concatenate_str,
        Parrot_Iterator_ro_i_divide,
        Parrot_Iterator_ro_i_divide_float,
        Parrot_Iterator_ro_i_divide_int,
        Parrot_Iterator_ro_i_floor_divide,
        Parrot_Iterator_ro_i_floor_divide_float,
        Parrot_Iterator_ro_i_floor_divide_int,
        Parrot_Iterator_ro_i_logical_not,
        Parrot_Iterator_ro_i_modulus,
        Parrot_Iterator_ro_i_modulus_float,
        Parrot_Iterator_ro_i_modulus_int,
        Parrot_Iterator_ro_i_multiply,
        Parrot_Iterator_ro_i_multiply_float,
        Parrot_Iterator_ro_i_multiply_int,
        Parrot_Iterator_ro_i_neg,
        Parrot_Iterator_ro_i_pow,
        Parrot_Iterator_ro_i_pow_float,
        Parrot_Iterator_ro_i_pow_int,
        Parrot_Iterator_ro_i_repeat,
        Parrot_Iterator_ro_i_repeat_int,
        Parrot_Iterator_ro_i_subtract,
        Parrot_Iterator_ro_i_subtract_float,
        Parrot_Iterator_ro_i_subtract_int,
        Parrot_Iterator_ro_increment,
        Parrot_Iterator_init,
        Parrot_Iterator_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_Iterator_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Iterator_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_Iterator_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Iterator_ro_pop_float,
        Parrot_Iterator_ro_pop_integer,
        Parrot_Iterator_ro_pop_pmc,
        Parrot_Iterator_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Iterator_ro_push_float,
        Parrot_Iterator_ro_push_integer,
        Parrot_Iterator_ro_push_pmc,
        Parrot_Iterator_ro_push_string,
        Parrot_Iterator_ro_remove_attribute,
        Parrot_Iterator_ro_remove_method,
        Parrot_Iterator_ro_remove_parent,
        Parrot_Iterator_ro_remove_role,
        Parrot_Iterator_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_Iterator_ro_set_attr_keyed,
        Parrot_Iterator_ro_set_attr_str,
        Parrot_Iterator_ro_set_bignum_int,
        Parrot_Iterator_ro_set_bignum_num,
        Parrot_Iterator_ro_set_bignum_str,
        Parrot_Iterator_ro_set_bool,
        Parrot_Iterator_ro_set_integer_keyed,
        Parrot_Iterator_ro_set_integer_keyed_int,
        Parrot_Iterator_ro_set_integer_keyed_str,
        Parrot_Iterator_ro_set_integer_native,
        Parrot_Iterator_ro_set_integer_same,
        Parrot_Iterator_ro_set_number_keyed,
        Parrot_Iterator_ro_set_number_keyed_int,
        Parrot_Iterator_ro_set_number_keyed_str,
        Parrot_Iterator_ro_set_number_native,
        Parrot_Iterator_ro_set_number_same,
        Parrot_Iterator_ro_set_pmc,
        Parrot_Iterator_ro_set_pmc_keyed,
        Parrot_Iterator_ro_set_pmc_keyed_int,
        Parrot_Iterator_ro_set_pmc_keyed_str,
        Parrot_Iterator_ro_set_pointer,
        Parrot_Iterator_ro_set_pointer_keyed,
        Parrot_Iterator_ro_set_pointer_keyed_int,
        Parrot_Iterator_ro_set_pointer_keyed_str,
        Parrot_Iterator_ro_set_string_keyed,
        Parrot_Iterator_ro_set_string_keyed_int,
        Parrot_Iterator_ro_set_string_keyed_str,
        Parrot_Iterator_ro_set_string_native,
        Parrot_Iterator_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Iterator_ro_shift_float,
        Parrot_Iterator_ro_shift_integer,
        Parrot_Iterator_ro_shift_pmc,
        Parrot_Iterator_ro_shift_string,
        Parrot_default_slice,
        Parrot_Iterator_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Iterator_ro_thaw,
        Parrot_Iterator_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Iterator_ro_unshift_float,
        Parrot_Iterator_ro_unshift_integer,
        Parrot_Iterator_ro_unshift_pmc,
        Parrot_Iterator_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Iterator");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Iterator")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Iterator"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Iterator_nci_set_key), "set_key");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Iterator_nci_get_key), "get_key");
        /* class_init */
        {
        
            if (pass) {
                /* Make the shift_pmc vtable function available as
                 * a method named "next" */
                register_nci_method(interp, enum_class_Iterator,
                        F2DPTR(Parrot_Iterator_shift_pmc), "next", "PJO");
            }

        }
        {
        }
    } /* pass */
} /* Parrot_Iterator_class_init */
#line 745 "./src/pmc/iterator.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
