/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/key.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_key.h"
#include "pmc_default.h"
#include "key.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/key.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: key.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/key.pmc - Key PMC

=head1 DESCRIPTION

These are the vtable functions for the Key PMC class.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#line 43 "./src/pmc/key.c"
PARROT_EXPORT  PMC  *
Parrot_Key_clone(PARROT_INTERP, PMC *pmc)
{
#line 74 "./src/pmc/key.pmc"

    PMC * const dest = pmc_new(interp, pmc->vtable->base_type);
    PMC *dkey        = dest;
    PMC *key         = pmc;

    PObj_custom_mark_destroy_SETALL(dest);

    for (; key ;) {
        switch (PObj_get_FLAGS(key) & KEY_type_FLAGS) {
            case KEY_integer_FLAG:
            case KEY_integer_FLAG | KEY_register_FLAG:
                key_set_integer(interp, dkey, key_integer(interp, key));
                break;
            case KEY_number_FLAG:
            case KEY_number_FLAG | KEY_register_FLAG:
                key_set_number(interp, dkey, key_number(interp, key));
                break;
            case KEY_string_FLAG:
            case KEY_string_FLAG | KEY_register_FLAG:
                key_set_string(interp, dkey,
                    Parrot_str_copy(interp, VTABLE_get_string(interp, key)));
                break;
            case KEY_pmc_FLAG:
            case KEY_pmc_FLAG | KEY_register_FLAG:
                {
                PMC * const p = key_pmc(interp, key);
                key_set_pmc(interp, dkey, VTABLE_clone(interp, p));
                }
                break;
            default:
                break;
        }

        key = key_next(interp, key);

        if (key) {
            PMC * const p = key_new(interp);
            key_append(interp, dkey, p);
            dkey = p;
        }
    }

    return dest;
#line 91 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_destroy(PARROT_INTERP, PMC *pmc)
{
#line 60 "./src/pmc/key.pmc"

    mem_sys_free(PMC_data(pmc));
#line 99 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 427 "./src/pmc/key.pmc"

    IMAGE_IO * const io = info->image_io;

    /* write flags */
    const INTVAL flags  = (PObj_get_FLAGS(pmc) & KEY_type_FLAGS);

    /* write the contents of a register - else thaw can't restore
     * the register state */
    VTABLE_push_integer(interp, io, flags & ~KEY_register_FLAG);

    /* and contents of this key component */
    switch (flags) {
        case KEY_integer_FLAG:
        case KEY_integer_FLAG | KEY_register_FLAG:
            VTABLE_push_integer(interp, io, key_integer(interp, pmc));
            break;
        case KEY_number_FLAG:
        case KEY_number_FLAG | KEY_register_FLAG:
            VTABLE_push_float(interp, io, key_number(interp, pmc));
            break;
        case KEY_string_FLAG:
        case KEY_string_FLAG | KEY_register_FLAG:
            VTABLE_push_string(interp, io, key_string(interp, pmc));
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
                "Unsupported key type in Key.freeze");
            break;
    }
#line 134 "./src/pmc/key.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Key_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 143 "./src/pmc/key.pmc"

    return key_integer(interp, pmc);
#line 142 "./src/pmc/key.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Key_get_number(PARROT_INTERP, PMC *pmc)
{
#line 157 "./src/pmc/key.pmc"

    return key_number(interp, pmc);
#line 150 "./src/pmc/key.c"
}
PARROT_EXPORT  PMC  *
Parrot_Key_get_pmc(PARROT_INTERP, PMC *pmc)
{
#line 189 "./src/pmc/key.pmc"

    return key_pmc(interp, pmc);
#line 158 "./src/pmc/key.c"
}
PARROT_EXPORT  PMC  *
Parrot_Key_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 297 "./src/pmc/key.pmc"

    return key;
#line 166 "./src/pmc/key.c"
}
PARROT_EXPORT  STRING* 
Parrot_Key_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 502 "./src/pmc/key.pmc"

    return key_set_to_string(interp, pmc);
#line 174 "./src/pmc/key.c"
}
PARROT_EXPORT  STRING  *
Parrot_Key_get_string(PARROT_INTERP, PMC *pmc)
{
#line 171 "./src/pmc/key.pmc"

    /* key_string() is only useful if this PMC has a key type */
    if (PObj_get_FLAGS(pmc) & KEY_type_FLAGS)
        return key_string(interp, pmc);

    return string_from_literal(interp, "");
#line 186 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_init(PARROT_INTERP, PMC *pmc)
{
#line 42 "./src/pmc/key.pmc"


    Parrot_Key_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_Key_attributes);

    PMC_data(pmc) = attrs;
    PObj_custom_mark_destroy_SETALL(pmc);
#line 199 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_mark(PARROT_INTERP, PMC *pmc)
{
#line 129 "./src/pmc/key.pmc"

    key_mark(interp, pmc);
#line 207 "./src/pmc/key.c"
}
PARROT_EXPORT  PMC  *
Parrot_Key_nextkey_keyed(PARROT_INTERP, PMC *pmc, PMC *agg, INTVAL what)
{
#line 312 "./src/pmc/key.pmc"

    PMC  * const ret = pmc;
    const INTVAL n   = VTABLE_elements(interp, agg);
    INTVAL       int_key;

    switch (what) {
        case ITERATE_FROM_START_KEYS:
            /*
             * OrderedHash supports two iterators: by key
             * or by ordered values
             */
            PObj_get_FLAGS(ret) &= ~KEY_type_FLAGS;
            PObj_get_FLAGS(ret) |=  KEY_integer_FLAG;

            if (agg->vtable->base_type == enum_class_OrderedHash)
                PObj_get_FLAGS(ret) |= KEY_number_FLAG;

            goto init;
        case ITERATE_FROM_START:    /* reset key */
            PObj_get_FLAGS(ret) &= ~KEY_type_FLAGS;
            PObj_get_FLAGS(ret) |= KEY_integer_FLAG;

            /*
             * KEY_hash_iterator_FLAGS, which is the same as
             * KEY_integer_FLAG | KEY_number_FLAG
             * indicates a hash iterator operation
             * KEY_integer_FLAG alone is an indexed hash lookup
             * with an Integer KEY
             */

             if (VTABLE_isa(interp, agg, CONST_STRING(interp, "Hash"))
             &&  agg->vtable->base_type != enum_class_OrderedHash)
                PObj_get_FLAGS(ret) |= KEY_hash_iterator_FLAGS;
    init:
            if (!n) {
                SETATTR_Key_int_key(interp, ret, -1);
            }
            else {
                SETATTR_Key_int_key(interp, ret, 0);
            }

            /* iterating over a hash additionally needs the Bucket index */
            if (KEY_IS_HASH_ITERATOR(ret))
                SETATTR_Key_next_key(interp, ret, (PMC *)INITBucketIndex);

            break;
        case ITERATE_GET_NEXT:
            /*
             * src/hash.c:parrot_hash_get_idx() advances to next
             * so, if we are iterating over a hash do nothing
             * */
            if (!KEY_IS_HASH_ITERATOR(ret)) {
                GETATTR_Key_int_key(interp, ret, int_key);
                if (int_key < n - 1) {
                    SETATTR_Key_int_key(interp, ret, int_key+1);
                }
                else {
                    SETATTR_Key_int_key(interp, ret, -1);
                }
            }
            break;
        case ITERATE_GET_PREV:
            GETATTR_Key_int_key(interp, ret, int_key);
            if (int_key >= 0)
                SETATTR_Key_int_key(interp, ret, int_key-1);
            break;
        case ITERATE_FROM_END:
            PObj_get_FLAGS(ret) &= ~KEY_type_FLAGS;
            PObj_get_FLAGS(ret) |= KEY_integer_FLAG;
            SETATTR_Key_int_key(interp, ret, n-1);
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Unknown iterator type in Key.nextkey_keyed: %d", what);
    }
    return ret;
#line 290 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 256 "./src/pmc/key.pmc"

    if (value->vtable->base_type != enum_class_Key)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Can only push another Key onto a Key PMC.");

    key_append(interp, pmc, value);
#line 302 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 201 "./src/pmc/key.pmc"

    key_set_integer(interp, pmc, value);
#line 310 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_set_number_native(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 215 "./src/pmc/key.pmc"

    key_set_number(interp, pmc, value);
#line 318 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_set_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 242 "./src/pmc/key.pmc"

    key_set_pmc(interp, pmc, value);
#line 326 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_set_string_native(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 228 "./src/pmc/key.pmc"

    key_set_string(interp, pmc, value);
#line 334 "./src/pmc/key.c"
}
PARROT_EXPORT  PMC  *
Parrot_Key_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 277 "./src/pmc/key.pmc"

    return key_next(interp, pmc);
#line 342 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 458 "./src/pmc/key.pmc"

    IMAGE_IO * const io = info->image_io;
    const INTVAL flags  = VTABLE_shift_integer(interp, io) & KEY_type_FLAGS;

    PObj_get_FLAGS(pmc) |= flags;
    PObj_custom_mark_SET(pmc);

    if (!PMC_data(pmc))
        VTABLE_init(interp, pmc);

    /* get contents */
    switch (flags) {
        case KEY_integer_FLAG:
            SETATTR_Key_int_key(interp, pmc, VTABLE_shift_integer(interp, io));
            break;
        case KEY_number_FLAG:
            VTABLE_set_number_native(interp, pmc, VTABLE_shift_float(interp, io));
            break;
        case KEY_string_FLAG:
            VTABLE_set_string_native(interp, pmc, VTABLE_shift_string(interp, io));
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
                "Unsupported key type in Key.thaw");
            break;
    }
#line 374 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 486 "./src/pmc/key.pmc"

    PMC *key = pmc;

    while (1) {
        PMC *next;
        GETATTR_Key_next_key(interp, key, next);

        if (PMC_IS_NULL(next)) {
            SETATTR_Key_next_key(interp, key, NULL);
            break;
        }

        key = next;
    }
#line 394 "./src/pmc/key.c"
}
PARROT_EXPORT  void 
Parrot_Key_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 412 "./src/pmc/key.pmc"


    Parrot_Key_attributes *attrs;
    /* at end a PMCNULL is written during thaw, which should stop visiting
     * the key */

    /* Sometimes visit gets an uninitialized Key.  Initialize it. */
    if (!PMC_data(pmc))
        VTABLE_init(interp, pmc);

    attrs = (Parrot_Key_attributes *)PMC_data(pmc);
    info->thaw_ptr  = &attrs->next_key;
    (info->visit_pmc_now)(interp, attrs->next_key, info);
#line 413 "./src/pmc/key.c"
}
PARROT_EXPORT  void
Parrot_Key_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Key");
}
PARROT_EXPORT  PMC *
Parrot_Key_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Key_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Key");
}
PARROT_EXPORT  FLOATVAL
Parrot_Key_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Key");
}
PARROT_EXPORT  INTVAL
Parrot_Key_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Key");
}
PARROT_EXPORT  PMC *
Parrot_Key_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Key");
}
PARROT_EXPORT  STRING *
Parrot_Key_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Key");
}
PARROT_EXPORT  FLOATVAL
Parrot_Key_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Key");
}
PARROT_EXPORT  INTVAL
Parrot_Key_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Key");
}
PARROT_EXPORT  PMC *
Parrot_Key_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Key");
}
PARROT_EXPORT  STRING *
Parrot_Key_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Key");
}
PARROT_EXPORT  void
Parrot_Key_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Key");
}
#include "pmc_default.h"
void
Parrot_Key_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fnext_key Iint_key Fnum_key Sstr_key ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Key, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Key_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Key_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Key_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Key_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_Key_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_Key_get_pmc,
        Parrot_Key_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Key_get_repr,
        Parrot_Key_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_Key_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Key_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_Key_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_Key_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Key_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_Key_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Key_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Key_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_Key_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Key_thaw,
        Parrot_Key_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Key_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Key, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Key_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Key_ro_add_method,
        Parrot_Key_ro_add_parent,
        Parrot_Key_ro_add_role,
        Parrot_Key_ro_add_vtable_override,
        Parrot_Key_ro_assign_pmc,
        Parrot_Key_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Key_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Key_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Key_ro_delete_keyed,
        Parrot_Key_ro_delete_keyed_int,
        Parrot_Key_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Key_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Key_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Key_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Key_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_Key_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_Key_get_pmc,
        Parrot_Key_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Key_get_repr,
        Parrot_Key_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Key_ro_i_absolute,
        Parrot_Key_ro_i_add,
        Parrot_Key_ro_i_add_float,
        Parrot_Key_ro_i_add_int,
        Parrot_Key_ro_i_bitwise_and,
        Parrot_Key_ro_i_bitwise_and_int,
        Parrot_Key_ro_i_bitwise_ands,
        Parrot_Key_ro_i_bitwise_ands_str,
        Parrot_Key_ro_i_bitwise_lsr,
        Parrot_Key_ro_i_bitwise_lsr_int,
        Parrot_Key_ro_i_bitwise_not,
        Parrot_Key_ro_i_bitwise_nots,
        Parrot_Key_ro_i_bitwise_or,
        Parrot_Key_ro_i_bitwise_or_int,
        Parrot_Key_ro_i_bitwise_ors,
        Parrot_Key_ro_i_bitwise_ors_str,
        Parrot_Key_ro_i_bitwise_shl,
        Parrot_Key_ro_i_bitwise_shl_int,
        Parrot_Key_ro_i_bitwise_shr,
        Parrot_Key_ro_i_bitwise_shr_int,
        Parrot_Key_ro_i_bitwise_xor,
        Parrot_Key_ro_i_bitwise_xor_int,
        Parrot_Key_ro_i_bitwise_xors,
        Parrot_Key_ro_i_bitwise_xors_str,
        Parrot_Key_ro_i_concatenate,
        Parrot_Key_ro_i_concatenate_str,
        Parrot_Key_ro_i_divide,
        Parrot_Key_ro_i_divide_float,
        Parrot_Key_ro_i_divide_int,
        Parrot_Key_ro_i_floor_divide,
        Parrot_Key_ro_i_floor_divide_float,
        Parrot_Key_ro_i_floor_divide_int,
        Parrot_Key_ro_i_logical_not,
        Parrot_Key_ro_i_modulus,
        Parrot_Key_ro_i_modulus_float,
        Parrot_Key_ro_i_modulus_int,
        Parrot_Key_ro_i_multiply,
        Parrot_Key_ro_i_multiply_float,
        Parrot_Key_ro_i_multiply_int,
        Parrot_Key_ro_i_neg,
        Parrot_Key_ro_i_pow,
        Parrot_Key_ro_i_pow_float,
        Parrot_Key_ro_i_pow_int,
        Parrot_Key_ro_i_repeat,
        Parrot_Key_ro_i_repeat_int,
        Parrot_Key_ro_i_subtract,
        Parrot_Key_ro_i_subtract_float,
        Parrot_Key_ro_i_subtract_int,
        Parrot_Key_ro_increment,
        Parrot_Key_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Key_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_Key_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_Key_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Key_ro_pop_float,
        Parrot_Key_ro_pop_integer,
        Parrot_Key_ro_pop_pmc,
        Parrot_Key_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Key_ro_push_float,
        Parrot_Key_ro_push_integer,
        Parrot_Key_ro_push_pmc,
        Parrot_Key_ro_push_string,
        Parrot_Key_ro_remove_attribute,
        Parrot_Key_ro_remove_method,
        Parrot_Key_ro_remove_parent,
        Parrot_Key_ro_remove_role,
        Parrot_Key_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_Key_ro_set_attr_keyed,
        Parrot_Key_ro_set_attr_str,
        Parrot_Key_ro_set_bignum_int,
        Parrot_Key_ro_set_bignum_num,
        Parrot_Key_ro_set_bignum_str,
        Parrot_Key_ro_set_bool,
        Parrot_Key_ro_set_integer_keyed,
        Parrot_Key_ro_set_integer_keyed_int,
        Parrot_Key_ro_set_integer_keyed_str,
        Parrot_Key_ro_set_integer_native,
        Parrot_Key_ro_set_integer_same,
        Parrot_Key_ro_set_number_keyed,
        Parrot_Key_ro_set_number_keyed_int,
        Parrot_Key_ro_set_number_keyed_str,
        Parrot_Key_ro_set_number_native,
        Parrot_Key_ro_set_number_same,
        Parrot_Key_ro_set_pmc,
        Parrot_Key_ro_set_pmc_keyed,
        Parrot_Key_ro_set_pmc_keyed_int,
        Parrot_Key_ro_set_pmc_keyed_str,
        Parrot_Key_ro_set_pointer,
        Parrot_Key_ro_set_pointer_keyed,
        Parrot_Key_ro_set_pointer_keyed_int,
        Parrot_Key_ro_set_pointer_keyed_str,
        Parrot_Key_ro_set_string_keyed,
        Parrot_Key_ro_set_string_keyed_int,
        Parrot_Key_ro_set_string_keyed_str,
        Parrot_Key_ro_set_string_native,
        Parrot_Key_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Key_ro_shift_float,
        Parrot_Key_ro_shift_integer,
        Parrot_Key_ro_shift_pmc,
        Parrot_Key_ro_shift_string,
        Parrot_default_slice,
        Parrot_Key_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Key_ro_thaw,
        Parrot_Key_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Key_ro_unshift_float,
        Parrot_Key_ro_unshift_integer,
        Parrot_Key_ro_unshift_pmc,
        Parrot_Key_ro_unshift_string,
        Parrot_Key_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Key");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Key")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Key"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_Key_class_init */
#line 504 "./src/pmc/key.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
