/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/orderedhash.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_orderedhash.h"
#include "pmc_hash.h"
#include "pmc_default.h"
#include "orderedhash.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/orderedhash.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: orderedhash.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/orderedhash.pmc - Ordered Hash

=head1 DESCRIPTION

C<OrderedHash> extends C<Hash> to provide the interfaces of C<array> and
C<hash>. To achieve ordering, hash there are a few restrictions:
C<delete_keyed> never removes items; they are just nulled.

Please note that if values are set via integer idx, these indices have to be in
strict order. Using C<push_xx> simplifies this task.  This creates a key
"\1idx" for C<idx> and is therefore not fully transparent.

There are two iterator interfaces:

=over 4

=item * retrieve values (in creation order)

Please note that after a C<delete_keyed> operation, iterating over
values doesn't work any more.  You'll get an error 'No such key'.

=item * retrieve keys (in creation order)

=back

See F<t/pmc/orderedhash.t>.

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#line 65 "./src/pmc/orderedhash.c"
PARROT_EXPORT  PMC  *
Parrot_OrderedHash_clone(PARROT_INTERP, PMC *pmc)
{
#line 580 "./src/pmc/orderedhash.pmc"

    PMC  * const dest   = pmc_new(interp, pmc->vtable->base_type);
    Hash * const hash   = (Hash *)PMC_struct_val(pmc);
    Hash * const h_dest = (Hash *)PMC_struct_val(dest);
    UINTVAL     i;

    for (i = 0; i <= N_BUCKETS(hash->mask-1); i++) {
        HashBucket * const b      = hash->bs + i;
        void       * const key    = b->key;

        if (key)
            parrot_hash_put(interp, h_dest, key,
                (void *)VTABLE_clone(interp, (PMC *)b->value));
    }

    return dest;
#line 86 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_OrderedHash_defined_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 450 "./src/pmc/orderedhash.pmc"

    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        Hash * const h   = (Hash *)PMC_struct_val(pmc);
        INTVAL       idx = key_integer(interp, key);
        const INTVAL n   = h->entries;

        HashBucket *b;
        PMC        *item, *next;

        if (idx < 0)
            idx += n;

        /* XXX non-existent is undefined - is this correct */
        if (idx < 0 || idx >= n)
            return 0;

        b = h->bs + idx;

        if (!b->key)
            return 0;

        item = (PMC *)b->value;
        next = key_next(interp, key);

        if (!next)
            return VTABLE_defined(interp, item);

        return VTABLE_defined_keyed(interp, item, next);
    }

    return Parrot_Hash_defined_keyed(interp, pmc, key);
#line 123 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_OrderedHash_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 483 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)PMC_struct_val(pmc);
    const INTVAL n = h->entries;
    HashBucket  *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        return 0;

    b = h->bs + idx;

    if (b->key)
        return VTABLE_defined(interp, (PMC *)b->value);

    return 0;
#line 146 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 516 "./src/pmc/orderedhash.pmc"

    PMC * const next = key_next(interp, key);

    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        if (next) {
            PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, key_integer(interp, key));
            VTABLE_delete_keyed(interp, item, next);
            return;
        }

        VTABLE_delete_keyed_int(interp, pmc, key_integer(interp, key));
    }
    else {
        if (next) {
            PMC * const item = VTABLE_get_pmc_keyed_str(interp, pmc, VTABLE_get_string(interp, key));
            VTABLE_delete_keyed(interp, item, next);
            return;
        }
        VTABLE_delete_keyed_str(interp, pmc, VTABLE_get_string(interp, key));
    }
#line 172 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 538 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)PMC_struct_val(pmc);
    const INTVAL n = h->entries;
    HashBucket  *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        return;

    b = h->bs + idx;

    if (!b)
        return;

    b->key       = NULL;
    b->value     = NULL;
#line 196 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_delete_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 558 "./src/pmc/orderedhash.pmc"

    const Hash * const h = (Hash *)PMC_struct_val(pmc);
    HashBucket * const b = parrot_hash_get_bucket(interp, h, key);

    if (!b)
        return;

    b->key       = NULL;
    b->value     = NULL;
#line 211 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_OrderedHash_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 400 "./src/pmc/orderedhash.pmc"

    if (PObj_get_FLAGS(key) & KEY_integer_FLAG) {
        PMC        *item, *next;
        HashBucket *b;
        Hash       * const h   = (Hash *)PMC_struct_val(pmc);
        INTVAL             idx = key_integer(interp, key);
        const INTVAL       n   = h->entries;

        if (idx < 0)
            idx += n;

        if (idx < 0 || idx >= n)
            return 0;

        b = h->bs + idx;

        if (!b->key)
            return 0;

        item = (PMC *)b->value;
        next = key_next(interp, key);

        if (!next)
            return 1;

        return VTABLE_exists_keyed(interp, item, next);
    }

    return Parrot_Hash_exists_keyed(interp, pmc, key);
#line 246 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_OrderedHash_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 381 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)PMC_struct_val(pmc);
    const INTVAL n = h->entries;
    HashBucket  *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        return 0;

    b = h->bs + idx;

    if (b->key)
        return 1;

    return 0;
#line 269 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_OrderedHash_exists_keyed_str(PARROT_INTERP, PMC *pmc, STRING *key)
{
#line 431 "./src/pmc/orderedhash.pmc"

    const Hash * const       h = (Hash *)PMC_struct_val(pmc);
    const HashBucket * const b = parrot_hash_get_bucket(interp, h, key);

    return (b && b->key);
#line 280 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_OrderedHash_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 209 "./src/pmc/orderedhash.pmc"


    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, key_integer(interp, key));
        PMC * const next = key_next(interp, key);

        if (!next)
            return VTABLE_get_integer(interp, item);

        return VTABLE_get_integer_keyed(interp, item, next);
    }

    return Parrot_Hash_get_integer_keyed(interp, pmc, key);
#line 299 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  INTVAL 
Parrot_OrderedHash_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 188 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)PMC_struct_val(pmc);
    const INTVAL n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return VTABLE_get_integer(interp, (PMC *)b->value);

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
        "OrderedHash: No such key");
#line 324 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_OrderedHash_get_number_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 259 "./src/pmc/orderedhash.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, key_integer(interp, key));
        PMC * const next = key_next(interp, key);

        if (!next)
            return VTABLE_get_number(interp, item);

        return VTABLE_get_number_keyed(interp, item, next);
    }

    return Parrot_Hash_get_number_keyed(interp, pmc, key);
#line 342 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_OrderedHash_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 238 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)PMC_struct_val(pmc);
    const INTVAL n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return VTABLE_get_number(interp, (PMC *)b->value);

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
        "OrderedHash: No such key");
#line 367 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  PMC  *
Parrot_OrderedHash_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 113 "./src/pmc/orderedhash.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, key_integer(interp, key));
        PMC * const next = key_next(interp, key);

        if (!next)
            return item;

        return VTABLE_get_pmc_keyed(interp, item, next);
    }

    return Parrot_Hash_get_pmc_keyed(interp, pmc, key);
#line 385 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  PMC  *
Parrot_OrderedHash_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 92 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)PMC_struct_val(pmc);
    const INTVAL n = h->entries;
    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
            "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return (PMC *)b->value;

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
        "OrderedHash: No such key");
#line 410 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  STRING  *
Parrot_OrderedHash_get_string_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 161 "./src/pmc/orderedhash.pmc"

    if ((PObj_get_FLAGS(key) & KEY_type_FLAGS) == KEY_integer_FLAG) {
        PMC * const item = VTABLE_get_pmc_keyed_int(interp, pmc, key_integer(interp, key));
        PMC * const next = key_next(interp, key);

        if (!next)
            return VTABLE_get_string(interp, item);

        return VTABLE_get_string_keyed(interp, item, next);
    }

    return Parrot_Hash_get_string_keyed(interp, pmc, key);
#line 428 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  STRING  *
Parrot_OrderedHash_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx)
{
#line 139 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)PMC_struct_val(pmc);
    const INTVAL n = h->entries;

    HashBucket *b;

    if (idx < 0)
        idx += n;

    if (idx < 0 || idx >= n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
            "OrderedHash: index out of bounds!");

    b = h->bs + idx;

    if (b->key)
        return VTABLE_get_string(interp, (PMC *)b->value);

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_KEY_NOT_FOUND,
        "OrderedHash: No such key");
#line 454 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_mark(PARROT_INTERP, PMC *pmc)
{
#line 56 "./src/pmc/orderedhash.pmc"

    Hash * const h = (Hash *)PMC_struct_val(pmc);
    INTVAL  i;

    if (!h)
        return;

    /* RT #53890 - keys can be NULL on purpose; move to src/hash.c ? */
    for (i = h->mask; i >= 0; --i) {
        HashBucket *b = h->bi[i];

        while (b) {

            if (b->key) {
                pobject_lives(interp, (PObj *)b->key);
                if (b->value)
                    pobject_lives(interp, (PObj *)b->value);
            }

            b = b->next;
        }
    }
#line 482 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 354 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_number_keyed_int(interp, pmc, n, value);
#line 491 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 359 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_integer_keyed_int(interp, pmc, n, value);
#line 500 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 349 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_pmc_keyed_int(interp, pmc, n, value);
#line 509 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 364 "./src/pmc/orderedhash.pmc"

    const INTVAL n = VTABLE_elements(interp, pmc);
    VTABLE_set_string_keyed_int(interp, pmc, n, value);
#line 518 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, INTVAL value)
{
#line 315 "./src/pmc/orderedhash.pmc"

    PMC * const v = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Integer));
    VTABLE_set_integer_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, idx, v);
#line 529 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, FLOATVAL value)
{
#line 322 "./src/pmc/orderedhash.pmc"

    PMC * const v = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_Float));
    VTABLE_set_number_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, idx, v);
#line 540 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, PMC *val)
{
#line 290 "./src/pmc/orderedhash.pmc"

    Hash * const     h = (Hash *)PMC_struct_val(pmc);
    const INTVAL     n = h->entries;
    STRING * const fmt = CONST_STRING(interp, "\1%d");

    if (idx < -n)
        idx = -idx - n - 1;
    else if (idx < 0)
        idx += n;

    if (idx >= n) {
        /* TODO warn or fill if there are holes */
        STRING * const key = Parrot_sprintf_s(interp, fmt, idx);
        VTABLE_set_pmc_keyed_str(interp, pmc, key, val);
    }
    else {
        HashBucket * const b = h->bs + idx;

        if (!b->key)
            b->key = Parrot_sprintf_s(interp, fmt, idx);

        b->value     = val;
    }
#line 569 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL idx, STRING *value)
{
#line 329 "./src/pmc/orderedhash.pmc"

    PMC * const v = pmc_new(interp, Parrot_get_ctx_HLL_type(interp,
                enum_class_String));
    VTABLE_set_string_native(interp, v, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, idx, v);
#line 580 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void 
Parrot_OrderedHash_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 618 "./src/pmc/orderedhash.pmc"

    info->container  = pmc;

    switch (info->what) {
        case VISIT_THAW_NORMAL:
        case VISIT_THAW_CONSTANTS:
            Parrot_Hash_visit(interp, pmc, info);
            break;

        case VISIT_FREEZE_NORMAL:
        case VISIT_FREEZE_AT_DESTRUCT:
            {
                Hash     * const hash = (Hash *)PMC_struct_val(pmc);
                IMAGE_IO * const io   = info->image_io;
                UINTVAL i;

                for (i = 0; i <= hash->entries; i++) {
                    HashBucket * const b   = hash->bs + i;

                    if (b) {
                        STRING * const key = (STRING *)b->key;
                        if (key) {
                            VTABLE_push_string(interp, io, key);
                            (info->visit_pmc_now)(interp, (PMC *)b->value, info);
                        }
                    }
                }
            }
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "unhandled visit action (%d)", info->what);
    }
#line 620 "./src/pmc/orderedhash.c"
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  PMC *
Parrot_OrderedHash_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of OrderedHash");
}
PARROT_EXPORT  FLOATVAL
Parrot_OrderedHash_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of OrderedHash");
}
PARROT_EXPORT  INTVAL
Parrot_OrderedHash_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of OrderedHash");
}
PARROT_EXPORT  PMC *
Parrot_OrderedHash_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of OrderedHash");
}
PARROT_EXPORT  STRING *
Parrot_OrderedHash_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of OrderedHash");
}
PARROT_EXPORT  FLOATVAL
Parrot_OrderedHash_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of OrderedHash");
}
PARROT_EXPORT  INTVAL
Parrot_OrderedHash_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of OrderedHash");
}
PARROT_EXPORT  PMC *
Parrot_OrderedHash_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of OrderedHash");
}
PARROT_EXPORT  STRING *
Parrot_OrderedHash_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of OrderedHash");
}
PARROT_EXPORT  void
Parrot_OrderedHash_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of OrderedHash");
}
#include "pmc_default.h"
void
Parrot_OrderedHash_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_OrderedHash, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_OrderedHash_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_OrderedHash_defined_keyed,
        Parrot_OrderedHash_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_OrderedHash_delete_keyed,
        Parrot_OrderedHash_delete_keyed_int,
        Parrot_OrderedHash_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Hash_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_Hash_elements,
        Parrot_OrderedHash_exists_keyed,
        Parrot_OrderedHash_exists_keyed_int,
        Parrot_OrderedHash_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Hash_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_OrderedHash_get_integer_keyed,
        Parrot_OrderedHash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_namespace,
        Parrot_Hash_get_number,
        Parrot_OrderedHash_get_number_keyed,
        Parrot_OrderedHash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_OrderedHash_get_pmc_keyed,
        Parrot_OrderedHash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string,
        Parrot_OrderedHash_get_string_keyed,
        Parrot_OrderedHash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_Hash_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_OrderedHash_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_OrderedHash_push_float,
        Parrot_OrderedHash_push_integer,
        Parrot_OrderedHash_push_pmc,
        Parrot_OrderedHash_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_Hash_set_integer_keyed,
        Parrot_OrderedHash_set_integer_keyed_int,
        Parrot_Hash_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_Hash_set_number_keyed,
        Parrot_OrderedHash_set_number_keyed_int,
        Parrot_Hash_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_Hash_set_pmc_keyed,
        Parrot_OrderedHash_set_pmc_keyed_int,
        Parrot_Hash_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_Hash_set_string_keyed,
        Parrot_OrderedHash_set_string_keyed_int,
        Parrot_Hash_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_Hash_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Hash_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_OrderedHash_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_OrderedHash, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_OrderedHash_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_OrderedHash_ro_add_method,
        Parrot_OrderedHash_ro_add_parent,
        Parrot_OrderedHash_ro_add_role,
        Parrot_OrderedHash_ro_add_vtable_override,
        Parrot_OrderedHash_ro_assign_pmc,
        Parrot_OrderedHash_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_OrderedHash_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_OrderedHash_ro_decrement,
        Parrot_default_defined,
        Parrot_OrderedHash_defined_keyed,
        Parrot_OrderedHash_defined_keyed_int,
        Parrot_Hash_defined_keyed_str,
        Parrot_OrderedHash_ro_delete_keyed,
        Parrot_OrderedHash_ro_delete_keyed_int,
        Parrot_OrderedHash_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Hash_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_Hash_elements,
        Parrot_OrderedHash_exists_keyed,
        Parrot_OrderedHash_exists_keyed_int,
        Parrot_OrderedHash_exists_keyed_str,
        Parrot_OrderedHash_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Hash_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Hash_get_bool,
        Parrot_default_get_class,
        Parrot_Hash_get_integer,
        Parrot_OrderedHash_get_integer_keyed,
        Parrot_OrderedHash_get_integer_keyed_int,
        Parrot_Hash_get_integer_keyed_str,
        Parrot_Hash_get_iter,
        Parrot_default_get_namespace,
        Parrot_Hash_get_number,
        Parrot_OrderedHash_get_number_keyed,
        Parrot_OrderedHash_get_number_keyed_int,
        Parrot_Hash_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_OrderedHash_get_pmc_keyed,
        Parrot_OrderedHash_get_pmc_keyed_int,
        Parrot_Hash_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_Hash_get_repr,
        Parrot_Hash_get_string,
        Parrot_OrderedHash_get_string_keyed,
        Parrot_OrderedHash_get_string_keyed_int,
        Parrot_Hash_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_OrderedHash_ro_i_absolute,
        Parrot_OrderedHash_ro_i_add,
        Parrot_OrderedHash_ro_i_add_float,
        Parrot_OrderedHash_ro_i_add_int,
        Parrot_OrderedHash_ro_i_bitwise_and,
        Parrot_OrderedHash_ro_i_bitwise_and_int,
        Parrot_OrderedHash_ro_i_bitwise_ands,
        Parrot_OrderedHash_ro_i_bitwise_ands_str,
        Parrot_OrderedHash_ro_i_bitwise_lsr,
        Parrot_OrderedHash_ro_i_bitwise_lsr_int,
        Parrot_OrderedHash_ro_i_bitwise_not,
        Parrot_OrderedHash_ro_i_bitwise_nots,
        Parrot_OrderedHash_ro_i_bitwise_or,
        Parrot_OrderedHash_ro_i_bitwise_or_int,
        Parrot_OrderedHash_ro_i_bitwise_ors,
        Parrot_OrderedHash_ro_i_bitwise_ors_str,
        Parrot_OrderedHash_ro_i_bitwise_shl,
        Parrot_OrderedHash_ro_i_bitwise_shl_int,
        Parrot_OrderedHash_ro_i_bitwise_shr,
        Parrot_OrderedHash_ro_i_bitwise_shr_int,
        Parrot_OrderedHash_ro_i_bitwise_xor,
        Parrot_OrderedHash_ro_i_bitwise_xor_int,
        Parrot_OrderedHash_ro_i_bitwise_xors,
        Parrot_OrderedHash_ro_i_bitwise_xors_str,
        Parrot_OrderedHash_ro_i_concatenate,
        Parrot_OrderedHash_ro_i_concatenate_str,
        Parrot_OrderedHash_ro_i_divide,
        Parrot_OrderedHash_ro_i_divide_float,
        Parrot_OrderedHash_ro_i_divide_int,
        Parrot_OrderedHash_ro_i_floor_divide,
        Parrot_OrderedHash_ro_i_floor_divide_float,
        Parrot_OrderedHash_ro_i_floor_divide_int,
        Parrot_OrderedHash_ro_i_logical_not,
        Parrot_OrderedHash_ro_i_modulus,
        Parrot_OrderedHash_ro_i_modulus_float,
        Parrot_OrderedHash_ro_i_modulus_int,
        Parrot_OrderedHash_ro_i_multiply,
        Parrot_OrderedHash_ro_i_multiply_float,
        Parrot_OrderedHash_ro_i_multiply_int,
        Parrot_OrderedHash_ro_i_neg,
        Parrot_OrderedHash_ro_i_pow,
        Parrot_OrderedHash_ro_i_pow_float,
        Parrot_OrderedHash_ro_i_pow_int,
        Parrot_OrderedHash_ro_i_repeat,
        Parrot_OrderedHash_ro_i_repeat_int,
        Parrot_OrderedHash_ro_i_subtract,
        Parrot_OrderedHash_ro_i_subtract_float,
        Parrot_OrderedHash_ro_i_subtract_int,
        Parrot_OrderedHash_ro_increment,
        Parrot_Hash_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_Hash_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_Hash_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_OrderedHash_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_OrderedHash_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_OrderedHash_ro_pop_float,
        Parrot_OrderedHash_ro_pop_integer,
        Parrot_OrderedHash_ro_pop_pmc,
        Parrot_OrderedHash_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_OrderedHash_ro_push_float,
        Parrot_OrderedHash_ro_push_integer,
        Parrot_OrderedHash_ro_push_pmc,
        Parrot_OrderedHash_ro_push_string,
        Parrot_OrderedHash_ro_remove_attribute,
        Parrot_OrderedHash_ro_remove_method,
        Parrot_OrderedHash_ro_remove_parent,
        Parrot_OrderedHash_ro_remove_role,
        Parrot_OrderedHash_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_OrderedHash_ro_set_attr_keyed,
        Parrot_OrderedHash_ro_set_attr_str,
        Parrot_OrderedHash_ro_set_bignum_int,
        Parrot_OrderedHash_ro_set_bignum_num,
        Parrot_OrderedHash_ro_set_bignum_str,
        Parrot_OrderedHash_ro_set_bool,
        Parrot_OrderedHash_ro_set_integer_keyed,
        Parrot_OrderedHash_ro_set_integer_keyed_int,
        Parrot_OrderedHash_ro_set_integer_keyed_str,
        Parrot_OrderedHash_ro_set_integer_native,
        Parrot_OrderedHash_ro_set_integer_same,
        Parrot_OrderedHash_ro_set_number_keyed,
        Parrot_OrderedHash_ro_set_number_keyed_int,
        Parrot_OrderedHash_ro_set_number_keyed_str,
        Parrot_OrderedHash_ro_set_number_native,
        Parrot_OrderedHash_ro_set_number_same,
        Parrot_OrderedHash_ro_set_pmc,
        Parrot_OrderedHash_ro_set_pmc_keyed,
        Parrot_OrderedHash_ro_set_pmc_keyed_int,
        Parrot_OrderedHash_ro_set_pmc_keyed_str,
        Parrot_OrderedHash_ro_set_pointer,
        Parrot_OrderedHash_ro_set_pointer_keyed,
        Parrot_OrderedHash_ro_set_pointer_keyed_int,
        Parrot_OrderedHash_ro_set_pointer_keyed_str,
        Parrot_OrderedHash_ro_set_string_keyed,
        Parrot_OrderedHash_ro_set_string_keyed_int,
        Parrot_OrderedHash_ro_set_string_keyed_str,
        Parrot_OrderedHash_ro_set_string_native,
        Parrot_OrderedHash_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_OrderedHash_ro_shift_float,
        Parrot_OrderedHash_ro_shift_integer,
        Parrot_OrderedHash_ro_shift_pmc,
        Parrot_OrderedHash_ro_shift_string,
        Parrot_Hash_slice,
        Parrot_OrderedHash_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_OrderedHash_ro_thaw,
        Parrot_OrderedHash_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_OrderedHash_ro_unshift_float,
        Parrot_OrderedHash_ro_unshift_integer,
        Parrot_OrderedHash_ro_unshift_pmc,
        Parrot_OrderedHash_ro_unshift_string,
        Parrot_OrderedHash_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "OrderedHash");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "array hash");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "OrderedHash")), PMCNULL);
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Hash")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "OrderedHash"));
            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Hash"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_OrderedHash_class_init */
#line 652 "./src/pmc/orderedhash.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd08_keys.pod>.

=head1 HISTORY

Initial rev by leo 2003-08-21.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
