/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/parrotinterpreter.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_parrotinterpreter.h"
#include "pmc_default.h"
#include "parrotinterpreter.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/parrotinterpreter.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: parrotinterpreter.pmc 37393 2009-03-13 19:56:52Z Util $

=head1 NAME

src/pmc/parrotinterpreter.pmc - Parrot Interpreter

=head1 DESCRIPTION

These are the vtable functions for the ParrotInterpreter base class

   getinterp P0
   set P1, P0[.IGLOBALS_*]  # access interpreter globals
   set I0, P0[x]            # interpinfo I0, x
   set I0, P0[-1]           # get interpreter flags
   set P0[-1], x            # set flags on interpreter
                            # NOTE: this doesn't restart

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/embed.h"
#include "parrot/dynext.h"
#include "parrot/io.h"
#include "pmc_class.h"
#include "pmc_sub.h"

#define PMC_interp(x) ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->interp
#define PMC_args(x)   ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->args
#define PMC_sub(x)    ((Parrot_ParrotInterpreter_attributes *)PMC_data(x))->sub

/*

=item C<void
clone_interpreter(Parrot_Interp dest, const Parrot_Interp source, INTVAL flags)>

Clones the interpreter as specified by the flags.

=cut

*/

void
clone_interpreter(Parrot_Interp d, Parrot_Interp s, INTVAL flags)
{
    /* we block GC runs while cloning since C<d> is not yet running */
    Parrot_block_GC_mark(d);

    d->scheduler = pmc_new(d, enum_class_Scheduler);
    d->scheduler = VTABLE_share_ro(d, d->scheduler);

    if (flags & PARROT_CLONE_RUNOPS)
        d->run_core = s->run_core;

    if (flags & PARROT_CLONE_INTERP_FLAGS) {
        /* XXX setting of IS_THREAD? */
        d->flags       = s->flags;
        d->debug_flags = s->debug_flags;
    }

    if (flags & PARROT_CLONE_HLL) {
        /* we'd like to share the HLL data. Give it a PMC_sync structure
           if it doesn't have one already */
        add_pmc_sync(s, s->HLL_info);
        d->HLL_info = s->HLL_info;
        Parrot_regenerate_HLL_namespaces(d);
    }

    if (flags & (PARROT_CLONE_LIBRARIES | PARROT_CLONE_CLASSES)) {
        INTVAL i, last_remove;
        const INTVAL start = d->n_vtable_max;

        /* copy type registrations to keep type numbers the same */
        d->class_hash   = Parrot_clone(d, s->class_hash);
        d->n_vtable_max = s->n_vtable_max;

        if (d->n_vtable_max > d->n_vtable_alloced)
            parrot_realloc_vtables(d);

        last_remove = s->n_vtable_max;

        for (i = s->n_vtable_max - 1; i >= start; --i) {
            if (s->vtables[i] && s->vtables[i]->pmc_class &&
                PObj_is_class_TEST(s->vtables[i]->pmc_class)) {
                STRING * const class_name =
                    VTABLE_get_string(s, s->vtables[i]->pmc_class);
                PARROT_ASSERT(VTABLE_exists_keyed_str(d,
                    d->class_hash, class_name));

                VTABLE_delete_keyed_str(d, d->class_hash, class_name);

                if (last_remove == i + 1) {
                    --d->n_vtable_max;
                    last_remove = i;
                }
            }
        }
    }

    if (flags & PARROT_CLONE_LIBRARIES) {
        PMC   * const libs     = VTABLE_get_pmc_keyed_int(s, s->iglobals,
            IGLOBALS_DYN_LIBS);
        PMC   * const lib_iter = VTABLE_get_iter(s, libs);
        const INTVAL n         = VTABLE_elements(s, libs);
        INTVAL i;

        for (i = 0; i < n; ++i) {
            STRING * const key     = VTABLE_shift_string(s, lib_iter);
            PMC    * const lib_pmc = VTABLE_get_pmc_keyed_str(s, libs, key);
            PMC    * const ignored = Parrot_clone_lib_into(d, s, lib_pmc);
            UNUSED(ignored);
        }
    }

    if (flags & PARROT_CLONE_CLASSES) {
        INTVAL i;
        for (i = 0; i < s->n_vtable_max; ++i) {
            if (s->vtables[i] && s->vtables[i]->pmc_class &&
                    PObj_is_class_TEST(s->vtables[i]->pmc_class)) {
                /* Cloning the class into the new interpreter ought
                 * to be sufficient to instantiate the class.  */
                 PMC          *source       = s->vtables[i]->pmc_class;
                 PMC          *dest         = Parrot_clone(d, source);
                 Parrot_Class_attributes *source_class = PARROT_CLASS(source);
                 Parrot_Class_attributes *dest_class   = PARROT_CLASS(dest);
                 dest_class->name           = Parrot_str_copy(d, source_class->name);
                 dest_class->_namespace     = VTABLE_clone(d, source_class->_namespace);
            }
        }
    }

    if (flags & PARROT_CLONE_CODE)
        pt_clone_code(d, s);

    if (flags & PARROT_CLONE_GLOBALS)
        pt_clone_globals(d, s);

    Parrot_unblock_GC_sweep(d);
}


/*

=item C<static void
create_interp(PMC *self, Parrot_Interp parent)>

Creates a new child interpreter of C<parent>.

=cut

*/

static void
create_interp(PMC *self, Parrot_Interp parent)
{
    Interp_flags flag  = PARROT_NO_FLAGS;
    Parrot_Interp new_interp;

    if (self->vtable->base_type == enum_class_ParrotThread)
        flag = PARROT_IS_THREAD;

    new_interp       = make_interpreter(parent, (INTVAL)flag);
    PMC_interp(self) = new_interp;

    VTABLE_set_pmc_keyed_int(new_interp, new_interp->iglobals,
        (INTVAL) IGLOBALS_INTERPRETER, self);

    new_interp->current_cont = NEED_CONTINUATION;
}

static int
recursion_limit(PARROT_INTERP, PMC *self, int l)
{
    const int ret           = interp->recursion_limit;
    interp->recursion_limit = l;
    return ret;
}
#line 207 "./src/pmc/parrotinterpreter.c"
PARROT_EXPORT  PMC  *
Parrot_ParrotInterpreter_clone(PARROT_INTERP, PMC *pmc)
{
#line 585 "./src/pmc/parrotinterpreter.pmc"

    PMC * const dest = pmc_new(interp, pmc->vtable->base_type);

    clone_interpreter(PMC_interp(dest),
                      PMC_interp(pmc), PARROT_CLONE_DEFAULT);

    return dest;
#line 219 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ParrotInterpreter_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 313 "./src/pmc/parrotinterpreter.pmc"

    const Parrot_Interp i = PMC_interp(pmc);
    return (INTVAL)i->thread_data->tid;
#line 228 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ParrotInterpreter_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 541 "./src/pmc/parrotinterpreter.pmc"

    Interp * const new_interp = PMC_interp(pmc);

    if (key == -1)
        return (INTVAL)new_interp->flags;

    return interpinfo(new_interp, key);
#line 241 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  PMC  *
Parrot_ParrotInterpreter_get_pmc(PARROT_INTERP, PMC *pmc)
{
#line 354 "./src/pmc/parrotinterpreter.pmc"

    return PMC_args(pmc);
#line 249 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  PMC  *
Parrot_ParrotInterpreter_get_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 418 "./src/pmc/parrotinterpreter.pmc"

    PMC    *nextkey, *cont;
    STRING *outer = NULL;
    STRING *item  = key_string(interp, key);
    STRING *s     = CONST_STRING(interp, "globals");
    int     level = 0;

    Parrot_Context *ctx;

    if (Parrot_str_equal(interp, item, s))
        return interp->root_namespace;

    s     = CONST_STRING(interp, "outer");

    if (Parrot_str_equal(interp, item, s)) {
        outer   = item;
        nextkey = key_next(interp, key);

        if (nextkey && (PObj_get_FLAGS(nextkey) & KEY_string_FLAG)) {
            key  = nextkey;
            item = VTABLE_get_string(interp, key);
        }
    }

    nextkey = key_next(interp, key);

    if (nextkey)
        level = key_integer(interp, nextkey);
    else if (outer)
        level = 1;

    if (level < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, CONTROL_ERROR,
            "No such caller depth");

    ctx = CONTEXT(interp);

    if (outer) {
        for (; level; --level) {
            ctx = ctx->outer_ctx;
            if (!ctx)
                Parrot_ex_throw_from_c_args(interp, NULL,
                    CONTROL_ERROR, "No such outer depth");
        }
    }
    else {
        for (; level; --level) {
            cont = ctx->current_cont;

            if (PMC_IS_NULL(cont) || !PMC_cont(cont)->seg)
                Parrot_ex_throw_from_c_args(interp, NULL,
                    CONTROL_ERROR, "No such caller depth");

            ctx = PMC_cont(cont)->to_ctx;

            if (!ctx->current_sub)
                Parrot_ex_throw_from_c_args(interp, NULL,
                    CONTROL_ERROR, "No such caller depth");
        }
    }

    if (item == outer)
        return ctx->current_sub;

    s = CONST_STRING(interp, "sub");

    if (Parrot_str_equal(interp, item, s))
        return ctx->current_sub;

    s = CONST_STRING(interp, "lexpad");

    if (Parrot_str_equal(interp, item, s))
        return ctx->lex_pad;

    s = CONST_STRING(interp, "namespace");

    if (Parrot_str_equal(interp, item, s))
        return ctx->current_namespace;

    s = CONST_STRING(interp, "continuation");

    if (Parrot_str_equal(interp, item, s))
        return VTABLE_clone(interp, ctx->current_cont);

    s = CONST_STRING(interp, "annotations");

    if (Parrot_str_equal(interp, item, s)) {
        Parrot_sub *sub;
        PMC        *sub_pmc = ctx->current_sub;
        PMC_get_sub(interp, sub_pmc, sub);
        if (ctx == CONTEXT(interp)) {
            /* We can't know the current program counter for the currently
             * executing sub, so can't return annotations for that. */
            if (ctx == CONTEXT(interp))
                Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                        "Cannot get annotations at depth 0; use annotations op instead.");
        }
        if (!PMC_IS_NULL(sub_pmc) && sub_pmc->vtable->base_type == enum_class_Sub &&
                sub->seg->annotations) {
            PackFile_ByteCode *seg = sub->seg;
            opcode_t *pc = ctx->current_pc;
            return PackFile_Annotations_lookup(interp,  seg->annotations,
                    pc - seg->base.data, NULL);
        }
        else {
            return pmc_new(interp, enum_class_Hash);
        }
    }

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ATTRIB_NOT_FOUND,
            "No such item %Ss", item);
#line 366 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  PMC  *
Parrot_ParrotInterpreter_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 383 "./src/pmc/parrotinterpreter.pmc"

    Interp * const new_interp = PMC_interp(pmc);

    if (key >= 0 && key < IGLOBALS_SIZE)
        return VTABLE_get_pmc_keyed_int(new_interp,
            new_interp->iglobals, key);

    /* quick hack to get the global stash */
    if (key == -1)
        return new_interp->root_namespace;

    return PMCNULL;
#line 384 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void  *
Parrot_ParrotInterpreter_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 299 "./src/pmc/parrotinterpreter.pmc"

    return PMC_interp(pmc);
#line 392 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void 
Parrot_ParrotInterpreter_init(PARROT_INTERP, PMC *pmc)
{
#line 232 "./src/pmc/parrotinterpreter.pmc"

    /*
     * init/init_pmc may be called internally (from thread creation in
     * ParrotThread::init_pmc() or stand-alone
     * so we check, if the interpreter is already set up
     */
    if (!PMC_data(pmc)) {
        Parrot_ParrotInterpreter_attributes *attrs =
            mem_allocate_zeroed_typed(Parrot_ParrotInterpreter_attributes);
        PMC_data(pmc) = attrs;
        create_interp(pmc, interp);
        PARROT_ASSERT(attrs->interp);
    }
#line 411 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void 
Parrot_ParrotInterpreter_init_pmc(PARROT_INTERP, PMC *pmc, PMC *parent)
{
#line 259 "./src/pmc/parrotinterpreter.pmc"

    Parrot_Interp p = PMC_interp(parent);

    if (!PMC_interp(pmc))
        create_interp(pmc, p);
#line 422 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  opcode_t  *
Parrot_ParrotInterpreter_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 328 "./src/pmc/parrotinterpreter.pmc"

    Interp * const new_interp = PMC_interp(pmc);

    /* setup code */
    pt_thread_prepare_for_run(new_interp, interp);

    /* TODO pass arguments from parent (interp) to child (new_interp) by
     * possibly clone of share the arguments r/o args can be passed as is */

    /* calculate offset and run */
    runops(new_interp, (size_t)((opcode_t *)PMC_sub(pmc) -
        (opcode_t *)interp->code->base.data));

    return (opcode_t *)next;
#line 442 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ParrotInterpreter_is_equal(PARROT_INTERP, PMC *pmc, PMC *val)
{
#line 607 "./src/pmc/parrotinterpreter.pmc"

    Parrot_Interp self  = PMC_interp(pmc);
    Parrot_Interp other = PMC_interp(val);

    if (!self->thread_data && !other->thread_data)
        return 1;

    if (self->thread_data && other->thread_data &&
        self->thread_data->tid == other->thread_data->tid)
        return 1;

    return 0;
#line 460 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void 
Parrot_ParrotInterpreter_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL val)
{
#line 560 "./src/pmc/parrotinterpreter.pmc"

    Interp * const new_interp = PMC_interp(pmc);

    /* set interpreter flags */
    if (key == -1) {
        const INTVAL allowed = PARROT_BOUNDS_FLAG | PARROT_PROFILE_FLAG |
                         PARROT_GC_DEBUG_FLAG;
        Parrot_clear_flag(new_interp, allowed);
        Parrot_set_flag(new_interp, val & allowed);
    }
#line 476 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void 
Parrot_ParrotInterpreter_set_pmc(PARROT_INTERP, PMC *pmc, PMC *args)
{
#line 368 "./src/pmc/parrotinterpreter.pmc"

    PMC_args(pmc) = args;
#line 484 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void 
Parrot_ParrotInterpreter_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
#line 276 "./src/pmc/parrotinterpreter.pmc"


    /* XXX: init_world in src/global_setup.c needs to create a
     * ParrotInterpreter through pmc_new_noinit.  If this PMC hasn't been
     * initialized, cheat by initializing instead. */
    if (!PMC_data(pmc)) {
        Parrot_ParrotInterpreter_attributes *attrs =
            mem_allocate_zeroed_typed(Parrot_ParrotInterpreter_attributes);
        PMC_data(pmc) = attrs;
    }
    PMC_interp(pmc) = (struct parrot_interp_t *)value;
#line 501 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void 
Parrot_ParrotInterpreter_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 684 "./src/pmc/parrotinterpreter.pmc"

    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        Parrot_default_thaw(interp, pmc, info);
    }
    else if (info->extra_flags == EXTRA_IS_NULL) {

        if (!PMC_data(pmc)) {
            Parrot_ParrotInterpreter_attributes *attrs =
                mem_allocate_zeroed_typed(Parrot_ParrotInterpreter_attributes);
            PMC_data(pmc) = attrs;
        }

        PMC_interp(pmc) = interp;
        info->what       = VISIT_THAW_CONSTANTS;
    }
#line 522 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void 
Parrot_ParrotInterpreter_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 701 "./src/pmc/parrotinterpreter.pmc"

    PMC * const new_info = PMC_args(pmc);
    const INTVAL  m      = VTABLE_elements(interp, new_info);
    INTVAL  i;

    PMC_args(pmc) = NULL;

    /* merge new_info */
    /* TODO compare old entries */

    for (i = 0; i < m; ++i) {
        PMC * const entry    = VTABLE_get_pmc_keyed_int(interp, new_info, i);
        PMC * const lib_pmc  = VTABLE_get_pmc_keyed_int(interp, entry, e_HLL_lib);
        PMC * const name_pmc = VTABLE_get_pmc_keyed_int(interp, entry, e_HLL_name);
        PMC * const typemap  = VTABLE_get_pmc_keyed_int(interp, entry, e_HLL_typemap);
        INTVAL hll_id = - 1;

        if (!PMC_IS_NULL(name_pmc)) {
            STRING * const hll_name = VTABLE_get_string(interp, name_pmc);

            hll_id           = Parrot_register_HLL(interp, hll_name);
        }

        if (!PMC_IS_NULL(lib_pmc)) {
            STRING *lib_name = VTABLE_get_string(interp, lib_pmc);
            PMC    *ignored;

            if (!STRING_IS_EMPTY(lib_name)) {
                INTVAL id;
                ignored      = Parrot_load_lib(interp, lib_name, NULL);
                id           = Parrot_register_HLL_lib(interp, lib_name);
                UNUSED(id);
            }

            UNUSED(ignored);
        }

        if (hll_id >= 0 && !PMC_IS_NULL(typemap)) {
            PMC   *iter = VTABLE_get_iter(interp, typemap);
            INTVAL e    = VTABLE_get_integer(interp, typemap);
            INTVAL i;

            for (i = 0; i < e; ++i) {
                PMC * const key        = VTABLE_shift_pmc(interp, iter);
                const INTVAL core_type = VTABLE_get_integer(interp, key);
                const INTVAL hll_type  =
                    VTABLE_get_integer_keyed_int(interp, typemap, core_type);

                Parrot_register_HLL_type(interp, hll_id,
                    core_type, hll_type);
            }
        }
    }
#line 581 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void 
Parrot_ParrotInterpreter_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 648 "./src/pmc/parrotinterpreter.pmc"

    PMC **pos;
    /*
     * the information frozen here is part of all PBCs
     * we probably need to freeze all dynamic extensible
     * mappings (or at least the dynamic part)
     * e.g.
     *    charsets   idx - name
     *    encodings  idx - name
     *    pmc types  idx - name
     *    dynamic oplibs    opcode nr - opname
     *
     * The machine thawing this info still needs to load
     * these extensions, but the order of loading could be
     * relaxed.
     *
     * creating all these info as standard PMCs would vastly
     * simplify this process
     *
     * thaw would then need a merge operation:
     *  - compare existing for sanity
     *  - extend new
     */

    /*  HLL_info */
    if (info->what == VISIT_THAW_NORMAL ||
            info->what == VISIT_THAW_CONSTANTS) {
        pos = &PMC_args(pmc);
    }
    else
        pos = &interp->HLL_info;

    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);
#line 621 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_nci_run_gc(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 659 "./src/pmc/parrotinterpreter.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 676 "./src/pmc/parrotinterpreter.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 756 "./src/pmc/parrotinterpreter.pmc"

    Parrot_do_gc_run(PMC_interp(pmc), 0);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 700 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_nci_hll_map(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 3 };
    opcode_t _param_indexes[]     = { 0, 1, 2 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 740 "./src/pmc/parrotinterpreter.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 757 "./src/pmc/parrotinterpreter.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* core_type = CTX_REG_PMC(_ctx, 1);
    PMC* hll_type = CTX_REG_PMC(_ctx, 2);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 770 "./src/pmc/parrotinterpreter.pmc"

    INTVAL core_type_id = VTABLE_type(interp, core_type);
    INTVAL hll_type_id  = VTABLE_type(interp, hll_type);
    INTVAL hll_id       = CONTEXT(interp)->current_HLL;
    Parrot_register_HLL_type(interp, hll_id, core_type_id, hll_type_id);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 786 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_nci_stdhandle(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 0);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 130);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 826 "./src/pmc/parrotinterpreter.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 843 "./src/pmc/parrotinterpreter.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    INTVAL fileno = CTX_REG_INT(_ctx, 0);
    PMC* newhandle = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 793 "./src/pmc/parrotinterpreter.pmc"

    PMC * handle = Parrot_io_stdhandle(interp, fileno, newhandle);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *handle */
    /*BEGIN GENERATED ACCESSORS */
#line 859 "./src/pmc/parrotinterpreter.pmc"
    CTX_REG_PMC(_ctx, 0) = handle;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto stdhandle_returns;
    /*END RETURN PMC *handle */
    }
#line 795 "./src/pmc/parrotinterpreter.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
stdhandle_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 904 "./src/pmc/parrotinterpreter.c"
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  PMC *
Parrot_ParrotInterpreter_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  FLOATVAL
Parrot_ParrotInterpreter_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  INTVAL
Parrot_ParrotInterpreter_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  PMC *
Parrot_ParrotInterpreter_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  STRING *
Parrot_ParrotInterpreter_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  FLOATVAL
Parrot_ParrotInterpreter_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  INTVAL
Parrot_ParrotInterpreter_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  PMC *
Parrot_ParrotInterpreter_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  STRING *
Parrot_ParrotInterpreter_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ParrotInterpreter");
}
PARROT_EXPORT  void
Parrot_ParrotInterpreter_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ParrotInterpreter");
}
#include "pmc_default.h"
void
Parrot_ParrotInterpreter_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":interp Itid Fargs Fsub ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_ParrotInterpreter, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_ParrotInterpreter_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_ParrotInterpreter_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_ParrotInterpreter_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_ParrotInterpreter_get_pmc,
        Parrot_ParrotInterpreter_get_pmc_keyed,
        Parrot_ParrotInterpreter_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_ParrotInterpreter_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_ParrotInterpreter_init,
        Parrot_ParrotInterpreter_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_ParrotInterpreter_invoke,
        Parrot_ParrotInterpreter_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_ParrotInterpreter_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_ParrotInterpreter_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_ParrotInterpreter_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_ParrotInterpreter_thaw,
        Parrot_ParrotInterpreter_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_ParrotInterpreter_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_ParrotInterpreter, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_ParrotInterpreter_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_ParrotInterpreter_ro_add_method,
        Parrot_ParrotInterpreter_ro_add_parent,
        Parrot_ParrotInterpreter_ro_add_role,
        Parrot_ParrotInterpreter_ro_add_vtable_override,
        Parrot_ParrotInterpreter_ro_assign_pmc,
        Parrot_ParrotInterpreter_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_ParrotInterpreter_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_ParrotInterpreter_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ParrotInterpreter_ro_delete_keyed,
        Parrot_ParrotInterpreter_ro_delete_keyed_int,
        Parrot_ParrotInterpreter_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ParrotInterpreter_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_ParrotInterpreter_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_ParrotInterpreter_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_ParrotInterpreter_get_pmc,
        Parrot_ParrotInterpreter_get_pmc_keyed,
        Parrot_ParrotInterpreter_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_ParrotInterpreter_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_ParrotInterpreter_ro_i_absolute,
        Parrot_ParrotInterpreter_ro_i_add,
        Parrot_ParrotInterpreter_ro_i_add_float,
        Parrot_ParrotInterpreter_ro_i_add_int,
        Parrot_ParrotInterpreter_ro_i_bitwise_and,
        Parrot_ParrotInterpreter_ro_i_bitwise_and_int,
        Parrot_ParrotInterpreter_ro_i_bitwise_ands,
        Parrot_ParrotInterpreter_ro_i_bitwise_ands_str,
        Parrot_ParrotInterpreter_ro_i_bitwise_lsr,
        Parrot_ParrotInterpreter_ro_i_bitwise_lsr_int,
        Parrot_ParrotInterpreter_ro_i_bitwise_not,
        Parrot_ParrotInterpreter_ro_i_bitwise_nots,
        Parrot_ParrotInterpreter_ro_i_bitwise_or,
        Parrot_ParrotInterpreter_ro_i_bitwise_or_int,
        Parrot_ParrotInterpreter_ro_i_bitwise_ors,
        Parrot_ParrotInterpreter_ro_i_bitwise_ors_str,
        Parrot_ParrotInterpreter_ro_i_bitwise_shl,
        Parrot_ParrotInterpreter_ro_i_bitwise_shl_int,
        Parrot_ParrotInterpreter_ro_i_bitwise_shr,
        Parrot_ParrotInterpreter_ro_i_bitwise_shr_int,
        Parrot_ParrotInterpreter_ro_i_bitwise_xor,
        Parrot_ParrotInterpreter_ro_i_bitwise_xor_int,
        Parrot_ParrotInterpreter_ro_i_bitwise_xors,
        Parrot_ParrotInterpreter_ro_i_bitwise_xors_str,
        Parrot_ParrotInterpreter_ro_i_concatenate,
        Parrot_ParrotInterpreter_ro_i_concatenate_str,
        Parrot_ParrotInterpreter_ro_i_divide,
        Parrot_ParrotInterpreter_ro_i_divide_float,
        Parrot_ParrotInterpreter_ro_i_divide_int,
        Parrot_ParrotInterpreter_ro_i_floor_divide,
        Parrot_ParrotInterpreter_ro_i_floor_divide_float,
        Parrot_ParrotInterpreter_ro_i_floor_divide_int,
        Parrot_ParrotInterpreter_ro_i_logical_not,
        Parrot_ParrotInterpreter_ro_i_modulus,
        Parrot_ParrotInterpreter_ro_i_modulus_float,
        Parrot_ParrotInterpreter_ro_i_modulus_int,
        Parrot_ParrotInterpreter_ro_i_multiply,
        Parrot_ParrotInterpreter_ro_i_multiply_float,
        Parrot_ParrotInterpreter_ro_i_multiply_int,
        Parrot_ParrotInterpreter_ro_i_neg,
        Parrot_ParrotInterpreter_ro_i_pow,
        Parrot_ParrotInterpreter_ro_i_pow_float,
        Parrot_ParrotInterpreter_ro_i_pow_int,
        Parrot_ParrotInterpreter_ro_i_repeat,
        Parrot_ParrotInterpreter_ro_i_repeat_int,
        Parrot_ParrotInterpreter_ro_i_subtract,
        Parrot_ParrotInterpreter_ro_i_subtract_float,
        Parrot_ParrotInterpreter_ro_i_subtract_int,
        Parrot_ParrotInterpreter_ro_increment,
        Parrot_ParrotInterpreter_init,
        Parrot_ParrotInterpreter_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_ParrotInterpreter_invoke,
        Parrot_ParrotInterpreter_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_ParrotInterpreter_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_ParrotInterpreter_ro_pop_float,
        Parrot_ParrotInterpreter_ro_pop_integer,
        Parrot_ParrotInterpreter_ro_pop_pmc,
        Parrot_ParrotInterpreter_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_ParrotInterpreter_ro_push_float,
        Parrot_ParrotInterpreter_ro_push_integer,
        Parrot_ParrotInterpreter_ro_push_pmc,
        Parrot_ParrotInterpreter_ro_push_string,
        Parrot_ParrotInterpreter_ro_remove_attribute,
        Parrot_ParrotInterpreter_ro_remove_method,
        Parrot_ParrotInterpreter_ro_remove_parent,
        Parrot_ParrotInterpreter_ro_remove_role,
        Parrot_ParrotInterpreter_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_ParrotInterpreter_ro_set_attr_keyed,
        Parrot_ParrotInterpreter_ro_set_attr_str,
        Parrot_ParrotInterpreter_ro_set_bignum_int,
        Parrot_ParrotInterpreter_ro_set_bignum_num,
        Parrot_ParrotInterpreter_ro_set_bignum_str,
        Parrot_ParrotInterpreter_ro_set_bool,
        Parrot_ParrotInterpreter_ro_set_integer_keyed,
        Parrot_ParrotInterpreter_ro_set_integer_keyed_int,
        Parrot_ParrotInterpreter_ro_set_integer_keyed_str,
        Parrot_ParrotInterpreter_ro_set_integer_native,
        Parrot_ParrotInterpreter_ro_set_integer_same,
        Parrot_ParrotInterpreter_ro_set_number_keyed,
        Parrot_ParrotInterpreter_ro_set_number_keyed_int,
        Parrot_ParrotInterpreter_ro_set_number_keyed_str,
        Parrot_ParrotInterpreter_ro_set_number_native,
        Parrot_ParrotInterpreter_ro_set_number_same,
        Parrot_ParrotInterpreter_ro_set_pmc,
        Parrot_ParrotInterpreter_ro_set_pmc_keyed,
        Parrot_ParrotInterpreter_ro_set_pmc_keyed_int,
        Parrot_ParrotInterpreter_ro_set_pmc_keyed_str,
        Parrot_ParrotInterpreter_ro_set_pointer,
        Parrot_ParrotInterpreter_ro_set_pointer_keyed,
        Parrot_ParrotInterpreter_ro_set_pointer_keyed_int,
        Parrot_ParrotInterpreter_ro_set_pointer_keyed_str,
        Parrot_ParrotInterpreter_ro_set_string_keyed,
        Parrot_ParrotInterpreter_ro_set_string_keyed_int,
        Parrot_ParrotInterpreter_ro_set_string_keyed_str,
        Parrot_ParrotInterpreter_ro_set_string_native,
        Parrot_ParrotInterpreter_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ParrotInterpreter_ro_shift_float,
        Parrot_ParrotInterpreter_ro_shift_integer,
        Parrot_ParrotInterpreter_ro_shift_pmc,
        Parrot_ParrotInterpreter_ro_shift_string,
        Parrot_default_slice,
        Parrot_ParrotInterpreter_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_ParrotInterpreter_ro_thaw,
        Parrot_ParrotInterpreter_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_ParrotInterpreter_ro_unshift_float,
        Parrot_ParrotInterpreter_ro_unshift_integer,
        Parrot_ParrotInterpreter_ro_unshift_pmc,
        Parrot_ParrotInterpreter_ro_unshift_string,
        Parrot_ParrotInterpreter_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "ParrotInterpreter");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "ParrotInterpreter")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "ParrotInterpreter"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ParrotInterpreter_nci_run_gc), "run_gc");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ParrotInterpreter_nci_hll_map), "hll_map");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ParrotInterpreter_nci_stdhandle), "stdhandle");
        /* class_init */
        {
        
            const int typ = enum_class_ParrotInterpreter;
        
            if (pass) {
                /* TODO unify and fix signatures */
                register_nci_method(interp, typ,
                        F2DPTR(pt_thread_yield), "yield", "v");
        
                /* misc functions */
                register_nci_method(interp, typ,
                        F2DPTR(recursion_limit), "recursion_limit", "iJOi");
            }

        }
        {
        }
    } /* pass */
} /* Parrot_ParrotInterpreter_class_init */
#line 796 "./src/pmc/parrotinterpreter.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
