/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/pmcproxy.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_pmcproxy.h"
#include "pmc_class.h"
#include "pmc_default.h"
#include "pmcproxy.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/pmcproxy.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: pmcproxy.pmc 37099 2009-03-03 18:23:12Z Util $

=head1 NAME

src/pmc/pmcproxy.pmc - proxy class object for a PMC enabling introspection

=head1 DESCRIPTION

This class is used to describe a PMC. It can sit in an inheritance hierarchy
of a PDD15 class as well as allowing introspection of the PMC.

PMCProxy is not derived from any other PMC.

=head2 Structure

This class stores its state in the Parrot_Class structure, using the
following fields.

=over 4

=item C<id>

The type number of the PMC that is being described.

=item C<name>

The name of the PMC -- a STRING.

=item C<namespace>

The namespace the PMC is associated with, if any.

=item C<parents>

An array of immediate parent classes.
An empty ResizablePMCArray PMC is allocated during initialization.

=item C<all_parents>

A cached array of ourself and all parent classes, in MRO order.
A ResizablePMCArray PMC is allocated during initialization,
and is populated with the current class.

=back

NOTE: No doubt we will need other things later; this is a start.

=cut

*/

#include "parrot/parrot.h"
#include "parrot/oo_private.h"

/*

=head2 Functions

=over 4

=cut

*/
#line 89 "./src/pmc/pmcproxy.c"
PARROT_EXPORT  void 
Parrot_PMCProxy_destroy(PARROT_INTERP, PMC *pmc)
{
#line 213 "./src/pmc/pmcproxy.pmc"

    mem_sys_free(PMC_data(pmc));
#line 96 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  INTVAL 
Parrot_PMCProxy_does(PARROT_INTERP, PMC *pmc, STRING *role_name)
{
#line 352 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes *_class  = PARROT_CLASS(pmc);
    INTVAL                   id      = _class->id;
    PMC                     *proxied = pmc_new(interp, id);

    if (VTABLE_does(interp, proxied, role_name))
        return 1;

    return VTABLE_isa(interp, proxied, role_name);

#line 112 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  STRING  *
Parrot_PMCProxy_get_string(PARROT_INTERP, PMC *pmc)
{
#line 516 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes * const proxy_info = PARROT_CLASS(pmc);

    /* Copy the stored string name of the proxy. */
    return Parrot_str_copy(interp, proxy_info->name);
#line 123 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  void 
Parrot_PMCProxy_init(PARROT_INTERP, PMC *pmc)
{
#line 80 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes * const _pmc = mem_allocate_zeroed_typed(Parrot_Class_attributes);
    PMC          * const new_attribute   = pmc_new(interp, enum_class_Hash);
    STRING       * const name            = CONST_STRING(interp, "proxy");
    PMC_data(pmc)                       = _pmc;

    /* Set flags for custom GC mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);

    /* Set up the object. */
    _pmc->id               = 0;
    _pmc->name             = CONST_STRING(interp, "");
    _pmc->_namespace       = PMCNULL;
    _pmc->parents          = pmc_new(interp, enum_class_ResizablePMCArray);
    _pmc->all_parents      = pmc_new(interp, enum_class_ResizablePMCArray);
    _pmc->roles            = pmc_new(interp, enum_class_ResizablePMCArray);
    _pmc->methods          = pmc_new(interp, enum_class_Hash);
    _pmc->vtable_overrides = constant_pmc_new(interp, enum_class_Hash);
    _pmc->parent_overrides = pmc_new(interp, enum_class_Hash);
    _pmc->attrib_metadata  = pmc_new(interp, enum_class_Hash);
    _pmc->attrib_index     = PMCNULL;
    _pmc->attrib_cache     = PMCNULL;
    _pmc->resolve_method   = pmc_new(interp, enum_class_ResizablePMCArray);

    /* Set up the attribute storage for the proxy instance */
    VTABLE_set_string_keyed_str(interp, new_attribute, CONST_STRING(interp, "name"), name);
    VTABLE_set_pmc_keyed_str(interp, _pmc->attrib_metadata, name, new_attribute);

    /* We put ourself on the all parents list. */
    VTABLE_push_pmc(interp, _pmc->all_parents, pmc);

    /* We are a class. */
    PObj_is_class_SET(pmc);
#line 163 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  void 
Parrot_PMCProxy_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init_data)
{
#line 116 "./src/pmc/pmcproxy.pmc"

    const INTVAL type_num = VTABLE_get_integer(interp, init_data);
    Parrot_Class_attributes *proxy_info;
    INTVAL mro_length, i;

    /* Ensure that it's a valid type number. */
    if (type_num > interp->n_vtable_max || type_num <= 0)
        Parrot_ex_throw_from_c_args(interp, NULL, 1,
            "Attempt to create PMC Proxy for invalid type number!");

    /* Set up the object. */
    VTABLE_init(interp, pmc);

    /* Set up number, name and namespace. */
    proxy_info             = PARROT_CLASS(pmc);
    proxy_info->id         = type_num;
    proxy_info->name       = interp->vtables[type_num]->whoami;
    proxy_info->_namespace = interp->vtables[type_num]->_namespace;

    /* Build MRO (skip ourself). */
    mro_length = VTABLE_elements(interp, interp->vtables[type_num]->mro);
    for (i = 1; i < mro_length; i++) {
        PMC    *pclass = VTABLE_get_pmc_keyed_int(interp, interp->vtables[type_num]->mro, i);
        STRING *cname  = pclass->vtable->whoami;
        if (Parrot_str_not_equal(interp, cname, CONST_STRING(interp, "scalar"))) {
            PMC *pproxy = Parrot_oo_get_class_str(interp, cname);
            VTABLE_push_pmc(interp, proxy_info->all_parents, pproxy);
        }
    }

    /* PMCs just do single inheritance, so we'll assume that if we have a
     * second entry in our MRO, it goes in the parents list. */
    if (VTABLE_elements(interp, proxy_info->all_parents) >= 2)
        VTABLE_push_pmc(interp, proxy_info->parents,
                VTABLE_get_pmc_keyed_int(interp, proxy_info->all_parents, 1));

    if (!PMC_IS_NULL(proxy_info->_namespace) &&
        PMC_IS_NULL(VTABLE_get_class(interp, proxy_info->_namespace))) {

        /* Link the proxy and the namespace, caching the proxy object for
         * later retrieval on class lookup. */
         Parrot_PCCINVOKE(interp, proxy_info->_namespace, CONST_STRING(interp, "set_class"), "P->", pmc);

        /* Extract any methods from the namespace */
        Parrot_oo_extract_methods_from_namespace(interp, pmc,
                proxy_info->_namespace);
    }

    { /* Create inherited attributes */
        /* Each attribute is prefixed with his type
         * and terminated by an space,
         * the list is '\0' terminated
         */
        const char * attr = interp->vtables[type_num]->attribute_defs;
        while (* attr) {
            const char * const current = attr + 1;
            size_t l;
            char attrtype = * attr;
            while (* attr != ' ') ++attr;
            l= attr - current;
            if (attrtype != ':') {
                STRING *sattr = Parrot_str_new(interp, current, l);
                VTABLE_add_attribute(interp, pmc, sattr, NULL);
            }
            ++attr;
        }
    }
#line 236 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  PMC  *
Parrot_PMCProxy_inspect(PARROT_INTERP, PMC *pmc)
{
#line 391 "./src/pmc/pmcproxy.pmc"

    /* Create a hash, then use inspect_str to get all of the data to
     * fill it up with. */
    STRING * const name_str    = CONST_STRING(interp, "name");
    STRING * const ns_str      = CONST_STRING(interp, "namespace");
    STRING * const meth_str    = CONST_STRING(interp, "methods");
    STRING * const parents_str = CONST_STRING(interp, "parents");

    PMC * const metadata = pmc_new(interp, enum_class_Hash);

    VTABLE_set_pmc_keyed_str(interp, metadata, name_str,
        VTABLE_inspect_str(interp, pmc, name_str));
    VTABLE_set_pmc_keyed_str(interp, metadata, ns_str,
        VTABLE_inspect_str(interp, pmc, ns_str));
    VTABLE_set_pmc_keyed_str(interp, metadata, meth_str,
        VTABLE_inspect_str(interp, pmc, meth_str));
    VTABLE_set_pmc_keyed_str(interp, metadata, parents_str,
        VTABLE_inspect_str(interp, pmc, parents_str));

    return metadata;
#line 262 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  PMC  *
Parrot_PMCProxy_instantiate(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 194 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes * const _pmc = PARROT_CLASS(pmc);

    if (!PMC_IS_NULL(init))
        return pmc_new_init(interp, _pmc->id, init);

    return pmc_new(interp, _pmc->id);
#line 275 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  INTVAL 
Parrot_PMCProxy_isa(PARROT_INTERP, PMC *pmc, STRING *classname)
{
#line 325 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes * const _proxy = PARROT_CLASS(pmc);
    const STRING * const pmc_proxy = CONST_STRING(interp, "PMCProxy");

    if (Parrot_str_equal(interp, classname, pmc_proxy))
        return 1;

    if (Parrot_Class_isa(interp, pmc, classname))
        return 1;

    /* Look in the isa hash. */
    if (parrot_hash_exists(interp, interp->vtables[_proxy->id]->isa_hash, classname))
        return 1;

    return 0;
#line 296 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  INTVAL 
Parrot_PMCProxy_isa_pmc(PARROT_INTERP, PMC *pmc, PMC *lookup)
{
#line 266 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes * const _proxy = PARROT_CLASS(pmc);
    INTVAL        i, num_classes;
    STRING       *classname;
    PMC          *classobj;

    if (PMC_IS_NULL(lookup))
        return 0;

    if (Parrot_Class_isa_pmc(interp, pmc, lookup))
        return 1;

    classobj = Parrot_oo_get_class(interp, lookup);

    if (PMC_IS_NULL(classobj))
        return 0;

    classname = VTABLE_get_string(interp, classobj);

    /* Check if the passed name is the same as the stored short name. */
    if (Parrot_str_equal(interp, classname, _proxy->name))
        return 1;

    /* Check if the class object is the same as self's class object */
    if (VTABLE_is_same(interp, pmc, classobj))
        return 1;

    /* Check if the passed name is the same as the fully qualified name. */
    if (Parrot_str_equal(interp, classname, VTABLE_get_string(interp, pmc)))
        return 1;

    /* Look in the isa hash. */
    if (parrot_hash_exists(interp, interp->vtables[_proxy->id]->isa_hash, classname))
        return 1;

    /* Iterate over all the parents and check if they respond true
     * for 'isa' on the original comparison. */
    num_classes = VTABLE_elements(interp, _proxy->parents);

    for (i = 0; i < num_classes; i++) {
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp,
            _proxy->parents, i);

        if (VTABLE_isa_pmc(interp, cur_class, lookup))
            return 1;
    }

    return 0;
#line 350 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  void 
Parrot_PMCProxy_mark(PARROT_INTERP, PMC *pmc)
{
#line 227 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes * const _pmc = PARROT_CLASS(pmc);

    if (_pmc->name)
        pobject_lives(interp, (PObj *)_pmc->name);
    if (_pmc->_namespace)
        pobject_lives(interp, (PObj *)_pmc->_namespace);
    if (_pmc->parents)
        pobject_lives(interp, (PObj *)_pmc->parents);
    if (_pmc->all_parents)
        pobject_lives(interp, (PObj *)_pmc->all_parents);
    if (_pmc->roles)
        pobject_lives(interp, (PObj *)_pmc->roles);
    if (_pmc->methods)
        pobject_lives(interp, (PObj *)_pmc->methods);
    if (_pmc->vtable_overrides)
        pobject_lives(interp, (PObj *)_pmc->vtable_overrides);
    if (_pmc->parent_overrides)
        pobject_lives(interp, (PObj *)_pmc->parent_overrides);
    if (_pmc->attrib_metadata)
        pobject_lives(interp, (PObj *)_pmc->attrib_metadata);
    if (_pmc->attrib_index)
        pobject_lives(interp, (PObj *)_pmc->attrib_index);
    if (_pmc->attrib_cache)
        pobject_lives(interp, (PObj *)_pmc->attrib_cache);
    if (_pmc->resolve_method)
        pobject_lives(interp, (PObj *)_pmc->resolve_method);
#line 383 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  INTVAL 
Parrot_PMCProxy_type(PARROT_INTERP, PMC *pmc)
{
#line 375 "./src/pmc/pmcproxy.pmc"

    const Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);
    return _class->id;
#line 392 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  void
Parrot_PMCProxy_nci_name(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 430 "./src/pmc/pmcproxy.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 447 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 422 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes * const _pmc     = PARROT_CLASS(pmc);
    STRING       * const ret_name = _pmc->name;
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *ret_name */
    /*BEGIN GENERATED ACCESSORS */
#line 462 "./src/pmc/pmcproxy.pmc"
    CTX_REG_STR(_ctx, 0) = ret_name;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto name_returns;
    /*END RETURN STRING *ret_name */
    }
#line 425 "./src/pmc/pmcproxy.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
name_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 507 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  void
Parrot_PMCProxy_nci_get_namespace(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 545 "./src/pmc/pmcproxy.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 562 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 437 "./src/pmc/pmcproxy.pmc"

    Parrot_Class_attributes * const _pmc          = PARROT_CLASS(pmc);
    PMC          * const ret_namespace = _pmc->_namespace;
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_namespace */
    /*BEGIN GENERATED ACCESSORS */
#line 577 "./src/pmc/pmcproxy.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_namespace;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_namespace_returns;
    /*END RETURN PMC *ret_namespace */
    }
#line 440 "./src/pmc/pmcproxy.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_namespace_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 622 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  void
Parrot_PMCProxy_nci_new(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 130);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 662 "./src/pmc/pmcproxy.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 679 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* args = CTX_REG_PMC(_ctx, 1);
    INTVAL got_args = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 452 "./src/pmc/pmcproxy.pmc"

    PMC * const obj = VTABLE_instantiate(interp, pmc, args);
    UNUSED(got_args);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *obj */
    /*BEGIN GENERATED ACCESSORS */
#line 696 "./src/pmc/pmcproxy.pmc"
    CTX_REG_PMC(_ctx, 0) = obj;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto new_returns;
    /*END RETURN PMC *obj */
    }
#line 455 "./src/pmc/pmcproxy.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
new_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 741 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  void
Parrot_PMCProxy_nci_methods(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 779 "./src/pmc/pmcproxy.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 796 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 467 "./src/pmc/pmcproxy.pmc"

    PMC * const ret_methods = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "methods"));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_methods */
    /*BEGIN GENERATED ACCESSORS */
#line 810 "./src/pmc/pmcproxy.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_methods;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto methods_returns;
    /*END RETURN PMC *ret_methods */
    }
#line 469 "./src/pmc/pmcproxy.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
methods_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 855 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  void
Parrot_PMCProxy_nci_parents(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 893 "./src/pmc/pmcproxy.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 910 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 481 "./src/pmc/pmcproxy.pmc"

    PMC * const ret_parents = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "parents"));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_parents */
    /*BEGIN GENERATED ACCESSORS */
#line 924 "./src/pmc/pmcproxy.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_parents;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto parents_returns;
    /*END RETURN PMC *ret_parents */
    }
#line 483 "./src/pmc/pmcproxy.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
parents_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 969 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  void
Parrot_PMCProxy_nci_inspect(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1009 "./src/pmc/pmcproxy.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1026 "./src/pmc/pmcproxy.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* what = CTX_REG_STR(_ctx, 0);
    INTVAL got_what = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 496 "./src/pmc/pmcproxy.pmc"

    /* Just delegate to the appropriate vtable method. */
    PMC * const found =
        got_what
            ? VTABLE_inspect_str(interp, pmc, what)
            : VTABLE_inspect(interp, pmc);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *found */
    /*BEGIN GENERATED ACCESSORS */
#line 1047 "./src/pmc/pmcproxy.pmc"
    CTX_REG_PMC(_ctx, 0) = found;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto inspect_returns;
    /*END RETURN PMC *found */
    }
#line 503 "./src/pmc/pmcproxy.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
inspect_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1092 "./src/pmc/pmcproxy.c"
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  PMC *
Parrot_PMCProxy_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of PMCProxy");
}
PARROT_EXPORT  FLOATVAL
Parrot_PMCProxy_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of PMCProxy");
}
PARROT_EXPORT  INTVAL
Parrot_PMCProxy_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of PMCProxy");
}
PARROT_EXPORT  PMC *
Parrot_PMCProxy_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of PMCProxy");
}
PARROT_EXPORT  STRING *
Parrot_PMCProxy_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of PMCProxy");
}
PARROT_EXPORT  FLOATVAL
Parrot_PMCProxy_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of PMCProxy");
}
PARROT_EXPORT  INTVAL
Parrot_PMCProxy_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of PMCProxy");
}
PARROT_EXPORT  PMC *
Parrot_PMCProxy_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of PMCProxy");
}
PARROT_EXPORT  STRING *
Parrot_PMCProxy_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of PMCProxy");
}
PARROT_EXPORT  void
Parrot_PMCProxy_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of PMCProxy");
}
#include "pmc_default.h"
void
Parrot_PMCProxy_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iid Sname Sfullname F_namespace Iinstantiated Fparents Fall_parents Froles Fmethods Fvtable_overrides Fattrib_metadata Fattrib_index Fattrib_cache Fresolve_method Fparent_overrides ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_PMCProxy, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Class_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Class_add_method,
        Parrot_Class_add_parent,
        Parrot_Class_add_role,
        Parrot_Class_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Class_clone,
        Parrot_Class_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_PMCProxy_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_PMCProxy_does,
        Parrot_Class_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Class_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Class_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_PMCProxy_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_PMCProxy_init,
        Parrot_PMCProxy_init_pmc,
        Parrot_PMCProxy_inspect,
        Parrot_Class_inspect_str,
        Parrot_PMCProxy_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_PMCProxy_isa,
        Parrot_PMCProxy_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_PMCProxy_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_Class_remove_attribute,
        Parrot_Class_remove_method,
        Parrot_Class_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Class_thaw,
        Parrot_Class_thawfinish,
        Parrot_PMCProxy_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Class_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_PMCProxy, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_PMCProxy_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_PMCProxy_ro_add_method,
        Parrot_PMCProxy_ro_add_parent,
        Parrot_PMCProxy_ro_add_role,
        Parrot_PMCProxy_ro_add_vtable_override,
        Parrot_PMCProxy_ro_assign_pmc,
        Parrot_PMCProxy_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Class_clone,
        Parrot_Class_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_PMCProxy_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_PMCProxy_ro_delete_keyed,
        Parrot_PMCProxy_ro_delete_keyed_int,
        Parrot_PMCProxy_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_PMCProxy_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_PMCProxy_does,
        Parrot_Class_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_PMCProxy_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Class_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Class_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_PMCProxy_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_PMCProxy_ro_i_absolute,
        Parrot_PMCProxy_ro_i_add,
        Parrot_PMCProxy_ro_i_add_float,
        Parrot_PMCProxy_ro_i_add_int,
        Parrot_PMCProxy_ro_i_bitwise_and,
        Parrot_PMCProxy_ro_i_bitwise_and_int,
        Parrot_PMCProxy_ro_i_bitwise_ands,
        Parrot_PMCProxy_ro_i_bitwise_ands_str,
        Parrot_PMCProxy_ro_i_bitwise_lsr,
        Parrot_PMCProxy_ro_i_bitwise_lsr_int,
        Parrot_PMCProxy_ro_i_bitwise_not,
        Parrot_PMCProxy_ro_i_bitwise_nots,
        Parrot_PMCProxy_ro_i_bitwise_or,
        Parrot_PMCProxy_ro_i_bitwise_or_int,
        Parrot_PMCProxy_ro_i_bitwise_ors,
        Parrot_PMCProxy_ro_i_bitwise_ors_str,
        Parrot_PMCProxy_ro_i_bitwise_shl,
        Parrot_PMCProxy_ro_i_bitwise_shl_int,
        Parrot_PMCProxy_ro_i_bitwise_shr,
        Parrot_PMCProxy_ro_i_bitwise_shr_int,
        Parrot_PMCProxy_ro_i_bitwise_xor,
        Parrot_PMCProxy_ro_i_bitwise_xor_int,
        Parrot_PMCProxy_ro_i_bitwise_xors,
        Parrot_PMCProxy_ro_i_bitwise_xors_str,
        Parrot_PMCProxy_ro_i_concatenate,
        Parrot_PMCProxy_ro_i_concatenate_str,
        Parrot_PMCProxy_ro_i_divide,
        Parrot_PMCProxy_ro_i_divide_float,
        Parrot_PMCProxy_ro_i_divide_int,
        Parrot_PMCProxy_ro_i_floor_divide,
        Parrot_PMCProxy_ro_i_floor_divide_float,
        Parrot_PMCProxy_ro_i_floor_divide_int,
        Parrot_PMCProxy_ro_i_logical_not,
        Parrot_PMCProxy_ro_i_modulus,
        Parrot_PMCProxy_ro_i_modulus_float,
        Parrot_PMCProxy_ro_i_modulus_int,
        Parrot_PMCProxy_ro_i_multiply,
        Parrot_PMCProxy_ro_i_multiply_float,
        Parrot_PMCProxy_ro_i_multiply_int,
        Parrot_PMCProxy_ro_i_neg,
        Parrot_PMCProxy_ro_i_pow,
        Parrot_PMCProxy_ro_i_pow_float,
        Parrot_PMCProxy_ro_i_pow_int,
        Parrot_PMCProxy_ro_i_repeat,
        Parrot_PMCProxy_ro_i_repeat_int,
        Parrot_PMCProxy_ro_i_subtract,
        Parrot_PMCProxy_ro_i_subtract_float,
        Parrot_PMCProxy_ro_i_subtract_int,
        Parrot_PMCProxy_ro_increment,
        Parrot_PMCProxy_init,
        Parrot_PMCProxy_init_pmc,
        Parrot_PMCProxy_inspect,
        Parrot_Class_inspect_str,
        Parrot_PMCProxy_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_PMCProxy_isa,
        Parrot_PMCProxy_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_PMCProxy_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_PMCProxy_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_PMCProxy_ro_pop_float,
        Parrot_PMCProxy_ro_pop_integer,
        Parrot_PMCProxy_ro_pop_pmc,
        Parrot_PMCProxy_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_PMCProxy_ro_push_float,
        Parrot_PMCProxy_ro_push_integer,
        Parrot_PMCProxy_ro_push_pmc,
        Parrot_PMCProxy_ro_push_string,
        Parrot_PMCProxy_ro_remove_attribute,
        Parrot_PMCProxy_ro_remove_method,
        Parrot_PMCProxy_ro_remove_parent,
        Parrot_PMCProxy_ro_remove_role,
        Parrot_PMCProxy_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_PMCProxy_ro_set_attr_keyed,
        Parrot_PMCProxy_ro_set_attr_str,
        Parrot_PMCProxy_ro_set_bignum_int,
        Parrot_PMCProxy_ro_set_bignum_num,
        Parrot_PMCProxy_ro_set_bignum_str,
        Parrot_PMCProxy_ro_set_bool,
        Parrot_PMCProxy_ro_set_integer_keyed,
        Parrot_PMCProxy_ro_set_integer_keyed_int,
        Parrot_PMCProxy_ro_set_integer_keyed_str,
        Parrot_PMCProxy_ro_set_integer_native,
        Parrot_PMCProxy_ro_set_integer_same,
        Parrot_PMCProxy_ro_set_number_keyed,
        Parrot_PMCProxy_ro_set_number_keyed_int,
        Parrot_PMCProxy_ro_set_number_keyed_str,
        Parrot_PMCProxy_ro_set_number_native,
        Parrot_PMCProxy_ro_set_number_same,
        Parrot_PMCProxy_ro_set_pmc,
        Parrot_PMCProxy_ro_set_pmc_keyed,
        Parrot_PMCProxy_ro_set_pmc_keyed_int,
        Parrot_PMCProxy_ro_set_pmc_keyed_str,
        Parrot_PMCProxy_ro_set_pointer,
        Parrot_PMCProxy_ro_set_pointer_keyed,
        Parrot_PMCProxy_ro_set_pointer_keyed_int,
        Parrot_PMCProxy_ro_set_pointer_keyed_str,
        Parrot_PMCProxy_ro_set_string_keyed,
        Parrot_PMCProxy_ro_set_string_keyed_int,
        Parrot_PMCProxy_ro_set_string_keyed_str,
        Parrot_PMCProxy_ro_set_string_native,
        Parrot_PMCProxy_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_PMCProxy_ro_shift_float,
        Parrot_PMCProxy_ro_shift_integer,
        Parrot_PMCProxy_ro_shift_pmc,
        Parrot_PMCProxy_ro_shift_string,
        Parrot_default_slice,
        Parrot_PMCProxy_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_PMCProxy_ro_thaw,
        Parrot_PMCProxy_ro_thawfinish,
        Parrot_PMCProxy_type,
        Parrot_default_type_keyed,
        Parrot_PMCProxy_ro_unshift_float,
        Parrot_PMCProxy_ro_unshift_integer,
        Parrot_PMCProxy_ro_unshift_pmc,
        Parrot_PMCProxy_ro_unshift_string,
        Parrot_Class_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "PMCProxy");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "PMCProxy")), PMCNULL);
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Class")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "PMCProxy"));
            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Class"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_name), "name");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_get_namespace), "get_namespace");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_new), "new");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_methods), "methods");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_parents), "parents");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_PMCProxy_nci_inspect), "inspect");
        {
        }
    } /* pass */
} /* Parrot_PMCProxy_class_init */
#line 521 "./src/pmc/pmcproxy.pmc"
 /* END pmclass */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_pmc.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
