/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablebooleanarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_resizablebooleanarray.h"
#include "pmc_fixedbooleanarray.h"
#include "pmc_default.h"
#include "resizablebooleanarray.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/resizablebooleanarray.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: resizablebooleanarray.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/resizablebooleanarray.pmc - resizable array for booleans only

=head1 DESCRIPTION

The C<ResizableBooleanArray PMC> implements an array of resizable size, which
stores booleans.  It uses the C<Boolean PMC> for all conversions.  The
C<ResizableBooleanArray PMC> extends the C<FixedBooleanArray PMC>.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"


#define BITS_PER_CHAR 8
/* MIN_ALLOC is 8 * BITS_PER_CHAR */
#define MIN_ALLOC 64

/* Round a given size in bits to the nearest allocation unit, then convert it
 * to bytes. */
#define ROUND_BYTES(size) (((size) / MIN_ALLOC + 1) * MIN_ALLOC / BITS_PER_CHAR)
/* Convert a size in bits to a size in bytes */
#define BITS_TO_BYTES(size) ((size) / BITS_PER_CHAR)
#line 57 "./src/pmc/resizablebooleanarray.c"
PARROT_EXPORT  PMC  *
Parrot_ResizableBooleanArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 375 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL         tail_pos, head_pos;
    unsigned char * my_bit_array, * dest_bit_array;

    PMC * const     dest = pmc_new(interp, pmc->vtable->base_type);

    GETATTR_ResizableBooleanArray_bit_array(interp, pmc, my_bit_array);
    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);

    SETATTR_ResizableBooleanArray_size(interp, dest, tail_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, dest, head_pos);

    if (my_bit_array) {
        size_t size_in_bits = tail_pos / BITS_PER_CHAR + 1;
        dest_bit_array = (unsigned char *)mem_sys_allocate(size_in_bits);
        mem_sys_memcopy(dest_bit_array, my_bit_array, size_in_bits);
    }
    else
        dest_bit_array = NULL;

    SETATTR_ResizableBooleanArray_bit_array(interp, dest, dest_bit_array);

    PObj_active_destroy_SET(dest);
    return dest;
#line 87 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizableBooleanArray_elements(PARROT_INTERP, PMC *pmc)
{
#line 344 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL tail_pos, head_pos;
    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
    return tail_pos - head_pos;
#line 98 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableBooleanArray_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 417 "./src/pmc/resizablebooleanarray.pmc"

    /* XXX Dino - I'm concerned about freezing the entire
        allocated block of memory, it's dependent on the
        BITS_PER_CHAR value.
        Maybe we need to store that during the freeze as well
        and use it during thaw?
    */

    STRING           *s;
    UINTVAL           tail_pos, rounded_size, head_pos;
    unsigned char    *bit_array;
    IMAGE_IO * const  io = info->image_io;

    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
    GETATTR_ResizableBooleanArray_bit_array(interp, pmc, bit_array);
    rounded_size = ROUND_BYTES(tail_pos);

    VTABLE_push_integer(interp, io, head_pos);
    VTABLE_push_integer(interp, io, tail_pos);

    s = Parrot_str_new(interp, (char*)bit_array, tail_pos);

    VTABLE_push_string(interp, io, s);
#line 128 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizableBooleanArray_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 361 "./src/pmc/resizablebooleanarray.pmc"

    return VTABLE_elements(interp, pmc);
#line 136 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizableBooleanArray_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 58 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL offsetkey, tail_pos, head_pos;

    /* Try to make negative index into a real index */
    if (key < 0) {
        key = VTABLE_elements(interp, pmc) + key;

        /* If it's still negative, we have a problem */
        if (key < 0)
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableBooleanArray: index out of bounds!");
    }

    /* Check if key is greater than allocated size */
    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
    offsetkey = key + head_pos;

    if (offsetkey >= tail_pos)
        return 0;

    return Parrot_FixedBooleanArray_get_integer_keyed_int(interp, pmc, offsetkey);
#line 164 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizableBooleanArray_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 207 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL new_size, tail_pos, head_pos;
    INTVAL  value;

    if (VTABLE_elements(interp, pmc) < 1)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "ResizableBooleanArray: Can't pop from an empty array!");

    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);

    new_size  = tail_pos - head_pos;
    value = VTABLE_get_integer_keyed_int(interp, pmc, new_size - 1);
    VTABLE_set_integer_native(interp, pmc, new_size - 1);

    return value;
#line 186 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableBooleanArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 185 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL tail_pos, head_pos;
    INTVAL  new_size;

    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);

    new_size = tail_pos - head_pos;
    VTABLE_set_integer_native(interp, pmc, new_size + 1);
    VTABLE_set_integer_keyed_int(interp, pmc, new_size, value);
#line 202 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableBooleanArray_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 92 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL offsetkey, tail_pos, head_pos;

    /* Try to make negative index into a real index */
    if (key < 0) {
        key = VTABLE_elements(interp, pmc) + key;

        /* If it's still negative, we have a problem */
        if (key < 0)
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableBooleanArray: index out of bounds!");
    }

    /* Check if key is greater than allocated size */
    GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
    offsetkey = key + head_pos;

    if (offsetkey >= tail_pos)
        VTABLE_set_integer_native(interp, pmc, key+1);

    Parrot_FixedBooleanArray_set_integer_keyed_int(interp, pmc, offsetkey, value);
#line 230 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableBooleanArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 126 "./src/pmc/resizablebooleanarray.pmc"


    unsigned char * bit_array;
    size_t          old_tail_pos, new_tail_pos, new_size_in_bytes, old_size_in_bytes;

    /* Size respects any existing head position offset from unshift */
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, new_tail_pos);
    GETATTR_ResizableBooleanArray_size(interp, pmc, old_tail_pos);
    new_tail_pos += size;

    /* We are already at the requested size. Yay */
    if (new_tail_pos == old_tail_pos)
        return;

    if (size < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "ResizableBooleanArray: Can't resize!");

    /* now set the new size, in bits */
    SETATTR_ResizableBooleanArray_size(interp, pmc, new_tail_pos);

    /* convert sizes to bytes */
    new_size_in_bytes = ROUND_BYTES(new_tail_pos);
    old_size_in_bytes = ROUND_BYTES(old_tail_pos);

    /* Nothing allocated yet */
    GETATTR_ResizableBooleanArray_bit_array(interp, pmc, bit_array);
    if (!bit_array) {
        SETATTR_ResizableBooleanArray_bit_array(interp, pmc,
                (unsigned char *)mem_sys_allocate_zeroed(new_size_in_bytes));

    /* The size is different, and doesn't fit within the current
     * allocation */
    }
    else if (new_size_in_bytes != old_size_in_bytes) {
        unsigned char * old_store = bit_array;
        unsigned char * new_store =
            (unsigned char *)mem_sys_allocate_zeroed(new_tail_pos);
        size_t          copy_size =
            new_size_in_bytes < old_size_in_bytes ? new_size_in_bytes : old_size_in_bytes;

        /* Replace old array with new array, and free old array */
        SETATTR_ResizableBooleanArray_bit_array(interp, pmc,
                (unsigned char *)mem_sys_memmove(
                    new_store, old_store, copy_size));
        mem_sys_free(old_store);
    }
#line 283 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizableBooleanArray_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 291 "./src/pmc/resizablebooleanarray.pmc"

    INTVAL value;
    UINTVAL tail_pos, head_pos;

    if (VTABLE_elements(interp, pmc) < 1)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "ResizableBooleanArray: Can't shift from an empty array!");

    /* Get head value */
    value = VTABLE_get_integer_keyed_int(interp, pmc, 0);

    /* Move the head position */
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc,   head_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, ++head_pos);

    /* If the head position offset is greater than our allocation unit
     * size, size this thing down */
    if (head_pos >= MIN_ALLOC) {
        /* Allocate one allocation unit less of space in new array */
        unsigned char *new_bit_array, *old_bit_array;
        size_t         new_mem_size;
        GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
        new_mem_size  = ROUND_BYTES(tail_pos - MIN_ALLOC);
        new_bit_array =
            (unsigned char *)mem_sys_allocate_zeroed(new_mem_size);

        /* Copy contents of old array to new array, move the head position
         * offset back by one allocation unit (in bytes) */
        GETATTR_ResizableBooleanArray_bit_array(interp, pmc, old_bit_array);
        mem_sys_memmove(new_bit_array, old_bit_array + (BITS_TO_BYTES(MIN_ALLOC)),
            new_mem_size);

        /* Replace old array with new array, and free old array */
        SETATTR_ResizableBooleanArray_bit_array(interp, pmc, new_bit_array);
        mem_sys_free(old_bit_array);

        /* Removed one allocation unit from the head position offset */
        SETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos - MIN_ALLOC);
        GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
        SETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos- MIN_ALLOC);
    }

    return value;
#line 332 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableBooleanArray_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 452 "./src/pmc/resizablebooleanarray.pmc"

    unsigned char   *bit_array;
    IMAGE_IO * const io       = info->image_io;
    const UINTVAL    head_pos = VTABLE_shift_integer(interp, io);
    const UINTVAL    tail_pos = VTABLE_shift_integer(interp, io);
    STRING * const   s        = VTABLE_shift_string(interp, io);

    bit_array      = (unsigned char *)mem_sys_allocate_zeroed(s->bufused);
    mem_sys_memcopy(bit_array, (unsigned char *)s->strstart, s->bufused);
    PMC_data(pmc) =
        mem_allocate_zeroed_typed(Parrot_ResizableBooleanArray_attributes);

    SETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
    SETATTR_ResizableBooleanArray_bit_array(interp, pmc, bit_array);
#line 353 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableBooleanArray_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 236 "./src/pmc/resizablebooleanarray.pmc"

    UINTVAL head_pos;
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);

    /* If the current head position offset is 0, size this thing up by one
     * allocation unit */
    if (head_pos<= 0) {

        UINTVAL         tail_pos;
        unsigned char * old_bit_array;
        size_t          old_mem_size, new_mem_size;
        unsigned char * new_bit_array;

        GETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos);
        GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos);
        GETATTR_ResizableBooleanArray_bit_array(interp, pmc, old_bit_array);

        /* Allocate an extra allocation unit of space in new array */
        new_mem_size  = ROUND_BYTES(tail_pos+ MIN_ALLOC);
        new_bit_array = (unsigned char *)mem_sys_allocate_zeroed(new_mem_size);

        /* Copy contents of old array to new array, moving the head
         * position forward by one allocation unit (in bytes). */
        old_mem_size = ROUND_BYTES(tail_pos);
        mem_sys_memmove(new_bit_array + (BITS_TO_BYTES(MIN_ALLOC)),
                old_bit_array, old_mem_size);

        /* Replace old array with new array, and free old array */
        SETATTR_ResizableBooleanArray_bit_array(interp, pmc, new_bit_array);
        mem_sys_free(old_bit_array);

        /* Added one allocation unit to the head position offset */
        SETATTR_ResizableBooleanArray_size(interp, pmc, tail_pos + MIN_ALLOC);
        SETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, head_pos + MIN_ALLOC);

    }

    /* Move the head position */
    GETATTR_ResizableBooleanArray_resize_threshold(interp, pmc,   head_pos);
    SETATTR_ResizableBooleanArray_resize_threshold(interp, pmc, --head_pos);

    /* Assign the new value as the first item */
    VTABLE_set_integer_keyed_int(interp, pmc, 0, value);
#line 402 "./src/pmc/resizablebooleanarray.c"
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  PMC *
Parrot_ResizableBooleanArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  FLOATVAL
Parrot_ResizableBooleanArray_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  INTVAL
Parrot_ResizableBooleanArray_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  PMC *
Parrot_ResizableBooleanArray_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  STRING *
Parrot_ResizableBooleanArray_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  FLOATVAL
Parrot_ResizableBooleanArray_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  INTVAL
Parrot_ResizableBooleanArray_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  PMC *
Parrot_ResizableBooleanArray_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  STRING *
Parrot_ResizableBooleanArray_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ResizableBooleanArray");
}
PARROT_EXPORT  void
Parrot_ResizableBooleanArray_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ResizableBooleanArray");
}
#include "pmc_default.h"
void
Parrot_ResizableBooleanArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":size :resize_threshold :bit_array ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_ResizableBooleanArray, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_ResizableBooleanArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_ResizableBooleanArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_ResizableBooleanArray_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_class,
        Parrot_ResizableBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_ResizableBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_FixedBooleanArray_get_string,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_ResizableBooleanArray_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_ResizableBooleanArray_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedBooleanArray_set_integer_keyed,
        Parrot_ResizableBooleanArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_ResizableBooleanArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedBooleanArray_set_number_keyed,
        Parrot_FixedBooleanArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedBooleanArray_set_pmc_keyed,
        Parrot_FixedBooleanArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedBooleanArray_set_string_keyed,
        Parrot_FixedBooleanArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_ResizableBooleanArray_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_ResizableBooleanArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_ResizableBooleanArray_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_ResizableBooleanArray, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_ResizableBooleanArray_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_ResizableBooleanArray_ro_add_method,
        Parrot_ResizableBooleanArray_ro_add_parent,
        Parrot_ResizableBooleanArray_ro_add_role,
        Parrot_ResizableBooleanArray_ro_add_vtable_override,
        Parrot_ResizableBooleanArray_ro_assign_pmc,
        Parrot_ResizableBooleanArray_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_ResizableBooleanArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_ResizableBooleanArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizableBooleanArray_ro_delete_keyed,
        Parrot_ResizableBooleanArray_ro_delete_keyed_int,
        Parrot_ResizableBooleanArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedBooleanArray_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_ResizableBooleanArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ResizableBooleanArray_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_ResizableBooleanArray_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedBooleanArray_get_bool,
        Parrot_default_get_class,
        Parrot_ResizableBooleanArray_get_integer,
        Parrot_FixedBooleanArray_get_integer_keyed,
        Parrot_ResizableBooleanArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_FixedBooleanArray_get_number_keyed,
        Parrot_FixedBooleanArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedBooleanArray_get_pmc_keyed,
        Parrot_FixedBooleanArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_FixedBooleanArray_get_string,
        Parrot_FixedBooleanArray_get_string_keyed,
        Parrot_FixedBooleanArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_ResizableBooleanArray_ro_i_absolute,
        Parrot_ResizableBooleanArray_ro_i_add,
        Parrot_ResizableBooleanArray_ro_i_add_float,
        Parrot_ResizableBooleanArray_ro_i_add_int,
        Parrot_ResizableBooleanArray_ro_i_bitwise_and,
        Parrot_ResizableBooleanArray_ro_i_bitwise_and_int,
        Parrot_ResizableBooleanArray_ro_i_bitwise_ands,
        Parrot_ResizableBooleanArray_ro_i_bitwise_ands_str,
        Parrot_ResizableBooleanArray_ro_i_bitwise_lsr,
        Parrot_ResizableBooleanArray_ro_i_bitwise_lsr_int,
        Parrot_ResizableBooleanArray_ro_i_bitwise_not,
        Parrot_ResizableBooleanArray_ro_i_bitwise_nots,
        Parrot_ResizableBooleanArray_ro_i_bitwise_or,
        Parrot_ResizableBooleanArray_ro_i_bitwise_or_int,
        Parrot_ResizableBooleanArray_ro_i_bitwise_ors,
        Parrot_ResizableBooleanArray_ro_i_bitwise_ors_str,
        Parrot_ResizableBooleanArray_ro_i_bitwise_shl,
        Parrot_ResizableBooleanArray_ro_i_bitwise_shl_int,
        Parrot_ResizableBooleanArray_ro_i_bitwise_shr,
        Parrot_ResizableBooleanArray_ro_i_bitwise_shr_int,
        Parrot_ResizableBooleanArray_ro_i_bitwise_xor,
        Parrot_ResizableBooleanArray_ro_i_bitwise_xor_int,
        Parrot_ResizableBooleanArray_ro_i_bitwise_xors,
        Parrot_ResizableBooleanArray_ro_i_bitwise_xors_str,
        Parrot_ResizableBooleanArray_ro_i_concatenate,
        Parrot_ResizableBooleanArray_ro_i_concatenate_str,
        Parrot_ResizableBooleanArray_ro_i_divide,
        Parrot_ResizableBooleanArray_ro_i_divide_float,
        Parrot_ResizableBooleanArray_ro_i_divide_int,
        Parrot_ResizableBooleanArray_ro_i_floor_divide,
        Parrot_ResizableBooleanArray_ro_i_floor_divide_float,
        Parrot_ResizableBooleanArray_ro_i_floor_divide_int,
        Parrot_ResizableBooleanArray_ro_i_logical_not,
        Parrot_ResizableBooleanArray_ro_i_modulus,
        Parrot_ResizableBooleanArray_ro_i_modulus_float,
        Parrot_ResizableBooleanArray_ro_i_modulus_int,
        Parrot_ResizableBooleanArray_ro_i_multiply,
        Parrot_ResizableBooleanArray_ro_i_multiply_float,
        Parrot_ResizableBooleanArray_ro_i_multiply_int,
        Parrot_ResizableBooleanArray_ro_i_neg,
        Parrot_ResizableBooleanArray_ro_i_pow,
        Parrot_ResizableBooleanArray_ro_i_pow_float,
        Parrot_ResizableBooleanArray_ro_i_pow_int,
        Parrot_ResizableBooleanArray_ro_i_repeat,
        Parrot_ResizableBooleanArray_ro_i_repeat_int,
        Parrot_ResizableBooleanArray_ro_i_subtract,
        Parrot_ResizableBooleanArray_ro_i_subtract_float,
        Parrot_ResizableBooleanArray_ro_i_subtract_int,
        Parrot_ResizableBooleanArray_ro_increment,
        Parrot_FixedBooleanArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_ResizableBooleanArray_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_ResizableBooleanArray_ro_pop_float,
        Parrot_ResizableBooleanArray_ro_pop_integer,
        Parrot_ResizableBooleanArray_ro_pop_pmc,
        Parrot_ResizableBooleanArray_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_ResizableBooleanArray_ro_push_float,
        Parrot_ResizableBooleanArray_ro_push_integer,
        Parrot_ResizableBooleanArray_ro_push_pmc,
        Parrot_ResizableBooleanArray_ro_push_string,
        Parrot_ResizableBooleanArray_ro_remove_attribute,
        Parrot_ResizableBooleanArray_ro_remove_method,
        Parrot_ResizableBooleanArray_ro_remove_parent,
        Parrot_ResizableBooleanArray_ro_remove_role,
        Parrot_ResizableBooleanArray_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_ResizableBooleanArray_ro_set_attr_keyed,
        Parrot_ResizableBooleanArray_ro_set_attr_str,
        Parrot_ResizableBooleanArray_ro_set_bignum_int,
        Parrot_ResizableBooleanArray_ro_set_bignum_num,
        Parrot_ResizableBooleanArray_ro_set_bignum_str,
        Parrot_ResizableBooleanArray_ro_set_bool,
        Parrot_ResizableBooleanArray_ro_set_integer_keyed,
        Parrot_ResizableBooleanArray_ro_set_integer_keyed_int,
        Parrot_ResizableBooleanArray_ro_set_integer_keyed_str,
        Parrot_ResizableBooleanArray_ro_set_integer_native,
        Parrot_ResizableBooleanArray_ro_set_integer_same,
        Parrot_ResizableBooleanArray_ro_set_number_keyed,
        Parrot_ResizableBooleanArray_ro_set_number_keyed_int,
        Parrot_ResizableBooleanArray_ro_set_number_keyed_str,
        Parrot_ResizableBooleanArray_ro_set_number_native,
        Parrot_ResizableBooleanArray_ro_set_number_same,
        Parrot_ResizableBooleanArray_ro_set_pmc,
        Parrot_ResizableBooleanArray_ro_set_pmc_keyed,
        Parrot_ResizableBooleanArray_ro_set_pmc_keyed_int,
        Parrot_ResizableBooleanArray_ro_set_pmc_keyed_str,
        Parrot_ResizableBooleanArray_ro_set_pointer,
        Parrot_ResizableBooleanArray_ro_set_pointer_keyed,
        Parrot_ResizableBooleanArray_ro_set_pointer_keyed_int,
        Parrot_ResizableBooleanArray_ro_set_pointer_keyed_str,
        Parrot_ResizableBooleanArray_ro_set_string_keyed,
        Parrot_ResizableBooleanArray_ro_set_string_keyed_int,
        Parrot_ResizableBooleanArray_ro_set_string_keyed_str,
        Parrot_ResizableBooleanArray_ro_set_string_native,
        Parrot_ResizableBooleanArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizableBooleanArray_ro_shift_float,
        Parrot_ResizableBooleanArray_ro_shift_integer,
        Parrot_ResizableBooleanArray_ro_shift_pmc,
        Parrot_ResizableBooleanArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_ResizableBooleanArray_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_ResizableBooleanArray_ro_thaw,
        Parrot_ResizableBooleanArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_ResizableBooleanArray_ro_unshift_float,
        Parrot_ResizableBooleanArray_ro_unshift_integer,
        Parrot_ResizableBooleanArray_ro_unshift_pmc,
        Parrot_ResizableBooleanArray_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "ResizableBooleanArray");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "array");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "ResizableBooleanArray")), PMCNULL);
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "FixedBooleanArray")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "ResizableBooleanArray"));
            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "FixedBooleanArray"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_ResizableBooleanArray_class_init */
#line 467 "./src/pmc/resizablebooleanarray.pmc"
  /* pmclass */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11

Changed allocator to double size - Matt Fowles 2004-06-15

Added push_integer               - Bernhard Schmalhofer 2004-10-17

Changed allocation code, added   - Dino Morelli 2005-06-10
  push_, pop_, shift_,
  unshift_integer, freeze, thaw

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
