/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablepmcarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_resizablepmcarray.h"
#include "pmc_fixedpmcarray.h"
#include "pmc_default.h"
#include "resizablepmcarray.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/resizablepmcarray.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: resizablepmcarray.pmc 37267 2009-03-10 10:01:14Z cotto $

=head1 NAME

src/pmc/resizablepmcarray.pmc - resizable array for PMCs only

=head1 DESCRIPTION

This class, ResizablePMCArray, implements an resizable array which stores PMCs.
It puts things into Integer, Float, or String PMCs as appropriate.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"

#define PMC_size(x)      ((Parrot_ResizablePMCArray_attributes *)PMC_data(x))->size
#define PMC_array(x)     ((Parrot_ResizablePMCArray_attributes *)PMC_data(x))->pmc_array
#define PMC_threshold(x) ((Parrot_ResizablePMCArray_attributes *)PMC_data(x))->resize_threshold
#line 50 "./src/pmc/resizablepmcarray.c"
PARROT_EXPORT  PMC  *
Parrot_ResizablePMCArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 589 "./src/pmc/resizablepmcarray.pmc"

    PMC *copy = Parrot_FixedPMCArray_clone(interp, pmc);

    /* copy trimmed extra space */
    PMC_threshold(copy) = PMC_size(pmc);

    return copy;
#line 62 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizablePMCArray_defined_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 332 "./src/pmc/resizablepmcarray.pmc"

    PMC *val;

    if (key < 0)
        key += PMC_size(pmc);

    if (key < 0 || key >= PMC_size(pmc))
        return 0;

    val = VTABLE_get_pmc_keyed_int(interp, pmc, key);

    if (PMC_IS_NULL(val))
        return 0;

    return VTABLE_defined(interp, val);
#line 83 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 280 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  i;
    INTVAL  idx  = key_integer(interp, key);
    INTVAL  n    = PMC_size(pmc);
    PMC   **data = PMC_array(pmc);

    for (i = idx; i < n - 1; ++i) {
        data[i] = data[i + 1];
    }

    PMC_size(pmc)--;
#line 100 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizablePMCArray_exists_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 317 "./src/pmc/resizablepmcarray.pmc"

    INTVAL ix = key_integer(interp, key);
    return VTABLE_exists_keyed_int(interp, pmc, ix);
#line 109 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizablePMCArray_exists_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 304 "./src/pmc/resizablepmcarray.pmc"

    PMC **data;

    if (key < 0)
        key += PMC_size(pmc);

    if (key < 0 || key >= PMC_size(pmc))
        return 0;

    data = PMC_array(pmc);
    return !PMC_IS_NULL(data[key]);
#line 126 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  PMC  *
Parrot_ResizablePMCArray_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 223 "./src/pmc/resizablepmcarray.pmc"

    PMC **data;

    if (key < 0)
        key += PMC_size(pmc);

    if (key < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "ResizablePMCArray: index out of bounds!");

    if (key >= PMC_size(pmc))
        return PMCNULL;

    data = PMC_array(pmc);

    if (PMC_IS_NULL(data[key]))
        return PMCNULL;

    return data[key];
#line 151 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_ResizablePMCArray_get_repr(PARROT_INTERP, PMC *pmc)
{
#line 684 "./src/pmc/resizablepmcarray.pmc"


    INTVAL  j;
    INTVAL  n   = VTABLE_elements(interp, pmc);
    STRING *res = CONST_STRING(interp, "[ ");

    for (j = 0; j < n; ++j) {
        PMC *val = VTABLE_get_pmc_keyed_int(interp, pmc, j);
        res      = Parrot_str_append(interp, res, VTABLE_get_repr(interp, val));

        if (j < n - 1)
            res = Parrot_str_append(interp, res, CONST_STRING(interp, ", "));
    }

    return Parrot_str_append(interp, res, CONST_STRING(interp, " ]"));
#line 172 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_init(PARROT_INTERP, PMC *pmc)
{
#line 41 "./src/pmc/resizablepmcarray.pmc"

    Parrot_ResizablePMCArray_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_ResizablePMCArray_attributes);

    PMC_data(pmc) = attrs;
    PObj_custom_mark_destroy_SETALL(pmc);
#line 184 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizablePMCArray_is_equal(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 608 "./src/pmc/resizablepmcarray.pmc"

    INTVAL j, n;

    if (value->vtable->base_type != enum_class_ResizablePMCArray)
        return 0;

    n = VTABLE_elements(interp, pmc);

    if (VTABLE_elements(interp, value) != n)
        return 0;

    for (j = 0; j < n; ++j) {
        PMC *item1 = VTABLE_get_pmc_keyed_int(interp, pmc, j);
        PMC *item2 = VTABLE_get_pmc_keyed_int(interp, value, j);
        INTVAL result;

        if (item1 == item2)
            continue;

        Parrot_mmd_multi_dispatch_from_c_args(interp,
                "is_equal", "PP->I", item1, item2, &result);

        if (!result)
            return 0;
    }

    return 1;
#line 217 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_ResizablePMCArray_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 424 "./src/pmc/resizablepmcarray.pmc"


    INTVAL   size = PMC_size(pmc);
    PMC     *data;

    if (0 == size)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizablePMCArray: Can't pop from an empty array!");

    data           = PMC_array(pmc)[--size];
    PMC_size(pmc) = size;

    return VTABLE_get_number(interp, data);
#line 236 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizablePMCArray_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 439 "./src/pmc/resizablepmcarray.pmc"


    INTVAL  size = PMC_size(pmc);
    PMC    *data;

    if (0 == size)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizablePMCArray: Can't pop from an empty array!");

    data           = PMC_array(pmc)[--size];
    PMC_size(pmc) = size;

    return VTABLE_get_integer(interp, data);
#line 255 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  PMC  *
Parrot_ResizablePMCArray_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 454 "./src/pmc/resizablepmcarray.pmc"


    INTVAL size = PMC_size(pmc);
    PMC   *data;

    if (0 == size)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizablePMCArray: Can't pop from an empty array!");

    data           = PMC_array(pmc)[--size];
    PMC_size(pmc) = size;

    return data;
#line 274 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_ResizablePMCArray_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 469 "./src/pmc/resizablepmcarray.pmc"


    INTVAL  size = PMC_size(pmc);
    PMC    *data;

    if (0 == size)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizablePMCArray: Can't pop from an empty array!");

    data           = PMC_array(pmc)[--size];
    PMC_size(pmc) = size;

    return VTABLE_get_string(interp, data);
#line 293 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 366 "./src/pmc/resizablepmcarray.pmc"


    INTVAL size = PMC_size(pmc);
    PMC   *val  = pmc_new(interp, enum_class_Float);

    VTABLE_set_number_native(interp, val, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, size, val);

    return;
#line 308 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 377 "./src/pmc/resizablepmcarray.pmc"


    INTVAL size = PMC_size(pmc);
    PMC   *val  = pmc_new(interp, enum_class_Integer);

    VTABLE_set_integer_native(interp, val, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, size, val);

    return;
#line 323 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 388 "./src/pmc/resizablepmcarray.pmc"


    INTVAL size = PMC_size(pmc);
    VTABLE_set_integer_native(interp, pmc, size + 1);
    ((PMC **)PMC_array(pmc))[size] = value;

    return;
#line 336 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 397 "./src/pmc/resizablepmcarray.pmc"


    INTVAL size = PMC_size(pmc);
    PMC   *val  = pmc_new(interp, enum_class_String);

    VTABLE_assign_string_native(interp, val, value);
    VTABLE_set_pmc_keyed_int(interp, pmc, size, val);

    return;
#line 351 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL size)
{
#line 59 "./src/pmc/resizablepmcarray.pmc"

    if (size < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizablePMCArray: Can't resize!");

    if (!PMC_array(pmc)) {
        /* empty - used fixed routine */
        if (size < 8) {

            Parrot_FixedPMCArray_set_integer_native(interp, pmc, 8);
            PMC_size(pmc)      = size;
            PMC_threshold(pmc) = 8;

        }
        else {

            Parrot_FixedPMCArray_set_integer_native(interp, pmc, size);
            PMC_threshold(pmc) = size;
        }
    }
    else if (size <= PMC_threshold(pmc)) {

        PMC_size(pmc) = size;
        /* we could shrink here if necessary */
        return;
    }
    else {

        INTVAL i, cur, needed;
        i = cur = PMC_threshold(pmc);
        if (cur < 8192)
            cur = size < 2 * cur ? 2 * cur : size;
        else {
            needed = size - cur;
            cur   += needed + 4096;
            cur   &= ~0xfff;
        }

        PMC_array(pmc) = (PMC **)mem_sys_realloc(PMC_array(pmc),
                cur * sizeof (PMC *));

        for (; i < cur; i++) {
            (PMC_array(pmc))[i] = PMCNULL;
        }

        PMC_threshold(pmc) = cur;
        PMC_size(pmc)      = size;
    }
#line 405 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_set_pmc_keyed(PARROT_INTERP, PMC *pmc, PMC *key, PMC *src)
{
#line 276 "./src/pmc/resizablepmcarray.pmc"

    Parrot_FixedPMCArray_set_pmc_keyed(interp, pmc, key, src);
#line 413 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *src)
{
#line 258 "./src/pmc/resizablepmcarray.pmc"

    PMC **data;

    if (key < 0)
        key += PMC_size(pmc);

    if (key < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "ResizablePMCArray: index out of bounds!");

    if (key >= PMC_size(pmc))
        VTABLE_set_integer_native(interp, pmc, key+1);

    data      = PMC_array(pmc);
    GC_WRITE_BARRIER(interp, pmc, data[key], src);
    data[key] = src;
#line 435 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_ResizablePMCArray_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 128 "./src/pmc/resizablepmcarray.pmc"

    INTVAL    size = PMC_size(pmc);
    PMC      *data;
    PMC     **item;
    FLOATVAL  value;

    if (0 == size)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizablePMCArray: Can't shift from an empty array!");

    item           = PMC_array(pmc);
    data           = item[0];
    value          = VTABLE_get_number(interp, data);
    PMC_size(pmc) = --size;

    mem_sys_memmove(item, item + 1, size * sizeof (PMC *));

    item[size] = PMCNULL;

    return value;
#line 461 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizablePMCArray_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 150 "./src/pmc/resizablepmcarray.pmc"

    INTVAL    size = PMC_size(pmc);
    PMC      *data;
    PMC     **item;
    INTVAL    value;

    if (0 == size)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizablePMCArray: Can't shift from an empty array!");

    item           = PMC_array(pmc);
    data           = item[0];
    value          = VTABLE_get_integer(interp, data);
    PMC_size(pmc) = --size;

    mem_sys_memmove(item, item + 1, size * sizeof (PMC*));
    item[size] = PMCNULL;

    return value;
#line 486 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  PMC  *
Parrot_ResizablePMCArray_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 171 "./src/pmc/resizablepmcarray.pmc"

    INTVAL  size = PMC_size(pmc);
    PMC    *data;
    PMC   **item;

    if (0 == size)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizablePMCArray: Can't shift from an empty array!");

    item           = PMC_array(pmc);
    data           = item[0];
    PMC_size(pmc) = --size;

    mem_sys_memmove(item, item + 1, size * sizeof (PMC *));
    item[size] = PMCNULL;

    return data;
#line 509 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_ResizablePMCArray_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 190 "./src/pmc/resizablepmcarray.pmc"

    INTVAL   size = PMC_size(pmc);
    PMC     *data;
    PMC    **item;
    STRING  *value;

    if (0 == size)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizablePMCArray: Can't shift from an empty array!");

    item           = PMC_array(pmc);
    data           = item[0];
    value          = VTABLE_get_string(interp, data);
    PMC_size(pmc) = --size;

    mem_sys_memmove(item, item + 1, size * sizeof (PMC *));

    item[size] = PMCNULL;

    return value;
#line 535 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
#line 717 "./src/pmc/resizablepmcarray.pmc"


    const INTVAL length = VTABLE_elements(interp, pmc);
    const INTVAL elems  = VTABLE_elements(interp, value);
    INTVAL       shift  = elems - count;
    INTVAL       i;

    /* start from end? */
    if (offset < 0)
        offset += length;

    if (offset < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "illegal splice offset\n");

    /* shrink the array */
    if (shift < 0) {
        /* start at offset so we don't overwrite values we'll need */
        for (i = offset + count; i < length; i++)
            VTABLE_set_pmc_keyed_int(interp, pmc, i + shift,
                VTABLE_get_pmc_keyed_int(interp, pmc, i));

        VTABLE_set_integer_native(interp, pmc, length + shift);
    }
    /* grow the array */
    else if (shift > 0) {
        VTABLE_set_integer_native(interp, pmc, length + shift);

        /* move the existing values */
        /* start at length-1 so we don't overwrite values we'll need */
        for (i = length - 1; i >= offset; i--)
            VTABLE_set_pmc_keyed_int(interp, pmc, i + shift,
                VTABLE_get_pmc_keyed_int(interp, pmc, i));
    }

    /* copy the new values */
    for (i = 0; i < elems; i++)
        VTABLE_set_pmc_keyed_int(interp, pmc, i + offset,
            VTABLE_get_pmc_keyed_int(interp, value, i));
#line 580 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 501 "./src/pmc/resizablepmcarray.pmc"


    INTVAL  size = PMC_size(pmc);
    PMC    *val  = pmc_new(interp, enum_class_Float);
    PMC   **data;
    INTVAL  i;

    VTABLE_set_number_native(interp, val, value);
    VTABLE_set_integer_native(interp, pmc, size + 1);

    data = PMC_array(pmc);

    for (i = size; i; --i)
        data[i] = data[i - 1];

    data[0] = val;

    return;
#line 604 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 521 "./src/pmc/resizablepmcarray.pmc"


    INTVAL  size = PMC_size(pmc);
    PMC    *val  = pmc_new(interp, enum_class_Integer);
    PMC    **data;
    INTVAL   i;

    VTABLE_set_integer_native(interp, val, value);
    VTABLE_set_integer_native(interp, pmc, size + 1);

    data = PMC_array(pmc);

    for (i = size; i; --i)
        data[i] = data[i - 1];

    data[0] = val;

    return;
#line 628 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 541 "./src/pmc/resizablepmcarray.pmc"


    INTVAL  size = PMC_size(pmc);
    PMC   **data;
    INTVAL  i;

    VTABLE_set_integer_native(interp, pmc, size + 1);

    data = PMC_array(pmc);

    for (i = size; i; --i)
        data[i] = data[i - 1];

    data[0] = value;

    return;
#line 650 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizablePMCArray_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 559 "./src/pmc/resizablepmcarray.pmc"


    INTVAL  size = PMC_size(pmc);
    PMC    *val  = pmc_new(interp, enum_class_String);
    PMC   **data;
    INTVAL  i;

    VTABLE_set_string_native(interp, val, value);
    VTABLE_set_integer_native(interp, pmc, size + 1);

    data = PMC_array(pmc);

    for (i = size; i; --i)
        data[i] = data[i - 1];

    data[0] = val;

    return;
#line 674 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_nci_append(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 713 "./src/pmc/resizablepmcarray.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 730 "./src/pmc/resizablepmcarray.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* other = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 647 "./src/pmc/resizablepmcarray.pmc"


    INTVAL i;
    INTVAL n = VTABLE_elements(interp, pmc);
    INTVAL m = VTABLE_elements(interp, other);

    if (!m)
        #line 221 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*BEGIN RETURN void */
    goto no_return;
    /*END RETURN void */
#line 654 "./src/pmc/resizablepmcarray.pmc"


    /* pre-size it */
    VTABLE_set_integer_native(interp, pmc, n + m);

    if (other->vtable->base_type == pmc->vtable->base_type
    ||  other->vtable->base_type == enum_class_FixedPMCArray) {
        PMC **other_data = PMC_array(other);
        PMC **this_data  = PMC_array(pmc);

        /* libc is faster at copying data than a manual loop here */
        memmove(this_data + n, other_data, m  * sizeof (PMC *));
    }
    else {
        PMC **this_data = PMC_array(pmc);

        for (i = 0; i < m; ++i)
            this_data[n + i] = VTABLE_get_pmc_keyed_int(interp, other, i);
    }
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
append_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 796 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_nci_shift(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 834 "./src/pmc/resizablepmcarray.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 851 "./src/pmc/resizablepmcarray.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 771 "./src/pmc/resizablepmcarray.pmc"

    PMC *value = VTABLE_shift_pmc(interp, pmc);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *value */
    /*BEGIN GENERATED ACCESSORS */
#line 865 "./src/pmc/resizablepmcarray.pmc"
    CTX_REG_PMC(_ctx, 0) = value;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto shift_returns;
    /*END RETURN PMC *value */
    }
#line 773 "./src/pmc/resizablepmcarray.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
shift_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 910 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_nci_pop(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 948 "./src/pmc/resizablepmcarray.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 965 "./src/pmc/resizablepmcarray.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 776 "./src/pmc/resizablepmcarray.pmc"

    PMC *value = VTABLE_pop_pmc(interp, pmc);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *value */
    /*BEGIN GENERATED ACCESSORS */
#line 979 "./src/pmc/resizablepmcarray.pmc"
    CTX_REG_PMC(_ctx, 0) = value;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto pop_returns;
    /*END RETURN PMC *value */
    }
#line 778 "./src/pmc/resizablepmcarray.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
pop_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1024 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_nci_unshift(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1063 "./src/pmc/resizablepmcarray.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1080 "./src/pmc/resizablepmcarray.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* value = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 793 "./src/pmc/resizablepmcarray.pmc"

    VTABLE_unshift_pmc(interp, pmc, value);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1105 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_nci_push(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1144 "./src/pmc/resizablepmcarray.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1161 "./src/pmc/resizablepmcarray.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* value = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 797 "./src/pmc/resizablepmcarray.pmc"

    VTABLE_push_pmc(interp, pmc, value);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1186 "./src/pmc/resizablepmcarray.c"
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  PMC *
Parrot_ResizablePMCArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  FLOATVAL
Parrot_ResizablePMCArray_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  INTVAL
Parrot_ResizablePMCArray_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  PMC *
Parrot_ResizablePMCArray_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  STRING *
Parrot_ResizablePMCArray_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  FLOATVAL
Parrot_ResizablePMCArray_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  INTVAL
Parrot_ResizablePMCArray_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  PMC *
Parrot_ResizablePMCArray_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  STRING *
Parrot_ResizablePMCArray_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ResizablePMCArray");
}
PARROT_EXPORT  void
Parrot_ResizablePMCArray_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ResizablePMCArray");
}
#include "pmc_default.h"
void
Parrot_ResizablePMCArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Isize :pmc_array Iresize_threshold ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_ResizablePMCArray, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_ResizablePMCArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_ResizablePMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizablePMCArray_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_FixedPMCArray_elements,
        Parrot_ResizablePMCArray_exists_keyed,
        Parrot_ResizablePMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_FixedPMCArray_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedPMCArray_get_integer,
        Parrot_FixedPMCArray_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_get_namespace,
        Parrot_FixedPMCArray_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedPMCArray_get_pmc_keyed,
        Parrot_ResizablePMCArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_ResizablePMCArray_get_repr,
        Parrot_FixedPMCArray_get_string,
        Parrot_FixedPMCArray_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_ResizablePMCArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_ResizablePMCArray_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_FixedPMCArray_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_ResizablePMCArray_pop_float,
        Parrot_ResizablePMCArray_pop_integer,
        Parrot_ResizablePMCArray_pop_pmc,
        Parrot_ResizablePMCArray_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_ResizablePMCArray_push_float,
        Parrot_ResizablePMCArray_push_integer,
        Parrot_ResizablePMCArray_push_pmc,
        Parrot_ResizablePMCArray_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedPMCArray_set_integer_keyed,
        Parrot_FixedPMCArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_ResizablePMCArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedPMCArray_set_number_keyed,
        Parrot_FixedPMCArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_FixedPMCArray_set_pmc,
        Parrot_ResizablePMCArray_set_pmc_keyed,
        Parrot_ResizablePMCArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedPMCArray_set_string_keyed,
        Parrot_FixedPMCArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizablePMCArray_shift_float,
        Parrot_ResizablePMCArray_shift_integer,
        Parrot_ResizablePMCArray_shift_pmc,
        Parrot_ResizablePMCArray_shift_string,
        Parrot_FixedPMCArray_slice,
        Parrot_ResizablePMCArray_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_FixedPMCArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_ResizablePMCArray_unshift_float,
        Parrot_ResizablePMCArray_unshift_integer,
        Parrot_ResizablePMCArray_unshift_pmc,
        Parrot_ResizablePMCArray_unshift_string,
        Parrot_FixedPMCArray_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_ResizablePMCArray, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_ResizablePMCArray_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_ResizablePMCArray_ro_add_method,
        Parrot_ResizablePMCArray_ro_add_parent,
        Parrot_ResizablePMCArray_ro_add_role,
        Parrot_ResizablePMCArray_ro_add_vtable_override,
        Parrot_ResizablePMCArray_ro_assign_pmc,
        Parrot_ResizablePMCArray_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_ResizablePMCArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_ResizablePMCArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_ResizablePMCArray_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizablePMCArray_ro_delete_keyed,
        Parrot_ResizablePMCArray_ro_delete_keyed_int,
        Parrot_ResizablePMCArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedPMCArray_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_FixedPMCArray_elements,
        Parrot_ResizablePMCArray_exists_keyed,
        Parrot_ResizablePMCArray_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ResizablePMCArray_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_FixedPMCArray_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedPMCArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedPMCArray_get_integer,
        Parrot_FixedPMCArray_get_integer_keyed,
        Parrot_FixedPMCArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedPMCArray_get_iter,
        Parrot_default_get_namespace,
        Parrot_FixedPMCArray_get_number,
        Parrot_FixedPMCArray_get_number_keyed,
        Parrot_FixedPMCArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedPMCArray_get_pmc_keyed,
        Parrot_ResizablePMCArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_ResizablePMCArray_get_repr,
        Parrot_FixedPMCArray_get_string,
        Parrot_FixedPMCArray_get_string_keyed,
        Parrot_FixedPMCArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_ResizablePMCArray_ro_i_absolute,
        Parrot_ResizablePMCArray_ro_i_add,
        Parrot_ResizablePMCArray_ro_i_add_float,
        Parrot_ResizablePMCArray_ro_i_add_int,
        Parrot_ResizablePMCArray_ro_i_bitwise_and,
        Parrot_ResizablePMCArray_ro_i_bitwise_and_int,
        Parrot_ResizablePMCArray_ro_i_bitwise_ands,
        Parrot_ResizablePMCArray_ro_i_bitwise_ands_str,
        Parrot_ResizablePMCArray_ro_i_bitwise_lsr,
        Parrot_ResizablePMCArray_ro_i_bitwise_lsr_int,
        Parrot_ResizablePMCArray_ro_i_bitwise_not,
        Parrot_ResizablePMCArray_ro_i_bitwise_nots,
        Parrot_ResizablePMCArray_ro_i_bitwise_or,
        Parrot_ResizablePMCArray_ro_i_bitwise_or_int,
        Parrot_ResizablePMCArray_ro_i_bitwise_ors,
        Parrot_ResizablePMCArray_ro_i_bitwise_ors_str,
        Parrot_ResizablePMCArray_ro_i_bitwise_shl,
        Parrot_ResizablePMCArray_ro_i_bitwise_shl_int,
        Parrot_ResizablePMCArray_ro_i_bitwise_shr,
        Parrot_ResizablePMCArray_ro_i_bitwise_shr_int,
        Parrot_ResizablePMCArray_ro_i_bitwise_xor,
        Parrot_ResizablePMCArray_ro_i_bitwise_xor_int,
        Parrot_ResizablePMCArray_ro_i_bitwise_xors,
        Parrot_ResizablePMCArray_ro_i_bitwise_xors_str,
        Parrot_ResizablePMCArray_ro_i_concatenate,
        Parrot_ResizablePMCArray_ro_i_concatenate_str,
        Parrot_ResizablePMCArray_ro_i_divide,
        Parrot_ResizablePMCArray_ro_i_divide_float,
        Parrot_ResizablePMCArray_ro_i_divide_int,
        Parrot_ResizablePMCArray_ro_i_floor_divide,
        Parrot_ResizablePMCArray_ro_i_floor_divide_float,
        Parrot_ResizablePMCArray_ro_i_floor_divide_int,
        Parrot_ResizablePMCArray_ro_i_logical_not,
        Parrot_ResizablePMCArray_ro_i_modulus,
        Parrot_ResizablePMCArray_ro_i_modulus_float,
        Parrot_ResizablePMCArray_ro_i_modulus_int,
        Parrot_ResizablePMCArray_ro_i_multiply,
        Parrot_ResizablePMCArray_ro_i_multiply_float,
        Parrot_ResizablePMCArray_ro_i_multiply_int,
        Parrot_ResizablePMCArray_ro_i_neg,
        Parrot_ResizablePMCArray_ro_i_pow,
        Parrot_ResizablePMCArray_ro_i_pow_float,
        Parrot_ResizablePMCArray_ro_i_pow_int,
        Parrot_ResizablePMCArray_ro_i_repeat,
        Parrot_ResizablePMCArray_ro_i_repeat_int,
        Parrot_ResizablePMCArray_ro_i_subtract,
        Parrot_ResizablePMCArray_ro_i_subtract_float,
        Parrot_ResizablePMCArray_ro_i_subtract_int,
        Parrot_ResizablePMCArray_ro_increment,
        Parrot_ResizablePMCArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_ResizablePMCArray_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_FixedPMCArray_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_ResizablePMCArray_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_ResizablePMCArray_ro_pop_float,
        Parrot_ResizablePMCArray_ro_pop_integer,
        Parrot_ResizablePMCArray_ro_pop_pmc,
        Parrot_ResizablePMCArray_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_ResizablePMCArray_ro_push_float,
        Parrot_ResizablePMCArray_ro_push_integer,
        Parrot_ResizablePMCArray_ro_push_pmc,
        Parrot_ResizablePMCArray_ro_push_string,
        Parrot_ResizablePMCArray_ro_remove_attribute,
        Parrot_ResizablePMCArray_ro_remove_method,
        Parrot_ResizablePMCArray_ro_remove_parent,
        Parrot_ResizablePMCArray_ro_remove_role,
        Parrot_ResizablePMCArray_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_ResizablePMCArray_ro_set_attr_keyed,
        Parrot_ResizablePMCArray_ro_set_attr_str,
        Parrot_ResizablePMCArray_ro_set_bignum_int,
        Parrot_ResizablePMCArray_ro_set_bignum_num,
        Parrot_ResizablePMCArray_ro_set_bignum_str,
        Parrot_ResizablePMCArray_ro_set_bool,
        Parrot_ResizablePMCArray_ro_set_integer_keyed,
        Parrot_ResizablePMCArray_ro_set_integer_keyed_int,
        Parrot_ResizablePMCArray_ro_set_integer_keyed_str,
        Parrot_ResizablePMCArray_ro_set_integer_native,
        Parrot_ResizablePMCArray_ro_set_integer_same,
        Parrot_ResizablePMCArray_ro_set_number_keyed,
        Parrot_ResizablePMCArray_ro_set_number_keyed_int,
        Parrot_ResizablePMCArray_ro_set_number_keyed_str,
        Parrot_ResizablePMCArray_ro_set_number_native,
        Parrot_ResizablePMCArray_ro_set_number_same,
        Parrot_ResizablePMCArray_ro_set_pmc,
        Parrot_ResizablePMCArray_ro_set_pmc_keyed,
        Parrot_ResizablePMCArray_ro_set_pmc_keyed_int,
        Parrot_ResizablePMCArray_ro_set_pmc_keyed_str,
        Parrot_ResizablePMCArray_ro_set_pointer,
        Parrot_ResizablePMCArray_ro_set_pointer_keyed,
        Parrot_ResizablePMCArray_ro_set_pointer_keyed_int,
        Parrot_ResizablePMCArray_ro_set_pointer_keyed_str,
        Parrot_ResizablePMCArray_ro_set_string_keyed,
        Parrot_ResizablePMCArray_ro_set_string_keyed_int,
        Parrot_ResizablePMCArray_ro_set_string_keyed_str,
        Parrot_ResizablePMCArray_ro_set_string_native,
        Parrot_ResizablePMCArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizablePMCArray_ro_shift_float,
        Parrot_ResizablePMCArray_ro_shift_integer,
        Parrot_ResizablePMCArray_ro_shift_pmc,
        Parrot_ResizablePMCArray_ro_shift_string,
        Parrot_FixedPMCArray_slice,
        Parrot_ResizablePMCArray_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_ResizablePMCArray_ro_thaw,
        Parrot_ResizablePMCArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_ResizablePMCArray_ro_unshift_float,
        Parrot_ResizablePMCArray_ro_unshift_integer,
        Parrot_ResizablePMCArray_ro_unshift_pmc,
        Parrot_ResizablePMCArray_ro_unshift_string,
        Parrot_FixedPMCArray_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "ResizablePMCArray");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "array");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "ResizablePMCArray")), PMCNULL);
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "FixedPMCArray")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "ResizablePMCArray"));
            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "FixedPMCArray"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ResizablePMCArray_nci_append), "append");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ResizablePMCArray_nci_shift), "shift");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ResizablePMCArray_nci_pop), "pop");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ResizablePMCArray_nci_unshift), "unshift");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ResizablePMCArray_nci_push), "push");
        {
        }
    } /* pass */
} /* Parrot_ResizablePMCArray_class_init */
#line 799 "./src/pmc/resizablepmcarray.pmc"


/*

=back

=head1 See also

F<docs/pdds/pdd17_basic_types.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
