/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/resizablestringarray.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_resizablestringarray.h"
#include "pmc_fixedstringarray.h"
#include "pmc_default.h"
#include "resizablestringarray.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/resizablestringarray.pmc"
/*
Copyright (C) 2001-2009, Parrot Foundation.
$Id: resizablestringarray.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/resizablestringarray.pmc - resizable array for strings only

=head1 DESCRIPTION

ResizableStringArray implements a resizeable array which stores Parrot strings
only. Any ints or floats assigned to elements of the array will first be
converted to String PMCs and then to native Parrot strings.  PMCs assigned to
to elements of the array will be stringified by having their C<get_string>
method called.

=cut

*/

#include "parrot/parrot.h"
#line 45 "./src/pmc/resizablestringarray.c"
PARROT_EXPORT  PMC  *
Parrot_ResizableStringArray_clone(PARROT_INTERP, PMC *pmc)
{
#line 284 "./src/pmc/resizablestringarray.pmc"

    PMC *copy = Parrot_FixedStringArray_clone(interp, pmc);
    /* copy trimmed extra space */
    SETATTR_ResizableStringArray_resize_threshold(interp, copy, VTABLE_elements(interp, pmc));
    return copy;
#line 55 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_delete_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 565 "./src/pmc/resizablestringarray.pmc"

    INTVAL    idx  = key_integer(interp, key);
    STRING  **str_array;
    UINTVAL   size, i;

    GETATTR_ResizableStringArray_str_array(interp, pmc, str_array);
    GETATTR_ResizableStringArray_size(interp, pmc, size);

    for (i = idx; i < size - 1; ++i)
        str_array[i] = str_array[i + 1];

    VTABLE_set_integer_native(interp, pmc, size - 1);
#line 73 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_delete_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 542 "./src/pmc/resizablestringarray.pmc"

    STRING  **str_array;
    UINTVAL   size, i;

    GETATTR_ResizableStringArray_str_array(interp, pmc, str_array);
    GETATTR_ResizableStringArray_size(interp, pmc, size);

    for (i = key; i < size - 1; ++i)
        str_array[i] = str_array[i + 1];

    VTABLE_set_integer_native(interp, pmc, size - 1);
#line 90 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_ResizableStringArray_get_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 60 "./src/pmc/resizablestringarray.pmc"


    STRING **str_array;
    INTVAL size = VTABLE_elements(interp, pmc);

    if (key < 0) {
        if (key < -size)
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: index out of bounds!");
        else
            key += size;
    }

    if (key >= size)
        return string_from_literal(interp, "");

    GETATTR_ResizableStringArray_str_array(interp, pmc, str_array);

    if (!str_array[key])
        str_array[key] = Parrot_str_new(interp, NULL, 0);

    return str_array[key];
#line 118 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_init(PARROT_INTERP, PMC *pmc)
{
#line 40 "./src/pmc/resizablestringarray.pmc"


    Parrot_ResizableStringArray_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_ResizableStringArray_attributes);

    PMC_data(pmc)   = attrs;

    PObj_custom_mark_destroy_SETALL(pmc);
#line 132 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_ResizableStringArray_pop_float(PARROT_INTERP, PMC *pmc)
{
#line 198 "./src/pmc/resizablestringarray.pmc"

    PMC *pmcval = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_number(interp, pmcval);
#line 141 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizableStringArray_pop_integer(PARROT_INTERP, PMC *pmc)
{
#line 183 "./src/pmc/resizablestringarray.pmc"

    PMC *pmcval = VTABLE_pop_pmc(interp, pmc);
    return VTABLE_get_integer(interp, pmcval);
#line 150 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  PMC  *
Parrot_ResizableStringArray_pop_pmc(PARROT_INTERP, PMC *pmc)
{
#line 164 "./src/pmc/resizablestringarray.pmc"

    STRING *strval = VTABLE_pop_string(interp, pmc);
    PMC    *value  = pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, value, strval);

    return value;
#line 163 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_ResizableStringArray_pop_string(PARROT_INTERP, PMC *pmc)
{
#line 141 "./src/pmc/resizablestringarray.pmc"

    INTVAL  size = VTABLE_elements(interp, pmc);
    STRING *value;

    if (size == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: Can't pop from an empty array!");

    value = VTABLE_get_string_keyed_int(interp, pmc, size - 1);
    VTABLE_set_integer_native(interp, pmc, size - 1);
    return value;
#line 180 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_push_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 411 "./src/pmc/resizablestringarray.pmc"

    PMC    *ret = pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_number_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_push_string(interp, pmc, val);
#line 193 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_push_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 391 "./src/pmc/resizablestringarray.pmc"

    PMC    *ret = pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_integer_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_push_string(interp, pmc, val);
#line 206 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_push_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 375 "./src/pmc/resizablestringarray.pmc"

    STRING *strvalue = VTABLE_get_string(interp, value);
    VTABLE_push_string(interp, pmc, strvalue);
#line 215 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_push_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 126 "./src/pmc/resizablestringarray.pmc"

    INTVAL next_idx = VTABLE_elements(interp, pmc);
    VTABLE_set_string_keyed_int(interp, pmc, next_idx, value);
#line 224 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_set_integer_native(PARROT_INTERP, PMC *pmc, INTVAL new_size)
{
#line 213 "./src/pmc/resizablestringarray.pmc"


    STRING **str_array;
    INTVAL   resize_threshold;

    if (new_size < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: Can't resize!");

    GETATTR_ResizableStringArray_str_array(interp, pmc, str_array);
    GETATTR_ResizableStringArray_resize_threshold(interp, pmc, resize_threshold);
    if (!str_array) {
        /* empty - used fixed routine */
        if (new_size < 8) {
            Parrot_FixedStringArray_set_integer_native(interp, pmc, 8);
            SETATTR_ResizableStringArray_size(interp, pmc, new_size);
            SETATTR_ResizableStringArray_resize_threshold(interp, pmc, 8);
        }
        else {
            Parrot_FixedStringArray_set_integer_native(interp, pmc, new_size);
            SETATTR_ResizableStringArray_resize_threshold(interp, pmc, new_size);
        }
    }
    else if (new_size <= resize_threshold) {
        /* zero out anything that was previously allocated
         * if we're growing the array */
        INTVAL old_size = VTABLE_elements(interp, pmc);
        if (new_size > old_size) {
            INTVAL i;
            for (i = old_size; i < new_size; i++)
                str_array[i] = NULL;
        }

        SETATTR_ResizableStringArray_size(interp, pmc, new_size);
        /* we could shrink here if necessary */
        return;
    }
    else {
        INTVAL i   = resize_threshold;
        INTVAL cur = i;

        if (cur < 8192)
            cur = new_size < 2 * cur ? 2 * cur : new_size;
        else {
            cur = new_size + 4096;
            cur &= ~0xfff;
        }

        SETATTR_ResizableStringArray_str_array(interp, pmc,
                (STRING **)mem_sys_realloc(
                    str_array, cur * sizeof (STRING*)));
        GETATTR_ResizableStringArray_str_array(interp, pmc, str_array);

        for (; i < cur; i++)
            str_array[i] = NULL;

        SETATTR_ResizableStringArray_size(interp, pmc, new_size);
        SETATTR_ResizableStringArray_resize_threshold(interp, pmc, cur);
    }
#line 289 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_set_string_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, STRING *value)
{
#line 94 "./src/pmc/resizablestringarray.pmc"


    STRING **str_array;
    INTVAL size = VTABLE_elements(interp, pmc);

    if (key < 0) {
        if (key < -size)
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: index out of bounds!");
        else
            key += size;
    }

    if (key >= size)
        VTABLE_set_integer_native(interp, pmc, key+1);

    GETATTR_ResizableStringArray_str_array(interp, pmc, str_array);
    GC_WRITE_BARRIER(interp, pmc, str_array[key], value);
    str_array[key] = value;
#line 314 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_ResizableStringArray_shift_float(PARROT_INTERP, PMC *pmc)
{
#line 358 "./src/pmc/resizablestringarray.pmc"

    PMC *pmcval = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_number(interp, pmcval);
#line 323 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  INTVAL 
Parrot_ResizableStringArray_shift_integer(PARROT_INTERP, PMC *pmc)
{
#line 343 "./src/pmc/resizablestringarray.pmc"

    PMC *pmcval = VTABLE_shift_pmc(interp, pmc);
    return VTABLE_get_integer(interp, pmcval);
#line 332 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  PMC  *
Parrot_ResizableStringArray_shift_pmc(PARROT_INTERP, PMC *pmc)
{
#line 430 "./src/pmc/resizablestringarray.pmc"

    UINTVAL  size;
    PMC     *ret;
    STRING  *value;

    GETATTR_ResizableStringArray_size(interp, pmc, size);

    if (size == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: Can't shift from an empty array!");

    value = VTABLE_get_string_keyed_int(interp, pmc, 0);
    ret   = pmc_new(interp, enum_class_String);

    VTABLE_set_string_native(interp, ret, value);
    VTABLE_delete_keyed_int(interp, pmc, 0);

    return ret;
#line 356 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  STRING  *
Parrot_ResizableStringArray_shift_string(PARROT_INTERP, PMC *pmc)
{
#line 301 "./src/pmc/resizablestringarray.pmc"

    INTVAL  size = VTABLE_elements(interp, pmc);
    STRING *value;

    if (size == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
                "ResizableStringArray: Can't shift from an empty array!");

    value = VTABLE_get_string_keyed_int(interp, pmc, 0);
    VTABLE_delete_keyed_int(interp, pmc, 0);
    return value;
#line 373 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_splice(PARROT_INTERP, PMC *pmc, PMC *value, INTVAL offset, INTVAL count)
{
#line 595 "./src/pmc/resizablestringarray.pmc"


    INTVAL length, elems, shift, i;

    if (value->vtable->base_type != pmc->vtable->base_type &&
            value->vtable->base_type != enum_class_FixedStringArray)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "ResizableStringArray: illegal type for splice!");

    length = VTABLE_elements(interp, pmc);
    elems  = VTABLE_elements(interp, value);
    shift  = elems - count;

    /* start from end? */
    if (offset < 0)
        offset += length;

    if (offset < 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "illegal splice offset\n");

    /* shrink the array */
    if (shift < 0) {
        /* start at offset so we don't overwrite values we'll need */
        for (i = offset+count; i < length; i++)
            VTABLE_set_pmc_keyed_int(interp, pmc, i + shift,
                VTABLE_get_pmc_keyed_int(interp, pmc, i));

        VTABLE_set_integer_native(interp, pmc, length + shift);
    }
    /* grow the array */
    else if (shift > 0) {
        VTABLE_set_integer_native(interp, pmc, length + shift);

        /* move the existing values */
        /* start at length-1 so we don't overwrite values we'll need */
        for (i = length - 1; i >= offset; i--)
            VTABLE_set_pmc_keyed_int(interp, pmc, i + shift,
                VTABLE_get_pmc_keyed_int(interp, pmc, i));
    }

    /* copy the new values */
    for (i = 0; i < elems; i++)
        VTABLE_set_pmc_keyed_int(interp, pmc, i + offset,
            VTABLE_get_pmc_keyed_int(interp, value, i));
#line 424 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_unshift_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 523 "./src/pmc/resizablestringarray.pmc"

    PMC    *ret = pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_number_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_unshift_string(interp, pmc, val);
#line 437 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_unshift_integer(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 503 "./src/pmc/resizablestringarray.pmc"

    PMC    *ret = pmc_new(interp, enum_class_String);
    STRING *val;

    VTABLE_set_integer_native(interp, ret, value);
    val = VTABLE_get_string(interp, ret);
    VTABLE_unshift_string(interp, pmc, val);
#line 450 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_unshift_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 487 "./src/pmc/resizablestringarray.pmc"

    STRING *strvalue = VTABLE_get_string(interp, value);
    VTABLE_unshift_string(interp, pmc, strvalue);
#line 459 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void 
Parrot_ResizableStringArray_unshift_string(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 461 "./src/pmc/resizablestringarray.pmc"

    STRING  **str_array;
    UINTVAL   size, i;

    GETATTR_ResizableStringArray_size(interp, pmc, size);
    VTABLE_set_integer_native(interp, pmc, size + 1);

    GETATTR_ResizableStringArray_str_array(interp, pmc, str_array);
    for (i = size; i; --i)
        str_array[i] = str_array[i - 1];

    VTABLE_set_string_keyed_int(interp, pmc, 0, value);
#line 477 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_nci_shift(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 515 "./src/pmc/resizablestringarray.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 532 "./src/pmc/resizablestringarray.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 655 "./src/pmc/resizablestringarray.pmc"

    PMC *value = pmc->vtable->shift_pmc(interp, pmc);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *value */
    /*BEGIN GENERATED ACCESSORS */
#line 546 "./src/pmc/resizablestringarray.pmc"
    CTX_REG_PMC(_ctx, 0) = value;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto shift_returns;
    /*END RETURN PMC *value */
    }
#line 657 "./src/pmc/resizablestringarray.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
shift_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 591 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_nci_pop(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 629 "./src/pmc/resizablestringarray.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 646 "./src/pmc/resizablestringarray.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 660 "./src/pmc/resizablestringarray.pmc"

    PMC *value = pmc->vtable->pop_pmc(interp, pmc);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *value */
    /*BEGIN GENERATED ACCESSORS */
#line 660 "./src/pmc/resizablestringarray.pmc"
    CTX_REG_PMC(_ctx, 0) = value;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto pop_returns;
    /*END RETURN PMC *value */
    }
#line 662 "./src/pmc/resizablestringarray.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
pop_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 705 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_nci_unshift(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 744 "./src/pmc/resizablestringarray.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 761 "./src/pmc/resizablestringarray.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* value = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 677 "./src/pmc/resizablestringarray.pmc"

    pmc->vtable->unshift_pmc(interp, pmc, value);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 786 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_nci_push(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 825 "./src/pmc/resizablestringarray.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 842 "./src/pmc/resizablestringarray.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* value = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 681 "./src/pmc/resizablestringarray.pmc"

    pmc->vtable->push_pmc(interp, pmc, value);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 867 "./src/pmc/resizablestringarray.c"
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  PMC *
Parrot_ResizableStringArray_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  FLOATVAL
Parrot_ResizableStringArray_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  INTVAL
Parrot_ResizableStringArray_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  PMC *
Parrot_ResizableStringArray_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  STRING *
Parrot_ResizableStringArray_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  FLOATVAL
Parrot_ResizableStringArray_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  INTVAL
Parrot_ResizableStringArray_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  PMC *
Parrot_ResizableStringArray_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  STRING *
Parrot_ResizableStringArray_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of ResizableStringArray");
}
PARROT_EXPORT  void
Parrot_ResizableStringArray_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of ResizableStringArray");
}
#include "pmc_default.h"
void
Parrot_ResizableStringArray_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":str_array :size :resize_threshold ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_ResizableStringArray, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_ResizableStringArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizableStringArray_delete_keyed,
        Parrot_ResizableStringArray_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedStringArray_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_FixedStringArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_FixedStringArray_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedStringArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedStringArray_get_integer,
        Parrot_FixedStringArray_get_integer_keyed,
        Parrot_FixedStringArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedStringArray_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_FixedStringArray_get_number_keyed,
        Parrot_FixedStringArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedStringArray_get_pmc_keyed,
        Parrot_FixedStringArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedStringArray_get_repr,
        Parrot_default_get_string,
        Parrot_FixedStringArray_get_string_keyed,
        Parrot_ResizableStringArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_ResizableStringArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_FixedStringArray_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_ResizableStringArray_pop_float,
        Parrot_ResizableStringArray_pop_integer,
        Parrot_ResizableStringArray_pop_pmc,
        Parrot_ResizableStringArray_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_ResizableStringArray_push_float,
        Parrot_ResizableStringArray_push_integer,
        Parrot_ResizableStringArray_push_pmc,
        Parrot_ResizableStringArray_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_FixedStringArray_set_integer_keyed,
        Parrot_FixedStringArray_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_ResizableStringArray_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_FixedStringArray_set_number_keyed,
        Parrot_FixedStringArray_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_FixedStringArray_set_pmc_keyed,
        Parrot_FixedStringArray_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_FixedStringArray_set_string_keyed,
        Parrot_ResizableStringArray_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizableStringArray_shift_float,
        Parrot_ResizableStringArray_shift_integer,
        Parrot_ResizableStringArray_shift_pmc,
        Parrot_ResizableStringArray_shift_string,
        Parrot_default_slice,
        Parrot_ResizableStringArray_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_FixedStringArray_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_ResizableStringArray_unshift_float,
        Parrot_ResizableStringArray_unshift_integer,
        Parrot_ResizableStringArray_unshift_pmc,
        Parrot_ResizableStringArray_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_ResizableStringArray, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_ResizableStringArray_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_ResizableStringArray_ro_add_method,
        Parrot_ResizableStringArray_ro_add_parent,
        Parrot_ResizableStringArray_ro_add_role,
        Parrot_ResizableStringArray_ro_add_vtable_override,
        Parrot_ResizableStringArray_ro_assign_pmc,
        Parrot_ResizableStringArray_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_ResizableStringArray_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_ResizableStringArray_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_ResizableStringArray_ro_delete_keyed,
        Parrot_ResizableStringArray_ro_delete_keyed_int,
        Parrot_ResizableStringArray_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_FixedStringArray_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_FixedStringArray_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_ResizableStringArray_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_FixedStringArray_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_FixedStringArray_get_bool,
        Parrot_default_get_class,
        Parrot_FixedStringArray_get_integer,
        Parrot_FixedStringArray_get_integer_keyed,
        Parrot_FixedStringArray_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_FixedStringArray_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_FixedStringArray_get_number_keyed,
        Parrot_FixedStringArray_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_FixedStringArray_get_pmc_keyed,
        Parrot_FixedStringArray_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_FixedStringArray_get_repr,
        Parrot_default_get_string,
        Parrot_FixedStringArray_get_string_keyed,
        Parrot_ResizableStringArray_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_ResizableStringArray_ro_i_absolute,
        Parrot_ResizableStringArray_ro_i_add,
        Parrot_ResizableStringArray_ro_i_add_float,
        Parrot_ResizableStringArray_ro_i_add_int,
        Parrot_ResizableStringArray_ro_i_bitwise_and,
        Parrot_ResizableStringArray_ro_i_bitwise_and_int,
        Parrot_ResizableStringArray_ro_i_bitwise_ands,
        Parrot_ResizableStringArray_ro_i_bitwise_ands_str,
        Parrot_ResizableStringArray_ro_i_bitwise_lsr,
        Parrot_ResizableStringArray_ro_i_bitwise_lsr_int,
        Parrot_ResizableStringArray_ro_i_bitwise_not,
        Parrot_ResizableStringArray_ro_i_bitwise_nots,
        Parrot_ResizableStringArray_ro_i_bitwise_or,
        Parrot_ResizableStringArray_ro_i_bitwise_or_int,
        Parrot_ResizableStringArray_ro_i_bitwise_ors,
        Parrot_ResizableStringArray_ro_i_bitwise_ors_str,
        Parrot_ResizableStringArray_ro_i_bitwise_shl,
        Parrot_ResizableStringArray_ro_i_bitwise_shl_int,
        Parrot_ResizableStringArray_ro_i_bitwise_shr,
        Parrot_ResizableStringArray_ro_i_bitwise_shr_int,
        Parrot_ResizableStringArray_ro_i_bitwise_xor,
        Parrot_ResizableStringArray_ro_i_bitwise_xor_int,
        Parrot_ResizableStringArray_ro_i_bitwise_xors,
        Parrot_ResizableStringArray_ro_i_bitwise_xors_str,
        Parrot_ResizableStringArray_ro_i_concatenate,
        Parrot_ResizableStringArray_ro_i_concatenate_str,
        Parrot_ResizableStringArray_ro_i_divide,
        Parrot_ResizableStringArray_ro_i_divide_float,
        Parrot_ResizableStringArray_ro_i_divide_int,
        Parrot_ResizableStringArray_ro_i_floor_divide,
        Parrot_ResizableStringArray_ro_i_floor_divide_float,
        Parrot_ResizableStringArray_ro_i_floor_divide_int,
        Parrot_ResizableStringArray_ro_i_logical_not,
        Parrot_ResizableStringArray_ro_i_modulus,
        Parrot_ResizableStringArray_ro_i_modulus_float,
        Parrot_ResizableStringArray_ro_i_modulus_int,
        Parrot_ResizableStringArray_ro_i_multiply,
        Parrot_ResizableStringArray_ro_i_multiply_float,
        Parrot_ResizableStringArray_ro_i_multiply_int,
        Parrot_ResizableStringArray_ro_i_neg,
        Parrot_ResizableStringArray_ro_i_pow,
        Parrot_ResizableStringArray_ro_i_pow_float,
        Parrot_ResizableStringArray_ro_i_pow_int,
        Parrot_ResizableStringArray_ro_i_repeat,
        Parrot_ResizableStringArray_ro_i_repeat_int,
        Parrot_ResizableStringArray_ro_i_subtract,
        Parrot_ResizableStringArray_ro_i_subtract_float,
        Parrot_ResizableStringArray_ro_i_subtract_int,
        Parrot_ResizableStringArray_ro_increment,
        Parrot_ResizableStringArray_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_FixedStringArray_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_ResizableStringArray_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_ResizableStringArray_ro_pop_float,
        Parrot_ResizableStringArray_ro_pop_integer,
        Parrot_ResizableStringArray_ro_pop_pmc,
        Parrot_ResizableStringArray_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_ResizableStringArray_ro_push_float,
        Parrot_ResizableStringArray_ro_push_integer,
        Parrot_ResizableStringArray_ro_push_pmc,
        Parrot_ResizableStringArray_ro_push_string,
        Parrot_ResizableStringArray_ro_remove_attribute,
        Parrot_ResizableStringArray_ro_remove_method,
        Parrot_ResizableStringArray_ro_remove_parent,
        Parrot_ResizableStringArray_ro_remove_role,
        Parrot_ResizableStringArray_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_ResizableStringArray_ro_set_attr_keyed,
        Parrot_ResizableStringArray_ro_set_attr_str,
        Parrot_ResizableStringArray_ro_set_bignum_int,
        Parrot_ResizableStringArray_ro_set_bignum_num,
        Parrot_ResizableStringArray_ro_set_bignum_str,
        Parrot_ResizableStringArray_ro_set_bool,
        Parrot_ResizableStringArray_ro_set_integer_keyed,
        Parrot_ResizableStringArray_ro_set_integer_keyed_int,
        Parrot_ResizableStringArray_ro_set_integer_keyed_str,
        Parrot_ResizableStringArray_ro_set_integer_native,
        Parrot_ResizableStringArray_ro_set_integer_same,
        Parrot_ResizableStringArray_ro_set_number_keyed,
        Parrot_ResizableStringArray_ro_set_number_keyed_int,
        Parrot_ResizableStringArray_ro_set_number_keyed_str,
        Parrot_ResizableStringArray_ro_set_number_native,
        Parrot_ResizableStringArray_ro_set_number_same,
        Parrot_ResizableStringArray_ro_set_pmc,
        Parrot_ResizableStringArray_ro_set_pmc_keyed,
        Parrot_ResizableStringArray_ro_set_pmc_keyed_int,
        Parrot_ResizableStringArray_ro_set_pmc_keyed_str,
        Parrot_ResizableStringArray_ro_set_pointer,
        Parrot_ResizableStringArray_ro_set_pointer_keyed,
        Parrot_ResizableStringArray_ro_set_pointer_keyed_int,
        Parrot_ResizableStringArray_ro_set_pointer_keyed_str,
        Parrot_ResizableStringArray_ro_set_string_keyed,
        Parrot_ResizableStringArray_ro_set_string_keyed_int,
        Parrot_ResizableStringArray_ro_set_string_keyed_str,
        Parrot_ResizableStringArray_ro_set_string_native,
        Parrot_ResizableStringArray_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_ResizableStringArray_ro_shift_float,
        Parrot_ResizableStringArray_ro_shift_integer,
        Parrot_ResizableStringArray_ro_shift_pmc,
        Parrot_ResizableStringArray_ro_shift_string,
        Parrot_default_slice,
        Parrot_ResizableStringArray_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_ResizableStringArray_ro_thaw,
        Parrot_ResizableStringArray_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_ResizableStringArray_ro_unshift_float,
        Parrot_ResizableStringArray_ro_unshift_integer,
        Parrot_ResizableStringArray_ro_unshift_pmc,
        Parrot_ResizableStringArray_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "ResizableStringArray");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "array");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "ResizableStringArray")), PMCNULL);
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "FixedStringArray")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "ResizableStringArray"));
            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "FixedStringArray"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ResizableStringArray_nci_shift), "shift");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ResizableStringArray_nci_pop), "pop");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ResizableStringArray_nci_unshift), "unshift");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_ResizableStringArray_nci_push), "push");
        {
        }
    } /* pass */
} /* Parrot_ResizableStringArray_class_init */
#line 683 "./src/pmc/resizablestringarray.pmc"


/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd17_basic_types.pod>.

=head1 HISTORY

Initial version                  - Matt Fowles 2004-06-11
Changed allocator to double size - Matt Fowles 2004-06-15
Added push_string                - Bernhard Schmalhofer 2004-10-17
moved available size to int_val2 - Matt Fowles 2005-07-22

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
