/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/role.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_role.h"
#include "pmc_default.h"
#include "role.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/role.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: role.pmc 37099 2009-03-03 18:23:12Z Util $

=head1 NAME

src/pmc/role.pmc - Role - defines a role

=head1 DESCRIPTION

This class implements the Role PMC, a unit of class composition as outlined in
F<docs/pdds/pdd15_objects.pod>.

Role is not derived from any other PMC.

=head2 Structure

The Role PMC structure (C<Parrot_Role>) consists of five items:

=over 4

=item C<name>

The name of the role -- a STRING.
An empty STRING is allocated during initialization.

=item C<namespace>

The namespace the role is associated with, if any.
A Null PMC is allocated during initialization.

=item C<roles>

The list of roles from which this role is composed, if any.
An empty ResizablePMCArray is allocated during initialization.

=item C<methods>

The directory of method names and methods this role implements.
An empty Hash PMC is allocated during initialization.

=item C<attrib_metadata>

The directory of attribute names and attribute metadata this role contains.
An empty Hash PMC is allocated during initialization.

=cut

*/

#include "parrot/parrot.h"
#include "pmc_namespace.h"

/* Takes a hash and initializes the role based on it. */
static void init_role_from_hash(PARROT_INTERP, PMC *self, PMC *info)
{
    Parrot_Role_attributes * const role     = PARROT_ROLE(self);
    STRING * const ns_string     = CONST_STRING(interp, "NameSpace");
    STRING * const name_str      = CONST_STRING(interp, "name");
    STRING * const namespace_str = CONST_STRING(interp, "namespace");

    int have_name, have_ns;
    PMC *old_ns;
    int i;

    /* Ensure we actually have some initialization info. */
    if (PMC_IS_NULL(info))
        return;

    /* Check if we have a name and/or a namespace. */
    have_name = VTABLE_exists_keyed_str(interp, info, name_str);

    have_ns = VTABLE_exists_keyed_str(interp, info, namespace_str);

    /* Take a copy of the current namespace the role is attached to. */
    old_ns = role->_namespace;

    /* Let's roll (no pun intended!) If we have a namespace and a name,
     * set both. */
    if (have_name && have_ns) {
        /* If we weren't passed a NameSpace PMC, assume it's something we have
         * to look one up with and do so. */
        PMC *_namespace = VTABLE_get_pmc_keyed_str(interp, info, namespace_str);
        if (!VTABLE_isa(interp, _namespace, ns_string))
            _namespace = Parrot_make_namespace_autobase(interp, _namespace);

        /* If we get something null back it's an error; otherwise, store it. */
        if (!PMC_IS_NULL(_namespace))
            role->_namespace = _namespace;
        else
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_GLOBAL_NOT_FOUND,
                    "Namespace not found");

        /* Set a (string) name. */
        role->name = VTABLE_get_string_keyed_str(interp, info, name_str);
    }

    /* Otherwise, we may just have a name. */
    else if (have_name) {
        /* Set the name. */
        role->name = VTABLE_get_string_keyed_str(interp, info, name_str);

        /* Namespace is nested in the current namespace and with the name of
         * the role. */
        role->_namespace = Parrot_make_namespace_keyed_str(interp,
            CONTEXT(interp)->current_namespace, role->name);
    }

    /* Otherwise, we may just have a namespace. */
    else if (have_ns) {
        /* If we weren't passed a NameSpace PMC, assume it's something we have
         * to look one up with and do so. */
        PMC *_namespace = VTABLE_get_pmc_keyed_str(interp, info, namespace_str);
        if (!VTABLE_isa(interp, _namespace, ns_string))
            _namespace = Parrot_make_namespace_autobase(interp, _namespace);

        /* If we get something null back it's an error; otherwise, store it. */
        if (PMC_IS_NULL(_namespace))
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_GLOBAL_NOT_FOUND,
                    "Namespace not found");

        role->_namespace = _namespace;
        /* Name is that of the most nested part of the namespace. */
        role->name = VTABLE_get_string(interp, _namespace);
    }

    /* If we were attached to a namespce and are now attached to a new one,
     * need to unset ourselves in the old namespace. */
    if (!PMC_IS_NULL(old_ns) && role->_namespace != old_ns) {
        STRING * const set_class_str = CONST_STRING(interp, "set_class");
        Parrot_PCCINVOKE(interp, old_ns, set_class_str, "P->", PMCNULL);
    }

    /* Link namespace to this role, if there is one. */
    if (!PMC_IS_NULL(role->_namespace)) {
        STRING * const set_class_str = CONST_STRING(interp, "set_class");
        Parrot_PCCINVOKE(interp, role->_namespace, set_class_str, "P->", self);
    }

    /* Initialize roles, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, CONST_STRING(interp, "roles"))) {
        /* Loop over roles array and compose them. */
        STRING * const roles_str = CONST_STRING(interp, "roles");
        PMC    * const role_list = VTABLE_get_pmc_keyed_str(interp, info, roles_str);
        const int role_count     = VTABLE_elements(interp, role_list);

        for (i = 0; i < role_count; i++) {
            PMC * const cur_role = VTABLE_get_pmc_keyed_int(interp, role_list, i);
            VTABLE_add_role(interp, self, cur_role);
        }
    }

    /* Initialize attributes, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, CONST_STRING(interp, "attributes"))) {
        /* Loop over attributes array and add them. */
        STRING * const attributes_str   = CONST_STRING(interp, "attributes");
        PMC    * const attrib_name_list = VTABLE_get_pmc_keyed_str(interp, info, attributes_str);

        const int attrib_count = VTABLE_elements(interp, attrib_name_list);

        for (i = 0; i < attrib_count; i++) {
            STRING * const attrib_name = VTABLE_get_string_keyed_int(interp,
                attrib_name_list, i);
            VTABLE_add_attribute(interp, self, attrib_name, PMCNULL);
        }
    }

    /* Initialize methods, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, CONST_STRING(interp, "methods"))) {
        /* Get the methods hash. */
        STRING * const methods_str = CONST_STRING(interp, "methods");
        PMC    * const methods     = VTABLE_get_pmc_keyed_str(interp, info, methods_str);

        /* Iterate over the list of methods. */
        PMC    * const iter        = VTABLE_get_iter(interp, methods);

        while (VTABLE_get_bool(interp, iter)) {
            /* Add the method. */
            STRING * const method_name = VTABLE_shift_string(interp, iter);
            PMC    * const method_pmc  =
                VTABLE_get_pmc_keyed_str(interp, methods, method_name);
            VTABLE_add_method(interp, self, method_name, method_pmc);
        }
    }

    /* Extract any methods from the namespace */
    Parrot_oo_extract_methods_from_namespace(interp, self, role->_namespace);
}

/*

=back

=head2 Functions

=over 4

=cut

*/
#line 223 "./src/pmc/role.c"
PARROT_EXPORT  void 
Parrot_Role_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
#line 298 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role  = PARROT_ROLE(pmc);
    PMC           * const new_attribute  = pmc_new(interp, enum_class_Hash);

    /* Set name and type. */
    VTABLE_set_string_keyed_str(interp, new_attribute, CONST_STRING(interp, "name"), name);

    if (!PMC_IS_NULL(type))
        VTABLE_set_pmc_keyed_str(interp, new_attribute, CONST_STRING(interp, "type"), type);

    /* Enter the attribute in the attributes array. */
    VTABLE_set_pmc_keyed_str(interp, role->attrib_metadata,
        name, new_attribute);
#line 241 "./src/pmc/role.c"
}
PARROT_EXPORT  void 
Parrot_Role_add_method(PARROT_INTERP, PMC *pmc, STRING *name, PMC *sub)
{
#line 323 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role = PARROT_ROLE(pmc);

    /* If we have already added a method with this name... */
    if (VTABLE_exists_keyed_str(interp, role->methods, name)) {
        /* XXX Need to handle multi methods here. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNIMPLEMENTED,
            "Currently, adding multiple methods of the same name"
            " is not supported.");
    }
    else {
        /* Enter it into the table. */
        VTABLE_set_pmc_keyed_str(interp, role->methods, name, sub);
    }
#line 261 "./src/pmc/role.c"
}
PARROT_EXPORT  void 
Parrot_Role_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
#line 369 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const this_role = PARROT_ROLE(pmc);

    /* Do the composition. */
    Parrot_ComposeRole(interp, role, PMCNULL, 0, PMCNULL, 0,
           this_role->methods, this_role->roles);
#line 273 "./src/pmc/role.c"
}
PARROT_EXPORT  void 
Parrot_Role_destroy(PARROT_INTERP, PMC *pmc)
{
#line 258 "./src/pmc/role.pmc"

    mem_sys_free(PMC_data(pmc));
#line 281 "./src/pmc/role.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Role_does(PARROT_INTERP, PMC *pmc, STRING *role_name)
{
#line 532 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role  = PARROT_ROLE(pmc);
    INTVAL      i, count;

    if (Parrot_str_equal(interp, role->name, role_name))
        return 1;

    count = VTABLE_elements(interp, role->roles);
    for (i = 0; i < count; i++) {
        PMC *cur_role = VTABLE_get_pmc_keyed_int(interp, role->roles, i);
        if (VTABLE_does(interp, cur_role, role_name))
            return 1;
    }

    return 0;
#line 302 "./src/pmc/role.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Role_does_pmc(PARROT_INTERP, PMC *pmc, PMC *role)
{
#line 559 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const this_role  = PARROT_ROLE(pmc);
    INTVAL      i, count;

    if (role == pmc)
        return 1;

    count = VTABLE_elements(interp, this_role->roles);
    for (i = 0; i < count; i++) {
        PMC *cur_role = VTABLE_get_pmc_keyed_int(interp, this_role->roles, i);
        if (VTABLE_does_pmc(interp, cur_role, role))
            return 1;
    }

    return 0;
#line 323 "./src/pmc/role.c"
}
PARROT_EXPORT  STRING  *
Parrot_Role_get_string(PARROT_INTERP, PMC *pmc)
{
#line 500 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role  = PARROT_ROLE(pmc);
    PMC               * const _namespace = role->_namespace;

    if (!PMC_IS_NULL(_namespace)) {
        /* Call the 'get_name' method on the role's associated namespace
         * to retrieve a fully qualified list of names, then join the list
         * with a semicolon.
         */
        PMC * const names = Parrot_ns_get_name(interp, _namespace);

        if (!PMC_IS_NULL(names)) {
            /* remove the HLL namespace name */
            VTABLE_shift_string(interp, names);
            return Parrot_str_join(interp, CONST_STRING(interp, ";"), names);
        }
    }

    /* Otherwise, copy the stored string name of the class. */
    return Parrot_str_copy(interp, role->name);
#line 349 "./src/pmc/role.c"
}
PARROT_EXPORT  void 
Parrot_Role_init(PARROT_INTERP, PMC *pmc)
{
#line 224 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role = mem_allocate_zeroed_typed(Parrot_Role_attributes);
    PMC_data(pmc)        = role;

    /* Set flags for custom GC mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);

    /* Set up the object. */
    role->name            = CONST_STRING(interp, "");
    role->_namespace      = PMCNULL;
    role->roles           = pmc_new(interp, enum_class_ResizablePMCArray);
    role->methods         = pmc_new(interp, enum_class_Hash);
    role->attrib_metadata = pmc_new(interp, enum_class_Hash);
#line 369 "./src/pmc/role.c"
}
PARROT_EXPORT  void 
Parrot_Role_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init_data)
{
#line 240 "./src/pmc/role.pmc"

    /* Create the role. */
    VTABLE_init(interp, pmc);

    /* Initialize the role with the supplied data. */
    init_role_from_hash(interp, pmc, init_data);
#line 381 "./src/pmc/role.c"
}
PARROT_EXPORT  PMC  *
Parrot_Role_inspect(PARROT_INTERP, PMC *pmc)
{
#line 462 "./src/pmc/role.pmc"

    /* Create a hash, then use inspect_str to get all of the data to
     * fill it up with. */
    PMC * const metadata = pmc_new(interp, enum_class_Hash);

    STRING * const name       = CONST_STRING(interp, "name");
    STRING * const _namespace = CONST_STRING(interp, "namespace");
    STRING * const attributes = CONST_STRING(interp, "attributes");
    STRING * const methods    = CONST_STRING(interp, "methods");
    STRING * const roles      = CONST_STRING(interp, "roles");

    VTABLE_set_pmc_keyed_str(interp, metadata, name,
        VTABLE_inspect_str(interp, pmc, name));

    VTABLE_set_pmc_keyed_str(interp, metadata, _namespace,
        VTABLE_inspect_str(interp, pmc, _namespace));

    VTABLE_set_pmc_keyed_str(interp, metadata, attributes,
        VTABLE_inspect_str(interp, pmc, attributes));

    VTABLE_set_pmc_keyed_str(interp, metadata, methods,
        VTABLE_inspect_str(interp, pmc, methods));

    VTABLE_set_pmc_keyed_str(interp, metadata, roles,
        VTABLE_inspect_str(interp, pmc, roles));
    return metadata;
#line 413 "./src/pmc/role.c"
}
PARROT_EXPORT  PMC  *
Parrot_Role_inspect_str(PARROT_INTERP, PMC *pmc, STRING *what)
{
#line 405 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role  = PARROT_ROLE(pmc);

    /* What should we return? */
    PMC         *found;

    if (Parrot_str_equal(interp, what, CONST_STRING(interp, "name"))) {
        found = pmc_new(interp, enum_class_String);
        VTABLE_set_string_native(interp, found, role->name);
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "namespace"))) {
        /* Don't clone the namespace, as it's not part of our state. */
        return role->_namespace;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "attributes"))) {
        found = role->attrib_metadata;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "methods"))) {
        found = role->methods;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "roles"))) {
        found = role->roles;
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unknown introspection value '%S'", what);
    }

    /* Clone and return. */
    if (PMC_IS_NULL(found)) { return PMCNULL; }
    if (found->vtable->base_type == enum_class_Hash) {
        /* for Hash return values, create and return a shallow
         * clone because the VTABLE_clone does a deep clone */
        PMC * const hash = pmc_new(interp, enum_class_Hash);
        PMC * const iter = VTABLE_get_iter(interp, found);
        while (VTABLE_get_bool(interp, iter)) {
            STRING * key = VTABLE_shift_string(interp, iter);
            PMC * value  = VTABLE_get_pmc_keyed_str(interp, found, key);
            VTABLE_set_pmc_keyed_str(interp, hash, key, value);
        }
        return hash;
    }
    return VTABLE_clone(interp, found);
#line 462 "./src/pmc/role.c"
}
PARROT_EXPORT  void 
Parrot_Role_mark(PARROT_INTERP, PMC *pmc)
{
#line 272 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role = PARROT_ROLE(pmc);

    if (role->name)
        pobject_lives(interp, (PObj *)role->name);
    if (role->_namespace)
        pobject_lives(interp, (PObj *)role->_namespace);
    if (role->roles)
        pobject_lives(interp, (PObj *)role->roles);
    if (role->methods)
        pobject_lives(interp, (PObj *)role->methods);
    if (role->attrib_metadata)
        pobject_lives(interp, (PObj *)role->attrib_metadata);
#line 481 "./src/pmc/role.c"
}
PARROT_EXPORT  void 
Parrot_Role_remove_method(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 348 "./src/pmc/role.pmc"

    Parrot_Role_attributes * const role = PARROT_ROLE(pmc);
    if (VTABLE_exists_keyed_str(interp, role->methods, name))
        VTABLE_delete_keyed_str(interp, role->methods, name);
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "No method named '%S' to remove in role '%S'.",
            name, VTABLE_get_string(interp, pmc));
#line 495 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_nci_name(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 535 "./src/pmc/role.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 552 "./src/pmc/role.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    INTVAL got_name = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 600 "./src/pmc/role.pmc"

    Parrot_Role_attributes *role     = PARROT_ROLE(pmc);
    STRING                 *ret_name = NULL;

    if (got_name) {
        /* We'll build a hash just containing the name, then give this to
         * init_role_from_hash - saves some code duplication. */
        PMC *naming_hash = pmc_new(interp, enum_class_Hash);
        VTABLE_set_string_keyed_str(interp, naming_hash, CONST_STRING(interp, "name"), name);
        init_role_from_hash(interp, pmc, naming_hash);
    }

    ret_name = role->name;
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *ret_name */
    /*BEGIN GENERATED ACCESSORS */
#line 579 "./src/pmc/role.pmc"
    CTX_REG_STR(_ctx, 0) = ret_name;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto name_returns;
    /*END RETURN STRING *ret_name */
    }
#line 613 "./src/pmc/role.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
name_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 624 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_nci_get_namespace(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 662 "./src/pmc/role.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 679 "./src/pmc/role.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 628 "./src/pmc/role.pmc"

    Parrot_Role_attributes *role = PARROT_ROLE(pmc);
    PMC           *ret_namespace = role->_namespace;
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_namespace */
    /*BEGIN GENERATED ACCESSORS */
#line 694 "./src/pmc/role.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_namespace;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_namespace_returns;
    /*END RETURN PMC *ret_namespace */
    }
#line 631 "./src/pmc/role.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_namespace_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 739 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_nci_attributes(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 777 "./src/pmc/role.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 794 "./src/pmc/role.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 646 "./src/pmc/role.pmc"

    PMC *ret_attrib_metadata = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "attributes"));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_attrib_metadata */
    /*BEGIN GENERATED ACCESSORS */
#line 808 "./src/pmc/role.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_attrib_metadata;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto attributes_returns;
    /*END RETURN PMC *ret_attrib_metadata */
    }
#line 648 "./src/pmc/role.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
attributes_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 853 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_nci_add_attribute(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 2 };
    opcode_t _param_indexes[]     = { 0, 0, 1, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 4);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 130);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 3, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 894 "./src/pmc/role.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 911 "./src/pmc/role.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* attribute_name = CTX_REG_STR(_ctx, 0);
    PMC* attribute_type = CTX_REG_PMC(_ctx, 1);
    INTVAL got_type = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 664 "./src/pmc/role.pmc"

    VTABLE_add_attribute(interp, pmc, attribute_name,
        got_type ? attribute_type : PMCNULL);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 939 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_nci_methods(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 977 "./src/pmc/role.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 994 "./src/pmc/role.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 679 "./src/pmc/role.pmc"

    PMC *ret_methods = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "methods"));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_methods */
    /*BEGIN GENERATED ACCESSORS */
#line 1008 "./src/pmc/role.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_methods;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto methods_returns;
    /*END RETURN PMC *ret_methods */
    }
#line 681 "./src/pmc/role.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
methods_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1053 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_nci_add_method(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 2 };
    opcode_t _param_indexes[]     = { 0, 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1093 "./src/pmc/role.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1110 "./src/pmc/role.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    PMC* sub = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 694 "./src/pmc/role.pmc"

    VTABLE_add_method(interp, pmc, name, sub);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1136 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_nci_remove_method(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1175 "./src/pmc/role.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1192 "./src/pmc/role.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 708 "./src/pmc/role.pmc"

    VTABLE_remove_method(interp, pmc, name);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1217 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_nci_roles(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1255 "./src/pmc/role.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1272 "./src/pmc/role.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 722 "./src/pmc/role.pmc"

    PMC *ret_roles = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "roles"));
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_roles */
    /*BEGIN GENERATED ACCESSORS */
#line 1286 "./src/pmc/role.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_roles;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto roles_returns;
    /*END RETURN PMC *ret_roles */
    }
#line 724 "./src/pmc/role.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
roles_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1331 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_nci_add_role(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 2, 0, 2, 4 };
    opcode_t _param_indexes[]     = { 0, 1, 0, 2, 0, 1, 3, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 8);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 513);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 3, 130);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 4, 256);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 5, 513);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 6, 130);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 7, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1376 "./src/pmc/role.pmc"
    CTX_REG_STR(_ctx, 0) = CONST_STRING_GEN(interp, "exclude_method");
    CTX_REG_STR(_ctx, 1) = CONST_STRING_GEN(interp, "alias_method");

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1395 "./src/pmc/role.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* role = CTX_REG_PMC(_ctx, 1);
    PMC* exclude_method = CTX_REG_PMC(_ctx, 2);
    INTVAL got_exclude_method = CTX_REG_INT(_ctx, 0);
    PMC* alias_method = CTX_REG_PMC(_ctx, 3);
    INTVAL got_alias_method = CTX_REG_INT(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 746 "./src/pmc/role.pmc"

    Parrot_Role_attributes *role_info = PARROT_ROLE(pmc);
    STRING *s_name, *r_name;

    #line 1412 "./src/pmc/role.pmc"
Parrot_PCCINVOKE(interp, pmc, CONST_STRING_GEN(interp, "name"), "->S", &s_name);
#line 750 "./src/pmc/role.pmc"

    #line 1416 "./src/pmc/role.pmc"
Parrot_PCCINVOKE(interp, role, CONST_STRING_GEN(interp, "name"), "->S", &r_name);
#line 751 "./src/pmc/role.pmc"

    UNUSED(s_name);
    UNUSED(r_name);

    Parrot_ComposeRole(interp, role, exclude_method, got_exclude_method,
                       alias_method, got_alias_method,
                       role_info->methods, role_info->roles);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1440 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_nci_inspect(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1480 "./src/pmc/role.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1497 "./src/pmc/role.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* what = CTX_REG_STR(_ctx, 0);
    INTVAL got_what = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 770 "./src/pmc/role.pmc"

    PMC *found;

    /* Just delegate to the appropriate vtable method. */
    if (got_what)
        found = VTABLE_inspect_str(interp, pmc, what);
    else
        found = VTABLE_inspect(interp, pmc);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *found */
    /*BEGIN GENERATED ACCESSORS */
#line 1520 "./src/pmc/role.pmc"
    CTX_REG_PMC(_ctx, 0) = found;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto inspect_returns;
    /*END RETURN PMC *found */
    }
#line 779 "./src/pmc/role.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
inspect_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1565 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_nci_does(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1604 "./src/pmc/role.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1621 "./src/pmc/role.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 793 "./src/pmc/role.pmc"

    INTVAL does = VTABLE_does(interp, pmc, name);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL does */
    /*BEGIN GENERATED ACCESSORS */
#line 1636 "./src/pmc/role.pmc"
    CTX_REG_INT(_ctx, 0) = does;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto does_returns;
    /*END RETURN INTVAL does */
    }
#line 795 "./src/pmc/role.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
does_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1681 "./src/pmc/role.c"
}
PARROT_EXPORT  void
Parrot_Role_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Role");
}
PARROT_EXPORT  PMC *
Parrot_Role_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Role_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Role");
}
PARROT_EXPORT  FLOATVAL
Parrot_Role_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Role");
}
PARROT_EXPORT  INTVAL
Parrot_Role_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Role");
}
PARROT_EXPORT  PMC *
Parrot_Role_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Role");
}
PARROT_EXPORT  STRING *
Parrot_Role_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Role");
}
PARROT_EXPORT  FLOATVAL
Parrot_Role_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Role");
}
PARROT_EXPORT  INTVAL
Parrot_Role_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Role");
}
PARROT_EXPORT  PMC *
Parrot_Role_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Role");
}
PARROT_EXPORT  STRING *
Parrot_Role_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Role");
}
PARROT_EXPORT  void
Parrot_Role_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Role");
}
#include "pmc_default.h"
void
Parrot_Role_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Sname F_namespace Froles Fmethods Fattrib_metadata ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Role, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Role_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Role_add_method,
        Parrot_default_add_parent,
        Parrot_Role_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Role_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_Role_does,
        Parrot_Role_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Role_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_Role_init,
        Parrot_Role_init_pmc,
        Parrot_Role_inspect,
        Parrot_Role_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Role_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_Role_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Role, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Role_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Role_ro_add_method,
        Parrot_Role_ro_add_parent,
        Parrot_Role_ro_add_role,
        Parrot_Role_ro_add_vtable_override,
        Parrot_Role_ro_assign_pmc,
        Parrot_Role_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_default_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Role_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Role_ro_delete_keyed,
        Parrot_Role_ro_delete_keyed_int,
        Parrot_Role_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Role_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_Role_does,
        Parrot_Role_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Role_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Role_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Role_ro_i_absolute,
        Parrot_Role_ro_i_add,
        Parrot_Role_ro_i_add_float,
        Parrot_Role_ro_i_add_int,
        Parrot_Role_ro_i_bitwise_and,
        Parrot_Role_ro_i_bitwise_and_int,
        Parrot_Role_ro_i_bitwise_ands,
        Parrot_Role_ro_i_bitwise_ands_str,
        Parrot_Role_ro_i_bitwise_lsr,
        Parrot_Role_ro_i_bitwise_lsr_int,
        Parrot_Role_ro_i_bitwise_not,
        Parrot_Role_ro_i_bitwise_nots,
        Parrot_Role_ro_i_bitwise_or,
        Parrot_Role_ro_i_bitwise_or_int,
        Parrot_Role_ro_i_bitwise_ors,
        Parrot_Role_ro_i_bitwise_ors_str,
        Parrot_Role_ro_i_bitwise_shl,
        Parrot_Role_ro_i_bitwise_shl_int,
        Parrot_Role_ro_i_bitwise_shr,
        Parrot_Role_ro_i_bitwise_shr_int,
        Parrot_Role_ro_i_bitwise_xor,
        Parrot_Role_ro_i_bitwise_xor_int,
        Parrot_Role_ro_i_bitwise_xors,
        Parrot_Role_ro_i_bitwise_xors_str,
        Parrot_Role_ro_i_concatenate,
        Parrot_Role_ro_i_concatenate_str,
        Parrot_Role_ro_i_divide,
        Parrot_Role_ro_i_divide_float,
        Parrot_Role_ro_i_divide_int,
        Parrot_Role_ro_i_floor_divide,
        Parrot_Role_ro_i_floor_divide_float,
        Parrot_Role_ro_i_floor_divide_int,
        Parrot_Role_ro_i_logical_not,
        Parrot_Role_ro_i_modulus,
        Parrot_Role_ro_i_modulus_float,
        Parrot_Role_ro_i_modulus_int,
        Parrot_Role_ro_i_multiply,
        Parrot_Role_ro_i_multiply_float,
        Parrot_Role_ro_i_multiply_int,
        Parrot_Role_ro_i_neg,
        Parrot_Role_ro_i_pow,
        Parrot_Role_ro_i_pow_float,
        Parrot_Role_ro_i_pow_int,
        Parrot_Role_ro_i_repeat,
        Parrot_Role_ro_i_repeat_int,
        Parrot_Role_ro_i_subtract,
        Parrot_Role_ro_i_subtract_float,
        Parrot_Role_ro_i_subtract_int,
        Parrot_Role_ro_increment,
        Parrot_Role_init,
        Parrot_Role_init_pmc,
        Parrot_Role_inspect,
        Parrot_Role_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Role_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_Role_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Role_ro_pop_float,
        Parrot_Role_ro_pop_integer,
        Parrot_Role_ro_pop_pmc,
        Parrot_Role_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Role_ro_push_float,
        Parrot_Role_ro_push_integer,
        Parrot_Role_ro_push_pmc,
        Parrot_Role_ro_push_string,
        Parrot_Role_ro_remove_attribute,
        Parrot_Role_ro_remove_method,
        Parrot_Role_ro_remove_parent,
        Parrot_Role_ro_remove_role,
        Parrot_Role_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_Role_ro_set_attr_keyed,
        Parrot_Role_ro_set_attr_str,
        Parrot_Role_ro_set_bignum_int,
        Parrot_Role_ro_set_bignum_num,
        Parrot_Role_ro_set_bignum_str,
        Parrot_Role_ro_set_bool,
        Parrot_Role_ro_set_integer_keyed,
        Parrot_Role_ro_set_integer_keyed_int,
        Parrot_Role_ro_set_integer_keyed_str,
        Parrot_Role_ro_set_integer_native,
        Parrot_Role_ro_set_integer_same,
        Parrot_Role_ro_set_number_keyed,
        Parrot_Role_ro_set_number_keyed_int,
        Parrot_Role_ro_set_number_keyed_str,
        Parrot_Role_ro_set_number_native,
        Parrot_Role_ro_set_number_same,
        Parrot_Role_ro_set_pmc,
        Parrot_Role_ro_set_pmc_keyed,
        Parrot_Role_ro_set_pmc_keyed_int,
        Parrot_Role_ro_set_pmc_keyed_str,
        Parrot_Role_ro_set_pointer,
        Parrot_Role_ro_set_pointer_keyed,
        Parrot_Role_ro_set_pointer_keyed_int,
        Parrot_Role_ro_set_pointer_keyed_str,
        Parrot_Role_ro_set_string_keyed,
        Parrot_Role_ro_set_string_keyed_int,
        Parrot_Role_ro_set_string_keyed_str,
        Parrot_Role_ro_set_string_native,
        Parrot_Role_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Role_ro_shift_float,
        Parrot_Role_ro_shift_integer,
        Parrot_Role_ro_shift_pmc,
        Parrot_Role_ro_shift_string,
        Parrot_default_slice,
        Parrot_Role_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Role_ro_thaw,
        Parrot_Role_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Role_ro_unshift_float,
        Parrot_Role_ro_unshift_integer,
        Parrot_Role_ro_unshift_pmc,
        Parrot_Role_ro_unshift_string,
        Parrot_default_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Role");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Role")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Role"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_name), "name");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_get_namespace), "get_namespace");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_attributes), "attributes");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_add_attribute), "add_attribute");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_methods), "methods");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_add_method), "add_method");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_remove_method), "remove_method");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_roles), "roles");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_add_role), "add_role");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_inspect), "inspect");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Role_nci_does), "does");
        {
        }
    } /* pass */
} /* Parrot_Role_class_init */
#line 796 "./src/pmc/role.pmc"
 /* end pmclass Role */


/*

=back

=head1 STABILITY

Unstable. This PMC is under active development; major portions of the
interface have not yet been completed.

=head1 SEE ALSO

F<docs/pdds/pdd15_objects.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
