/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/scalar.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_scalar.h"
#include "pmc_default.h"
#include "scalar.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/scalar.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: scalar.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/scalar.pmc - Scalar Abstract Superclass

=head1 DESCRIPTION

These are the vtable functions for the scalar base PMC class

=head2 Methods

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "pmc_bigint.h"


static PMC *
bitwise_left_shift_internal(PARROT_INTERP, PMC *self,
                            PMC *dest, INTVAL shift_amount)
{
    /* This handles both left and right shifts; the sign of shift_amount
       controls the direction, shifting left if positive and right if negative.
       If we get an error (which can only happen for left shifts) and
       PARROT_ERRORS_OVERFLOW_FLAG is set, then we throw an error, else the
       destination is promoted to a BigInt before shifting.  If dest == self,
       then the shift is done in place.  */
    const INTVAL base = VTABLE_get_integer(interp, self);
    INTVAL result     = 0;
    int overflow_p    = 0;

    /* Compute the shift. */
    if (shift_amount >= 8*INTVAL_SIZE) {
        /* Extreme left shift; no need to do an integer shift first. */
        overflow_p = 1;
    }
    else if (shift_amount >= 0) {
        /* Left shift. */
        result = base << shift_amount;
        overflow_p = (result >> shift_amount) != base;
    }
    else if (shift_amount > -8*INTVAL_SIZE) {
        /* Right shift.  By definition, this can never overflow. */
        result = base >> -shift_amount;
    }
    else {
        /* Extreme right shift. */
        result = 0;
    }

    /* Store the result. */
    if (! overflow_p) {
        /* If SELF is the destination, we won't want to create a
           new PMC, because then we won't have the result in SELF.
           Only create a new PMC if we aren't saving the result
           to SELF, or if they are both NULL */
        if (dest != self || dest == NULL)
            dest = pmc_new(interp, VTABLE_type(interp, self));

        VTABLE_set_integer_native(interp, dest, result);
    }
    else if (PARROT_ERRORS_test(interp, PARROT_ERRORS_OVERFLOW_FLAG)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_ERR_OVERFLOW,
            "Integer overflow");
    }
    else {
        /* Overflow; must promote dest to BigInt, and do a BigInt shift. */
        if (self == dest)
            pmc_reuse(interp, self, enum_class_BigInt, 0);
        else
            dest = pmc_new(interp, enum_class_BigInt);

        VTABLE_set_integer_native(interp, dest, base);
        Parrot_BigInt_bitwise_shl_int(interp, dest, shift_amount, dest);
    }

    return dest;
}
#line 107 "./src/pmc/scalar.c"
PARROT_EXPORT  PMC  *
Parrot_scalar_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 221 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) + value);
    return dest;
#line 118 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_add_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 213 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) + (FLOATVAL)value);
    return dest;
#line 130 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 100 "./src/pmc/scalar.pmc"

    STRING * const s_int = CONST_STRING(interp, "Integer");
    STRING        *s_num;
    STRING        *s_str;

    if (pmc->vtable->base_type == enum_class_Boolean)
        /* doesn't morph */
        pmc_reuse(interp, pmc, value->vtable->base_type, 0);

    if (value->vtable->base_type == enum_class_Undef) {
        pmc_reuse(interp, pmc, value->vtable->base_type, 0);
        return;
    }

    if (VTABLE_isa(interp, value, s_int)) {
        const INTVAL v = VTABLE_get_integer(interp, value);
        VTABLE_set_integer_native(interp, pmc, v);
        return;
    }

    s_num = CONST_STRING(interp, "Float");

    if (VTABLE_isa(interp, value, s_num)) {
        const FLOATVAL v = VTABLE_get_number(interp, value);
        VTABLE_set_number_native(interp, pmc, v);
        return;
    }

    s_str = CONST_STRING(interp, "String");

    if (VTABLE_isa(interp, value, s_str)) {
        STRING * const v = VTABLE_get_string(interp, value);
        VTABLE_set_string_native(interp, pmc, v);
        return;
    }
    pmc_reuse(interp, pmc, enum_class_Ref, 0);
    VTABLE_set_pmc(interp, pmc, value);
#line 173 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 829 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) & VTABLE_get_integer(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 187 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 839 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) & value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 200 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 992 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >>
        VTABLE_get_integer(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 214 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1002 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >> value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 227 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_bitwise_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 920 "./src/pmc/scalar.pmc"

    const INTVAL a = ~VTABLE_get_integer(interp, pmc);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, a);
    return dest;
#line 240 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 779 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) | VTABLE_get_integer(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 253 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 789 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) | value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 266 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1042 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest,
                                       VTABLE_get_integer(interp, value));
#line 275 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1047 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest, value);
#line 283 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 956 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest,
                                       -VTABLE_get_integer(interp, value));
#line 292 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 961 "./src/pmc/scalar.pmc"

    return bitwise_left_shift_internal(interp, pmc, dest, -value);
#line 300 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_clone(PARROT_INTERP, PMC *pmc)
{
#line 149 "./src/pmc/scalar.pmc"

    PMC * const dest = pmc_new(interp, VTABLE_type(interp, pmc));
    memcpy(&PMC_union(dest), &PMC_union(pmc), sizeof (UnionVal));
    return dest;
#line 310 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_concatenate(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1084 "./src/pmc/scalar.pmc"

    STRING * const s = Parrot_str_concat(interp, VTABLE_get_string(interp, pmc),
        VTABLE_get_string(interp, value), 0);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_native(interp, dest, s);
    return dest;
#line 324 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value, PMC *dest)
{
#line 1094 "./src/pmc/scalar.pmc"

    STRING * const s = Parrot_str_concat(interp,
        VTABLE_get_string(interp, pmc), value, 0);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_native(interp, dest, s);
    return dest;
#line 338 "./src/pmc/scalar.c"
}
PARROT_EXPORT  INTVAL 
Parrot_scalar_defined(PARROT_INTERP, PMC *pmc)
{
#line 1360 "./src/pmc/scalar.pmc"

    return 1;
#line 346 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 448 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, VTABLE_get_number(interp, pmc) / value);
    return dest;
#line 361 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 437 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, VTABLE_get_number(interp, pmc) / value);
    return dest;
#line 376 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 533 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            floor(VTABLE_get_number(interp, pmc) / value));
    return dest;
#line 392 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 521 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            floor(VTABLE_get_number(interp, pmc) / value));
    return dest;
#line 408 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_add_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 249 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) + value);
#line 417 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_add_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 244 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) + (FLOATVAL)value);
#line 426 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_and(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 848 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) & VTABLE_get_integer(interp, value);
    VTABLE_set_integer_native(interp, pmc, result);
#line 436 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_and_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 855 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) & value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 445 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_lsr(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1011 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >>
            VTABLE_get_integer(interp, value);
    VTABLE_set_integer_native(interp, pmc, result);
#line 455 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_lsr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1017 "./src/pmc/scalar.pmc"

    const INTVAL result = (UINTVAL)VTABLE_get_integer(interp, pmc) >> value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 464 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_not(PARROT_INTERP, PMC *pmc)
{
#line 929 "./src/pmc/scalar.pmc"

    VTABLE_set_integer_native(interp, pmc, ~VTABLE_get_integer(interp, pmc));
#line 472 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_or(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 798 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) | VTABLE_get_integer(interp, value);

    VTABLE_set_integer_native(interp, pmc, result);
#line 483 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_or_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 806 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) | value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 492 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_shl(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1051 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc,
                                VTABLE_get_integer(interp, value));
#line 501 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_shl_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1056 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc, value);
#line 509 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_shr(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 965 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc,
                                -VTABLE_get_integer(interp, value));
#line 518 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_shr_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 970 "./src/pmc/scalar.pmc"

    bitwise_left_shift_internal(interp, pmc, pmc, -value);
#line 526 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_xor(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 897 "./src/pmc/scalar.pmc"

    const INTVAL result =
        VTABLE_get_integer(interp, pmc) ^ VTABLE_get_integer(interp, value);
    VTABLE_set_integer_native(interp, pmc, result);
#line 536 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_bitwise_xor_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 903 "./src/pmc/scalar.pmc"

    const INTVAL result = VTABLE_get_integer(interp, pmc) ^ value;
    VTABLE_set_integer_native(interp, pmc, result);
#line 545 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_concatenate(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1104 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    STRING * const v = VTABLE_get_string(interp, value);
    VTABLE_set_string_native(interp, pmc, Parrot_str_append(interp, s, v));
#line 555 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_concatenate_str(PARROT_INTERP, PMC *pmc, STRING *value)
{
#line 1110 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    VTABLE_set_string_native(interp, pmc, Parrot_str_append(interp, s, value));
#line 564 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 459 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) / d);
#line 578 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 477 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) / value);
#line 590 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 469 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) / value);
#line 602 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_floor_divide(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 545 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc,
            floor(VTABLE_get_number(interp, pmc) / d));
#line 617 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_floor_divide_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 565 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc,
            floor(VTABLE_get_number(interp, pmc) / value));
#line 630 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_floor_divide_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 556 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    VTABLE_set_number_native(interp, pmc,
            floor(VTABLE_get_number(interp, pmc) / value));
#line 643 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_logical_not(PARROT_INTERP, PMC *pmc)
{
#line 1346 "./src/pmc/scalar.pmc"

    VTABLE_set_bool(interp, pmc, ! VTABLE_get_bool(interp, pmc));
#line 651 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_modulus(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 635 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    VTABLE_set_number_native(interp, pmc,
            floatval_mod(VTABLE_get_number(interp, pmc), d));
#line 666 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 655 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    VTABLE_set_number_native(interp, pmc,
            floatval_mod(VTABLE_get_number(interp, pmc), value));
#line 679 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 646 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    VTABLE_set_number_native(interp, pmc,
            floatval_mod(VTABLE_get_number(interp, pmc), (FLOATVAL)value));
#line 692 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 398 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc, VTABLE_get_number(interp, pmc) * value);
#line 700 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 393 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) * (FLOATVAL)value);
#line 709 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_neg(PARROT_INTERP, PMC *pmc)
{
#line 751 "./src/pmc/scalar.pmc"

    VTABLE_set_integer_native(interp, pmc, -VTABLE_get_integer(interp, pmc));
#line 717 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_pow(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 713 "./src/pmc/scalar.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    VTABLE_set_number_native(interp, pmc,
            pow(VTABLE_get_number(interp, pmc), d));
#line 728 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 725 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
            pow(VTABLE_get_number(interp, pmc), value));
#line 737 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 720 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
            pow(VTABLE_get_number(interp, pmc), (float)value));
#line 746 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_repeat(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1156 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = (UINTVAL)VTABLE_get_integer(interp, value);
    VTABLE_set_string_native(interp, pmc, Parrot_str_repeat(interp, s, n));
#line 756 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 1162 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = value;
    VTABLE_set_string_native(interp, pmc, Parrot_str_repeat(interp, s, n));
#line 766 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value)
{
#line 334 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) - value);
#line 775 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_i_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value)
{
#line 329 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        VTABLE_get_number(interp, pmc) - (FLOATVAL)value);
#line 784 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_logical_and(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1293 "./src/pmc/scalar.pmc"

    if (VTABLE_get_bool(interp, pmc))
        return value;

    return pmc;
#line 795 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_logical_not(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 1337 "./src/pmc/scalar.pmc"

    const INTVAL a = ! VTABLE_get_bool(interp, pmc);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_bool(interp, dest, a);
    return dest;
#line 808 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_logical_or(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1275 "./src/pmc/scalar.pmc"

    if (VTABLE_get_bool(interp, pmc))
        return pmc;

    return value;
#line 819 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_logical_xor(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1310 "./src/pmc/scalar.pmc"

    const INTVAL my_bool    = VTABLE_get_bool(interp, pmc);
    const INTVAL value_bool = VTABLE_get_bool(interp, value);

    if (my_bool && ! value_bool)
        return pmc;
    else if (value_bool && ! my_bool)
        return value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));
    VTABLE_set_bool(interp, dest, 0);
    return dest;
#line 837 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_modulus_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 623 "./src/pmc/scalar.pmc"

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            floatval_mod(VTABLE_get_number(interp, pmc), value));
    return dest;
#line 853 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_modulus_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 611 "./src/pmc/scalar.pmc"

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            floatval_mod(VTABLE_get_number(interp, pmc), (FLOATVAL)value));
    return dest;
#line 869 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multiply_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 374 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
        VTABLE_get_number(interp, pmc) * value);
    return dest;
#line 881 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multiply_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 366 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
        VTABLE_get_number(interp, pmc) * value);
    return dest;
#line 893 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_neg(PARROT_INTERP, PMC *pmc, PMC *dest)
{
#line 742 "./src/pmc/scalar.pmc"

    const INTVAL a = -VTABLE_get_integer(interp, pmc);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, a);
    return dest;
#line 906 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_pow_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 705 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            pow(VTABLE_get_number(interp, pmc), value));
    return dest;
#line 918 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_pow_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 696 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            pow(VTABLE_get_number(interp, pmc), (double)value));

    return dest;
#line 931 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_repeat(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 1133 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = (UINTVAL)VTABLE_get_integer(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_native(interp, dest,
        Parrot_str_repeat(interp, s, n));
    return dest;
#line 946 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_repeat_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 1144 "./src/pmc/scalar.pmc"

    STRING * const s = VTABLE_get_string(interp, pmc);
    const UINTVAL  n = value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_string_native(interp, dest,
        Parrot_str_repeat(interp, s, n));
    return dest;
#line 961 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_share_ro(PARROT_INTERP, PMC *pmc)
{
#line 1389 "./src/pmc/scalar.pmc"

    PMC         *ret  = pt_shared_fixup(interp, pmc);
    PMC * const _true = pmc_new(interp, enum_class_Integer);

    VTABLE_set_integer_native(interp, _true, 1);

    /* first set readonly */
    VTABLE_setprop(interp, ret, CONST_STRING(interp, "_ro"), _true);

    /* now share; we add a PMC_EXT so we can identify the owning interp */
    add_pmc_sync(interp, ret);
    PObj_is_PMC_shared_SET(ret);

    /* XXX FIXME workaround lack of metadata sharing*/
    PMC_metadata(pmc) = NULL;

    return ret;
#line 984 "./src/pmc/scalar.c"
}
PARROT_EXPORT  STRING  *
Parrot_scalar_substr_str(PARROT_INTERP, PMC *pmc, INTVAL offset, INTVAL length)
{
#line 1375 "./src/pmc/scalar.pmc"

    return Parrot_str_substr(interp, VTABLE_get_string(interp, pmc),
        offset, length, NULL, 0);
#line 993 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_subtract_float(PARROT_INTERP, PMC *pmc, FLOATVAL value, PMC *dest)
{
#line 306 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) - value);
    return dest;
#line 1005 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_subtract_int(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 298 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            VTABLE_get_number(interp, pmc) - (FLOATVAL)value);
    return dest;
#line 1017 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_add_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 193 "./src/pmc/scalar.pmc"

    const FLOATVAL a = pmc->vtable->get_number(interp, pmc);

    dest = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a + VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            VTABLE_get_number_keyed_int(interp, value, 1));
    return dest;
#line 1033 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_add_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 205 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            pmc->vtable->get_number(interp, pmc) + VTABLE_get_number(interp, value));
    return dest;
#line 1045 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_multi_i_add_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 229 "./src/pmc/scalar.pmc"

    const FLOATVAL a = pmc->vtable->get_number(interp, pmc);

    pmc_reuse(interp, pmc, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, pmc,
            a + VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, pmc, 1,
            VTABLE_get_number_keyed_int(interp, value, 1));
#line 1059 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_multi_i_add_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 239 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        pmc->vtable->get_number(interp, pmc) + VTABLE_get_number(interp, value));
#line 1068 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_subtract_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 277 "./src/pmc/scalar.pmc"

    const FLOATVAL a = pmc->vtable->get_number(interp, pmc);
    if (dest)
        pmc_reuse(interp, dest, value->vtable->base_type, 0);
    else
        dest = pmc_new(interp, VTABLE_type(interp, value));

    VTABLE_set_number_native(interp, dest,
            a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, dest, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));
    return dest;
#line 1086 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_subtract_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 291 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));
    VTABLE_set_number_native(interp, dest,
            pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value));
    return dest;
#line 1097 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_multi_i_subtract_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 314 "./src/pmc/scalar.pmc"

    const FLOATVAL a = pmc->vtable->get_number(interp, pmc);

    pmc_reuse(interp, pmc, enum_class_Complex, 0);
    VTABLE_set_number_native(interp, pmc,
            a - VTABLE_get_number_keyed_int(interp, value, 0));
    VTABLE_set_number_keyed_int(interp, pmc, 1,
            -VTABLE_get_number_keyed_int(interp, value, 1));
#line 1111 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_multi_i_subtract_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 324 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        pmc->vtable->get_number(interp, pmc) - VTABLE_get_number(interp, value));
#line 1120 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_multiply_Complex_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 353 "./src/pmc/scalar.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED, "TODO mul<Float, Complex>");
#line 1129 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_multiply_DEFAULT_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 358 "./src/pmc/scalar.pmc"

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
        pmc->vtable->get_number(interp, pmc) * VTABLE_get_number(interp, value));
    return dest;
#line 1141 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_multi_i_multiply_Complex(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 382 "./src/pmc/scalar.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL,
        EXCEPTION_INTERNAL_NOT_IMPLEMENTED,
        "TODO i_mul<Float, Complex>");
#line 1151 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void 
Parrot_scalar_multi_i_multiply_DEFAULT(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 388 "./src/pmc/scalar.pmc"

    VTABLE_set_number_native(interp, pmc,
        pmc->vtable->get_number(interp, pmc) * VTABLE_get_number(interp, value));
#line 1160 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_divide_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 424 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, pmc->vtable->get_number(interp, pmc) / d);
    return dest;
#line 1177 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_floor_divide_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 507 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float division by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));
    d    = floor(pmc->vtable->get_number(interp, pmc) / d);

    VTABLE_set_integer_native(interp, dest, (INTVAL)d);
    return dest;
#line 1195 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_modulus_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 597 "./src/pmc/scalar.pmc"

    FLOATVAL d = VTABLE_get_number(interp, value);

    if (FLOAT_IS_ZERO(d))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "float modulus by zero");

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest,
            floatval_mod(pmc->vtable->get_number(interp, pmc), d));
    return dest;
#line 1213 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_pow_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 687 "./src/pmc/scalar.pmc"

    const FLOATVAL d = VTABLE_get_number(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_number_native(interp, dest, pow(pmc->vtable->get_number(interp, pmc), d));
    return dest;
#line 1226 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_bitwise_xor_PMC_PMC(PARROT_INTERP, PMC *pmc, PMC *value, PMC *dest)
{
#line 878 "./src/pmc/scalar.pmc"

    const INTVAL result =
        pmc->vtable->get_integer(interp, pmc) ^ VTABLE_get_integer(interp, value);

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 1240 "./src/pmc/scalar.c"
}
PARROT_EXPORT  PMC  *
Parrot_scalar_multi_bitwise_xor_int_INTVAL_PMC(PARROT_INTERP, PMC *pmc, INTVAL value, PMC *dest)
{
#line 888 "./src/pmc/scalar.pmc"

    const INTVAL result = pmc->vtable->get_integer(interp, pmc) ^ value;

    dest = pmc_new(interp, VTABLE_type(interp, pmc));

    VTABLE_set_integer_native(interp, dest, result);
    return dest;
#line 1253 "./src/pmc/scalar.c"
}
PARROT_EXPORT  INTVAL 
Parrot_scalar_multi_cmp_num_PMC(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1187 "./src/pmc/scalar.pmc"

    /* XXX - Floating-point precision errors possible? */
    FLOATVAL diff = VTABLE_get_number(interp, value) -
                    pmc->vtable->get_number(interp, pmc);

    return FLOAT_IS_ZERO(diff) ? 0 : diff < 0.0 ? -1 : 1;
#line 1265 "./src/pmc/scalar.c"
}
PARROT_EXPORT  INTVAL 
Parrot_scalar_multi_cmp_string_PMC(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1206 "./src/pmc/scalar.pmc"

    return Parrot_str_compare(interp, pmc->vtable->get_string(interp, pmc),
        VTABLE_get_string(interp, value));
#line 1274 "./src/pmc/scalar.c"
}
PARROT_EXPORT  INTVAL 
Parrot_scalar_multi_is_equal_PMC(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1221 "./src/pmc/scalar.pmc"

    return (pmc->vtable         == value->vtable
        &&  PMC_struct_val(pmc) == PMC_struct_val(value)
        &&  PMC_data(pmc)       == PMC_data(value));
#line 1284 "./src/pmc/scalar.c"
}
PARROT_EXPORT  INTVAL 
Parrot_scalar_multi_is_equal_num_PMC(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1237 "./src/pmc/scalar.pmc"

    return (VTABLE_get_number(interp, pmc) ==
            VTABLE_get_number(interp, value));
#line 1293 "./src/pmc/scalar.c"
}
PARROT_EXPORT  INTVAL 
Parrot_scalar_multi_is_equal_string_PMC(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 1252 "./src/pmc/scalar.pmc"

    return (0 != Parrot_str_equal(interp, VTABLE_get_string(interp, pmc),
                                      VTABLE_get_string(interp, value)));
#line 1302 "./src/pmc/scalar.c"
}
PARROT_EXPORT  void
Parrot_scalar_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of scalar");
}
PARROT_EXPORT  PMC *
Parrot_scalar_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of scalar");
}
PARROT_EXPORT  FLOATVAL
Parrot_scalar_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of scalar");
}
PARROT_EXPORT  INTVAL
Parrot_scalar_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of scalar");
}
PARROT_EXPORT  PMC *
Parrot_scalar_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of scalar");
}
PARROT_EXPORT  STRING *
Parrot_scalar_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of scalar");
}
PARROT_EXPORT  FLOATVAL
Parrot_scalar_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of scalar");
}
PARROT_EXPORT  INTVAL
Parrot_scalar_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of scalar");
}
PARROT_EXPORT  PMC *
Parrot_scalar_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of scalar");
}
PARROT_EXPORT  STRING *
Parrot_scalar_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of scalar");
}
PARROT_EXPORT  void
Parrot_scalar_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of scalar");
}
#include "pmc_default.h"
void
Parrot_scalar_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_scalar, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_scalar_add_float,
        Parrot_scalar_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_scalar_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_scalar_bitwise_and,
        Parrot_scalar_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_scalar_bitwise_lsr,
        Parrot_scalar_bitwise_lsr_int,
        Parrot_scalar_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_scalar_bitwise_or,
        Parrot_scalar_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_scalar_bitwise_shl,
        Parrot_scalar_bitwise_shl_int,
        Parrot_scalar_bitwise_shr,
        Parrot_scalar_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_scalar_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_scalar_concatenate,
        Parrot_scalar_concatenate_str,
        Parrot_default_decrement,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_divide,
        Parrot_scalar_divide_float,
        Parrot_scalar_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_scalar_floor_divide_float,
        Parrot_scalar_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_scalar_i_add_float,
        Parrot_scalar_i_add_int,
        Parrot_scalar_i_bitwise_and,
        Parrot_scalar_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_scalar_i_bitwise_lsr,
        Parrot_scalar_i_bitwise_lsr_int,
        Parrot_scalar_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_scalar_i_bitwise_or,
        Parrot_scalar_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_scalar_i_bitwise_shl,
        Parrot_scalar_i_bitwise_shl_int,
        Parrot_scalar_i_bitwise_shr,
        Parrot_scalar_i_bitwise_shr_int,
        Parrot_scalar_i_bitwise_xor,
        Parrot_scalar_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_scalar_i_concatenate,
        Parrot_scalar_i_concatenate_str,
        Parrot_scalar_i_divide,
        Parrot_scalar_i_divide_float,
        Parrot_scalar_i_divide_int,
        Parrot_scalar_i_floor_divide,
        Parrot_scalar_i_floor_divide_float,
        Parrot_scalar_i_floor_divide_int,
        Parrot_scalar_i_logical_not,
        Parrot_scalar_i_modulus,
        Parrot_scalar_i_modulus_float,
        Parrot_scalar_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_scalar_i_multiply_float,
        Parrot_scalar_i_multiply_int,
        Parrot_scalar_i_neg,
        Parrot_scalar_i_pow,
        Parrot_scalar_i_pow_float,
        Parrot_scalar_i_pow_int,
        Parrot_scalar_i_repeat,
        Parrot_scalar_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_scalar_i_subtract_float,
        Parrot_scalar_i_subtract_int,
        Parrot_default_increment,
        Parrot_default_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_scalar_logical_and,
        Parrot_scalar_logical_not,
        Parrot_scalar_logical_or,
        Parrot_scalar_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_scalar_modulus_float,
        Parrot_scalar_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_scalar_multiply_float,
        Parrot_scalar_multiply_int,
        Parrot_default_name,
        Parrot_scalar_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_scalar_pow_float,
        Parrot_scalar_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_scalar_repeat,
        Parrot_scalar_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_scalar_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_subtract,
        Parrot_scalar_subtract_float,
        Parrot_scalar_subtract_int,
        Parrot_default_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_default_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_scalar, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_scalar_ro_add_attribute,
        Parrot_scalar_add_float,
        Parrot_scalar_add_int,
        Parrot_scalar_ro_add_method,
        Parrot_scalar_ro_add_parent,
        Parrot_scalar_ro_add_role,
        Parrot_scalar_ro_add_vtable_override,
        Parrot_scalar_ro_assign_pmc,
        Parrot_scalar_ro_assign_string_native,
        Parrot_scalar_bitwise_and,
        Parrot_scalar_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_scalar_bitwise_lsr,
        Parrot_scalar_bitwise_lsr_int,
        Parrot_scalar_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_scalar_bitwise_or,
        Parrot_scalar_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_scalar_bitwise_shl,
        Parrot_scalar_bitwise_shl_int,
        Parrot_scalar_bitwise_shr,
        Parrot_scalar_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_scalar_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_scalar_concatenate,
        Parrot_scalar_concatenate_str,
        Parrot_scalar_ro_decrement,
        Parrot_scalar_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_scalar_ro_delete_keyed,
        Parrot_scalar_ro_delete_keyed_int,
        Parrot_scalar_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_default_destroy,
        Parrot_default_divide,
        Parrot_scalar_divide_float,
        Parrot_scalar_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_scalar_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_scalar_floor_divide_float,
        Parrot_scalar_floor_divide_int,
        Parrot_default_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_scalar_ro_i_absolute,
        Parrot_scalar_ro_i_add,
        Parrot_scalar_ro_i_add_float,
        Parrot_scalar_ro_i_add_int,
        Parrot_scalar_ro_i_bitwise_and,
        Parrot_scalar_ro_i_bitwise_and_int,
        Parrot_scalar_ro_i_bitwise_ands,
        Parrot_scalar_ro_i_bitwise_ands_str,
        Parrot_scalar_ro_i_bitwise_lsr,
        Parrot_scalar_ro_i_bitwise_lsr_int,
        Parrot_scalar_ro_i_bitwise_not,
        Parrot_scalar_ro_i_bitwise_nots,
        Parrot_scalar_ro_i_bitwise_or,
        Parrot_scalar_ro_i_bitwise_or_int,
        Parrot_scalar_ro_i_bitwise_ors,
        Parrot_scalar_ro_i_bitwise_ors_str,
        Parrot_scalar_ro_i_bitwise_shl,
        Parrot_scalar_ro_i_bitwise_shl_int,
        Parrot_scalar_ro_i_bitwise_shr,
        Parrot_scalar_ro_i_bitwise_shr_int,
        Parrot_scalar_ro_i_bitwise_xor,
        Parrot_scalar_ro_i_bitwise_xor_int,
        Parrot_scalar_ro_i_bitwise_xors,
        Parrot_scalar_ro_i_bitwise_xors_str,
        Parrot_scalar_ro_i_concatenate,
        Parrot_scalar_ro_i_concatenate_str,
        Parrot_scalar_ro_i_divide,
        Parrot_scalar_ro_i_divide_float,
        Parrot_scalar_ro_i_divide_int,
        Parrot_scalar_ro_i_floor_divide,
        Parrot_scalar_ro_i_floor_divide_float,
        Parrot_scalar_ro_i_floor_divide_int,
        Parrot_scalar_ro_i_logical_not,
        Parrot_scalar_ro_i_modulus,
        Parrot_scalar_ro_i_modulus_float,
        Parrot_scalar_ro_i_modulus_int,
        Parrot_scalar_ro_i_multiply,
        Parrot_scalar_ro_i_multiply_float,
        Parrot_scalar_ro_i_multiply_int,
        Parrot_scalar_ro_i_neg,
        Parrot_scalar_ro_i_pow,
        Parrot_scalar_ro_i_pow_float,
        Parrot_scalar_ro_i_pow_int,
        Parrot_scalar_ro_i_repeat,
        Parrot_scalar_ro_i_repeat_int,
        Parrot_scalar_ro_i_subtract,
        Parrot_scalar_ro_i_subtract_float,
        Parrot_scalar_ro_i_subtract_int,
        Parrot_scalar_ro_increment,
        Parrot_default_init,
        Parrot_default_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_scalar_logical_and,
        Parrot_scalar_logical_not,
        Parrot_scalar_logical_or,
        Parrot_scalar_logical_xor,
        Parrot_default_mark,
        Parrot_default_modulus,
        Parrot_scalar_modulus_float,
        Parrot_scalar_modulus_int,
        Parrot_scalar_ro_morph,
        Parrot_default_multiply,
        Parrot_scalar_multiply_float,
        Parrot_scalar_multiply_int,
        Parrot_default_name,
        Parrot_scalar_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_scalar_ro_pop_float,
        Parrot_scalar_ro_pop_integer,
        Parrot_scalar_ro_pop_pmc,
        Parrot_scalar_ro_pop_string,
        Parrot_default_pow,
        Parrot_scalar_pow_float,
        Parrot_scalar_pow_int,
        Parrot_scalar_ro_push_float,
        Parrot_scalar_ro_push_integer,
        Parrot_scalar_ro_push_pmc,
        Parrot_scalar_ro_push_string,
        Parrot_scalar_ro_remove_attribute,
        Parrot_scalar_ro_remove_method,
        Parrot_scalar_ro_remove_parent,
        Parrot_scalar_ro_remove_role,
        Parrot_scalar_ro_remove_vtable_override,
        Parrot_scalar_repeat,
        Parrot_scalar_repeat_int,
        Parrot_scalar_ro_set_attr_keyed,
        Parrot_scalar_ro_set_attr_str,
        Parrot_scalar_ro_set_bignum_int,
        Parrot_scalar_ro_set_bignum_num,
        Parrot_scalar_ro_set_bignum_str,
        Parrot_scalar_ro_set_bool,
        Parrot_scalar_ro_set_integer_keyed,
        Parrot_scalar_ro_set_integer_keyed_int,
        Parrot_scalar_ro_set_integer_keyed_str,
        Parrot_scalar_ro_set_integer_native,
        Parrot_scalar_ro_set_integer_same,
        Parrot_scalar_ro_set_number_keyed,
        Parrot_scalar_ro_set_number_keyed_int,
        Parrot_scalar_ro_set_number_keyed_str,
        Parrot_scalar_ro_set_number_native,
        Parrot_scalar_ro_set_number_same,
        Parrot_scalar_ro_set_pmc,
        Parrot_scalar_ro_set_pmc_keyed,
        Parrot_scalar_ro_set_pmc_keyed_int,
        Parrot_scalar_ro_set_pmc_keyed_str,
        Parrot_scalar_ro_set_pointer,
        Parrot_scalar_ro_set_pointer_keyed,
        Parrot_scalar_ro_set_pointer_keyed_int,
        Parrot_scalar_ro_set_pointer_keyed_str,
        Parrot_scalar_ro_set_string_keyed,
        Parrot_scalar_ro_set_string_keyed_int,
        Parrot_scalar_ro_set_string_keyed_str,
        Parrot_scalar_ro_set_string_native,
        Parrot_scalar_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_scalar_share_ro,
        Parrot_scalar_ro_shift_float,
        Parrot_scalar_ro_shift_integer,
        Parrot_scalar_ro_shift_pmc,
        Parrot_scalar_ro_shift_string,
        Parrot_default_slice,
        Parrot_scalar_ro_splice,
        Parrot_default_substr,
        Parrot_scalar_substr_str,
        Parrot_default_subtract,
        Parrot_scalar_subtract_float,
        Parrot_scalar_subtract_int,
        Parrot_scalar_ro_thaw,
        Parrot_scalar_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_scalar_ro_unshift_float,
        Parrot_scalar_ro_unshift_integer,
        Parrot_scalar_ro_unshift_pmc,
        Parrot_scalar_ro_unshift_string,
        Parrot_default_visit
    };

    const  multi_func_list _temp_multi_func_list[] = {
        { "add", 
          "PJPPP", 
          "scalar,Complex,PMC", 
          (funcptr_t) Parrot_scalar_multi_add_Complex_PMC },
        { "add", 
          "PJPPP", 
          "scalar,DEFAULT,PMC", 
          (funcptr_t) Parrot_scalar_multi_add_DEFAULT_PMC },
        { "i_add", 
          "vJPP", 
          "scalar,Complex", 
          (funcptr_t) Parrot_scalar_multi_i_add_Complex },
        { "i_add", 
          "vJPP", 
          "scalar,DEFAULT", 
          (funcptr_t) Parrot_scalar_multi_i_add_DEFAULT },
        { "subtract", 
          "PJPPP", 
          "scalar,Complex,PMC", 
          (funcptr_t) Parrot_scalar_multi_subtract_Complex_PMC },
        { "subtract", 
          "PJPPP", 
          "scalar,DEFAULT,PMC", 
          (funcptr_t) Parrot_scalar_multi_subtract_DEFAULT_PMC },
        { "i_subtract", 
          "vJPP", 
          "scalar,Complex", 
          (funcptr_t) Parrot_scalar_multi_i_subtract_Complex },
        { "i_subtract", 
          "vJPP", 
          "scalar,DEFAULT", 
          (funcptr_t) Parrot_scalar_multi_i_subtract_DEFAULT },
        { "multiply", 
          "PJPPP", 
          "scalar,Complex,PMC", 
          (funcptr_t) Parrot_scalar_multi_multiply_Complex_PMC },
        { "multiply", 
          "PJPPP", 
          "scalar,DEFAULT,PMC", 
          (funcptr_t) Parrot_scalar_multi_multiply_DEFAULT_PMC },
        { "i_multiply", 
          "vJPP", 
          "scalar,Complex", 
          (funcptr_t) Parrot_scalar_multi_i_multiply_Complex },
        { "i_multiply", 
          "vJPP", 
          "scalar,DEFAULT", 
          (funcptr_t) Parrot_scalar_multi_i_multiply_DEFAULT },
        { "divide", 
          "PJPPP", 
          "scalar,PMC,PMC", 
          (funcptr_t) Parrot_scalar_multi_divide_PMC_PMC },
        { "floor_divide", 
          "PJPPP", 
          "scalar,PMC,PMC", 
          (funcptr_t) Parrot_scalar_multi_floor_divide_PMC_PMC },
        { "modulus", 
          "PJPPP", 
          "scalar,PMC,PMC", 
          (funcptr_t) Parrot_scalar_multi_modulus_PMC_PMC },
        { "pow", 
          "PJPPP", 
          "scalar,PMC,PMC", 
          (funcptr_t) Parrot_scalar_multi_pow_PMC_PMC },
        { "bitwise_xor", 
          "PJPPP", 
          "scalar,PMC,PMC", 
          (funcptr_t) Parrot_scalar_multi_bitwise_xor_PMC_PMC },
        { "bitwise_xor_int", 
          "PJPIP", 
          "scalar,INTVAL,PMC", 
          (funcptr_t) Parrot_scalar_multi_bitwise_xor_int_INTVAL_PMC },
        { "cmp_num", 
          "IJPP", 
          "scalar,PMC", 
          (funcptr_t) Parrot_scalar_multi_cmp_num_PMC },
        { "cmp_string", 
          "IJPP", 
          "scalar,PMC", 
          (funcptr_t) Parrot_scalar_multi_cmp_string_PMC },
        { "is_equal", 
          "IJPP", 
          "scalar,PMC", 
          (funcptr_t) Parrot_scalar_multi_is_equal_PMC },
        { "is_equal_num", 
          "IJPP", 
          "scalar,PMC", 
          (funcptr_t) Parrot_scalar_multi_is_equal_num_PMC },
        { "is_equal_string", 
          "IJPP", 
          "scalar,PMC", 
          (funcptr_t) Parrot_scalar_multi_is_equal_string_PMC }
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "scalar");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "scalar")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "scalar"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_scalar_class_init */
#line 1406 "./src/pmc/scalar.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
