/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/sub.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "sub.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/sub.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: sub.pmc 37414 2009-03-14 15:58:25Z jonathan $

=head1 NAME

src/pmc/sub.pmc - Subroutine

=head1 DESCRIPTION

These are the vtable functions for the Sub (subroutine) base class

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/oplib/ops.h"
#include "sub.str"

static void
print_sub_name(PARROT_INTERP, PMC *sub)
{
    Interp * const tracer = (interp->pdb && interp->pdb->debugger) ?
        interp->pdb->debugger :
        interp;

    /* sub was located via globals */
    Parrot_io_eprintf(tracer, "# Calling sub '%Ss'\n# ",
        Parrot_full_sub_name(interp, sub));

    print_pbc_location(interp);
}

/*
 * A sub now contains more data like namespace, which makes it
 * effectively a container. Therefore need_ext has to be set
 */
#line 65 "./src/pmc/sub.c"
PARROT_EXPORT  void 
Parrot_Sub_assign_pmc(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 428 "./src/pmc/sub.pmc"

    Parrot_sub *my_sub, *other_sub;
    /* only handle the case where the other PMC is the same type */
    if (other->vtable->base_type == pmc->vtable->base_type) {
        /* copy the sub struct */
        PMC_get_sub(interp, pmc, my_sub);
        PMC_get_sub(interp, other, other_sub);
        memcpy(my_sub, other_sub, sizeof (struct Parrot_sub));

        /* copy the name so it's a different string in memory */
        my_sub->name = Parrot_str_copy(interp, my_sub->name);
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Can't assign a non-Sub type to a Sub");
#line 85 "./src/pmc/sub.c"
}
PARROT_EXPORT  PMC  *
Parrot_Sub_clone(PARROT_INTERP, PMC *pmc)
{
#line 391 "./src/pmc/sub.pmc"

    Parrot_sub *dest_sub;
    Parrot_sub *sub = mem_allocate_typed(Parrot_sub);
    PMC * const ret = pmc_new(interp, pmc->vtable->base_type);

    /* we have to mark it ourselves */
    PObj_custom_mark_destroy_SETALL(ret);

    /* first set the sub struct, Parrot_str_copy may cause GC */
    SETATTR_Sub_sub(interp, ret, sub);
    PMC_get_sub(interp, pmc, dest_sub);
    memcpy(sub, dest_sub, sizeof (Parrot_sub));
    if (sub->name != NULL)
        sub->name = Parrot_str_copy(interp, sub->name);

    if (sub->ctx)
        Parrot_context_ref(interp, sub->ctx);
    if (sub->outer_ctx)
        Parrot_context_ref(interp, sub->outer_ctx);

    return ret;
#line 112 "./src/pmc/sub.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Sub_defined(PARROT_INTERP, PMC *pmc)
{
#line 196 "./src/pmc/sub.pmc"

    return 1;
#line 120 "./src/pmc/sub.c"
}
PARROT_EXPORT  void 
Parrot_Sub_destroy(PARROT_INTERP, PMC *pmc)
{
#line 89 "./src/pmc/sub.pmc"

    Parrot_sub *sub;
    GETATTR_Sub_sub(interp, pmc, sub);

    if (!sub)
        return;
    if (sub->arg_info)
        mem_sys_free(sub->arg_info);
    if (sub->ctx)
        Parrot_free_context(interp, sub->ctx, 1);
    if (sub->outer_ctx)
        Parrot_free_context(interp, sub->outer_ctx, 1);

    mem_sys_free(sub);
    mem_sys_free(PMC_data(pmc));
    PMC_data(pmc) = NULL;
#line 142 "./src/pmc/sub.c"
}
PARROT_EXPORT  void 
Parrot_Sub_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 549 "./src/pmc/sub.pmc"

    IMAGE_IO   * const io  = info->image_io;
    Parrot_sub        *sub;
    STRING            *hll_name;
    int i;

    PMC_get_sub(interp, pmc, sub);

    Parrot_default_freeze(interp, pmc, info);
    /*
     * we currently need to write these items:
     * - start offset in byte-code segment
     * - end   offset in byte-code segment
     * - segment TODO ???
     * - flags  (i.e. :load pragma and such)
     * - name of the sub's label
     * - method name
     * - ns entry name
     * - namespace
     * - HLL_id
     * - multi_signature
     * - n_regs_used[i]
     * - lex_info
     * - vtable_index
     * - subid
     */

    VTABLE_push_integer(interp, io, (INTVAL) sub->start_offs);
    VTABLE_push_integer(interp, io, (INTVAL) sub->end_offs);
    VTABLE_push_integer(interp, io,
        (INTVAL)(PObj_get_FLAGS(pmc) & SUB_FLAG_PF_MASK));

    VTABLE_push_string(interp, io, sub->name);

    if (!sub->method_name)
        sub->method_name = CONST_STRING(interp, "");
    VTABLE_push_string(interp, io, sub->method_name);

    if (!sub->ns_entry_name)
        sub->ns_entry_name = CONST_STRING(interp, "");
    VTABLE_push_string(interp, io, sub->ns_entry_name);

    hll_name = Parrot_get_HLL_name(interp, sub->HLL_id);
    if (!hll_name)
        hll_name = CONST_STRING(interp, "");
    VTABLE_push_string(interp, io, hll_name);

    VTABLE_push_integer(interp, io, (INTVAL)sub->comp_flags);
    VTABLE_push_integer(interp, io, sub->vtable_index);

    for (i = 0; i < 4; ++i)
        VTABLE_push_integer(interp, io, sub->n_regs_used[i]);

    if (!sub->subid)
        sub->subid = CONST_STRING(interp, "");
    VTABLE_push_string(interp, io, sub->subid);
#line 204 "./src/pmc/sub.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Sub_get_bool(PARROT_INTERP, PMC *pmc)
{
#line 200 "./src/pmc/sub.pmc"

    return 1;
#line 212 "./src/pmc/sub.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Sub_get_integer_keyed(PARROT_INTERP, PMC *pmc, PMC *key)
{
#line 178 "./src/pmc/sub.pmc"

    Parrot_sub *sub;
    PMC_get_sub(interp, pmc, sub);
    return (INTVAL) (sub->seg->base.data);
#line 222 "./src/pmc/sub.c"
}
PARROT_EXPORT  void  *
Parrot_Sub_get_pointer(PARROT_INTERP, PMC *pmc)
{
#line 160 "./src/pmc/sub.pmc"

    Parrot_sub *sub;
    PMC_get_sub(interp, pmc, sub);
    return sub->seg->base.data + sub->start_offs;
#line 232 "./src/pmc/sub.c"
}
PARROT_EXPORT  STRING  *
Parrot_Sub_get_string(PARROT_INTERP, PMC *pmc)
{
#line 121 "./src/pmc/sub.pmc"

    Parrot_sub *sub;
    PMC_get_sub(interp, pmc, sub);
    return Parrot_str_copy(interp, sub->name);
#line 242 "./src/pmc/sub.c"
}
PARROT_EXPORT  void 
Parrot_Sub_init(PARROT_INTERP, PMC *pmc)
{
#line 70 "./src/pmc/sub.pmc"

    Parrot_Sub_attributes *attrs =
        mem_allocate_zeroed_typed(Parrot_Sub_attributes);

    attrs->sub     = new_sub(interp);
    PMC_data(pmc) = attrs;
    PObj_custom_mark_destroy_SETALL(pmc);
#line 255 "./src/pmc/sub.c"
}
PARROT_EXPORT  PMC  *
Parrot_Sub_inspect(PARROT_INTERP, PMC *pmc)
{
#line 660 "./src/pmc/sub.pmc"

    /* Create a hash, then use inspect_str to get all of the data to
     * fill it up with. */
    PMC    * const metadata    = pmc_new(interp, enum_class_Hash);
    STRING * const pos_required_str    = CONST_STRING(interp, "pos_required");
    STRING * const pos_optional_str      = CONST_STRING(interp, "pos_optional");
    STRING * const named_required_str   = CONST_STRING(interp, "named_required");
    STRING * const named_optional_str   = CONST_STRING(interp, "named_optional");
    STRING * const pos_slurpy_str = CONST_STRING(interp, "pos_slurpy");
    STRING * const named_slurpy_str   = CONST_STRING(interp, "named_slurpy");

    VTABLE_set_pmc_keyed_str(interp, metadata, pos_required_str,
        VTABLE_inspect_str(interp, pmc, pos_required_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, pos_optional_str,
        VTABLE_inspect_str(interp, pmc, pos_optional_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, named_required_str,
        VTABLE_inspect_str(interp, pmc, named_required_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, named_optional_str,
        VTABLE_inspect_str(interp, pmc, named_optional_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, pos_slurpy_str,
        VTABLE_inspect_str(interp, pmc, pos_slurpy_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, named_slurpy_str,
        VTABLE_inspect_str(interp, pmc, named_slurpy_str));

    return metadata;
#line 291 "./src/pmc/sub.c"
}
PARROT_EXPORT  PMC  *
Parrot_Sub_inspect_str(PARROT_INTERP, PMC *pmc, STRING *what)
{
#line 732 "./src/pmc/sub.pmc"

    Parrot_sub *sub;
    INTVAL count_found = -1;
    PMC *retval;

    PMC_get_sub(interp, pmc, sub);
    /* If the argument info hasn't been generated yet, generate it. */
    if (sub->arg_info == NULL)
    {
        /* Get pointer into the bytecode where this sub starts. */
        opcode_t *pc = sub->seg->base.data + sub->start_offs;

        /* Allocate structure to store argument information in. */
        sub->arg_info = mem_allocate_zeroed_typed(Parrot_sub_arginfo);

        /* If the first instruction is a get_params... */
        if (*pc == PARROT_OP_get_params_pc) {
            int     i, sig_length;
            PMC    *sig;

            /* Get the signature (the next thing in the bytecode). */
            pc++;
            sig = PF_CONST(sub->seg, *pc)->u.key;
            ASSERT_SIG_PMC(sig);

            /* Iterate over the signature and compute argument counts. */
            sig_length = VTABLE_elements(interp, sig);
            for (i = 0; i < sig_length; i++)
            {
                int sig_item = VTABLE_get_integer_keyed_int(interp, sig, i);;
                if (PARROT_ARG_SLURPY_ARRAY_ISSET(sig_item)){
                    if (PARROT_ARG_NAME_ISSET(sig_item))
                        sub->arg_info->named_slurpy = 1;
                    else
                        sub->arg_info->pos_slurpy = 1;
                }
                else if (PARROT_ARG_NAME_ISSET(sig_item)) {
                    i++;
                    sig_item = VTABLE_get_integer_keyed_int(interp, sig, i);;
                    if (PARROT_ARG_OPTIONAL_ISSET(sig_item))
                        sub->arg_info->named_optional++;
                    else
                        sub->arg_info->named_required++;
                }
                else if (!PARROT_ARG_OPT_FLAG_ISSET(sig_item)) {
                    if (PARROT_ARG_OPTIONAL_ISSET(sig_item))
                        sub->arg_info->pos_optional++;
                    else
                        sub->arg_info->pos_required++;
                }
            }
        }
    }

    /* Return the argument information that was requested. */
    if (Parrot_str_equal(interp, what, CONST_STRING(interp, "pos_required"))) {
        count_found = (INTVAL)sub->arg_info->pos_required;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "pos_optional"))) {
        count_found = (INTVAL)sub->arg_info->pos_optional;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "pos_slurpy"))) {
        count_found = (INTVAL)sub->arg_info->pos_slurpy;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "named_required"))) {
        count_found = (INTVAL)sub->arg_info->named_required;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "named_optional"))) {
        count_found = (INTVAL)sub->arg_info->named_optional;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "named_slurpy"))) {
        count_found = (INTVAL)sub->arg_info->named_slurpy;
    }
    else {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unknown introspection value '%S'", what);
    }

    retval = pmc_new(interp, enum_class_Integer);
    VTABLE_set_integer_native(interp, retval, count_found);
    return retval;
#line 378 "./src/pmc/sub.c"
}
PARROT_EXPORT  opcode_t  *
Parrot_Sub_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 214 "./src/pmc/sub.pmc"

    Parrot_sub     *sub;
    Parrot_Context *caller_ctx;
    Parrot_Context *context;
    Parrot_Context *c;
    PMC            *ccont;
    opcode_t       *pc;

    PMC_get_sub(interp, pmc, sub);
    if (Interp_trace_TEST(interp, PARROT_TRACE_SUB_CALL_FLAG))
        print_sub_name(interp, pmc);

    /*
     * A remark WRT tail calls
     *
     * we have:
     * sub A:
     *    ...
     *    B()
     *    ...
     * sub B:
     *    ...
     *    .return C(...)
     *
     * that is the sub B() returns whatever C() returns.
     *
     * We are just calling the sub C().
     * If the private2 flag is set, this code is called by a
     * tailcall opcode.
     *
     * We allocate a new register frame and recycle it
     * immediately after argument passing.
     *
     */
    pc                   = sub->seg->base.data + sub->start_offs;
    caller_ctx           = CONTEXT(interp);
    ccont                = interp->current_cont;
    interp->current_cont = NULL;

    if (ccont == NEED_CONTINUATION)
        ccont = new_ret_continuation_pmc(interp, (opcode_t *)next);

    PARROT_ASSERT(!PMC_IS_NULL(ccont));

    /*
     * plain subroutine call
     * create new context, place it in interpreter
     */
/*#define PREMATURE_OPT*/
#ifdef PREMATURE_OPT
    if (caller_ctx->current_sub == pmc)
        context = Parrot_dup_context(interp, caller_ctx);
    else
#endif
    context               = Parrot_set_new_context(interp, sub->n_regs_used);
    context->current_sub  = pmc;
    context->caller_ctx   = caller_ctx;
    context->current_pc   = pc;
    context->current_cont = ccont;

    /* check recursion/call depth */
    if (++context->recursion_depth > interp->recursion_limit)
        Parrot_ex_throw_from_c_args(interp, next, CONTROL_ERROR,
                "maximum recursion depth exceeded");

    /* and copy set context variables */
    PMC_cont(ccont)->from_ctx = context;

    /* if this is an outer sub, then we need to set sub->ctx
     * to the new context (refcounted) and convert the
     * retcontinuation to a normal continuation.
     */
    if (PObj_get_FLAGS(pmc) & SUB_FLAG_IS_OUTER) {
        /* release any previously held context */
        if (sub->ctx)
            Parrot_free_context(interp, sub->ctx, 1);
        sub->ctx = Parrot_context_ref(interp, context);
        /* convert retcontinuation to a continuation */
        ccont->vtable = interp->vtables[enum_class_Continuation];
    }

    /* reference counting should work */
    Parrot_context_ref(interp, context);

    if (!PMC_IS_NULL(interp->current_object)) {
        context->current_object = interp->current_object;
        interp->current_object  = NULL;
    }

    context->current_HLL       = sub->HLL_id;
    context->current_namespace = sub->namespace_stash;

    /* create pad if needed
     * TODO move this up in front of argument passing
     *      and factor out common code with coroutine pmc
     */
    if (!PMC_IS_NULL(sub->lex_info)) {
        context->lex_pad = pmc_new_init(interp,
                Parrot_get_ctx_HLL_type(interp, enum_class_LexPad),
                sub->lex_info);
        VTABLE_set_pointer(interp, context->lex_pad, context);
    }

    if (sub->outer_ctx) {
        /* set outer context */
        context->outer_ctx = Parrot_context_ref(interp, sub->outer_ctx);
    }
    else {
        /* autoclose */
        for (c = context; !c->outer_ctx; c = c->outer_ctx) {

            PMC         *outer_pmc;
            Parrot_sub  *current_sub, *outer_sub;

            PMC_get_sub(interp, c->current_sub, current_sub);
            outer_pmc   = current_sub->outer_sub;

            if (PMC_IS_NULL(outer_pmc))
                break;

            PMC_get_sub(interp, outer_pmc, outer_sub);

            if (!outer_sub->ctx) {
                Parrot_Context *dummy = Parrot_alloc_context(interp,
                                            outer_sub->n_regs_used, NULL);
                dummy->current_sub    = outer_pmc;

                if (!PMC_IS_NULL(outer_sub->lex_info)) {
                    dummy->lex_pad = pmc_new_init(interp,
                           Parrot_get_ctx_HLL_type(interp, enum_class_LexPad),
                           outer_sub->lex_info);
                    VTABLE_set_pointer(interp, dummy->lex_pad, dummy);
                }

                if (outer_sub->outer_ctx) {
                    dummy->outer_ctx = Parrot_context_ref(interp,
                                           outer_sub->outer_ctx);
                }
                outer_sub->ctx = Parrot_context_ref(interp, dummy);
            }

            c->outer_ctx = Parrot_context_ref(interp, outer_sub->ctx);
        }
    }

    /* switch code segment if needed */
    if (interp->code != sub->seg)
        Parrot_switch_to_cs(interp, sub->seg, 1);

    if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL) {
        if (!(*pc == PARROT_OP_get_params_pc ||
                    (*pc == PARROT_OP_push_eh_ic &&
                     pc[2] == PARROT_OP_get_params_pc))) {

            /* TODO keep it or resize it */
            --context->recursion_depth;

            PObj_get_FLAGS(ccont) &= ~SUB_FLAG_TAILCALL;
            context->caller_ctx    = caller_ctx->caller_ctx;

            Parrot_free_context(interp, caller_ctx, 1);
        }
    }

    return pc;
#line 549 "./src/pmc/sub.c"
}
PARROT_EXPORT  void 
Parrot_Sub_mark(PARROT_INTERP, PMC *pmc)
{
#line 455 "./src/pmc/sub.pmc"

    Parrot_sub *sub;
    PMC_get_sub(interp, pmc, sub);

    if (!sub)
        return;

    if (sub->name)
        pobject_lives(interp, (PObj *) sub->name);
    if (sub->method_name)
        pobject_lives(interp, (PObj *) sub->method_name);
    if (sub->ns_entry_name)
        pobject_lives(interp, (PObj *) sub->ns_entry_name);
    if (!PMC_IS_NULL(sub->namespace_name))
        pobject_lives(interp, (PObj *) sub->namespace_name);
    if (!PMC_IS_NULL(sub->multi_signature))
        pobject_lives(interp, (PObj *) sub->multi_signature);
    if (!PMC_IS_NULL(sub->lex_info))
        pobject_lives(interp, (PObj *) sub->lex_info);
    if (!PMC_IS_NULL(sub->outer_sub))
        pobject_lives(interp, (PObj *) sub->outer_sub);
    if (!PMC_IS_NULL(sub->eval_pmc))
        pobject_lives(interp, (PObj *) sub->eval_pmc);
    if (sub->subid)
        pobject_lives(interp, (PObj *) sub->subid);
    if (sub->ctx)
        mark_context(interp, sub->ctx);
    if (sub->outer_ctx)
        mark_context(interp, sub->outer_ctx);
#line 584 "./src/pmc/sub.c"
}
PARROT_EXPORT  void 
Parrot_Sub_set_pmc(PARROT_INTERP, PMC *pmc, PMC *other)
{
#line 424 "./src/pmc/sub.pmc"

    VTABLE_assign_pmc(interp, pmc, other);
#line 592 "./src/pmc/sub.c"
}
PARROT_EXPORT  void 
Parrot_Sub_set_pointer(PARROT_INTERP, PMC *pmc, void *value)
{
#line 145 "./src/pmc/sub.pmc"

    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
        "Don't set the address of a sub\nuse .const 'Sub' instead");
#line 601 "./src/pmc/sub.c"
}
PARROT_EXPORT  void 
Parrot_Sub_set_string_native(PARROT_INTERP, PMC *pmc, STRING *subname)
{
#line 127 "./src/pmc/sub.pmc"

    Parrot_sub *sub;
    PMC_get_sub(interp, pmc, sub);
    sub->name              = Parrot_str_copy(interp, subname);
#line 611 "./src/pmc/sub.c"
}
PARROT_EXPORT  void 
Parrot_Sub_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 617 "./src/pmc/sub.pmc"

    IMAGE_IO * const io = info->image_io;
    Parrot_default_thaw(interp, pmc, info);

    if (info->extra_flags == EXTRA_IS_NULL) {
        Parrot_sub *sub;
        INTVAL flags;
        int    i;

        PMC_get_sub(interp, pmc, sub);
        /* we get relative offsets */
        sub->start_offs   = (size_t) VTABLE_shift_integer(interp, io);
        sub->end_offs     = (size_t) VTABLE_shift_integer(interp, io);
        flags             = VTABLE_shift_integer(interp, io);

        PObj_get_FLAGS(pmc) |= flags & SUB_FLAG_PF_MASK;

        sub->name           = VTABLE_shift_string(interp, io);
        sub->method_name    = VTABLE_shift_string(interp, io);
        sub->ns_entry_name  = VTABLE_shift_string(interp, io);
        sub->HLL_id         = Parrot_get_HLL_id(interp,
            VTABLE_shift_string(interp, io));
        sub->comp_flags     = VTABLE_shift_integer(interp, io);
        sub->vtable_index   = VTABLE_shift_integer(interp, io);

        for (i = 0; i < 4; ++i)
            sub->n_regs_used[i] = VTABLE_shift_integer(interp, io);

        sub->subid        = VTABLE_shift_string(interp, io);
    }
#line 647 "./src/pmc/sub.c"
}
PARROT_EXPORT  void 
Parrot_Sub_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 522 "./src/pmc/sub.pmc"

    Parrot_sub *sub;

    PMC_get_sub(interp, pmc, sub);

    info->thaw_ptr = &sub->namespace_name;
    (info->visit_pmc_now)(interp, sub->namespace_name, info);

    info->thaw_ptr = &sub->multi_signature;
    (info->visit_pmc_now)(interp, sub->multi_signature, info);

    info->thaw_ptr = &sub->outer_sub;
    (info->visit_pmc_now)(interp, sub->outer_sub, info);

    /*
     * XXX visit_pmc_now is wrong, because it breaks
     *     depth-first visit inside the todo list
     * TODO change all user visit functions to use
     *    visit_pmc (the todo renamed visit_pm_later)
     *
     * Therefore the hash must be last during visit for now.
     */
    info->thaw_ptr = &sub->lex_info;
    (info->visit_pmc_now)(interp, sub->lex_info, info);
    Parrot_default_visit(interp, pmc, info);
#line 678 "./src/pmc/sub.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Sub_multi_is_equal_PMC(PARROT_INTERP, PMC *pmc, PMC *value)
{
#line 496 "./src/pmc/sub.pmc"


    Parrot_sub *my_sub, *value_sub;

    PMC_get_sub(interp, pmc, my_sub);
    PMC_get_sub(interp, value, value_sub);

    return pmc->vtable == value->vtable &&
        (my_sub)->start_offs == (value_sub)->start_offs &&
        (my_sub)->seg        == (value_sub)->seg;
#line 694 "./src/pmc/sub.c"
}
PARROT_EXPORT  void
Parrot_Sub_nci_get_namespace(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 732 "./src/pmc/sub.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 749 "./src/pmc/sub.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 858 "./src/pmc/sub.pmc"

    Parrot_sub *sub;
    PMC *_namespace;

    PMC_get_sub(interp, pmc, sub);
    _namespace = sub->namespace_stash;
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *_namespace */
    /*BEGIN GENERATED ACCESSORS */
#line 767 "./src/pmc/sub.pmc"
    CTX_REG_PMC(_ctx, 0) = _namespace;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_namespace_returns;
    /*END RETURN PMC *_namespace */
    }
#line 864 "./src/pmc/sub.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_namespace_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 812 "./src/pmc/sub.c"
}
PARROT_EXPORT  void
Parrot_Sub_nci___get_regs_used(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 851 "./src/pmc/sub.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 868 "./src/pmc/sub.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* reg = CTX_REG_STR(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 867 "./src/pmc/sub.pmc"


    /* TODO switch to canonical NiSP order
     * see also imcc/reg_alloc.c */
    static const char types[] = "INSP";
    char *p;
    Parrot_sub         *sub;
    char       * const kind = Parrot_str_to_cstring(interp, reg);
    INTVAL             regs_used;

    PMC_get_sub(interp, pmc, sub);

    PARROT_ASSERT(sub->n_regs_used);

    if (!*kind || kind[1]) {
        Parrot_str_free_cstring(kind);
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "illegal register kind '%Ss'", reg);
    }

    p = strchr(types, *kind);
    Parrot_str_free_cstring(kind);

    if (!p)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "illegal register kind '%Ss'", reg);

    regs_used = sub->n_regs_used[p - types];
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL regs_used */
    /*BEGIN GENERATED ACCESSORS */
#line 909 "./src/pmc/sub.pmc"
    CTX_REG_INT(_ctx, 0) = regs_used;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto __get_regs_used_returns;
    /*END RETURN INTVAL regs_used */
    }
#line 895 "./src/pmc/sub.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
__get_regs_used_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 954 "./src/pmc/sub.c"
}
PARROT_EXPORT  void
Parrot_Sub_nci_get_lexinfo(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 992 "./src/pmc/sub.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1009 "./src/pmc/sub.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 898 "./src/pmc/sub.pmc"

    Parrot_sub *sub;
    PMC        *lexinfo;

    PMC_get_sub(interp, pmc, sub);
    lexinfo = sub->lex_info ? sub->lex_info : PMCNULL;
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *lexinfo */
    /*BEGIN GENERATED ACCESSORS */
#line 1027 "./src/pmc/sub.pmc"
    CTX_REG_PMC(_ctx, 0) = lexinfo;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_lexinfo_returns;
    /*END RETURN PMC *lexinfo */
    }
#line 904 "./src/pmc/sub.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_lexinfo_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1072 "./src/pmc/sub.c"
}
PARROT_EXPORT  void
Parrot_Sub_nci_get_outer(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1110 "./src/pmc/sub.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1127 "./src/pmc/sub.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 907 "./src/pmc/sub.pmc"

    Parrot_sub *sub;
    PMC        *outersub;

    PMC_get_sub(interp, pmc, sub);
    outersub = sub->outer_sub ? sub->outer_sub : PMCNULL;
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *outersub */
    /*BEGIN GENERATED ACCESSORS */
#line 1145 "./src/pmc/sub.pmc"
    CTX_REG_PMC(_ctx, 0) = outersub;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_outer_returns;
    /*END RETURN PMC *outersub */
    }
#line 913 "./src/pmc/sub.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_outer_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1190 "./src/pmc/sub.c"
}
PARROT_EXPORT  void
Parrot_Sub_nci_set_outer(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1229 "./src/pmc/sub.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1246 "./src/pmc/sub.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* outer = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 916 "./src/pmc/sub.pmc"

    /* Set outer sub. */
    Parrot_sub *sub;

    PMC_get_sub(interp, pmc, sub);
    sub->outer_sub = outer;

    /* Make sure outer flag of that sub is set. */
    PObj_get_FLAGS(outer) |= SUB_FLAG_IS_OUTER;

    /* Ensure we have lex info. */
    if (PMC_IS_NULL(sub->lex_info)) {
        const INTVAL lex_info_id = Parrot_get_ctx_HLL_type(interp,
                                       enum_class_LexInfo);
        sub->lex_info = pmc_new_init(interp, lex_info_id, pmc);
    }

    /* If we've got a context around for the outer sub, set it as the
     * outer context. */
    if (CONTEXT(interp)->caller_ctx->caller_ctx->current_sub == outer)
        sub->outer_ctx = Parrot_context_ref(interp, CONTEXT(interp)->caller_ctx->caller_ctx);
    else if (CONTEXT(interp)->caller_ctx->current_sub == outer)
        sub->outer_ctx = Parrot_context_ref(interp, CONTEXT(interp)->caller_ctx);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1292 "./src/pmc/sub.c"
}
PARROT_EXPORT  void
Parrot_Sub_nci_get_multisig(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1330 "./src/pmc/sub.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1347 "./src/pmc/sub.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 941 "./src/pmc/sub.pmc"

    Parrot_sub *sub;
    PMC        *multisig;

    PMC_get_sub(interp, pmc, sub);
    multisig = sub->multi_signature ? sub->multi_signature : PMCNULL;
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *multisig */
    /*BEGIN GENERATED ACCESSORS */
#line 1365 "./src/pmc/sub.pmc"
    CTX_REG_PMC(_ctx, 0) = multisig;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_multisig_returns;
    /*END RETURN PMC *multisig */
    }
#line 947 "./src/pmc/sub.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_multisig_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1410 "./src/pmc/sub.c"
}
PARROT_EXPORT  void
Parrot_Sub_nci_arity(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1448 "./src/pmc/sub.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1465 "./src/pmc/sub.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 950 "./src/pmc/sub.pmc"

    PMC *pos_required = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "pos_required"));
    PMC *named_required = VTABLE_inspect_str(interp, pmc, CONST_STRING(interp, "named_required"));

    INTVAL arity = VTABLE_get_integer(interp, pos_required) +
        VTABLE_get_integer(interp, named_required);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL arity */
    /*BEGIN GENERATED ACCESSORS */
#line 1484 "./src/pmc/sub.pmc"
    CTX_REG_INT(_ctx, 0) = arity;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto arity_returns;
    /*END RETURN INTVAL arity */
    }
#line 957 "./src/pmc/sub.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
arity_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1529 "./src/pmc/sub.c"
}
PARROT_EXPORT  void
Parrot_Sub_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Sub");
}
PARROT_EXPORT  PMC *
Parrot_Sub_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Sub");
}
PARROT_EXPORT  FLOATVAL
Parrot_Sub_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Sub");
}
PARROT_EXPORT  INTVAL
Parrot_Sub_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Sub");
}
PARROT_EXPORT  PMC *
Parrot_Sub_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Sub");
}
PARROT_EXPORT  STRING *
Parrot_Sub_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Sub");
}
PARROT_EXPORT  FLOATVAL
Parrot_Sub_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Sub");
}
PARROT_EXPORT  INTVAL
Parrot_Sub_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Sub");
}
PARROT_EXPORT  PMC *
Parrot_Sub_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Sub");
}
PARROT_EXPORT  STRING *
Parrot_Sub_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Sub");
}
PARROT_EXPORT  void
Parrot_Sub_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Sub");
}
#include "pmc_default.h"
void
Parrot_Sub_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":sub ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Sub, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_Sub_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Sub_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Sub_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Sub_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Sub_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_Sub_init,
        Parrot_default_init_pmc,
        Parrot_Sub_inspect,
        Parrot_Sub_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_Sub_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Sub_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_Sub_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_Sub_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Sub_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Sub_thaw,
        Parrot_default_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Sub_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Sub, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Sub_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Sub_ro_add_method,
        Parrot_Sub_ro_add_parent,
        Parrot_Sub_ro_add_role,
        Parrot_Sub_ro_add_vtable_override,
        Parrot_Sub_ro_assign_pmc,
        Parrot_Sub_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Sub_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Sub_ro_decrement,
        Parrot_Sub_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Sub_ro_delete_keyed,
        Parrot_Sub_ro_delete_keyed_int,
        Parrot_Sub_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Sub_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Sub_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Sub_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_Sub_get_bool,
        Parrot_default_get_class,
        Parrot_default_get_integer,
        Parrot_Sub_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_Sub_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Sub_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Sub_ro_i_absolute,
        Parrot_Sub_ro_i_add,
        Parrot_Sub_ro_i_add_float,
        Parrot_Sub_ro_i_add_int,
        Parrot_Sub_ro_i_bitwise_and,
        Parrot_Sub_ro_i_bitwise_and_int,
        Parrot_Sub_ro_i_bitwise_ands,
        Parrot_Sub_ro_i_bitwise_ands_str,
        Parrot_Sub_ro_i_bitwise_lsr,
        Parrot_Sub_ro_i_bitwise_lsr_int,
        Parrot_Sub_ro_i_bitwise_not,
        Parrot_Sub_ro_i_bitwise_nots,
        Parrot_Sub_ro_i_bitwise_or,
        Parrot_Sub_ro_i_bitwise_or_int,
        Parrot_Sub_ro_i_bitwise_ors,
        Parrot_Sub_ro_i_bitwise_ors_str,
        Parrot_Sub_ro_i_bitwise_shl,
        Parrot_Sub_ro_i_bitwise_shl_int,
        Parrot_Sub_ro_i_bitwise_shr,
        Parrot_Sub_ro_i_bitwise_shr_int,
        Parrot_Sub_ro_i_bitwise_xor,
        Parrot_Sub_ro_i_bitwise_xor_int,
        Parrot_Sub_ro_i_bitwise_xors,
        Parrot_Sub_ro_i_bitwise_xors_str,
        Parrot_Sub_ro_i_concatenate,
        Parrot_Sub_ro_i_concatenate_str,
        Parrot_Sub_ro_i_divide,
        Parrot_Sub_ro_i_divide_float,
        Parrot_Sub_ro_i_divide_int,
        Parrot_Sub_ro_i_floor_divide,
        Parrot_Sub_ro_i_floor_divide_float,
        Parrot_Sub_ro_i_floor_divide_int,
        Parrot_Sub_ro_i_logical_not,
        Parrot_Sub_ro_i_modulus,
        Parrot_Sub_ro_i_modulus_float,
        Parrot_Sub_ro_i_modulus_int,
        Parrot_Sub_ro_i_multiply,
        Parrot_Sub_ro_i_multiply_float,
        Parrot_Sub_ro_i_multiply_int,
        Parrot_Sub_ro_i_neg,
        Parrot_Sub_ro_i_pow,
        Parrot_Sub_ro_i_pow_float,
        Parrot_Sub_ro_i_pow_int,
        Parrot_Sub_ro_i_repeat,
        Parrot_Sub_ro_i_repeat_int,
        Parrot_Sub_ro_i_subtract,
        Parrot_Sub_ro_i_subtract_float,
        Parrot_Sub_ro_i_subtract_int,
        Parrot_Sub_ro_increment,
        Parrot_Sub_init,
        Parrot_default_init_pmc,
        Parrot_Sub_inspect,
        Parrot_Sub_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_Sub_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Sub_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_Sub_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Sub_ro_pop_float,
        Parrot_Sub_ro_pop_integer,
        Parrot_Sub_ro_pop_pmc,
        Parrot_Sub_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Sub_ro_push_float,
        Parrot_Sub_ro_push_integer,
        Parrot_Sub_ro_push_pmc,
        Parrot_Sub_ro_push_string,
        Parrot_Sub_ro_remove_attribute,
        Parrot_Sub_ro_remove_method,
        Parrot_Sub_ro_remove_parent,
        Parrot_Sub_ro_remove_role,
        Parrot_Sub_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_Sub_ro_set_attr_keyed,
        Parrot_Sub_ro_set_attr_str,
        Parrot_Sub_ro_set_bignum_int,
        Parrot_Sub_ro_set_bignum_num,
        Parrot_Sub_ro_set_bignum_str,
        Parrot_Sub_ro_set_bool,
        Parrot_Sub_ro_set_integer_keyed,
        Parrot_Sub_ro_set_integer_keyed_int,
        Parrot_Sub_ro_set_integer_keyed_str,
        Parrot_Sub_ro_set_integer_native,
        Parrot_Sub_ro_set_integer_same,
        Parrot_Sub_ro_set_number_keyed,
        Parrot_Sub_ro_set_number_keyed_int,
        Parrot_Sub_ro_set_number_keyed_str,
        Parrot_Sub_ro_set_number_native,
        Parrot_Sub_ro_set_number_same,
        Parrot_Sub_ro_set_pmc,
        Parrot_Sub_ro_set_pmc_keyed,
        Parrot_Sub_ro_set_pmc_keyed_int,
        Parrot_Sub_ro_set_pmc_keyed_str,
        Parrot_Sub_ro_set_pointer,
        Parrot_Sub_ro_set_pointer_keyed,
        Parrot_Sub_ro_set_pointer_keyed_int,
        Parrot_Sub_ro_set_pointer_keyed_str,
        Parrot_Sub_ro_set_string_keyed,
        Parrot_Sub_ro_set_string_keyed_int,
        Parrot_Sub_ro_set_string_keyed_str,
        Parrot_Sub_ro_set_string_native,
        Parrot_Sub_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Sub_ro_shift_float,
        Parrot_Sub_ro_shift_integer,
        Parrot_Sub_ro_shift_pmc,
        Parrot_Sub_ro_shift_string,
        Parrot_default_slice,
        Parrot_Sub_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Sub_ro_thaw,
        Parrot_Sub_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Sub_ro_unshift_float,
        Parrot_Sub_ro_unshift_integer,
        Parrot_Sub_ro_unshift_pmc,
        Parrot_Sub_ro_unshift_string,
        Parrot_Sub_visit
    };

    const  multi_func_list _temp_multi_func_list[] = {
        { "is_equal", 
          "IJPP", 
          "Sub,PMC", 
          (funcptr_t) Parrot_Sub_multi_is_equal_PMC }
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Sub");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Sub")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Sub"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Sub_nci_get_namespace), "get_namespace");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Sub_nci___get_regs_used), "__get_regs_used");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Sub_nci_get_lexinfo), "get_lexinfo");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Sub_nci_get_outer), "get_outer");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Sub_nci_set_outer), "set_outer");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Sub_nci_get_multisig), "get_multisig");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Sub_nci_arity), "arity");
        {
#define N_MULTI_LIST (sizeof(_temp_multi_func_list)/sizeof(_temp_multi_func_list[0]))
            Parrot_mmd_add_multi_list_from_c_args(interp,
                _temp_multi_func_list, N_MULTI_LIST);
        }
    } /* pass */
} /* Parrot_Sub_class_init */
#line 958 "./src/pmc/sub.pmc"


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
