/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/timer.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_timer.h"
#include "pmc_task.h"
#include "pmc_default.h"
#include "timer.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/timer.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: timer.pmc 37201 2009-03-08 12:07:48Z fperrad $

=head1 NAME

src/pmc/timer.pmc - Timer

=head1 SYNOPSIS

    new P0, 'Timer'
    set P0[.PARROT_TIMER_SEC],     I_seconds       # whole seconds
    set P0[.PARROT_TIMER_USEC],    I_micro seconds # and/or micro seconds
    set P0[.PARROT_TIMER_NSEC],    N_seconds_frac  # or fraction in seconds
    set P0[.PARROT_TIMER_REPEAT],  I_repeat        # 0 = one shot ...
    set P0[.PARROT_TIMER_HANDLER], P_sub           # set handler sub PMC
    invoke P0                                      # start timer
    set P0[.PARROT_TIMER_RUNNING], 1               # same

    new P0, 'Timer', P1                            # set everything

    set I0, P0[.PARROT_TIMER_SEC]                  # query current timer status
    set N0, P0[.PARROT_TIMER_NSEC]
    ...
    set P0[.PARROT_TIMER_RUNNING], 0               # turn timer off


=head1 DESCRIPTION

This is the Timer base class

Running timers are kept in a linked list. Each timer has a tick count,
which gets decremented if the system timer expires. If the tick count
reaches zero, the timer handler gets invoked via Parrot's event handling
code.

The Timer resolution is operating system dependent. It's only guaranteed
that the Timer will fire some time after the programmed interval.

The Timer stops after invoking the handler (repeat + 1) times. To create a
Timer that will run forever, set "repeat" to -1. Turning the Timer off
preserves set values; the Timer is not destroyed.

When setting both C<PARROT_TIMER_SEC> and C<PARROT_TIMER_USEC> it must
be done in that sequence, whole seconds first. If a timer is constructed
with an initializer and it should be run immediately, the
C<PARROT_TIMER_RUNNING> value has to be in the last key of the
initializer.

=head2 Functions

=over 4

=cut

*/

#include "parrot/parrot.h"
#include "parrot/scheduler_private.h"
#line 82 "./src/pmc/timer.c"
PARROT_EXPORT  PMC  *
Parrot_Timer_clone(PARROT_INTERP, PMC *pmc)
{
#line 158 "./src/pmc/timer.pmc"

    PMC          * const copy       = Parrot_Task_clone(interp, pmc);
    Parrot_Timer_attributes * const new_struct = PARROT_TIMER(copy);
    Parrot_Timer_attributes * const old_struct = PARROT_TIMER(pmc);

    new_struct->duration  = old_struct->duration;
    new_struct->interval  = old_struct->interval;
    new_struct->repeat    = old_struct->repeat;

    return copy;
#line 97 "./src/pmc/timer.c"
}
PARROT_EXPORT  void 
Parrot_Timer_destroy(PARROT_INTERP, PMC *pmc)
{
#line 180 "./src/pmc/timer.pmc"

    Parrot_cx_delete_task(interp, pmc);
    mem_sys_free(PMC_data(pmc));
#line 106 "./src/pmc/timer.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Timer_get_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 195 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);
    const FLOATVAL absolute_time = core_struct->birthtime + core_struct->duration;

    switch (key) {
        case PARROT_TIMER_SEC:
            return (INTVAL)absolute_time;
        case PARROT_TIMER_USEC:
            return (INTVAL)((absolute_time - (INTVAL)absolute_time) *1000000.0);
        case PARROT_TIMER_REPEAT:
            return (INTVAL) core_struct->repeat;
        case PARROT_TIMER_INTERVAL:
            return (INTVAL) core_struct->interval;
        case PARROT_TIMER_RUNNING:
            return 0;
        default:
            return -1;
    }
#line 130 "./src/pmc/timer.c"
}
PARROT_EXPORT  FLOATVAL 
Parrot_Timer_get_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 244 "./src/pmc/timer.pmc"

    const Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);

    switch (key) {
        case PARROT_TIMER_NSEC:
            return core_struct->birthtime + core_struct->duration;
        case PARROT_TIMER_INTERVAL:
            return core_struct->interval;
        default:
            break;
    }

    return -1.0;
#line 149 "./src/pmc/timer.c"
}
PARROT_EXPORT  PMC  *
Parrot_Timer_get_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key)
{
#line 225 "./src/pmc/timer.pmc"

    if (key == PARROT_TIMER_HANDLER) {
        const Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);
        return core_struct->codeblock;
    }

    return PMCNULL;
#line 162 "./src/pmc/timer.c"
}
PARROT_EXPORT  void 
Parrot_Timer_init(PARROT_INTERP, PMC *pmc)
{
#line 76 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct =
        mem_allocate_zeroed_typed(Parrot_Timer_attributes);

    /* Set flags for custom GC mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);

    /* Set up the core struct. */
    PMC_data(pmc)           = core_struct;
    core_struct->id          = 0;
    core_struct->type        = CONST_STRING(interp, "timer");
    core_struct->subtype     = CONST_STRING(interp, "");
    core_struct->priority    = 0;
    core_struct->status      = CONST_STRING(interp, "created");
    core_struct->birthtime   = 0.0;
    core_struct->codeblock   = PMCNULL;
    core_struct->interp      = interp;
    core_struct->duration    = 0.0;
    core_struct->interval    = 0.0;
    core_struct->repeat      = 0;

    /* Make sure the flag is cleared by default */
    TASK_terminate_runloop_CLEAR(pmc);
#line 192 "./src/pmc/timer.c"
}
PARROT_EXPORT  void 
Parrot_Timer_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 112 "./src/pmc/timer.pmc"

    const INTVAL n = VTABLE_get_integer(interp, init);
    INTVAL       i;

    VTABLE_init(interp, pmc);

    for (i = 0; i < n; i += 2) {
        const INTVAL key = VTABLE_get_integer_keyed_int(interp, init, i);
        switch (key) {
            case PARROT_TIMER_SEC:
            case PARROT_TIMER_USEC:
            case PARROT_TIMER_REPEAT:
            case PARROT_TIMER_RUNNING:
                {
                const INTVAL val = VTABLE_get_integer_keyed_int(interp, init, i+1);
                VTABLE_set_integer_keyed_int(interp, pmc, key, val);
                }
                break;
            case PARROT_TIMER_NSEC:
                {
                const FLOATVAL nval = VTABLE_get_number_keyed_int(interp, init, i+1);
                VTABLE_set_number_keyed_int(interp, pmc, key, nval);
                }
                break;
            case PARROT_TIMER_HANDLER:
                {
                PMC * const pval = VTABLE_get_pmc_keyed_int(interp, init, i+1);
                VTABLE_set_pmc_keyed_int(interp, pmc, key, pval);
                }
                break;
            default:
                break;
        }
    }
#line 232 "./src/pmc/timer.c"
}
PARROT_EXPORT  opcode_t  *
Parrot_Timer_invoke(PARROT_INTERP, PMC *pmc, void *next)
{
#line 329 "./src/pmc/timer.pmc"

    Parrot_cx_schedule_task(interp, pmc);
    return (opcode_t *)next;
#line 241 "./src/pmc/timer.c"
}
PARROT_EXPORT  void 
Parrot_Timer_set_integer_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, INTVAL value)
{
#line 269 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);

    switch (key) {
        case PARROT_TIMER_SEC:
            core_struct->duration = value;
            break;
        case PARROT_TIMER_USEC:
            core_struct->duration += value / 1000000.0;
            break;
        case PARROT_TIMER_REPEAT:
            core_struct->repeat = value;
            break;
        case PARROT_TIMER_INTERVAL:
            core_struct->interval = value;
            break;
        case PARROT_TIMER_RUNNING:
            if (value)
                Parrot_cx_schedule_task(interp, pmc);
            else
                Parrot_cx_delete_task(interp, pmc);
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Unknown timer type in Timer.set_integer_keyed_int: %d",
                key);
    }
#line 275 "./src/pmc/timer.c"
}
PARROT_EXPORT  void 
Parrot_Timer_set_number_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, FLOATVAL value)
{
#line 344 "./src/pmc/timer.pmc"

    Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);

    switch (key) {
        case PARROT_TIMER_NSEC:
            core_struct->duration = value;
            break;
        case PARROT_TIMER_INTERVAL:
            core_struct->interval = value;
            break;
        default:
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Unknown timer attribute in Timer.set_number_keyed_int: %d",
                key);
    }
#line 297 "./src/pmc/timer.c"
}
PARROT_EXPORT  void 
Parrot_Timer_set_pmc_keyed_int(PARROT_INTERP, PMC *pmc, INTVAL key, PMC *value)
{
#line 309 "./src/pmc/timer.pmc"

    if (key == PARROT_TIMER_HANDLER) {
/*
        Parrot_Timer_attributes * const core_struct = PARROT_TIMER(pmc);
        core_struct->codeblock = value;
*/
        SETATTR_Timer_codeblock(interp, pmc, value);
    }
#line 311 "./src/pmc/timer.c"
}
PARROT_EXPORT  void
Parrot_Timer_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Timer");
}
PARROT_EXPORT  PMC *
Parrot_Timer_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Timer");
}
PARROT_EXPORT  FLOATVAL
Parrot_Timer_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Timer");
}
PARROT_EXPORT  INTVAL
Parrot_Timer_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Timer");
}
PARROT_EXPORT  PMC *
Parrot_Timer_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Timer");
}
PARROT_EXPORT  STRING *
Parrot_Timer_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Timer");
}
PARROT_EXPORT  FLOATVAL
Parrot_Timer_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Timer");
}
PARROT_EXPORT  INTVAL
Parrot_Timer_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Timer");
}
PARROT_EXPORT  PMC *
Parrot_Timer_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Timer");
}
PARROT_EXPORT  STRING *
Parrot_Timer_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Timer");
}
PARROT_EXPORT  void
Parrot_Timer_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Timer");
}
#include "pmc_default.h"
void
Parrot_Timer_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iid Ipriority Fbirthtime Stype Ssubtype Sstatus :interp Fcodeblock Fdata :cb_data Fduration Finterval Irepeat ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Timer, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_default_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_default_add_method,
        Parrot_default_add_parent,
        Parrot_default_add_role,
        Parrot_default_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Timer_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Timer_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Task_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_Task_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Task_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_Timer_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_Timer_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_Timer_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_Timer_init,
        Parrot_Timer_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_Timer_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Task_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_default_remove_attribute,
        Parrot_default_remove_method,
        Parrot_default_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_Task_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_Timer_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_Task_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_Timer_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_Task_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_Timer_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_Task_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_Task_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Task_thaw,
        Parrot_Task_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Task_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Timer, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Timer_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Timer_ro_add_method,
        Parrot_Timer_ro_add_parent,
        Parrot_Timer_ro_add_role,
        Parrot_Timer_ro_add_vtable_override,
        Parrot_Timer_ro_assign_pmc,
        Parrot_Timer_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Timer_clone,
        Parrot_default_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Timer_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Timer_ro_delete_keyed,
        Parrot_Timer_ro_delete_keyed_int,
        Parrot_Timer_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Timer_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_default_does,
        Parrot_default_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Timer_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Task_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_Task_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Task_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_Timer_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_Timer_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_Timer_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_default_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Timer_ro_i_absolute,
        Parrot_Timer_ro_i_add,
        Parrot_Timer_ro_i_add_float,
        Parrot_Timer_ro_i_add_int,
        Parrot_Timer_ro_i_bitwise_and,
        Parrot_Timer_ro_i_bitwise_and_int,
        Parrot_Timer_ro_i_bitwise_ands,
        Parrot_Timer_ro_i_bitwise_ands_str,
        Parrot_Timer_ro_i_bitwise_lsr,
        Parrot_Timer_ro_i_bitwise_lsr_int,
        Parrot_Timer_ro_i_bitwise_not,
        Parrot_Timer_ro_i_bitwise_nots,
        Parrot_Timer_ro_i_bitwise_or,
        Parrot_Timer_ro_i_bitwise_or_int,
        Parrot_Timer_ro_i_bitwise_ors,
        Parrot_Timer_ro_i_bitwise_ors_str,
        Parrot_Timer_ro_i_bitwise_shl,
        Parrot_Timer_ro_i_bitwise_shl_int,
        Parrot_Timer_ro_i_bitwise_shr,
        Parrot_Timer_ro_i_bitwise_shr_int,
        Parrot_Timer_ro_i_bitwise_xor,
        Parrot_Timer_ro_i_bitwise_xor_int,
        Parrot_Timer_ro_i_bitwise_xors,
        Parrot_Timer_ro_i_bitwise_xors_str,
        Parrot_Timer_ro_i_concatenate,
        Parrot_Timer_ro_i_concatenate_str,
        Parrot_Timer_ro_i_divide,
        Parrot_Timer_ro_i_divide_float,
        Parrot_Timer_ro_i_divide_int,
        Parrot_Timer_ro_i_floor_divide,
        Parrot_Timer_ro_i_floor_divide_float,
        Parrot_Timer_ro_i_floor_divide_int,
        Parrot_Timer_ro_i_logical_not,
        Parrot_Timer_ro_i_modulus,
        Parrot_Timer_ro_i_modulus_float,
        Parrot_Timer_ro_i_modulus_int,
        Parrot_Timer_ro_i_multiply,
        Parrot_Timer_ro_i_multiply_float,
        Parrot_Timer_ro_i_multiply_int,
        Parrot_Timer_ro_i_neg,
        Parrot_Timer_ro_i_pow,
        Parrot_Timer_ro_i_pow_float,
        Parrot_Timer_ro_i_pow_int,
        Parrot_Timer_ro_i_repeat,
        Parrot_Timer_ro_i_repeat_int,
        Parrot_Timer_ro_i_subtract,
        Parrot_Timer_ro_i_subtract_float,
        Parrot_Timer_ro_i_subtract_int,
        Parrot_Timer_ro_increment,
        Parrot_Timer_init,
        Parrot_Timer_init_pmc,
        Parrot_default_inspect,
        Parrot_default_inspect_str,
        Parrot_default_instantiate,
        Parrot_default_instantiate_str,
        Parrot_Timer_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_default_isa,
        Parrot_default_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Task_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_Timer_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Timer_ro_pop_float,
        Parrot_Timer_ro_pop_integer,
        Parrot_Timer_ro_pop_pmc,
        Parrot_Timer_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Timer_ro_push_float,
        Parrot_Timer_ro_push_integer,
        Parrot_Timer_ro_push_pmc,
        Parrot_Timer_ro_push_string,
        Parrot_Timer_ro_remove_attribute,
        Parrot_Timer_ro_remove_method,
        Parrot_Timer_ro_remove_parent,
        Parrot_Timer_ro_remove_role,
        Parrot_Timer_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_Timer_ro_set_attr_keyed,
        Parrot_Timer_ro_set_attr_str,
        Parrot_Timer_ro_set_bignum_int,
        Parrot_Timer_ro_set_bignum_num,
        Parrot_Timer_ro_set_bignum_str,
        Parrot_Timer_ro_set_bool,
        Parrot_Timer_ro_set_integer_keyed,
        Parrot_Timer_ro_set_integer_keyed_int,
        Parrot_Timer_ro_set_integer_keyed_str,
        Parrot_Timer_ro_set_integer_native,
        Parrot_Timer_ro_set_integer_same,
        Parrot_Timer_ro_set_number_keyed,
        Parrot_Timer_ro_set_number_keyed_int,
        Parrot_Timer_ro_set_number_keyed_str,
        Parrot_Timer_ro_set_number_native,
        Parrot_Timer_ro_set_number_same,
        Parrot_Timer_ro_set_pmc,
        Parrot_Timer_ro_set_pmc_keyed,
        Parrot_Timer_ro_set_pmc_keyed_int,
        Parrot_Timer_ro_set_pmc_keyed_str,
        Parrot_Timer_ro_set_pointer,
        Parrot_Timer_ro_set_pointer_keyed,
        Parrot_Timer_ro_set_pointer_keyed_int,
        Parrot_Timer_ro_set_pointer_keyed_str,
        Parrot_Timer_ro_set_string_keyed,
        Parrot_Timer_ro_set_string_keyed_int,
        Parrot_Timer_ro_set_string_keyed_str,
        Parrot_Timer_ro_set_string_native,
        Parrot_Timer_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_Task_share_ro,
        Parrot_Timer_ro_shift_float,
        Parrot_Timer_ro_shift_integer,
        Parrot_Timer_ro_shift_pmc,
        Parrot_Timer_ro_shift_string,
        Parrot_default_slice,
        Parrot_Timer_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Timer_ro_thaw,
        Parrot_Timer_ro_thawfinish,
        Parrot_default_type,
        Parrot_default_type_keyed,
        Parrot_Timer_ro_unshift_float,
        Parrot_Timer_ro_unshift_integer,
        Parrot_Timer_ro_unshift_pmc,
        Parrot_Timer_ro_unshift_string,
        Parrot_Task_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Timer");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "event");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Timer")), PMCNULL);
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Task")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Timer"));
            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Task"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_Timer_class_init */
#line 360 "./src/pmc/timer.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
