/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically by tools/build/nativecall.pl
 * from definitions in src/call_list.txt
 *
 * Any changes made here will be lost!
 *
 */

/* nci.c
 *  Copyright (C) 2001-2007, Parrot Foundation.
 *  SVN Info
 *     $Id$
 *  Overview:
 *     Native Call Interface routines. The code needed to build a
 *     parrot to C call frame is in here
 *  Data Structure and Algorithms:
 *  History:
 *  Notes:
 *  References:
 */
#include "parrot/parrot.h"
#include "parrot/hash.h"
#include "parrot/oplib/ops.h"
#include "pmc/pmc_nci.h"
#include "nci.str"

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

/*
 * if the architecture can build some or all of these signatures
 * enable the define below
 * - the JITed function will be called first
 * - if it returns NULL, the hardcoded version will do the job
 */

#if defined(HAS_JIT) && defined(I386)
#  include "parrot/exec.h"
#  include "jit.h"
#  define CAN_BUILD_CALL_FRAMES
#endif

/*
 * helper funcs - get argument n
 */
static INTVAL
get_nci_I(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    if (n >= st->src.n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "too few arguments passed to NCI function");

    Parrot_fetch_arg_nci(interp, st);

    return UVal_int(st->val);
}

static FLOATVAL
get_nci_N(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    if (n >= st->src.n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "too few arguments passed to NCI function");

    Parrot_fetch_arg_nci(interp, st);

    return UVal_num(st->val);
}

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static STRING*
get_nci_S(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    /* TODO or act like below? */
    if (n >= st->src.n)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "too few arguments passed to NCI function");

    Parrot_fetch_arg_nci(interp, st);

    return UVal_str(st->val);
}

PARROT_WARN_UNUSED_RESULT
PARROT_CANNOT_RETURN_NULL
static PMC*
get_nci_P(PARROT_INTERP, ARGMOD(call_state *st), int n)
{
    /*
     * excessive args are passed as NULL
     * used by e.g. MMD infix like __add
     */
    if (n < st->src.n)
        Parrot_fetch_arg_nci(interp, st);
    else
        UVal_pmc(st->val) = PMCNULL;

    return UVal_pmc(st->val);
}

#define GET_NCI_I(n) get_nci_I(interp, &st, n)
#define GET_NCI_S(n) get_nci_S(interp, &st, n)
#define GET_NCI_N(n) get_nci_N(interp, &st, n)
#define GET_NCI_P(n) get_nci_P(interp, &st, n)

/*
 * set return value
 */
static void
set_nci_I(PARROT_INTERP, ARGOUT(call_state *st), INTVAL val)
{
    Parrot_init_ret_nci(interp, st, "I");
    if (st->dest.i < st->dest.n) {
        UVal_int(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_N(PARROT_INTERP, ARGOUT(call_state *st), FLOATVAL val)
{
    Parrot_init_ret_nci(interp, st, "N");
    if (st->dest.i < st->dest.n) {
        UVal_num(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_S(PARROT_INTERP, ARGOUT(call_state *st), STRING *val)
{
    Parrot_init_ret_nci(interp, st, "S");
    if (st->dest.i < st->dest.n) {
        UVal_str(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

static void
set_nci_P(PARROT_INTERP, ARGOUT(call_state *st), PMC* val)
{
    Parrot_init_ret_nci(interp, st, "P");
    if (st->dest.i < st->dest.n) {
        UVal_pmc(st->val) = val;
        Parrot_convert_arg(interp, st);
        Parrot_store_arg(interp, st);
    }
}

/* All our static functions that call in various ways. Yes, terribly
   hackish, but that is just fine */

static void
pcf_d_JOd(PARROT_INTERP, PMC *self)
{
    typedef double (*func_t)(PARROT_INTERP, PMC *, double);
    func_t pointer;
    void *orig_func;
    call_state st;
    double return_data;
    PMC *t_1;
    double t_2;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_1 = GET_NCI_P(0);
    t_2 = (double)GET_NCI_N(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (double)(*pointer)(interp,PMC_IS_NULL(t_1) ? NULL : t_1,t_2);
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_I_JOS(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_4;
    STRING * t_5;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_4 = GET_NCI_P(0);
    t_5 = (STRING *)GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_4) ? NULL : t_4,t_5);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOl(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_7;
    long t_8;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_7 = GET_NCI_P(0);
    t_8 = (long)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_7) ? NULL : t_7,t_8);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_Jt(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    char *t_10;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_10 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,t_10);
    set_nci_P(interp, &st, return_data);
    do { if (t_10) Parrot_str_free_cstring(t_10); } while (0);
}
static void
pcf_S_JOS(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    PMC *t_12;
    STRING * t_13;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_12 = GET_NCI_P(0);
    t_13 = (STRING *)GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_12) ? NULL : t_12,t_13);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_I_JI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    INTVAL t_15;
    Parrot_init_arg_nci(interp, &st, "I");
    t_15 = (INTVAL)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,t_15);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_JOSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_17;
    STRING * t_18;
    PMC *t_19;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_17 = GET_NCI_P(0);
    t_18 = (STRING *)GET_NCI_S(1);
    t_19 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_17) ? NULL : t_17,t_18,PMC_IS_NULL(t_19) ? NULL : t_19);
    
    
}
static void
pcf_v_JOS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_21;
    STRING * t_22;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_21 = GET_NCI_P(0);
    t_22 = (STRING *)GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_21) ? NULL : t_21,t_22);
    
    
}
static void
pcf_P_JOS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_24;
    STRING * t_25;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_24 = GET_NCI_P(0);
    t_25 = (STRING *)GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_24) ? NULL : t_24,t_25);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JOI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_27;
    INTVAL t_28;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_27 = GET_NCI_P(0);
    t_28 = (INTVAL)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_27) ? NULL : t_27,t_28);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_30;
    PMC *t_31;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_30 = GET_NCI_P(0);
    t_31 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_30) ? NULL : t_30,PMC_IS_NULL(t_31) ? NULL : t_31);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOPS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_33;
    PMC *t_34;
    STRING * t_35;
    Parrot_init_arg_nci(interp, &st, "PPS");
    t_33 = GET_NCI_P(0);
    t_34 = GET_NCI_P(1);
    t_35 = (STRING *)GET_NCI_S(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_33) ? NULL : t_33,PMC_IS_NULL(t_34) ? NULL : t_34,t_35);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOPSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, STRING *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_37;
    PMC *t_38;
    STRING * t_39;
    PMC *t_40;
    Parrot_init_arg_nci(interp, &st, "PPSP");
    t_37 = GET_NCI_P(0);
    t_38 = GET_NCI_P(1);
    t_39 = (STRING *)GET_NCI_S(2);
    t_40 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_37) ? NULL : t_37,PMC_IS_NULL(t_38) ? NULL : t_38,t_39,PMC_IS_NULL(t_40) ? NULL : t_40);
    
    
}
static void
pcf_v_JPPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_42;
    PMC *t_43;
    PMC *t_44;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_42 = GET_NCI_P(0);
    t_43 = GET_NCI_P(1);
    t_44 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_42) ? NULL : t_42,PMC_IS_NULL(t_43) ? NULL : t_43,PMC_IS_NULL(t_44) ? NULL : t_44);
    
    
}
static void
pcf_v_JPIP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_46;
    INTVAL t_47;
    PMC *t_48;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_46 = GET_NCI_P(0);
    t_47 = (INTVAL)GET_NCI_I(1);
    t_48 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_46) ? NULL : t_46,t_47,PMC_IS_NULL(t_48) ? NULL : t_48);
    
    
}
static void
pcf_v_JPSP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_50;
    STRING * t_51;
    PMC *t_52;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_50 = GET_NCI_P(0);
    t_51 = (STRING *)GET_NCI_S(1);
    t_52 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_50) ? NULL : t_50,t_51,PMC_IS_NULL(t_52) ? NULL : t_52);
    
    
}
static void
pcf_v_JPNP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_54;
    FLOATVAL t_55;
    PMC *t_56;
    Parrot_init_arg_nci(interp, &st, "PNP");
    t_54 = GET_NCI_P(0);
    t_55 = (FLOATVAL)GET_NCI_N(1);
    t_56 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_54) ? NULL : t_54,t_55,PMC_IS_NULL(t_56) ? NULL : t_56);
    
    
}
static void
pcf_v_JPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_58;
    PMC *t_59;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_58 = GET_NCI_P(0);
    t_59 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_58) ? NULL : t_58,PMC_IS_NULL(t_59) ? NULL : t_59);
    
    
}
static void
pcf_v_JPI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_61;
    INTVAL t_62;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_61 = GET_NCI_P(0);
    t_62 = (INTVAL)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_61) ? NULL : t_61,t_62);
    
    
}
static void
pcf_v_JPS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_64;
    STRING * t_65;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_64 = GET_NCI_P(0);
    t_65 = (STRING *)GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_64) ? NULL : t_64,t_65);
    
    
}
static void
pcf_v_JPN(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_67;
    FLOATVAL t_68;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_67 = GET_NCI_P(0);
    t_68 = (FLOATVAL)GET_NCI_N(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_67) ? NULL : t_67,t_68);
    
    
}
static void
pcf_P_JPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_70;
    PMC *t_71;
    PMC *t_72;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_70 = GET_NCI_P(0);
    t_71 = GET_NCI_P(1);
    t_72 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_70) ? NULL : t_70,PMC_IS_NULL(t_71) ? NULL : t_71,PMC_IS_NULL(t_72) ? NULL : t_72);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPIP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_74;
    INTVAL t_75;
    PMC *t_76;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_74 = GET_NCI_P(0);
    t_75 = (INTVAL)GET_NCI_I(1);
    t_76 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_74) ? NULL : t_74,t_75,PMC_IS_NULL(t_76) ? NULL : t_76);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPSP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_78;
    STRING * t_79;
    PMC *t_80;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_78 = GET_NCI_P(0);
    t_79 = (STRING *)GET_NCI_S(1);
    t_80 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_78) ? NULL : t_78,t_79,PMC_IS_NULL(t_80) ? NULL : t_80);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPNP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, FLOATVAL, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_82;
    FLOATVAL t_83;
    PMC *t_84;
    Parrot_init_arg_nci(interp, &st, "PNP");
    t_82 = GET_NCI_P(0);
    t_83 = (FLOATVAL)GET_NCI_N(1);
    t_84 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_82) ? NULL : t_82,t_83,PMC_IS_NULL(t_84) ? NULL : t_84);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JPP(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_86;
    PMC *t_87;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_86 = GET_NCI_P(0);
    t_87 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_86) ? NULL : t_86,PMC_IS_NULL(t_87) ? NULL : t_87);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_89;
    Parrot_init_arg_nci(interp, &st, "P");
    t_89 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_89) ? NULL : t_89);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_JP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_91;
    Parrot_init_arg_nci(interp, &st, "P");
    t_91 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_91) ? NULL : t_91);
    
    
}
static void
pcf_i_JPi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_93;
    int t_94;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_93 = GET_NCI_P(0);
    t_94 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_93) ? NULL : t_93,t_94);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_96;
    int t_97;
    int t_98;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_96 = GET_NCI_P(0);
    t_97 = (int)GET_NCI_I(1);
    t_98 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_96) ? NULL : t_96,t_97,t_98);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_100;
    int t_101;
    int t_102;
    int t_103;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_100 = GET_NCI_P(0);
    t_101 = (int)GET_NCI_I(1);
    t_102 = (int)GET_NCI_I(2);
    t_103 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_100) ? NULL : t_100,t_101,t_102,t_103);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_105;
    char *t_106;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_105 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_106 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_105) ? NULL : t_105,t_106);
    set_nci_I(interp, &st, return_data);
    do { if (t_106) Parrot_str_free_cstring(t_106); } while (0);
}
static void
pcf_P_JOSSS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, STRING *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_108;
    STRING * t_109;
    STRING * t_110;
    STRING * t_111;
    Parrot_init_arg_nci(interp, &st, "PSSS");
    t_108 = GET_NCI_P(0);
    t_109 = (STRING *)GET_NCI_S(1);
    t_110 = (STRING *)GET_NCI_S(2);
    t_111 = (STRING *)GET_NCI_S(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_108) ? NULL : t_108,t_109,t_110,t_111);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOSS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_113;
    STRING * t_114;
    STRING * t_115;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_113 = GET_NCI_P(0);
    t_114 = (STRING *)GET_NCI_S(1);
    t_115 = (STRING *)GET_NCI_S(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_113) ? NULL : t_113,t_114,t_115);
    
    
}
static void
pcf_S_JOI(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    PMC *t_117;
    INTVAL t_118;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_117 = GET_NCI_P(0);
    t_118 = (INTVAL)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_117) ? NULL : t_117,t_118);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_v_JOb(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_120;
    STRING *t_121;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_120 = GET_NCI_P(0);
    t_121 = GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_120) ? NULL : t_120,PObj_bufstart(t_121));
    
    
}
static void
pcf_i_JOPxAT_(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_123;
    PMC *t_124;
    PMC *t_125;
    Parrot_init_arg_nci(interp, &st, "PP@");
    t_123 = GET_NCI_P(0);
    t_124 = GET_NCI_P(1);
    t_125 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_123) ? NULL : t_123,PMC_IS_NULL(t_124) ? NULL : t_124,PMC_IS_NULL(t_125) ? NULL : t_125);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_I_JOPxAT_(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_127;
    PMC *t_128;
    PMC *t_129;
    Parrot_init_arg_nci(interp, &st, "PP@");
    t_127 = GET_NCI_P(0);
    t_128 = GET_NCI_P(1);
    t_129 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_127) ? NULL : t_127,PMC_IS_NULL(t_128) ? NULL : t_128,PMC_IS_NULL(t_129) ? NULL : t_129);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_I_JOIPxAT_(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, INTVAL, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_131;
    INTVAL t_132;
    PMC *t_133;
    PMC *t_134;
    Parrot_init_arg_nci(interp, &st, "PIP@");
    t_131 = GET_NCI_P(0);
    t_132 = (INTVAL)GET_NCI_I(1);
    t_133 = GET_NCI_P(2);
    t_134 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_131) ? NULL : t_131,t_132,PMC_IS_NULL(t_133) ? NULL : t_133,PMC_IS_NULL(t_134) ? NULL : t_134);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JO(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_136;
    Parrot_init_arg_nci(interp, &st, "P");
    t_136 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_136) ? NULL : t_136);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_138;
    PMC *t_139;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_138 = GET_NCI_P(0);
    t_139 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_138) ? NULL : t_138,PMC_IS_NULL(t_139) ? NULL : t_139);
    
    
}
static void
pcf_P_Ji(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    int t_141;
    Parrot_init_arg_nci(interp, &st, "I");
    t_141 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,t_141);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_J(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    
    Parrot_init_arg_nci(interp, &st, "");
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp);
    
    
}
static void
pcf_i_ip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_143;
    PMC *t_144;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_143 = (int)GET_NCI_I(0);
    t_144 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_143,PMC_data(t_144));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JPip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_146;
    int t_147;
    PMC *t_148;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_146 = GET_NCI_P(0);
    t_147 = (int)GET_NCI_I(1);
    t_148 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_146) ? NULL : t_146,t_147,PMC_data(t_148));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JpP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, void *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_150;
    PMC *t_151;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_150 = GET_NCI_P(0);
    t_151 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_data(t_150),PMC_IS_NULL(t_151) ? NULL : t_151);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_Jpii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_153;
    int t_154;
    int t_155;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_153 = GET_NCI_P(0);
    t_154 = (int)GET_NCI_I(1);
    t_155 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_data(t_153),t_154,t_155);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_156;
    Parrot_init_arg_nci(interp, &st, "P");
    t_156 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_156));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_tp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_157;
    PMC *t_158;
    Parrot_init_arg_nci(interp, &st, "SP");
    {STRING * s= GET_NCI_S(0); t_157 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_158 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_157,PMC_data(t_158));
    set_nci_I(interp, &st, return_data);
    do { if (t_157) Parrot_str_free_cstring(t_157); } while (0);
}
static void
pcf_p_J(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);
    Parrot_init_arg_nci(interp, &st, "");
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_161;
    Parrot_init_arg_nci(interp, &st, "P");
    t_161 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,PMC_data(t_161));
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_t_J(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(PARROT_INTERP);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;
    Parrot_init_arg_nci(interp, &st, "");
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(interp);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_Jpti(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(PARROT_INTERP, void *, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;PMC *t_164;
    char *t_165;
    int t_166;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_164 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_165 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_166 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(interp,PMC_data(t_164),t_165,t_166);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_165) Parrot_str_free_cstring(t_165); } while (0);
}
static void
pcf_t_p(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;PMC *t_167;
    Parrot_init_arg_nci(interp, &st, "P");
    t_167 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(PMC_data(t_167));
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pt(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;PMC *t_168;
    char *t_169;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_168 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_169 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(PMC_data(t_168),t_169);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_169) Parrot_str_free_cstring(t_169); } while (0);
}
static void
pcf_v_p(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_170;
    Parrot_init_arg_nci(interp, &st, "P");
    t_170 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_170));
    
    
}
static void
pcf_v_pit(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_171;
    int t_172;
    char *t_173;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_171 = GET_NCI_P(0);
    t_172 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_173 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_171),t_172,t_173);
    
    do { if (t_173) Parrot_str_free_cstring(t_173); } while (0);
}
static void
pcf_v_ptt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_174;
    char *t_175;
    char *t_176;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_174 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_175 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_176 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_174),t_175,t_176);
    
    do { if (t_175) Parrot_str_free_cstring(t_175); } while (0);
    do { if (t_176) Parrot_str_free_cstring(t_176); } while (0);
}
static void
pcf_v_Jtiiipt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, char *, int, int, int, void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    char *t_178;
    int t_179;
    int t_180;
    int t_181;
    PMC *t_182;
    char *t_183;
    Parrot_init_arg_nci(interp, &st, "SIIIPS");
    {STRING * s= GET_NCI_S(0); t_178 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_179 = (int)GET_NCI_I(1);
    t_180 = (int)GET_NCI_I(2);
    t_181 = (int)GET_NCI_I(3);
    t_182 = GET_NCI_P(4);
    {STRING * s= GET_NCI_S(5); t_183 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,t_178,t_179,t_180,t_181,PMC_data(t_182),t_183);
    
    do { if (t_178) Parrot_str_free_cstring(t_178); } while (0);
    do { if (t_183) Parrot_str_free_cstring(t_183); } while (0);
}
static void
pcf_p_JttPP(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, char *, char *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_185;
    char *t_186;
    PMC *t_187;
    PMC *t_188;
    Parrot_init_arg_nci(interp, &st, "SSPP");
    {STRING * s= GET_NCI_S(0); t_185 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(1); t_186 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_187 = GET_NCI_P(2);
    t_188 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,t_185,t_186,PMC_IS_NULL(t_187) ? NULL : t_187,PMC_IS_NULL(t_188) ? NULL : t_188);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_185) Parrot_str_free_cstring(t_185); } while (0);
    do { if (t_186) Parrot_str_free_cstring(t_186); } while (0);
}
static void
pcf_P_Jtpi(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, char *, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    char *t_190;
    PMC *t_191;
    int t_192;
    Parrot_init_arg_nci(interp, &st, "SPI");
    {STRING * s= GET_NCI_S(0); t_190 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_191 = GET_NCI_P(1);
    t_192 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,t_190,PMC_data(t_191),t_192);
    set_nci_P(interp, &st, return_data);
    do { if (t_190) Parrot_str_free_cstring(t_190); } while (0);
}
static void
pcf_i_Vppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void **, void *, void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_193;
    PMC *t_194;
    PMC *t_195;
    PMC *t_196;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_193 = GET_NCI_P(0);
    t_194 = GET_NCI_P(1);
    t_195 = GET_NCI_P(2);
    t_196 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)((void**)&PMC_data(t_193),PMC_data(t_194),PMC_data(t_195),PMC_data(t_196));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_JpPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, void *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_198;
    PMC *t_199;
    PMC *t_200;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_198 = GET_NCI_P(0);
    t_199 = GET_NCI_P(1);
    t_200 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_data(t_198),PMC_IS_NULL(t_199) ? NULL : t_199,PMC_IS_NULL(t_200) ? NULL : t_200);
    
    
}
static void
pcf_v_pt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_201;
    char *t_202;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_201 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_202 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_201),t_202);
    
    do { if (t_202) Parrot_str_free_cstring(t_202); } while (0);
}
static void
pcf_v_Jpt(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_204;
    char *t_205;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_204 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_205 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_data(t_204),t_205);
    
    do { if (t_205) Parrot_str_free_cstring(t_205); } while (0);
}
static void
pcf_v_(PARROT_INTERP, PMC *self)
{
    void (*pointer)(void);
    void *orig_func;
    
    
    
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (void (*)(void))D2FPTR(orig_func);
     (void)(*pointer)();
    
    
}
static void
pcf_v_Jiiip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, int, int, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    int t_207;
    int t_208;
    int t_209;
    PMC *t_210;
    Parrot_init_arg_nci(interp, &st, "IIIP");
    t_207 = (int)GET_NCI_I(0);
    t_208 = (int)GET_NCI_I(1);
    t_209 = (int)GET_NCI_I(2);
    t_210 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,t_207,t_208,t_209,PMC_data(t_210));
    
    
}
static void
pcf_v_i(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    int t_211;
    Parrot_init_arg_nci(interp, &st, "I");
    t_211 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_211);
    
    
}
static void
pcf_v_ii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    int t_212;
    int t_213;
    Parrot_init_arg_nci(interp, &st, "II");
    t_212 = (int)GET_NCI_I(0);
    t_213 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_212,t_213);
    
    
}
static void
pcf_v_illllllll(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(int, long, long, long, long, long, long, long, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    int t_214;
    long t_215;
    long t_216;
    long t_217;
    long t_218;
    long t_219;
    long t_220;
    long t_221;
    long t_222;
    Parrot_init_arg_nci(interp, &st, "IIIIIIIII");
    t_214 = (int)GET_NCI_I(0);
    t_215 = (long)GET_NCI_I(1);
    t_216 = (long)GET_NCI_I(2);
    t_217 = (long)GET_NCI_I(3);
    t_218 = (long)GET_NCI_I(4);
    t_219 = (long)GET_NCI_I(5);
    t_220 = (long)GET_NCI_I(6);
    t_221 = (long)GET_NCI_I(7);
    t_222 = (long)GET_NCI_I(8);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_214,t_215,t_216,t_217,t_218,t_219,t_220,t_221,t_222);
    
    
}
static void
pcf_v_l(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(long);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    long t_223;
    Parrot_init_arg_nci(interp, &st, "I");
    t_223 = (long)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_223);
    
    
}
static void
pcf_v_pbip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_224;
    STRING *t_225;
    int t_226;
    PMC *t_227;
    Parrot_init_arg_nci(interp, &st, "PSIP");
    t_224 = GET_NCI_P(0);
    t_225 = GET_NCI_S(1);
    t_226 = (int)GET_NCI_I(2);
    t_227 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_224),PObj_bufstart(t_225),t_226,PMC_data(t_227));
    
    
}
static void
pcf_v_pi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_228;
    int t_229;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_228 = GET_NCI_P(0);
    t_229 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_228),t_229);
    
    
}
static void
pcf_v_piiii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_230;
    int t_231;
    int t_232;
    int t_233;
    int t_234;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_230 = GET_NCI_P(0);
    t_231 = (int)GET_NCI_I(1);
    t_232 = (int)GET_NCI_I(2);
    t_233 = (int)GET_NCI_I(3);
    t_234 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_230),t_231,t_232,t_233,t_234);
    
    
}
static void
pcf_v_pl(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_235;
    long t_236;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_235 = GET_NCI_P(0);
    t_236 = (long)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_235),t_236);
    
    
}
static void
pcf_v_pp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_237;
    PMC *t_238;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_237 = GET_NCI_P(0);
    t_238 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_237),PMC_data(t_238));
    
    
}
static void
pcf_i_JPP(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_240;
    PMC *t_241;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_240 = GET_NCI_P(0);
    t_241 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_240) ? NULL : t_240,PMC_IS_NULL(t_241) ? NULL : t_241);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_243;
    Parrot_init_arg_nci(interp, &st, "P");
    t_243 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_243) ? NULL : t_243);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_245;
    PMC *t_246;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_245 = GET_NCI_P(0);
    t_246 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_245) ? NULL : t_245,PMC_IS_NULL(t_246) ? NULL : t_246);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_S_JO(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    PMC *t_248;
    Parrot_init_arg_nci(interp, &st, "P");
    t_248 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_248) ? NULL : t_248);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_i_P(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_249;
    Parrot_init_arg_nci(interp, &st, "P");
    t_249 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_IS_NULL(t_249) ? NULL : t_249);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_251;
    PMC *t_252;
    PMC *t_253;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_251 = GET_NCI_P(0);
    t_252 = GET_NCI_P(1);
    t_253 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_251) ? NULL : t_251,PMC_IS_NULL(t_252) ? NULL : t_252,PMC_IS_NULL(t_253) ? NULL : t_253);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_255;
    PMC *t_256;
    PMC *t_257;
    PMC *t_258;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_255 = GET_NCI_P(0);
    t_256 = GET_NCI_P(1);
    t_257 = GET_NCI_P(2);
    t_258 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_255) ? NULL : t_255,PMC_IS_NULL(t_256) ? NULL : t_256,PMC_IS_NULL(t_257) ? NULL : t_257,PMC_IS_NULL(t_258) ? NULL : t_258);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_260;
    PMC *t_261;
    PMC *t_262;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_260 = GET_NCI_P(0);
    t_261 = GET_NCI_P(1);
    t_262 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_260) ? NULL : t_260,PMC_IS_NULL(t_261) ? NULL : t_261,PMC_IS_NULL(t_262) ? NULL : t_262);
    
    
}
static void
pcf_v_JOPPP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_264;
    PMC *t_265;
    PMC *t_266;
    PMC *t_267;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_264 = GET_NCI_P(0);
    t_265 = GET_NCI_P(1);
    t_266 = GET_NCI_P(2);
    t_267 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_264) ? NULL : t_264,PMC_IS_NULL(t_265) ? NULL : t_265,PMC_IS_NULL(t_266) ? NULL : t_266,PMC_IS_NULL(t_267) ? NULL : t_267);
    
    
}
static void
pcf_P_JOPPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_269;
    PMC *t_270;
    PMC *t_271;
    PMC *t_272;
    PMC *t_273;
    Parrot_init_arg_nci(interp, &st, "PPPPP");
    t_269 = GET_NCI_P(0);
    t_270 = GET_NCI_P(1);
    t_271 = GET_NCI_P(2);
    t_272 = GET_NCI_P(3);
    t_273 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_269) ? NULL : t_269,PMC_IS_NULL(t_270) ? NULL : t_270,PMC_IS_NULL(t_271) ? NULL : t_271,PMC_IS_NULL(t_272) ? NULL : t_272,PMC_IS_NULL(t_273) ? NULL : t_273);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOPPPPP(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, PMC *, PMC *, PMC *, PMC *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_275;
    PMC *t_276;
    PMC *t_277;
    PMC *t_278;
    PMC *t_279;
    PMC *t_280;
    Parrot_init_arg_nci(interp, &st, "PPPPPP");
    t_275 = GET_NCI_P(0);
    t_276 = GET_NCI_P(1);
    t_277 = GET_NCI_P(2);
    t_278 = GET_NCI_P(3);
    t_279 = GET_NCI_P(4);
    t_280 = GET_NCI_P(5);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_275) ? NULL : t_275,PMC_IS_NULL(t_276) ? NULL : t_276,PMC_IS_NULL(t_277) ? NULL : t_277,PMC_IS_NULL(t_278) ? NULL : t_278,PMC_IS_NULL(t_279) ? NULL : t_279,PMC_IS_NULL(t_280) ? NULL : t_280);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_I_JOSI(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_282;
    STRING * t_283;
    INTVAL t_284;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_282 = GET_NCI_P(0);
    t_283 = (STRING *)GET_NCI_S(1);
    t_284 = (INTVAL)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_282) ? NULL : t_282,t_283,t_284);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_P_JOSII(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_286;
    STRING * t_287;
    INTVAL t_288;
    INTVAL t_289;
    Parrot_init_arg_nci(interp, &st, "PSII");
    t_286 = GET_NCI_P(0);
    t_287 = (STRING *)GET_NCI_S(1);
    t_288 = (INTVAL)GET_NCI_I(2);
    t_289 = (INTVAL)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_286) ? NULL : t_286,t_287,t_288,t_289);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_p_Ji(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_291;
    Parrot_init_arg_nci(interp, &st, "I");
    t_291 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,t_291);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jipp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, int, void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_293;
    PMC *t_294;
    PMC *t_295;
    Parrot_init_arg_nci(interp, &st, "IPP");
    t_293 = (int)GET_NCI_I(0);
    t_294 = GET_NCI_P(1);
    t_295 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,t_293,PMC_data(t_294),PMC_data(t_295));
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jbip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, void *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);STRING *t_297;
    int t_298;
    PMC *t_299;
    Parrot_init_arg_nci(interp, &st, "SIP");
    t_297 = GET_NCI_S(0);
    t_298 = (int)GET_NCI_I(1);
    t_299 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,PObj_bufstart(t_297),t_298,PMC_data(t_299));
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_v_Jp(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_301;
    Parrot_init_arg_nci(interp, &st, "P");
    t_301 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_data(t_301));
    
    
}
static void
pcf_v_JS(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    STRING * t_303;
    Parrot_init_arg_nci(interp, &st, "S");
    t_303 = (STRING *)GET_NCI_S(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,t_303);
    
    
}
static void
pcf_t_tt(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;char *t_304;
    char *t_305;
    Parrot_init_arg_nci(interp, &st, "SS");
    {STRING * s= GET_NCI_S(0); t_304 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(1); t_305 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_304,t_305);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_304) Parrot_str_free_cstring(t_304); } while (0);
    do { if (t_305) Parrot_str_free_cstring(t_305); } while (0);
}
static void
pcf_I_JOt(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_307;
    char *t_308;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_307 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_308 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_307) ? NULL : t_307,t_308);
    set_nci_I(interp, &st, return_data);
    do { if (t_308) Parrot_str_free_cstring(t_308); } while (0);
}
static void
pcf_v_JOSI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, STRING *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_310;
    STRING * t_311;
    INTVAL t_312;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_310 = GET_NCI_P(0);
    t_311 = (STRING *)GET_NCI_S(1);
    t_312 = (INTVAL)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_310) ? NULL : t_310,t_311,t_312);
    
    
}
static void
pcf_S_JOi(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    PMC *t_314;
    int t_315;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_314 = GET_NCI_P(0);
    t_315 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_314) ? NULL : t_314,t_315);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_v_JOi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_317;
    int t_318;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_317 = GET_NCI_P(0);
    t_318 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_317) ? NULL : t_317,t_318);
    
    
}
static void
pcf_I_JO(PARROT_INTERP, PMC *self)
{
    typedef INTVAL (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    INTVAL return_data;
    PMC *t_320;
    Parrot_init_arg_nci(interp, &st, "P");
    t_320 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (INTVAL)(*pointer)(interp,PMC_IS_NULL(t_320) ? NULL : t_320);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_N_JO(PARROT_INTERP, PMC *self)
{
    typedef FLOATVAL (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    FLOATVAL return_data;
    PMC *t_322;
    Parrot_init_arg_nci(interp, &st, "P");
    t_322 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (FLOATVAL)(*pointer)(interp,PMC_IS_NULL(t_322) ? NULL : t_322);
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_v_JON(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, FLOATVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_324;
    FLOATVAL t_325;
    Parrot_init_arg_nci(interp, &st, "PN");
    t_324 = GET_NCI_P(0);
    t_325 = (FLOATVAL)GET_NCI_N(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_324) ? NULL : t_324,t_325);
    
    
}
static void
pcf_P_JOi(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_327;
    int t_328;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_327 = GET_NCI_P(0);
    t_328 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_327) ? NULL : t_327,t_328);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_v_JOI(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_330;
    INTVAL t_331;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_330 = GET_NCI_P(0);
    t_331 = (INTVAL)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_330) ? NULL : t_330,t_331);
    
    
}
static void
pcf_P_JOI(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_333;
    INTVAL t_334;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_333 = GET_NCI_P(0);
    t_334 = (INTVAL)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_333) ? NULL : t_333,t_334);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_P_JOIS(PARROT_INTERP, PMC *self)
{
    typedef PMC * (*func_t)(PARROT_INTERP, PMC *, INTVAL, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    PMC * return_data;
    PMC *t_336;
    INTVAL t_337;
    STRING * t_338;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_336 = GET_NCI_P(0);
    t_337 = (INTVAL)GET_NCI_I(1);
    t_338 = (STRING *)GET_NCI_S(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (PMC *)(*pointer)(interp,PMC_IS_NULL(t_336) ? NULL : t_336,t_337,t_338);
    set_nci_P(interp, &st, return_data);
    
}
static void
pcf_S_JOSP(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(PARROT_INTERP, PMC *, STRING *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    PMC *t_340;
    STRING * t_341;
    PMC *t_342;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_340 = GET_NCI_P(0);
    t_341 = (STRING *)GET_NCI_S(1);
    t_342 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(interp,PMC_IS_NULL(t_340) ? NULL : t_340,t_341,PMC_IS_NULL(t_342) ? NULL : t_342);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_i_(PARROT_INTERP, PMC *self)
{
    int (*pointer)(void);
    void *orig_func;
    int return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (int (*)(void))D2FPTR(orig_func);
    return_data =  (int)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_i3i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_343;
    PMC *t_344;
    int i_344;
    int t_345;
    Parrot_init_arg_nci(interp, &st, "IPI");
    t_343 = (int)GET_NCI_I(0);
    t_344 = GET_NCI_P(1);
    i_344 = (int) VTABLE_get_integer(interp, t_344);
    t_345 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_343,&i_344,t_345);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_344, i_344);
}
static void
pcf_i_ibi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_346;
    STRING *t_347;
    int t_348;
    Parrot_init_arg_nci(interp, &st, "ISI");
    t_346 = (int)GET_NCI_I(0);
    t_347 = GET_NCI_S(1);
    t_348 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_346,PObj_bufstart(t_347),t_348);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_lttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(long, char *, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    long t_349;
    char *t_350;
    char *t_351;
    long t_352;
    Parrot_init_arg_nci(interp, &st, "ISSI");
    t_349 = (long)GET_NCI_I(0);
    {STRING * s= GET_NCI_S(1); t_350 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_351 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_352 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(t_349,t_350,t_351,t_352);
    set_nci_I(interp, &st, return_data);
    do { if (t_350) Parrot_str_free_cstring(t_350); } while (0);
    do { if (t_351) Parrot_str_free_cstring(t_351); } while (0);
}
static void
pcf_i_pip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_353;
    int t_354;
    PMC *t_355;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_353 = GET_NCI_P(0);
    t_354 = (int)GET_NCI_I(1);
    t_355 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_353),t_354,PMC_data(t_355));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piS(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, STRING *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_356;
    int t_357;
    STRING * t_358;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_356 = GET_NCI_P(0);
    t_357 = (int)GET_NCI_I(1);
    t_358 = (STRING *)GET_NCI_S(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_356),t_357,t_358);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_S_i(PARROT_INTERP, PMC *self)
{
    typedef STRING * (*func_t)(int);
    func_t pointer;
    void *orig_func;
    call_state st;
    STRING * return_data;
    int t_359;
    Parrot_init_arg_nci(interp, &st, "I");
    t_359 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (STRING *)(*pointer)(t_359);
    set_nci_S(interp, &st, return_data);
    
}
static void
pcf_l_p(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_360;
    Parrot_init_arg_nci(interp, &st, "P");
    t_360 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(PMC_data(t_360));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_p(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char return_data;
    PMC *t_361;
    Parrot_init_arg_nci(interp, &st, "P");
    t_361 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char)(*pointer)(PMC_data(t_361));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_pi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_362;
    int t_363;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_362 = GET_NCI_P(0);
    t_363 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_362),t_363);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_p(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_364;
    Parrot_init_arg_nci(interp, &st, "P");
    t_364 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_364));
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_pttttt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, char *, char *, char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_365;
    char *t_366;
    char *t_367;
    char *t_368;
    char *t_369;
    char *t_370;
    Parrot_init_arg_nci(interp, &st, "PSSSSS");
    t_365 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_366 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_367 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(3); t_368 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(4); t_369 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(5); t_370 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_365),t_366,t_367,t_368,t_369,t_370);
    set_nci_I(interp, &st, return_data);
    do { if (t_366) Parrot_str_free_cstring(t_366); } while (0);
    do { if (t_367) Parrot_str_free_cstring(t_367); } while (0);
    do { if (t_368) Parrot_str_free_cstring(t_368); } while (0);
    do { if (t_369) Parrot_str_free_cstring(t_369); } while (0);
    do { if (t_370) Parrot_str_free_cstring(t_370); } while (0);
}
static void
pcf_c_pttt(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *, char *, char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char return_data;
    PMC *t_371;
    char *t_372;
    char *t_373;
    char *t_374;
    Parrot_init_arg_nci(interp, &st, "PSSS");
    t_371 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_372 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_373 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(3); t_374 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char)(*pointer)(PMC_data(t_371),t_372,t_373,t_374);
    set_nci_I(interp, &st, return_data);
    do { if (t_372) Parrot_str_free_cstring(t_372); } while (0);
    do { if (t_373) Parrot_str_free_cstring(t_373); } while (0);
    do { if (t_374) Parrot_str_free_cstring(t_374); } while (0);
}
static void
pcf_p_pttttiti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *, char *, char *, int, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_375;
    char *t_376;
    char *t_377;
    char *t_378;
    char *t_379;
    int t_380;
    char *t_381;
    int t_382;
    Parrot_init_arg_nci(interp, &st, "PSSSSISI");
    t_375 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_376 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_377 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(3); t_378 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(4); t_379 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_380 = (int)GET_NCI_I(5);
    {STRING * s= GET_NCI_S(6); t_381 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_382 = (int)GET_NCI_I(7);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_375),t_376,t_377,t_378,t_379,t_380,t_381,t_382);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_376) Parrot_str_free_cstring(t_376); } while (0);
    do { if (t_377) Parrot_str_free_cstring(t_377); } while (0);
    do { if (t_378) Parrot_str_free_cstring(t_378); } while (0);
    do { if (t_379) Parrot_str_free_cstring(t_379); } while (0);
    do { if (t_381) Parrot_str_free_cstring(t_381); } while (0);
}
static void
pcf_i_pt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_383;
    char *t_384;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_383 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_384 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_383),t_384);
    set_nci_I(interp, &st, return_data);
    do { if (t_384) Parrot_str_free_cstring(t_384); } while (0);
}
static void
pcf_i_ptl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_385;
    char *t_386;
    long t_387;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_385 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_386 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_387 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_385),t_386,t_387);
    set_nci_I(interp, &st, return_data);
    do { if (t_386) Parrot_str_free_cstring(t_386); } while (0);
}
static void
pcf_i_pi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_388;
    int t_389;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_388 = GET_NCI_P(0);
    t_389 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_388),t_389);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_390;
    long t_391;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_390 = GET_NCI_P(0);
    t_391 = (long)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_390),t_391);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_(PARROT_INTERP, PMC *self)
{
    long (*pointer)(void);
    void *orig_func;
    long return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (long (*)(void))D2FPTR(orig_func);
    return_data =  (long)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_pt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_392;
    char *t_393;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_392 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_393 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_392),t_393);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_393) Parrot_str_free_cstring(t_393); } while (0);
}
static void
pcf_p_ptt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_394;
    char *t_395;
    char *t_396;
    Parrot_init_arg_nci(interp, &st, "PSS");
    t_394 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_395 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_396 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_394),t_395,t_396);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_395) Parrot_str_free_cstring(t_395); } while (0);
    do { if (t_396) Parrot_str_free_cstring(t_396); } while (0);
}
static void
pcf_i_pit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_397;
    int t_398;
    char *t_399;
    Parrot_init_arg_nci(interp, &st, "PIS");
    t_397 = GET_NCI_P(0);
    t_398 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_399 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_397),t_398,t_399);
    set_nci_I(interp, &st, return_data);
    do { if (t_399) Parrot_str_free_cstring(t_399); } while (0);
}
static void
pcf_p_pp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_400;
    PMC *t_401;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_400 = GET_NCI_P(0);
    t_401 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_400),PMC_data(t_401));
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_l_ttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(char *, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    char *t_402;
    char *t_403;
    long t_404;
    Parrot_init_arg_nci(interp, &st, "SSI");
    {STRING * s= GET_NCI_S(0); t_402 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(1); t_403 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_404 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(t_402,t_403,t_404);
    set_nci_I(interp, &st, return_data);
    do { if (t_402) Parrot_str_free_cstring(t_402); } while (0);
    do { if (t_403) Parrot_str_free_cstring(t_403); } while (0);
}
static void
pcf_l_pttl(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, char *, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_405;
    char *t_406;
    char *t_407;
    long t_408;
    Parrot_init_arg_nci(interp, &st, "PSSI");
    t_405 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_406 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_407 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_408 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(PMC_data(t_405),t_406,t_407,t_408);
    set_nci_I(interp, &st, return_data);
    do { if (t_406) Parrot_str_free_cstring(t_406); } while (0);
    do { if (t_407) Parrot_str_free_cstring(t_407); } while (0);
}
static void
pcf_v_t(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    char *t_409;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_409 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_409);
    
    do { if (t_409) Parrot_str_free_cstring(t_409); } while (0);
}
static void
pcf_p_pttttitl(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *, char *, char *, int, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_410;
    char *t_411;
    char *t_412;
    char *t_413;
    char *t_414;
    int t_415;
    char *t_416;
    long t_417;
    Parrot_init_arg_nci(interp, &st, "PSSSSISI");
    t_410 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_411 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_412 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(3); t_413 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(4); t_414 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_415 = (int)GET_NCI_I(5);
    {STRING * s= GET_NCI_S(6); t_416 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_417 = (long)GET_NCI_I(7);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_410),t_411,t_412,t_413,t_414,t_415,t_416,t_417);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_411) Parrot_str_free_cstring(t_411); } while (0);
    do { if (t_412) Parrot_str_free_cstring(t_412); } while (0);
    do { if (t_413) Parrot_str_free_cstring(t_413); } while (0);
    do { if (t_414) Parrot_str_free_cstring(t_414); } while (0);
    do { if (t_416) Parrot_str_free_cstring(t_416); } while (0);
}
static void
pcf_p_tiB3P(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int, void **, int *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_418;
    int t_419;
    char *s_420;
    char *t_420;
    void** v_420 = (void **) &t_420;
    PMC *t_421;
    int i_421;
    PMC *t_422;
    Parrot_init_arg_nci(interp, &st, "SISPP");
    {STRING * s= GET_NCI_S(0); t_418 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_419 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_420 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL; s_420 = t_420;}
    t_421 = GET_NCI_P(3);
    i_421 = (int) VTABLE_get_integer(interp, t_421);
    t_422 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_418,t_419,v_420,&i_421,PMC_IS_NULL(t_422) ? NULL : t_422);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_418) Parrot_str_free_cstring(t_418); } while (0);
    do { if (s_420) Parrot_str_free_cstring(s_420); } while (0);
    VTABLE_set_integer_native(interp, t_421, i_421);
}
static void
pcf_p_tip3P(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int, void *, int *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_423;
    int t_424;
    PMC *t_425;
    PMC *t_426;
    int i_426;
    PMC *t_427;
    Parrot_init_arg_nci(interp, &st, "SIPPP");
    {STRING * s= GET_NCI_S(0); t_423 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_424 = (int)GET_NCI_I(1);
    t_425 = GET_NCI_P(2);
    t_426 = GET_NCI_P(3);
    i_426 = (int) VTABLE_get_integer(interp, t_426);
    t_427 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_423,t_424,PMC_data(t_425),&i_426,PMC_IS_NULL(t_427) ? NULL : t_427);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_423) Parrot_str_free_cstring(t_423); } while (0);
    VTABLE_set_integer_native(interp, t_426, i_426);
}
static void
pcf_i_pPtiiipi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, PMC *, char *, int, int, int, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_428;
    PMC *t_429;
    char *t_430;
    int t_431;
    int t_432;
    int t_433;
    PMC *t_434;
    int t_435;
    Parrot_init_arg_nci(interp, &st, "PPSIIIPI");
    t_428 = GET_NCI_P(0);
    t_429 = GET_NCI_P(1);
    {STRING * s= GET_NCI_S(2); t_430 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_431 = (int)GET_NCI_I(3);
    t_432 = (int)GET_NCI_I(4);
    t_433 = (int)GET_NCI_I(5);
    t_434 = GET_NCI_P(6);
    t_435 = (int)GET_NCI_I(7);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_428),PMC_IS_NULL(t_429) ? NULL : t_429,t_430,t_431,t_432,t_433,PMC_data(t_434),t_435);
    set_nci_I(interp, &st, return_data);
    do { if (t_430) Parrot_str_free_cstring(t_430); } while (0);
}
static void
pcf_i_tpiibi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, void *, int, int, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_436;
    PMC *t_437;
    int t_438;
    int t_439;
    STRING *t_440;
    int t_441;
    Parrot_init_arg_nci(interp, &st, "SPIISI");
    {STRING * s= GET_NCI_S(0); t_436 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_437 = GET_NCI_P(1);
    t_438 = (int)GET_NCI_I(2);
    t_439 = (int)GET_NCI_I(3);
    t_440 = GET_NCI_S(4);
    t_441 = (int)GET_NCI_I(5);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_436,PMC_data(t_437),t_438,t_439,PObj_bufstart(t_440),t_441);
    set_nci_I(interp, &st, return_data);
    do { if (t_436) Parrot_str_free_cstring(t_436); } while (0);
}
static void
pcf_p_ptippppi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int, void *, void *, void *, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_442;
    char *t_443;
    int t_444;
    PMC *t_445;
    PMC *t_446;
    PMC *t_447;
    PMC *t_448;
    int t_449;
    Parrot_init_arg_nci(interp, &st, "PSIPPPPI");
    t_442 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_443 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_444 = (int)GET_NCI_I(2);
    t_445 = GET_NCI_P(3);
    t_446 = GET_NCI_P(4);
    t_447 = GET_NCI_P(5);
    t_448 = GET_NCI_P(6);
    t_449 = (int)GET_NCI_I(7);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_442),t_443,t_444,PMC_data(t_445),PMC_data(t_446),PMC_data(t_447),PMC_data(t_448),t_449);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_443) Parrot_str_free_cstring(t_443); } while (0);
}
static void
pcf_p_pi33ipi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int *, int *, int, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_450;
    int t_451;
    PMC *t_452;
    int i_452;
    PMC *t_453;
    int i_453;
    int t_454;
    PMC *t_455;
    int t_456;
    Parrot_init_arg_nci(interp, &st, "PIPPIPI");
    t_450 = GET_NCI_P(0);
    t_451 = (int)GET_NCI_I(1);
    t_452 = GET_NCI_P(2);
    i_452 = (int) VTABLE_get_integer(interp, t_452);
    t_453 = GET_NCI_P(3);
    i_453 = (int) VTABLE_get_integer(interp, t_453);
    t_454 = (int)GET_NCI_I(4);
    t_455 = GET_NCI_P(5);
    t_456 = (int)GET_NCI_I(6);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_450),t_451,&i_452,&i_453,t_454,PMC_data(t_455),t_456);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    VTABLE_set_integer_native(interp, t_452, i_452);
    VTABLE_set_integer_native(interp, t_453, i_453);
}
static void
pcf_p_pttip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, char *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_457;
    char *t_458;
    char *t_459;
    int t_460;
    PMC *t_461;
    Parrot_init_arg_nci(interp, &st, "PSSIP");
    t_457 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_458 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_459 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_460 = (int)GET_NCI_I(3);
    t_461 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_457),t_458,t_459,t_460,PMC_data(t_461));
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_458) Parrot_str_free_cstring(t_458); } while (0);
    do { if (t_459) Parrot_str_free_cstring(t_459); } while (0);
}
static void
pcf_p_ptipppi(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int, void *, void *, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_462;
    char *t_463;
    int t_464;
    PMC *t_465;
    PMC *t_466;
    PMC *t_467;
    int t_468;
    Parrot_init_arg_nci(interp, &st, "PSIPPPI");
    t_462 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_463 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_464 = (int)GET_NCI_I(2);
    t_465 = GET_NCI_P(3);
    t_466 = GET_NCI_P(4);
    t_467 = GET_NCI_P(5);
    t_468 = (int)GET_NCI_I(6);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_462),t_463,t_464,PMC_data(t_465),PMC_data(t_466),PMC_data(t_467),t_468);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_463) Parrot_str_free_cstring(t_463); } while (0);
}
static void
pcf_p_ppP(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_469;
    PMC *t_470;
    PMC *t_471;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_469 = GET_NCI_P(0);
    t_470 = GET_NCI_P(1);
    t_471 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_469),PMC_data(t_470),PMC_IS_NULL(t_471) ? NULL : t_471);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiil(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_472;
    int t_473;
    int t_474;
    long t_475;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_472 = (int)GET_NCI_I(0);
    t_473 = (int)GET_NCI_I(1);
    t_474 = (int)GET_NCI_I(2);
    t_475 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_472,t_473,t_474,t_475);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_ppl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_476;
    PMC *t_477;
    long t_478;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_476 = GET_NCI_P(0);
    t_477 = GET_NCI_P(1);
    t_478 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_476),PMC_data(t_477),t_478);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_pip(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_479;
    int t_480;
    PMC *t_481;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_479 = GET_NCI_P(0);
    t_480 = (int)GET_NCI_I(1);
    t_481 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_479),t_480,PMC_data(t_481));
    
    
}
static void
pcf_p_pti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_482;
    char *t_483;
    int t_484;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_482 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_483 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_484 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_482),t_483,t_484);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_483) Parrot_str_free_cstring(t_483); } while (0);
}
static void
pcf_i_ppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_485;
    PMC *t_486;
    PMC *t_487;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_485 = GET_NCI_P(0);
    t_486 = GET_NCI_P(1);
    t_487 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_485),PMC_data(t_486),PMC_data(t_487));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_p_ti(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_488;
    int t_489;
    Parrot_init_arg_nci(interp, &st, "SI");
    {STRING * s= GET_NCI_S(0); t_488 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_489 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_488,t_489);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_488) Parrot_str_free_cstring(t_488); } while (0);
}
static void
pcf_p_ptp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, char *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_490;
    char *t_491;
    PMC *t_492;
    Parrot_init_arg_nci(interp, &st, "PSP");
    t_490 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_491 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_492 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_490),t_491,PMC_data(t_492));
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_491) Parrot_str_free_cstring(t_491); } while (0);
}
static void
pcf_i_pt33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, int *, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_493;
    char *t_494;
    PMC *t_495;
    int i_495;
    PMC *t_496;
    int i_496;
    Parrot_init_arg_nci(interp, &st, "PSPP");
    t_493 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_494 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_495 = GET_NCI_P(2);
    i_495 = (int) VTABLE_get_integer(interp, t_495);
    t_496 = GET_NCI_P(3);
    i_496 = (int) VTABLE_get_integer(interp, t_496);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_493),t_494,&i_495,&i_496);
    set_nci_I(interp, &st, return_data);
    do { if (t_494) Parrot_str_free_cstring(t_494); } while (0);
    VTABLE_set_integer_native(interp, t_495, i_495);
    VTABLE_set_integer_native(interp, t_496, i_496);
}
static void
pcf_c_(PARROT_INTERP, PMC *self)
{
    char (*pointer)(void);
    void *orig_func;
    char return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (char (*)(void))D2FPTR(orig_func);
    return_data =  (char)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_pi(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char return_data;
    PMC *t_497;
    int t_498;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_497 = GET_NCI_P(0);
    t_498 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char)(*pointer)(PMC_data(t_497),t_498);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_d_(PARROT_INTERP, PMC *self)
{
    double (*pointer)(void);
    void *orig_func;
    double return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (double (*)(void))D2FPTR(orig_func);
    return_data =  (double)(*pointer)();
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_d_d(PARROT_INTERP, PMC *self)
{
    typedef double (*func_t)(double);
    func_t pointer;
    void *orig_func;
    call_state st;
    double return_data;
    double t_499;
    Parrot_init_arg_nci(interp, &st, "N");
    t_499 = (double)GET_NCI_N(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (double)(*pointer)(t_499);
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_f_(PARROT_INTERP, PMC *self)
{
    float (*pointer)(void);
    void *orig_func;
    float return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (float (*)(void))D2FPTR(orig_func);
    return_data =  (float)(*pointer)();
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_f_ff(PARROT_INTERP, PMC *self)
{
    typedef float (*func_t)(float, float);
    func_t pointer;
    void *orig_func;
    call_state st;
    float return_data;
    float t_500;
    float t_501;
    Parrot_init_arg_nci(interp, &st, "NN");
    t_500 = (float)GET_NCI_N(0);
    t_501 = (float)GET_NCI_N(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (float)(*pointer)(t_500,t_501);
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_f_is(PARROT_INTERP, PMC *self)
{
    typedef float (*func_t)(int, short);
    func_t pointer;
    void *orig_func;
    call_state st;
    float return_data;
    int t_502;
    short t_503;
    Parrot_init_arg_nci(interp, &st, "II");
    t_502 = (int)GET_NCI_I(0);
    t_503 = (short)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (float)(*pointer)(t_502,t_503);
    set_nci_N(interp, &st, return_data);
    
}
static void
pcf_i_b(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    STRING *t_504;
    Parrot_init_arg_nci(interp, &st, "S");
    t_504 = GET_NCI_S(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PObj_bufstart(t_504));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_d(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(double);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    double t_505;
    Parrot_init_arg_nci(interp, &st, "N");
    t_505 = (double)GET_NCI_N(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_505);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_506;
    Parrot_init_arg_nci(interp, &st, "I");
    t_506 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_506);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_507;
    int t_508;
    Parrot_init_arg_nci(interp, &st, "II");
    t_507 = (int)GET_NCI_I(0);
    t_508 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_507,t_508);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ii4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_509;
    int t_510;
    PMC *t_511;
    long i_511;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_509 = (int)GET_NCI_I(0);
    t_510 = (int)GET_NCI_I(1);
    t_511 = GET_NCI_P(2);
    i_511 = (long) VTABLE_get_integer(interp, t_511);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_509,t_510,&i_511);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_511, i_511);
}
static void
pcf_i_ii4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_512;
    int t_513;
    PMC *t_514;
    long i_514;
    int t_515;
    Parrot_init_arg_nci(interp, &st, "IIPI");
    t_512 = (int)GET_NCI_I(0);
    t_513 = (int)GET_NCI_I(1);
    t_514 = GET_NCI_P(2);
    i_514 = (long) VTABLE_get_integer(interp, t_514);
    t_515 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_512,t_513,&i_514,t_515);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_514, i_514);
}
static void
pcf_i_iiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_516;
    int t_517;
    int t_518;
    int t_519;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_516 = (int)GET_NCI_I(0);
    t_517 = (int)GET_NCI_I(1);
    t_518 = (int)GET_NCI_I(2);
    t_519 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_516,t_517,t_518,t_519);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iiilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int, long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_520;
    int t_521;
    int t_522;
    long t_523;
    short t_524;
    PMC *t_525;
    Parrot_init_arg_nci(interp, &st, "IIIIIP");
    t_520 = (int)GET_NCI_I(0);
    t_521 = (int)GET_NCI_I(1);
    t_522 = (int)GET_NCI_I(2);
    t_523 = (long)GET_NCI_I(3);
    t_524 = (short)GET_NCI_I(4);
    t_525 = GET_NCI_P(5);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_520,t_521,t_522,t_523,t_524,PMC_data(t_525));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iil(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_526;
    int t_527;
    long t_528;
    Parrot_init_arg_nci(interp, &st, "III");
    t_526 = (int)GET_NCI_I(0);
    t_527 = (int)GET_NCI_I(1);
    t_528 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_526,t_527,t_528);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iili(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, long, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_529;
    int t_530;
    long t_531;
    int t_532;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_529 = (int)GET_NCI_I(0);
    t_530 = (int)GET_NCI_I(1);
    t_531 = (long)GET_NCI_I(2);
    t_532 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_529,t_530,t_531,t_532);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iip(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_533;
    int t_534;
    PMC *t_535;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_533 = (int)GET_NCI_I(0);
    t_534 = (int)GET_NCI_I(1);
    t_535 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_533,t_534,PMC_data(t_535));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_536;
    int t_537;
    char *t_538;
    Parrot_init_arg_nci(interp, &st, "IIS");
    t_536 = (int)GET_NCI_I(0);
    t_537 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_538 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_536,t_537,t_538);
    set_nci_I(interp, &st, return_data);
    do { if (t_538) Parrot_str_free_cstring(t_538); } while (0);
}
static void
pcf_i_iiti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_539;
    int t_540;
    char *t_541;
    int t_542;
    Parrot_init_arg_nci(interp, &st, "IISI");
    t_539 = (int)GET_NCI_I(0);
    t_540 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_541 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_542 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_539,t_540,t_541,t_542);
    set_nci_I(interp, &st, return_data);
    do { if (t_541) Parrot_str_free_cstring(t_541); } while (0);
}
static void
pcf_i_ilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_543;
    long t_544;
    short t_545;
    PMC *t_546;
    Parrot_init_arg_nci(interp, &st, "IIIP");
    t_543 = (int)GET_NCI_I(0);
    t_544 = (long)GET_NCI_I(1);
    t_545 = (short)GET_NCI_I(2);
    t_546 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_543,t_544,t_545,PMC_data(t_546));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_547;
    char *t_548;
    int t_549;
    Parrot_init_arg_nci(interp, &st, "ISI");
    t_547 = (int)GET_NCI_I(0);
    {STRING * s= GET_NCI_S(1); t_548 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_549 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_547,t_548,t_549);
    set_nci_I(interp, &st, return_data);
    do { if (t_548) Parrot_str_free_cstring(t_548); } while (0);
}
static void
pcf_i_l(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    long t_550;
    Parrot_init_arg_nci(interp, &st, "I");
    t_550 = (long)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_550);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_li(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    long t_551;
    int t_552;
    Parrot_init_arg_nci(interp, &st, "II");
    t_551 = (long)GET_NCI_I(0);
    t_552 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_551,t_552);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_lp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    long t_553;
    PMC *t_554;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_553 = (long)GET_NCI_I(0);
    t_554 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_553,PMC_data(t_554));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_lsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    long t_555;
    short t_556;
    PMC *t_557;
    Parrot_init_arg_nci(interp, &st, "IIP");
    t_555 = (long)GET_NCI_I(0);
    t_556 = (short)GET_NCI_I(1);
    t_557 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_555,t_556,PMC_data(t_557));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_p33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_558;
    PMC *t_559;
    int i_559;
    PMC *t_560;
    int i_560;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_558 = GET_NCI_P(0);
    t_559 = GET_NCI_P(1);
    i_559 = (int) VTABLE_get_integer(interp, t_559);
    t_560 = GET_NCI_P(2);
    i_560 = (int) VTABLE_get_integer(interp, t_560);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_558),&i_559,&i_560);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_559, i_559);
    VTABLE_set_integer_native(interp, t_560, i_560);
}
static void
pcf_i_p333(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_561;
    PMC *t_562;
    int i_562;
    PMC *t_563;
    int i_563;
    PMC *t_564;
    int i_564;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_561 = GET_NCI_P(0);
    t_562 = GET_NCI_P(1);
    i_562 = (int) VTABLE_get_integer(interp, t_562);
    t_563 = GET_NCI_P(2);
    i_563 = (int) VTABLE_get_integer(interp, t_563);
    t_564 = GET_NCI_P(3);
    i_564 = (int) VTABLE_get_integer(interp, t_564);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_561),&i_562,&i_563,&i_564);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_562, i_562);
    VTABLE_set_integer_native(interp, t_563, i_563);
    VTABLE_set_integer_native(interp, t_564, i_564);
}
static void
pcf_i_p333333(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int *, int *, int *, int *, int *, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_565;
    PMC *t_566;
    int i_566;
    PMC *t_567;
    int i_567;
    PMC *t_568;
    int i_568;
    PMC *t_569;
    int i_569;
    PMC *t_570;
    int i_570;
    PMC *t_571;
    int i_571;
    Parrot_init_arg_nci(interp, &st, "PPPPPPP");
    t_565 = GET_NCI_P(0);
    t_566 = GET_NCI_P(1);
    i_566 = (int) VTABLE_get_integer(interp, t_566);
    t_567 = GET_NCI_P(2);
    i_567 = (int) VTABLE_get_integer(interp, t_567);
    t_568 = GET_NCI_P(3);
    i_568 = (int) VTABLE_get_integer(interp, t_568);
    t_569 = GET_NCI_P(4);
    i_569 = (int) VTABLE_get_integer(interp, t_569);
    t_570 = GET_NCI_P(5);
    i_570 = (int) VTABLE_get_integer(interp, t_570);
    t_571 = GET_NCI_P(6);
    i_571 = (int) VTABLE_get_integer(interp, t_571);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_565),&i_566,&i_567,&i_568,&i_569,&i_570,&i_571);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_566, i_566);
    VTABLE_set_integer_native(interp, t_567, i_567);
    VTABLE_set_integer_native(interp, t_568, i_568);
    VTABLE_set_integer_native(interp, t_569, i_569);
    VTABLE_set_integer_native(interp, t_570, i_570);
    VTABLE_set_integer_native(interp, t_571, i_571);
}
static void
pcf_i_p4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_572;
    PMC *t_573;
    long i_573;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_572 = GET_NCI_P(0);
    t_573 = GET_NCI_P(1);
    i_573 = (long) VTABLE_get_integer(interp, t_573);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_572),&i_573);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_573, i_573);
}
static void
pcf_i_p42p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *, short *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_574;
    PMC *t_575;
    long i_575;
    PMC *t_576;
    short i_576;
    PMC *t_577;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_574 = GET_NCI_P(0);
    t_575 = GET_NCI_P(1);
    i_575 = (long) VTABLE_get_integer(interp, t_575);
    t_576 = GET_NCI_P(2);
    i_576 = (short) VTABLE_get_integer(interp, t_576);
    t_577 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_574),&i_575,&i_576,PMC_data(t_577));
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_575, i_575);
    VTABLE_set_integer_native(interp, t_576, i_576);
}
static void
pcf_i_p4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_578;
    PMC *t_579;
    long i_579;
    int t_580;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_578 = GET_NCI_P(0);
    t_579 = GET_NCI_P(1);
    i_579 = (long) VTABLE_get_integer(interp, t_579);
    t_580 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_578),&i_579,t_580);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_579, i_579);
}
static void
pcf_i_pb(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_581;
    STRING *t_582;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_581 = GET_NCI_P(0);
    t_582 = GET_NCI_S(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_581),PObj_bufstart(t_582));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_583;
    int t_584;
    int t_585;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_583 = GET_NCI_P(0);
    t_584 = (int)GET_NCI_I(1);
    t_585 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_583),t_584,t_585);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pii4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_586;
    int t_587;
    int t_588;
    PMC *t_589;
    long i_589;
    Parrot_init_arg_nci(interp, &st, "PIIP");
    t_586 = GET_NCI_P(0);
    t_587 = (int)GET_NCI_I(1);
    t_588 = (int)GET_NCI_I(2);
    t_589 = GET_NCI_P(3);
    i_589 = (long) VTABLE_get_integer(interp, t_589);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_586),t_587,t_588,&i_589);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_589, i_589);
}
static void
pcf_i_pii4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_590;
    int t_591;
    int t_592;
    PMC *t_593;
    long i_593;
    int t_594;
    Parrot_init_arg_nci(interp, &st, "PIIPI");
    t_590 = GET_NCI_P(0);
    t_591 = (int)GET_NCI_I(1);
    t_592 = (int)GET_NCI_I(2);
    t_593 = GET_NCI_P(3);
    i_593 = (long) VTABLE_get_integer(interp, t_593);
    t_594 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_590),t_591,t_592,&i_593,t_594);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_593, i_593);
}
static void
pcf_i_piii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_595;
    int t_596;
    int t_597;
    int t_598;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_595 = GET_NCI_P(0);
    t_596 = (int)GET_NCI_I(1);
    t_597 = (int)GET_NCI_I(2);
    t_598 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_595),t_596,t_597,t_598);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piiiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_599;
    int t_600;
    int t_601;
    int t_602;
    int t_603;
    int t_604;
    int t_605;
    Parrot_init_arg_nci(interp, &st, "PIIIIII");
    t_599 = GET_NCI_P(0);
    t_600 = (int)GET_NCI_I(1);
    t_601 = (int)GET_NCI_I(2);
    t_602 = (int)GET_NCI_I(3);
    t_603 = (int)GET_NCI_I(4);
    t_604 = (int)GET_NCI_I(5);
    t_605 = (int)GET_NCI_I(6);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_599),t_600,t_601,t_602,t_603,t_604,t_605);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piiilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, int, long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_606;
    int t_607;
    int t_608;
    int t_609;
    long t_610;
    short t_611;
    PMC *t_612;
    Parrot_init_arg_nci(interp, &st, "PIIIIIP");
    t_606 = GET_NCI_P(0);
    t_607 = (int)GET_NCI_I(1);
    t_608 = (int)GET_NCI_I(2);
    t_609 = (int)GET_NCI_I(3);
    t_610 = (long)GET_NCI_I(4);
    t_611 = (short)GET_NCI_I(5);
    t_612 = GET_NCI_P(6);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_606),t_607,t_608,t_609,t_610,t_611,PMC_data(t_612));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piil(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_613;
    int t_614;
    int t_615;
    long t_616;
    Parrot_init_arg_nci(interp, &st, "PIII");
    t_613 = GET_NCI_P(0);
    t_614 = (int)GET_NCI_I(1);
    t_615 = (int)GET_NCI_I(2);
    t_616 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_613),t_614,t_615,t_616);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piili(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, long, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_617;
    int t_618;
    int t_619;
    long t_620;
    int t_621;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_617 = GET_NCI_P(0);
    t_618 = (int)GET_NCI_I(1);
    t_619 = (int)GET_NCI_I(2);
    t_620 = (long)GET_NCI_I(3);
    t_621 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_617),t_618,t_619,t_620,t_621);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_piit(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_622;
    int t_623;
    int t_624;
    char *t_625;
    Parrot_init_arg_nci(interp, &st, "PIIS");
    t_622 = GET_NCI_P(0);
    t_623 = (int)GET_NCI_I(1);
    t_624 = (int)GET_NCI_I(2);
    {STRING * s= GET_NCI_S(3); t_625 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_622),t_623,t_624,t_625);
    set_nci_I(interp, &st, return_data);
    do { if (t_625) Parrot_str_free_cstring(t_625); } while (0);
}
static void
pcf_i_piiti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, int, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_626;
    int t_627;
    int t_628;
    char *t_629;
    int t_630;
    Parrot_init_arg_nci(interp, &st, "PIISI");
    t_626 = GET_NCI_P(0);
    t_627 = (int)GET_NCI_I(1);
    t_628 = (int)GET_NCI_I(2);
    {STRING * s= GET_NCI_S(3); t_629 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_630 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_626),t_627,t_628,t_629,t_630);
    set_nci_I(interp, &st, return_data);
    do { if (t_629) Parrot_str_free_cstring(t_629); } while (0);
}
static void
pcf_i_pilsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_631;
    int t_632;
    long t_633;
    short t_634;
    PMC *t_635;
    Parrot_init_arg_nci(interp, &st, "PIIIP");
    t_631 = GET_NCI_P(0);
    t_632 = (int)GET_NCI_I(1);
    t_633 = (long)GET_NCI_I(2);
    t_634 = (short)GET_NCI_I(3);
    t_635 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_631),t_632,t_633,t_634,PMC_data(t_635));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pli(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_636;
    long t_637;
    int t_638;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_636 = GET_NCI_P(0);
    t_637 = (long)GET_NCI_I(1);
    t_638 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_636),t_637,t_638);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pll(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_639;
    long t_640;
    long t_641;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_639 = GET_NCI_P(0);
    t_640 = (long)GET_NCI_I(1);
    t_641 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_639),t_640,t_641);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pllllllll(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, long, long, long, long, long, long, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_642;
    long t_643;
    long t_644;
    long t_645;
    long t_646;
    long t_647;
    long t_648;
    long t_649;
    long t_650;
    Parrot_init_arg_nci(interp, &st, "PIIIIIIII");
    t_642 = GET_NCI_P(0);
    t_643 = (long)GET_NCI_I(1);
    t_644 = (long)GET_NCI_I(2);
    t_645 = (long)GET_NCI_I(3);
    t_646 = (long)GET_NCI_I(4);
    t_647 = (long)GET_NCI_I(5);
    t_648 = (long)GET_NCI_I(6);
    t_649 = (long)GET_NCI_I(7);
    t_650 = (long)GET_NCI_I(8);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_642),t_643,t_644,t_645,t_646,t_647,t_648,t_649,t_650);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_plp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_651;
    long t_652;
    PMC *t_653;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_651 = GET_NCI_P(0);
    t_652 = (long)GET_NCI_I(1);
    t_653 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_651),t_652,PMC_data(t_653));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_plsp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, long, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_654;
    long t_655;
    short t_656;
    PMC *t_657;
    Parrot_init_arg_nci(interp, &st, "PIIP");
    t_654 = GET_NCI_P(0);
    t_655 = (long)GET_NCI_I(1);
    t_656 = (short)GET_NCI_I(2);
    t_657 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_654),t_655,t_656,PMC_data(t_657));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_658;
    PMC *t_659;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_658 = GET_NCI_P(0);
    t_659 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_658),PMC_data(t_659));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ppi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_660;
    PMC *t_661;
    int t_662;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_660 = GET_NCI_P(0);
    t_661 = GET_NCI_P(1);
    t_662 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_660),PMC_data(t_661),t_662);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ppiiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, int, int, int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_663;
    PMC *t_664;
    int t_665;
    int t_666;
    int t_667;
    int t_668;
    int t_669;
    int t_670;
    int t_671;
    int t_672;
    Parrot_init_arg_nci(interp, &st, "PPIIIIIIII");
    t_663 = GET_NCI_P(0);
    t_664 = GET_NCI_P(1);
    t_665 = (int)GET_NCI_I(2);
    t_666 = (int)GET_NCI_I(3);
    t_667 = (int)GET_NCI_I(4);
    t_668 = (int)GET_NCI_I(5);
    t_669 = (int)GET_NCI_I(6);
    t_670 = (int)GET_NCI_I(7);
    t_671 = (int)GET_NCI_I(8);
    t_672 = (int)GET_NCI_I(9);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_663),PMC_data(t_664),t_665,t_666,t_667,t_668,t_669,t_670,t_671,t_672);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pppp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_673;
    PMC *t_674;
    PMC *t_675;
    PMC *t_676;
    Parrot_init_arg_nci(interp, &st, "PPPP");
    t_673 = GET_NCI_P(0);
    t_674 = GET_NCI_P(1);
    t_675 = GET_NCI_P(2);
    t_676 = GET_NCI_P(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_673),PMC_data(t_674),PMC_data(t_675),PMC_data(t_676));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_psp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_677;
    short t_678;
    PMC *t_679;
    Parrot_init_arg_nci(interp, &st, "PIP");
    t_677 = GET_NCI_P(0);
    t_678 = (short)GET_NCI_I(1);
    t_679 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_677),t_678,PMC_data(t_679));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_680;
    char *t_681;
    int t_682;
    Parrot_init_arg_nci(interp, &st, "PSI");
    t_680 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_681 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_682 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_680),t_681,t_682);
    set_nci_I(interp, &st, return_data);
    do { if (t_681) Parrot_str_free_cstring(t_681); } while (0);
}
static void
pcf_i_pitl(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, char *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_683;
    int t_684;
    char *t_685;
    long t_686;
    Parrot_init_arg_nci(interp, &st, "PISI");
    t_683 = GET_NCI_P(0);
    t_684 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_685 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_686 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_683),t_684,t_685,t_686);
    set_nci_I(interp, &st, return_data);
    do { if (t_685) Parrot_str_free_cstring(t_685); } while (0);
}
static void
pcf_i_s(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_687;
    Parrot_init_arg_nci(interp, &st, "I");
    t_687 = (short)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_687);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_s22(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short *, short *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_688;
    PMC *t_689;
    short i_689;
    PMC *t_690;
    short i_690;
    Parrot_init_arg_nci(interp, &st, "IPP");
    t_688 = (short)GET_NCI_I(0);
    t_689 = GET_NCI_P(1);
    i_689 = (short) VTABLE_get_integer(interp, t_689);
    t_690 = GET_NCI_P(2);
    i_690 = (short) VTABLE_get_integer(interp, t_690);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_688,&i_689,&i_690);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_689, i_689);
    VTABLE_set_integer_native(interp, t_690, i_690);
}
static void
pcf_i_s222(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short *, short *, short *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_691;
    PMC *t_692;
    short i_692;
    PMC *t_693;
    short i_693;
    PMC *t_694;
    short i_694;
    Parrot_init_arg_nci(interp, &st, "IPPP");
    t_691 = (short)GET_NCI_I(0);
    t_692 = GET_NCI_P(1);
    i_692 = (short) VTABLE_get_integer(interp, t_692);
    t_693 = GET_NCI_P(2);
    i_693 = (short) VTABLE_get_integer(interp, t_693);
    t_694 = GET_NCI_P(3);
    i_694 = (short) VTABLE_get_integer(interp, t_694);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_691,&i_692,&i_693,&i_694);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_692, i_692);
    VTABLE_set_integer_native(interp, t_693, i_693);
    VTABLE_set_integer_native(interp, t_694, i_694);
}
static void
pcf_i_sp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_695;
    PMC *t_696;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_695 = (short)GET_NCI_I(0);
    t_696 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_695,PMC_data(t_696));
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_sss(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short, short);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_697;
    short t_698;
    short t_699;
    Parrot_init_arg_nci(interp, &st, "III");
    t_697 = (short)GET_NCI_I(0);
    t_698 = (short)GET_NCI_I(1);
    t_699 = (short)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_697,t_698,t_699);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ssss(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, short, short, short);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_700;
    short t_701;
    short t_702;
    short t_703;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_700 = (short)GET_NCI_I(0);
    t_701 = (short)GET_NCI_I(1);
    t_702 = (short)GET_NCI_I(2);
    t_703 = (short)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_700,t_701,t_702,t_703);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_t(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_704;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_704 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_704);
    set_nci_I(interp, &st, return_data);
    do { if (t_704) Parrot_str_free_cstring(t_704); } while (0);
}
static void
pcf_i_ti(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_705;
    int t_706;
    Parrot_init_arg_nci(interp, &st, "SI");
    {STRING * s= GET_NCI_S(0); t_705 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_706 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_705,t_706);
    set_nci_I(interp, &st, return_data);
    do { if (t_705) Parrot_str_free_cstring(t_705); } while (0);
}
static void
pcf_i_4(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_707;
    long i_707;
    Parrot_init_arg_nci(interp, &st, "P");
    t_707 = GET_NCI_P(0);
    i_707 = (long) VTABLE_get_integer(interp, t_707);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(&i_707);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_707, i_707);
}
static void
pcf_i_4i(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_708;
    long i_708;
    int t_709;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_708 = GET_NCI_P(0);
    i_708 = (long) VTABLE_get_integer(interp, t_708);
    t_709 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(&i_708,t_709);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_708, i_708);
}
static void
pcf_i_42p(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(long *, short *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_710;
    long i_710;
    PMC *t_711;
    short i_711;
    PMC *t_712;
    Parrot_init_arg_nci(interp, &st, "PPP");
    t_710 = GET_NCI_P(0);
    i_710 = (long) VTABLE_get_integer(interp, t_710);
    t_711 = GET_NCI_P(1);
    i_711 = (short) VTABLE_get_integer(interp, t_711);
    t_712 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(&i_710,&i_711,PMC_data(t_712));
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_710, i_710);
    VTABLE_set_integer_native(interp, t_711, i_711);
}
static void
pcf_l_ii(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    int t_713;
    int t_714;
    Parrot_init_arg_nci(interp, &st, "II");
    t_713 = (int)GET_NCI_I(0);
    t_714 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(t_713,t_714);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_l4(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(long, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    long t_715;
    PMC *t_716;
    long i_716;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_715 = (long)GET_NCI_I(0);
    t_716 = GET_NCI_P(1);
    i_716 = (long) VTABLE_get_integer(interp, t_716);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(t_715,&i_716);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_716, i_716);
}
static void
pcf_l_pi(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_717;
    int t_718;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_717 = GET_NCI_P(0);
    t_718 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(PMC_data(t_717),t_718);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_pii(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_719;
    int t_720;
    int t_721;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_719 = GET_NCI_P(0);
    t_720 = (int)GET_NCI_I(1);
    t_721 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(PMC_data(t_719),t_720,t_721);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_l_p33l(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(void *, int *, int *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_722;
    PMC *t_723;
    int i_723;
    PMC *t_724;
    int i_724;
    long t_725;
    Parrot_init_arg_nci(interp, &st, "PPPI");
    t_722 = GET_NCI_P(0);
    t_723 = GET_NCI_P(1);
    i_723 = (int) VTABLE_get_integer(interp, t_723);
    t_724 = GET_NCI_P(2);
    i_724 = (int) VTABLE_get_integer(interp, t_724);
    t_725 = (long)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(PMC_data(t_722),&i_723,&i_724,t_725);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_723, i_723);
    VTABLE_set_integer_native(interp, t_724, i_724);
}
static void
pcf_l_33l(PARROT_INTERP, PMC *self)
{
    typedef long (*func_t)(int *, int *, long);
    func_t pointer;
    void *orig_func;
    call_state st;
    long return_data;
    PMC *t_726;
    int i_726;
    PMC *t_727;
    int i_727;
    long t_728;
    Parrot_init_arg_nci(interp, &st, "PPI");
    t_726 = GET_NCI_P(0);
    i_726 = (int) VTABLE_get_integer(interp, t_726);
    t_727 = GET_NCI_P(1);
    i_727 = (int) VTABLE_get_integer(interp, t_727);
    t_728 = (long)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (long)(*pointer)(&i_726,&i_727,t_728);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_726, i_726);
    VTABLE_set_integer_native(interp, t_727, i_727);
}
static void
pcf_p_(PARROT_INTERP, PMC *self)
{
    void * (*pointer)(void);
    void *orig_func;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (void * (*)(void))D2FPTR(orig_func);
    return_data =  (void *)(*pointer)();
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_B(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void **);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *s_729;
    char *t_729;
    void** v_729 = (void **) &t_729;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_729 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL; s_729 = t_729;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(v_729);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (s_729) Parrot_str_free_cstring(s_729); } while (0);
}
static void
pcf_p_b(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);STRING *t_730;
    Parrot_init_arg_nci(interp, &st, "S");
    t_730 = GET_NCI_S(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PObj_bufstart(t_730));
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_Jt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_732;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_732 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(interp,t_732);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_732) Parrot_str_free_cstring(t_732); } while (0);
}
static void
pcf_p_i(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_733;
    Parrot_init_arg_nci(interp, &st, "I");
    t_733 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_733);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_ii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_734;
    int t_735;
    Parrot_init_arg_nci(interp, &st, "II");
    t_734 = (int)GET_NCI_I(0);
    t_735 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_734,t_735);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_736;
    int t_737;
    int t_738;
    int t_739;
    Parrot_init_arg_nci(interp, &st, "IIII");
    t_736 = (int)GET_NCI_I(0);
    t_737 = (int)GET_NCI_I(1);
    t_738 = (int)GET_NCI_I(2);
    t_739 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_736,t_737,t_738,t_739);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiiiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_740;
    int t_741;
    int t_742;
    int t_743;
    int t_744;
    int t_745;
    Parrot_init_arg_nci(interp, &st, "IIIIII");
    t_740 = (int)GET_NCI_I(0);
    t_741 = (int)GET_NCI_I(1);
    t_742 = (int)GET_NCI_I(2);
    t_743 = (int)GET_NCI_I(3);
    t_744 = (int)GET_NCI_I(4);
    t_745 = (int)GET_NCI_I(5);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_740,t_741,t_742,t_743,t_744,t_745);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_iiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, int, int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_746;
    int t_747;
    int t_748;
    int t_749;
    int t_750;
    int t_751;
    int t_752;
    int t_753;
    Parrot_init_arg_nci(interp, &st, "IIIIIIII");
    t_746 = (int)GET_NCI_I(0);
    t_747 = (int)GET_NCI_I(1);
    t_748 = (int)GET_NCI_I(2);
    t_749 = (int)GET_NCI_I(3);
    t_750 = (int)GET_NCI_I(4);
    t_751 = (int)GET_NCI_I(5);
    t_752 = (int)GET_NCI_I(6);
    t_753 = (int)GET_NCI_I(7);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_746,t_747,t_748,t_749,t_750,t_751,t_752,t_753);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_pii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_754;
    int t_755;
    int t_756;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_754 = GET_NCI_P(0);
    t_755 = (int)GET_NCI_I(1);
    t_756 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_754),t_755,t_756);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_piiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_757;
    int t_758;
    int t_759;
    int t_760;
    int t_761;
    Parrot_init_arg_nci(interp, &st, "PIIII");
    t_757 = GET_NCI_P(0);
    t_758 = (int)GET_NCI_I(1);
    t_759 = (int)GET_NCI_I(2);
    t_760 = (int)GET_NCI_I(3);
    t_761 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_757),t_758,t_759,t_760,t_761);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_t(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_762;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_762 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_762);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_762) Parrot_str_free_cstring(t_762); } while (0);
}
static void
pcf_p_tpp(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, void *, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_763;
    PMC *t_764;
    PMC *t_765;
    Parrot_init_arg_nci(interp, &st, "SPP");
    {STRING * s= GET_NCI_S(0); t_763 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_764 = GET_NCI_P(1);
    t_765 = GET_NCI_P(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_763,PMC_data(t_764),PMC_data(t_765));
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_763) Parrot_str_free_cstring(t_763); } while (0);
}
static void
pcf_p_ttttttt(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(char *, char *, char *, char *, char *, char *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);char *t_766;
    char *t_767;
    char *t_768;
    char *t_769;
    char *t_770;
    char *t_771;
    char *t_772;
    Parrot_init_arg_nci(interp, &st, "SSSSSSS");
    {STRING * s= GET_NCI_S(0); t_766 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(1); t_767 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(2); t_768 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(3); t_769 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(4); t_770 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(5); t_771 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    {STRING * s= GET_NCI_S(6); t_772 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_766,t_767,t_768,t_769,t_770,t_771,t_772);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    do { if (t_766) Parrot_str_free_cstring(t_766); } while (0);
    do { if (t_767) Parrot_str_free_cstring(t_767); } while (0);
    do { if (t_768) Parrot_str_free_cstring(t_768); } while (0);
    do { if (t_769) Parrot_str_free_cstring(t_769); } while (0);
    do { if (t_770) Parrot_str_free_cstring(t_770); } while (0);
    do { if (t_771) Parrot_str_free_cstring(t_771); } while (0);
    do { if (t_772) Parrot_str_free_cstring(t_772); } while (0);
}
static void
pcf_s_(PARROT_INTERP, PMC *self)
{
    short (*pointer)(void);
    void *orig_func;
    short return_data;
    
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (short (*)(void))D2FPTR(orig_func);
    return_data =  (short)(*pointer)();
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_t_(PARROT_INTERP, PMC *self)
{
    char * (*pointer)(void);
    void *orig_func;
    char * return_data;
    STRING *final_destination;
    call_state st;
    

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (char * (*)(void))D2FPTR(orig_func);
    return_data =  (char *)(*pointer)();
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_i(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;int t_773;
    Parrot_init_arg_nci(interp, &st, "I");
    t_773 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_773);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_ii(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;int t_774;
    int t_775;
    Parrot_init_arg_nci(interp, &st, "II");
    t_774 = (int)GET_NCI_I(0);
    t_775 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_774,t_775);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pi(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;PMC *t_776;
    int t_777;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_776 = GET_NCI_P(0);
    t_777 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(PMC_data(t_776),t_777);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_pii(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;PMC *t_778;
    int t_779;
    int t_780;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_778 = GET_NCI_P(0);
    t_779 = (int)GET_NCI_I(1);
    t_780 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(PMC_data(t_778),t_779,t_780);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_t(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;char *t_781;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_781 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_781);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_781) Parrot_str_free_cstring(t_781); } while (0);
}
static void
pcf_t_tl4(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, long, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;char *t_782;
    long t_783;
    PMC *t_784;
    long i_784;
    Parrot_init_arg_nci(interp, &st, "SIP");
    {STRING * s= GET_NCI_S(0); t_782 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_783 = (long)GET_NCI_I(1);
    t_784 = GET_NCI_P(2);
    i_784 = (long) VTABLE_get_integer(interp, t_784);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_782,t_783,&i_784);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_782) Parrot_str_free_cstring(t_782); } while (0);
    VTABLE_set_integer_native(interp, t_784, i_784);
}
static void
pcf_t_t4(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(char *, long *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;char *t_785;
    PMC *t_786;
    long i_786;
    Parrot_init_arg_nci(interp, &st, "SP");
    {STRING * s= GET_NCI_S(0); t_785 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_786 = GET_NCI_P(1);
    i_786 = (long) VTABLE_get_integer(interp, t_786);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(t_785,&i_786);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (t_785) Parrot_str_free_cstring(t_785); } while (0);
    VTABLE_set_integer_native(interp, t_786, i_786);
}
static void
pcf_i_sc(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(short, char);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    short t_787;
    char t_788;
    Parrot_init_arg_nci(interp, &st, "II");
    t_787 = (short)GET_NCI_I(0);
    t_788 = (char)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_787,t_788);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_s_sc(PARROT_INTERP, PMC *self)
{
    typedef short (*func_t)(short, char);
    func_t pointer;
    void *orig_func;
    call_state st;
    short return_data;
    short t_789;
    char t_790;
    Parrot_init_arg_nci(interp, &st, "II");
    t_789 = (short)GET_NCI_I(0);
    t_790 = (char)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (short)(*pointer)(t_789,t_790);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_c_sc(PARROT_INTERP, PMC *self)
{
    typedef char (*func_t)(short, char);
    func_t pointer;
    void *orig_func;
    call_state st;
    char return_data;
    short t_791;
    char t_792;
    Parrot_init_arg_nci(interp, &st, "II");
    t_791 = (short)GET_NCI_I(0);
    t_792 = (char)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char)(*pointer)(t_791,t_792);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_iii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_793;
    int t_794;
    int t_795;
    Parrot_init_arg_nci(interp, &st, "III");
    t_793 = (int)GET_NCI_I(0);
    t_794 = (int)GET_NCI_I(1);
    t_795 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_793,t_794,t_795);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_i3(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_796;
    PMC *t_797;
    int i_797;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_796 = (int)GET_NCI_I(0);
    t_797 = GET_NCI_P(1);
    i_797 = (int) VTABLE_get_integer(interp, t_797);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_796,&i_797);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_797, i_797);
}
static void
pcf_t_b(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;STRING *t_798;
    Parrot_init_arg_nci(interp, &st, "S");
    t_798 = GET_NCI_S(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(PObj_bufstart(t_798));
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    
}
static void
pcf_t_B(PARROT_INTERP, PMC *self)
{
    typedef char * (*func_t)(void **);
    func_t pointer;
    void *orig_func;
    call_state st;
    char * return_data;
    STRING *final_destination;char *s_799;
    char *t_799;
    void** v_799 = (void **) &t_799;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_799 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL; s_799 = t_799;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (char *)(*pointer)(v_799);
    final_destination = Parrot_str_new(interp, return_data, 0);
    set_nci_S(interp, &st, final_destination);
    do { if (s_799) Parrot_str_free_cstring(s_799); } while (0);
}
static void
pcf_v_P(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_800;
    Parrot_init_arg_nci(interp, &st, "P");
    t_800 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_IS_NULL(t_800) ? NULL : t_800);
    
    
}
static void
pcf_v_pP(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_801;
    PMC *t_802;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_801 = GET_NCI_P(0);
    t_802 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_801),PMC_IS_NULL(t_802) ? NULL : t_802);
    
    
}
static void
pcf_p_ip(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(int, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);int t_803;
    PMC *t_804;
    Parrot_init_arg_nci(interp, &st, "IP");
    t_803 = (int)GET_NCI_I(0);
    t_804 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(t_803,PMC_data(t_804));
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_33(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(int *, int *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_805;
    int i_805;
    PMC *t_806;
    int i_806;
    Parrot_init_arg_nci(interp, &st, "PP");
    t_805 = GET_NCI_P(0);
    i_805 = (int) VTABLE_get_integer(interp, t_805);
    t_806 = GET_NCI_P(1);
    i_806 = (int) VTABLE_get_integer(interp, t_806);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(&i_805,&i_806);
    set_nci_I(interp, &st, return_data);
    VTABLE_set_integer_native(interp, t_805, i_805);
    VTABLE_set_integer_native(interp, t_806, i_806);
}
static void
pcf_v_pii(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_807;
    int t_808;
    int t_809;
    Parrot_init_arg_nci(interp, &st, "PII");
    t_807 = GET_NCI_P(0);
    t_808 = (int)GET_NCI_I(1);
    t_809 = (int)GET_NCI_I(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(PMC_data(t_807),t_808,t_809);
    
    
}
static void
pcf_v_JO(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_811;
    Parrot_init_arg_nci(interp, &st, "P");
    t_811 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(interp,PMC_IS_NULL(t_811) ? NULL : t_811);
    
    
}
static void
pcf_i_JO(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_813;
    Parrot_init_arg_nci(interp, &st, "P");
    t_813 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_813) ? NULL : t_813);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JOi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_815;
    int t_816;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_815 = GET_NCI_P(0);
    t_816 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_815) ? NULL : t_815,t_816);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_JOt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, PMC *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_818;
    char *t_819;
    Parrot_init_arg_nci(interp, &st, "PS");
    t_818 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_819 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,PMC_IS_NULL(t_818) ? NULL : t_818,t_819);
    set_nci_I(interp, &st, return_data);
    do { if (t_819) Parrot_str_free_cstring(t_819); } while (0);
}
static void
pcf_i_Jt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_821;
    Parrot_init_arg_nci(interp, &st, "S");
    {STRING * s= GET_NCI_S(0); t_821 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,t_821);
    set_nci_I(interp, &st, return_data);
    do { if (t_821) Parrot_str_free_cstring(t_821); } while (0);
}
static void
pcf_i_Ji(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(PARROT_INTERP, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    int t_823;
    Parrot_init_arg_nci(interp, &st, "I");
    t_823 = (int)GET_NCI_I(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(interp,t_823);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_Vi(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void **, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_824;
    int t_825;
    Parrot_init_arg_nci(interp, &st, "PI");
    t_824 = GET_NCI_P(0);
    t_825 = (int)GET_NCI_I(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((void**)&PMC_data(t_824),t_825);
    
    
}
static void
pcf_p_ppiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_826;
    PMC *t_827;
    int t_828;
    int t_829;
    int t_830;
    Parrot_init_arg_nci(interp, &st, "PPIII");
    t_826 = GET_NCI_P(0);
    t_827 = GET_NCI_P(1);
    t_828 = (int)GET_NCI_I(2);
    t_829 = (int)GET_NCI_I(3);
    t_830 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_826),PMC_data(t_827),t_828,t_829,t_830);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_p_ppiiiiiii(PARROT_INTERP, PMC *self)
{
    typedef void * (*func_t)(void *, void *, int, int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    void * return_data;
    PMC * const final_destination = pmc_new(interp, enum_class_UnManagedStruct);PMC *t_831;
    PMC *t_832;
    int t_833;
    int t_834;
    int t_835;
    int t_836;
    int t_837;
    int t_838;
    int t_839;
    Parrot_init_arg_nci(interp, &st, "PPIIIIIII");
    t_831 = GET_NCI_P(0);
    t_832 = GET_NCI_P(1);
    t_833 = (int)GET_NCI_I(2);
    t_834 = (int)GET_NCI_I(3);
    t_835 = (int)GET_NCI_I(4);
    t_836 = (int)GET_NCI_I(5);
    t_837 = (int)GET_NCI_I(6);
    t_838 = (int)GET_NCI_I(7);
    t_839 = (int)GET_NCI_I(8);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (void *)(*pointer)(PMC_data(t_831),PMC_data(t_832),t_833,t_834,t_835,t_836,t_837,t_838,t_839);
    PMC_data(final_destination) = return_data;    set_nci_P(interp, &st, final_destination);
    
}
static void
pcf_i_ppt(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, char *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_840;
    PMC *t_841;
    char *t_842;
    Parrot_init_arg_nci(interp, &st, "PPS");
    t_840 = GET_NCI_P(0);
    t_841 = GET_NCI_P(1);
    {STRING * s= GET_NCI_S(2); t_842 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_840),PMC_data(t_841),t_842);
    set_nci_I(interp, &st, return_data);
    do { if (t_842) Parrot_str_free_cstring(t_842); } while (0);
}
static void
pcf_i_pppi(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_843;
    PMC *t_844;
    PMC *t_845;
    int t_846;
    Parrot_init_arg_nci(interp, &st, "PPPI");
    t_843 = GET_NCI_P(0);
    t_844 = GET_NCI_P(1);
    t_845 = GET_NCI_P(2);
    t_846 = (int)GET_NCI_I(3);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_843),PMC_data(t_844),PMC_data(t_845),t_846);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pppii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_847;
    PMC *t_848;
    PMC *t_849;
    int t_850;
    int t_851;
    Parrot_init_arg_nci(interp, &st, "PPPII");
    t_847 = GET_NCI_P(0);
    t_848 = GET_NCI_P(1);
    t_849 = GET_NCI_P(2);
    t_850 = (int)GET_NCI_I(3);
    t_851 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_847),PMC_data(t_848),PMC_data(t_849),t_850,t_851);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pppiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_852;
    PMC *t_853;
    PMC *t_854;
    int t_855;
    int t_856;
    int t_857;
    int t_858;
    Parrot_init_arg_nci(interp, &st, "PPPIIII");
    t_852 = GET_NCI_P(0);
    t_853 = GET_NCI_P(1);
    t_854 = GET_NCI_P(2);
    t_855 = (int)GET_NCI_I(3);
    t_856 = (int)GET_NCI_I(4);
    t_857 = (int)GET_NCI_I(5);
    t_858 = (int)GET_NCI_I(6);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_852),PMC_data(t_853),PMC_data(t_854),t_855,t_856,t_857,t_858);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_ppppiiiiii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, void *, void *, void *, int, int, int, int, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_859;
    PMC *t_860;
    PMC *t_861;
    PMC *t_862;
    int t_863;
    int t_864;
    int t_865;
    int t_866;
    int t_867;
    int t_868;
    Parrot_init_arg_nci(interp, &st, "PPPPIIIIII");
    t_859 = GET_NCI_P(0);
    t_860 = GET_NCI_P(1);
    t_861 = GET_NCI_P(2);
    t_862 = GET_NCI_P(3);
    t_863 = (int)GET_NCI_I(4);
    t_864 = (int)GET_NCI_I(5);
    t_865 = (int)GET_NCI_I(6);
    t_866 = (int)GET_NCI_I(7);
    t_867 = (int)GET_NCI_I(8);
    t_868 = (int)GET_NCI_I(9);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_859),PMC_data(t_860),PMC_data(t_861),PMC_data(t_862),t_863,t_864,t_865,t_866,t_867,t_868);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_v_fff(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(float, float, float);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    float t_869;
    float t_870;
    float t_871;
    Parrot_init_arg_nci(interp, &st, "NNN");
    t_869 = (float)GET_NCI_N(0);
    t_870 = (float)GET_NCI_N(1);
    t_871 = (float)GET_NCI_N(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)(t_869,t_870,t_871);
    
    
}
static void
pcf_v_V(PARROT_INTERP, PMC *self)
{
    typedef void (*func_t)(void **);
    func_t pointer;
    void *orig_func;
    call_state st;
    
    PMC *t_872;
    Parrot_init_arg_nci(interp, &st, "P");
    t_872 = GET_NCI_P(0);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
     (void)(*pointer)((void**)&PMC_data(t_872));
    
    
}
static void
pcf_i_tV(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(char *, void **);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    char *t_873;
    PMC *t_874;
    Parrot_init_arg_nci(interp, &st, "SP");
    {STRING * s= GET_NCI_S(0); t_873 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_874 = GET_NCI_P(1);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(t_873,(void**)&PMC_data(t_874));
    set_nci_I(interp, &st, return_data);
    do { if (t_873) Parrot_str_free_cstring(t_873); } while (0);
}
static void
pcf_i_ptiVp(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, char *, int, void **, void *);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_875;
    char *t_876;
    int t_877;
    PMC *t_878;
    PMC *t_879;
    Parrot_init_arg_nci(interp, &st, "PSIPP");
    t_875 = GET_NCI_P(0);
    {STRING * s= GET_NCI_S(1); t_876 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_877 = (int)GET_NCI_I(2);
    t_878 = GET_NCI_P(3);
    t_879 = GET_NCI_P(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_875),t_876,t_877,(void**)&PMC_data(t_878),PMC_data(t_879));
    set_nci_I(interp, &st, return_data);
    do { if (t_876) Parrot_str_free_cstring(t_876); } while (0);
}
static void
pcf_i_pid(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, double);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_880;
    int t_881;
    double t_882;
    Parrot_init_arg_nci(interp, &st, "PIN");
    t_880 = GET_NCI_P(0);
    t_881 = (int)GET_NCI_I(1);
    t_882 = (double)GET_NCI_N(2);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_880),t_881,t_882);
    set_nci_I(interp, &st, return_data);
    
}
static void
pcf_i_pitii(PARROT_INTERP, PMC *self)
{
    typedef int (*func_t)(void *, int, char *, int, int);
    func_t pointer;
    void *orig_func;
    call_state st;
    int return_data;
    PMC *t_883;
    int t_884;
    char *t_885;
    int t_886;
    int t_887;
    Parrot_init_arg_nci(interp, &st, "PISII");
    t_883 = GET_NCI_P(0);
    t_884 = (int)GET_NCI_I(1);
    {STRING * s= GET_NCI_S(2); t_885 = s ? Parrot_str_to_cstring(interp, s) : (char *) NULL;}
    t_886 = (int)GET_NCI_I(3);
    t_887 = (int)GET_NCI_I(4);

    GETATTR_NCI_orig_func(interp, self, orig_func);
    pointer = (func_t)D2FPTR(orig_func);
    return_data =  (int)(*pointer)(PMC_data(t_883),t_884,t_885,t_886,t_887);
    set_nci_I(interp, &st, return_data);
    do { if (t_885) Parrot_str_free_cstring(t_885); } while (0);
}


/* This function serves a single purpose. It takes the function
   signature for a C function we want to call and returns a pointer
   to a function that can call it. */
void *
build_call_func(PARROT_INTERP,
#if defined(CAN_BUILD_CALL_FRAMES)
PMC *pmc_nci,
#else
SHIM(PMC *pmc_nci),
#endif
NOTNULL(STRING *signature), NOTNULL(int *jitted))
{
    char       *c;
    STRING     *ns, *message;
    STRING     *jit_key_name;
    PMC        *b;
    PMC        *iglobals;
    PMC        *temp_pmc;
    UINTVAL    signature_len;

    PMC        *HashPointer   = NULL;

    /* And in here is the platform-independent way. Which is to say
       "here there be hacks" */
    signature_len = Parrot_str_byte_length(interp, signature);
    if (0 == signature_len)
       return F2DPTR(pcf_v_);
    /* remove deprecated void argument 'v' character */
    if (2 == signature_len && 'v' == Parrot_str_indexed(interp, signature, 1)) {
       Parrot_warn(interp, PARROT_WARNINGS_ALL_FLAG, "function signature argument character 'v' ignored");
       Parrot_str_chopn_inplace(interp, signature, 1);
       signature_len = Parrot_str_byte_length(interp, signature);
    }

    iglobals = interp->iglobals;

    if (PMC_IS_NULL(iglobals))
        PANIC(interp, "iglobals isn't created yet");
    HashPointer = VTABLE_get_pmc_keyed_int(interp, iglobals,
            IGLOBALS_NCI_FUNCS);

    if (!HashPointer) {
        HashPointer = pmc_new(interp, enum_class_Hash);
        VTABLE_set_pmc_keyed_int(interp, iglobals, IGLOBALS_NCI_FUNCS,
                HashPointer);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_d_JOd;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "dJOd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_I_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_Jt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_S_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "SJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_I_JI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JOSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_I_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOPS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOPS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JOPSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JPIP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPIP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JPSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JPNP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPNP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JPI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JPS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JPN;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJPN"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JPIP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJPIP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JPSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJPSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JPNP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJPNP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_I_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JPi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JPii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JPiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JPt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOSSS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOSSS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JOSS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOSS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_S_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "SJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JOb;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JOPxAT_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJOP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_I_JOPxAT_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_I_JOIPxAT_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOIP@"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JOP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_Ji;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_J;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJ"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JPip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JpP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJpP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_Jpii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_tp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "itp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_J;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJ"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_Jp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_J;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tJ"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_Jpti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tJpti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_pt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tpt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_pit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_ptt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vptt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_Jtiiipt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJtiiipt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_JttPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJttPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_Jtpi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJtpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_Vppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iVppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JpPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJpPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_pt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_Jpt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJpt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "v"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_Jiiip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJiiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_illllllll;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "villllllll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_pbip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpbip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_piiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_pl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_pp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_S_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "SJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JOPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JOPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOPPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOPPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOPPPPP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOPPPPP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_I_JOSI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOSI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOSII;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOSII"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_Ji;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_Jipp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_Jbip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJbip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_Jp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_tt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_I_JOt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJOt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JOSI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOSI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_S_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "SJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_I_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "IJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_N_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "NJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JON;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJON"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOI;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOI"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_P_JOIS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "PJOIS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_S_JOSP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "SJOSP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_i3i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ii3i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ibi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iibi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_l_lttl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "llttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_piS;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiS"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_S_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "Si"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_l_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_c_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "cp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pttttt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipttttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_c_pttt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "cpttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_pttttiti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppttttiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ptl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iptl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_l_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_pt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_ptt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pptt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_pp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_l_ttl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_l_pttl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lpttl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_pttttitl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppttttitl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_tiB3P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ptiB3P"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_tip3P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ptip3P"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pPtiiipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipPtiiipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_tpiibi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "itpiibi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_ptippppi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pptippppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_pi33ipi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppi33ipi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_pttip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppttip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_ptipppi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pptipppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_ppP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pppP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_iiil;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "piiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ppl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_pip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_pti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_ti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_ptp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pptp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pt33;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipt33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_c_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "c"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_c_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "cpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_d_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "d"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_d_d;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "dd"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_f_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "f"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_f_ff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "fff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_f_is;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "fis"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_b;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ib"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_d;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "id"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ii4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iii4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ii4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iii4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_iiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_iiilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiiilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_iil;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_iili;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_iip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_iit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_iiti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_iti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "il"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_li;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_lp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ilp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_lsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_p33;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_p333;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip333"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_p333333;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip333333"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_p4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_p42p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip42p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_p4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ip4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pb;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pii4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipii4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pii4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipii4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_piii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_piiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_piiilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiiilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_piil;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiil"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_piili;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiili"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_piit;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiit"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_piiti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipiiti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pilsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipilsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pli;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipli"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pll;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pllllllll;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipllllllll"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_plp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iplp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_plsp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iplsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ppi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ppiiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippiiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pppp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipppp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_psp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipsp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pitl;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipitl"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_s;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "is"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_s22;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "is22"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_s222;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "is222"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_sp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "isp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_sss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "isss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ssss;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "issss"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "it"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ti;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "i4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_4i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "i4i"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_42p;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "i42p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_l_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_l_l4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ll4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_l_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_l_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_l_p33l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "lp33l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_l_33l;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "l33l"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "p"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_B;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pB"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_b;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_Jt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_iiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "piiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_iiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "piiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_iiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "piiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_piiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ppiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_tpp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ptpp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_ttttttt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pttttttt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_s_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "s"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "t"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_i;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ti"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_ii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_pi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tpi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_t;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_tl4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ttl4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_t4;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tt4"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_sc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "isc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_s_sc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ssc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_c_sc;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "csc"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_iii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_i3;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ii3"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_b;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tb"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_t_B;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "tB"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_P;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_pP;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpP"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_ip;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pip"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_33;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "i33"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_pii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vpii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JO;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJO"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JOi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJOi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_JOt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJOt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_Jt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_Ji;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iJi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_Vi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vVi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_ppiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pppiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_p_ppiiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "pppiiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ppt;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippt"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pppi;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipppi"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pppii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipppii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pppiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipppiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ppppiiiiii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ippppiiiiii"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_fff;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vfff"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_v_V;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "vV"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_tV;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "itV"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_ptiVp;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "iptiVp"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pid;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipid"), temp_pmc);

        temp_pmc = pmc_new(interp, enum_class_UnManagedStruct);
        PMC_data(temp_pmc) = (void *)pcf_i_pitii;
        VTABLE_set_pmc_keyed_str(interp, HashPointer, CONST_STRING(interp, "ipitii"), temp_pmc);


    }

#if defined(CAN_BUILD_CALL_FRAMES)
    /* Try if JIT code can build that signature. If yes, we are done */

    jit_key_name = CONST_STRING(interp, "_XJIT_");
    jit_key_name = Parrot_str_concat(interp, jit_key_name, signature, 0);
    b            = VTABLE_get_pmc_keyed_str(interp, HashPointer, jit_key_name);

    if (b && b->vtable->base_type == enum_class_ManagedStruct) {
        *jitted = 1;
        return F2DPTR(VTABLE_get_pointer(interp, b));
    }
    else {
        void * const result = Parrot_jit_build_call_func(interp, pmc_nci, signature);
        if (result) {
            *jitted = 1;
            temp_pmc = pmc_new(interp, enum_class_ManagedStruct);
            VTABLE_set_pointer(interp, temp_pmc, (void *)result);
            VTABLE_set_pmc_keyed_str(interp, HashPointer, jit_key_name, temp_pmc);
            return result;
        }
    }

#endif

    b = VTABLE_get_pmc_keyed_str(interp, HashPointer, signature);

    if (b && b->vtable->base_type == enum_class_UnManagedStruct)
        return F2DPTR(PMC_data(b));

    /*
      These three lines have been added to aid debugging. I want to be able to
      see which signature has an unknown type. I am sure someone can come up
      with a neater way to do this.
     */
    ns = string_make(interp, " is an unknown signature type", 29, "ascii", 0);
    message = Parrot_str_concat(interp, signature, ns, 0);

#if defined(CAN_BUILD_CALL_FRAMES)
    ns = string_make(interp, ".\nCAN_BUILD_CALL_FRAMES is enabled, this should not happen", 58, "ascii", 0);
#else
    ns = string_make(interp, ".\nCAN_BUILD_CALL_FRAMES is disabled, add the signature to src/call_list.txt", 75, "ascii", 0);
#endif
    message = Parrot_str_concat(interp, message, ns, 0);

    /*
     * I think there may be memory issues with this but if we get to here we are
     * aborting.
     */
    c = Parrot_str_to_cstring(interp, message);
    PANIC(interp, c);
}


/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
