/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/class.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_class.h"
#include "pmc_default.h"
#include "class.str"
#include "pmc_continuation.h"
#line 1 "./src/pmc/class.pmc"
/*
Copyright (C) 2001-2008, Parrot Foundation.
$Id: class.pmc 37374 2009-03-13 07:47:12Z allison $

=head1 NAME

src/pmc/class.pmc - defines a class

=head1 DESCRIPTION

This class implements the Class PMC, as outlined in
F<docs/pdds/pdd15_objects.pod>.

Class is not derived from any other PMC.

=head2 Structure

The Class PMC structure (C<Parrot_Class>) consists of twelve items:

=over 4

=item C<id>

The type number of the PMC. [deprecated: See RT #48024]

=item C<name>

The name of the class -- a STRING.
An empty STRING is allocated during initialization.

=item C<namespace>

The namespace the class is associated with, if any.
A Null PMC is allocated during initialization.

=item C<instantiated>

A flag denoting whether this class has been instantiated since last
modification.  A native integer with value zero is allocated during
initialization.

=item C<parents>

An array of immediate parent classes.
An empty ResizablePMCArray PMC is allocated during initialization.

=item C<all_parents>

A cached array of ourself and all parent classes, in MRO order.
A ResizablePMCArray PMC is allocated during initialization,
and is populated with the current class.

=item C<roles>

An array of the roles this class has been composed from.
An empty ResizablePMCArray PMC is allocated during initialization.

=item C<methods>

A directory of method names and method bodies this class provides.
An empty Hash PMC is allocated during initialization.

=item C<vtable_overrides>

A directory of vtable method names and method bodies this class overrides.
An empty Hash PMC is allocated during initialization.

=item C<attrib_metadata>

A directory of attribute names and attribute metadata this class contains.
An empty Hash PMC is allocated during initialization.

=item C<attrib_index>

A lookup table for attributes in this class and parents.
A Null PMC is allocated during initialization.

=item C<attrib_cache>

A cache of visible attribute names to attribute indexes.
A Null PMC is allocated during initialization.

=item C<resolve_method>

A list of method names the class provides used for name conflict resolution.
An empty ResizablePMCArray PMC is allocated during initialization.

=cut

*/

#define PARROT_IN_OBJECTS_C /* To get the vtable.h imports we want. */
#include "parrot/parrot.h"
#include "parrot/oo_private.h"
#include "pmc_object.h"
#include "pmc_namespace.h"

/* This function builds the attribute index (table to map class name and
 * attribute name to an index) for the current class. */
static void
build_attrib_index(PARROT_INTERP, PMC *self)
{
    Parrot_Class_attributes * const _class      = PARROT_CLASS(self);
    int                  cur_index    = 0;
    PMC * const          attrib_index = pmc_new(interp, enum_class_Hash);
    PMC * const          cache        = pmc_new(interp, enum_class_Hash);
    const int            num_classes  = VTABLE_elements(interp, _class->all_parents);
    int                  i;

    /* We will go over the list of all parents to construct the attribute index. */
    for (i = 0; i < num_classes; i++) {
       /* Get the class and check that it respects the standard class interface
        * (if not we don't know how it stores its attributes, so we'll have to
        * delegate the lookup). */
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp,
                                    _class->all_parents, i);

        if (PObj_is_class_TEST(cur_class)) {
            /* The attribute metadata hash. */
            Parrot_Class_attributes * const class_info = PARROT_CLASS(cur_class);
            PMC          * const attribs     = class_info->attrib_metadata;
            PMC          * const iter        = VTABLE_get_iter(interp, attribs);

            /* Build a string representing the fully qualified class name. */
            /* Retrieve the fully qualified class name for the class. */
            STRING       * const fq_class    = VTABLE_get_string(interp, cur_class);
            PMC          * const class_cache = pmc_new(interp, enum_class_Hash);
            VTABLE_set_pmc_keyed_str(interp, cache, fq_class, class_cache);

            /* Iterate over the attributes. */
            while (VTABLE_get_bool(interp, iter)) {
                /* Get attribute. */
                PMC    * const cur_attrib  = VTABLE_get_pmc_keyed_str(interp,
                        attribs, VTABLE_shift_string(interp, iter));

                /* Get attribute name and append it to the key. */
                STRING * const name_str    = CONST_STRING(interp, "name");
                STRING * const attrib_name = VTABLE_get_string_keyed_str(
                    interp, cur_attrib, name_str);

                STRING *full_key           = Parrot_str_append(interp, fq_class, attrib_name);

                /* Insert into hash, along with index. */
                VTABLE_set_integer_keyed_str(interp, attrib_index, full_key, cur_index);
                VTABLE_set_integer_keyed_str(interp, class_cache, attrib_name, cur_index);
                cur_index++;
            }
        }
    }

    /* Store built attribute index and invalidate cache. */
    _class->attrib_index = attrib_index;
    _class->attrib_cache = cache;
}

/* Takes a hash and initializes the class based on it. */
static void
init_class_from_hash(PARROT_INTERP, PMC *self, PMC *info)
{
    Parrot_Class_attributes * const _class      = PARROT_CLASS(self);
    STRING       * const name_str    = CONST_STRING(interp, "name");
    STRING       * const parents_str = CONST_STRING(interp, "parents");
    STRING       * const methods_str = CONST_STRING(interp, "methods");
    STRING       * const roles_str   = CONST_STRING(interp, "roles");
    STRING       * const attrs_str   = CONST_STRING(interp, "attributes");
    PMC          *old_ns;
    STRING       *resolve_method_str;
    INTVAL        type_num;

    /* Ensure we actually have some initialization info. */
    if (PMC_IS_NULL(info))
        return;

    /* Take a copy of the current namespace the class is attached to. */
    old_ns = _class->_namespace;

    /* Check if we have a name/namespace. */
    if (VTABLE_exists_keyed_str(interp, info, name_str)) {
        STRING *new_name;
        PMC    *new_namespace;
        PMC    *name_arg = VTABLE_get_pmc_keyed_str(interp, info, name_str);
        VTABLE *new_vtable;

        /* If we were passed a namespace PMC, set the namespace attribute
         * directly. Otherwise, lookup or create the appropriate namespace. */
        if (name_arg->vtable->base_type == enum_class_NameSpace) {
            new_namespace = name_arg;
            name_arg      = Parrot_ns_get_name(interp, new_namespace);
            VTABLE_shift_string(interp, name_arg);
        }
        else {
            PMC * const hll_ns = VTABLE_get_pmc_keyed_int(interp,
                    interp->HLL_namespace, CONTEXT(interp)->current_HLL);
            new_namespace = Parrot_make_namespace_keyed(interp, hll_ns, name_arg);
        }

        if (PMC_IS_NULL(new_namespace))
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Failed to set namespace for class.");

        /* Set the name of the class to the name of the innermost namespace
         * associated with the class.  */
        new_name = VTABLE_get_string(interp, new_namespace);

        if (STRING_IS_NULL(new_name) || STRING_IS_EMPTY(new_name))
              Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Failed to set name for class.");

        _class->_namespace = new_namespace;
        _class->name       = new_name;

        /* At this point we know the class isn't anonymous */
        CLASS_is_anon_CLEAR(self);

        /* Register a type number for the class. */
        type_num   = Parrot_oo_register_type(interp, name_arg, new_namespace);

        /* Link the type number with the class's vtable. */
        new_vtable = Parrot_clone_vtable(interp, self->vtable);

        new_vtable->base_type         = type_num;
        new_vtable->pmc_class         = self;
        new_vtable->whoami            = VTABLE_get_string(interp, self);
        new_vtable->mro               = _class->all_parents;
        new_vtable->ro_variant_vtable =
                Parrot_clone_vtable(interp, self->vtable->ro_variant_vtable);

        /* Store the class's vtable in the global table */
        interp->vtables[type_num]     = new_vtable;

        _class->id                    = type_num;
    }

    /* If we were attached to a namespace and are now attached to a new one,
     * need to unset ourselves in the old namespace. */
    if (!PMC_IS_NULL(old_ns) && _class->_namespace != old_ns)
        Parrot_PCCINVOKE(interp, old_ns, CONST_STRING(interp, "set_class"), "P->", PMCNULL);

    /* Link namespace to this class, if there is one. */
    if (!PMC_IS_NULL(_class->_namespace)) {
        STRING * const set_class_str = CONST_STRING(interp, "set_class");
        Parrot_PCCINVOKE(interp, _class->_namespace, set_class_str, "P->", self);
    }

    /* Initialize resolve_method. */
    resolve_method_str = CONST_STRING(interp, "resolve_method");
    if (VTABLE_exists_keyed_str(interp, info, resolve_method_str)) {
        /* Set it. */
        _class->resolve_method =
            VTABLE_get_pmc_keyed_str(interp, info, resolve_method_str);
    }

    /* Initialize parents, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, parents_str)) {
        /* Loop over parents array and add them. */
        PMC * const parent_list = VTABLE_get_pmc_keyed_str(interp, info,
            parents_str);
        const int  parent_count = VTABLE_elements(interp, parent_list);
        int i;

        for (i = 0; i < parent_count; i++)
            VTABLE_add_parent(interp, self,
                VTABLE_get_pmc_keyed_int(interp, parent_list, i));
    }

    /* Initialize roles, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, roles_str)) {
        /* Loop over roles array and compose them. */
        PMC * const role_list  = VTABLE_get_pmc_keyed_str(interp, info,
            roles_str);
        const int   role_count = VTABLE_elements(interp, role_list);
        int i;

        for (i = 0; i < role_count; i++)
            VTABLE_add_role(interp, self,
                VTABLE_get_pmc_keyed_int(interp, role_list, i));
    }

    /* Initialize attributes, if we have any. */
    if (VTABLE_exists_keyed_str(interp, info, attrs_str)) {
        /* Loop over attributes array and add them. */
        PMC * const attrs_name_list = VTABLE_get_pmc_keyed_str(interp, info,
                                            attrs_str);
        const int   attrib_count    = VTABLE_elements(interp, attrs_name_list);
        int i;

        for (i = 0; i < attrib_count; i++) {
            STRING * const attr_name = VTABLE_get_string_keyed_int(interp,
                attrs_name_list, i);
            VTABLE_add_attribute(interp, self, attr_name, PMCNULL);
        }
    }

    /* Initialize methods. */
    if (VTABLE_exists_keyed_str(interp, info, methods_str)) {
        /* Get the methods hash. */
        PMC * const methods = VTABLE_get_pmc_keyed_str(interp, info,
            methods_str);

        /* Iterate over the list of methods. */
        PMC * const iter    = VTABLE_get_iter(interp, methods);

        while (VTABLE_get_bool(interp, iter)) {
            /* Add the method. */
            STRING * const method_name = VTABLE_shift_string(interp, iter);
            PMC    * const method_pmc  = VTABLE_get_pmc_keyed_str(interp,
                methods, method_name);
            VTABLE_add_method(interp, self, method_name, method_pmc);
        }
    }

    /* Extract any methods from the namespace */
    Parrot_oo_extract_methods_from_namespace(interp, self, _class->_namespace);
}

static void
initialize_parents(PARROT_INTERP, PMC *object, PMC *all_parents)
{
    INTVAL  parent_index = VTABLE_elements(interp, all_parents) - 1;
    STRING * const name  = CONST_STRING(interp, "init");

    /* Loop through the parents in reverse MRO order. */
    for (; parent_index >= 0; parent_index--) {
        PMC *meth;
        PMC * const parent = VTABLE_get_pmc_keyed_int(interp,
            all_parents, parent_index);

        /* PMCProxy parents store an instance to delegate to */
        if (parent->vtable->base_type == enum_class_PMCProxy) {
            PMC    *proxy     = VTABLE_instantiate(interp, parent, PMCNULL);
            STRING *proxy_str = CONST_STRING(interp, "proxy");
            VTABLE_set_attr_keyed(interp, object, parent, proxy_str, proxy);
        }

        meth = Parrot_oo_find_vtable_override_for_class(interp, parent, name);

        if (!PMC_IS_NULL(meth)) {
            Parrot_run_meth_fromc_args(interp, meth, object, name, "v");
        }
    }
}

static void
initialize_parents_pmc(PARROT_INTERP, PMC *object, PMC *all_parents, PMC *init)
{
    INTVAL  parent_index = VTABLE_elements(interp, all_parents) - 1;
    STRING * const name  = CONST_STRING(interp, "init_pmc");

    /* Loop through the parents in reverse MRO order. */
    for (; parent_index >= 0; parent_index--) {
        PMC *meth;
        PMC * const parent = VTABLE_get_pmc_keyed_int(interp,
            all_parents, parent_index);

        /* PMCProxy parents store an instance to delegate to */
        if (parent->vtable->base_type == enum_class_PMCProxy) {
            PMC    * const proxy     = VTABLE_instantiate(interp, parent, init);
            STRING * const proxy_str = CONST_STRING(interp, "proxy");
            VTABLE_set_attr_keyed(interp, object, parent, proxy_str, proxy);
        }

        meth = Parrot_oo_find_vtable_override_for_class(interp, parent, name);

        if (!PMC_IS_NULL(meth))
            Parrot_run_meth_fromc_args(interp, meth, object, name, "vP", init);
    }
}

/* This function makes and caches the name of this class, returning the string
 * directly.  VTABLE_isa() uses the name without copying it, for efficiency
 * reasons, as it does not modify the STRING.  VTABLE_get_string() makes a copy
 * of the STRING, so its callers are free to modify it. */
static STRING *
make_class_name(PARROT_INTERP, PMC *SELF)
{
    Parrot_Class_attributes * const  _class    = PARROT_CLASS(SELF);
    PMC          * const _namespace = _class->_namespace;

    if (!PMC_IS_NULL(_namespace)) {
        if (_class->fullname)
            return _class->fullname;
        else {

            /* Call the 'get_name' method on the class's associated
             * namespace to retrieve a fully qualified list of names, then
             * join the list with a semicolon.  */
            PMC * const names = Parrot_ns_get_name(interp, _namespace);

            if (!PMC_IS_NULL(names))
                /* remove the HLL namespace name */
                VTABLE_shift_string(interp, names);
                _class->fullname = Parrot_str_join(interp, CONST_STRING(interp, ";"), names);
                return _class->fullname;
        }
    }

    /* Otherwise, copy the stored string name of the class. */
    return _class->name;
}

/*

=back

=head2 Functions

=over 4

=cut

*/
#line 434 "./src/pmc/class.c"
PARROT_EXPORT  void 
Parrot_Class_add_attribute(PARROT_INTERP, PMC *pmc, STRING *name, PMC *type)
{
#line 622 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class        = PARROT_CLASS(pmc);
    PMC          * const new_attribute = pmc_new(interp, enum_class_Hash);

    /* If we've been instantiated already, not allowed. */
    if (_class->instantiated)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Modifications to classes are not allowed after instantiation.");

    /* If we already have an attribute of this name, it's an error. */
    if (VTABLE_exists_keyed_str(interp, _class->attrib_metadata, name))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Attribute '%Ss' already exists in '%Ss'.", name,
            VTABLE_get_string(interp, pmc));

    /* Set name and type. */
    VTABLE_set_string_keyed_str(interp, new_attribute, CONST_STRING(interp, "name"), name);

    if (!PMC_IS_NULL(type))
        VTABLE_set_pmc_keyed_str(interp, new_attribute, CONST_STRING(interp, "type"), type);

    /* Enter the attribute in the attrib_metadata table. */
    VTABLE_set_pmc_keyed_str(interp, _class->attrib_metadata, name,
        new_attribute);
#line 463 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_add_method(PARROT_INTERP, PMC *pmc, STRING *name, PMC *sub)
{
#line 689 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);

    /* If we have already added a method with this name... */
    if (VTABLE_exists_keyed_str(interp, _class->methods, name))
        /* RT #46095 Need to handle multi methods here. */
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "A method named '%S' already exists in class '%S'. "
            "It may have been supplied by a role.",
            name, VTABLE_get_string(interp, pmc));

    /* Enter it into the table. */
    VTABLE_set_pmc_keyed_str(interp, _class->methods, name, sub);
#line 482 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_add_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
#line 760 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);

    /* get name of the parent being added */
    STRING * const parent_name  = VTABLE_get_string(interp, parent);

    /* get number of direct parents */
    int parent_count      = VTABLE_elements(interp, _class->parents);

    int index; /* loop iterator */

    /* If we've been instantiated already, not allowed. */
    if (_class->instantiated)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Modifications to classes are not allowed after instantiation.");

    /* Ensure it really is a class. */
    if (!PObj_is_class_TEST(parent))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                "Parent isn't a Class.");

    /* iterate over all direct parents, check whether this class already has
     * the parent being added. */
    for (index = 0; index < parent_count; index++) {
        /* get the next parent */
        PMC * const current_parent = VTABLE_get_pmc_keyed_int(interp,
                                  _class->parents, index);

        /* get the name of the current parent */
        STRING * const current_name = VTABLE_get_string(interp, current_parent);

        /* throw an exception if we already have this parent */
        if (Parrot_str_equal(interp, current_name, parent_name))
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "The class '%S' already has a parent class '%S'. "
                "It may have been supplied by a role.",
                VTABLE_get_string(interp, pmc), parent_name);
    }
    /* Check is not self */
    if (parent == pmc)
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION, "Can't be own parent");

    /* Check that none of the parents is self */
    parent_count = VTABLE_elements(interp,
        PARROT_CLASS(parent)->all_parents);
    for (index = 0; index < parent_count; index++) {
        /* get the next parent */
        PMC * const current_parent = VTABLE_get_pmc_keyed_int(interp,
            PARROT_CLASS(parent)->all_parents, index);
        if (current_parent == pmc)
            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION,
                "Loop in class hierarchy: '%S' is an ancestor of '%S'.",
                VTABLE_get_string(interp, pmc),
                VTABLE_get_string(interp, parent));
    }

    /* Add to the lists of our immediate parents and all parents. */
    VTABLE_push_pmc(interp, _class->parents, parent);
    _class->all_parents = Parrot_ComputeMRO_C3(interp, pmc);

    /* Anonymous classes have no entry in the vtable array */
    if (!CLASS_is_anon_TEST(pmc))
        interp->vtables[VTABLE_type(interp, pmc)]->mro = _class->all_parents;
#line 554 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_add_role(PARROT_INTERP, PMC *pmc, PMC *role)
{
#line 899 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);

    /* Do the composition. */
    Parrot_ComposeRole(interp, role,
        _class->resolve_method, !PMC_IS_NULL(_class->resolve_method),
       PMCNULL, 0, _class->methods, _class->roles);
#line 567 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_add_vtable_override(PARROT_INTERP, PMC *pmc, STRING *name, PMC *sub)
{
#line 732 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);

    /* If we have already added a vtable override with this name... */
    if (VTABLE_exists_keyed_str(interp, _class->vtable_overrides, name))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "A vtable override named '%S' already exists in class '%S'. "
            "It may have been supplied by a role.",
            name, VTABLE_get_string(interp, pmc));

    /* Check that the name is actually valid as a vtable override */
    if (Parrot_get_vtable_index(interp, name) == -1)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_METHOD_NOT_FOUND,
            "'%S' is not a valid vtable function name.", name);

    /* Add it to vtable methods list. */
    VTABLE_set_pmc_keyed_str(interp, _class->vtable_overrides, name, sub);
#line 590 "./src/pmc/class.c"
}
PARROT_EXPORT  PMC  *
Parrot_Class_clone(PARROT_INTERP, PMC *pmc)
{
#line 1070 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class    = PARROT_CLASS(pmc);

    /* Create the new class PMC, of the same type of this one (we may
     * have been subclassed). */
    PMC          * const copy      = Parrot_default_clone(interp, pmc);

    /* Clone parents, roles, methods, attributes and resolve data. We do
     * not copy name/namespace related stuff (need anonymous clone) or
     * stuff that gets computed on the first instantiation. */

    Parrot_Class_attributes * const new_class = PARROT_CLASS(copy);

    new_class->name                = CONST_STRING(interp, "");
    new_class->_namespace          = PMCNULL;
    new_class->parents             = VTABLE_clone(interp, _class->parents);
    new_class->roles               = VTABLE_clone(interp, _class->roles);
    new_class->methods             = VTABLE_clone(interp, _class->methods);
    new_class->vtable_overrides    = VTABLE_clone(interp,
                                        _class->vtable_overrides);
    new_class->parent_overrides    = VTABLE_clone(interp,
                                        _class->parent_overrides);
    new_class->attrib_metadata     = VTABLE_clone(interp,
                                        _class->attrib_metadata);
    new_class->resolve_method      = VTABLE_clone(interp,
                                        _class->resolve_method);

    /* Return cloned class. */
    return copy;
#line 625 "./src/pmc/class.c"
}
PARROT_EXPORT  PMC  *
Parrot_Class_clone_pmc(PARROT_INTERP, PMC *pmc, PMC *args)
{
#line 1114 "./src/pmc/class.pmc"

    /* Do the standard clone. */
    PMC * const copy = VTABLE_clone(interp, pmc);

    init_class_from_hash(interp, copy, args);

    return copy;
#line 638 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_destroy(PARROT_INTERP, PMC *pmc)
{
#line 550 "./src/pmc/class.pmc"

    mem_sys_free(PMC_data(pmc));
#line 646 "./src/pmc/class.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Class_does(PARROT_INTERP, PMC *pmc, STRING *role_name)
{
#line 1336 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class    = PARROT_CLASS(pmc);
    PMC          * const role_list = _class->roles;
    INTVAL i, count;

    if (!role_list)
        return 0;

    count = VTABLE_elements(interp, role_list);

    for (i = 0; i < count; i++) {
        PMC * const role = VTABLE_get_pmc_keyed_int(interp, role_list, i);

        if (VTABLE_does(interp, role, role_name))
            return 1;
    }

    /* Iterate over all the parents and check if they respond true
     * for 'does' on the original comparison. */
    count = VTABLE_elements(interp, _class->parents);

    for (i = 0; i < count; i++) {
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp,
                _class->parents, i);

        if (VTABLE_does(interp, cur_class, role_name))
            return 1;
    }

    return VTABLE_isa(interp, pmc, role_name);
#line 682 "./src/pmc/class.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Class_does_pmc(PARROT_INTERP, PMC *pmc, PMC *role)
{
#line 1377 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class    = PARROT_CLASS(pmc);
    PMC * const role_list          = _class->roles;
    INTVAL i, role_count, count;

    if (!role_list)
        return 0;

    role_count = VTABLE_elements(interp, role_list);

    for (i = 0; i < role_count; i++) {
        INTVAL  role_does;
        PMC    * const test_role = VTABLE_get_pmc_keyed_int(interp, role_list, i);

        role_does = VTABLE_does_pmc(interp, test_role, role);

        if (role_does)
            return 1;
    }

    /* Iterate over all the parents and check if they respond true
     * for 'does' on the original comparison. */
    count = VTABLE_elements(interp, _class->parents);

    for (i = 0; i < count; i++) {
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp,
                _class->parents, i);

        if (VTABLE_does_pmc(interp, cur_class, role))
            return 1;
    }

    return VTABLE_isa_pmc(interp, pmc, role);
#line 721 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_freeze(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1484 "./src/pmc/class.pmc"

    IMAGE_IO     * const io         = info->image_io;
    Parrot_Class_attributes * const class_data = PARROT_CLASS(pmc);
    STRING       *serial_namespace  = CONST_STRING(interp, "");

    /* 1) freeze class id */
    VTABLE_push_integer(interp, io, class_data->id);

    /* 2) freeze class name */
    VTABLE_push_string(interp, io, class_data->name);

    /* 3) serialize namespace name, including HLL */
    if (!PMC_IS_NULL(class_data->_namespace)) {
        PMC * const names = Parrot_ns_get_name(interp,
                class_data->_namespace);
        if (!PMC_IS_NULL(names))
            serial_namespace = Parrot_str_join(interp, CONST_STRING(interp, ";"), names);
    }
    VTABLE_push_string(interp, io, serial_namespace);
#line 746 "./src/pmc/class.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Class_get_integer(PARROT_INTERP, PMC *pmc)
{
#line 1574 "./src/pmc/class.pmc"

    return PARROT_CLASS(pmc)->id;
#line 754 "./src/pmc/class.c"
}
PARROT_EXPORT  STRING  *
Parrot_Class_get_string(PARROT_INTERP, PMC *pmc)
{
#line 564 "./src/pmc/class.pmc"

    return Parrot_str_copy(interp, make_class_name(interp, pmc));
#line 762 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_init(PARROT_INTERP, PMC *pmc)
{
#line 431 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = mem_allocate_zeroed_typed(Parrot_Class_attributes);

    /* Set flags for custom GC mark and destroy. */
    PObj_custom_mark_SET(pmc);
    PObj_active_destroy_SET(pmc);

    /* Set up the object. */
    PMC_data(pmc)          = _class;
    _class->name            = CONST_STRING(interp, "");
    _class->_namespace      = PMCNULL;
    _class->parents         = pmc_new(interp, enum_class_ResizablePMCArray);
    _class->all_parents     = pmc_new(interp, enum_class_ResizablePMCArray);
    _class->roles           = pmc_new(interp, enum_class_ResizablePMCArray);
    _class->methods         = pmc_new(interp, enum_class_Hash);
    _class->attrib_metadata = pmc_new(interp, enum_class_Hash);
    _class->attrib_index    = PMCNULL;
    _class->attrib_cache    = PMCNULL;
    _class->resolve_method  = pmc_new(interp, enum_class_ResizablePMCArray);

    _class->vtable_overrides = pmc_new(interp, enum_class_Hash);
    _class->parent_overrides = constant_pmc_new(interp, enum_class_Hash);

    /* We put ourself on the all parents list. */
    VTABLE_push_pmc(interp, _class->all_parents, pmc);

    /* We are a class. */
    PObj_is_class_SET(pmc);

    /* By default we're anonymous. */
    CLASS_is_anon_SET(pmc);
#line 799 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_init_pmc(PARROT_INTERP, PMC *pmc, PMC *init_data)
{
#line 464 "./src/pmc/class.pmc"

    PMC           *arg;
    const INTVAL   arg_type = VTABLE_type(interp, init_data);
    STRING * const name_str = CONST_STRING(interp, "name");

    /* Set up the object. */
    VTABLE_init(interp, pmc);

    /* fast attempt to determine init_data type */
    switch (arg_type) {
        case enum_class_String:
        case enum_class_Key:
        case enum_class_ResizableStringArray:
        case enum_class_NameSpace:
            /* set only the name property */
            arg = pmc_new(interp, enum_class_Hash);
            VTABLE_set_pmc_keyed_str(interp, arg, name_str, init_data);
            break;

        case enum_class_Hash:
            arg = init_data;
            break;

        /* slow attempt to determine init_data type */
        default:
            if (VTABLE_isa(interp, init_data, CONST_STRING(interp, "String"))
            || VTABLE_isa(interp, init_data, CONST_STRING(interp, "Key"))
            || VTABLE_isa(interp, init_data, CONST_STRING(interp, "ResizableStringArray"))) {
                /* set only the name property */
                arg = pmc_new(interp, enum_class_Hash);
                VTABLE_set_pmc_keyed_str(interp, arg, name_str, init_data);
            }

            if (VTABLE_isa(interp, init_data, CONST_STRING(interp, "Hash")))
                arg = init_data;
            else
                Parrot_ex_throw_from_c_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION,
                        "Invalid class name key in init_pmc for Class");
            break;
    }

    /* Initialize the class with the supplied data. */
    init_class_from_hash(interp, pmc, arg);
#line 849 "./src/pmc/class.c"
}
PARROT_EXPORT  PMC  *
Parrot_Class_inspect(PARROT_INTERP, PMC *pmc)
{
#line 1023 "./src/pmc/class.pmc"

    /* Create a hash, then use inspect_str to get all of the data to
     * fill it up with. */
    PMC    * const metadata    = pmc_new(interp, enum_class_Hash);
    STRING * const name_str    = CONST_STRING(interp, "name");
    STRING * const ns_str      = CONST_STRING(interp, "namespace");
    STRING * const attrs_str   = CONST_STRING(interp, "attributes");
    STRING * const meths_str   = CONST_STRING(interp, "methods");
    STRING * const parents_str = CONST_STRING(interp, "parents");
    STRING * const roles_str   = CONST_STRING(interp, "roles");
    STRING * const flags_str   = CONST_STRING(interp, "flags");

    VTABLE_set_pmc_keyed_str(interp, metadata, name_str,
        VTABLE_inspect_str(interp, pmc, name_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, ns_str,
        VTABLE_inspect_str(interp, pmc, ns_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, attrs_str,
        VTABLE_inspect_str(interp, pmc, attrs_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, meths_str,
        VTABLE_inspect_str(interp, pmc, meths_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, parents_str,
        VTABLE_inspect_str(interp, pmc, parents_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, roles_str,
        VTABLE_inspect_str(interp, pmc, roles_str));

    VTABLE_set_pmc_keyed_str(interp, metadata, flags_str,
        VTABLE_inspect_str(interp, pmc, flags_str));

    return metadata;
#line 889 "./src/pmc/class.c"
}
PARROT_EXPORT  PMC  *
Parrot_Class_inspect_str(PARROT_INTERP, PMC *pmc, STRING *what)
{
#line 948 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);

    /* What should we return? */
    PMC *found;

    if (Parrot_str_equal(interp, what, CONST_STRING(interp, "name"))) {
        found = pmc_new(interp, enum_class_String);
        VTABLE_set_string_native(interp, found, _class->name);
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "id"))) {
        found = pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, found, _class->id);
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "namespace"))) {
        /* Should not clone this. */
        return _class->_namespace;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "attributes"))) {
        found = _class->attrib_metadata;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "attrib_index"))) {
        found = _class->attrib_index;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "methods"))) {
        found = _class->methods;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "vtable_overrides"))) {
        found = _class->vtable_overrides;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "parents"))) {
        found = _class->parents;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "all_parents"))) {
        found = _class->all_parents;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "roles"))) {
        found = _class->roles;
    }
    else if (Parrot_str_equal(interp, what, CONST_STRING(interp, "flags"))) {
        found = pmc_new(interp, enum_class_Integer);
        VTABLE_set_integer_native(interp, found,
            (INTVAL)PObj_get_FLAGS(pmc));
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Unknown introspection value '%S'", what);

    /* return found value */
    if (PMC_IS_NULL(found)) { return PMCNULL; }
    if (found->vtable->base_type == enum_class_Hash) {
        /* for Hash return values, create and return a shallow
         * clone because the VTABLE_clone does a deep clone */
        PMC * const hash = pmc_new(interp, enum_class_Hash);
        PMC * const iter = VTABLE_get_iter(interp, found);
        while (VTABLE_get_bool(interp, iter)) {
            STRING * key = VTABLE_shift_string(interp, iter);
            PMC * value  = VTABLE_get_pmc_keyed_str(interp, found, key);
            VTABLE_set_pmc_keyed_str(interp, hash, key, value);
        }
        return hash;
    }
    return VTABLE_clone(interp, found);
#line 958 "./src/pmc/class.c"
}
PARROT_EXPORT  PMC  *
Parrot_Class_instantiate(PARROT_INTERP, PMC *pmc, PMC *init)
{
#line 1133 "./src/pmc/class.pmc"

    Parrot_Class_attributes  * const _class    = PARROT_CLASS(pmc);

    Parrot_Object_attributes *obj_guts;
    PMC                      *object;

    /* If we've not been instantiated before... */
    if (!_class->instantiated) {
        /* Check that we have all methods listed in resolve list. */
        const int resolve_count = VTABLE_elements(interp, _class->resolve_method);
        const INTVAL cur_hll    = CONTEXT(interp)->current_HLL;
        INTVAL    mro_length;
        int       i;

        /* don't use HLL mappings for internal-only data */
        CONTEXT(interp)->current_HLL = 0;

        for (i = 0; i < resolve_count; i++) {
            STRING * const check_meth =
                VTABLE_get_string_keyed_int(interp, _class->resolve_method, i);
            if (!VTABLE_exists_keyed_str(interp, _class->methods, check_meth))
                Parrot_ex_throw_from_c_args(interp, NULL,
                    EXCEPTION_METHOD_NOT_FOUND, "The method '%S' was named "
                    "in the resolve list, but not supplied", check_meth);
        }

        /* Build full parents list.
         * RT #46101 Need pluggable MRO, for now always do C3. */
        _class->all_parents = Parrot_ComputeMRO_C3(interp, pmc);

        if (!CLASS_is_anon_TEST(pmc))
            interp->vtables[VTABLE_type(interp, pmc)]->mro = _class->all_parents;

        build_attrib_index(interp, pmc);

        if (PMC_IS_NULL(_class->attrib_index))
            return PMCNULL;

        /* See if we have any parents from other universes and if so set a
         * flag stating so. */
        mro_length = VTABLE_elements(interp, _class->all_parents);

        for (i = 0; i < mro_length; i++) {
            PMC * const class_check = VTABLE_get_pmc_keyed_int(interp,
                _class->all_parents, i);
            if (class_check->vtable->base_type != enum_class_Class) {
                /* Found one; that's enough. */
                CLASS_has_alien_parents_SET(pmc);
                break;
            }
        }

        CONTEXT(interp)->current_HLL = cur_hll;
    }

    /* Set instantiated flag. */
    _class->instantiated = 1;

    /* Create object. */
    object = pmc_new_noinit(interp, enum_class_Object);

    /* Set custom GC mark and destroy on the object. */
    PObj_custom_mark_SET(object);
    PObj_active_destroy_SET(object);

    /* Flag that it is an object */
    PObj_is_object_SET(object);

    /* Initialize the object's underlying structure, pointing it to this
     * class. */
    obj_guts               = mem_allocate_zeroed_typed(Parrot_Object_attributes);
    obj_guts->_class       = pmc;
    PMC_data(object)       = obj_guts;
    obj_guts->attrib_store = pmc_new(interp, enum_class_ResizablePMCArray);

    if (!PMC_IS_NULL(init)) {
        /* Initialize attributes with the supplied values. */
        PMC * const iter = VTABLE_get_iter(interp, init);

        while (VTABLE_get_bool(interp, iter)) {
            /* Get name and value. */
            STRING * const attr_name  = VTABLE_shift_string(interp, iter);
            PMC    * const attr_value = VTABLE_get_pmc_keyed_str(interp, init,
                attr_name);

            /* Set the attribute. */
            VTABLE_set_attr_str(interp, object, attr_name, attr_value);
        }
    }

    /* Check for overrides on the init or init_pmc vtable function and call
     * them if they exist */
    if (PMC_IS_NULL(init))
        initialize_parents(interp, object, _class->all_parents);
    else
        initialize_parents_pmc(interp, object, _class->all_parents, init);

    return object;
#line 1062 "./src/pmc/class.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Class_isa(PARROT_INTERP, PMC *pmc, STRING *classname)
{
#line 1309 "./src/pmc/class.pmc"

    PMC *want_class;

    /* hard-code this one exception right away */
    if (Parrot_str_equal(interp, classname, CONST_STRING(interp, "Class")))
        return 1;

    want_class = Parrot_oo_get_class_str(interp, classname);

    if (PMC_IS_NULL(want_class))
        return 0;

    if (pmc == want_class)
        return 1;

    return VTABLE_isa_pmc(interp, pmc, want_class);
#line 1084 "./src/pmc/class.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Class_isa_pmc(PARROT_INTERP, PMC *pmc, PMC *lookup)
{
#line 1244 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class    = PARROT_CLASS(pmc);
    PMC          *classobj;
    INTVAL        i, num_classes;

    if (PMC_IS_NULL(lookup))
        return 0;

    if (Parrot_default_isa_pmc(interp, pmc, lookup))
        return 1;

    classobj = Parrot_oo_get_class(interp, lookup);

    if (PMC_IS_NULL(classobj))
        return 0;

    /* Check if the class object is the same as self's class object */
    if (VTABLE_is_same(interp, pmc, classobj))
        return 1;
    else {
        STRING *classname = VTABLE_get_string(interp, classobj);
        INTVAL  is_proxy  = pmc->vtable->base_type == enum_class_PMCProxy
                           ? 1 : 0;

        /* avoid the expensive string copy, if possible */
        STRING *self_name = is_proxy
                           ? VTABLE_get_string(interp, pmc)
                           : make_class_name(interp, pmc);

        /* Check if the passed name is the same as the stored short name. */
        INTVAL name_match = Parrot_str_equal(interp, classname, self_name);

        Parrot_str_free(interp, classname);
        if (is_proxy)
            Parrot_str_free(interp, self_name);

        if (name_match)
            return 1;
    }

    /* Iterate over all the parents and check if they respond true
     * for 'isa' on the original comparison. */
    num_classes = VTABLE_elements(interp, _class->parents);

    for (i = 0; i < num_classes; i++) {
        PMC * const cur_class = VTABLE_get_pmc_keyed_int(interp,
                _class->parents, i);

        if (VTABLE_isa_pmc(interp, cur_class, lookup))
            return 1;
    }

    return 0;
#line 1143 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_mark(PARROT_INTERP, PMC *pmc)
{
#line 578 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);
    if (_class->name)
        pobject_lives(interp, (PObj *)_class->name);
    if (_class->fullname)
        pobject_lives(interp, (PObj *)_class->fullname);
    if (_class->_namespace)
        pobject_lives(interp, (PObj *)_class->_namespace);
    if (_class->parents)
        pobject_lives(interp, (PObj *)_class->parents);
    if (_class->all_parents)
        pobject_lives(interp, (PObj *)_class->all_parents);
    if (_class->roles)
        pobject_lives(interp, (PObj *)_class->roles);
    if (_class->methods)
        pobject_lives(interp, (PObj *)_class->methods);
    if (_class->vtable_overrides)
        pobject_lives(interp, (PObj *)_class->vtable_overrides);
    if (_class->parent_overrides)
        pobject_lives(interp, (PObj *)_class->parent_overrides);
    if (_class->attrib_metadata)
        pobject_lives(interp, (PObj *)_class->attrib_metadata);
    if (_class->attrib_index)
        pobject_lives(interp, (PObj *)_class->attrib_index);
    if (_class->attrib_cache)
        pobject_lives(interp, (PObj *)_class->attrib_cache);
    if (_class->resolve_method)
        pobject_lives(interp, (PObj *)_class->resolve_method);
#line 1177 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_remove_attribute(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 660 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class        = PARROT_CLASS(pmc);

    /* If we've been instantiated already, not allowed. */
    if (_class->instantiated)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Modifications to classes are not allowed after instantiation.");

    /* If we don't have an attribute of this name, it's an error. */
    if (!VTABLE_exists_keyed_str(interp, _class->attrib_metadata, name))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Attribute '%Ss' cannot be removed, does not exist in '%Ss'.", name,
            VTABLE_get_string(interp, pmc));

    /* Remove the attribute from the attrib_metadata table. */
    VTABLE_delete_keyed_str(interp, _class->attrib_metadata, name);

    build_attrib_index(interp, pmc);
#line 1201 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_remove_method(PARROT_INTERP, PMC *pmc, STRING *name)
{
#line 713 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);
    if (VTABLE_exists_keyed_str(interp, _class->methods, name))
        VTABLE_delete_keyed_str(interp, _class->methods, name);
    else
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "No method named '%S' to remove in class '%S'.",
            name, VTABLE_get_string(interp, pmc));
#line 1215 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_remove_parent(PARROT_INTERP, PMC *pmc, PMC *parent)
{
#line 839 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);

    /* get number of direct parents */
    const int parent_count      = VTABLE_elements(interp, _class->parents);

    int index; /* loop iterator */

    /* If we've been instantiated already, not allowed. */
    if (_class->instantiated) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Modifications to classes are not allowed after instantiation.");
    }

    /* Ensure it really is a class. */
    if (!PObj_is_class_TEST(parent)) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Parent isn't a Class.");
    }

    /* iterate over all direct parents, looking for
     * the parent to be removed.
     */
    for (index = 0; index < parent_count; index++) {
        /* get the next parent */
        PMC * const current_parent = VTABLE_get_pmc_keyed_int(interp,
                                  _class->parents, index);
        if (current_parent == parent)
            break;
    }
    if (index >= parent_count)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Can't remove_parent: is not a parent.");

    /* Move up the remaining parents on the list and pops it */
    for (; index < parent_count - 1; index++) {
        PMC * const current_parent = VTABLE_get_pmc_keyed_int(interp,
            _class->parents, index + 1);
        VTABLE_set_pmc_keyed_int(interp, _class->parents,
            index, current_parent);
    }
    VTABLE_pop_pmc(interp, _class->parents);

    _class->all_parents = Parrot_ComputeMRO_C3(interp, pmc);

    /* Anonymous classes have no entry in the vtable array */
    if (!CLASS_is_anon_TEST(pmc))
        interp->vtables[VTABLE_type(interp, pmc)]->mro = _class->all_parents;
#line 1269 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_thaw(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1515 "./src/pmc/class.pmc"

    /* The class might already exist in the interpreter, so create it as an
     * anonymous class and later decide whether to link it into the
     * namespace.  */

    if (info->extra_flags == EXTRA_IS_PROP_HASH) {
        Parrot_default_thaw(interp, pmc, info);
    }
    else if (info->extra_flags == EXTRA_IS_NULL) {
        IMAGE_IO * const io = info->image_io;

        /* 1) thaw class id */
        const INTVAL id = VTABLE_shift_integer(interp, io);

        /* 2) thaw class name */
        STRING * const name = VTABLE_shift_string(interp, io);

        /* 3) deserialize namespace name, including HLL */
        STRING * const serial_namespace = VTABLE_shift_string(interp, io);
        STRING * const semicolon_str = CONST_STRING(interp, ";");
        PMC    * const namespace_array =
            Parrot_str_split(interp, semicolon_str, serial_namespace);
        PMC *ns = Parrot_get_namespace_keyed(interp,
                interp->root_namespace, namespace_array);

        /* If the namespace doesn't exist, we create it, and initialize
         * ourselves in it */
        if (PMC_IS_NULL(ns)) {
            ns = Parrot_make_namespace_keyed(interp,
                    interp->root_namespace, namespace_array);
            VTABLE_init_pmc(interp, pmc, ns);
        }
        /* If the namespace exists already, we point to it, but otherwise
         * act as an anonymous class. */
        else {
            VTABLE_init(interp, pmc);
            PARROT_CLASS(pmc)->_namespace = ns;
        }

        /* Set the class's short name to the frozen name */
        PARROT_CLASS(pmc)->name = name;

        /* Set the class's id the frozen id */
        PARROT_CLASS(pmc)->id = id;
    }
#line 1320 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_thawfinish(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1588 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);

    /* Recalculate full MRO from thawed parents */
    _class->all_parents         = Parrot_ComputeMRO_C3(interp, pmc);
    _class->parent_overrides    = pmc_new(interp, enum_class_Hash);

    /* Rebuild attribute index from thawed attribute metadata */
    build_attrib_index(interp, pmc);
#line 1335 "./src/pmc/class.c"
}
PARROT_EXPORT  INTVAL 
Parrot_Class_type(PARROT_INTERP, PMC *pmc)
{
#line 1422 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);
    return _class->id;
#line 1344 "./src/pmc/class.c"
}
PARROT_EXPORT  void 
Parrot_Class_visit(PARROT_INTERP, PMC *pmc, visit_info *info)
{
#line 1439 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const class_data = PARROT_CLASS(pmc);
    PMC **pos;

    /* 1) visit the attribute description hash */
    pos            = &class_data->attrib_metadata;
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);

    /* 2) visit list of parents */
    pos            = &class_data->parents;
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);

    /* 3) visit list of roles */
    pos            = &class_data->roles;
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);

    /* 4) visit hash of methods */
    pos            = &class_data->methods;
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);

    /* 5) visit hash of vtable overrides */
    pos            = &class_data->vtable_overrides;
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);

    /* 6) visit list of resolve methods */
    pos            = &class_data->resolve_method;
    info->thaw_ptr = pos;
    (info->visit_pmc_now)(interp, *pos, info);
#line 1383 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_name(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1423 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1440 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    INTVAL has_name = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1614 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);
    STRING *ret_name;

    if (has_name) {
        /* We'll build a hash just containing the name, then give this to
         * init_class_from_hash - saves some code duplication. */
        PMC    * const naming_hash = pmc_new(interp, enum_class_Hash);
        STRING * const name_str    = CONST_STRING(interp, "name");

        VTABLE_set_string_keyed_str(interp, naming_hash, name_str, name);
        init_class_from_hash(interp, pmc, naming_hash);
    }

    ret_name = _class->name;
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN STRING *ret_name */
    /*BEGIN GENERATED ACCESSORS */
#line 1469 "./src/pmc/class.pmc"
    CTX_REG_STR(_ctx, 0) = ret_name;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 1);

    goto name_returns;
    /*END RETURN STRING *ret_name */
    }
#line 1629 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
name_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1514 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_get_namespace(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 130);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1554 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1571 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* _namespace = CTX_REG_PMC(_ctx, 1);
    INTVAL has_name = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1641 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class        = PARROT_CLASS(pmc);
    PMC          * const ret_namespace = _class->_namespace;
    UNUSED(_namespace);
    UNUSED(has_name);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_namespace */
    /*BEGIN GENERATED ACCESSORS */
#line 1590 "./src/pmc/class.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_namespace;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto get_namespace_returns;
    /*END RETURN PMC *ret_namespace */
    }
#line 1646 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
get_namespace_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1635 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_resolve_method(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 130);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1675 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1692 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* resolve_list = CTX_REG_PMC(_ctx, 1);
    INTVAL has_list = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1659 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const _class   = PARROT_CLASS(pmc);
    PMC *ret_list;

    /* Store list. */
    if (has_list)
        _class->resolve_method = resolve_list;

    ret_list = _class->resolve_method;
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_list */
    /*BEGIN GENERATED ACCESSORS */
#line 1715 "./src/pmc/class.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_list;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto resolve_method_returns;
    /*END RETURN PMC *ret_list */
    }
#line 1668 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
resolve_method_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1760 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_new(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 546);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1799 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1816 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* args = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1681 "./src/pmc/class.pmc"

    /* Check if any arguments are in the slurpy hash, don't pass an empty
     * hash to instantiate */
    PMC * const obj =
        VTABLE_elements(interp, args) > 0
            ? VTABLE_instantiate(interp, pmc, args)
            : VTABLE_instantiate(interp, pmc, PMCNULL);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *obj */
    /*BEGIN GENERATED ACCESSORS */
#line 1837 "./src/pmc/class.pmc"
    CTX_REG_PMC(_ctx, 0) = obj;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto new_returns;
    /*END RETURN PMC *obj */
    }
#line 1689 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
new_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1882 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_attributes(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 1920 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 1937 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1702 "./src/pmc/class.pmc"

    STRING * const attr_str            = CONST_STRING(interp, "attributes");
    PMC    * const ret_attrib_metadata = pmc->vtable->inspect_str(interp, pmc, attr_str);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_attrib_metadata */
    /*BEGIN GENERATED ACCESSORS */
#line 1953 "./src/pmc/class.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_attrib_metadata;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto attributes_returns;
    /*END RETURN PMC *ret_attrib_metadata */
    }
#line 1706 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
attributes_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 1998 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_add_attribute(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 2 };
    opcode_t _param_indexes[]     = { 0, 0, 1, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 4);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 130);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 3, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2039 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2056 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* attribute_name = CTX_REG_STR(_ctx, 0);
    PMC* attribute_type = CTX_REG_PMC(_ctx, 1);
    INTVAL has_type = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1719 "./src/pmc/class.pmc"

    PMC * const type = has_type ? attribute_type : PMCNULL;
    pmc->vtable->add_attribute(interp, pmc, attribute_name, type);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2084 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_methods(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2122 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2139 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1733 "./src/pmc/class.pmc"

    PMC * const ret_methods = pmc->vtable->inspect_str(interp, pmc, CONST_STRING(interp, "methods"));

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_methods */
    /*BEGIN GENERATED ACCESSORS */
#line 2154 "./src/pmc/class.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_methods;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto methods_returns;
    /*END RETURN PMC *ret_methods */
    }
#line 1736 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
methods_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2199 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_add_method(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 4, 0, 3, 2 };
    opcode_t _param_indexes[]     = { 0, 0, 1, 1, 0, 1, 2, 2, 3 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 9);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 3, 513);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 4, 128);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 5, 256);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 6, 513);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 7, 128);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 8, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2245 "./src/pmc/class.pmc"
    CTX_REG_STR(_ctx, 1) = CONST_STRING_GEN(interp, "vtable");
    CTX_REG_STR(_ctx, 2) = CONST_STRING_GEN(interp, "anon");

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2264 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    PMC* sub = CTX_REG_PMC(_ctx, 1);
    INTVAL vtable = CTX_REG_INT(_ctx, 0);
    INTVAL has_vtable = CTX_REG_INT(_ctx, 1);
    INTVAL anon = CTX_REG_INT(_ctx, 2);
    INTVAL has_anon = CTX_REG_INT(_ctx, 3);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1754 "./src/pmc/class.pmc"

    /* If it's a vtable method... */
    if (has_vtable && vtable)
        VTABLE_add_vtable_override(interp, pmc, name, sub);

    /* Provided it's not anonymous, add it to the methods list. */
    if (!has_anon || !anon)
        pmc->vtable->add_method(interp, pmc, name, sub);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2300 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_add_vtable_override(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 2 };
    opcode_t _param_indexes[]     = { 0, 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2340 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2357 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);
    PMC* sub = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1774 "./src/pmc/class.pmc"

    VTABLE_add_vtable_override(interp, pmc, name, sub);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2383 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_remove_method(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2422 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2439 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1788 "./src/pmc/class.pmc"

    VTABLE_remove_method(interp, pmc, name);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2464 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_find_method(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2503 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2520 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* name = CTX_REG_STR(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1802 "./src/pmc/class.pmc"

    Parrot_Class_attributes * const  _class    = PARROT_CLASS(pmc);
    int i;

    /* Walk and search. One day, we'll use the cache first. */
    const int num_classes = VTABLE_elements(interp, _class->all_parents);

    for (i = 0; i < num_classes; i++) {
        /* Get the class and see if it has the method. */
        PMC * const cur_class =
            VTABLE_get_pmc_keyed_int(interp, _class->all_parents, i);
        const Parrot_Class_attributes * const class_info = PARROT_CLASS(cur_class);

        /* Found it! */
        if (VTABLE_exists_keyed_str(interp, class_info->methods, name)) {
            PMC * const ret = VTABLE_get_pmc_keyed_str(interp, class_info->methods, name);
            #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret */
    /*BEGIN GENERATED ACCESSORS */
#line 2549 "./src/pmc/class.pmc"
    CTX_REG_PMC(_ctx, 0) = ret;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto find_method_returns;
    /*END RETURN PMC *ret */
    }
#line 1818 "./src/pmc/class.pmc"

        }
    }

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    /*BEGIN GENERATED ACCESSORS */
#line 2575 "./src/pmc/class.pmc"
    CTX_REG_PMC(_ctx, 0) = PMCNULL;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto find_method_returns;
    /*END RETURN PMC *PMCNULL */
    }
#line 1822 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
find_method_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2620 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_parents(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2658 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2675 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1834 "./src/pmc/class.pmc"

    PMC * const ret_parents = pmc->vtable->inspect_str(interp, pmc, CONST_STRING(interp, "parents"));

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_parents */
    /*BEGIN GENERATED ACCESSORS */
#line 2690 "./src/pmc/class.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_parents;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto parents_returns;
    /*END RETURN PMC *ret_parents */
    }
#line 1837 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
parents_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2735 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_add_parent(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 2 };
    opcode_t _param_indexes[]     = { 0, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2774 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2791 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* parent = CTX_REG_PMC(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1849 "./src/pmc/class.pmc"

    pmc->vtable->add_parent(interp, pmc, parent);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2816 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_roles(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 0, 0, 0, 1 };
    opcode_t _param_indexes[]     = { 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2854 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2871 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1862 "./src/pmc/class.pmc"

    PMC * const ret_roles = pmc->vtable->inspect_str(interp, pmc, CONST_STRING(interp, "roles"));

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *ret_roles */
    /*BEGIN GENERATED ACCESSORS */
#line 2886 "./src/pmc/class.pmc"
    CTX_REG_PMC(_ctx, 0) = ret_roles;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto roles_returns;
    /*END RETURN PMC *ret_roles */
    }
#line 1865 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
roles_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 2931 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_add_role(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 2, 0, 2, 4 };
    opcode_t _param_indexes[]     = { 0, 1, 0, 2, 0, 1, 3, 1 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 8);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 513);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 3, 130);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 4, 256);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 5, 513);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 6, 130);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 7, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 2976 "./src/pmc/class.pmc"
    CTX_REG_STR(_ctx, 0) = CONST_STRING_GEN(interp, "exclude_method");
    CTX_REG_STR(_ctx, 1) = CONST_STRING_GEN(interp, "alias_method");

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 2995 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    PMC* role = CTX_REG_PMC(_ctx, 1);
    PMC* exclude_method = CTX_REG_PMC(_ctx, 2);
    INTVAL has_exclude_method = CTX_REG_INT(_ctx, 0);
    PMC* alias_method = CTX_REG_PMC(_ctx, 3);
    INTVAL has_alias_method = CTX_REG_INT(_ctx, 1);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1882 "./src/pmc/class.pmc"


    Parrot_Class_attributes * const _class = PARROT_CLASS(pmc);

    /* Add everything on the resolve list to the exclude list; if we have
     * no exclude list, pass along the resolve list in its place if it has
     * any methods listed in it. */
    if (!has_exclude_method) {
        if (VTABLE_elements(interp, _class->resolve_method) != 0) {
            exclude_method     = _class->resolve_method;
            has_exclude_method = 1;
        }
    }
    else {
        const int resolve_count = VTABLE_elements(interp, _class->resolve_method);
        int i;

        for (i = 0; i < resolve_count; i++) {
            STRING * const meth_name = VTABLE_get_string_keyed_int(interp,
                _class->resolve_method, i);
            VTABLE_push_string(interp, exclude_method, meth_name);
        }
    }

    /* Do the composition. */
    Parrot_ComposeRole(interp, role, exclude_method, has_exclude_method,
                       alias_method, has_alias_method,
                       _class->methods, _class->roles);
#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 3050 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_inspect(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 3);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 129);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 2, 256);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 3090 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 3107 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* what = CTX_REG_STR(_ctx, 0);
    INTVAL has_what = CTX_REG_INT(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1922 "./src/pmc/class.pmc"

    PMC *found;

    /* Just delegate to the appropriate vtable method. */
    if (has_what)
        found = pmc->vtable->inspect_str(interp, pmc, what);
    else
        found = pmc->vtable->inspect(interp, pmc);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN PMC *found */
    /*BEGIN GENERATED ACCESSORS */
#line 3130 "./src/pmc/class.pmc"
    CTX_REG_PMC(_ctx, 0) = found;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 2);

    goto inspect_returns;
    /*END RETURN PMC *found */
    }
#line 1931 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
inspect_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 3175 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_isa(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 3214 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 3231 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* class_name = CTX_REG_STR(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1944 "./src/pmc/class.pmc"

    const INTVAL isa = pmc->vtable->isa(interp, pmc, class_name);

    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL isa */
    /*BEGIN GENERATED ACCESSORS */
#line 3247 "./src/pmc/class.pmc"
    CTX_REG_INT(_ctx, 0) = isa;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto isa_returns;
    /*END RETURN INTVAL isa */
    }
#line 1947 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
isa_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 3292 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_nci_does(PARROT_INTERP, PMC *pmc)
{
#line 421 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    const INTVAL _n_regs_used[]   = { 1, 0, 1, 1 };
    opcode_t _param_indexes[]     = { 0, 0 };
    opcode_t *_return_indexes;
    opcode_t *_current_args;
    PMC      * const _param_sig   = pmc_new(interp, enum_class_FixedIntegerArray);
    PMC      *_return_sig         = PMCNULL;

    Parrot_Context *_caller_ctx   = CONTEXT(interp);
    PMC * const _ret_cont         = new_ret_continuation_pmc(interp, NULL);
    Parrot_Context *_ctx          = Parrot_push_context(interp, _n_regs_used);
    PMC *_ccont                   = PMCNULL;

    VTABLE_set_integer_native(interp, _param_sig, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 0, 2);
    VTABLE_set_integer_keyed_int(interp, _param_sig, 1, 1);

    UNUSED(_return_indexes);

    if (_caller_ctx) {
        _ccont = _caller_ctx->current_cont;
    }
    else {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    _ctx->current_cont            = _ret_cont;
    PMC_cont(_ret_cont)->from_ctx = _ctx;

    _current_args                 = interp->current_args;
    interp->current_args         = NULL;

#line 3331 "./src/pmc/class.pmc"

#line 440 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    interp->params_signature     = _param_sig;
    parrot_pass_args(interp, _caller_ctx, _ctx, _current_args, _param_indexes,
        PARROT_PASS_PARAMS);

    if (PObj_get_FLAGS(_ccont) & SUB_FLAG_TAILCALL) {
        PObj_get_FLAGS(_ccont) &= ~SUB_FLAG_TAILCALL;
        --_ctx->recursion_depth;
        _ctx->caller_ctx      = _caller_ctx->caller_ctx;
        Parrot_free_context(interp, _caller_ctx, 1);
        interp->current_args = NULL;
    }
    /* BEGIN PARMS SCOPE */
    {
#line 3348 "./src/pmc/class.pmc"
    PMC* pmc = CTX_REG_PMC(_ctx, 0);
    STRING* role_name = CTX_REG_STR(_ctx, 0);

#line 448 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* BEGIN PMETHOD BODY */
    {
#line 1960 "./src/pmc/class.pmc"

    INTVAL does = VTABLE_does(interp, pmc, role_name);
    #line 237 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    {
    /*BEGIN RETURN INTVAL does */
    /*BEGIN GENERATED ACCESSORS */
#line 3363 "./src/pmc/class.pmc"
    CTX_REG_INT(_ctx, 0) = does;

#line 256 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
    /*END GENERATED ACCESSORS */
    {
        opcode_t _temp_return_indexes[] = { 0 };
        _return_indexes                 = _temp_return_indexes;
    }

    _return_sig = pmc_new(interp, enum_class_FixedIntegerArray);
    VTABLE_set_integer_native(interp, _return_sig, 1);
    VTABLE_set_integer_keyed_int(interp, _return_sig, 0, 0);

    goto does_returns;
    /*END RETURN INTVAL does */
    }
#line 1962 "./src/pmc/class.pmc"

#line 457 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    }
    goto no_return;
    /* END PMETHOD BODY */

#line 471 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"
does_returns:

    if (! _caller_ctx) {
        /* there is no point calling Parrot_ex_throw_from_c_args here, because
           PDB_backtrace can't deal with a missing to_ctx either. */
        exit_fatal(1, "No caller_ctx for continuation %p.", _ccont);
    }

    interp->returns_signature = _return_sig;
    parrot_pass_args(interp, _ctx, _caller_ctx, _return_indexes,
        _caller_ctx->current_results, PARROT_PASS_RESULTS);
#line 481 "/builddir/build/BUILD/parrot-1.0.0/tools/build/../../lib/Parrot/Pmc2c/PCCMETHOD.pm"

    /* END PARAMS SCOPE */
    }
    no_return:
    PObj_live_CLEAR(_param_sig);
    PObj_live_CLEAR(_return_sig);
    Parrot_pop_context(interp);
#line 3408 "./src/pmc/class.c"
}
PARROT_EXPORT  void
Parrot_Class_ro_add_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_attribute() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_add_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_method() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_add_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_parent() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_add_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_role() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_add_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name), SHIM(PMC *sub_pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "add_vtable_override() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_assign_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_pmc() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_assign_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "assign_string_native() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_decrement(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "decrement() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_delete_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_delete_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_delete_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "delete_keyed_str() in read-only instance of Class");
}
PARROT_EXPORT  PMC *
Parrot_Class_ro_find_method(PARROT_INTERP, PMC *pmc, STRING *method_name)
{
    PMC *const method = Parrot_default_find_method(interp, pmc, method_name);
    if (!PMC_IS_NULL(VTABLE_getprop(interp, method, CONST_STRING_GEN(interp, "write"))))
        return PMCNULL;
    else
        return method;
}
PARROT_EXPORT  void
Parrot_Class_ro_i_absolute(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_absolute() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_add(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_add_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_float() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_add_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_add_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_and(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_and_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_and_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_ands(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_ands_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ands_str() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_lsr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_lsr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_lsr_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_not() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_nots(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_nots() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_or(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_or_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_or_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_ors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_ors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_ors_str() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_shl(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_shl_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shl_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_shr(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_shr_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_shr_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_xor(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_xor_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xor_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_xors(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_bitwise_xors_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_bitwise_xors_str() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_concatenate(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_concatenate_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_concatenate_str() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_float() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_divide_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_floor_divide(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_floor_divide_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_float() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_floor_divide_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_floor_divide_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_logical_not(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_logical_not() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_modulus(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_modulus_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_float() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_modulus_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_modulus_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_multiply(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_multiply_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_float() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_multiply_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_multiply_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_neg(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_neg() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_pow(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_pow_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_float() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_pow_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_pow_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_repeat(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_repeat_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_repeat_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_subtract(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_subtract_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_float() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_i_subtract_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "i_subtract_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_increment(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "increment() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_morph(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *type))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "morph() in read-only instance of Class");
}
PARROT_EXPORT  FLOATVAL
Parrot_Class_ro_pop_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_float() in read-only instance of Class");
}
PARROT_EXPORT  INTVAL
Parrot_Class_ro_pop_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_integer() in read-only instance of Class");
}
PARROT_EXPORT  PMC *
Parrot_Class_ro_pop_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_pmc() in read-only instance of Class");
}
PARROT_EXPORT  STRING *
Parrot_Class_ro_pop_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "pop_string() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_push_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_float() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_push_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_integer() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_push_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_pmc() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_push_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "push_string() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_remove_attribute(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_attribute() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_remove_method(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *method_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_method() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_remove_parent(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *parent))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_parent() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_remove_role(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *role))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_role() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_remove_vtable_override(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *vtable_name))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "remove_vtable_override() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_attr_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_keyed() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_attr_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *idx), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_attr_str() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_bignum_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_bignum_num(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_num() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_bignum_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bignum_str() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_bool(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_bool() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_integer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_integer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_integer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_keyed_str() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_integer_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_native() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_integer_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_integer_same() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_number_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_number_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_number_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_keyed_str() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_number_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_native() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_number_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_number_same() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_pmc_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_pmc_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_pmc_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pmc_keyed_str() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_pointer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_pointer_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_pointer_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_pointer_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(void *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_pointer_keyed_str() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_string_keyed(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_string_keyed_int(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_int() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_string_keyed_str(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *key), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_keyed_str() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_string_native(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_native() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_set_string_same(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "set_string_same() in read-only instance of Class");
}
PARROT_EXPORT  FLOATVAL
Parrot_Class_ro_shift_float(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_float() in read-only instance of Class");
}
PARROT_EXPORT  INTVAL
Parrot_Class_ro_shift_integer(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_integer() in read-only instance of Class");
}
PARROT_EXPORT  PMC *
Parrot_Class_ro_shift_pmc(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_pmc() in read-only instance of Class");
}
PARROT_EXPORT  STRING *
Parrot_Class_ro_shift_string(PARROT_INTERP, SHIM(PMC *pmc))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "shift_string() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_splice(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value), SHIM(INTVAL offset), SHIM(INTVAL count))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "splice() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_thaw(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thaw() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_thawfinish(PARROT_INTERP, SHIM(PMC *pmc), SHIM(visit_info *info))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "thawfinish() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_unshift_float(PARROT_INTERP, SHIM(PMC *pmc), SHIM(FLOATVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_float() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_unshift_integer(PARROT_INTERP, SHIM(PMC *pmc), SHIM(INTVAL value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_integer() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_unshift_pmc(PARROT_INTERP, SHIM(PMC *pmc), SHIM(PMC *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_pmc() in read-only instance of Class");
}
PARROT_EXPORT  void
Parrot_Class_ro_unshift_string(PARROT_INTERP, SHIM(PMC *pmc), SHIM(STRING *value))
{
    Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_WRITE_TO_CONSTCLASS,
            "unshift_string() in read-only instance of Class");
}
#include "pmc_default.h"
void
Parrot_Class_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Iid Sname Sfullname F_namespace Iinstantiated Fparents Fall_parents Froles Fmethods Fvtable_overrides Fattrib_metadata Fattrib_index Fattrib_cache Fresolve_method Fparent_overrides ";
    const VTABLE temp_base_vtable = {
        NULL,       /* namespace */
        enum_class_Class, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_HAS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Class_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Class_add_method,
        Parrot_Class_add_parent,
        Parrot_Class_add_role,
        Parrot_Class_add_vtable_override,
        Parrot_default_assign_pmc,
        Parrot_default_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Class_clone,
        Parrot_Class_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_default_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_default_delete_keyed,
        Parrot_default_delete_keyed_int,
        Parrot_default_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Class_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_Class_does,
        Parrot_Class_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_default_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Class_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Class_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Class_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_default_i_absolute,
        Parrot_default_i_add,
        Parrot_default_i_add_float,
        Parrot_default_i_add_int,
        Parrot_default_i_bitwise_and,
        Parrot_default_i_bitwise_and_int,
        Parrot_default_i_bitwise_ands,
        Parrot_default_i_bitwise_ands_str,
        Parrot_default_i_bitwise_lsr,
        Parrot_default_i_bitwise_lsr_int,
        Parrot_default_i_bitwise_not,
        Parrot_default_i_bitwise_nots,
        Parrot_default_i_bitwise_or,
        Parrot_default_i_bitwise_or_int,
        Parrot_default_i_bitwise_ors,
        Parrot_default_i_bitwise_ors_str,
        Parrot_default_i_bitwise_shl,
        Parrot_default_i_bitwise_shl_int,
        Parrot_default_i_bitwise_shr,
        Parrot_default_i_bitwise_shr_int,
        Parrot_default_i_bitwise_xor,
        Parrot_default_i_bitwise_xor_int,
        Parrot_default_i_bitwise_xors,
        Parrot_default_i_bitwise_xors_str,
        Parrot_default_i_concatenate,
        Parrot_default_i_concatenate_str,
        Parrot_default_i_divide,
        Parrot_default_i_divide_float,
        Parrot_default_i_divide_int,
        Parrot_default_i_floor_divide,
        Parrot_default_i_floor_divide_float,
        Parrot_default_i_floor_divide_int,
        Parrot_default_i_logical_not,
        Parrot_default_i_modulus,
        Parrot_default_i_modulus_float,
        Parrot_default_i_modulus_int,
        Parrot_default_i_multiply,
        Parrot_default_i_multiply_float,
        Parrot_default_i_multiply_int,
        Parrot_default_i_neg,
        Parrot_default_i_pow,
        Parrot_default_i_pow_float,
        Parrot_default_i_pow_int,
        Parrot_default_i_repeat,
        Parrot_default_i_repeat_int,
        Parrot_default_i_subtract,
        Parrot_default_i_subtract_float,
        Parrot_default_i_subtract_int,
        Parrot_default_increment,
        Parrot_Class_init,
        Parrot_Class_init_pmc,
        Parrot_Class_inspect,
        Parrot_Class_inspect_str,
        Parrot_Class_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_Class_isa,
        Parrot_Class_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Class_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_default_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_default_pop_float,
        Parrot_default_pop_integer,
        Parrot_default_pop_pmc,
        Parrot_default_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_default_push_float,
        Parrot_default_push_integer,
        Parrot_default_push_pmc,
        Parrot_default_push_string,
        Parrot_Class_remove_attribute,
        Parrot_Class_remove_method,
        Parrot_Class_remove_parent,
        Parrot_default_remove_role,
        Parrot_default_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_default_set_attr_keyed,
        Parrot_default_set_attr_str,
        Parrot_default_set_bignum_int,
        Parrot_default_set_bignum_num,
        Parrot_default_set_bignum_str,
        Parrot_default_set_bool,
        Parrot_default_set_integer_keyed,
        Parrot_default_set_integer_keyed_int,
        Parrot_default_set_integer_keyed_str,
        Parrot_default_set_integer_native,
        Parrot_default_set_integer_same,
        Parrot_default_set_number_keyed,
        Parrot_default_set_number_keyed_int,
        Parrot_default_set_number_keyed_str,
        Parrot_default_set_number_native,
        Parrot_default_set_number_same,
        Parrot_default_set_pmc,
        Parrot_default_set_pmc_keyed,
        Parrot_default_set_pmc_keyed_int,
        Parrot_default_set_pmc_keyed_str,
        Parrot_default_set_pointer,
        Parrot_default_set_pointer_keyed,
        Parrot_default_set_pointer_keyed_int,
        Parrot_default_set_pointer_keyed_str,
        Parrot_default_set_string_keyed,
        Parrot_default_set_string_keyed_int,
        Parrot_default_set_string_keyed_str,
        Parrot_default_set_string_native,
        Parrot_default_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_default_shift_float,
        Parrot_default_shift_integer,
        Parrot_default_shift_pmc,
        Parrot_default_shift_string,
        Parrot_default_slice,
        Parrot_default_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Class_thaw,
        Parrot_Class_thawfinish,
        Parrot_Class_type,
        Parrot_default_type_keyed,
        Parrot_default_unshift_float,
        Parrot_default_unshift_integer,
        Parrot_default_unshift_pmc,
        Parrot_default_unshift_string,
        Parrot_Class_visit
    };

    const VTABLE temp_ro_vtable = {
        NULL,       /* namespace */
        enum_class_Class, /* base_type */
        NULL,       /* whoami */
        0|VTABLE_PMC_NEEDS_EXT|VTABLE_IS_READONLY_FLAG, /* flags */
        NULL,       /* provides_str */
        NULL,       /* isa_hash */
        NULL,       /* class */
        NULL,       /* mro */
        attr_defs,  /* attribute_defs */
        NULL,       /* ro_variant_vtable */
        Parrot_default_absolute,
        Parrot_default_add,
        Parrot_Class_ro_add_attribute,
        Parrot_default_add_float,
        Parrot_default_add_int,
        Parrot_Class_ro_add_method,
        Parrot_Class_ro_add_parent,
        Parrot_Class_ro_add_role,
        Parrot_Class_ro_add_vtable_override,
        Parrot_Class_ro_assign_pmc,
        Parrot_Class_ro_assign_string_native,
        Parrot_default_bitwise_and,
        Parrot_default_bitwise_and_int,
        Parrot_default_bitwise_ands,
        Parrot_default_bitwise_ands_str,
        Parrot_default_bitwise_lsr,
        Parrot_default_bitwise_lsr_int,
        Parrot_default_bitwise_not,
        Parrot_default_bitwise_nots,
        Parrot_default_bitwise_or,
        Parrot_default_bitwise_or_int,
        Parrot_default_bitwise_ors,
        Parrot_default_bitwise_ors_str,
        Parrot_default_bitwise_shl,
        Parrot_default_bitwise_shl_int,
        Parrot_default_bitwise_shr,
        Parrot_default_bitwise_shr_int,
        Parrot_default_bitwise_xor,
        Parrot_default_bitwise_xor_int,
        Parrot_default_bitwise_xors,
        Parrot_default_bitwise_xors_str,
        Parrot_default_can,
        Parrot_Class_clone,
        Parrot_Class_clone_pmc,
        Parrot_default_cmp,
        Parrot_default_cmp_num,
        Parrot_default_cmp_pmc,
        Parrot_default_cmp_string,
        Parrot_default_concatenate,
        Parrot_default_concatenate_str,
        Parrot_Class_ro_decrement,
        Parrot_default_defined,
        Parrot_default_defined_keyed,
        Parrot_default_defined_keyed_int,
        Parrot_default_defined_keyed_str,
        Parrot_Class_ro_delete_keyed,
        Parrot_Class_ro_delete_keyed_int,
        Parrot_Class_ro_delete_keyed_str,
        Parrot_default_delprop,
        Parrot_Class_destroy,
        Parrot_default_divide,
        Parrot_default_divide_float,
        Parrot_default_divide_int,
        Parrot_Class_does,
        Parrot_Class_does_pmc,
        Parrot_default_elements,
        Parrot_default_exists_keyed,
        Parrot_default_exists_keyed_int,
        Parrot_default_exists_keyed_str,
        Parrot_Class_ro_find_method,
        Parrot_default_floor_divide,
        Parrot_default_floor_divide_float,
        Parrot_default_floor_divide_int,
        Parrot_Class_freeze,
        Parrot_default_get_attr_keyed,
        Parrot_default_get_attr_str,
        Parrot_default_get_bignum,
        Parrot_default_get_bool,
        Parrot_default_get_class,
        Parrot_Class_get_integer,
        Parrot_default_get_integer_keyed,
        Parrot_default_get_integer_keyed_int,
        Parrot_default_get_integer_keyed_str,
        Parrot_default_get_iter,
        Parrot_default_get_namespace,
        Parrot_default_get_number,
        Parrot_default_get_number_keyed,
        Parrot_default_get_number_keyed_int,
        Parrot_default_get_number_keyed_str,
        Parrot_default_get_pmc,
        Parrot_default_get_pmc_keyed,
        Parrot_default_get_pmc_keyed_int,
        Parrot_default_get_pmc_keyed_str,
        Parrot_default_get_pointer,
        Parrot_default_get_pointer_keyed,
        Parrot_default_get_pointer_keyed_int,
        Parrot_default_get_pointer_keyed_str,
        Parrot_default_get_repr,
        Parrot_Class_get_string,
        Parrot_default_get_string_keyed,
        Parrot_default_get_string_keyed_int,
        Parrot_default_get_string_keyed_str,
        Parrot_default_getprop,
        Parrot_default_getprops,
        Parrot_Class_ro_i_absolute,
        Parrot_Class_ro_i_add,
        Parrot_Class_ro_i_add_float,
        Parrot_Class_ro_i_add_int,
        Parrot_Class_ro_i_bitwise_and,
        Parrot_Class_ro_i_bitwise_and_int,
        Parrot_Class_ro_i_bitwise_ands,
        Parrot_Class_ro_i_bitwise_ands_str,
        Parrot_Class_ro_i_bitwise_lsr,
        Parrot_Class_ro_i_bitwise_lsr_int,
        Parrot_Class_ro_i_bitwise_not,
        Parrot_Class_ro_i_bitwise_nots,
        Parrot_Class_ro_i_bitwise_or,
        Parrot_Class_ro_i_bitwise_or_int,
        Parrot_Class_ro_i_bitwise_ors,
        Parrot_Class_ro_i_bitwise_ors_str,
        Parrot_Class_ro_i_bitwise_shl,
        Parrot_Class_ro_i_bitwise_shl_int,
        Parrot_Class_ro_i_bitwise_shr,
        Parrot_Class_ro_i_bitwise_shr_int,
        Parrot_Class_ro_i_bitwise_xor,
        Parrot_Class_ro_i_bitwise_xor_int,
        Parrot_Class_ro_i_bitwise_xors,
        Parrot_Class_ro_i_bitwise_xors_str,
        Parrot_Class_ro_i_concatenate,
        Parrot_Class_ro_i_concatenate_str,
        Parrot_Class_ro_i_divide,
        Parrot_Class_ro_i_divide_float,
        Parrot_Class_ro_i_divide_int,
        Parrot_Class_ro_i_floor_divide,
        Parrot_Class_ro_i_floor_divide_float,
        Parrot_Class_ro_i_floor_divide_int,
        Parrot_Class_ro_i_logical_not,
        Parrot_Class_ro_i_modulus,
        Parrot_Class_ro_i_modulus_float,
        Parrot_Class_ro_i_modulus_int,
        Parrot_Class_ro_i_multiply,
        Parrot_Class_ro_i_multiply_float,
        Parrot_Class_ro_i_multiply_int,
        Parrot_Class_ro_i_neg,
        Parrot_Class_ro_i_pow,
        Parrot_Class_ro_i_pow_float,
        Parrot_Class_ro_i_pow_int,
        Parrot_Class_ro_i_repeat,
        Parrot_Class_ro_i_repeat_int,
        Parrot_Class_ro_i_subtract,
        Parrot_Class_ro_i_subtract_float,
        Parrot_Class_ro_i_subtract_int,
        Parrot_Class_ro_increment,
        Parrot_Class_init,
        Parrot_Class_init_pmc,
        Parrot_Class_inspect,
        Parrot_Class_inspect_str,
        Parrot_Class_instantiate,
        Parrot_default_instantiate_str,
        Parrot_default_invoke,
        Parrot_default_is_equal,
        Parrot_default_is_equal_num,
        Parrot_default_is_equal_string,
        Parrot_default_is_same,
        Parrot_Class_isa,
        Parrot_Class_isa_pmc,
        Parrot_default_logical_and,
        Parrot_default_logical_not,
        Parrot_default_logical_or,
        Parrot_default_logical_xor,
        Parrot_Class_mark,
        Parrot_default_modulus,
        Parrot_default_modulus_float,
        Parrot_default_modulus_int,
        Parrot_Class_ro_morph,
        Parrot_default_multiply,
        Parrot_default_multiply_float,
        Parrot_default_multiply_int,
        Parrot_default_name,
        Parrot_default_neg,
        Parrot_default_nextkey_keyed,
        Parrot_default_nextkey_keyed_int,
        Parrot_default_nextkey_keyed_str,
        Parrot_Class_ro_pop_float,
        Parrot_Class_ro_pop_integer,
        Parrot_Class_ro_pop_pmc,
        Parrot_Class_ro_pop_string,
        Parrot_default_pow,
        Parrot_default_pow_float,
        Parrot_default_pow_int,
        Parrot_Class_ro_push_float,
        Parrot_Class_ro_push_integer,
        Parrot_Class_ro_push_pmc,
        Parrot_Class_ro_push_string,
        Parrot_Class_ro_remove_attribute,
        Parrot_Class_ro_remove_method,
        Parrot_Class_ro_remove_parent,
        Parrot_Class_ro_remove_role,
        Parrot_Class_ro_remove_vtable_override,
        Parrot_default_repeat,
        Parrot_default_repeat_int,
        Parrot_Class_ro_set_attr_keyed,
        Parrot_Class_ro_set_attr_str,
        Parrot_Class_ro_set_bignum_int,
        Parrot_Class_ro_set_bignum_num,
        Parrot_Class_ro_set_bignum_str,
        Parrot_Class_ro_set_bool,
        Parrot_Class_ro_set_integer_keyed,
        Parrot_Class_ro_set_integer_keyed_int,
        Parrot_Class_ro_set_integer_keyed_str,
        Parrot_Class_ro_set_integer_native,
        Parrot_Class_ro_set_integer_same,
        Parrot_Class_ro_set_number_keyed,
        Parrot_Class_ro_set_number_keyed_int,
        Parrot_Class_ro_set_number_keyed_str,
        Parrot_Class_ro_set_number_native,
        Parrot_Class_ro_set_number_same,
        Parrot_Class_ro_set_pmc,
        Parrot_Class_ro_set_pmc_keyed,
        Parrot_Class_ro_set_pmc_keyed_int,
        Parrot_Class_ro_set_pmc_keyed_str,
        Parrot_Class_ro_set_pointer,
        Parrot_Class_ro_set_pointer_keyed,
        Parrot_Class_ro_set_pointer_keyed_int,
        Parrot_Class_ro_set_pointer_keyed_str,
        Parrot_Class_ro_set_string_keyed,
        Parrot_Class_ro_set_string_keyed_int,
        Parrot_Class_ro_set_string_keyed_str,
        Parrot_Class_ro_set_string_native,
        Parrot_Class_ro_set_string_same,
        Parrot_default_setprop,
        Parrot_default_share,
        Parrot_default_share_ro,
        Parrot_Class_ro_shift_float,
        Parrot_Class_ro_shift_integer,
        Parrot_Class_ro_shift_pmc,
        Parrot_Class_ro_shift_string,
        Parrot_default_slice,
        Parrot_Class_ro_splice,
        Parrot_default_substr,
        Parrot_default_substr_str,
        Parrot_default_subtract,
        Parrot_default_subtract_float,
        Parrot_default_subtract_int,
        Parrot_Class_ro_thaw,
        Parrot_Class_ro_thawfinish,
        Parrot_Class_type,
        Parrot_default_type_keyed,
        Parrot_Class_ro_unshift_float,
        Parrot_Class_ro_unshift_integer,
        Parrot_Class_ro_unshift_pmc,
        Parrot_Class_ro_unshift_string,
        Parrot_Class_visit
    };
    if (pass == 0) {
        Hash          *isa_hash;
        /* create vtable - clone it - we have to set a few items */
        VTABLE * const vt_clone        = Parrot_clone_vtable(interp,
                                             &temp_base_vtable);
        VTABLE * const vt_ro_clone     = Parrot_clone_vtable(interp,
                                             &temp_ro_vtable);
        vt_clone->whoami       = CONST_STRING_GEN(interp, "Class");
        vt_clone->provides_str = CONST_STRING_GEN(interp, "scalar");

        /* set up isa hash */
        parrot_new_hash(interp, &isa_hash);
        vt_clone->isa_hash     = isa_hash;
        vt_ro_clone->base_type    = entry;
        vt_ro_clone->whoami       = vt_clone->whoami;
        vt_ro_clone->provides_str = vt_clone->provides_str;
        vt_clone->ro_variant_vtable    = vt_ro_clone;
        vt_ro_clone->ro_variant_vtable = vt_clone;
        vt_ro_clone->isa_hash          = isa_hash;
        interp->vtables[entry]         = vt_clone;
        parrot_hash_put(interp, isa_hash, (void *)(CONST_STRING_GEN(interp, "Class")), PMCNULL);
    }
    else { /* pass */
        {
            PMC           *mro      = pmc_new(interp, enum_class_ResizableStringArray);
            VTABLE * const vt_clone = interp->vtables[entry];

            vt_clone->mro = mro;

            if (vt_clone->ro_variant_vtable)
                vt_clone->ro_variant_vtable->mro = mro;

            VTABLE_push_string(interp, mro, CONST_STRING_GEN(interp, "Class"));
        }

        /* setup MRO and _namespace */
        Parrot_create_mro(interp, entry);
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_name), "name");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_get_namespace), "get_namespace");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_resolve_method), "resolve_method");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_new), "new");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_attributes), "attributes");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_add_attribute), "add_attribute");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_methods), "methods");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_add_method), "add_method");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_add_vtable_override), "add_vtable_override");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_remove_method), "remove_method");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_find_method), "find_method");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_parents), "parents");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_add_parent), "add_parent");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_roles), "roles");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_add_role), "add_role");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_inspect), "inspect");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_isa), "isa");
        register_raw_nci_method_in_ns(interp, entry,
            F2DPTR(Parrot_Class_nci_does), "does");
        {
        }
    } /* pass */
} /* Parrot_Class_class_init */
#line 1963 "./src/pmc/class.pmc"
 /* END pmclass */

/*

=back

=head1 SEE ALSO

F<docs/pdds/pdd15_objects.pod>.

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4:
 */
